/// @file xed-enc-groups.c

// This file was automatically generated.
// Do not edit this file.

/*BEGIN_LEGAL

Copyright (c) 2020 Intel Corporation

  Licensed under the Apache License, Version 2.0 (the "License");
  you may not use this file except in compliance with the License.
  You may obtain a copy of the License at

      http://www.apache.org/licenses/LICENSE-2.0

  Unless required by applicable law or agreed to in writing, software
  distributed under the License is distributed on an "AS IS" BASIS,
  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
  See the License for the specific language governing permissions and
  limitations under the License.
  
END_LEGAL */
#include "xed-internal-header.h"
#include "xed-encode-private.h"
#include "xed-enc-operand-lu.h"
#include "xed-operand-accessors.h"
#include "xed-encoder.h"
xed_bool_t xed_encode_group_0(xed_encoder_request_t* xes)
{
   xed_bool_t okay=1;
   xed_bool_t conditions_satisfied=0;
   xed_ptrn_func_ptr_t fb_ptrn_function;
   static const xed_uint16_t iform_ids[6][12] = {
   /*RCL           */    {2618,2620,2617,2619,2614,2610,2616,2612,2613,2609,2615,2611,},
   /*RCR           */    {6078,6080,6077,6079,6074,6070,6076,6072,6073,6069,6075,6071,},
   /*ROL           */    {1141,1143,1140,1142,1137,1133,1139,1135,1136,1132,1138,1134,},
   /*ROR           */    { 162, 164, 161, 163, 158, 154, 160, 155, 157, 153, 159, 156,},
   /*SAR           */    {5150,5152,5149,5151,5146,5142,5148,5144,5145,5141,5147,5143,},
   /*SHR           */    {   9,  11,   8,  10,   5,   1,   7,   3,   4,   0,   6,   2,},
   };
   xed_uint8_t iclass_index = xed_encoder_get_iclasses_index_in_group(xes);
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_REG1) {
   conditions_satisfied = xed_encode_ntluf_GPR8_B(xes,xed3_operand_get_reg0(xes)) &&
		 (xed3_operand_get_reg1(xes) == XED_REG_CL);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][0]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_REG1) {
   conditions_satisfied = xed_encode_ntluf_GPRv_B(xes,xed3_operand_get_reg0(xes)) &&
		 (xed3_operand_get_reg1(xes) == XED_REG_CL);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][1]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_MEM0 && xes->_operand_order[1] == XED_OPERAND_REG0) {
   conditions_satisfied = (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_B) &&
		 (xed3_operand_get_reg0(xes) == XED_REG_CL);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][2]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_MEM0 && xes->_operand_order[1] == XED_OPERAND_REG0) {
   conditions_satisfied = (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_V) &&
		 (xed3_operand_get_reg0(xes) == XED_REG_CL);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][3]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_IMM0) {
   conditions_satisfied = xed_encode_ntluf_GPR8_B(xes,xed3_operand_get_reg0(xes)) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][4]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_ONE_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_IMM0) {
   conditions_satisfied = xed_encode_ntluf_GPR8_B(xes,xed3_operand_get_reg0(xes)) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][5]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_UIMM8_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_IMM0) {
   conditions_satisfied = xed_encode_ntluf_GPRv_B(xes,xed3_operand_get_reg0(xes)) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][6]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_ONE_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_IMM0) {
   conditions_satisfied = xed_encode_ntluf_GPRv_B(xes,xed3_operand_get_reg0(xes)) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][7]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_UIMM8_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_MEM0 && xes->_operand_order[1] == XED_OPERAND_IMM0) {
   conditions_satisfied = (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_B) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][8]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ONE_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_MEM0 && xes->_operand_order[1] == XED_OPERAND_IMM0) {
   conditions_satisfied = (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_B) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][9]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_UIMM8_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_MEM0 && xes->_operand_order[1] == XED_OPERAND_IMM0) {
   conditions_satisfied = (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_V) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][10]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ONE_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_MEM0 && xes->_operand_order[1] == XED_OPERAND_IMM0) {
   conditions_satisfied = (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_V) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][11]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_UIMM8_BIND(xes);
       if (okay) return 1;
   }
     }
   return 0;
   (void) okay;
   (void) conditions_satisfied;
   (void) xes;
}
xed_bool_t xed_encode_group_1(xed_encoder_request_t* xes)
{
   xed_bool_t okay=1;
   xed_bool_t conditions_satisfied=0;
   xed_ptrn_func_ptr_t fb_ptrn_function;
   static const xed_uint16_t iform_ids[2][8] = {
   /*VMOVDQA       */    {1682,1680,1686,1684,1681,1679,1685,1683,},
   /*VMOVDQU       */    {  17,  13,  19,  15,  16,  12,  18,  14,},
   };
   xed_uint8_t iclass_index = xed_encoder_get_iclasses_index_in_group(xes);
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_REG1) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 (xed3_operand_get_must_use_evex(xes) == 0) &&
		 xed_encode_ntluf_XMM_B(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_XMM_R(xes,xed3_operand_get_reg1(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][0]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_REG1) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 (xed3_operand_get_must_use_evex(xes) == 0) &&
		 xed_encode_ntluf_XMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_XMM_B(xes,xed3_operand_get_reg1(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][1]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_REG1) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 1) &&
		 (xed3_operand_get_must_use_evex(xes) == 0) &&
		 xed_encode_ntluf_YMM_B(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_YMM_R(xes,xed3_operand_get_reg1(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][2]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_REG1) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 1) &&
		 (xed3_operand_get_must_use_evex(xes) == 0) &&
		 xed_encode_ntluf_YMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_YMM_B(xes,xed3_operand_get_reg1(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][3]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_MEM0 && xes->_operand_order[1] == XED_OPERAND_REG0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 (xed3_operand_get_must_use_evex(xes) == 0) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_DQ) &&
		 xed_encode_ntluf_XMM_R(xes,xed3_operand_get_reg0(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][4]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_MEM0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 (xed3_operand_get_must_use_evex(xes) == 0) &&
		 xed_encode_ntluf_XMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_DQ);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][5]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_MEM0 && xes->_operand_order[1] == XED_OPERAND_REG0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 1) &&
		 (xed3_operand_get_must_use_evex(xes) == 0) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_QQ) &&
		 xed_encode_ntluf_YMM_R(xes,xed3_operand_get_reg0(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][6]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_MEM0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 1) &&
		 (xed3_operand_get_must_use_evex(xes) == 0) &&
		 xed_encode_ntluf_YMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_QQ);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][7]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay) return 1;
   }
     }
   return 0;
   (void) okay;
   (void) conditions_satisfied;
   (void) xes;
}
xed_bool_t xed_encode_group_2(xed_encoder_request_t* xes)
{
   xed_bool_t okay=1;
   xed_bool_t conditions_satisfied=0;
   xed_ptrn_func_ptr_t fb_ptrn_function;
   static const xed_uint16_t iform_ids[4][1] = {
   /*RDFSBASE      */    {5737,},
   /*RDGSBASE      */    { 352,},
   /*WRFSBASE      */    {  20,},
   /*WRGSBASE      */    {3159,},
   };
   xed_uint8_t iclass_index = xed_encoder_get_iclasses_index_in_group(xes);
   if (xes->_n_operand_order == 1 && xes->_operand_order[0] == XED_OPERAND_REG0) {
   conditions_satisfied = (xed3_operand_get_mode(xes) == 2) &&
		 xed_encode_ntluf_GPRy_B(xes,xed3_operand_get_reg0(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][0]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   return 0;
   (void) okay;
   (void) conditions_satisfied;
   (void) xes;
}
xed_bool_t xed_encode_group_3(xed_encoder_request_t* xes)
{
   xed_bool_t okay=1;
   xed_bool_t conditions_satisfied=0;
   xed_ptrn_func_ptr_t fb_ptrn_function;
   static const xed_uint16_t iform_ids[1][1] = {
   /*MASKMOVDQU    */    {  21,},
   };
   xed_uint8_t iclass_index = xed_encoder_get_iclasses_index_in_group(xes);
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_REG1) {
   conditions_satisfied = xed_encode_ntluf_XMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_XMM_B(xes,xed3_operand_get_reg1(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][0]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_REFINING66_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_OVERRIDE_SEG0_BIND(xes);
       if (okay) return 1;
   }
     }
   return 0;
   (void) okay;
   (void) conditions_satisfied;
   (void) xes;
}
xed_bool_t xed_encode_group_4(xed_encoder_request_t* xes)
{
   xed_bool_t okay=1;
   xed_bool_t conditions_satisfied=0;
   xed_ptrn_func_ptr_t fb_ptrn_function;
   static const xed_uint16_t iform_ids[2][6] = {
   /*AND_LOCK      */    {1872,1873,1868,1871,1869,1870,},
   /*XOR_LOCK      */    {  26,  27,  22,  25,  23,  24,},
   };
   xed_uint8_t iclass_index = xed_encoder_get_iclasses_index_in_group(xes);
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_MEM0 && xes->_operand_order[1] == XED_OPERAND_REG0) {
   conditions_satisfied = (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_B) &&
		 xed_encode_ntluf_GPR8_R(xes,xed3_operand_get_reg0(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][0]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_MEM0 && xes->_operand_order[1] == XED_OPERAND_REG0) {
   conditions_satisfied = (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_V) &&
		 xed_encode_ntluf_GPRv_R(xes,xed3_operand_get_reg0(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][1]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_MEM0 && xes->_operand_order[1] == XED_OPERAND_IMM0) {
   conditions_satisfied = (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_B) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][2]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_UIMM8_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_MEM0 && xes->_operand_order[1] == XED_OPERAND_IMM0) {
   conditions_satisfied = (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_V) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][3]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_SIMM8_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_MEM0 && xes->_operand_order[1] == XED_OPERAND_IMM0) {
   conditions_satisfied = (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_V) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][4]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_SIMMz_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_MEM0 && xes->_operand_order[1] == XED_OPERAND_IMM0) {
   conditions_satisfied = (xed3_operand_get_mode(xes) != 2) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_B) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][5]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_UIMM8_BIND(xes);
       if (okay) return 1;
   }
     }
   return 0;
   (void) okay;
   (void) conditions_satisfied;
   (void) xes;
}
xed_bool_t xed_encode_group_5(xed_encoder_request_t* xes)
{
   xed_bool_t okay=1;
   xed_bool_t conditions_satisfied=0;
   xed_ptrn_func_ptr_t fb_ptrn_function;
   static const xed_uint16_t iform_ids[2][6] = {
   /*VCOMPRESSPS   */    {2089,2091,2087,2088,2090,2086,},
   /*VPCOMPRESSD   */    {  31,  33,  29,  30,  32,  28,},
   };
   xed_uint8_t iclass_index = xed_encoder_get_iclasses_index_in_group(xes);
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[7], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 xed_encode_ntluf_XMM_B3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_XMM_R3(xes,xed3_operand_get_reg2(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][0]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[7], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 1) &&
		 xed_encode_ntluf_YMM_B3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_YMM_R3(xes,xed3_operand_get_reg2(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][1]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[7], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 2) &&
		 xed_encode_ntluf_ZMM_B3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_ZMM_R3(xes,xed3_operand_get_reg2(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][2]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[6], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_DQ) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_XMM_R3(xes,xed3_operand_get_reg1(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][3]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_32_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_GSCAT_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[6], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 1) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_QQ) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_YMM_R3(xes,xed3_operand_get_reg1(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][4]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_32_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_GSCAT_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[6], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 2) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_ZD) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_ZMM_R3(xes,xed3_operand_get_reg1(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][5]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_32_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_GSCAT_BIND(xes);
       if (okay) return 1;
   }
     }
   return 0;
   (void) okay;
   (void) conditions_satisfied;
   (void) xes;
}
xed_bool_t xed_encode_group_6(xed_encoder_request_t* xes)
{
   xed_bool_t okay=1;
   xed_bool_t conditions_satisfied=0;
   xed_ptrn_func_ptr_t fb_ptrn_function;
   static const xed_uint16_t iform_ids[121][1] = {
   /*CLAC          */    {5427,},
   /*CLC           */    {5531,},
   /*CLD           */    {2029,},
   /*CLGI          */    {1109,},
   /*CLI           */    { 137,},
   /*CLTS          */    {6056,},
   /*CLZERO        */    {5612,},
   /*CMC           */    {  41,},
   /*CPUID         */    {5221,},
   /*EMMS          */    {  34,},
   /*ENCLS         */    { 100,},
   /*ENCLU         */    {4475,},
   /*ENCLV         */    {4437,},
   /*ENDBR32       */    {6386,},
   /*ENDBR64       */    {2036,},
   /*F2XM1         */    {3461,},
   /*FABS          */    {5785,},
   /*FCHS          */    { 283,},
   /*FCOMPP        */    {1199,},
   /*FCOS          */    {6057,},
   /*FDECSTP       */    {3463,},
   /*FDISI8087_NOP */    {2926,},
   /*FEMMS         */    {6174,},
   /*FENI8087_NOP  */    {3615,},
   /*FINCSTP       */    {6103,},
   /*FLD1          */    {2834,},
   /*FLDL2E        */    {2112,},
   /*FLDL2T        */    {2365,},
   /*FLDLG2        */    { 365,},
   /*FLDLN2        */    { 991,},
   /*FLDPI         */    {6159,},
   /*FLDZ          */    {6247,},
   /*FNCLEX        */    {2054,},
   /*FNINIT        */    {5055,},
   /*FNOP          */    { 810,},
   /*FPATAN        */    {1128,},
   /*FPREM         */    {5823,},
   /*FPREM1        */    {6632,},
   /*FPTAN         */    {1654,},
   /*FRNDINT       */    {1360,},
   /*FSCALE        */    {5490,},
   /*FSETPM287_NOP */    { 423,},
   /*FSIN          */    {4699,},
   /*FSINCOS       */    {3376,},
   /*FSQRT         */    {4787,},
   /*FTST          */    {5768,},
   /*FUCOMPP       */    {6362,},
   /*FWAIT         */    {1894,},
   /*FXAM          */    {4121,},
   /*FXTRACT       */    {3044,},
   /*FYL2X         */    {1242,},
   /*FYL2XP1       */    {2268,},
   /*GETSEC        */    { 496,},
   /*HLT           */    {3959,},
   /*INSB          */    { 165,},
   /*INT1          */    {4246,},
   /*INT3          */    {3063,},
   /*INVD          */    { 675,},
   /*LAHF          */    {5723,},
   /*LFENCE        */    { 729,},
   /*MCOMMIT       */    { 192,},
   /*MFENCE        */    { 374,},
   /*MWAIT         */    {4604,},
   /*MWAITX        */    {1718,},
   /*NOP2          */    {3462,},
   /*NOP3          */    {4894,},
   /*NOP4          */    {5185,},
   /*NOP5          */    {5247,},
   /*NOP6          */    {3464,},
   /*NOP7          */    {2193,},
   /*NOP8          */    {3732,},
   /*NOP9          */    {5813,},
   /*PAUSE         */    { 629,},
   /*PCONFIG       */    {3861,},
   /*RDMSR         */    {2430,},
   /*RDPKRU        */    {3141,},
   /*RDPMC         */    {4810,},
   /*RDPRU         */    {4516,},
   /*RDTSC         */    {5545,},
   /*RDTSCP        */    {3947,},
   /*REPE_SCASB    */    { 197,},
   /*REPNE_SCASB   */    {3663,},
   /*REP_XCRYPTCBC */    {2820,},
   /*REP_XCRYPTCFB */    {1321,},
   /*REP_XCRYPTCTR */    {2833,},
   /*REP_XCRYPTECB */    {3281,},
   /*REP_XCRYPTOFB */    {1455,},
   /*REP_XSHA1     */    {2830,},
   /*REP_XSHA256   */    {1477,},
   /*REP_XSTORE    */    {2459,},
   /*RSM           */    {1558,},
   /*SAHF          */    {5370,},
   /*SAVEPREVSSP   */    {1004,},
   /*SCASB         */    {2137,},
   /*SERIALIZE     */    {2560,},
   /*SETSSBSY      */    {5346,},
   /*SFENCE        */    {3877,},
   /*STAC          */    { 280,},
   /*STC           */    {6965,},
   /*STD           */    {4698,},
   /*STGI          */    {2981,},
   /*STI           */    {1293,},
   /*STOSB         */    {1856,},
   /*UD2           */    {5530,},
   /*VMCALL        */    {1444,},
   /*VMFUNC        */    {2638,},
   /*VMLAUNCH      */    {4345,},
   /*VMMCALL       */    {4118,},
   /*VMRESUME      */    {4907,},
   /*VMSAVE        */    {4260,},
   /*VMXOFF        */    { 644,},
   /*WBNOINVD      */    {4473,},
   /*WRMSR         */    {2828,},
   /*WRPKRU        */    { 107,},
   /*XEND          */    { 152,},
   /*XGETBV        */    {4409,},
   /*XRESLDTRK     */    {2792,},
   /*XSETBV        */    { 566,},
   /*XSTORE        */    {5371,},
   /*XSUSLDTRK     */    {2622,},
   /*XTEST         */    {4057,},
   };
   xed_uint8_t iclass_index = xed_encoder_get_iclasses_index_in_group(xes);
   if (xes->_n_operand_order == 0) {
   conditions_satisfied = 1;
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][0]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   return 0;
   (void) okay;
   (void) conditions_satisfied;
   (void) xes;
}
xed_bool_t xed_encode_group_7(xed_encoder_request_t* xes)
{
   xed_bool_t okay=1;
   xed_bool_t conditions_satisfied=0;
   xed_ptrn_func_ptr_t fb_ptrn_function;
   static const xed_uint16_t iform_ids[1][4] = {
   /*MOVSD_XMM     */    {  38,  36,  37,  35,},
   };
   xed_uint8_t iclass_index = xed_encoder_get_iclasses_index_in_group(xes);
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_REG1) {
   conditions_satisfied = xed_encode_ntluf_XMM_B(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_XMM_R(xes,xed3_operand_get_reg1(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][0]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_IGNORE66_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_REG1) {
   conditions_satisfied = xed_encode_ntluf_XMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_XMM_B(xes,xed3_operand_get_reg1(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][1]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_IGNORE66_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_MEM0 && xes->_operand_order[1] == XED_OPERAND_REG0) {
   conditions_satisfied = (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_SD) &&
		 xed_encode_ntluf_XMM_R(xes,xed3_operand_get_reg0(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][2]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_IGNORE66_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_MEM0) {
   conditions_satisfied = xed_encode_ntluf_XMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_SD);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][3]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_IGNORE66_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay) return 1;
   }
     }
   return 0;
   (void) okay;
   (void) conditions_satisfied;
   (void) xes;
}
xed_bool_t xed_encode_group_8(xed_encoder_request_t* xes)
{
   xed_bool_t okay=1;
   xed_bool_t conditions_satisfied=0;
   xed_ptrn_func_ptr_t fb_ptrn_function;
   static const xed_uint16_t iform_ids[1][2] = {
   /*ARPL          */    {  40,  39,},
   };
   xed_uint8_t iclass_index = xed_encoder_get_iclasses_index_in_group(xes);
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_REG1) {
   conditions_satisfied = (xed3_operand_get_mode(xes) != 2) &&
		 xed_encode_ntluf_GPR16_B(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_GPR16_R(xes,xed3_operand_get_reg1(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][0]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_MEM0 && xes->_operand_order[1] == XED_OPERAND_REG0) {
   conditions_satisfied = (xed3_operand_get_mode(xes) != 2) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_W) &&
		 xed_encode_ntluf_GPR16_R(xes,xed3_operand_get_reg0(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][1]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay) return 1;
   }
     }
   return 0;
   (void) okay;
   (void) conditions_satisfied;
   (void) xes;
}
xed_bool_t xed_encode_group_9(xed_encoder_request_t* xes)
{
   xed_bool_t okay=1;
   xed_bool_t conditions_satisfied=0;
   xed_ptrn_func_ptr_t fb_ptrn_function;
   static const xed_uint16_t iform_ids[10][2] = {
   /*CVTDQ2PS      */    {  43,  42,},
   /*GF2P8MULB     */    {4908,4909,},
   /*SHA1MSG1      */    {6393,6394,},
   /*SHA1MSG2      */    {1014,1015,},
   /*SHA1NEXTE     */    { 695, 696,},
   /*SHA256MSG1    */    {4247,4248,},
   /*SHA256MSG2    */    {1453,1454,},
   /*SHA256RNDS2   */    {2097,2098,},
   /*UNPCKHPS      */    {1579,1578,},
   /*UNPCKLPS      */    {4852,4851,},
   };
   xed_uint8_t iclass_index = xed_encoder_get_iclasses_index_in_group(xes);
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_REG1) {
   conditions_satisfied = xed_encode_ntluf_XMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_XMM_B(xes,xed3_operand_get_reg1(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][0]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_MEM0) {
   conditions_satisfied = xed_encode_ntluf_XMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_DQ);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][1]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay) return 1;
   }
     }
   return 0;
   (void) okay;
   (void) conditions_satisfied;
   (void) xes;
}
xed_bool_t xed_encode_group_10(xed_encoder_request_t* xes)
{
   xed_bool_t okay=1;
   xed_bool_t conditions_satisfied=0;
   xed_ptrn_func_ptr_t fb_ptrn_function;
   static const xed_uint16_t iform_ids[2][4] = {
   /*LOOPE         */    {  46,  44,  45,  47,},
   /*LOOPNE        */    {2076,2074,2075,2077,},
   };
   xed_uint8_t iclass_index = xed_encoder_get_iclasses_index_in_group(xes);
   if (xes->_n_operand_order == 1 && xes->_operand_order[0] == XED_OPERAND_RELBR) {
   conditions_satisfied = (xed3_operand_get_modep5(xes) == 0) &&
		 (xed3_operand_get_relbr(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][0]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_DF64_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_BRDISP8_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_IMMUNE66_LOOP64_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 1 && xes->_operand_order[0] == XED_OPERAND_RELBR) {
   conditions_satisfied = (xed3_operand_get_modep5(xes) == 1) &&
		 (xed3_operand_get_relbr(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][1]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_DF64_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_BRDISP8_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_IMMUNE66_LOOP64_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 1 && xes->_operand_order[0] == XED_OPERAND_RELBR) {
   conditions_satisfied = (xed3_operand_get_modep5(xes) == 1) &&
		 (xed3_operand_get_relbr(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][2]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_DF64_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_BRDISP8_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_IMMUNE66_LOOP64_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 1 && xes->_operand_order[0] == XED_OPERAND_RELBR) {
   conditions_satisfied = (xed3_operand_get_modep5(xes) == 1) &&
		 (xed3_operand_get_relbr(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][3]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_DF64_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_BRDISP8_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_IMMUNE66_LOOP64_BIND(xes);
       if (okay) return 1;
   }
     }
   return 0;
   (void) okay;
   (void) conditions_satisfied;
   (void) xes;
}
xed_bool_t xed_encode_group_11(xed_encoder_request_t* xes)
{
   xed_bool_t okay=1;
   xed_bool_t conditions_satisfied=0;
   xed_ptrn_func_ptr_t fb_ptrn_function;
   static const xed_uint16_t iform_ids[12][1] = {
   /*XRSTOR        */    {3370,},
   /*XRSTOR64      */    {2590,},
   /*XRSTORS       */    { 273,},
   /*XRSTORS64     */    {3274,},
   /*XSAVE         */    {5842,},
   /*XSAVE64       */    {6020,},
   /*XSAVEC        */    {4656,},
   /*XSAVEC64      */    {  48,},
   /*XSAVEOPT      */    {2475,},
   /*XSAVEOPT64    */    {4609,},
   /*XSAVES        */    {2267,},
   /*XSAVES64      */    {2576,},
   };
   xed_uint8_t iclass_index = xed_encoder_get_iclasses_index_in_group(xes);
   if (xes->_n_operand_order == 1 && xes->_operand_order[0] == XED_OPERAND_MEM0) {
   conditions_satisfied = (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_MXSAVE);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][0]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay) return 1;
   }
     }
   return 0;
   (void) okay;
   (void) conditions_satisfied;
   (void) xes;
}
xed_bool_t xed_encode_group_12(xed_encoder_request_t* xes)
{
   xed_bool_t okay=1;
   xed_bool_t conditions_satisfied=0;
   xed_ptrn_func_ptr_t fb_ptrn_function;
   static const xed_uint16_t iform_ids[4][4] = {
   /*VFMADDSS      */    {  50,  52,  49,  51,},
   /*VFMSUBSS      */    {6256,6258,6255,6257,},
   /*VFNMADDSS     */    {5218,5220,5217,5219,},
   /*VFNMSUBSS     */    { 267, 269, 266, 268,},
   };
   xed_uint8_t iclass_index = xed_encoder_get_iclasses_index_in_group(xes);
   if (xes->_n_operand_order == 4 && memcmp(xed_encode_order[12], xes->_operand_order, sizeof(xed_uint8_t)*4)==0) {
   conditions_satisfied = (xed3_operand_get_must_use_evex(xes) == 0) &&
		 xed_encode_ntluf_XMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_XMM_N(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_XMM_B(xes,xed3_operand_get_reg2(xes)) &&
		 xed_encode_ntluf_XMM_SE(xes,xed3_operand_get_reg3(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][0]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_SE_IMM8_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 4 && memcmp(xed_encode_order[12], xes->_operand_order, sizeof(xed_uint8_t)*4)==0) {
   conditions_satisfied = (xed3_operand_get_must_use_evex(xes) == 0) &&
		 xed_encode_ntluf_XMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_XMM_N(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_XMM_SE(xes,xed3_operand_get_reg2(xes)) &&
		 xed_encode_ntluf_XMM_B(xes,xed3_operand_get_reg3(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][1]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_SE_IMM8_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 4 && memcmp(xed_encode_order[11], xes->_operand_order, sizeof(xed_uint8_t)*4)==0) {
   conditions_satisfied = (xed3_operand_get_must_use_evex(xes) == 0) &&
		 xed_encode_ntluf_XMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_XMM_N(xes,xed3_operand_get_reg1(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_D) &&
		 xed_encode_ntluf_XMM_SE(xes,xed3_operand_get_reg2(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][2]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_SE_IMM8_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 4 && memcmp(xed_encode_order[13], xes->_operand_order, sizeof(xed_uint8_t)*4)==0) {
   conditions_satisfied = (xed3_operand_get_must_use_evex(xes) == 0) &&
		 xed_encode_ntluf_XMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_XMM_N(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_XMM_SE(xes,xed3_operand_get_reg2(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_D);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][3]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_SE_IMM8_BIND(xes);
       if (okay) return 1;
   }
     }
   return 0;
   (void) okay;
   (void) conditions_satisfied;
   (void) xes;
}
xed_bool_t xed_encode_group_13(xed_encoder_request_t* xes)
{
   xed_bool_t okay=1;
   xed_bool_t conditions_satisfied=0;
   xed_ptrn_func_ptr_t fb_ptrn_function;
   static const xed_uint16_t iform_ids[15][2] = {
   /*VPHADDBD      */    {  54,  53,},
   /*VPHADDBQ      */    { 151, 150,},
   /*VPHADDBW      */    {6566,6565,},
   /*VPHADDDQ      */    { 515, 514,},
   /*VPHADDUBD     */    { 964, 963,},
   /*VPHADDUBQ     */    {5772,5771,},
   /*VPHADDUBW     */    {1024,1023,},
   /*VPHADDUDQ     */    {1545,1544,},
   /*VPHADDUWD     */    {3260,3259,},
   /*VPHADDUWQ     */    {1975,1974,},
   /*VPHADDWD      */    {5917,5916,},
   /*VPHADDWQ      */    {1615,1614,},
   /*VPHSUBBW      */    {1499,1498,},
   /*VPHSUBDQ      */    {4518,4517,},
   /*VPHSUBWD      */    { 962, 961,},
   };
   xed_uint8_t iclass_index = xed_encoder_get_iclasses_index_in_group(xes);
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_REG1) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 xed_encode_ntluf_XMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_XMM_B(xes,xed3_operand_get_reg1(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][0]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_MEM0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 xed_encode_ntluf_XMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_DQ);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][1]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay) return 1;
   }
     }
   return 0;
   (void) okay;
   (void) conditions_satisfied;
   (void) xes;
}
xed_bool_t xed_encode_group_14(xed_encoder_request_t* xes)
{
   xed_bool_t okay=1;
   xed_bool_t conditions_satisfied=0;
   xed_ptrn_func_ptr_t fb_ptrn_function;
   static const xed_uint16_t iform_ids[22][11] = {
   /*VADDPD        */    { 429, 425, 427, 424, 426, 431, 433, 428, 432, 434, 430,},
   /*VDIVPD        */    {3430,3426,3428,3425,3427,3432,3434,3429,3433,3435,3431,},
   /*VFMADD132PD   */    {2007,2003,2005,2002,2004,2009,2011,2006,2010,2012,2008,},
   /*VFMADD213PD   */    {4146,4142,4144,4141,4143,4148,4150,4145,4149,4151,4147,},
   /*VFMADD231PD   */    {2245,2241,2243,2240,2242,2247,2249,2244,2248,2250,2246,},
   /*VFMADDSUB132PD*/    {2732,2728,2730,2727,2729,2734,2736,2731,2735,2737,2733,},
   /*VFMADDSUB213PD*/    { 735, 731, 733, 730, 732, 737, 739, 734, 738, 740, 736,},
   /*VFMADDSUB231PD*/    {3020,3016,3018,3015,3017,3022,3024,3019,3023,3025,3021,},
   /*VFMSUB132PD   */    {2389,2385,2387,2384,2386,2391,2393,2388,2392,2394,2390,},
   /*VFMSUB213PD   */    { 920, 916, 918, 915, 917, 922, 924, 919, 923, 925, 921,},
   /*VFMSUB231PD   */    {1257,1253,1255,1252,1254,1259,1261,1256,1260,1262,1258,},
   /*VFMSUBADD132PD*/    {5848,5844,5846,5843,5845,5850,5852,5847,5851,5853,5849,},
   /*VFMSUBADD213PD*/    {5128,5124,5126,5123,5125,5130,5132,5127,5131,5133,5129,},
   /*VFMSUBADD231PD*/    {6457,6453,6455,6452,6454,6459,6461,6456,6460,6462,6458,},
   /*VFNMADD132PD  */    { 119, 115, 117, 114, 116, 121, 123, 118, 122, 124, 120,},
   /*VFNMADD213PD  */    { 669, 665, 667, 664, 666, 671, 673, 668, 672, 674, 670,},
   /*VFNMADD231PD  */    {3099,3095,3097,3094,3096,3101,3103,3098,3102,3104,3100,},
   /*VFNMSUB132PD  */    {6729,6725,6727,6724,6726,6731,6733,6728,6732,6734,6730,},
   /*VFNMSUB213PD  */    {6752,6748,6750,6747,6749,6754,6756,6751,6755,6757,6753,},
   /*VFNMSUB231PD  */    {2293,2289,2291,2288,2290,2295,2297,2292,2296,2298,2294,},
   /*VMULPD        */    {  60,  56,  58,  55,  57,  62,  64,  59,  63,  65,  61,},
   /*VSUBPD        */    {6140,6136,6138,6135,6137,6142,6144,6139,6143,6145,6141,},
   };
   xed_uint8_t iclass_index = xed_encoder_get_iclasses_index_in_group(xes);
   if (xes->_n_operand_order == 4 && memcmp(xed_encode_order[12], xes->_operand_order, sizeof(xed_uint8_t)*4)==0) {
   conditions_satisfied = (xed3_operand_get_roundc(xes) != 0) &&
		 xed_encode_ntluf_ZMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_ZMM_N3(xes,xed3_operand_get_reg2(xes)) &&
		 xed_encode_ntluf_ZMM_B3(xes,xed3_operand_get_reg3(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][0]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_FIX_ROUND_LEN512_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_AVX512_ROUND_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[7], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 (xed3_operand_get_must_use_evex(xes) == 0) &&
		 xed_encode_ntluf_XMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_XMM_N(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_XMM_B(xes,xed3_operand_get_reg2(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][1]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[7], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 1) &&
		 (xed3_operand_get_must_use_evex(xes) == 0) &&
		 xed_encode_ntluf_YMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_YMM_N(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_YMM_B(xes,xed3_operand_get_reg2(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][2]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[14], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 (xed3_operand_get_must_use_evex(xes) == 0) &&
		 xed_encode_ntluf_XMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_XMM_N(xes,xed3_operand_get_reg1(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_DQ);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][3]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[14], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 1) &&
		 (xed3_operand_get_must_use_evex(xes) == 0) &&
		 xed_encode_ntluf_YMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_YMM_N(xes,xed3_operand_get_reg1(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_QQ);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][4]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 4 && memcmp(xed_encode_order[12], xes->_operand_order, sizeof(xed_uint8_t)*4)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 xed_encode_ntluf_XMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_XMM_N3(xes,xed3_operand_get_reg2(xes)) &&
		 xed_encode_ntluf_XMM_B3(xes,xed3_operand_get_reg3(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][5]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 4 && memcmp(xed_encode_order[12], xes->_operand_order, sizeof(xed_uint8_t)*4)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 1) &&
		 xed_encode_ntluf_YMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_YMM_N3(xes,xed3_operand_get_reg2(xes)) &&
		 xed_encode_ntluf_YMM_B3(xes,xed3_operand_get_reg3(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][6]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 4 && memcmp(xed_encode_order[12], xes->_operand_order, sizeof(xed_uint8_t)*4)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 2) &&
		 xed_encode_ntluf_ZMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_ZMM_N3(xes,xed3_operand_get_reg2(xes)) &&
		 xed_encode_ntluf_ZMM_B3(xes,xed3_operand_get_reg3(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][7]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 4 && memcmp(xed_encode_order[13], xes->_operand_order, sizeof(xed_uint8_t)*4)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 xed_encode_ntluf_XMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_XMM_N3(xes,xed3_operand_get_reg2(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_VV);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][8]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_64_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_FULL_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 4 && memcmp(xed_encode_order[13], xes->_operand_order, sizeof(xed_uint8_t)*4)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 1) &&
		 xed_encode_ntluf_YMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_YMM_N3(xes,xed3_operand_get_reg2(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_VV);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][9]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_64_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_FULL_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 4 && memcmp(xed_encode_order[13], xes->_operand_order, sizeof(xed_uint8_t)*4)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 2) &&
		 xed_encode_ntluf_ZMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_ZMM_N3(xes,xed3_operand_get_reg2(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_VV);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][10]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_64_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_FULL_BIND(xes);
       if (okay) return 1;
   }
     }
   return 0;
   (void) okay;
   (void) conditions_satisfied;
   (void) xes;
}
xed_bool_t xed_encode_group_15(xed_encoder_request_t* xes)
{
   xed_bool_t okay=1;
   xed_bool_t conditions_satisfied=0;
   xed_ptrn_func_ptr_t fb_ptrn_function;
   static const xed_uint16_t iform_ids[59][4] = {
   /*PABSB         */    {1213,1212,1215,1214,},
   /*PABSD         */    {2523,2522,2525,2524,},
   /*PABSW         */    {4387,4386,4389,4388,},
   /*PACKSSDW      */    { 726, 725, 728, 727,},
   /*PACKSSWB      */    {3867,3866,3869,3868,},
   /*PACKUSWB      */    {4307,4306,4309,4308,},
   /*PADDB         */    {1328,1327,1330,1329,},
   /*PADDD         */    {5077,5076,5079,5078,},
   /*PADDQ         */    {  67,  66,  69,  68,},
   /*PADDSB        */    {6434,6433,6436,6435,},
   /*PADDSW        */    {5575,5574,5577,5576,},
   /*PADDUSB       */    {1772,1771,1774,1773,},
   /*PADDUSW       */    {4484,4483,4486,4485,},
   /*PADDW         */    {3030,3029,3032,3031,},
   /*PAND          */    {3012,3011,3014,3013,},
   /*PANDN         */    { 476, 475, 478, 477,},
   /*PAVGB         */    {3518,3517,3520,3519,},
   /*PAVGW         */    { 823, 822, 825, 824,},
   /*PCMPEQB       */    {5367,5366,5369,5368,},
   /*PCMPEQD       */    { 301, 300, 303, 302,},
   /*PCMPEQW       */    {3729,3728,3731,3730,},
   /*PCMPGTB       */    {3220,3219,3222,3221,},
   /*PCMPGTD       */    {4521,4520,4523,4522,},
   /*PCMPGTW       */    {5614,5613,5616,5615,},
   /*PHADDD        */    {3480,3479,3482,3481,},
   /*PHADDSW       */    {6088,6087,6090,6089,},
   /*PHADDW        */    { 698, 697, 700, 699,},
   /*PHSUBD        */    {2928,2927,2930,2929,},
   /*PHSUBSW       */    {3594,3593,3596,3595,},
   /*PHSUBW        */    { 572, 571, 574, 573,},
   /*PMADDUBSW     */    {4302,4301,4304,4303,},
   /*PMADDWD       */    {6024,6023,6026,6025,},
   /*PMAXSW        */    { 415, 414, 417, 416,},
   /*PMAXUB        */    {3112,3111,3114,3113,},
   /*PMINSW        */    {6098,6097,6100,6099,},
   /*PMINUB        */    { 589, 588, 591, 590,},
   /*PMULHRSW      */    {2421,2420,2423,2422,},
   /*PMULHUW       */    {6132,6131,6134,6133,},
   /*PMULHW        */    {2761,2760,2763,2762,},
   /*PMULLW        */    {4679,4678,4681,4680,},
   /*PMULUDQ       */    { 886, 885, 888, 887,},
   /*POR           */    {5932,5931,5934,5933,},
   /*PSADBW        */    {5471,5470,5473,5472,},
   /*PSHUFB        */    {5373,5372,5375,5374,},
   /*PSIGNB        */    { 657, 656, 659, 658,},
   /*PSIGND        */    {1555,1554,1557,1556,},
   /*PSIGNW        */    {1720,1719,1722,1721,},
   /*PSUBB         */    {6700,6699,6702,6701,},
   /*PSUBD         */    {4062,4061,4064,4063,},
   /*PSUBQ         */    {4480,4479,4482,4481,},
   /*PSUBSB        */    {4701,4700,4703,4702,},
   /*PSUBSW        */    {1611,1610,1613,1612,},
   /*PSUBUSB       */    {1385,1384,1387,1386,},
   /*PSUBUSW       */    { 856, 855, 858, 857,},
   /*PSUBW         */    {3421,3420,3423,3422,},
   /*PUNPCKHBW     */    {5690,5689,5692,5691,},
   /*PUNPCKHDQ     */    {2948,2947,2950,2949,},
   /*PUNPCKHWD     */    {3107,3106,3109,3108,},
   /*PXOR          */    {2145,2144,2147,2146,},
   };
   xed_uint8_t iclass_index = xed_encoder_get_iclasses_index_in_group(xes);
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_REG1) {
   conditions_satisfied = xed_encode_ntluf_MMX_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MMX_B(xes,xed3_operand_get_reg1(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][0]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_MEM0) {
   conditions_satisfied = xed_encode_ntluf_MMX_R(xes,xed3_operand_get_reg0(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_Q);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][1]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_REG1) {
   conditions_satisfied = xed_encode_ntluf_XMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_XMM_B(xes,xed3_operand_get_reg1(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][2]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_REFINING66_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_MEM0) {
   conditions_satisfied = xed_encode_ntluf_XMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_DQ);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][3]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_REFINING66_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay) return 1;
   }
     }
   return 0;
   (void) okay;
   (void) conditions_satisfied;
   (void) xes;
}
xed_bool_t xed_encode_group_16(xed_encoder_request_t* xes)
{
   xed_bool_t okay=1;
   xed_bool_t conditions_satisfied=0;
   xed_ptrn_func_ptr_t fb_ptrn_function;
   static const xed_uint16_t iform_ids[4][7] = {
   /*VCVTPD2QQ     */    {  75,  70,  72,  74,  71,  73,  76,},
   /*VCVTPD2UQQ    */    { 641, 636, 638, 640, 637, 639, 642,},
   /*VCVTQQ2PD     */    {2775,2770,2772,2774,2771,2773,2776,},
   /*VCVTUQQ2PD    */    { 584, 579, 581, 583, 580, 582, 585,},
   };
   xed_uint8_t iclass_index = xed_encoder_get_iclasses_index_in_group(xes);
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[7], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_roundc(xes) != 0) &&
		 xed_encode_ntluf_ZMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_ZMM_B3(xes,xed3_operand_get_reg2(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][0]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_FIX_ROUND_LEN512_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_AVX512_ROUND_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[7], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 xed_encode_ntluf_XMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_XMM_B3(xes,xed3_operand_get_reg2(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][1]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[7], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 1) &&
		 xed_encode_ntluf_YMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_YMM_B3(xes,xed3_operand_get_reg2(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][2]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[7], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 2) &&
		 xed_encode_ntluf_ZMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_ZMM_B3(xes,xed3_operand_get_reg2(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][3]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[14], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 xed_encode_ntluf_XMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_VV);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][4]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_64_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_FULL_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[14], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 1) &&
		 xed_encode_ntluf_YMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_VV);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][5]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_64_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_FULL_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[14], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 2) &&
		 xed_encode_ntluf_ZMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_VV);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][6]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_64_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_FULL_BIND(xes);
       if (okay) return 1;
   }
     }
   return 0;
   (void) okay;
   (void) conditions_satisfied;
   (void) xes;
}
xed_bool_t xed_encode_group_17(xed_encoder_request_t* xes)
{
   xed_bool_t okay=1;
   xed_bool_t conditions_satisfied=0;
   xed_ptrn_func_ptr_t fb_ptrn_function;
   static const xed_uint16_t iform_ids[8][1] = {
   /*VGATHERPF0DPS */    {2697,},
   /*VGATHERPF0QPS */    {2821,},
   /*VGATHERPF1DPS */    {2936,},
   /*VGATHERPF1QPS */    { 554,},
   /*VSCATTERPF0DPS*/    {2910,},
   /*VSCATTERPF0QPS*/    {  77,},
   /*VSCATTERPF1DPS*/    {3668,},
   /*VSCATTERPF1QPS*/    {2358,},
   };
   xed_uint8_t iclass_index = xed_encoder_get_iclasses_index_in_group(xes);
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_MEM0 && xes->_operand_order[1] == XED_OPERAND_REG0) {
   conditions_satisfied = (xed3_operand_get_easz(xes) != 1) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_D) &&
		 xed_encode_ntluf_MASKNOT0(xes,xed3_operand_get_reg0(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][0]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_UISA_VMODRM_ZMM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_32_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_GSCAT_BIND(xes);
       if (okay) return 1;
   }
     }
   return 0;
   (void) okay;
   (void) conditions_satisfied;
   (void) xes;
}
xed_bool_t xed_encode_group_18(xed_encoder_request_t* xes)
{
   xed_bool_t okay=1;
   xed_bool_t conditions_satisfied=0;
   xed_ptrn_func_ptr_t fb_ptrn_function;
   static const xed_uint16_t iform_ids[5][6] = {
   /*VPCONFLICTD   */    { 632, 634, 630, 633, 635, 631,},
   /*VPLZCNTD      */    {4618,4620,4616,4619,4621,4617,},
   /*VPOPCNTD      */    {6040,6042,6038,6041,6043,6039,},
   /*VRCP14PS      */    {  80,  82,  78,  81,  83,  79,},
   /*VRSQRT14PS    */    {3535,3537,3533,3536,3538,3534,},
   };
   xed_uint8_t iclass_index = xed_encoder_get_iclasses_index_in_group(xes);
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[7], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 xed_encode_ntluf_XMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_XMM_B3(xes,xed3_operand_get_reg2(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][0]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[7], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 1) &&
		 xed_encode_ntluf_YMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_YMM_B3(xes,xed3_operand_get_reg2(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][1]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[7], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 2) &&
		 xed_encode_ntluf_ZMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_ZMM_B3(xes,xed3_operand_get_reg2(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][2]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[14], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 xed_encode_ntluf_XMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_VV);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][3]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_32_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_FULL_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[14], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 1) &&
		 xed_encode_ntluf_YMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_VV);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][4]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_32_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_FULL_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[14], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 2) &&
		 xed_encode_ntluf_ZMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_VV);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][5]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_32_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_FULL_BIND(xes);
       if (okay) return 1;
   }
     }
   return 0;
   (void) okay;
   (void) conditions_satisfied;
   (void) xes;
}
xed_bool_t xed_encode_group_19(xed_encoder_request_t* xes)
{
   xed_bool_t okay=1;
   xed_bool_t conditions_satisfied=0;
   xed_ptrn_func_ptr_t fb_ptrn_function;
   static const xed_uint16_t iform_ids[8][1] = {
   /*KSHIFTLB      */    {4245,},
   /*KSHIFTLD      */    {4474,},
   /*KSHIFTLQ      */    {  84,},
   /*KSHIFTLW      */    { 530,},
   /*KSHIFTRB      */    {3483,},
   /*KSHIFTRD      */    { 996,},
   /*KSHIFTRQ      */    {3296,},
   /*KSHIFTRW      */    {4994,},
   };
   xed_uint8_t iclass_index = xed_encoder_get_iclasses_index_in_group(xes);
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[15], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_must_use_evex(xes) == 0) &&
		 xed_encode_ntluf_MASK_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK_B(xes,xed3_operand_get_reg1(xes)) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][0]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_UIMM8_BIND(xes);
       if (okay) return 1;
   }
     }
   return 0;
   (void) okay;
   (void) conditions_satisfied;
   (void) xes;
}
xed_bool_t xed_encode_group_20(xed_encoder_request_t* xes)
{
   xed_bool_t okay=1;
   xed_bool_t conditions_satisfied=0;
   xed_ptrn_func_ptr_t fb_ptrn_function;
   static const xed_uint16_t iform_ids[1][1] = {
   /*RMPADJUST     */    {  85,},
   };
   xed_uint8_t iclass_index = xed_encoder_get_iclasses_index_in_group(xes);
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[7], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_mode(xes) == 2) &&
		 (xed3_operand_get_reg0(xes) == XED_REG_RAX) &&
		 (xed3_operand_get_reg1(xes) == XED_REG_RCX) &&
		 (xed3_operand_get_reg2(xes) == XED_REG_RDX);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][0]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   return 0;
   (void) okay;
   (void) conditions_satisfied;
   (void) xes;
}
xed_bool_t xed_encode_group_21(xed_encoder_request_t* xes)
{
   xed_bool_t okay=1;
   xed_bool_t conditions_satisfied=0;
   xed_ptrn_func_ptr_t fb_ptrn_function;
   static const xed_uint16_t iform_ids[16][2] = {
   /*SETB          */    {2608,2607,},
   /*SETBE         */    { 413, 412,},
   /*SETL          */    {1006,1005,},
   /*SETLE         */    {3927,3926,},
   /*SETNB         */    {6022,6021,},
   /*SETNBE        */    {3879,3878,},
   /*SETNL         */    {2181,2180,},
   /*SETNLE        */    {6432,6431,},
   /*SETNO         */    { 932, 931,},
   /*SETNP         */    {6246,6245,},
   /*SETNS         */    {3478,3477,},
   /*SETNZ         */    {  87,  86,},
   /*SETO          */    {4804,4803,},
   /*SETP          */    {2832,2831,},
   /*SETS          */    {2983,2982,},
   /*SETZ          */    { 373, 372,},
   };
   xed_uint8_t iclass_index = xed_encoder_get_iclasses_index_in_group(xes);
   if (xes->_n_operand_order == 1 && xes->_operand_order[0] == XED_OPERAND_REG0) {
   conditions_satisfied = xed_encode_ntluf_GPR8_B(xes,xed3_operand_get_reg0(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][0]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 1 && xes->_operand_order[0] == XED_OPERAND_MEM0) {
   conditions_satisfied = (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_B);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][1]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay) return 1;
   }
     }
   return 0;
   (void) okay;
   (void) conditions_satisfied;
   (void) xes;
}
xed_bool_t xed_encode_group_22(xed_encoder_request_t* xes)
{
   xed_bool_t okay=1;
   xed_bool_t conditions_satisfied=0;
   xed_ptrn_func_ptr_t fb_ptrn_function;
   static const xed_uint16_t iform_ids[1][7] = {
   /*VSCALEFPD     */    {  89,  91,  93,  88,  92,  94,  90,},
   };
   xed_uint8_t iclass_index = xed_encoder_get_iclasses_index_in_group(xes);
   if (xes->_n_operand_order == 4 && memcmp(xed_encode_order[12], xes->_operand_order, sizeof(xed_uint8_t)*4)==0) {
   conditions_satisfied = (xed3_operand_get_roundc(xes) != 0) &&
		 xed_encode_ntluf_ZMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_ZMM_N3(xes,xed3_operand_get_reg2(xes)) &&
		 xed_encode_ntluf_ZMM_B3(xes,xed3_operand_get_reg3(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][0]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_FIX_ROUND_LEN512_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_AVX512_ROUND_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 4 && memcmp(xed_encode_order[12], xes->_operand_order, sizeof(xed_uint8_t)*4)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 xed_encode_ntluf_XMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_XMM_N3(xes,xed3_operand_get_reg2(xes)) &&
		 xed_encode_ntluf_XMM_B3(xes,xed3_operand_get_reg3(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][1]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 4 && memcmp(xed_encode_order[12], xes->_operand_order, sizeof(xed_uint8_t)*4)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 1) &&
		 xed_encode_ntluf_YMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_YMM_N3(xes,xed3_operand_get_reg2(xes)) &&
		 xed_encode_ntluf_YMM_B3(xes,xed3_operand_get_reg3(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][2]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 4 && memcmp(xed_encode_order[12], xes->_operand_order, sizeof(xed_uint8_t)*4)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 2) &&
		 xed_encode_ntluf_ZMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_ZMM_N3(xes,xed3_operand_get_reg2(xes)) &&
		 xed_encode_ntluf_ZMM_B3(xes,xed3_operand_get_reg3(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][3]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 4 && memcmp(xed_encode_order[13], xes->_operand_order, sizeof(xed_uint8_t)*4)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 xed_encode_ntluf_XMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_XMM_N3(xes,xed3_operand_get_reg2(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_VV);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][4]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_64_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_FULL_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 4 && memcmp(xed_encode_order[13], xes->_operand_order, sizeof(xed_uint8_t)*4)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 1) &&
		 xed_encode_ntluf_YMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_YMM_N3(xes,xed3_operand_get_reg2(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_VV);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][5]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_64_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_FULL_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 4 && memcmp(xed_encode_order[13], xes->_operand_order, sizeof(xed_uint8_t)*4)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 2) &&
		 xed_encode_ntluf_ZMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_ZMM_N3(xes,xed3_operand_get_reg2(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_VV);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][6]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_64_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_FULL_BIND(xes);
       if (okay) return 1;
   }
     }
   return 0;
   (void) okay;
   (void) conditions_satisfied;
   (void) xes;
}
xed_bool_t xed_encode_group_23(xed_encoder_request_t* xes)
{
   xed_bool_t okay=1;
   xed_bool_t conditions_satisfied=0;
   xed_ptrn_func_ptr_t fb_ptrn_function;
   static const xed_uint16_t iform_ids[1][1] = {
   /*LEA           */    {  95,},
   };
   xed_uint8_t iclass_index = xed_encoder_get_iclasses_index_in_group(xes);
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_AGEN) {
   conditions_satisfied = xed_encode_ntluf_GPRv_R(xes,xed3_operand_get_reg0(xes)) &&
		 (xed3_operand_get_agen(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][0]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_REMOVE_SEGMENT_BIND(xes);
       if (okay) return 1;
   }
     }
   return 0;
   (void) okay;
   (void) conditions_satisfied;
   (void) xes;
}
xed_bool_t xed_encode_group_24(xed_encoder_request_t* xes)
{
   xed_bool_t okay=1;
   xed_bool_t conditions_satisfied=0;
   xed_ptrn_func_ptr_t fb_ptrn_function;
   static const xed_uint16_t iform_ids[6][3] = {
   /*VPBROADCASTMB2Q*/    {6147,6148,6146,},
   /*VPBROADCASTMW2D*/    { 228, 229, 227,},
   /*VPMOVM2B      */    {4058,4059,4060,},
   /*VPMOVM2D      */    {6569,6570,6571,},
   /*VPMOVM2Q      */    {  96,  97,  98,},
   /*VPMOVM2W      */    {3319,3320,3321,},
   };
   xed_uint8_t iclass_index = xed_encoder_get_iclasses_index_in_group(xes);
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_REG1) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 xed_encode_ntluf_XMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK_B(xes,xed3_operand_get_reg1(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][0]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_REG1) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 1) &&
		 xed_encode_ntluf_YMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK_B(xes,xed3_operand_get_reg1(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][1]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_REG1) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 2) &&
		 xed_encode_ntluf_ZMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK_B(xes,xed3_operand_get_reg1(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][2]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   return 0;
   (void) okay;
   (void) conditions_satisfied;
   (void) xes;
}
xed_bool_t xed_encode_group_25(xed_encoder_request_t* xes)
{
   xed_bool_t okay=1;
   xed_bool_t conditions_satisfied=0;
   xed_ptrn_func_ptr_t fb_ptrn_function;
   static const xed_uint16_t iform_ids[4][1] = {
   /*FXRSTOR       */    {6244,},
   /*FXRSTOR64     */    {1224,},
   /*FXSAVE        */    {6261,},
   /*FXSAVE64      */    {  99,},
   };
   xed_uint8_t iclass_index = xed_encoder_get_iclasses_index_in_group(xes);
   if (xes->_n_operand_order == 1 && xes->_operand_order[0] == XED_OPERAND_MEM0) {
   conditions_satisfied = (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_MFPXENV);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][0]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay) return 1;
   }
     }
   return 0;
   (void) okay;
   (void) conditions_satisfied;
   (void) xes;
}
xed_bool_t xed_encode_group_26(xed_encoder_request_t* xes)
{
   xed_bool_t okay=1;
   xed_bool_t conditions_satisfied=0;
   xed_ptrn_func_ptr_t fb_ptrn_function;
   static const xed_uint16_t iform_ids[3][6] = {
   /*VPMOVSWB      */    { 101, 103, 105, 102, 104, 106,},
   /*VPMOVUSWB     */    {6889,6891,6893,6890,6892,6894,},
   /*VPMOVWB       */    { 985, 987, 989, 986, 988, 990,},
   };
   xed_uint8_t iclass_index = xed_encoder_get_iclasses_index_in_group(xes);
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[7], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 xed_encode_ntluf_XMM_B3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_XMM_R3(xes,xed3_operand_get_reg2(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][0]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[7], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 1) &&
		 xed_encode_ntluf_XMM_B3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_YMM_R3(xes,xed3_operand_get_reg2(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][1]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[7], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 2) &&
		 xed_encode_ntluf_YMM_B3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_ZMM_R3(xes,xed3_operand_get_reg2(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][2]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[6], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_Q) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_XMM_R3(xes,xed3_operand_get_reg1(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][3]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_8_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_HALFMEM_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[6], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 1) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_DQ) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_YMM_R3(xes,xed3_operand_get_reg1(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][4]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_8_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_HALFMEM_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[6], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 2) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_QQ) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_ZMM_R3(xes,xed3_operand_get_reg1(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][5]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_8_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_HALFMEM_BIND(xes);
       if (okay) return 1;
   }
     }
   return 0;
   (void) okay;
   (void) conditions_satisfied;
   (void) xes;
}
xed_bool_t xed_encode_group_27(xed_encoder_request_t* xes)
{
   xed_bool_t okay=1;
   xed_bool_t conditions_satisfied=0;
   xed_ptrn_func_ptr_t fb_ptrn_function;
   static const xed_uint16_t iform_ids[6][4] = {
   /*FADD          */    {3918,3916,3917,3915,},
   /*FDIV          */    {5722,5720,5721,5719,},
   /*FDIVR         */    { 111, 109, 110, 108,},
   /*FMUL          */    {4934,4932,4933,4931,},
   /*FSUB          */    {3171,3169,3170,3168,},
   /*FSUBR         */    {1469,1467,1468,1466,},
   };
   xed_uint8_t iclass_index = xed_encoder_get_iclasses_index_in_group(xes);
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_REG1) {
   conditions_satisfied = xed_encode_ntluf_X87(xes,xed3_operand_get_reg0(xes)) &&
		 (xed3_operand_get_reg1(xes) == XED_REG_ST0);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][0]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_REG1) {
   conditions_satisfied = (xed3_operand_get_reg0(xes) == XED_REG_ST0) &&
		 xed_encode_ntluf_X87(xes,xed3_operand_get_reg1(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][1]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_MEM0) {
   conditions_satisfied = (xed3_operand_get_reg0(xes) == XED_REG_ST0) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_M64REAL);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][2]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_MEM0) {
   conditions_satisfied = (xed3_operand_get_reg0(xes) == XED_REG_ST0) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_MEM32REAL);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][3]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay) return 1;
   }
     }
   return 0;
   (void) okay;
   (void) conditions_satisfied;
   (void) xes;
}
xed_bool_t xed_encode_group_28(xed_encoder_request_t* xes)
{
   xed_bool_t okay=1;
   xed_bool_t conditions_satisfied=0;
   xed_ptrn_func_ptr_t fb_ptrn_function;
   static const xed_uint16_t iform_ids[2][2] = {
   /*VEXTRACTF128  */    { 113, 112,},
   /*VEXTRACTI128  */    {6378,6377,},
   };
   xed_uint8_t iclass_index = xed_encoder_get_iclasses_index_in_group(xes);
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[15], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 1) &&
		 (xed3_operand_get_must_use_evex(xes) == 0) &&
		 xed_encode_ntluf_XMM_B(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_YMM_R(xes,xed3_operand_get_reg1(xes)) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][0]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_UIMM8_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[17], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 1) &&
		 (xed3_operand_get_must_use_evex(xes) == 0) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_DQ) &&
		 xed_encode_ntluf_YMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][1]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_UIMM8_BIND(xes);
       if (okay) return 1;
   }
     }
   return 0;
   (void) okay;
   (void) conditions_satisfied;
   (void) xes;
}
xed_bool_t xed_encode_group_29(xed_encoder_request_t* xes)
{
   xed_bool_t okay=1;
   xed_bool_t conditions_satisfied=0;
   xed_ptrn_func_ptr_t fb_ptrn_function;
   static const xed_uint16_t iform_ids[2][1] = {
   /*RDRAND        */    { 125,},
   /*RDSEED        */    {4127,},
   };
   xed_uint8_t iclass_index = xed_encoder_get_iclasses_index_in_group(xes);
   if (xes->_n_operand_order == 1 && xes->_operand_order[0] == XED_OPERAND_REG0) {
   conditions_satisfied = xed_encode_ntluf_GPRv_B(xes,xed3_operand_get_reg0(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][0]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   return 0;
   (void) okay;
   (void) conditions_satisfied;
   (void) xes;
}
xed_bool_t xed_encode_group_30(xed_encoder_request_t* xes)
{
   xed_bool_t okay=1;
   xed_bool_t conditions_satisfied=0;
   xed_ptrn_func_ptr_t fb_ptrn_function;
   static const xed_uint16_t iform_ids[2][11] = {
   /*VCVTPD2DQ     */    { 131, 127, 129, 126, 128, 133, 135, 130, 134, 136, 132,},
   /*VCVTPD2PS     */    {6605,6601,6603,6600,6602,6607,6609,6604,6608,6610,6606,},
   };
   xed_uint8_t iclass_index = xed_encoder_get_iclasses_index_in_group(xes);
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[7], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_roundc(xes) != 0) &&
		 xed_encode_ntluf_YMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_ZMM_B3(xes,xed3_operand_get_reg2(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][0]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_FIX_ROUND_LEN512_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_AVX512_ROUND_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_REG1) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 (xed3_operand_get_must_use_evex(xes) == 0) &&
		 xed_encode_ntluf_XMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_XMM_B(xes,xed3_operand_get_reg1(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][1]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_REG1) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 1) &&
		 (xed3_operand_get_must_use_evex(xes) == 0) &&
		 xed_encode_ntluf_XMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_YMM_B(xes,xed3_operand_get_reg1(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][2]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_MEM0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 (xed3_operand_get_must_use_evex(xes) == 0) &&
		 xed_encode_ntluf_XMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_DQ);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][3]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_MEM0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 1) &&
		 (xed3_operand_get_must_use_evex(xes) == 0) &&
		 xed_encode_ntluf_XMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_QQ);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][4]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[7], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 xed_encode_ntluf_XMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_XMM_B3(xes,xed3_operand_get_reg2(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][5]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[7], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 1) &&
		 xed_encode_ntluf_XMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_YMM_B3(xes,xed3_operand_get_reg2(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][6]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[7], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 2) &&
		 xed_encode_ntluf_YMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_ZMM_B3(xes,xed3_operand_get_reg2(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][7]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[14], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 xed_encode_ntluf_XMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_VV);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][8]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_64_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_FULL_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[14], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 1) &&
		 xed_encode_ntluf_XMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_VV);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][9]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_64_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_FULL_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[14], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 2) &&
		 xed_encode_ntluf_YMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_VV);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][10]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_64_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_FULL_BIND(xes);
       if (okay) return 1;
   }
     }
   return 0;
   (void) okay;
   (void) conditions_satisfied;
   (void) xes;
}
xed_bool_t xed_encode_group_31(xed_encoder_request_t* xes)
{
   xed_bool_t okay=1;
   xed_bool_t conditions_satisfied=0;
   xed_ptrn_func_ptr_t fb_ptrn_function;
   static const xed_uint16_t iform_ids[1][2] = {
   /*REP_STOSQ     */    { 138, 139,},
   };
   xed_uint8_t iclass_index = xed_encoder_get_iclasses_index_in_group(xes);
   if (xes->_n_operand_order == 0) {
   conditions_satisfied = (xed3_operand_get_mode(xes) == 2);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][0]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 0) {
   conditions_satisfied = (xed3_operand_get_mode(xes) == 2);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][1]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   return 0;
   (void) okay;
   (void) conditions_satisfied;
   (void) xes;
}
xed_bool_t xed_encode_group_32(xed_encoder_request_t* xes)
{
   xed_bool_t okay=1;
   xed_bool_t conditions_satisfied=0;
   xed_ptrn_func_ptr_t fb_ptrn_function;
   static const xed_uint16_t iform_ids[2][10] = {
   /*VPCMPEQB      */    { 141, 143, 140, 142, 144, 146, 148, 145, 147, 149,},
   /*VPCMPGTB      */    {4658,4660,4657,4659,4661,4663,4665,4662,4664,4666,},
   };
   xed_uint8_t iclass_index = xed_encoder_get_iclasses_index_in_group(xes);
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[7], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 (xed3_operand_get_must_use_evex(xes) == 0) &&
		 xed_encode_ntluf_XMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_XMM_N(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_XMM_B(xes,xed3_operand_get_reg2(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][0]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[7], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 1) &&
		 (xed3_operand_get_must_use_evex(xes) == 0) &&
		 xed_encode_ntluf_YMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_YMM_N(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_YMM_B(xes,xed3_operand_get_reg2(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][1]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[14], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 (xed3_operand_get_must_use_evex(xes) == 0) &&
		 xed_encode_ntluf_XMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_XMM_N(xes,xed3_operand_get_reg1(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_DQ);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][2]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[14], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 1) &&
		 (xed3_operand_get_must_use_evex(xes) == 0) &&
		 xed_encode_ntluf_YMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_YMM_N(xes,xed3_operand_get_reg1(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_QQ);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][3]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 4 && memcmp(xed_encode_order[12], xes->_operand_order, sizeof(xed_uint8_t)*4)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 xed_encode_ntluf_MASK_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_XMM_N3(xes,xed3_operand_get_reg2(xes)) &&
		 xed_encode_ntluf_XMM_B3(xes,xed3_operand_get_reg3(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][4]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 4 && memcmp(xed_encode_order[12], xes->_operand_order, sizeof(xed_uint8_t)*4)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 1) &&
		 xed_encode_ntluf_MASK_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_YMM_N3(xes,xed3_operand_get_reg2(xes)) &&
		 xed_encode_ntluf_YMM_B3(xes,xed3_operand_get_reg3(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][5]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 4 && memcmp(xed_encode_order[12], xes->_operand_order, sizeof(xed_uint8_t)*4)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 2) &&
		 xed_encode_ntluf_MASK_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_ZMM_N3(xes,xed3_operand_get_reg2(xes)) &&
		 xed_encode_ntluf_ZMM_B3(xes,xed3_operand_get_reg3(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][6]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 4 && memcmp(xed_encode_order[13], xes->_operand_order, sizeof(xed_uint8_t)*4)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 xed_encode_ntluf_MASK_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_XMM_N3(xes,xed3_operand_get_reg2(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_DQ);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][7]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_8_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_FULLMEM_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 4 && memcmp(xed_encode_order[13], xes->_operand_order, sizeof(xed_uint8_t)*4)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 1) &&
		 xed_encode_ntluf_MASK_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_YMM_N3(xes,xed3_operand_get_reg2(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_QQ);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][8]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_8_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_FULLMEM_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 4 && memcmp(xed_encode_order[13], xes->_operand_order, sizeof(xed_uint8_t)*4)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 2) &&
		 xed_encode_ntluf_MASK_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_ZMM_N3(xes,xed3_operand_get_reg2(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_ZD);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][9]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_8_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_FULLMEM_BIND(xes);
       if (okay) return 1;
   }
     }
   return 0;
   (void) okay;
   (void) conditions_satisfied;
   (void) xes;
}
xed_bool_t xed_encode_group_33(xed_encoder_request_t* xes)
{
   xed_bool_t okay=1;
   xed_bool_t conditions_satisfied=0;
   xed_ptrn_func_ptr_t fb_ptrn_function;
   static const xed_uint16_t iform_ids[19][4] = {
   /*VADDSUBPD     */    {6971,6973,6970,6972,},
   /*VADDSUBPS     */    {2120,2122,2119,2121,},
   /*VHADDPD       */    {2197,2199,2196,2198,},
   /*VHADDPS       */    {2156,2158,2155,2157,},
   /*VHSUBPD       */    {6987,6989,6986,6988,},
   /*VHSUBPS       */    {4823,4825,4822,4824,},
   /*VPAND         */    { 993, 995, 992, 994,},
   /*VPANDN        */    { 967, 969, 966, 968,},
   /*VPHADDD       */    {4446,4448,4445,4447,},
   /*VPHADDSW      */    {3382,3384,3381,3383,},
   /*VPHADDW       */    {5590,5592,5589,5591,},
   /*VPHSUBD       */    {3305,3307,3304,3306,},
   /*VPHSUBSW      */    { 758, 760, 757, 759,},
   /*VPHSUBW       */    {2177,2179,2176,2178,},
   /*VPOR          */    {6546,6548,6545,6547,},
   /*VPSIGNB       */    {1161,1163,1160,1162,},
   /*VPSIGND       */    {1930,1932,1929,1931,},
   /*VPSIGNW       */    { 167, 169, 166, 168,},
   /*VPXOR         */    {3854,3856,3853,3855,},
   };
   xed_uint8_t iclass_index = xed_encoder_get_iclasses_index_in_group(xes);
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[7], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 (xed3_operand_get_must_use_evex(xes) == 0) &&
		 xed_encode_ntluf_XMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_XMM_N(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_XMM_B(xes,xed3_operand_get_reg2(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][0]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[7], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 1) &&
		 (xed3_operand_get_must_use_evex(xes) == 0) &&
		 xed_encode_ntluf_YMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_YMM_N(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_YMM_B(xes,xed3_operand_get_reg2(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][1]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[14], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 (xed3_operand_get_must_use_evex(xes) == 0) &&
		 xed_encode_ntluf_XMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_XMM_N(xes,xed3_operand_get_reg1(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_DQ);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][2]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[14], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 1) &&
		 (xed3_operand_get_must_use_evex(xes) == 0) &&
		 xed_encode_ntluf_YMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_YMM_N(xes,xed3_operand_get_reg1(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_QQ);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][3]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay) return 1;
   }
     }
   return 0;
   (void) okay;
   (void) conditions_satisfied;
   (void) xes;
}
xed_bool_t xed_encode_group_34(xed_encoder_request_t* xes)
{
   xed_bool_t okay=1;
   xed_bool_t conditions_satisfied=0;
   xed_ptrn_func_ptr_t fb_ptrn_function;
   static const xed_uint16_t iform_ids[4][6] = {
   /*VALIGND       */    {6443,6445,6441,6444,6446,6442,},
   /*VPSHLDD       */    {2401,2403,2405,2402,2404,2406,},
   /*VPSHRDD       */    { 170, 172, 174, 171, 173, 175,},
   /*VPTERNLOGD    */    {3416,3418,3414,3417,3419,3415,},
   };
   xed_uint8_t iclass_index = xed_encoder_get_iclasses_index_in_group(xes);
   if (xes->_n_operand_order == 5 && memcmp(xed_encode_order[18], xes->_operand_order, sizeof(xed_uint8_t)*5)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 xed_encode_ntluf_XMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_XMM_N3(xes,xed3_operand_get_reg2(xes)) &&
		 xed_encode_ntluf_XMM_B3(xes,xed3_operand_get_reg3(xes)) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][0]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_UIMM8_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 5 && memcmp(xed_encode_order[18], xes->_operand_order, sizeof(xed_uint8_t)*5)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 1) &&
		 xed_encode_ntluf_YMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_YMM_N3(xes,xed3_operand_get_reg2(xes)) &&
		 xed_encode_ntluf_YMM_B3(xes,xed3_operand_get_reg3(xes)) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][1]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_UIMM8_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 5 && memcmp(xed_encode_order[18], xes->_operand_order, sizeof(xed_uint8_t)*5)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 2) &&
		 xed_encode_ntluf_ZMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_ZMM_N3(xes,xed3_operand_get_reg2(xes)) &&
		 xed_encode_ntluf_ZMM_B3(xes,xed3_operand_get_reg3(xes)) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][2]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_UIMM8_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 5 && memcmp(xed_encode_order[19], xes->_operand_order, sizeof(xed_uint8_t)*5)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 xed_encode_ntluf_XMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_XMM_N3(xes,xed3_operand_get_reg2(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_VV) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][3]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_UIMM8_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_32_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_FULL_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 5 && memcmp(xed_encode_order[19], xes->_operand_order, sizeof(xed_uint8_t)*5)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 1) &&
		 xed_encode_ntluf_YMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_YMM_N3(xes,xed3_operand_get_reg2(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_VV) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][4]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_UIMM8_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_32_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_FULL_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 5 && memcmp(xed_encode_order[19], xes->_operand_order, sizeof(xed_uint8_t)*5)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 2) &&
		 xed_encode_ntluf_ZMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_ZMM_N3(xes,xed3_operand_get_reg2(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_VV) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][5]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_UIMM8_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_32_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_FULL_BIND(xes);
       if (okay) return 1;
   }
     }
   return 0;
   (void) okay;
   (void) conditions_satisfied;
   (void) xes;
}
xed_bool_t xed_encode_group_35(xed_encoder_request_t* xes)
{
   xed_bool_t okay=1;
   xed_bool_t conditions_satisfied=0;
   xed_ptrn_func_ptr_t fb_ptrn_function;
   static const xed_uint16_t iform_ids[2][2] = {
   /*MOVHPS        */    { 177, 176,},
   /*MOVLPS        */    {1521,1520,},
   };
   xed_uint8_t iclass_index = xed_encoder_get_iclasses_index_in_group(xes);
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_MEM0 && xes->_operand_order[1] == XED_OPERAND_REG0) {
   conditions_satisfied = (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_Q) &&
		 xed_encode_ntluf_XMM_R(xes,xed3_operand_get_reg0(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][0]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_MEM0) {
   conditions_satisfied = xed_encode_ntluf_XMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_Q);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][1]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay) return 1;
   }
     }
   return 0;
   (void) okay;
   (void) conditions_satisfied;
   (void) xes;
}
xed_bool_t xed_encode_group_36(xed_encoder_request_t* xes)
{
   xed_bool_t okay=1;
   xed_bool_t conditions_satisfied=0;
   xed_ptrn_func_ptr_t fb_ptrn_function;
   static const xed_uint16_t iform_ids[1][4] = {
   /*IN            */    { 180, 181, 178, 179,},
   };
   xed_uint8_t iclass_index = xed_encoder_get_iclasses_index_in_group(xes);
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_REG1) {
   conditions_satisfied = (xed3_operand_get_reg0(xes) == XED_REG_AL) &&
		 (xed3_operand_get_reg1(xes) == XED_REG_DX);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][0]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_REG1) {
   conditions_satisfied = xed_encode_ntluf_OeAX(xes,xed3_operand_get_reg0(xes)) &&
		 (xed3_operand_get_reg1(xes) == XED_REG_DX);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][1]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_IMMUNE_REXW_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_IMM0) {
   conditions_satisfied = (xed3_operand_get_reg0(xes) == XED_REG_AL) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][2]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_UIMM8_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_IMM0) {
   conditions_satisfied = xed_encode_ntluf_OeAX(xes,xed3_operand_get_reg0(xes)) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][3]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_UIMM8_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_IMMUNE_REXW_BIND(xes);
       if (okay) return 1;
   }
     }
   return 0;
   (void) okay;
   (void) conditions_satisfied;
   (void) xes;
}
xed_bool_t xed_encode_group_37(xed_encoder_request_t* xes)
{
   xed_bool_t okay=1;
   xed_bool_t conditions_satisfied=0;
   xed_ptrn_func_ptr_t fb_ptrn_function;
   static const xed_uint16_t iform_ids[1][10] = {
   /*VPSHUFD       */    { 183, 185, 182, 184, 188, 190, 186, 189, 191, 187,},
   };
   xed_uint8_t iclass_index = xed_encoder_get_iclasses_index_in_group(xes);
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[15], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 (xed3_operand_get_must_use_evex(xes) == 0) &&
		 xed_encode_ntluf_XMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_XMM_B(xes,xed3_operand_get_reg1(xes)) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][0]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_UIMM8_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[15], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 1) &&
		 (xed3_operand_get_must_use_evex(xes) == 0) &&
		 xed_encode_ntluf_YMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_YMM_B(xes,xed3_operand_get_reg1(xes)) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][1]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_UIMM8_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[20], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 (xed3_operand_get_must_use_evex(xes) == 0) &&
		 xed_encode_ntluf_XMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_DQ) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][2]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_UIMM8_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[20], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 1) &&
		 (xed3_operand_get_must_use_evex(xes) == 0) &&
		 xed_encode_ntluf_YMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_QQ) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][3]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_UIMM8_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 4 && memcmp(xed_encode_order[21], xes->_operand_order, sizeof(xed_uint8_t)*4)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 xed_encode_ntluf_XMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_XMM_B3(xes,xed3_operand_get_reg2(xes)) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][4]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_UIMM8_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 4 && memcmp(xed_encode_order[21], xes->_operand_order, sizeof(xed_uint8_t)*4)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 1) &&
		 xed_encode_ntluf_YMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_YMM_B3(xes,xed3_operand_get_reg2(xes)) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][5]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_UIMM8_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 4 && memcmp(xed_encode_order[21], xes->_operand_order, sizeof(xed_uint8_t)*4)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 2) &&
		 xed_encode_ntluf_ZMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_ZMM_B3(xes,xed3_operand_get_reg2(xes)) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][6]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_UIMM8_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 4 && memcmp(xed_encode_order[22], xes->_operand_order, sizeof(xed_uint8_t)*4)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 xed_encode_ntluf_XMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_VV) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][7]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_UIMM8_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_32_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_FULL_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 4 && memcmp(xed_encode_order[22], xes->_operand_order, sizeof(xed_uint8_t)*4)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 1) &&
		 xed_encode_ntluf_YMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_VV) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][8]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_UIMM8_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_32_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_FULL_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 4 && memcmp(xed_encode_order[22], xes->_operand_order, sizeof(xed_uint8_t)*4)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 2) &&
		 xed_encode_ntluf_ZMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_VV) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][9]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_UIMM8_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_32_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_FULL_BIND(xes);
       if (okay) return 1;
   }
     }
   return 0;
   (void) okay;
   (void) conditions_satisfied;
   (void) xes;
}
xed_bool_t xed_encode_group_38(xed_encoder_request_t* xes)
{
   xed_bool_t okay=1;
   xed_bool_t conditions_satisfied=0;
   xed_ptrn_func_ptr_t fb_ptrn_function;
   static const xed_uint16_t iform_ids[16][4] = {
   /*JB            */    {2693,2694,2692,2695,},
   /*JBE           */    {3507,3508,3506,3509,},
   /*JL            */    {5158,5159,5157,5160,},
   /*JLE           */    {1688,1689,1687,1690,},
   /*JNB           */    {3570,3571,3569,3572,},
   /*JNBE          */    { 194, 195, 193, 196,},
   /*JNL           */    {2859,2860,2858,2861,},
   /*JNLE          */    { 953, 954, 952, 955,},
   /*JNO           */    {5195,5196,5194,5197,},
   /*JNP           */    {5792,5793,5791,5794,},
   /*JNS           */    { 556, 557, 555, 558,},
   /*JNZ           */    {3881,3882,3880,3883,},
   /*JO            */    {3323,3325,3322,3324,},
   /*JP            */    {5199,5200,5198,5201,},
   /*JS            */    {2068,2069,2067,2070,},
   /*JZ            */    {5994,5995,5993,5996,},
   };
   xed_uint8_t iclass_index = xed_encoder_get_iclasses_index_in_group(xes);
   if (xes->_n_operand_order == 1 && xes->_operand_order[0] == XED_OPERAND_RELBR) {
   conditions_satisfied = (xed3_operand_get_mode(xes) != 2) &&
		 (xed3_operand_get_relbr(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][0]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_BRANCH_HINT_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_BRDISP8_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 1 && xes->_operand_order[0] == XED_OPERAND_RELBR) {
   conditions_satisfied = (xed3_operand_get_mode(xes) != 2) &&
		 (xed3_operand_get_relbr(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][1]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_BRANCH_HINT_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_BRDISPz_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 1 && xes->_operand_order[0] == XED_OPERAND_RELBR) {
   conditions_satisfied = (xed3_operand_get_mode(xes) == 2) &&
		 (xed3_operand_get_relbr(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][2]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_FORCE64_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_BRANCH_HINT_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_BRDISP8_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 1 && xes->_operand_order[0] == XED_OPERAND_RELBR) {
   conditions_satisfied = (xed3_operand_get_mode(xes) == 2) &&
		 (xed3_operand_get_relbr(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][3]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_FORCE64_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_BRANCH_HINT_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_BRDISP32_BIND(xes);
       if (okay) return 1;
   }
     }
   return 0;
   (void) okay;
   (void) conditions_satisfied;
   (void) xes;
}
xed_bool_t xed_encode_group_39(xed_encoder_request_t* xes)
{
   xed_bool_t okay=1;
   xed_bool_t conditions_satisfied=0;
   xed_ptrn_func_ptr_t fb_ptrn_function;
   static const xed_uint16_t iform_ids[9][2] = {
   /*AESKEYGENASSIST*/    {3438,3439,},
   /*BLENDPD       */    { 411, 410,},
   /*BLENDPS       */    {1268,1267,},
   /*DPPD          */    {3514,3513,},
   /*DPPS          */    {6382,6381,},
   /*MPSADBW       */    { 199, 198,},
   /*PBLENDW       */    {1741,1740,},
   /*PCLMULQDQ     */    {6628,6629,},
   /*PSHUFD        */    {2427,2426,},
   };
   xed_uint8_t iclass_index = xed_encoder_get_iclasses_index_in_group(xes);
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[15], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = xed_encode_ntluf_XMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_XMM_B(xes,xed3_operand_get_reg1(xes)) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][0]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_REFINING66_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_UIMM8_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[20], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = xed_encode_ntluf_XMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_DQ) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][1]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_REFINING66_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_UIMM8_BIND(xes);
       if (okay) return 1;
   }
     }
   return 0;
   (void) okay;
   (void) conditions_satisfied;
   (void) xes;
}
xed_bool_t xed_encode_group_40(xed_encoder_request_t* xes)
{
   xed_bool_t okay=1;
   xed_bool_t conditions_satisfied=0;
   xed_ptrn_func_ptr_t fb_ptrn_function;
   static const xed_uint16_t iform_ids[4][2] = {
   /*ANDNPD        */    { 570, 569,},
   /*ANDPD         */    {4927,4926,},
   /*ORPD          */    { 201, 200,},
   /*XORPD         */    {6126,6125,},
   };
   xed_uint8_t iclass_index = xed_encoder_get_iclasses_index_in_group(xes);
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_REG1) {
   conditions_satisfied = xed_encode_ntluf_XMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_XMM_B(xes,xed3_operand_get_reg1(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][0]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_REFINING66_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_MEM0) {
   conditions_satisfied = xed_encode_ntluf_XMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_XUQ);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][1]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_REFINING66_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay) return 1;
   }
     }
   return 0;
   (void) okay;
   (void) conditions_satisfied;
   (void) xes;
}
xed_bool_t xed_encode_group_41(xed_encoder_request_t* xes)
{
   xed_bool_t okay=1;
   xed_bool_t conditions_satisfied=0;
   xed_ptrn_func_ptr_t fb_ptrn_function;
   static const xed_uint16_t iform_ids[1][4] = {
   /*PINSRW        */    { 203, 202, 205, 204,},
   };
   xed_uint8_t iclass_index = xed_encoder_get_iclasses_index_in_group(xes);
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[15], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = xed_encode_ntluf_MMX_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_GPR32_B(xes,xed3_operand_get_reg1(xes)) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][0]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_UIMM8_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[20], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = xed_encode_ntluf_MMX_R(xes,xed3_operand_get_reg0(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_W) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][1]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_UIMM8_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[15], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = xed_encode_ntluf_XMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_GPR32_B(xes,xed3_operand_get_reg1(xes)) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][2]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_REFINING66_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_UIMM8_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[20], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = xed_encode_ntluf_XMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_W) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][3]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_REFINING66_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_UIMM8_BIND(xes);
       if (okay) return 1;
   }
     }
   return 0;
   (void) okay;
   (void) conditions_satisfied;
   (void) xes;
}
xed_bool_t xed_encode_group_42(xed_encoder_request_t* xes)
{
   xed_bool_t okay=1;
   xed_bool_t conditions_satisfied=0;
   xed_ptrn_func_ptr_t fb_ptrn_function;
   static const xed_uint16_t iform_ids[21][10] = {
   /*VPACKSSWB     */    {6800,6802,6799,6801,6803,6805,6807,6804,6806,6808,},
   /*VPACKUSWB     */    {6880,6882,6879,6881,6883,6885,6887,6884,6886,6888,},
   /*VPADDSW       */    {1898,1900,1897,1899,1901,1903,1905,1902,1904,1906,},
   /*VPADDUSW      */    {3147,3149,3146,3148,3150,3152,3154,3151,3153,3155,},
   /*VPADDW        */    {4011,4013,4010,4012,4014,4016,4018,4015,4017,4019,},
   /*VPAVGW        */    {5618,5620,5617,5619,5621,5623,5625,5622,5624,5626,},
   /*VPMADDUBSW    */    {5325,5327,5324,5326,5328,5330,5332,5329,5331,5333,},
   /*VPMADDWD      */    {2254,2256,2253,2255,2257,2259,2261,2258,2260,2262,},
   /*VPMAXSW       */    {3890,3892,3889,3891,3893,3895,3897,3894,3896,3898,},
   /*VPMAXUW       */    { 716, 718, 715, 717, 719, 721, 723, 720, 722, 724,},
   /*VPMINSW       */    {3981,3983,3980,3982,3984,3986,3988,3985,3987,3989,},
   /*VPMINUW       */    {6975,6977,6974,6976,6978,6980,6982,6979,6981,6983,},
   /*VPMULHRSW     */    {3606,3608,3605,3607,3609,3611,3613,3610,3612,3614,},
   /*VPMULHUW      */    {4234,4236,4233,4235,4237,4239,4241,4238,4240,4242,},
   /*VPMULHW       */    {3522,3524,3521,3523,3525,3527,3529,3526,3528,3530,},
   /*VPMULLW       */    { 207, 209, 206, 208, 210, 212, 214, 211, 213, 215,},
   /*VPSUBSW       */    {1527,1529,1526,1528,1530,1532,1534,1531,1533,1535,},
   /*VPSUBUSW      */    {4794,4796,4793,4795,4797,4799,4801,4798,4800,4802,},
   /*VPSUBW        */    {3399,3401,3398,3400,3402,3404,3406,3403,3405,3407,},
   /*VPUNPCKHWD    */    {5443,5445,5442,5444,5446,5448,5450,5447,5449,5451,},
   /*VPUNPCKLWD    */    {4911,4913,4910,4912,4914,4916,4918,4915,4917,4919,},
   };
   xed_uint8_t iclass_index = xed_encoder_get_iclasses_index_in_group(xes);
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[7], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 (xed3_operand_get_must_use_evex(xes) == 0) &&
		 xed_encode_ntluf_XMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_XMM_N(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_XMM_B(xes,xed3_operand_get_reg2(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][0]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[7], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 1) &&
		 (xed3_operand_get_must_use_evex(xes) == 0) &&
		 xed_encode_ntluf_YMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_YMM_N(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_YMM_B(xes,xed3_operand_get_reg2(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][1]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[14], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 (xed3_operand_get_must_use_evex(xes) == 0) &&
		 xed_encode_ntluf_XMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_XMM_N(xes,xed3_operand_get_reg1(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_DQ);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][2]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[14], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 1) &&
		 (xed3_operand_get_must_use_evex(xes) == 0) &&
		 xed_encode_ntluf_YMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_YMM_N(xes,xed3_operand_get_reg1(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_QQ);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][3]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 4 && memcmp(xed_encode_order[12], xes->_operand_order, sizeof(xed_uint8_t)*4)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 xed_encode_ntluf_XMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_XMM_N3(xes,xed3_operand_get_reg2(xes)) &&
		 xed_encode_ntluf_XMM_B3(xes,xed3_operand_get_reg3(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][4]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 4 && memcmp(xed_encode_order[12], xes->_operand_order, sizeof(xed_uint8_t)*4)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 1) &&
		 xed_encode_ntluf_YMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_YMM_N3(xes,xed3_operand_get_reg2(xes)) &&
		 xed_encode_ntluf_YMM_B3(xes,xed3_operand_get_reg3(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][5]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 4 && memcmp(xed_encode_order[12], xes->_operand_order, sizeof(xed_uint8_t)*4)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 2) &&
		 xed_encode_ntluf_ZMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_ZMM_N3(xes,xed3_operand_get_reg2(xes)) &&
		 xed_encode_ntluf_ZMM_B3(xes,xed3_operand_get_reg3(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][6]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 4 && memcmp(xed_encode_order[13], xes->_operand_order, sizeof(xed_uint8_t)*4)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 xed_encode_ntluf_XMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_XMM_N3(xes,xed3_operand_get_reg2(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_DQ);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][7]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_16_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_FULLMEM_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 4 && memcmp(xed_encode_order[13], xes->_operand_order, sizeof(xed_uint8_t)*4)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 1) &&
		 xed_encode_ntluf_YMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_YMM_N3(xes,xed3_operand_get_reg2(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_QQ);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][8]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_16_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_FULLMEM_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 4 && memcmp(xed_encode_order[13], xes->_operand_order, sizeof(xed_uint8_t)*4)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 2) &&
		 xed_encode_ntluf_ZMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_ZMM_N3(xes,xed3_operand_get_reg2(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_ZD);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][9]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_16_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_FULLMEM_BIND(xes);
       if (okay) return 1;
   }
     }
   return 0;
   (void) okay;
   (void) conditions_satisfied;
   (void) xes;
}
xed_bool_t xed_encode_group_43(xed_encoder_request_t* xes)
{
   xed_bool_t okay=1;
   xed_bool_t conditions_satisfied=0;
   xed_ptrn_func_ptr_t fb_ptrn_function;
   static const xed_uint16_t iform_ids[3][11] = {
   /*VCVTDQ2PS     */    {2808,2804,2806,2803,2805,2810,2812,2807,2811,2813,2809,},
   /*VCVTPS2DQ     */    {6594,6590,6592,6589,6591,6596,6598,6593,6597,6599,6595,},
   /*VSQRTPS       */    { 221, 217, 219, 216, 218, 223, 225, 220, 224, 226, 222,},
   };
   xed_uint8_t iclass_index = xed_encoder_get_iclasses_index_in_group(xes);
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[7], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_roundc(xes) != 0) &&
		 xed_encode_ntluf_ZMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_ZMM_B3(xes,xed3_operand_get_reg2(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][0]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_FIX_ROUND_LEN512_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_AVX512_ROUND_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_REG1) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 (xed3_operand_get_must_use_evex(xes) == 0) &&
		 xed_encode_ntluf_XMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_XMM_B(xes,xed3_operand_get_reg1(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][1]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_REG1) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 1) &&
		 (xed3_operand_get_must_use_evex(xes) == 0) &&
		 xed_encode_ntluf_YMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_YMM_B(xes,xed3_operand_get_reg1(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][2]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_MEM0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 (xed3_operand_get_must_use_evex(xes) == 0) &&
		 xed_encode_ntluf_XMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_DQ);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][3]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_MEM0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 1) &&
		 (xed3_operand_get_must_use_evex(xes) == 0) &&
		 xed_encode_ntluf_YMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_QQ);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][4]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[7], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 xed_encode_ntluf_XMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_XMM_B3(xes,xed3_operand_get_reg2(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][5]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[7], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 1) &&
		 xed_encode_ntluf_YMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_YMM_B3(xes,xed3_operand_get_reg2(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][6]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[7], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 2) &&
		 xed_encode_ntluf_ZMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_ZMM_B3(xes,xed3_operand_get_reg2(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][7]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[14], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 xed_encode_ntluf_XMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_VV);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][8]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_32_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_FULL_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[14], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 1) &&
		 xed_encode_ntluf_YMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_VV);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][9]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_32_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_FULL_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[14], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 2) &&
		 xed_encode_ntluf_ZMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_VV);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][10]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_32_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_FULL_BIND(xes);
       if (okay) return 1;
   }
     }
   return 0;
   (void) okay;
   (void) conditions_satisfied;
   (void) xes;
}
xed_bool_t xed_encode_group_44(xed_encoder_request_t* xes)
{
   xed_bool_t okay=1;
   xed_bool_t conditions_satisfied=0;
   xed_ptrn_func_ptr_t fb_ptrn_function;
   static const xed_uint16_t iform_ids[4][1] = {
   /*VGATHERPF0QPD */    {6621,},
   /*VGATHERPF1QPD */    {2621,},
   /*VSCATTERPF0QPD*/    { 230,},
   /*VSCATTERPF1QPD*/    {4527,},
   };
   xed_uint8_t iclass_index = xed_encoder_get_iclasses_index_in_group(xes);
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_MEM0 && xes->_operand_order[1] == XED_OPERAND_REG0) {
   conditions_satisfied = (xed3_operand_get_easz(xes) != 1) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_Q) &&
		 xed_encode_ntluf_MASKNOT0(xes,xed3_operand_get_reg0(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][0]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_UISA_VMODRM_ZMM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_64_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_GSCAT_BIND(xes);
       if (okay) return 1;
   }
     }
   return 0;
   (void) okay;
   (void) conditions_satisfied;
   (void) xes;
}
xed_bool_t xed_encode_group_45(xed_encoder_request_t* xes)
{
   xed_bool_t okay=1;
   xed_bool_t conditions_satisfied=0;
   xed_ptrn_func_ptr_t fb_ptrn_function;
   static const xed_uint16_t iform_ids[22][11] = {
   /*VADDPS        */    { 346, 342, 344, 341, 343, 348, 350, 345, 349, 351, 347,},
   /*VDIVPS        */    {2782,2778,2780,2777,2779,2784,2786,2781,2785,2787,2783,},
   /*VFMADD132PS   */    {6168,6164,6166,6163,6165,6170,6172,6167,6171,6173,6169,},
   /*VFMADD213PS   */    {6901,6897,6899,6896,6898,6903,6905,6900,6904,6906,6902,},
   /*VFMADD231PS   */    { 390, 386, 388, 385, 387, 392, 394, 389, 393, 395, 391,},
   /*VFMADDSUB132PS*/    {6583,6579,6581,6578,6580,6585,6587,6582,6586,6588,6584,},
   /*VFMADDSUB213PS*/    { 236, 232, 234, 231, 233, 238, 240, 235, 239, 241, 237,},
   /*VFMADDSUB231PS*/    { 440, 436, 438, 435, 437, 442, 444, 439, 443, 445, 441,},
   /*VFMSUB132PS   */    {2959,2955,2957,2954,2956,2961,2963,2958,2962,2964,2960,},
   /*VFMSUB213PS   */    {3135,3131,3133,3130,3132,3137,3139,3134,3138,3140,3136,},
   /*VFMSUB231PS   */    {5484,5480,5482,5479,5481,5486,5488,5483,5487,5489,5485,},
   /*VFMSUBADD132PS*/    {6032,6028,6030,6027,6029,6034,6036,6031,6035,6037,6033,},
   /*VFMSUBADD213PS*/    {4509,4505,4507,4504,4506,4511,4513,4508,4512,4514,4510,},
   /*VFMSUBADD231PS*/    {6814,6810,6812,6809,6811,6816,6818,6813,6817,6819,6815,},
   /*VFNMADD132PS  */    {6519,6515,6517,6514,6516,6521,6523,6518,6522,6524,6520,},
   /*VFNMADD213PS  */    {1879,1875,1877,1874,1876,1881,1883,1878,1882,1884,1880,},
   /*VFNMADD231PS  */    {5381,5377,5379,5376,5378,5383,5385,5380,5384,5386,5382,},
   /*VFNMSUB132PS  */    {6417,6413,6415,6412,6414,6419,6421,6416,6420,6422,6418,},
   /*VFNMSUB213PS  */    {4462,4458,4460,4457,4459,4464,4466,4461,4465,4467,4463,},
   /*VFNMSUB231PS  */    {2743,2739,2741,2738,2740,2745,2747,2742,2746,2748,2744,},
   /*VMULPS        */    {5300,5296,5298,5295,5297,5302,5304,5299,5303,5305,5301,},
   /*VSUBPS        */    {4070,4066,4068,4065,4067,4072,4074,4069,4073,4075,4071,},
   };
   xed_uint8_t iclass_index = xed_encoder_get_iclasses_index_in_group(xes);
   if (xes->_n_operand_order == 4 && memcmp(xed_encode_order[12], xes->_operand_order, sizeof(xed_uint8_t)*4)==0) {
   conditions_satisfied = (xed3_operand_get_roundc(xes) != 0) &&
		 xed_encode_ntluf_ZMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_ZMM_N3(xes,xed3_operand_get_reg2(xes)) &&
		 xed_encode_ntluf_ZMM_B3(xes,xed3_operand_get_reg3(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][0]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_FIX_ROUND_LEN512_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_AVX512_ROUND_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[7], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 (xed3_operand_get_must_use_evex(xes) == 0) &&
		 xed_encode_ntluf_XMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_XMM_N(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_XMM_B(xes,xed3_operand_get_reg2(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][1]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[7], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 1) &&
		 (xed3_operand_get_must_use_evex(xes) == 0) &&
		 xed_encode_ntluf_YMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_YMM_N(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_YMM_B(xes,xed3_operand_get_reg2(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][2]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[14], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 (xed3_operand_get_must_use_evex(xes) == 0) &&
		 xed_encode_ntluf_XMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_XMM_N(xes,xed3_operand_get_reg1(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_DQ);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][3]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[14], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 1) &&
		 (xed3_operand_get_must_use_evex(xes) == 0) &&
		 xed_encode_ntluf_YMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_YMM_N(xes,xed3_operand_get_reg1(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_QQ);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][4]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 4 && memcmp(xed_encode_order[12], xes->_operand_order, sizeof(xed_uint8_t)*4)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 xed_encode_ntluf_XMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_XMM_N3(xes,xed3_operand_get_reg2(xes)) &&
		 xed_encode_ntluf_XMM_B3(xes,xed3_operand_get_reg3(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][5]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 4 && memcmp(xed_encode_order[12], xes->_operand_order, sizeof(xed_uint8_t)*4)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 1) &&
		 xed_encode_ntluf_YMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_YMM_N3(xes,xed3_operand_get_reg2(xes)) &&
		 xed_encode_ntluf_YMM_B3(xes,xed3_operand_get_reg3(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][6]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 4 && memcmp(xed_encode_order[12], xes->_operand_order, sizeof(xed_uint8_t)*4)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 2) &&
		 xed_encode_ntluf_ZMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_ZMM_N3(xes,xed3_operand_get_reg2(xes)) &&
		 xed_encode_ntluf_ZMM_B3(xes,xed3_operand_get_reg3(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][7]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 4 && memcmp(xed_encode_order[13], xes->_operand_order, sizeof(xed_uint8_t)*4)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 xed_encode_ntluf_XMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_XMM_N3(xes,xed3_operand_get_reg2(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_VV);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][8]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_32_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_FULL_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 4 && memcmp(xed_encode_order[13], xes->_operand_order, sizeof(xed_uint8_t)*4)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 1) &&
		 xed_encode_ntluf_YMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_YMM_N3(xes,xed3_operand_get_reg2(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_VV);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][9]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_32_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_FULL_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 4 && memcmp(xed_encode_order[13], xes->_operand_order, sizeof(xed_uint8_t)*4)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 2) &&
		 xed_encode_ntluf_ZMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_ZMM_N3(xes,xed3_operand_get_reg2(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_VV);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][10]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_32_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_FULL_BIND(xes);
       if (okay) return 1;
   }
     }
   return 0;
   (void) okay;
   (void) conditions_satisfied;
   (void) xes;
}
xed_bool_t xed_encode_group_46(xed_encoder_request_t* xes)
{
   xed_bool_t okay=1;
   xed_bool_t conditions_satisfied=0;
   xed_ptrn_func_ptr_t fb_ptrn_function;
   static const xed_uint16_t iform_ids[8][6] = {
   /*PSLLD         */    {5500,5497,5499,5502,5498,5501,},
   /*PSLLQ         */    {1798,1795,1797,1800,1796,1799,},
   /*PSLLW         */    { 245, 242, 244, 247, 243, 246,},
   /*PSRAD         */    {2134,2131,2133,2136,2132,2135,},
   /*PSRAW         */    {5913,5910,5912,5915,5911,5914,},
   /*PSRLD         */    {4048,4045,4047,4050,4046,4049,},
   /*PSRLQ         */    {5989,5986,5988,5991,5987,5990,},
   /*PSRLW         */    {1550,1547,1549,1552,1548,1551,},
   };
   xed_uint8_t iclass_index = xed_encoder_get_iclasses_index_in_group(xes);
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_REG1) {
   conditions_satisfied = xed_encode_ntluf_MMX_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MMX_B(xes,xed3_operand_get_reg1(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][0]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_IMM0) {
   conditions_satisfied = xed_encode_ntluf_MMX_B(xes,xed3_operand_get_reg0(xes)) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][1]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_UIMM8_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_MEM0) {
   conditions_satisfied = xed_encode_ntluf_MMX_R(xes,xed3_operand_get_reg0(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_Q);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][2]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_REG1) {
   conditions_satisfied = xed_encode_ntluf_XMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_XMM_B(xes,xed3_operand_get_reg1(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][3]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_REFINING66_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_IMM0) {
   conditions_satisfied = xed_encode_ntluf_XMM_B(xes,xed3_operand_get_reg0(xes)) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][4]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_REFINING66_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_UIMM8_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_MEM0) {
   conditions_satisfied = xed_encode_ntluf_XMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_DQ);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][5]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_REFINING66_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay) return 1;
   }
     }
   return 0;
   (void) okay;
   (void) conditions_satisfied;
   (void) xes;
}
xed_bool_t xed_encode_group_47(xed_encoder_request_t* xes)
{
   xed_bool_t okay=1;
   xed_bool_t conditions_satisfied=0;
   xed_ptrn_func_ptr_t fb_ptrn_function;
   static const xed_uint16_t iform_ids[2][6] = {
   /*VEXPANDPD     */    { 251, 253, 249, 250, 252, 248,},
   /*VPEXPANDQ     */    {4775,4777,4773,4774,4776,4772,},
   };
   xed_uint8_t iclass_index = xed_encoder_get_iclasses_index_in_group(xes);
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[7], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 xed_encode_ntluf_XMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_XMM_B3(xes,xed3_operand_get_reg2(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][0]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[7], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 1) &&
		 xed_encode_ntluf_YMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_YMM_B3(xes,xed3_operand_get_reg2(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][1]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[7], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 2) &&
		 xed_encode_ntluf_ZMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_ZMM_B3(xes,xed3_operand_get_reg2(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][2]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[14], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 xed_encode_ntluf_XMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_DQ);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][3]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_64_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_GSCAT_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[14], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 1) &&
		 xed_encode_ntluf_YMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_QQ);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][4]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_64_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_GSCAT_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[14], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 2) &&
		 xed_encode_ntluf_ZMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_ZD);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][5]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_64_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_GSCAT_BIND(xes);
       if (okay) return 1;
   }
     }
   return 0;
   (void) okay;
   (void) conditions_satisfied;
   (void) xes;
}
xed_bool_t xed_encode_group_48(xed_encoder_request_t* xes)
{
   xed_bool_t okay=1;
   xed_bool_t conditions_satisfied=0;
   xed_ptrn_func_ptr_t fb_ptrn_function;
   static const xed_uint16_t iform_ids[3][4] = {
   /*VPCMPESTRI    */    {1537,1539,1536,1538,},
   /*VPCMPESTRM    */    {5162,5164,5161,5163,},
   /*VPCMPISTRI    */    { 255, 257, 254, 256,},
   };
   xed_uint8_t iclass_index = xed_encoder_get_iclasses_index_in_group(xes);
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[15], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 (xed3_operand_get_mode(xes) != 2) &&
		 (xed3_operand_get_must_use_evex(xes) == 0) &&
		 xed_encode_ntluf_XMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_XMM_B(xes,xed3_operand_get_reg1(xes)) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][0]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_UIMM8_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[15], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 (xed3_operand_get_mode(xes) == 2) &&
		 (xed3_operand_get_must_use_evex(xes) == 0) &&
		 xed_encode_ntluf_XMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_XMM_B(xes,xed3_operand_get_reg1(xes)) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][1]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_UIMM8_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[20], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 (xed3_operand_get_mode(xes) != 2) &&
		 (xed3_operand_get_must_use_evex(xes) == 0) &&
		 xed_encode_ntluf_XMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_DQ) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][2]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_UIMM8_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[20], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 (xed3_operand_get_mode(xes) == 2) &&
		 (xed3_operand_get_must_use_evex(xes) == 0) &&
		 xed_encode_ntluf_XMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_DQ) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][3]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_UIMM8_BIND(xes);
       if (okay) return 1;
   }
     }
   return 0;
   (void) okay;
   (void) conditions_satisfied;
   (void) xes;
}
xed_bool_t xed_encode_group_49(xed_encoder_request_t* xes)
{
   xed_bool_t okay=1;
   xed_bool_t conditions_satisfied=0;
   xed_ptrn_func_ptr_t fb_ptrn_function;
   static const xed_uint16_t iform_ids[6][2] = {
   /*PMOVSXBW      */    {6260,6259,},
   /*PMOVSXDQ      */    {1854,1853,},
   /*PMOVSXWD      */    {1226,1225,},
   /*PMOVZXBW      */    {5402,5401,},
   /*PMOVZXDQ      */    {6697,6696,},
   /*PMOVZXWD      */    { 259, 258,},
   };
   xed_uint8_t iclass_index = xed_encoder_get_iclasses_index_in_group(xes);
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_REG1) {
   conditions_satisfied = xed_encode_ntluf_XMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_XMM_B(xes,xed3_operand_get_reg1(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][0]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_REFINING66_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_MEM0) {
   conditions_satisfied = xed_encode_ntluf_XMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_Q);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][1]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_REFINING66_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay) return 1;
   }
     }
   return 0;
   (void) okay;
   (void) conditions_satisfied;
   (void) xes;
}
xed_bool_t xed_encode_group_50(xed_encoder_request_t* xes)
{
   xed_bool_t okay=1;
   xed_bool_t conditions_satisfied=0;
   xed_ptrn_func_ptr_t fb_ptrn_function;
   static const xed_uint16_t iform_ids[4][6] = {
   /*VPBLENDMB     */    {2662,2664,2666,2663,2665,2667,},
   /*VPERMB        */    { 260, 262, 264, 261, 263, 265,},
   /*VPERMI2B      */    {3720,3722,3724,3721,3723,3725,},
   /*VPERMT2B      */    {2749,2751,2753,2750,2752,2754,},
   };
   xed_uint8_t iclass_index = xed_encoder_get_iclasses_index_in_group(xes);
   if (xes->_n_operand_order == 4 && memcmp(xed_encode_order[12], xes->_operand_order, sizeof(xed_uint8_t)*4)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 xed_encode_ntluf_XMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_XMM_N3(xes,xed3_operand_get_reg2(xes)) &&
		 xed_encode_ntluf_XMM_B3(xes,xed3_operand_get_reg3(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][0]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 4 && memcmp(xed_encode_order[12], xes->_operand_order, sizeof(xed_uint8_t)*4)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 1) &&
		 xed_encode_ntluf_YMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_YMM_N3(xes,xed3_operand_get_reg2(xes)) &&
		 xed_encode_ntluf_YMM_B3(xes,xed3_operand_get_reg3(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][1]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 4 && memcmp(xed_encode_order[12], xes->_operand_order, sizeof(xed_uint8_t)*4)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 2) &&
		 xed_encode_ntluf_ZMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_ZMM_N3(xes,xed3_operand_get_reg2(xes)) &&
		 xed_encode_ntluf_ZMM_B3(xes,xed3_operand_get_reg3(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][2]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 4 && memcmp(xed_encode_order[13], xes->_operand_order, sizeof(xed_uint8_t)*4)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 xed_encode_ntluf_XMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_XMM_N3(xes,xed3_operand_get_reg2(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_DQ);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][3]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_8_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_FULLMEM_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 4 && memcmp(xed_encode_order[13], xes->_operand_order, sizeof(xed_uint8_t)*4)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 1) &&
		 xed_encode_ntluf_YMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_YMM_N3(xes,xed3_operand_get_reg2(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_QQ);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][4]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_8_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_FULLMEM_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 4 && memcmp(xed_encode_order[13], xes->_operand_order, sizeof(xed_uint8_t)*4)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 2) &&
		 xed_encode_ntluf_ZMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_ZMM_N3(xes,xed3_operand_get_reg2(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_ZD);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][5]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_8_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_FULLMEM_BIND(xes);
       if (okay) return 1;
   }
     }
   return 0;
   (void) okay;
   (void) conditions_satisfied;
   (void) xes;
}
xed_bool_t xed_encode_group_51(xed_encoder_request_t* xes)
{
   xed_bool_t okay=1;
   xed_bool_t conditions_satisfied=0;
   xed_ptrn_func_ptr_t fb_ptrn_function;
   static const xed_uint16_t iform_ids[12][2] = {
   /*VPMACSDD      */    {1846,1845,},
   /*VPMACSDQH     */    {2669,2668,},
   /*VPMACSDQL     */    { 453, 452,},
   /*VPMACSSDD     */    {5855,5854,},
   /*VPMACSSDQH    */    {1866,1865,},
   /*VPMACSSDQL    */    { 271, 270,},
   /*VPMACSSWD     */    { 498, 497,},
   /*VPMACSSWW     */    {6652,6651,},
   /*VPMACSWD      */    {2765,2764,},
   /*VPMACSWW      */    {6985,6984,},
   /*VPMADCSSWD    */    { 914, 913,},
   /*VPMADCSWD     */    {5184,5183,},
   };
   xed_uint8_t iclass_index = xed_encoder_get_iclasses_index_in_group(xes);
   if (xes->_n_operand_order == 4 && memcmp(xed_encode_order[12], xes->_operand_order, sizeof(xed_uint8_t)*4)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 xed_encode_ntluf_XMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_XMM_N(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_XMM_B(xes,xed3_operand_get_reg2(xes)) &&
		 xed_encode_ntluf_XMM_SE(xes,xed3_operand_get_reg3(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][0]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_SE_IMM8_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 4 && memcmp(xed_encode_order[11], xes->_operand_order, sizeof(xed_uint8_t)*4)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 xed_encode_ntluf_XMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_XMM_N(xes,xed3_operand_get_reg1(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_DQ) &&
		 xed_encode_ntluf_XMM_SE(xes,xed3_operand_get_reg2(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][1]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_SE_IMM8_BIND(xes);
       if (okay) return 1;
   }
     }
   return 0;
   (void) okay;
   (void) conditions_satisfied;
   (void) xes;
}
xed_bool_t xed_encode_group_52(xed_encoder_request_t* xes)
{
   xed_bool_t okay=1;
   xed_bool_t conditions_satisfied=0;
   xed_ptrn_func_ptr_t fb_ptrn_function;
   static const xed_uint16_t iform_ids[2][1] = {
   /*WRSSD         */    { 272,},
   /*WRUSSD        */    {6993,},
   };
   xed_uint8_t iclass_index = xed_encoder_get_iclasses_index_in_group(xes);
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_MEM0 && xes->_operand_order[1] == XED_OPERAND_REG0) {
   conditions_satisfied = (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_D) &&
		 xed_encode_ntluf_GPR32_R(xes,xed3_operand_get_reg0(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][0]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay) return 1;
   }
     }
   return 0;
   (void) okay;
   (void) conditions_satisfied;
   (void) xes;
}
xed_bool_t xed_encode_group_53(xed_encoder_request_t* xes)
{
   xed_bool_t okay=1;
   xed_bool_t conditions_satisfied=0;
   xed_ptrn_func_ptr_t fb_ptrn_function;
   static const xed_uint16_t iform_ids[3][6] = {
   /*VPMOVQB       */    { 276, 278, 274, 277, 279, 275,},
   /*VPMOVSQB      */    {1925,1927,1923,1926,1928,1924,},
   /*VPMOVUSQB     */    {1948,1950,1946,1949,1951,1947,},
   };
   xed_uint8_t iclass_index = xed_encoder_get_iclasses_index_in_group(xes);
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[7], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 xed_encode_ntluf_XMM_B3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_XMM_R3(xes,xed3_operand_get_reg2(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][0]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[7], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 1) &&
		 xed_encode_ntluf_XMM_B3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_YMM_R3(xes,xed3_operand_get_reg2(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][1]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[7], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 2) &&
		 xed_encode_ntluf_XMM_B3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_ZMM_R3(xes,xed3_operand_get_reg2(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][2]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[6], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_WRD) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_XMM_R3(xes,xed3_operand_get_reg1(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][3]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_8_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_EIGHTHMEM_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[6], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 1) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_D) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_YMM_R3(xes,xed3_operand_get_reg1(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][4]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_8_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_EIGHTHMEM_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[6], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 2) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_Q) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_ZMM_R3(xes,xed3_operand_get_reg1(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][5]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_8_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_EIGHTHMEM_BIND(xes);
       if (okay) return 1;
   }
     }
   return 0;
   (void) okay;
   (void) conditions_satisfied;
   (void) xes;
}
xed_bool_t xed_encode_group_54(xed_encoder_request_t* xes)
{
   xed_bool_t okay=1;
   xed_bool_t conditions_satisfied=0;
   xed_ptrn_func_ptr_t fb_ptrn_function;
   static const xed_uint16_t iform_ids[1][2] = {
   /*CVTPD2DQ      */    { 282, 281,},
   };
   xed_uint8_t iclass_index = xed_encoder_get_iclasses_index_in_group(xes);
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_REG1) {
   conditions_satisfied = xed_encode_ntluf_XMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_XMM_B(xes,xed3_operand_get_reg1(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][0]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_IGNORE66_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_MEM0) {
   conditions_satisfied = xed_encode_ntluf_XMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_PD);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][1]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_IGNORE66_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay) return 1;
   }
     }
   return 0;
   (void) okay;
   (void) conditions_satisfied;
   (void) xes;
}
xed_bool_t xed_encode_group_55(xed_encoder_request_t* xes)
{
   xed_bool_t okay=1;
   xed_bool_t conditions_satisfied=0;
   xed_ptrn_func_ptr_t fb_ptrn_function;
   static const xed_uint16_t iform_ids[15][10] = {
   /*VGF2P8MULB    */    {3713,3715,3714,3716,3707,3709,3711,3708,3710,3712,},
   /*VPADDB        */    {6784,6786,6783,6785,6787,6789,6791,6788,6790,6792,},
   /*VPADDSB       */    {6265,6267,6264,6266,6268,6270,6272,6269,6271,6273,},
   /*VPADDUSB      */    {5776,5778,5775,5777,5779,5781,5783,5780,5782,5784,},
   /*VPAVGB        */    {4896,4898,4895,4897,4899,4901,4903,4900,4902,4904,},
   /*VPMAXSB       */    { 285, 287, 284, 286, 288, 290, 292, 289, 291, 293,},
   /*VPMAXUB       */    {1937,1939,1936,1938,1940,1942,1944,1941,1943,1945,},
   /*VPMINSB       */    {1820,1822,1819,1821,1823,1825,1827,1824,1826,1828,},
   /*VPMINUB       */    {2640,2642,2639,2641,2643,2645,2647,2644,2646,2648,},
   /*VPSHUFB       */    {1414,1416,1413,1415,1417,1419,1421,1418,1420,1422,},
   /*VPSUBB        */    {2408,2410,2407,2409,2411,2413,2415,2412,2414,2416,},
   /*VPSUBSB       */    {3629,3631,3628,3630,3632,3634,3636,3633,3635,3637,},
   /*VPSUBUSB      */    {3077,3079,3076,3078,3080,3082,3084,3081,3083,3085,},
   /*VPUNPCKHBW    */    {3444,3446,3443,3445,3447,3449,3451,3448,3450,3452,},
   /*VPUNPCKLBW    */    {6047,6049,6046,6048,6050,6052,6054,6051,6053,6055,},
   };
   xed_uint8_t iclass_index = xed_encoder_get_iclasses_index_in_group(xes);
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[7], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 (xed3_operand_get_must_use_evex(xes) == 0) &&
		 xed_encode_ntluf_XMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_XMM_N(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_XMM_B(xes,xed3_operand_get_reg2(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][0]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[7], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 1) &&
		 (xed3_operand_get_must_use_evex(xes) == 0) &&
		 xed_encode_ntluf_YMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_YMM_N(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_YMM_B(xes,xed3_operand_get_reg2(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][1]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[14], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 (xed3_operand_get_must_use_evex(xes) == 0) &&
		 xed_encode_ntluf_XMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_XMM_N(xes,xed3_operand_get_reg1(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_DQ);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][2]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[14], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 1) &&
		 (xed3_operand_get_must_use_evex(xes) == 0) &&
		 xed_encode_ntluf_YMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_YMM_N(xes,xed3_operand_get_reg1(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_QQ);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][3]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 4 && memcmp(xed_encode_order[12], xes->_operand_order, sizeof(xed_uint8_t)*4)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 xed_encode_ntluf_XMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_XMM_N3(xes,xed3_operand_get_reg2(xes)) &&
		 xed_encode_ntluf_XMM_B3(xes,xed3_operand_get_reg3(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][4]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 4 && memcmp(xed_encode_order[12], xes->_operand_order, sizeof(xed_uint8_t)*4)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 1) &&
		 xed_encode_ntluf_YMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_YMM_N3(xes,xed3_operand_get_reg2(xes)) &&
		 xed_encode_ntluf_YMM_B3(xes,xed3_operand_get_reg3(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][5]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 4 && memcmp(xed_encode_order[12], xes->_operand_order, sizeof(xed_uint8_t)*4)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 2) &&
		 xed_encode_ntluf_ZMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_ZMM_N3(xes,xed3_operand_get_reg2(xes)) &&
		 xed_encode_ntluf_ZMM_B3(xes,xed3_operand_get_reg3(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][6]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 4 && memcmp(xed_encode_order[13], xes->_operand_order, sizeof(xed_uint8_t)*4)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 xed_encode_ntluf_XMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_XMM_N3(xes,xed3_operand_get_reg2(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_DQ);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][7]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_8_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_FULLMEM_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 4 && memcmp(xed_encode_order[13], xes->_operand_order, sizeof(xed_uint8_t)*4)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 1) &&
		 xed_encode_ntluf_YMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_YMM_N3(xes,xed3_operand_get_reg2(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_QQ);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][8]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_8_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_FULLMEM_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 4 && memcmp(xed_encode_order[13], xes->_operand_order, sizeof(xed_uint8_t)*4)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 2) &&
		 xed_encode_ntluf_ZMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_ZMM_N3(xes,xed3_operand_get_reg2(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_ZD);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][9]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_8_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_FULLMEM_BIND(xes);
       if (okay) return 1;
   }
     }
   return 0;
   (void) okay;
   (void) conditions_satisfied;
   (void) xes;
}
xed_bool_t xed_encode_group_56(xed_encoder_request_t* xes)
{
   xed_bool_t okay=1;
   xed_bool_t conditions_satisfied=0;
   xed_ptrn_func_ptr_t fb_ptrn_function;
   static const xed_uint16_t iform_ids[1][6] = {
   /*VPCOMPRESSW   */    { 295, 297, 299, 294, 296, 298,},
   };
   xed_uint8_t iclass_index = xed_encoder_get_iclasses_index_in_group(xes);
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[7], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 xed_encode_ntluf_XMM_B3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_XMM_R3(xes,xed3_operand_get_reg2(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][0]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[7], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 1) &&
		 xed_encode_ntluf_YMM_B3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_YMM_R3(xes,xed3_operand_get_reg2(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][1]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[7], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 2) &&
		 xed_encode_ntluf_ZMM_B3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_ZMM_R3(xes,xed3_operand_get_reg2(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][2]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[6], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_DQ) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_XMM_R3(xes,xed3_operand_get_reg1(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][3]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_16_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_GSCAT_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[6], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 1) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_QQ) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_YMM_R3(xes,xed3_operand_get_reg1(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][4]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_16_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_GSCAT_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[6], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 2) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_ZD) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_ZMM_R3(xes,xed3_operand_get_reg1(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][5]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_16_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_GSCAT_BIND(xes);
       if (okay) return 1;
   }
     }
   return 0;
   (void) okay;
   (void) conditions_satisfied;
   (void) xes;
}
xed_bool_t xed_encode_group_57(xed_encoder_request_t* xes)
{
   xed_bool_t okay=1;
   xed_bool_t conditions_satisfied=0;
   xed_ptrn_func_ptr_t fb_ptrn_function;
   static const xed_uint16_t iform_ids[1][10] = {
   /*VPABSB        */    { 305, 307, 304, 306, 308, 310, 312, 309, 311, 313,},
   };
   xed_uint8_t iclass_index = xed_encoder_get_iclasses_index_in_group(xes);
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_REG1) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 (xed3_operand_get_must_use_evex(xes) == 0) &&
		 xed_encode_ntluf_XMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_XMM_B(xes,xed3_operand_get_reg1(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][0]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_REG1) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 1) &&
		 (xed3_operand_get_must_use_evex(xes) == 0) &&
		 xed_encode_ntluf_YMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_YMM_B(xes,xed3_operand_get_reg1(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][1]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_MEM0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 (xed3_operand_get_must_use_evex(xes) == 0) &&
		 xed_encode_ntluf_XMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_DQ);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][2]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_MEM0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 1) &&
		 (xed3_operand_get_must_use_evex(xes) == 0) &&
		 xed_encode_ntluf_YMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_QQ);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][3]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[7], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 xed_encode_ntluf_XMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_XMM_B3(xes,xed3_operand_get_reg2(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][4]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[7], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 1) &&
		 xed_encode_ntluf_YMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_YMM_B3(xes,xed3_operand_get_reg2(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][5]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[7], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 2) &&
		 xed_encode_ntluf_ZMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_ZMM_B3(xes,xed3_operand_get_reg2(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][6]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[14], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 xed_encode_ntluf_XMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_DQ);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][7]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_8_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_FULLMEM_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[14], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 1) &&
		 xed_encode_ntluf_YMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_QQ);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][8]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_8_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_FULLMEM_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[14], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 2) &&
		 xed_encode_ntluf_ZMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_ZD);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][9]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_8_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_FULLMEM_BIND(xes);
       if (okay) return 1;
   }
     }
   return 0;
   (void) okay;
   (void) conditions_satisfied;
   (void) xes;
}
xed_bool_t xed_encode_group_58(xed_encoder_request_t* xes)
{
   xed_bool_t okay=1;
   xed_bool_t conditions_satisfied=0;
   xed_ptrn_func_ptr_t fb_ptrn_function;
   static const xed_uint16_t iform_ids[17][3] = {
   /*CBW           */    {5082,5083,5084,},
   /*CDQ           */    {2025,2026,2027,},
   /*CWD           */    {6832,6833,6834,},
   /*CWDE          */    {4152,4153,4154,},
   /*INSW          */    {3510,3511,3512,},
   /*IRET          */    {3440,3441,3442,},
   /*IRETD         */    {3920,3921,3922,},
   /*POPF          */    {5795,5796,5797,},
   /*PUSHF         */    {3176,3177,3178,},
   /*REPE_SCASD    */    { 314, 315, 316,},
   /*REPE_SCASW    */    {6511,6512,6513,},
   /*REPNE_SCASD   */    {1007,1008,1009,},
   /*REPNE_SCASW   */    {3923,3924,3925,},
   /*SCASD         */    {3900,3901,3902,},
   /*SCASW         */    {1700,1701,1702,},
   /*STOSD         */    {5508,5509,5510,},
   /*STOSW         */    {1858,1859,1860,},
   };
   xed_uint8_t iclass_index = xed_encoder_get_iclasses_index_in_group(xes);
   if (xes->_n_operand_order == 0) {
   conditions_satisfied = (xed3_operand_get_mode(xes) == 0);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][0]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 0) {
   conditions_satisfied = (xed3_operand_get_mode(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][1]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 0) {
   conditions_satisfied = (xed3_operand_get_mode(xes) == 2);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][2]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   return 0;
   (void) okay;
   (void) conditions_satisfied;
   (void) xes;
}
xed_bool_t xed_encode_group_59(xed_encoder_request_t* xes)
{
   xed_bool_t okay=1;
   xed_bool_t conditions_satisfied=0;
   xed_ptrn_func_ptr_t fb_ptrn_function;
   static const xed_uint16_t iform_ids[18][2] = {
   /*CMOVB         */    { 503, 502,},
   /*CMOVBE        */    {6102,6101,},
   /*CMOVL         */    { 318, 317,},
   /*CMOVLE        */    {4456,4455,},
   /*CMOVNB        */    {5081,5080,},
   /*CMOVNBE       */    {2840,2839,},
   /*CMOVNL        */    { 694, 693,},
   /*CMOVNLE       */    {3904,3903,},
   /*CMOVNO        */    {6479,6478,},
   /*CMOVNP        */    {6209,6208,},
   /*CMOVNS        */    {1760,1759,},
   /*CMOVNZ        */    {5351,5350,},
   /*CMOVO         */    {3532,3531,},
   /*CMOVP         */    {5888,5887,},
   /*CMOVS         */    {1922,1921,},
   /*CMOVZ         */    {2521,2520,},
   /*POPCNT        */    {5788,5787,},
   /*TZCNT         */    {3166,3165,},
   };
   xed_uint8_t iclass_index = xed_encoder_get_iclasses_index_in_group(xes);
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_REG1) {
   conditions_satisfied = xed_encode_ntluf_GPRv_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_GPRv_B(xes,xed3_operand_get_reg1(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][0]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_MEM0) {
   conditions_satisfied = xed_encode_ntluf_GPRv_R(xes,xed3_operand_get_reg0(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_V);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][1]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay) return 1;
   }
     }
   return 0;
   (void) okay;
   (void) conditions_satisfied;
   (void) xes;
}
xed_bool_t xed_encode_group_60(xed_encoder_request_t* xes)
{
   xed_bool_t okay=1;
   xed_bool_t conditions_satisfied=0;
   xed_ptrn_func_ptr_t fb_ptrn_function;
   static const xed_uint16_t iform_ids[2][2] = {
   /*CMPPS         */    {6333,6332,},
   /*SHUFPS        */    { 320, 319,},
   };
   xed_uint8_t iclass_index = xed_encoder_get_iclasses_index_in_group(xes);
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[15], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = xed_encode_ntluf_XMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_XMM_B(xes,xed3_operand_get_reg1(xes)) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][0]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_UIMM8_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[20], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = xed_encode_ntluf_XMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_PS) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][1]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_UIMM8_BIND(xes);
       if (okay) return 1;
   }
     }
   return 0;
   (void) okay;
   (void) conditions_satisfied;
   (void) xes;
}
xed_bool_t xed_encode_group_61(xed_encoder_request_t* xes)
{
   xed_bool_t okay=1;
   xed_bool_t conditions_satisfied=0;
   xed_ptrn_func_ptr_t fb_ptrn_function;
   static const xed_uint16_t iform_ids[1][1] = {
   /*MOVMSKPS      */    { 321,},
   };
   xed_uint8_t iclass_index = xed_encoder_get_iclasses_index_in_group(xes);
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_REG1) {
   conditions_satisfied = xed_encode_ntluf_GPR32_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_XMM_B(xes,xed3_operand_get_reg1(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][0]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   return 0;
   (void) okay;
   (void) conditions_satisfied;
   (void) xes;
}
xed_bool_t xed_encode_group_62(xed_encoder_request_t* xes)
{
   xed_bool_t okay=1;
   xed_bool_t conditions_satisfied=0;
   xed_ptrn_func_ptr_t fb_ptrn_function;
   static const xed_uint16_t iform_ids[5][3] = {
   /*VFIXUPIMMSD   */    {6963,6962,6964,},
   /*VGETMANTSD    */    { 323, 322, 324,},
   /*VRANGESD      */    {3718,3717,3719,},
   /*VREDUCESD     */    {6364,6363,6365,},
   /*VRNDSCALESD   */    {2201,2200,2202,},
   };
   xed_uint8_t iclass_index = xed_encoder_get_iclasses_index_in_group(xes);
   if (xes->_n_operand_order == 5 && memcmp(xed_encode_order[18], xes->_operand_order, sizeof(xed_uint8_t)*5)==0) {
   conditions_satisfied = (xed3_operand_get_sae(xes) != 0) &&
		 xed_encode_ntluf_XMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_XMM_N3(xes,xed3_operand_get_reg2(xes)) &&
		 xed_encode_ntluf_XMM_B3(xes,xed3_operand_get_reg3(xes)) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][0]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_FIX_ROUND_LEN128_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_SAE_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_UIMM8_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 5 && memcmp(xed_encode_order[18], xes->_operand_order, sizeof(xed_uint8_t)*5)==0) {
   conditions_satisfied = xed_encode_ntluf_XMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_XMM_N3(xes,xed3_operand_get_reg2(xes)) &&
		 xed_encode_ntluf_XMM_B3(xes,xed3_operand_get_reg3(xes)) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][1]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_UIMM8_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 5 && memcmp(xed_encode_order[19], xes->_operand_order, sizeof(xed_uint8_t)*5)==0) {
   conditions_satisfied = xed_encode_ntluf_XMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_XMM_N3(xes,xed3_operand_get_reg2(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_Q) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][2]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_UIMM8_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_64_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_SCALAR_BIND(xes);
       if (okay) return 1;
   }
     }
   return 0;
   (void) okay;
   (void) conditions_satisfied;
   (void) xes;
}
xed_bool_t xed_encode_group_63(xed_encoder_request_t* xes)
{
   xed_bool_t okay=1;
   xed_bool_t conditions_satisfied=0;
   xed_ptrn_func_ptr_t fb_ptrn_function;
   static const xed_uint16_t iform_ids[14][1] = {
   /*FCMOVB        */    {3056,},
   /*FCMOVBE       */    {3759,},
   /*FCMOVE        */    {6615,},
   /*FCMOVNB       */    {3907,},
   /*FCMOVNBE      */    {3203,},
   /*FCMOVNE       */    {2650,},
   /*FCMOVNU       */    {6019,},
   /*FCMOVU        */    { 325,},
   /*FCOMI         */    { 646,},
   /*FCOMIP        */    {4519,},
   /*FUCOM         */    {1519,},
   /*FUCOMI        */    { 648,},
   /*FUCOMIP       */    {2455,},
   /*FUCOMP        */    {3385,},
   };
   xed_uint8_t iclass_index = xed_encoder_get_iclasses_index_in_group(xes);
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_REG1) {
   conditions_satisfied = (xed3_operand_get_reg0(xes) == XED_REG_ST0) &&
		 xed_encode_ntluf_X87(xes,xed3_operand_get_reg1(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][0]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   return 0;
   (void) okay;
   (void) conditions_satisfied;
   (void) xes;
}
xed_bool_t xed_encode_group_64(xed_encoder_request_t* xes)
{
   xed_bool_t okay=1;
   xed_bool_t conditions_satisfied=0;
   xed_ptrn_func_ptr_t fb_ptrn_function;
   static const xed_uint16_t iform_ids[24][2] = {
   /*PAVGUSB       */    {6510,6509,},
   /*PF2ID         */    {5900,5899,},
   /*PF2IW         */    {5923,5922,},
   /*PFACC         */    {6206,6205,},
   /*PFADD         */    {3161,3160,},
   /*PFCMPEQ       */    {3516,3515,},
   /*PFCMPGE       */    {6967,6966,},
   /*PFCMPGT       */    {6211,6210,},
   /*PFMAX         */    { 327, 326,},
   /*PFMIN         */    {4813,4812,},
   /*PFMUL         */    {2562,2561,},
   /*PFNACC        */    { 565, 564,},
   /*PFPNACC       */    { 455, 454,},
   /*PFRCP         */    {5950,5949,},
   /*PFRCPIT1      */    { 957, 956,},
   /*PFRCPIT2      */    {1379,1378,},
   /*PFRSQIT1      */    {2557,2556,},
   /*PFRSQRT       */    {3226,3225,},
   /*PFSUB         */    {2483,2482,},
   /*PFSUBR        */    {1802,1801,},
   /*PI2FD         */    {2035,2034,},
   /*PI2FW         */    {1997,1996,},
   /*PMULHRW       */    {5878,5877,},
   /*PSWAPD        */    {1617,1616,},
   };
   xed_uint8_t iclass_index = xed_encoder_get_iclasses_index_in_group(xes);
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_REG1) {
   conditions_satisfied = xed_encode_ntluf_MMX_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MMX_B(xes,xed3_operand_get_reg1(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][0]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_MEM0) {
   conditions_satisfied = xed_encode_ntluf_MMX_R(xes,xed3_operand_get_reg0(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_Q);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][1]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay) return 1;
   }
     }
   return 0;
   (void) okay;
   (void) conditions_satisfied;
   (void) xes;
}
xed_bool_t xed_encode_group_65(xed_encoder_request_t* xes)
{
   xed_bool_t okay=1;
   xed_bool_t conditions_satisfied=0;
   xed_ptrn_func_ptr_t fb_ptrn_function;
   static const xed_uint16_t iform_ids[2][2] = {
   /*VPERM2F128    */    { 329, 328,},
   /*VPERM2I128    */    {5260,5259,},
   };
   xed_uint8_t iclass_index = xed_encoder_get_iclasses_index_in_group(xes);
   if (xes->_n_operand_order == 4 && memcmp(xed_encode_order[21], xes->_operand_order, sizeof(xed_uint8_t)*4)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 1) &&
		 (xed3_operand_get_must_use_evex(xes) == 0) &&
		 xed_encode_ntluf_YMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_YMM_N(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_YMM_B(xes,xed3_operand_get_reg2(xes)) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][0]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_UIMM8_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 4 && memcmp(xed_encode_order[22], xes->_operand_order, sizeof(xed_uint8_t)*4)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 1) &&
		 (xed3_operand_get_must_use_evex(xes) == 0) &&
		 xed_encode_ntluf_YMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_YMM_N(xes,xed3_operand_get_reg1(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_QQ) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][1]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_UIMM8_BIND(xes);
       if (okay) return 1;
   }
     }
   return 0;
   (void) okay;
   (void) conditions_satisfied;
   (void) xes;
}
xed_bool_t xed_encode_group_66(xed_encoder_request_t* xes)
{
   xed_bool_t okay=1;
   xed_bool_t conditions_satisfied=0;
   xed_ptrn_func_ptr_t fb_ptrn_function;
   static const xed_uint16_t iform_ids[3][2] = {
   /*SLDT          */    { 331, 330,},
   /*SMSW          */    {2493,2492,},
   /*STR           */    {6283,6282,},
   };
   xed_uint8_t iclass_index = xed_encoder_get_iclasses_index_in_group(xes);
   if (xes->_n_operand_order == 1 && xes->_operand_order[0] == XED_OPERAND_REG0) {
   conditions_satisfied = xed_encode_ntluf_GPRv_B(xes,xed3_operand_get_reg0(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][0]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 1 && xes->_operand_order[0] == XED_OPERAND_MEM0) {
   conditions_satisfied = (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_W);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][1]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay) return 1;
   }
     }
   return 0;
   (void) okay;
   (void) conditions_satisfied;
   (void) xes;
}
xed_bool_t xed_encode_group_67(xed_encoder_request_t* xes)
{
   xed_bool_t okay=1;
   xed_bool_t conditions_satisfied=0;
   xed_ptrn_func_ptr_t fb_ptrn_function;
   static const xed_uint16_t iform_ids[12][8] = {
   /*VFMADDPD      */    {5725,5727,5729,5731,5724,5726,5728,5730,},
   /*VFMADDPS      */    {6492,6494,6496,6498,6491,6493,6495,6497,},
   /*VFMADDSUBPD   */    {1389,1391,1393,1395,1388,1390,1392,1394,},
   /*VFMADDSUBPS   */    {3068,3070,3072,3074,3067,3069,3071,3073,},
   /*VFMSUBADDPD   */    {1301,1303,1305,1307,1300,1302,1304,1306,},
   /*VFMSUBADDPS   */    {2569,2571,2573,2575,2568,2570,2572,2574,},
   /*VFMSUBPD      */    {5815,5817,5819,5821,5814,5816,5818,5820,},
   /*VFMSUBPS      */    {3454,3456,3458,3460,3453,3455,3457,3459,},
   /*VFNMADDPD     */    {1217,1219,1221,1223,1216,1218,1220,1222,},
   /*VFNMADDPS     */    {5353,5355,5357,5359,5352,5354,5356,5358,},
   /*VFNMSUBPD     */    { 835, 837, 839, 841, 834, 836, 838, 840,},
   /*VFNMSUBPS     */    { 333, 335, 337, 339, 332, 334, 336, 338,},
   };
   xed_uint8_t iclass_index = xed_encoder_get_iclasses_index_in_group(xes);
   if (xes->_n_operand_order == 4 && memcmp(xed_encode_order[12], xes->_operand_order, sizeof(xed_uint8_t)*4)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 (xed3_operand_get_must_use_evex(xes) == 0) &&
		 xed_encode_ntluf_XMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_XMM_N(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_XMM_B(xes,xed3_operand_get_reg2(xes)) &&
		 xed_encode_ntluf_XMM_SE(xes,xed3_operand_get_reg3(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][0]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_SE_IMM8_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 4 && memcmp(xed_encode_order[12], xes->_operand_order, sizeof(xed_uint8_t)*4)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 (xed3_operand_get_must_use_evex(xes) == 0) &&
		 xed_encode_ntluf_XMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_XMM_N(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_XMM_SE(xes,xed3_operand_get_reg2(xes)) &&
		 xed_encode_ntluf_XMM_B(xes,xed3_operand_get_reg3(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][1]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_SE_IMM8_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 4 && memcmp(xed_encode_order[12], xes->_operand_order, sizeof(xed_uint8_t)*4)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 1) &&
		 (xed3_operand_get_must_use_evex(xes) == 0) &&
		 xed_encode_ntluf_YMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_YMM_N(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_YMM_B(xes,xed3_operand_get_reg2(xes)) &&
		 xed_encode_ntluf_YMM_SE(xes,xed3_operand_get_reg3(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][2]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_SE_IMM8_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 4 && memcmp(xed_encode_order[12], xes->_operand_order, sizeof(xed_uint8_t)*4)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 1) &&
		 (xed3_operand_get_must_use_evex(xes) == 0) &&
		 xed_encode_ntluf_YMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_YMM_N(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_YMM_SE(xes,xed3_operand_get_reg2(xes)) &&
		 xed_encode_ntluf_YMM_B(xes,xed3_operand_get_reg3(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][3]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_SE_IMM8_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 4 && memcmp(xed_encode_order[11], xes->_operand_order, sizeof(xed_uint8_t)*4)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 (xed3_operand_get_must_use_evex(xes) == 0) &&
		 xed_encode_ntluf_XMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_XMM_N(xes,xed3_operand_get_reg1(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_DQ) &&
		 xed_encode_ntluf_XMM_SE(xes,xed3_operand_get_reg2(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][4]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_SE_IMM8_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 4 && memcmp(xed_encode_order[13], xes->_operand_order, sizeof(xed_uint8_t)*4)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 (xed3_operand_get_must_use_evex(xes) == 0) &&
		 xed_encode_ntluf_XMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_XMM_N(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_XMM_SE(xes,xed3_operand_get_reg2(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_DQ);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][5]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_SE_IMM8_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 4 && memcmp(xed_encode_order[11], xes->_operand_order, sizeof(xed_uint8_t)*4)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 1) &&
		 (xed3_operand_get_must_use_evex(xes) == 0) &&
		 xed_encode_ntluf_YMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_YMM_N(xes,xed3_operand_get_reg1(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_QQ) &&
		 xed_encode_ntluf_YMM_SE(xes,xed3_operand_get_reg2(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][6]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_SE_IMM8_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 4 && memcmp(xed_encode_order[13], xes->_operand_order, sizeof(xed_uint8_t)*4)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 1) &&
		 (xed3_operand_get_must_use_evex(xes) == 0) &&
		 xed_encode_ntluf_YMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_YMM_N(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_YMM_SE(xes,xed3_operand_get_reg2(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_QQ);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][7]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_SE_IMM8_BIND(xes);
       if (okay) return 1;
   }
     }
   return 0;
   (void) okay;
   (void) conditions_satisfied;
   (void) xes;
}
xed_bool_t xed_encode_group_68(xed_encoder_request_t* xes)
{
   xed_bool_t okay=1;
   xed_bool_t conditions_satisfied=0;
   xed_ptrn_func_ptr_t fb_ptrn_function;
   static const xed_uint16_t iform_ids[27][1] = {
   /*KADDB         */    {3905,},
   /*KADDD         */    {3066,},
   /*KADDQ         */    {1693,},
   /*KADDW         */    {5258,},
   /*KANDB         */    {5856,},
   /*KANDD         */    {3075,},
   /*KANDNB        */    {6215,},
   /*KANDND        */    {2028,},
   /*KANDNQ        */    { 340,},
   /*KANDNW        */    {1412,},
   /*KANDQ         */    {4805,},
   /*KANDW         */    {4995,},
   /*KORB          */    {3913,},
   /*KORD          */    {4259,},
   /*KORQ          */    {1844,},
   /*KORW          */    {4327,},
   /*KUNPCKBW      */    {3749,},
   /*KUNPCKDQ      */    {3276,},
   /*KUNPCKWD      */    {3110,},
   /*KXNORB        */    {1794,},
   /*KXNORD        */    {1546,},
   /*KXNORQ        */    {3914,},
   /*KXNORW        */    {1206,},
   /*KXORB         */    { 779,},
   /*KXORD         */    {2696,},
   /*KXORQ         */    {3906,},
   /*KXORW         */    { 965,},
   };
   xed_uint8_t iclass_index = xed_encoder_get_iclasses_index_in_group(xes);
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[7], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_must_use_evex(xes) == 0) &&
		 xed_encode_ntluf_MASK_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK_N(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_MASK_B(xes,xed3_operand_get_reg2(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][0]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   return 0;
   (void) okay;
   (void) conditions_satisfied;
   (void) xes;
}
xed_bool_t xed_encode_group_69(xed_encoder_request_t* xes)
{
   xed_bool_t okay=1;
   xed_bool_t conditions_satisfied=0;
   xed_ptrn_func_ptr_t fb_ptrn_function;
   static const xed_uint16_t iform_ids[2][10] = {
   /*VPCMPEQW      */    { 354, 356, 353, 355, 357, 359, 361, 358, 360, 362,},
   /*VPCMPGTW      */    {4089,4091,4088,4090,4092,4094,4096,4093,4095,4097,},
   };
   xed_uint8_t iclass_index = xed_encoder_get_iclasses_index_in_group(xes);
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[7], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 (xed3_operand_get_must_use_evex(xes) == 0) &&
		 xed_encode_ntluf_XMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_XMM_N(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_XMM_B(xes,xed3_operand_get_reg2(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][0]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[7], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 1) &&
		 (xed3_operand_get_must_use_evex(xes) == 0) &&
		 xed_encode_ntluf_YMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_YMM_N(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_YMM_B(xes,xed3_operand_get_reg2(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][1]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[14], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 (xed3_operand_get_must_use_evex(xes) == 0) &&
		 xed_encode_ntluf_XMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_XMM_N(xes,xed3_operand_get_reg1(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_DQ);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][2]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[14], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 1) &&
		 (xed3_operand_get_must_use_evex(xes) == 0) &&
		 xed_encode_ntluf_YMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_YMM_N(xes,xed3_operand_get_reg1(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_QQ);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][3]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 4 && memcmp(xed_encode_order[12], xes->_operand_order, sizeof(xed_uint8_t)*4)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 xed_encode_ntluf_MASK_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_XMM_N3(xes,xed3_operand_get_reg2(xes)) &&
		 xed_encode_ntluf_XMM_B3(xes,xed3_operand_get_reg3(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][4]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 4 && memcmp(xed_encode_order[12], xes->_operand_order, sizeof(xed_uint8_t)*4)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 1) &&
		 xed_encode_ntluf_MASK_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_YMM_N3(xes,xed3_operand_get_reg2(xes)) &&
		 xed_encode_ntluf_YMM_B3(xes,xed3_operand_get_reg3(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][5]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 4 && memcmp(xed_encode_order[12], xes->_operand_order, sizeof(xed_uint8_t)*4)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 2) &&
		 xed_encode_ntluf_MASK_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_ZMM_N3(xes,xed3_operand_get_reg2(xes)) &&
		 xed_encode_ntluf_ZMM_B3(xes,xed3_operand_get_reg3(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][6]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 4 && memcmp(xed_encode_order[13], xes->_operand_order, sizeof(xed_uint8_t)*4)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 xed_encode_ntluf_MASK_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_XMM_N3(xes,xed3_operand_get_reg2(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_DQ);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][7]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_16_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_FULLMEM_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 4 && memcmp(xed_encode_order[13], xes->_operand_order, sizeof(xed_uint8_t)*4)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 1) &&
		 xed_encode_ntluf_MASK_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_YMM_N3(xes,xed3_operand_get_reg2(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_QQ);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][8]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_16_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_FULLMEM_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 4 && memcmp(xed_encode_order[13], xes->_operand_order, sizeof(xed_uint8_t)*4)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 2) &&
		 xed_encode_ntluf_MASK_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_ZMM_N3(xes,xed3_operand_get_reg2(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_ZD);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][9]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_16_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_FULLMEM_BIND(xes);
       if (okay) return 1;
   }
     }
   return 0;
   (void) okay;
   (void) conditions_satisfied;
   (void) xes;
}
xed_bool_t xed_encode_group_70(xed_encoder_request_t* xes)
{
   xed_bool_t okay=1;
   xed_bool_t conditions_satisfied=0;
   xed_ptrn_func_ptr_t fb_ptrn_function;
   static const xed_uint16_t iform_ids[1][1] = {
   /*UMONITOR      */    { 363,},
   };
   xed_uint8_t iclass_index = xed_encoder_get_iclasses_index_in_group(xes);
   if (xes->_n_operand_order == 1 && xes->_operand_order[0] == XED_OPERAND_REG0) {
   conditions_satisfied = xed_encode_ntluf_A_GPR_B(xes,xed3_operand_get_reg0(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][0]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   return 0;
   (void) okay;
   (void) conditions_satisfied;
   (void) xes;
}
xed_bool_t xed_encode_group_71(xed_encoder_request_t* xes)
{
   xed_bool_t okay=1;
   xed_bool_t conditions_satisfied=0;
   xed_ptrn_func_ptr_t fb_ptrn_function;
   static const xed_uint16_t iform_ids[2][1] = {
   /*AAD           */    { 364,},
   /*AAM           */    {1758,},
   };
   xed_uint8_t iclass_index = xed_encoder_get_iclasses_index_in_group(xes);
   if (xes->_n_operand_order == 1 && xes->_operand_order[0] == XED_OPERAND_IMM0) {
   conditions_satisfied = (xed3_operand_get_mode(xes) != 2) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][0]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_UIMM8_BIND(xes);
       if (okay) return 1;
   }
     }
   return 0;
   (void) okay;
   (void) conditions_satisfied;
   (void) xes;
}
xed_bool_t xed_encode_group_72(xed_encoder_request_t* xes)
{
   xed_bool_t okay=1;
   xed_bool_t conditions_satisfied=0;
   xed_ptrn_func_ptr_t fb_ptrn_function;
   static const xed_uint16_t iform_ids[3][6] = {
   /*VPMOVDW       */    { 448, 450, 446, 449, 451, 447,},
   /*VPMOVSDW      */    {2653,2655,2651,2654,2656,2652,},
   /*VPMOVUSDW     */    { 368, 370, 366, 369, 371, 367,},
   };
   xed_uint8_t iclass_index = xed_encoder_get_iclasses_index_in_group(xes);
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[7], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 xed_encode_ntluf_XMM_B3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_XMM_R3(xes,xed3_operand_get_reg2(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][0]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[7], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 1) &&
		 xed_encode_ntluf_XMM_B3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_YMM_R3(xes,xed3_operand_get_reg2(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][1]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[7], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 2) &&
		 xed_encode_ntluf_YMM_B3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_ZMM_R3(xes,xed3_operand_get_reg2(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][2]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[6], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_Q) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_XMM_R3(xes,xed3_operand_get_reg1(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][3]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_16_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_HALFMEM_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[6], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 1) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_DQ) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_YMM_R3(xes,xed3_operand_get_reg1(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][4]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_16_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_HALFMEM_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[6], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 2) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_QQ) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_ZMM_R3(xes,xed3_operand_get_reg1(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][5]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_16_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_HALFMEM_BIND(xes);
       if (okay) return 1;
   }
     }
   return 0;
   (void) okay;
   (void) conditions_satisfied;
   (void) xes;
}
xed_bool_t xed_encode_group_73(xed_encoder_request_t* xes)
{
   xed_bool_t okay=1;
   xed_bool_t conditions_satisfied=0;
   xed_ptrn_func_ptr_t fb_ptrn_function;
   static const xed_uint16_t iform_ids[14][10] = {
   /*VANDNPD       */    {1581,1583,1580,1582,1584,1586,1588,1585,1587,1589,},
   /*VANDPD        */    {5710,5712,5709,5711,5713,5715,5717,5714,5716,5718,},
   /*VORPD         */    {3387,3389,3386,3388,3390,3392,3394,3391,3393,3395,},
   /*VPADDQ        */    {6667,6669,6666,6668,6672,6674,6670,6673,6675,6671,},
   /*VPMULDQ       */    {4347,4349,4346,4348,4352,4354,4350,4353,4355,4351,},
   /*VPMULUDQ      */    {5063,5065,5062,5064,5068,5070,5066,5069,5071,5067,},
   /*VPSLLVQ       */    { 376, 378, 375, 377, 381, 383, 379, 382, 384, 380,},
   /*VPSRLVQ       */    { 702, 704, 701, 703, 707, 709, 705, 708, 710, 706,},
   /*VPSUBQ        */    {3194,3196,3193,3195,3199,3201,3197,3200,3202,3198,},
   /*VPUNPCKHQDQ   */    {2794,2796,2793,2795,2799,2801,2797,2800,2802,2798,},
   /*VPUNPCKLQDQ   */    {3327,3329,3326,3328,3332,3334,3330,3333,3335,3331,},
   /*VUNPCKHPD     */    {1704,1706,1703,1705,1709,1711,1707,1710,1712,1708,},
   /*VUNPCKLPD     */    {6353,6355,6352,6354,6358,6360,6356,6359,6361,6357,},
   /*VXORPD        */    {4752,4754,4751,4753,4755,4757,4759,4756,4758,4760,},
   };
   xed_uint8_t iclass_index = xed_encoder_get_iclasses_index_in_group(xes);
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[7], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 (xed3_operand_get_must_use_evex(xes) == 0) &&
		 xed_encode_ntluf_XMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_XMM_N(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_XMM_B(xes,xed3_operand_get_reg2(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][0]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[7], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 1) &&
		 (xed3_operand_get_must_use_evex(xes) == 0) &&
		 xed_encode_ntluf_YMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_YMM_N(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_YMM_B(xes,xed3_operand_get_reg2(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][1]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[14], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 (xed3_operand_get_must_use_evex(xes) == 0) &&
		 xed_encode_ntluf_XMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_XMM_N(xes,xed3_operand_get_reg1(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_DQ);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][2]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[14], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 1) &&
		 (xed3_operand_get_must_use_evex(xes) == 0) &&
		 xed_encode_ntluf_YMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_YMM_N(xes,xed3_operand_get_reg1(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_QQ);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][3]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 4 && memcmp(xed_encode_order[12], xes->_operand_order, sizeof(xed_uint8_t)*4)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 xed_encode_ntluf_XMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_XMM_N3(xes,xed3_operand_get_reg2(xes)) &&
		 xed_encode_ntluf_XMM_B3(xes,xed3_operand_get_reg3(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][4]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 4 && memcmp(xed_encode_order[12], xes->_operand_order, sizeof(xed_uint8_t)*4)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 1) &&
		 xed_encode_ntluf_YMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_YMM_N3(xes,xed3_operand_get_reg2(xes)) &&
		 xed_encode_ntluf_YMM_B3(xes,xed3_operand_get_reg3(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][5]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 4 && memcmp(xed_encode_order[12], xes->_operand_order, sizeof(xed_uint8_t)*4)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 2) &&
		 xed_encode_ntluf_ZMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_ZMM_N3(xes,xed3_operand_get_reg2(xes)) &&
		 xed_encode_ntluf_ZMM_B3(xes,xed3_operand_get_reg3(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][6]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 4 && memcmp(xed_encode_order[13], xes->_operand_order, sizeof(xed_uint8_t)*4)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 xed_encode_ntluf_XMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_XMM_N3(xes,xed3_operand_get_reg2(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_VV);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][7]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_64_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_FULL_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 4 && memcmp(xed_encode_order[13], xes->_operand_order, sizeof(xed_uint8_t)*4)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 1) &&
		 xed_encode_ntluf_YMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_YMM_N3(xes,xed3_operand_get_reg2(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_VV);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][8]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_64_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_FULL_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 4 && memcmp(xed_encode_order[13], xes->_operand_order, sizeof(xed_uint8_t)*4)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 2) &&
		 xed_encode_ntluf_ZMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_ZMM_N3(xes,xed3_operand_get_reg2(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_VV);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][9]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_64_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_FULL_BIND(xes);
       if (okay) return 1;
   }
     }
   return 0;
   (void) okay;
   (void) conditions_satisfied;
   (void) xes;
}
xed_bool_t xed_encode_group_74(xed_encoder_request_t* xes)
{
   xed_bool_t okay=1;
   xed_bool_t conditions_satisfied=0;
   xed_ptrn_func_ptr_t fb_ptrn_function;
   static const xed_uint16_t iform_ids[3][7] = {
   /*VCVTTPD2QQ    */    { 401, 396, 398, 400, 397, 399, 402,},
   /*VCVTTPD2UQQ   */    {1115,1110,1112,1114,1111,1113,1116,},
   /*VGETEXPPD     */    {5539,5541,5543,5538,5542,5544,5540,},
   };
   xed_uint8_t iclass_index = xed_encoder_get_iclasses_index_in_group(xes);
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[7], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_sae(xes) != 0) &&
		 xed_encode_ntluf_ZMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_ZMM_B3(xes,xed3_operand_get_reg2(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][0]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_FIX_ROUND_LEN512_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_SAE_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[7], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 xed_encode_ntluf_XMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_XMM_B3(xes,xed3_operand_get_reg2(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][1]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[7], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 1) &&
		 xed_encode_ntluf_YMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_YMM_B3(xes,xed3_operand_get_reg2(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][2]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[7], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 2) &&
		 xed_encode_ntluf_ZMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_ZMM_B3(xes,xed3_operand_get_reg2(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][3]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[14], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 xed_encode_ntluf_XMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_VV);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][4]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_64_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_FULL_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[14], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 1) &&
		 xed_encode_ntluf_YMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_VV);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][5]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_64_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_FULL_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[14], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 2) &&
		 xed_encode_ntluf_ZMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_VV);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][6]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_64_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_FULL_BIND(xes);
       if (okay) return 1;
   }
     }
   return 0;
   (void) okay;
   (void) conditions_satisfied;
   (void) xes;
}
xed_bool_t xed_encode_group_75(xed_encoder_request_t* xes)
{
   xed_bool_t okay=1;
   xed_bool_t conditions_satisfied=0;
   xed_ptrn_func_ptr_t fb_ptrn_function;
   static const xed_uint16_t iform_ids[12][2] = {
   /*ADDPD         */    {5902,5901,},
   /*ADDSUBPD      */    {3065,3064,},
   /*CVTPD2PS      */    {6471,6470,},
   /*CVTTPD2DQ     */    {5537,5536,},
   /*DIVPD         */    { 524, 523,},
   /*HADDPD        */    {3576,3575,},
   /*HSUBPD        */    {2432,2431,},
   /*MAXPD         */    { 457, 456,},
   /*MINPD         */    {1312,1311,},
   /*MULPD         */    { 404, 403,},
   /*SQRTPD        */    { 687, 686,},
   /*SUBPD         */    {4269,4268,},
   };
   xed_uint8_t iclass_index = xed_encoder_get_iclasses_index_in_group(xes);
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_REG1) {
   conditions_satisfied = xed_encode_ntluf_XMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_XMM_B(xes,xed3_operand_get_reg1(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][0]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_REFINING66_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_MEM0) {
   conditions_satisfied = xed_encode_ntluf_XMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_PD);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][1]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_REFINING66_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay) return 1;
   }
     }
   return 0;
   (void) okay;
   (void) conditions_satisfied;
   (void) xes;
}
xed_bool_t xed_encode_group_76(xed_encoder_request_t* xes)
{
   xed_bool_t okay=1;
   xed_bool_t conditions_satisfied=0;
   xed_ptrn_func_ptr_t fb_ptrn_function;
   static const xed_uint16_t iform_ids[1][5] = {
   /*KMOVQ         */    { 409, 408, 405, 407, 406,},
   };
   xed_uint8_t iclass_index = xed_encoder_get_iclasses_index_in_group(xes);
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_REG1) {
   conditions_satisfied = (xed3_operand_get_mode(xes) == 2) &&
		 (xed3_operand_get_must_use_evex(xes) == 0) &&
		 xed_encode_ntluf_GPR64_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK_B(xes,xed3_operand_get_reg1(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][0]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_REG1) {
   conditions_satisfied = (xed3_operand_get_mode(xes) == 2) &&
		 (xed3_operand_get_must_use_evex(xes) == 0) &&
		 xed_encode_ntluf_MASK_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_GPR64_B(xes,xed3_operand_get_reg1(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][1]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_REG1) {
   conditions_satisfied = (xed3_operand_get_must_use_evex(xes) == 0) &&
		 xed_encode_ntluf_MASK_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK_B(xes,xed3_operand_get_reg1(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][2]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_MEM0 && xes->_operand_order[1] == XED_OPERAND_REG0) {
   conditions_satisfied = (xed3_operand_get_must_use_evex(xes) == 0) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_Q) &&
		 xed_encode_ntluf_MASK_R(xes,xed3_operand_get_reg0(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][3]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_MEM0) {
   conditions_satisfied = (xed3_operand_get_must_use_evex(xes) == 0) &&
		 xed_encode_ntluf_MASK_R(xes,xed3_operand_get_reg0(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_Q);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][4]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay) return 1;
   }
     }
   return 0;
   (void) okay;
   (void) conditions_satisfied;
   (void) xes;
}
xed_bool_t xed_encode_group_77(xed_encoder_request_t* xes)
{
   xed_bool_t okay=1;
   xed_bool_t conditions_satisfied=0;
   xed_ptrn_func_ptr_t fb_ptrn_function;
   static const xed_uint16_t iform_ids[8][4] = {
   /*VPSHAB        */    {6128,6130,6127,6129,},
   /*VPSHAD        */    {5494,5496,5493,5495,},
   /*VPSHAQ        */    {3278,3280,3277,3279,},
   /*VPSHAW        */    { 419, 421, 418, 420,},
   /*VPSHLB        */    {1743,1745,1742,1744,},
   /*VPSHLD        */    {1165,1167,1164,1166,},
   /*VPSHLQ        */    {4434,4436,4433,4435,},
   /*VPSHLW        */    {2264,2266,2263,2265,},
   };
   xed_uint8_t iclass_index = xed_encoder_get_iclasses_index_in_group(xes);
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[7], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 xed_encode_ntluf_XMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_XMM_B(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_XMM_N(xes,xed3_operand_get_reg2(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][0]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[7], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 xed_encode_ntluf_XMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_XMM_N(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_XMM_B(xes,xed3_operand_get_reg2(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][1]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[24], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 xed_encode_ntluf_XMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_DQ) &&
		 xed_encode_ntluf_XMM_N(xes,xed3_operand_get_reg1(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][2]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[14], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 xed_encode_ntluf_XMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_XMM_N(xes,xed3_operand_get_reg1(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_DQ);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][3]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay) return 1;
   }
     }
   return 0;
   (void) okay;
   (void) conditions_satisfied;
   (void) xes;
}
xed_bool_t xed_encode_group_78(xed_encoder_request_t* xes)
{
   xed_bool_t okay=1;
   xed_bool_t conditions_satisfied=0;
   xed_ptrn_func_ptr_t fb_ptrn_function;
   static const xed_uint16_t iform_ids[4][1] = {
   /*CMPSQ         */    {2829,},
   /*LODSQ         */    { 854,},
   /*REPE_CMPSQ    */    { 422,},
   /*REPNE_CMPSQ   */    {6659,},
   };
   xed_uint8_t iclass_index = xed_encoder_get_iclasses_index_in_group(xes);
   if (xes->_n_operand_order == 0) {
   conditions_satisfied = (xed3_operand_get_mode(xes) == 2);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][0]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_OVERRIDE_SEG0_BIND(xes);
       if (okay) return 1;
   }
     }
   return 0;
   (void) okay;
   (void) conditions_satisfied;
   (void) xes;
}
xed_bool_t xed_encode_group_79(xed_encoder_request_t* xes)
{
   xed_bool_t okay=1;
   xed_bool_t conditions_satisfied=0;
   xed_ptrn_func_ptr_t fb_ptrn_function;
   static const xed_uint16_t iform_ids[2][3] = {
   /*MOVSD         */    {6929,6930,6931,},
   /*MOVSW         */    { 458, 459, 460,},
   };
   xed_uint8_t iclass_index = xed_encoder_get_iclasses_index_in_group(xes);
   if (xes->_n_operand_order == 0) {
   conditions_satisfied = (xed3_operand_get_mode(xes) == 0);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][0]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_OVERRIDE_SEG1_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 0) {
   conditions_satisfied = (xed3_operand_get_mode(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][1]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_OVERRIDE_SEG1_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 0) {
   conditions_satisfied = (xed3_operand_get_mode(xes) == 2);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][2]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_OVERRIDE_SEG1_BIND(xes);
       if (okay) return 1;
   }
     }
   return 0;
   (void) okay;
   (void) conditions_satisfied;
   (void) xes;
}
xed_bool_t xed_encode_group_80(xed_encoder_request_t* xes)
{
   xed_bool_t okay=1;
   xed_bool_t conditions_satisfied=0;
   xed_ptrn_func_ptr_t fb_ptrn_function;
   static const xed_uint16_t iform_ids[27][2] = {
   /*AESDEC        */    {6059,6060,},
   /*AESDECLAST    */    {5085,5086,},
   /*AESENC        */    {2467,2468,},
   /*AESENCLAST    */    {5098,5099,},
   /*AESIMC        */    {4266,4267,},
   /*BLENDVPD      */    {2993,2992,},
   /*BLENDVPS      */    {6406,6405,},
   /*PACKUSDW      */    {6121,6120,},
   /*PBLENDVB      */    {1862,1861,},
   /*PCMPEQQ       */    {6534,6533,},
   /*PCMPGTQ       */    {5107,5106,},
   /*PHMINPOSUW    */    { 462, 461,},
   /*PMAXSB        */    {3574,3573,},
   /*PMAXSD        */    {6878,6877,},
   /*PMAXUD        */    {3832,3831,},
   /*PMAXUW        */    { 517, 516,},
   /*PMINSB        */    {6631,6630,},
   /*PMINSD        */    { 568, 567,},
   /*PMINUD        */    {4742,4741,},
   /*PMINUW        */    {5335,5334,},
   /*PMULDQ        */    {3116,3115,},
   /*PMULLD        */    {5948,5947,},
   /*PTEST         */    { 775, 774,},
   /*PUNPCKHQDQ    */    { 714, 713,},
   /*PUNPCKLQDQ    */    { 712, 711,},
   /*UNPCKHPD      */    {2838,2837,},
   /*UNPCKLPD      */    {6992,6991,},
   };
   xed_uint8_t iclass_index = xed_encoder_get_iclasses_index_in_group(xes);
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_REG1) {
   conditions_satisfied = xed_encode_ntluf_XMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_XMM_B(xes,xed3_operand_get_reg1(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][0]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_REFINING66_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_MEM0) {
   conditions_satisfied = xed_encode_ntluf_XMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_DQ);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][1]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_REFINING66_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay) return 1;
   }
     }
   return 0;
   (void) okay;
   (void) conditions_satisfied;
   (void) xes;
}
xed_bool_t xed_encode_group_81(xed_encoder_request_t* xes)
{
   xed_bool_t okay=1;
   xed_bool_t conditions_satisfied=0;
   xed_ptrn_func_ptr_t fb_ptrn_function;
   static const xed_uint16_t iform_ids[1][6] = {
   /*VPCOMPRESSB   */    { 464, 466, 468, 463, 465, 467,},
   };
   xed_uint8_t iclass_index = xed_encoder_get_iclasses_index_in_group(xes);
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[7], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 xed_encode_ntluf_XMM_B3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_XMM_R3(xes,xed3_operand_get_reg2(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][0]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[7], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 1) &&
		 xed_encode_ntluf_YMM_B3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_YMM_R3(xes,xed3_operand_get_reg2(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][1]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[7], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 2) &&
		 xed_encode_ntluf_ZMM_B3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_ZMM_R3(xes,xed3_operand_get_reg2(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][2]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[6], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_DQ) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_XMM_R3(xes,xed3_operand_get_reg1(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][3]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_8_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_GSCAT_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[6], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 1) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_QQ) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_YMM_R3(xes,xed3_operand_get_reg1(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][4]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_8_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_GSCAT_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[6], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 2) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_ZD) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_ZMM_R3(xes,xed3_operand_get_reg1(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][5]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_8_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_GSCAT_BIND(xes);
       if (okay) return 1;
   }
     }
   return 0;
   (void) okay;
   (void) conditions_satisfied;
   (void) xes;
}
xed_bool_t xed_encode_group_82(xed_encoder_request_t* xes)
{
   xed_bool_t okay=1;
   xed_bool_t conditions_satisfied=0;
   xed_ptrn_func_ptr_t fb_ptrn_function;
   static const xed_uint16_t iform_ids[3][6] = {
   /*VPMOVDB       */    { 471, 473, 469, 472, 474, 470,},
   /*VPMOVSDB      */    {4499,4501,4497,4500,4502,4498,},
   /*VPMOVUSDB     */    {6662,6664,6660,6663,6665,6661,},
   };
   xed_uint8_t iclass_index = xed_encoder_get_iclasses_index_in_group(xes);
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[7], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 xed_encode_ntluf_XMM_B3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_XMM_R3(xes,xed3_operand_get_reg2(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][0]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[7], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 1) &&
		 xed_encode_ntluf_XMM_B3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_YMM_R3(xes,xed3_operand_get_reg2(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][1]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[7], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 2) &&
		 xed_encode_ntluf_XMM_B3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_ZMM_R3(xes,xed3_operand_get_reg2(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][2]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[6], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_D) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_XMM_R3(xes,xed3_operand_get_reg1(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][3]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_8_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_QUARTERMEM_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[6], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 1) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_Q) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_YMM_R3(xes,xed3_operand_get_reg1(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][4]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_8_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_QUARTERMEM_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[6], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 2) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_DQ) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_ZMM_R3(xes,xed3_operand_get_reg1(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][5]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_8_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_QUARTERMEM_BIND(xes);
       if (okay) return 1;
   }
     }
   return 0;
   (void) okay;
   (void) conditions_satisfied;
   (void) xes;
}
xed_bool_t xed_encode_group_83(xed_encoder_request_t* xes)
{
   xed_bool_t okay=1;
   xed_bool_t conditions_satisfied=0;
   xed_ptrn_func_ptr_t fb_ptrn_function;
   static const xed_uint16_t iform_ids[18][5] = {
   /*VADDSD        */    {5506,5504,5503,5505,5507,},
   /*VCVTSD2SS     */    {2690,2688,2687,2689,2691,},
   /*VDIVSD        */    {2185,2183,2182,2184,2186,},
   /*VFMADD132SD   */    {5011,5009,5008,5010,5012,},
   /*VFMADD213SD   */    {1602,1600,1599,1601,1603,},
   /*VFMADD231SD   */    {2885,2883,2882,2884,2886,},
   /*VFMSUB132SD   */    {5037,5035,5034,5036,5038,},
   /*VFMSUB213SD   */    {4892,4890,4889,4891,4893,},
   /*VFMSUB231SD   */    {6221,6219,6218,6220,6222,},
   /*VFNMADD132SD  */    {6375,6373,6372,6374,6376,},
   /*VFNMADD213SD  */    { 869, 867, 866, 868, 870,},
   /*VFNMADD231SD  */    { 482, 480, 479, 481, 483,},
   /*VFNMSUB132SD  */    {1994,1992,1991,1993,1995,},
   /*VFNMSUB213SD  */    {4125,4123,4122,4124,4126,},
   /*VFNMSUB231SD  */    {4971,4969,4968,4970,4972,},
   /*VMULSD        */    {4781,4779,4778,4780,4782,},
   /*VSQRTSD       */    { 562, 560, 559, 561, 563,},
   /*VSUBSD        */    {1475,1473,1472,1474,1476,},
   };
   xed_uint8_t iclass_index = xed_encoder_get_iclasses_index_in_group(xes);
   if (xes->_n_operand_order == 4 && memcmp(xed_encode_order[12], xes->_operand_order, sizeof(xed_uint8_t)*4)==0) {
   conditions_satisfied = (xed3_operand_get_roundc(xes) != 0) &&
		 xed_encode_ntluf_XMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_XMM_N3(xes,xed3_operand_get_reg2(xes)) &&
		 xed_encode_ntluf_XMM_B3(xes,xed3_operand_get_reg3(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][0]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_FIX_ROUND_LEN128_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_AVX512_ROUND_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[7], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_must_use_evex(xes) == 0) &&
		 xed_encode_ntluf_XMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_XMM_N(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_XMM_B(xes,xed3_operand_get_reg2(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][1]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[14], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_must_use_evex(xes) == 0) &&
		 xed_encode_ntluf_XMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_XMM_N(xes,xed3_operand_get_reg1(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_Q);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][2]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 4 && memcmp(xed_encode_order[12], xes->_operand_order, sizeof(xed_uint8_t)*4)==0) {
   conditions_satisfied = xed_encode_ntluf_XMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_XMM_N3(xes,xed3_operand_get_reg2(xes)) &&
		 xed_encode_ntluf_XMM_B3(xes,xed3_operand_get_reg3(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][3]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 4 && memcmp(xed_encode_order[13], xes->_operand_order, sizeof(xed_uint8_t)*4)==0) {
   conditions_satisfied = xed_encode_ntluf_XMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_XMM_N3(xes,xed3_operand_get_reg2(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_Q);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][4]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_64_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_SCALAR_BIND(xes);
       if (okay) return 1;
   }
     }
   return 0;
   (void) okay;
   (void) conditions_satisfied;
   (void) xes;
}
xed_bool_t xed_encode_group_84(xed_encoder_request_t* xes)
{
   xed_bool_t okay=1;
   xed_bool_t conditions_satisfied=0;
   xed_ptrn_func_ptr_t fb_ptrn_function;
   static const xed_uint16_t iform_ids[2][2] = {
   /*REP_LODSB     */    {3797,3798,},
   /*REP_OUTSB     */    { 484, 485,},
   };
   xed_uint8_t iclass_index = xed_encoder_get_iclasses_index_in_group(xes);
   if (xes->_n_operand_order == 0) {
   conditions_satisfied = 1;
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][0]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_OVERRIDE_SEG0_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 0) {
   conditions_satisfied = 1;
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][1]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_OVERRIDE_SEG0_BIND(xes);
       if (okay) return 1;
   }
     }
   return 0;
   (void) okay;
   (void) conditions_satisfied;
   (void) xes;
}
xed_bool_t xed_encode_group_85(xed_encoder_request_t* xes)
{
   xed_bool_t okay=1;
   xed_bool_t conditions_satisfied=0;
   xed_ptrn_func_ptr_t fb_ptrn_function;
   static const xed_uint16_t iform_ids[6][2] = {
   /*POPA          */    {5627,5628,},
   /*POPAD         */    { 883, 884,},
   /*POPFD         */    { 486, 487,},
   /*PUSHA         */    {5662,5663,},
   /*PUSHAD        */    {2965,2966,},
   /*PUSHFD        */    {5585,5584,},
   };
   xed_uint8_t iclass_index = xed_encoder_get_iclasses_index_in_group(xes);
   if (xes->_n_operand_order == 0) {
   conditions_satisfied = (xed3_operand_get_mode(xes) == 0);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][0]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 0) {
   conditions_satisfied = (xed3_operand_get_mode(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][1]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   return 0;
   (void) okay;
   (void) conditions_satisfied;
   (void) xes;
}
xed_bool_t xed_encode_group_86(xed_encoder_request_t* xes)
{
   xed_bool_t okay=1;
   xed_bool_t conditions_satisfied=0;
   xed_ptrn_func_ptr_t fb_ptrn_function;
   static const xed_uint16_t iform_ids[2][6] = {
   /*REP_MOVSD     */    { 488, 491, 489, 492, 490, 493,},
   /*REP_MOVSW     */    {3500,3503,3501,3504,3502,3505,},
   };
   xed_uint8_t iclass_index = xed_encoder_get_iclasses_index_in_group(xes);
   if (xes->_n_operand_order == 0) {
   conditions_satisfied = (xed3_operand_get_mode(xes) == 0);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][0]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_OVERRIDE_SEG1_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 0) {
   conditions_satisfied = (xed3_operand_get_mode(xes) == 0);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][1]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_OVERRIDE_SEG1_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 0) {
   conditions_satisfied = (xed3_operand_get_mode(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][2]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_OVERRIDE_SEG1_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 0) {
   conditions_satisfied = (xed3_operand_get_mode(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][3]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_OVERRIDE_SEG1_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 0) {
   conditions_satisfied = (xed3_operand_get_mode(xes) == 2);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][4]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_OVERRIDE_SEG1_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 0) {
   conditions_satisfied = (xed3_operand_get_mode(xes) == 2);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][5]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_OVERRIDE_SEG1_BIND(xes);
       if (okay) return 1;
   }
     }
   return 0;
   (void) okay;
   (void) conditions_satisfied;
   (void) xes;
}
xed_bool_t xed_encode_group_87(xed_encoder_request_t* xes)
{
   xed_bool_t okay=1;
   xed_bool_t conditions_satisfied=0;
   xed_ptrn_func_ptr_t fb_ptrn_function;
   static const xed_uint16_t iform_ids[2][1] = {
   /*INCSSPD       */    { 494,},
   /*RDSSPD        */    {3919,},
   };
   xed_uint8_t iclass_index = xed_encoder_get_iclasses_index_in_group(xes);
   if (xes->_n_operand_order == 1 && xes->_operand_order[0] == XED_OPERAND_REG0) {
   conditions_satisfied = xed_encode_ntluf_GPR32_B(xes,xed3_operand_get_reg0(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][0]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   return 0;
   (void) okay;
   (void) conditions_satisfied;
   (void) xes;
}
xed_bool_t xed_encode_group_88(xed_encoder_request_t* xes)
{
   xed_bool_t okay=1;
   xed_bool_t conditions_satisfied=0;
   xed_ptrn_func_ptr_t fb_ptrn_function;
   static const xed_uint16_t iform_ids[12][1] = {
   /*KNOTB         */    {2686,},
   /*KNOTD         */    {1678,},
   /*KNOTQ         */    { 495,},
   /*KNOTW         */    {3297,},
   /*KORTESTB      */    {5097,},
   /*KORTESTD      */    {2477,},
   /*KORTESTQ      */    {4305,},
   /*KORTESTW      */    {1598,},
   /*KTESTB        */    {3690,},
   /*KTESTD        */    {2726,},
   /*KTESTQ        */    { 647,},
   /*KTESTW        */    {1829,},
   };
   xed_uint8_t iclass_index = xed_encoder_get_iclasses_index_in_group(xes);
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_REG1) {
   conditions_satisfied = (xed3_operand_get_must_use_evex(xes) == 0) &&
		 xed_encode_ntluf_MASK_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK_B(xes,xed3_operand_get_reg1(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][0]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   return 0;
   (void) okay;
   (void) conditions_satisfied;
   (void) xes;
}
xed_bool_t xed_encode_group_89(xed_encoder_request_t* xes)
{
   xed_bool_t okay=1;
   xed_bool_t conditions_satisfied=0;
   xed_ptrn_func_ptr_t fb_ptrn_function;
   static const xed_uint16_t iform_ids[5][3] = {
   /*VFIXUPIMMSS   */    {6403,6402,6404,},
   /*VGETMANTSS    */    {5053,5052,5054,},
   /*VRANGESS      */    {4525,4524,4526,},
   /*VREDUCESS     */    { 500, 499, 501,},
   /*VRNDSCALESS   */    {3565,3564,3566,},
   };
   xed_uint8_t iclass_index = xed_encoder_get_iclasses_index_in_group(xes);
   if (xes->_n_operand_order == 5 && memcmp(xed_encode_order[18], xes->_operand_order, sizeof(xed_uint8_t)*5)==0) {
   conditions_satisfied = (xed3_operand_get_sae(xes) != 0) &&
		 xed_encode_ntluf_XMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_XMM_N3(xes,xed3_operand_get_reg2(xes)) &&
		 xed_encode_ntluf_XMM_B3(xes,xed3_operand_get_reg3(xes)) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][0]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_FIX_ROUND_LEN128_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_SAE_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_UIMM8_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 5 && memcmp(xed_encode_order[18], xes->_operand_order, sizeof(xed_uint8_t)*5)==0) {
   conditions_satisfied = xed_encode_ntluf_XMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_XMM_N3(xes,xed3_operand_get_reg2(xes)) &&
		 xed_encode_ntluf_XMM_B3(xes,xed3_operand_get_reg3(xes)) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][1]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_UIMM8_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 5 && memcmp(xed_encode_order[19], xes->_operand_order, sizeof(xed_uint8_t)*5)==0) {
   conditions_satisfied = xed_encode_ntluf_XMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_XMM_N3(xes,xed3_operand_get_reg2(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_D) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][2]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_UIMM8_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_32_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_SCALAR_BIND(xes);
       if (okay) return 1;
   }
     }
   return 0;
   (void) okay;
   (void) conditions_satisfied;
   (void) xes;
}
xed_bool_t xed_encode_group_90(xed_encoder_request_t* xes)
{
   xed_bool_t okay=1;
   xed_bool_t conditions_satisfied=0;
   xed_ptrn_func_ptr_t fb_ptrn_function;
   static const xed_uint16_t iform_ids[2][10] = {
   /*VPCMPEQD      */    {6150,6152,6149,6151,6155,6157,6153,6156,6158,6154,},
   /*VPCMPGTD      */    { 505, 507, 504, 506, 510, 512, 508, 511, 513, 509,},
   };
   xed_uint8_t iclass_index = xed_encoder_get_iclasses_index_in_group(xes);
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[7], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 (xed3_operand_get_must_use_evex(xes) == 0) &&
		 xed_encode_ntluf_XMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_XMM_N(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_XMM_B(xes,xed3_operand_get_reg2(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][0]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[7], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 1) &&
		 (xed3_operand_get_must_use_evex(xes) == 0) &&
		 xed_encode_ntluf_YMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_YMM_N(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_YMM_B(xes,xed3_operand_get_reg2(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][1]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[14], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 (xed3_operand_get_must_use_evex(xes) == 0) &&
		 xed_encode_ntluf_XMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_XMM_N(xes,xed3_operand_get_reg1(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_DQ);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][2]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[14], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 1) &&
		 (xed3_operand_get_must_use_evex(xes) == 0) &&
		 xed_encode_ntluf_YMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_YMM_N(xes,xed3_operand_get_reg1(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_QQ);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][3]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 4 && memcmp(xed_encode_order[12], xes->_operand_order, sizeof(xed_uint8_t)*4)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 xed_encode_ntluf_MASK_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_XMM_N3(xes,xed3_operand_get_reg2(xes)) &&
		 xed_encode_ntluf_XMM_B3(xes,xed3_operand_get_reg3(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][4]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 4 && memcmp(xed_encode_order[12], xes->_operand_order, sizeof(xed_uint8_t)*4)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 1) &&
		 xed_encode_ntluf_MASK_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_YMM_N3(xes,xed3_operand_get_reg2(xes)) &&
		 xed_encode_ntluf_YMM_B3(xes,xed3_operand_get_reg3(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][5]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 4 && memcmp(xed_encode_order[12], xes->_operand_order, sizeof(xed_uint8_t)*4)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 2) &&
		 xed_encode_ntluf_MASK_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_ZMM_N3(xes,xed3_operand_get_reg2(xes)) &&
		 xed_encode_ntluf_ZMM_B3(xes,xed3_operand_get_reg3(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][6]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 4 && memcmp(xed_encode_order[13], xes->_operand_order, sizeof(xed_uint8_t)*4)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 xed_encode_ntluf_MASK_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_XMM_N3(xes,xed3_operand_get_reg2(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_VV);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][7]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_32_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_FULL_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 4 && memcmp(xed_encode_order[13], xes->_operand_order, sizeof(xed_uint8_t)*4)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 1) &&
		 xed_encode_ntluf_MASK_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_YMM_N3(xes,xed3_operand_get_reg2(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_VV);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][8]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_32_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_FULL_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 4 && memcmp(xed_encode_order[13], xes->_operand_order, sizeof(xed_uint8_t)*4)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 2) &&
		 xed_encode_ntluf_MASK_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_ZMM_N3(xes,xed3_operand_get_reg2(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_VV);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][9]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_32_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_FULL_BIND(xes);
       if (okay) return 1;
   }
     }
   return 0;
   (void) okay;
   (void) conditions_satisfied;
   (void) xes;
}
xed_bool_t xed_encode_group_91(xed_encoder_request_t* xes)
{
   xed_bool_t okay=1;
   xed_bool_t conditions_satisfied=0;
   xed_ptrn_func_ptr_t fb_ptrn_function;
   static const xed_uint16_t iform_ids[2][2] = {
   /*VMOVHLPS      */    {1636,1637,},
   /*VMOVLHPS      */    { 518, 519,},
   };
   xed_uint8_t iclass_index = xed_encoder_get_iclasses_index_in_group(xes);
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[7], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 (xed3_operand_get_must_use_evex(xes) == 0) &&
		 xed_encode_ntluf_XMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_XMM_N(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_XMM_B(xes,xed3_operand_get_reg2(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][0]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[7], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 xed_encode_ntluf_XMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_XMM_N3(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_XMM_B3(xes,xed3_operand_get_reg2(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][1]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   return 0;
   (void) okay;
   (void) conditions_satisfied;
   (void) xes;
}
xed_bool_t xed_encode_group_92(xed_encoder_request_t* xes)
{
   xed_bool_t okay=1;
   xed_bool_t conditions_satisfied=0;
   xed_ptrn_func_ptr_t fb_ptrn_function;
   static const xed_uint16_t iform_ids[6][2] = {
   /*ADDSUBPS      */    {2066,2065,},
   /*CVTTPS2DQ     */    {4807,4806,},
   /*HADDPS        */    { 521, 520,},
   /*HSUBPS        */    {2836,2835,},
   /*MOVSHDUP      */    {6064,6063,},
   /*MOVSLDUP      */    {4313,4312,},
   };
   xed_uint8_t iclass_index = xed_encoder_get_iclasses_index_in_group(xes);
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_REG1) {
   conditions_satisfied = xed_encode_ntluf_XMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_XMM_B(xes,xed3_operand_get_reg1(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][0]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_IGNORE66_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_MEM0) {
   conditions_satisfied = xed_encode_ntluf_XMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_PS);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][1]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_IGNORE66_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay) return 1;
   }
     }
   return 0;
   (void) okay;
   (void) conditions_satisfied;
   (void) xes;
}
xed_bool_t xed_encode_group_93(xed_encoder_request_t* xes)
{
   xed_bool_t okay=1;
   xed_bool_t conditions_satisfied=0;
   xed_ptrn_func_ptr_t fb_ptrn_function;
   static const xed_uint16_t iform_ids[1][1] = {
   /*INVLPGA       */    { 522,},
   };
   xed_uint8_t iclass_index = xed_encoder_get_iclasses_index_in_group(xes);
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_REG1) {
   conditions_satisfied = xed_encode_ntluf_ArAX(xes,xed3_operand_get_reg0(xes)) &&
		 (xed3_operand_get_reg1(xes) == XED_REG_ECX);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][0]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   return 0;
   (void) okay;
   (void) conditions_satisfied;
   (void) xes;
}
xed_bool_t xed_encode_group_94(xed_encoder_request_t* xes)
{
   xed_bool_t okay=1;
   xed_bool_t conditions_satisfied=0;
   xed_ptrn_func_ptr_t fb_ptrn_function;
   static const xed_uint16_t iform_ids[1][3] = {
   /*WBINVD        */    { 525, 526, 527,},
   };
   xed_uint8_t iclass_index = xed_encoder_get_iclasses_index_in_group(xes);
   if (xes->_n_operand_order == 0) {
   conditions_satisfied = 1;
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][0]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 0) {
   conditions_satisfied = 1;
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][1]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 0) {
   conditions_satisfied = 1;
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][2]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   return 0;
   (void) okay;
   (void) conditions_satisfied;
   (void) xes;
}
xed_bool_t xed_encode_group_95(xed_encoder_request_t* xes)
{
   xed_bool_t okay=1;
   xed_bool_t conditions_satisfied=0;
   xed_ptrn_func_ptr_t fb_ptrn_function;
   static const xed_uint16_t iform_ids[3][2] = {
   /*PCMPESTRI64   */    {3863,3862,},
   /*PCMPESTRM64   */    { 829, 828,},
   /*PCMPISTRI64   */    { 529, 528,},
   };
   xed_uint8_t iclass_index = xed_encoder_get_iclasses_index_in_group(xes);
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[15], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_mode(xes) == 2) &&
		 xed_encode_ntluf_XMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_XMM_B(xes,xed3_operand_get_reg1(xes)) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][0]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_IMMUNE66_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_UIMM8_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[20], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_mode(xes) == 2) &&
		 xed_encode_ntluf_XMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_DQ) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][1]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_IMMUNE66_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_UIMM8_BIND(xes);
       if (okay) return 1;
   }
     }
   return 0;
   (void) okay;
   (void) conditions_satisfied;
   (void) xes;
}
xed_bool_t xed_encode_group_96(xed_encoder_request_t* xes)
{
   xed_bool_t okay=1;
   xed_bool_t conditions_satisfied=0;
   xed_ptrn_func_ptr_t fb_ptrn_function;
   static const xed_uint16_t iform_ids[7][1] = {
   /*AAA           */    { 531,},
   /*AAS           */    {3039,},
   /*DAA           */    {5294,},
   /*DAS           */    {4811,},
   /*INTO          */    {2707,},
   /*SALC          */    {4603,},
   /*SYSRET_AMD    */    {3105,},
   };
   xed_uint8_t iclass_index = xed_encoder_get_iclasses_index_in_group(xes);
   if (xes->_n_operand_order == 0) {
   conditions_satisfied = (xed3_operand_get_mode(xes) != 2);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][0]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   return 0;
   (void) okay;
   (void) conditions_satisfied;
   (void) xes;
}
xed_bool_t xed_encode_group_97(xed_encoder_request_t* xes)
{
   xed_bool_t okay=1;
   xed_bool_t conditions_satisfied=0;
   xed_ptrn_func_ptr_t fb_ptrn_function;
   static const xed_uint16_t iform_ids[2][4] = {
   /*VMOVHPS       */    {4606,4605,4608,4607,},
   /*VMOVLPS       */    { 533, 532, 535, 534,},
   };
   xed_uint8_t iclass_index = xed_encoder_get_iclasses_index_in_group(xes);
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_MEM0 && xes->_operand_order[1] == XED_OPERAND_REG0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 (xed3_operand_get_must_use_evex(xes) == 0) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_Q) &&
		 xed_encode_ntluf_XMM_R(xes,xed3_operand_get_reg0(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][0]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[14], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 (xed3_operand_get_must_use_evex(xes) == 0) &&
		 xed_encode_ntluf_XMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_XMM_N(xes,xed3_operand_get_reg1(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_Q);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][1]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_MEM0 && xes->_operand_order[1] == XED_OPERAND_REG0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_Q) &&
		 xed_encode_ntluf_XMM_R3(xes,xed3_operand_get_reg0(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][2]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_32_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_TUPLE2_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[14], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 xed_encode_ntluf_XMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_XMM_N3(xes,xed3_operand_get_reg1(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_Q);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][3]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_32_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_TUPLE2_BIND(xes);
       if (okay) return 1;
   }
     }
   return 0;
   (void) okay;
   (void) conditions_satisfied;
   (void) xes;
}
xed_bool_t xed_encode_group_98(xed_encoder_request_t* xes)
{
   xed_bool_t okay=1;
   xed_bool_t conditions_satisfied=0;
   xed_ptrn_func_ptr_t fb_ptrn_function;
   static const xed_uint16_t iform_ids[4][2] = {
   /*ANDNPS        */    {2444,2443,},
   /*ANDPS         */    {2970,2969,},
   /*ORPS          */    {3309,3308,},
   /*XORPS         */    { 537, 536,},
   };
   xed_uint8_t iclass_index = xed_encoder_get_iclasses_index_in_group(xes);
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_REG1) {
   conditions_satisfied = xed_encode_ntluf_XMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_XMM_B(xes,xed3_operand_get_reg1(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][0]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_MEM0) {
   conditions_satisfied = xed_encode_ntluf_XMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_XUD);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][1]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay) return 1;
   }
     }
   return 0;
   (void) okay;
   (void) conditions_satisfied;
   (void) xes;
}
xed_bool_t xed_encode_group_99(xed_encoder_request_t* xes)
{
   xed_bool_t okay=1;
   xed_bool_t conditions_satisfied=0;
   xed_ptrn_func_ptr_t fb_ptrn_function;
   static const xed_uint16_t iform_ids[1][7] = {
   /*VCVTTPD2UDQ   */    { 539, 541, 543, 538, 542, 544, 540,},
   };
   xed_uint8_t iclass_index = xed_encoder_get_iclasses_index_in_group(xes);
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[7], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_sae(xes) != 0) &&
		 xed_encode_ntluf_YMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_ZMM_B3(xes,xed3_operand_get_reg2(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][0]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_FIX_ROUND_LEN512_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_SAE_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[7], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 xed_encode_ntluf_XMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_XMM_B3(xes,xed3_operand_get_reg2(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][1]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[7], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 1) &&
		 xed_encode_ntluf_XMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_YMM_B3(xes,xed3_operand_get_reg2(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][2]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[7], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 2) &&
		 xed_encode_ntluf_YMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_ZMM_B3(xes,xed3_operand_get_reg2(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][3]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[14], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 xed_encode_ntluf_XMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_VV);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][4]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_64_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_FULL_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[14], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 1) &&
		 xed_encode_ntluf_XMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_VV);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][5]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_64_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_FULL_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[14], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 2) &&
		 xed_encode_ntluf_YMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_VV);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][6]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_64_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_FULL_BIND(xes);
       if (okay) return 1;
   }
     }
   return 0;
   (void) okay;
   (void) conditions_satisfied;
   (void) xes;
}
xed_bool_t xed_encode_group_100(xed_encoder_request_t* xes)
{
   xed_bool_t okay=1;
   xed_bool_t conditions_satisfied=0;
   xed_ptrn_func_ptr_t fb_ptrn_function;
   static const xed_uint16_t iform_ids[1][3] = {
   /*FILD          */    { 547, 546, 545,},
   };
   xed_uint8_t iclass_index = xed_encoder_get_iclasses_index_in_group(xes);
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_MEM0) {
   conditions_satisfied = (xed3_operand_get_reg0(xes) == XED_REG_ST0) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_M64INT);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][0]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_MEM0) {
   conditions_satisfied = (xed3_operand_get_reg0(xes) == XED_REG_ST0) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_MEM16INT);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][1]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_MEM0) {
   conditions_satisfied = (xed3_operand_get_reg0(xes) == XED_REG_ST0) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_MEM32INT);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][2]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay) return 1;
   }
     }
   return 0;
   (void) okay;
   (void) conditions_satisfied;
   (void) xes;
}
xed_bool_t xed_encode_group_101(xed_encoder_request_t* xes)
{
   xed_bool_t okay=1;
   xed_bool_t conditions_satisfied=0;
   xed_ptrn_func_ptr_t fb_ptrn_function;
   static const xed_uint16_t iform_ids[3][6] = {
   /*REP_LODSD     */    { 548, 551, 549, 552, 550, 553,},
   /*REP_LODSW     */    {5799,5802,5800,5803,5801,5804,},
   /*REP_OUTSW     */    {2469,2472,2470,2473,2471,2474,},
   };
   xed_uint8_t iclass_index = xed_encoder_get_iclasses_index_in_group(xes);
   if (xes->_n_operand_order == 0) {
   conditions_satisfied = (xed3_operand_get_mode(xes) == 0);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][0]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_OVERRIDE_SEG0_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 0) {
   conditions_satisfied = (xed3_operand_get_mode(xes) == 0);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][1]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_OVERRIDE_SEG0_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 0) {
   conditions_satisfied = (xed3_operand_get_mode(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][2]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_OVERRIDE_SEG0_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 0) {
   conditions_satisfied = (xed3_operand_get_mode(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][3]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_OVERRIDE_SEG0_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 0) {
   conditions_satisfied = (xed3_operand_get_mode(xes) == 2);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][4]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_OVERRIDE_SEG0_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 0) {
   conditions_satisfied = (xed3_operand_get_mode(xes) == 2);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][5]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_OVERRIDE_SEG0_BIND(xes);
       if (okay) return 1;
   }
     }
   return 0;
   (void) okay;
   (void) conditions_satisfied;
   (void) xes;
}
xed_bool_t xed_encode_group_102(xed_encoder_request_t* xes)
{
   xed_bool_t okay=1;
   xed_bool_t conditions_satisfied=0;
   xed_ptrn_func_ptr_t fb_ptrn_function;
   static const xed_uint16_t iform_ids[4][4] = {
   /*BT            */    {6111,6110,6109,6108,},
   /*BTC           */    {5708,5707,5706,5705,},
   /*BTR           */    { 578, 577, 576, 575,},
   /*BTS           */    { 973, 972, 971, 970,},
   };
   xed_uint8_t iclass_index = xed_encoder_get_iclasses_index_in_group(xes);
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_REG1) {
   conditions_satisfied = xed_encode_ntluf_GPRv_B(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_GPRv_R(xes,xed3_operand_get_reg1(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][0]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_MEM0 && xes->_operand_order[1] == XED_OPERAND_REG0) {
   conditions_satisfied = (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_V) &&
		 xed_encode_ntluf_GPRv_R(xes,xed3_operand_get_reg0(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][1]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_IMM0) {
   conditions_satisfied = xed_encode_ntluf_GPRv_B(xes,xed3_operand_get_reg0(xes)) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][2]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_UIMM8_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_MEM0 && xes->_operand_order[1] == XED_OPERAND_IMM0) {
   conditions_satisfied = (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_V) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][3]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_UIMM8_BIND(xes);
       if (okay) return 1;
   }
     }
   return 0;
   (void) okay;
   (void) conditions_satisfied;
   (void) xes;
}
xed_bool_t xed_encode_group_103(xed_encoder_request_t* xes)
{
   xed_bool_t okay=1;
   xed_bool_t conditions_satisfied=0;
   xed_ptrn_func_ptr_t fb_ptrn_function;
   static const xed_uint16_t iform_ids[1][2] = {
   /*VLDDQU        */    { 586, 587,},
   };
   xed_uint8_t iclass_index = xed_encoder_get_iclasses_index_in_group(xes);
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_MEM0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 (xed3_operand_get_must_use_evex(xes) == 0) &&
		 xed_encode_ntluf_XMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_DQ);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][0]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_MEM0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 1) &&
		 (xed3_operand_get_must_use_evex(xes) == 0) &&
		 xed_encode_ntluf_YMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_QQ);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][1]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay) return 1;
   }
     }
   return 0;
   (void) okay;
   (void) conditions_satisfied;
   (void) xes;
}
xed_bool_t xed_encode_group_104(xed_encoder_request_t* xes)
{
   xed_bool_t okay=1;
   xed_bool_t conditions_satisfied=0;
   xed_ptrn_func_ptr_t fb_ptrn_function;
   static const xed_uint16_t iform_ids[4][4] = {
   /*VMASKMOVPD    */    { 594, 592, 595, 593,},
   /*VMASKMOVPS    */    {2462,2460,2463,2461,},
   /*VPMASKMOVD    */    {3174,3172,3175,3173,},
   /*VPMASKMOVQ    */    {6501,6499,6502,6500,},
   };
   xed_uint8_t iclass_index = xed_encoder_get_iclasses_index_in_group(xes);
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[6], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 (xed3_operand_get_must_use_evex(xes) == 0) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_DQ) &&
		 xed_encode_ntluf_XMM_N(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_XMM_R(xes,xed3_operand_get_reg1(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][0]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[14], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 (xed3_operand_get_must_use_evex(xes) == 0) &&
		 xed_encode_ntluf_XMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_XMM_N(xes,xed3_operand_get_reg1(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_DQ);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][1]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[6], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 1) &&
		 (xed3_operand_get_must_use_evex(xes) == 0) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_QQ) &&
		 xed_encode_ntluf_YMM_N(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_YMM_R(xes,xed3_operand_get_reg1(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][2]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[14], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 1) &&
		 (xed3_operand_get_must_use_evex(xes) == 0) &&
		 xed_encode_ntluf_YMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_YMM_N(xes,xed3_operand_get_reg1(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_QQ);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][3]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay) return 1;
   }
     }
   return 0;
   (void) okay;
   (void) conditions_satisfied;
   (void) xes;
}
xed_bool_t xed_encode_group_105(xed_encoder_request_t* xes)
{
   xed_bool_t okay=1;
   xed_bool_t conditions_satisfied=0;
   xed_ptrn_func_ptr_t fb_ptrn_function;
   static const xed_uint16_t iform_ids[3][5] = {
   /*VCVTSS2SD     */    { 599, 597, 596, 598, 600,},
   /*VMAXSS        */    {4868,4866,4865,4867,4869,},
   /*VMINSS        */    {1316,1314,1313,1315,1317,},
   };
   xed_uint8_t iclass_index = xed_encoder_get_iclasses_index_in_group(xes);
   if (xes->_n_operand_order == 4 && memcmp(xed_encode_order[12], xes->_operand_order, sizeof(xed_uint8_t)*4)==0) {
   conditions_satisfied = (xed3_operand_get_sae(xes) != 0) &&
		 xed_encode_ntluf_XMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_XMM_N3(xes,xed3_operand_get_reg2(xes)) &&
		 xed_encode_ntluf_XMM_B3(xes,xed3_operand_get_reg3(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][0]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_FIX_ROUND_LEN128_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_SAE_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[7], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_must_use_evex(xes) == 0) &&
		 xed_encode_ntluf_XMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_XMM_N(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_XMM_B(xes,xed3_operand_get_reg2(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][1]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[14], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_must_use_evex(xes) == 0) &&
		 xed_encode_ntluf_XMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_XMM_N(xes,xed3_operand_get_reg1(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_D);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][2]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 4 && memcmp(xed_encode_order[12], xes->_operand_order, sizeof(xed_uint8_t)*4)==0) {
   conditions_satisfied = xed_encode_ntluf_XMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_XMM_N3(xes,xed3_operand_get_reg2(xes)) &&
		 xed_encode_ntluf_XMM_B3(xes,xed3_operand_get_reg3(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][3]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 4 && memcmp(xed_encode_order[13], xes->_operand_order, sizeof(xed_uint8_t)*4)==0) {
   conditions_satisfied = xed_encode_ntluf_XMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_XMM_N3(xes,xed3_operand_get_reg2(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_D);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][4]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_32_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_SCALAR_BIND(xes);
       if (okay) return 1;
   }
     }
   return 0;
   (void) okay;
   (void) conditions_satisfied;
   (void) xes;
}
xed_bool_t xed_encode_group_106(xed_encoder_request_t* xes)
{
   xed_bool_t okay=1;
   xed_bool_t conditions_satisfied=0;
   xed_ptrn_func_ptr_t fb_ptrn_function;
   static const xed_uint16_t iform_ids[6][1] = {
   /*CLFLUSH       */    {6990,},
   /*PREFETCHNTA   */    { 601,},
   /*PREFETCHT0    */    {1241,},
   /*PREFETCHT1    */    {5822,},
   /*PREFETCHT2    */    { 645,},
   /*PREFETCH_EXCLUSIVE*/    {6695,},
   };
   xed_uint8_t iclass_index = xed_encoder_get_iclasses_index_in_group(xes);
   if (xes->_n_operand_order == 1 && xes->_operand_order[0] == XED_OPERAND_MEM0) {
   conditions_satisfied = (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_MPREFETCH);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][0]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay) return 1;
   }
     }
   return 0;
   (void) okay;
   (void) conditions_satisfied;
   (void) xes;
}
xed_bool_t xed_encode_group_107(xed_encoder_request_t* xes)
{
   xed_bool_t okay=1;
   xed_bool_t conditions_satisfied=0;
   xed_ptrn_func_ptr_t fb_ptrn_function;
   static const xed_uint16_t iform_ids[1][11] = {
   /*VCVTTPD2DQ    */    { 607, 603, 605, 602, 604, 609, 611, 606, 610, 612, 608,},
   };
   xed_uint8_t iclass_index = xed_encoder_get_iclasses_index_in_group(xes);
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[7], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_sae(xes) != 0) &&
		 xed_encode_ntluf_YMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_ZMM_B3(xes,xed3_operand_get_reg2(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][0]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_FIX_ROUND_LEN512_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_SAE_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_REG1) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 (xed3_operand_get_must_use_evex(xes) == 0) &&
		 xed_encode_ntluf_XMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_XMM_B(xes,xed3_operand_get_reg1(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][1]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_REG1) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 1) &&
		 (xed3_operand_get_must_use_evex(xes) == 0) &&
		 xed_encode_ntluf_XMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_YMM_B(xes,xed3_operand_get_reg1(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][2]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_MEM0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 (xed3_operand_get_must_use_evex(xes) == 0) &&
		 xed_encode_ntluf_XMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_DQ);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][3]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_MEM0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 1) &&
		 (xed3_operand_get_must_use_evex(xes) == 0) &&
		 xed_encode_ntluf_XMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_QQ);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][4]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[7], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 xed_encode_ntluf_XMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_XMM_B3(xes,xed3_operand_get_reg2(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][5]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[7], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 1) &&
		 xed_encode_ntluf_XMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_YMM_B3(xes,xed3_operand_get_reg2(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][6]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[7], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 2) &&
		 xed_encode_ntluf_YMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_ZMM_B3(xes,xed3_operand_get_reg2(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][7]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[14], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 xed_encode_ntluf_XMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_VV);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][8]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_64_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_FULL_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[14], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 1) &&
		 xed_encode_ntluf_XMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_VV);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][9]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_64_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_FULL_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[14], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 2) &&
		 xed_encode_ntluf_YMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_VV);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][10]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_64_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_FULL_BIND(xes);
       if (okay) return 1;
   }
     }
   return 0;
   (void) okay;
   (void) conditions_satisfied;
   (void) xes;
}
xed_bool_t xed_encode_group_108(xed_encoder_request_t* xes)
{
   xed_bool_t okay=1;
   xed_bool_t conditions_satisfied=0;
   xed_ptrn_func_ptr_t fb_ptrn_function;
   static const xed_uint16_t iform_ids[6][4] = {
   /*VBLENDPD      */    {5858,5860,5857,5859,},
   /*VBLENDPS      */    { 614, 616, 613, 615,},
   /*VDPPS         */    { 661, 663, 660, 662,},
   /*VMPSADBW      */    {2204,2206,2203,2205,},
   /*VPBLENDD      */    {5321,5323,5320,5322,},
   /*VPBLENDW      */    {2631,2633,2630,2632,},
   };
   xed_uint8_t iclass_index = xed_encoder_get_iclasses_index_in_group(xes);
   if (xes->_n_operand_order == 4 && memcmp(xed_encode_order[21], xes->_operand_order, sizeof(xed_uint8_t)*4)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 (xed3_operand_get_must_use_evex(xes) == 0) &&
		 xed_encode_ntluf_XMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_XMM_N(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_XMM_B(xes,xed3_operand_get_reg2(xes)) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][0]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_UIMM8_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 4 && memcmp(xed_encode_order[21], xes->_operand_order, sizeof(xed_uint8_t)*4)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 1) &&
		 (xed3_operand_get_must_use_evex(xes) == 0) &&
		 xed_encode_ntluf_YMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_YMM_N(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_YMM_B(xes,xed3_operand_get_reg2(xes)) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][1]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_UIMM8_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 4 && memcmp(xed_encode_order[22], xes->_operand_order, sizeof(xed_uint8_t)*4)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 (xed3_operand_get_must_use_evex(xes) == 0) &&
		 xed_encode_ntluf_XMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_XMM_N(xes,xed3_operand_get_reg1(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_DQ) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][2]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_UIMM8_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 4 && memcmp(xed_encode_order[22], xes->_operand_order, sizeof(xed_uint8_t)*4)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 1) &&
		 (xed3_operand_get_must_use_evex(xes) == 0) &&
		 xed_encode_ntluf_YMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_YMM_N(xes,xed3_operand_get_reg1(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_QQ) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][3]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_UIMM8_BIND(xes);
       if (okay) return 1;
   }
     }
   return 0;
   (void) okay;
   (void) conditions_satisfied;
   (void) xes;
}
xed_bool_t xed_encode_group_109(xed_encoder_request_t* xes)
{
   xed_bool_t okay=1;
   xed_bool_t conditions_satisfied=0;
   xed_ptrn_func_ptr_t fb_ptrn_function;
   static const xed_uint16_t iform_ids[1][2] = {
   /*REP_LODSQ     */    { 617, 618,},
   };
   xed_uint8_t iclass_index = xed_encoder_get_iclasses_index_in_group(xes);
   if (xes->_n_operand_order == 0) {
   conditions_satisfied = (xed3_operand_get_mode(xes) == 2);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][0]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_OVERRIDE_SEG0_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 0) {
   conditions_satisfied = (xed3_operand_get_mode(xes) == 2);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][1]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_OVERRIDE_SEG0_BIND(xes);
       if (okay) return 1;
   }
     }
   return 0;
   (void) okay;
   (void) conditions_satisfied;
   (void) xes;
}
xed_bool_t xed_encode_group_110(xed_encoder_request_t* xes)
{
   xed_bool_t okay=1;
   xed_bool_t conditions_satisfied=0;
   xed_ptrn_func_ptr_t fb_ptrn_function;
   static const xed_uint16_t iform_ids[20][10] = {
   /*VANDNPS       */    {5759,5761,5758,5760,5762,5764,5766,5763,5765,5767,},
   /*VANDPS        */    {1489,1491,1488,1490,1492,1494,1496,1493,1495,1497,},
   /*VORPS         */    {6715,6717,6714,6716,6718,6720,6722,6719,6721,6723,},
   /*VPACKSSDW     */    {3284,3286,3283,3285,3287,3289,3291,3288,3290,3292,},
   /*VPACKUSDW     */    {2226,2228,2225,2227,2229,2231,2233,2230,2232,2234,},
   /*VPADDD        */    {4162,4164,4161,4163,4167,4169,4165,4168,4170,4166,},
   /*VPMAXSD       */    {5249,5251,5248,5250,5254,5256,5252,5255,5257,5253,},
   /*VPMAXUD       */    {6823,6825,6822,6824,6828,6830,6826,6829,6831,6827,},
   /*VPMINSD       */    {4974,4976,4973,4975,4979,4981,4977,4980,4982,4978,},
   /*VPMINUD       */    {1776,1778,1775,1777,1781,1783,1779,1782,1784,1780,},
   /*VPMULLD       */    {1669,1671,1668,1670,1674,1676,1672,1675,1677,1673,},
   /*VPSLLVD       */    {4575,4577,4574,4576,4580,4582,4578,4581,4583,4579,},
   /*VPSRAVD       */    {2167,2169,2166,2168,2172,2174,2170,2173,2175,2171,},
   /*VPSRLVD       */    {5236,5238,5235,5237,5241,5243,5239,5242,5244,5240,},
   /*VPSUBD        */    {4997,4999,4996,4998,5002,5004,5000,5003,5005,5001,},
   /*VPUNPCKHDQ    */    {5414,5416,5413,5415,5419,5421,5417,5420,5422,5418,},
   /*VPUNPCKLDQ    */    { 620, 622, 619, 621, 625, 627, 623, 626, 628, 624,},
   /*VUNPCKHPS     */    {6768,6770,6767,6769,6773,6775,6771,6774,6776,6772,},
   /*VUNPCKLPS     */    {3343,3345,3342,3344,3348,3350,3346,3349,3351,3347,},
   /*VXORPS        */    {1479,1481,1478,1480,1482,1484,1486,1483,1485,1487,},
   };
   xed_uint8_t iclass_index = xed_encoder_get_iclasses_index_in_group(xes);
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[7], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 (xed3_operand_get_must_use_evex(xes) == 0) &&
		 xed_encode_ntluf_XMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_XMM_N(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_XMM_B(xes,xed3_operand_get_reg2(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][0]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[7], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 1) &&
		 (xed3_operand_get_must_use_evex(xes) == 0) &&
		 xed_encode_ntluf_YMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_YMM_N(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_YMM_B(xes,xed3_operand_get_reg2(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][1]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[14], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 (xed3_operand_get_must_use_evex(xes) == 0) &&
		 xed_encode_ntluf_XMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_XMM_N(xes,xed3_operand_get_reg1(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_DQ);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][2]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[14], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 1) &&
		 (xed3_operand_get_must_use_evex(xes) == 0) &&
		 xed_encode_ntluf_YMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_YMM_N(xes,xed3_operand_get_reg1(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_QQ);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][3]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 4 && memcmp(xed_encode_order[12], xes->_operand_order, sizeof(xed_uint8_t)*4)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 xed_encode_ntluf_XMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_XMM_N3(xes,xed3_operand_get_reg2(xes)) &&
		 xed_encode_ntluf_XMM_B3(xes,xed3_operand_get_reg3(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][4]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 4 && memcmp(xed_encode_order[12], xes->_operand_order, sizeof(xed_uint8_t)*4)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 1) &&
		 xed_encode_ntluf_YMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_YMM_N3(xes,xed3_operand_get_reg2(xes)) &&
		 xed_encode_ntluf_YMM_B3(xes,xed3_operand_get_reg3(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][5]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 4 && memcmp(xed_encode_order[12], xes->_operand_order, sizeof(xed_uint8_t)*4)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 2) &&
		 xed_encode_ntluf_ZMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_ZMM_N3(xes,xed3_operand_get_reg2(xes)) &&
		 xed_encode_ntluf_ZMM_B3(xes,xed3_operand_get_reg3(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][6]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 4 && memcmp(xed_encode_order[13], xes->_operand_order, sizeof(xed_uint8_t)*4)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 xed_encode_ntluf_XMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_XMM_N3(xes,xed3_operand_get_reg2(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_VV);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][7]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_32_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_FULL_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 4 && memcmp(xed_encode_order[13], xes->_operand_order, sizeof(xed_uint8_t)*4)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 1) &&
		 xed_encode_ntluf_YMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_YMM_N3(xes,xed3_operand_get_reg2(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_VV);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][8]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_32_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_FULL_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 4 && memcmp(xed_encode_order[13], xes->_operand_order, sizeof(xed_uint8_t)*4)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 2) &&
		 xed_encode_ntluf_ZMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_ZMM_N3(xes,xed3_operand_get_reg2(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_VV);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][9]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_32_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_FULL_BIND(xes);
       if (okay) return 1;
   }
     }
   return 0;
   (void) okay;
   (void) conditions_satisfied;
   (void) xes;
}
xed_bool_t xed_encode_group_111(xed_encoder_request_t* xes)
{
   xed_bool_t okay=1;
   xed_bool_t conditions_satisfied=0;
   xed_ptrn_func_ptr_t fb_ptrn_function;
   static const xed_uint16_t iform_ids[2][1] = {
   /*FLDCW         */    {1855,},
   /*FNSTCW        */    { 643,},
   };
   xed_uint8_t iclass_index = xed_encoder_get_iclasses_index_in_group(xes);
   if (xes->_n_operand_order == 1 && xes->_operand_order[0] == XED_OPERAND_MEM0) {
   conditions_satisfied = (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_MEM16);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][0]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay) return 1;
   }
     }
   return 0;
   (void) okay;
   (void) conditions_satisfied;
   (void) xes;
}
xed_bool_t xed_encode_group_112(xed_encoder_request_t* xes)
{
   xed_bool_t okay=1;
   xed_bool_t conditions_satisfied=0;
   xed_ptrn_func_ptr_t fb_ptrn_function;
   static const xed_uint16_t iform_ids[2][7] = {
   /*VFIXUPIMMPD   */    {5640,5642,5644,5639,5643,5645,5641,},
   /*VRANGEPD      */    { 654, 649, 651, 653, 650, 652, 655,},
   };
   xed_uint8_t iclass_index = xed_encoder_get_iclasses_index_in_group(xes);
   if (xes->_n_operand_order == 5 && memcmp(xed_encode_order[18], xes->_operand_order, sizeof(xed_uint8_t)*5)==0) {
   conditions_satisfied = (xed3_operand_get_sae(xes) != 0) &&
		 xed_encode_ntluf_ZMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_ZMM_N3(xes,xed3_operand_get_reg2(xes)) &&
		 xed_encode_ntluf_ZMM_B3(xes,xed3_operand_get_reg3(xes)) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][0]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_FIX_ROUND_LEN512_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_SAE_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_UIMM8_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 5 && memcmp(xed_encode_order[18], xes->_operand_order, sizeof(xed_uint8_t)*5)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 xed_encode_ntluf_XMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_XMM_N3(xes,xed3_operand_get_reg2(xes)) &&
		 xed_encode_ntluf_XMM_B3(xes,xed3_operand_get_reg3(xes)) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][1]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_UIMM8_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 5 && memcmp(xed_encode_order[18], xes->_operand_order, sizeof(xed_uint8_t)*5)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 1) &&
		 xed_encode_ntluf_YMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_YMM_N3(xes,xed3_operand_get_reg2(xes)) &&
		 xed_encode_ntluf_YMM_B3(xes,xed3_operand_get_reg3(xes)) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][2]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_UIMM8_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 5 && memcmp(xed_encode_order[18], xes->_operand_order, sizeof(xed_uint8_t)*5)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 2) &&
		 xed_encode_ntluf_ZMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_ZMM_N3(xes,xed3_operand_get_reg2(xes)) &&
		 xed_encode_ntluf_ZMM_B3(xes,xed3_operand_get_reg3(xes)) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][3]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_UIMM8_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 5 && memcmp(xed_encode_order[19], xes->_operand_order, sizeof(xed_uint8_t)*5)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 xed_encode_ntluf_XMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_XMM_N3(xes,xed3_operand_get_reg2(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_VV) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][4]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_UIMM8_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_64_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_FULL_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 5 && memcmp(xed_encode_order[19], xes->_operand_order, sizeof(xed_uint8_t)*5)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 1) &&
		 xed_encode_ntluf_YMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_YMM_N3(xes,xed3_operand_get_reg2(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_VV) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][5]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_UIMM8_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_64_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_FULL_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 5 && memcmp(xed_encode_order[19], xes->_operand_order, sizeof(xed_uint8_t)*5)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 2) &&
		 xed_encode_ntluf_ZMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_ZMM_N3(xes,xed3_operand_get_reg2(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_VV) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][6]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_UIMM8_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_64_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_FULL_BIND(xes);
       if (okay) return 1;
   }
     }
   return 0;
   (void) okay;
   (void) conditions_satisfied;
   (void) xes;
}
xed_bool_t xed_encode_group_113(xed_encoder_request_t* xes)
{
   xed_bool_t okay=1;
   xed_bool_t conditions_satisfied=0;
   xed_ptrn_func_ptr_t fb_ptrn_function;
   static const xed_uint16_t iform_ids[2][3] = {
   /*VPSCATTERQD   */    { 677, 678, 676,},
   /*VSCATTERQPS   */    {2566,2567,2565,},
   };
   xed_uint8_t iclass_index = xed_encoder_get_iclasses_index_in_group(xes);
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[6], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 (xed3_operand_get_easz(xes) != 1) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_D) &&
		 xed_encode_ntluf_MASKNOT0(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_XMM_R3(xes,xed3_operand_get_reg1(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][0]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_UISA_VMODRM_XMM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_32_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_GSCAT_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[6], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 1) &&
		 (xed3_operand_get_easz(xes) != 1) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_D) &&
		 xed_encode_ntluf_MASKNOT0(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_XMM_R3(xes,xed3_operand_get_reg1(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][1]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_UISA_VMODRM_YMM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_32_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_GSCAT_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[6], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 2) &&
		 (xed3_operand_get_easz(xes) != 1) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_D) &&
		 xed_encode_ntluf_MASKNOT0(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_YMM_R3(xes,xed3_operand_get_reg1(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][2]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_UISA_VMODRM_ZMM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_32_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_GSCAT_BIND(xes);
       if (okay) return 1;
   }
     }
   return 0;
   (void) okay;
   (void) conditions_satisfied;
   (void) xes;
}
xed_bool_t xed_encode_group_114(xed_encoder_request_t* xes)
{
   xed_bool_t okay=1;
   xed_bool_t conditions_satisfied=0;
   xed_ptrn_func_ptr_t fb_ptrn_function;
   static const xed_uint16_t iform_ids[2][1] = {
   /*V4FMADDSS     */    { 679,},
   /*V4FNMADDSS    */    {4024,},
   };
   xed_uint8_t iclass_index = xed_encoder_get_iclasses_index_in_group(xes);
   if (xes->_n_operand_order == 4 && memcmp(xed_encode_order[13], xes->_operand_order, sizeof(xed_uint8_t)*4)==0) {
   conditions_satisfied = xed_encode_ntluf_XMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_XMM_N3(xes,xed3_operand_get_reg2(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_DQ);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][0]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_32_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_TUPLE1_4X_BIND(xes);
       if (okay) return 1;
   }
     }
   return 0;
   (void) okay;
   (void) conditions_satisfied;
   (void) xes;
}
xed_bool_t xed_encode_group_115(xed_encoder_request_t* xes)
{
   xed_bool_t okay=1;
   xed_bool_t conditions_satisfied=0;
   xed_ptrn_func_ptr_t fb_ptrn_function;
   static const xed_uint16_t iform_ids[3][6] = {
   /*VDBPSADBW     */    {1723,1725,1727,1724,1726,1728,},
   /*VPSHLDW       */    {1245,1247,1249,1246,1248,1250,},
   /*VPSHRDW       */    { 680, 682, 684, 681, 683, 685,},
   };
   xed_uint8_t iclass_index = xed_encoder_get_iclasses_index_in_group(xes);
   if (xes->_n_operand_order == 5 && memcmp(xed_encode_order[18], xes->_operand_order, sizeof(xed_uint8_t)*5)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 xed_encode_ntluf_XMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_XMM_N3(xes,xed3_operand_get_reg2(xes)) &&
		 xed_encode_ntluf_XMM_B3(xes,xed3_operand_get_reg3(xes)) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][0]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_UIMM8_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 5 && memcmp(xed_encode_order[18], xes->_operand_order, sizeof(xed_uint8_t)*5)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 1) &&
		 xed_encode_ntluf_YMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_YMM_N3(xes,xed3_operand_get_reg2(xes)) &&
		 xed_encode_ntluf_YMM_B3(xes,xed3_operand_get_reg3(xes)) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][1]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_UIMM8_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 5 && memcmp(xed_encode_order[18], xes->_operand_order, sizeof(xed_uint8_t)*5)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 2) &&
		 xed_encode_ntluf_ZMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_ZMM_N3(xes,xed3_operand_get_reg2(xes)) &&
		 xed_encode_ntluf_ZMM_B3(xes,xed3_operand_get_reg3(xes)) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][2]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_UIMM8_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 5 && memcmp(xed_encode_order[19], xes->_operand_order, sizeof(xed_uint8_t)*5)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 xed_encode_ntluf_XMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_XMM_N3(xes,xed3_operand_get_reg2(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_DQ) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][3]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_UIMM8_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_16_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_FULLMEM_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 5 && memcmp(xed_encode_order[19], xes->_operand_order, sizeof(xed_uint8_t)*5)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 1) &&
		 xed_encode_ntluf_YMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_YMM_N3(xes,xed3_operand_get_reg2(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_QQ) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][4]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_UIMM8_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_16_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_FULLMEM_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 5 && memcmp(xed_encode_order[19], xes->_operand_order, sizeof(xed_uint8_t)*5)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 2) &&
		 xed_encode_ntluf_ZMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_ZMM_N3(xes,xed3_operand_get_reg2(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_ZD) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][5]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_UIMM8_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_16_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_FULLMEM_BIND(xes);
       if (okay) return 1;
   }
     }
   return 0;
   (void) okay;
   (void) conditions_satisfied;
   (void) xes;
}
xed_bool_t xed_encode_group_116(xed_encoder_request_t* xes)
{
   xed_bool_t okay=1;
   xed_bool_t conditions_satisfied=0;
   xed_ptrn_func_ptr_t fb_ptrn_function;
   static const xed_uint16_t iform_ids[9][2] = {
   /*ADDPS         */    {4077,4076,},
   /*DIVPS         */    {6955,6954,},
   /*MAXPS         */    {6483,6482,},
   /*MINPS         */    {6876,6875,},
   /*MULPS         */    {6424,6423,},
   /*RCPPS         */    {5967,5966,},
   /*RSQRTPS       */    { 689, 688,},
   /*SQRTPS        */    {4906,4905,},
   /*SUBPS         */    {2920,2919,},
   };
   xed_uint8_t iclass_index = xed_encoder_get_iclasses_index_in_group(xes);
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_REG1) {
   conditions_satisfied = xed_encode_ntluf_XMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_XMM_B(xes,xed3_operand_get_reg1(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][0]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_MEM0) {
   conditions_satisfied = xed_encode_ntluf_XMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_PS);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][1]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay) return 1;
   }
     }
   return 0;
   (void) okay;
   (void) conditions_satisfied;
   (void) xes;
}
xed_bool_t xed_encode_group_117(xed_encoder_request_t* xes)
{
   xed_bool_t okay=1;
   xed_bool_t conditions_satisfied=0;
   xed_ptrn_func_ptr_t fb_ptrn_function;
   static const xed_uint16_t iform_ids[9][3] = {
   /*CMPSD         */    {5734,5735,5736,},
   /*CMPSW         */    {1129,1130,1131,},
   /*LODSD         */    {4826,4827,4828,},
   /*LODSW         */    { 958, 959, 960,},
   /*OUTSW         */    { 690, 691, 692,},
   /*REPE_CMPSD    */    { 863, 864, 865,},
   /*REPE_CMPSW    */    { 786, 787, 788,},
   /*REPNE_CMPSD   */    {3687,3688,3689,},
   /*REPNE_CMPSW   */    {2717,2718,2719,},
   };
   xed_uint8_t iclass_index = xed_encoder_get_iclasses_index_in_group(xes);
   if (xes->_n_operand_order == 0) {
   conditions_satisfied = (xed3_operand_get_mode(xes) == 0);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][0]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_OVERRIDE_SEG0_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 0) {
   conditions_satisfied = (xed3_operand_get_mode(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][1]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_OVERRIDE_SEG0_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 0) {
   conditions_satisfied = (xed3_operand_get_mode(xes) == 2);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][2]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_OVERRIDE_SEG0_BIND(xes);
       if (okay) return 1;
   }
     }
   return 0;
   (void) okay;
   (void) conditions_satisfied;
   (void) xes;
}
xed_bool_t xed_encode_group_118(xed_encoder_request_t* xes)
{
   xed_bool_t okay=1;
   xed_bool_t conditions_satisfied=0;
   xed_ptrn_func_ptr_t fb_ptrn_function;
   static const xed_uint16_t iform_ids[2][10] = {
   /*VPMOVSXWQ     */    {6535,6537,6536,6538,6541,6543,6539,6542,6544,6540,},
   /*VPMOVZXWQ     */    { 741, 743, 742, 744, 747, 749, 745, 748, 750, 746,},
   };
   xed_uint8_t iclass_index = xed_encoder_get_iclasses_index_in_group(xes);
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_REG1) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 (xed3_operand_get_must_use_evex(xes) == 0) &&
		 xed_encode_ntluf_XMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_XMM_B(xes,xed3_operand_get_reg1(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][0]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_REG1) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 1) &&
		 (xed3_operand_get_must_use_evex(xes) == 0) &&
		 xed_encode_ntluf_YMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_XMM_B(xes,xed3_operand_get_reg1(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][1]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_MEM0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 (xed3_operand_get_must_use_evex(xes) == 0) &&
		 xed_encode_ntluf_XMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_D);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][2]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_MEM0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 1) &&
		 (xed3_operand_get_must_use_evex(xes) == 0) &&
		 xed_encode_ntluf_YMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_Q);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][3]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[7], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 xed_encode_ntluf_XMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_XMM_B3(xes,xed3_operand_get_reg2(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][4]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[7], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 1) &&
		 xed_encode_ntluf_YMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_XMM_B3(xes,xed3_operand_get_reg2(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][5]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[7], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 2) &&
		 xed_encode_ntluf_ZMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_XMM_B3(xes,xed3_operand_get_reg2(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][6]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[14], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 xed_encode_ntluf_XMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_D);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][7]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_16_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_QUARTERMEM_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[14], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 1) &&
		 xed_encode_ntluf_YMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_Q);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][8]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_16_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_QUARTERMEM_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[14], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 2) &&
		 xed_encode_ntluf_ZMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_DQ);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][9]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_16_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_QUARTERMEM_BIND(xes);
       if (okay) return 1;
   }
     }
   return 0;
   (void) okay;
   (void) conditions_satisfied;
   (void) xes;
}
xed_bool_t xed_encode_group_119(xed_encoder_request_t* xes)
{
   xed_bool_t okay=1;
   xed_bool_t conditions_satisfied=0;
   xed_ptrn_func_ptr_t fb_ptrn_function;
   static const xed_uint16_t iform_ids[5][6] = {
   /*BEXTR         */    {1229,1230,1232,1227,1228,1231,},
   /*BZHI          */    {1354,1355,1357,1352,1353,1356,},
   /*SARX          */    { 753, 754, 756, 751, 752, 755,},
   /*SHLX          */    {3693,3694,3696,3691,3692,3695,},
   /*SHRX          */    {4652,4653,4655,4650,4651,4654,},
   };
   xed_uint8_t iclass_index = xed_encoder_get_iclasses_index_in_group(xes);
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[7], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_mode(xes) != 2) &&
		 (xed3_operand_get_must_use_evex(xes) == 0) &&
		 xed_encode_ntluf_VGPR32_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_VGPR32_B(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_VGPR32_N(xes,xed3_operand_get_reg2(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][0]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[7], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_mode(xes) == 2) &&
		 (xed3_operand_get_must_use_evex(xes) == 0) &&
		 xed_encode_ntluf_VGPR32_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_VGPR32_B(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_VGPR32_N(xes,xed3_operand_get_reg2(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][1]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[7], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_mode(xes) == 2) &&
		 (xed3_operand_get_must_use_evex(xes) == 0) &&
		 xed_encode_ntluf_VGPR64_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_VGPR64_B(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_VGPR64_N(xes,xed3_operand_get_reg2(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][2]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[24], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_mode(xes) != 2) &&
		 (xed3_operand_get_must_use_evex(xes) == 0) &&
		 xed_encode_ntluf_VGPR32_R(xes,xed3_operand_get_reg0(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_D) &&
		 xed_encode_ntluf_VGPR32_N(xes,xed3_operand_get_reg1(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][3]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[24], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_mode(xes) == 2) &&
		 (xed3_operand_get_must_use_evex(xes) == 0) &&
		 xed_encode_ntluf_VGPR32_R(xes,xed3_operand_get_reg0(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_D) &&
		 xed_encode_ntluf_VGPR32_N(xes,xed3_operand_get_reg1(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][4]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[24], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_mode(xes) == 2) &&
		 (xed3_operand_get_must_use_evex(xes) == 0) &&
		 xed_encode_ntluf_VGPR64_R(xes,xed3_operand_get_reg0(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_Q) &&
		 xed_encode_ntluf_VGPR64_N(xes,xed3_operand_get_reg1(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][5]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay) return 1;
   }
     }
   return 0;
   (void) okay;
   (void) conditions_satisfied;
   (void) xes;
}
xed_bool_t xed_encode_group_120(xed_encoder_request_t* xes)
{
   xed_bool_t okay=1;
   xed_bool_t conditions_satisfied=0;
   xed_ptrn_func_ptr_t fb_ptrn_function;
   static const xed_uint16_t iform_ids[1][1] = {
   /*MOVSQ         */    { 761,},
   };
   xed_uint8_t iclass_index = xed_encoder_get_iclasses_index_in_group(xes);
   if (xes->_n_operand_order == 0) {
   conditions_satisfied = (xed3_operand_get_mode(xes) == 2);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][0]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_OVERRIDE_SEG1_BIND(xes);
       if (okay) return 1;
   }
     }
   return 0;
   (void) okay;
   (void) conditions_satisfied;
   (void) xes;
}
xed_bool_t xed_encode_group_121(xed_encoder_request_t* xes)
{
   xed_bool_t okay=1;
   xed_bool_t conditions_satisfied=0;
   xed_ptrn_func_ptr_t fb_ptrn_function;
   static const xed_uint16_t iform_ids[1][10] = {
   /*VBROADCASTSS  */    { 764, 765, 762, 763, 769, 771, 767, 768, 770, 766,},
   };
   xed_uint8_t iclass_index = xed_encoder_get_iclasses_index_in_group(xes);
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_REG1) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 (xed3_operand_get_must_use_evex(xes) == 0) &&
		 xed_encode_ntluf_XMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_XMM_B(xes,xed3_operand_get_reg1(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][0]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_REG1) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 1) &&
		 (xed3_operand_get_must_use_evex(xes) == 0) &&
		 xed_encode_ntluf_YMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_XMM_B(xes,xed3_operand_get_reg1(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][1]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_MEM0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 (xed3_operand_get_must_use_evex(xes) == 0) &&
		 xed_encode_ntluf_XMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_D);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][2]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_MEM0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 1) &&
		 (xed3_operand_get_must_use_evex(xes) == 0) &&
		 xed_encode_ntluf_YMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_D);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][3]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[7], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 xed_encode_ntluf_XMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_XMM_B3(xes,xed3_operand_get_reg2(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][4]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[7], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 1) &&
		 xed_encode_ntluf_YMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_XMM_B3(xes,xed3_operand_get_reg2(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][5]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[7], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 2) &&
		 xed_encode_ntluf_ZMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_XMM_B3(xes,xed3_operand_get_reg2(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][6]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[14], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 xed_encode_ntluf_XMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_D);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][7]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_32_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_TUPLE1_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[14], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 1) &&
		 xed_encode_ntluf_YMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_D);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][8]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_32_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_TUPLE1_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[14], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 2) &&
		 xed_encode_ntluf_ZMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_D);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][9]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_32_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_TUPLE1_BIND(xes);
       if (okay) return 1;
   }
     }
   return 0;
   (void) okay;
   (void) conditions_satisfied;
   (void) xes;
}
xed_bool_t xed_encode_group_122(xed_encoder_request_t* xes)
{
   xed_bool_t okay=1;
   xed_bool_t conditions_satisfied=0;
   xed_ptrn_func_ptr_t fb_ptrn_function;
   static const xed_uint16_t iform_ids[1][2] = {
   /*PEXTRB        */    { 773, 772,},
   };
   xed_uint8_t iclass_index = xed_encoder_get_iclasses_index_in_group(xes);
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[15], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = xed_encode_ntluf_GPR32_B(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_XMM_R(xes,xed3_operand_get_reg1(xes)) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][0]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_REFINING66_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_UIMM8_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[17], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_B) &&
		 xed_encode_ntluf_XMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][1]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_REFINING66_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_UIMM8_BIND(xes);
       if (okay) return 1;
   }
     }
   return 0;
   (void) okay;
   (void) conditions_satisfied;
   (void) xes;
}
xed_bool_t xed_encode_group_123(xed_encoder_request_t* xes)
{
   xed_bool_t okay=1;
   xed_bool_t conditions_satisfied=0;
   xed_ptrn_func_ptr_t fb_ptrn_function;
   static const xed_uint16_t iform_ids[3][3] = {
   /*VEXP2PS       */    {3027,3026,3028,},
   /*VRCP28PS      */    {5266,5265,5267,},
   /*VRSQRT28PS    */    { 777, 776, 778,},
   };
   xed_uint8_t iclass_index = xed_encoder_get_iclasses_index_in_group(xes);
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[7], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_sae(xes) != 0) &&
		 xed_encode_ntluf_ZMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_ZMM_B3(xes,xed3_operand_get_reg2(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][0]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_FIX_ROUND_LEN512_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_SAE_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[7], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 2) &&
		 xed_encode_ntluf_ZMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_ZMM_B3(xes,xed3_operand_get_reg2(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][1]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[14], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 2) &&
		 xed_encode_ntluf_ZMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_VV);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][2]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_32_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_FULL_BIND(xes);
       if (okay) return 1;
   }
     }
   return 0;
   (void) okay;
   (void) conditions_satisfied;
   (void) xes;
}
xed_bool_t xed_encode_group_124(xed_encoder_request_t* xes)
{
   xed_bool_t okay=1;
   xed_bool_t conditions_satisfied=0;
   xed_ptrn_func_ptr_t fb_ptrn_function;
   static const xed_uint16_t iform_ids[2][2] = {
   /*CALL_FAR      */    { 781, 780,},
   /*JMP_FAR       */    { 861, 860,},
   };
   xed_uint8_t iclass_index = xed_encoder_get_iclasses_index_in_group(xes);
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_PTR && xes->_operand_order[1] == XED_OPERAND_IMM0) {
   conditions_satisfied = (xed3_operand_get_mode(xes) != 2) &&
		 (xed3_operand_get_ptr(xes) == 1) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][0]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_BRDISPz_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_UIMM16_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 1 && xes->_operand_order[0] == XED_OPERAND_MEM0) {
   conditions_satisfied = (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_P2);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][1]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay) return 1;
   }
     }
   return 0;
   (void) okay;
   (void) conditions_satisfied;
   (void) xes;
}
xed_bool_t xed_encode_group_125(xed_encoder_request_t* xes)
{
   xed_bool_t okay=1;
   xed_bool_t conditions_satisfied=0;
   xed_ptrn_func_ptr_t fb_ptrn_function;
   static const xed_uint16_t iform_ids[4][2] = {
   /*PMOVSXBD      */    {3262,3261,},
   /*PMOVSXWQ      */    {4391,4390,},
   /*PMOVZXBD      */    {4289,4288,},
   /*PMOVZXWQ      */    { 783, 782,},
   };
   xed_uint8_t iclass_index = xed_encoder_get_iclasses_index_in_group(xes);
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_REG1) {
   conditions_satisfied = xed_encode_ntluf_XMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_XMM_B(xes,xed3_operand_get_reg1(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][0]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_REFINING66_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_MEM0) {
   conditions_satisfied = xed_encode_ntluf_XMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_D);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][1]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_REFINING66_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay) return 1;
   }
     }
   return 0;
   (void) okay;
   (void) conditions_satisfied;
   (void) xes;
}
xed_bool_t xed_encode_group_126(xed_encoder_request_t* xes)
{
   xed_bool_t okay=1;
   xed_bool_t conditions_satisfied=0;
   xed_ptrn_func_ptr_t fb_ptrn_function;
   static const xed_uint16_t iform_ids[2][2] = {
   /*VRCP14SD      */    { 784, 785,},
   /*VRSQRT14SD    */    {2428,2429,},
   };
   xed_uint8_t iclass_index = xed_encoder_get_iclasses_index_in_group(xes);
   if (xes->_n_operand_order == 4 && memcmp(xed_encode_order[12], xes->_operand_order, sizeof(xed_uint8_t)*4)==0) {
   conditions_satisfied = xed_encode_ntluf_XMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_XMM_N3(xes,xed3_operand_get_reg2(xes)) &&
		 xed_encode_ntluf_XMM_B3(xes,xed3_operand_get_reg3(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][0]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 4 && memcmp(xed_encode_order[13], xes->_operand_order, sizeof(xed_uint8_t)*4)==0) {
   conditions_satisfied = xed_encode_ntluf_XMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_XMM_N3(xes,xed3_operand_get_reg2(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_Q);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][1]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_64_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_SCALAR_BIND(xes);
       if (okay) return 1;
   }
     }
   return 0;
   (void) okay;
   (void) conditions_satisfied;
   (void) xes;
}
xed_bool_t xed_encode_group_127(xed_encoder_request_t* xes)
{
   xed_bool_t okay=1;
   xed_bool_t conditions_satisfied=0;
   xed_ptrn_func_ptr_t fb_ptrn_function;
   static const xed_uint16_t iform_ids[8][2] = {
   /*VPCOMB        */    {1786,1785,},
   /*VPCOMD        */    {2072,2071,},
   /*VPCOMQ        */    {4961,4960,},
   /*VPCOMUB       */    {3553,3552,},
   /*VPCOMUD       */    {4488,4487,},
   /*VPCOMUQ       */    {1501,1500,},
   /*VPCOMUW       */    { 790, 789,},
   /*VPCOMW        */    {3961,3960,},
   };
   xed_uint8_t iclass_index = xed_encoder_get_iclasses_index_in_group(xes);
   if (xes->_n_operand_order == 4 && memcmp(xed_encode_order[21], xes->_operand_order, sizeof(xed_uint8_t)*4)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 xed_encode_ntluf_XMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_XMM_N(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_XMM_B(xes,xed3_operand_get_reg2(xes)) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][0]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_UIMM8_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 4 && memcmp(xed_encode_order[22], xes->_operand_order, sizeof(xed_uint8_t)*4)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 xed_encode_ntluf_XMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_XMM_N(xes,xed3_operand_get_reg1(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_DQ) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][1]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_UIMM8_BIND(xes);
       if (okay) return 1;
   }
     }
   return 0;
   (void) okay;
   (void) conditions_satisfied;
   (void) xes;
}
xed_bool_t xed_encode_group_128(xed_encoder_request_t* xes)
{
   xed_bool_t okay=1;
   xed_bool_t conditions_satisfied=0;
   xed_ptrn_func_ptr_t fb_ptrn_function;
   static const xed_uint16_t iform_ids[1][15] = {
   /*VCVTSD2SI     */    { 799, 800, 804, 792, 794, 796, 791, 793, 795, 797, 798, 803, 801, 802, 805,},
   };
   xed_uint8_t iclass_index = xed_encoder_get_iclasses_index_in_group(xes);
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_REG1) {
   conditions_satisfied = (xed3_operand_get_roundc(xes) != 0) &&
		 (xed3_operand_get_mode(xes) != 2) &&
		 xed_encode_ntluf_GPR32_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_XMM_B3(xes,xed3_operand_get_reg1(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][0]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_FIX_ROUND_LEN128_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_AVX512_ROUND_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_REG1) {
   conditions_satisfied = (xed3_operand_get_roundc(xes) != 0) &&
		 (xed3_operand_get_mode(xes) == 2) &&
		 xed_encode_ntluf_GPR32_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_XMM_B3(xes,xed3_operand_get_reg1(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][1]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_FIX_ROUND_LEN128_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_AVX512_ROUND_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_REG1) {
   conditions_satisfied = (xed3_operand_get_roundc(xes) != 0) &&
		 (xed3_operand_get_mode(xes) == 2) &&
		 xed_encode_ntluf_GPR64_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_XMM_B3(xes,xed3_operand_get_reg1(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][2]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_FIX_ROUND_LEN128_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_AVX512_ROUND_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_REG1) {
   conditions_satisfied = (xed3_operand_get_mode(xes) != 2) &&
		 (xed3_operand_get_must_use_evex(xes) == 0) &&
		 xed_encode_ntluf_GPR32_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_XMM_B(xes,xed3_operand_get_reg1(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][3]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_REG1) {
   conditions_satisfied = (xed3_operand_get_mode(xes) == 2) &&
		 (xed3_operand_get_must_use_evex(xes) == 0) &&
		 xed_encode_ntluf_GPR32_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_XMM_B(xes,xed3_operand_get_reg1(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][4]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_REG1) {
   conditions_satisfied = (xed3_operand_get_mode(xes) == 2) &&
		 (xed3_operand_get_must_use_evex(xes) == 0) &&
		 xed_encode_ntluf_GPR64_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_XMM_B(xes,xed3_operand_get_reg1(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][5]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_MEM0) {
   conditions_satisfied = (xed3_operand_get_mode(xes) != 2) &&
		 (xed3_operand_get_must_use_evex(xes) == 0) &&
		 xed_encode_ntluf_GPR32_R(xes,xed3_operand_get_reg0(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_Q);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][6]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_MEM0) {
   conditions_satisfied = (xed3_operand_get_mode(xes) == 2) &&
		 (xed3_operand_get_must_use_evex(xes) == 0) &&
		 xed_encode_ntluf_GPR32_R(xes,xed3_operand_get_reg0(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_Q);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][7]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_MEM0) {
   conditions_satisfied = (xed3_operand_get_mode(xes) == 2) &&
		 (xed3_operand_get_must_use_evex(xes) == 0) &&
		 xed_encode_ntluf_GPR64_R(xes,xed3_operand_get_reg0(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_Q);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][8]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_REG1) {
   conditions_satisfied = (xed3_operand_get_mode(xes) != 2) &&
		 xed_encode_ntluf_GPR32_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_XMM_B3(xes,xed3_operand_get_reg1(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][9]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_FIX_ROUND_LEN128_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_REG1) {
   conditions_satisfied = (xed3_operand_get_mode(xes) == 2) &&
		 xed_encode_ntluf_GPR32_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_XMM_B3(xes,xed3_operand_get_reg1(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][10]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_FIX_ROUND_LEN128_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_REG1) {
   conditions_satisfied = (xed3_operand_get_mode(xes) == 2) &&
		 xed_encode_ntluf_GPR64_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_XMM_B3(xes,xed3_operand_get_reg1(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][11]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_FIX_ROUND_LEN128_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_MEM0) {
   conditions_satisfied = (xed3_operand_get_mode(xes) != 2) &&
		 xed_encode_ntluf_GPR32_R(xes,xed3_operand_get_reg0(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_Q);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][12]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_64_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_GPR_WRITER_LDOP_Q_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_FIX_ROUND_LEN128_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_MEM0) {
   conditions_satisfied = (xed3_operand_get_mode(xes) == 2) &&
		 xed_encode_ntluf_GPR32_R(xes,xed3_operand_get_reg0(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_Q);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][13]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_64_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_GPR_WRITER_LDOP_Q_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_FIX_ROUND_LEN128_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_MEM0) {
   conditions_satisfied = (xed3_operand_get_mode(xes) == 2) &&
		 xed_encode_ntluf_GPR64_R(xes,xed3_operand_get_reg0(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_Q);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][14]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_64_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_GPR_WRITER_LDOP_Q_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_FIX_ROUND_LEN128_BIND(xes);
       if (okay) return 1;
   }
     }
   return 0;
   (void) okay;
   (void) conditions_satisfied;
   (void) xes;
}
xed_bool_t xed_encode_group_129(xed_encoder_request_t* xes)
{
   xed_bool_t okay=1;
   xed_bool_t conditions_satisfied=0;
   xed_ptrn_func_ptr_t fb_ptrn_function;
   static const xed_uint16_t iform_ids[2][4] = {
   /*SHLD          */    {3374,3373,3372,3371,},
   /*SHRD          */    { 809, 808, 807, 806,},
   };
   xed_uint8_t iclass_index = xed_encoder_get_iclasses_index_in_group(xes);
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[7], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = xed_encode_ntluf_GPRv_B(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_GPRv_R(xes,xed3_operand_get_reg1(xes)) &&
		 (xed3_operand_get_reg2(xes) == XED_REG_CL);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][0]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[6], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_V) &&
		 xed_encode_ntluf_GPRv_R(xes,xed3_operand_get_reg0(xes)) &&
		 (xed3_operand_get_reg1(xes) == XED_REG_CL);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][1]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[15], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = xed_encode_ntluf_GPRv_B(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_GPRv_R(xes,xed3_operand_get_reg1(xes)) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][2]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_UIMM8_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[17], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_V) &&
		 xed_encode_ntluf_GPRv_R(xes,xed3_operand_get_reg0(xes)) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][3]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_UIMM8_BIND(xes);
       if (okay) return 1;
   }
     }
   return 0;
   (void) okay;
   (void) conditions_satisfied;
   (void) xes;
}
xed_bool_t xed_encode_group_130(xed_encoder_request_t* xes)
{
   xed_bool_t okay=1;
   xed_bool_t conditions_satisfied=0;
   xed_ptrn_func_ptr_t fb_ptrn_function;
   static const xed_uint16_t iform_ids[3][6] = {
   /*BLSI          */    {2986,2987,2989,2984,2985,2988,},
   /*BLSMSK        */    {4546,4547,4549,4544,4545,4548,},
   /*BLSR          */    { 813, 814, 816, 811, 812, 815,},
   };
   xed_uint8_t iclass_index = xed_encoder_get_iclasses_index_in_group(xes);
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_REG1) {
   conditions_satisfied = (xed3_operand_get_mode(xes) != 2) &&
		 (xed3_operand_get_must_use_evex(xes) == 0) &&
		 xed_encode_ntluf_VGPR32_N(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_VGPR32_B(xes,xed3_operand_get_reg1(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][0]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_REG1) {
   conditions_satisfied = (xed3_operand_get_mode(xes) == 2) &&
		 (xed3_operand_get_must_use_evex(xes) == 0) &&
		 xed_encode_ntluf_VGPR32_N(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_VGPR32_B(xes,xed3_operand_get_reg1(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][1]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_REG1) {
   conditions_satisfied = (xed3_operand_get_mode(xes) == 2) &&
		 (xed3_operand_get_must_use_evex(xes) == 0) &&
		 xed_encode_ntluf_VGPR64_N(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_VGPR64_B(xes,xed3_operand_get_reg1(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][2]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_MEM0) {
   conditions_satisfied = (xed3_operand_get_mode(xes) != 2) &&
		 (xed3_operand_get_must_use_evex(xes) == 0) &&
		 xed_encode_ntluf_VGPR32_N(xes,xed3_operand_get_reg0(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_D);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][3]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_MEM0) {
   conditions_satisfied = (xed3_operand_get_mode(xes) == 2) &&
		 (xed3_operand_get_must_use_evex(xes) == 0) &&
		 xed_encode_ntluf_VGPR32_N(xes,xed3_operand_get_reg0(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_D);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][4]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_MEM0) {
   conditions_satisfied = (xed3_operand_get_mode(xes) == 2) &&
		 (xed3_operand_get_must_use_evex(xes) == 0) &&
		 xed_encode_ntluf_VGPR64_N(xes,xed3_operand_get_reg0(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_Q);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][5]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay) return 1;
   }
     }
   return 0;
   (void) okay;
   (void) conditions_satisfied;
   (void) xes;
}
xed_bool_t xed_encode_group_131(xed_encoder_request_t* xes)
{
   xed_bool_t okay=1;
   xed_bool_t conditions_satisfied=0;
   xed_ptrn_func_ptr_t fb_ptrn_function;
   static const xed_uint16_t iform_ids[2][5] = {
   /*DEC           */    {2083,2080,2082,2079,2081,},
   /*INC           */    { 821, 818, 820, 817, 819,},
   };
   xed_uint8_t iclass_index = xed_encoder_get_iclasses_index_in_group(xes);
   if (xes->_n_operand_order == 1 && xes->_operand_order[0] == XED_OPERAND_REG0) {
   conditions_satisfied = (xed3_operand_get_mode(xes) != 2) &&
		 xed_encode_ntluf_GPRv_SB(xes,xed3_operand_get_reg0(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][0]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 1 && xes->_operand_order[0] == XED_OPERAND_REG0) {
   conditions_satisfied = xed_encode_ntluf_GPR8_B(xes,xed3_operand_get_reg0(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][1]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 1 && xes->_operand_order[0] == XED_OPERAND_REG0) {
   conditions_satisfied = xed_encode_ntluf_GPRv_B(xes,xed3_operand_get_reg0(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][2]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 1 && xes->_operand_order[0] == XED_OPERAND_MEM0) {
   conditions_satisfied = (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_B);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][3]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 1 && xes->_operand_order[0] == XED_OPERAND_MEM0) {
   conditions_satisfied = (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_V);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][4]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay) return 1;
   }
     }
   return 0;
   (void) okay;
   (void) conditions_satisfied;
   (void) xes;
}
xed_bool_t xed_encode_group_132(xed_encoder_request_t* xes)
{
   xed_bool_t okay=1;
   xed_bool_t conditions_satisfied=0;
   xed_ptrn_func_ptr_t fb_ptrn_function;
   static const xed_uint16_t iform_ids[10][2] = {
   /*ADDSS         */    {6821,6820,},
   /*CVTSS2SD      */    {6677,6676,},
   /*DIVSS         */    {4311,4310,},
   /*MAXSS         */    {1518,1517,},
   /*MINSS         */    {5293,5292,},
   /*MULSS         */    {1699,1698,},
   /*RCPSS         */    {3164,3163,},
   /*RSQRTSS       */    {5394,5393,},
   /*SQRTSS        */    {5946,5945,},
   /*SUBSS         */    { 827, 826,},
   };
   xed_uint8_t iclass_index = xed_encoder_get_iclasses_index_in_group(xes);
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_REG1) {
   conditions_satisfied = xed_encode_ntluf_XMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_XMM_B(xes,xed3_operand_get_reg1(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][0]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_IGNORE66_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_MEM0) {
   conditions_satisfied = xed_encode_ntluf_XMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_SS);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][1]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_IGNORE66_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay) return 1;
   }
     }
   return 0;
   (void) okay;
   (void) conditions_satisfied;
   (void) xes;
}
xed_bool_t xed_encode_group_133(xed_encoder_request_t* xes)
{
   xed_bool_t okay=1;
   xed_bool_t conditions_satisfied=0;
   xed_ptrn_func_ptr_t fb_ptrn_function;
   static const xed_uint16_t iform_ids[1][2] = {
   /*PEXTRQ        */    { 831, 830,},
   };
   xed_uint8_t iclass_index = xed_encoder_get_iclasses_index_in_group(xes);
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[15], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_mode(xes) == 2) &&
		 xed_encode_ntluf_GPR64_B(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_XMM_R(xes,xed3_operand_get_reg1(xes)) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][0]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_REFINING66_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_UIMM8_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[17], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_mode(xes) == 2) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_Q) &&
		 xed_encode_ntluf_XMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][1]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_REFINING66_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_UIMM8_BIND(xes);
       if (okay) return 1;
   }
     }
   return 0;
   (void) okay;
   (void) conditions_satisfied;
   (void) xes;
}
xed_bool_t xed_encode_group_134(xed_encoder_request_t* xes)
{
   xed_bool_t okay=1;
   xed_bool_t conditions_satisfied=0;
   xed_ptrn_func_ptr_t fb_ptrn_function;
   static const xed_uint16_t iform_ids[2][2] = {
   /*COMISD        */    {2925,2924,},
   /*UCOMISD       */    { 833, 832,},
   };
   xed_uint8_t iclass_index = xed_encoder_get_iclasses_index_in_group(xes);
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_REG1) {
   conditions_satisfied = xed_encode_ntluf_XMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_XMM_B(xes,xed3_operand_get_reg1(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][0]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_REFINING66_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_MEM0) {
   conditions_satisfied = xed_encode_ntluf_XMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_SD);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][1]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_REFINING66_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay) return 1;
   }
     }
   return 0;
   (void) okay;
   (void) conditions_satisfied;
   (void) xes;
}
xed_bool_t xed_encode_group_135(xed_encoder_request_t* xes)
{
   xed_bool_t okay=1;
   xed_bool_t conditions_satisfied=0;
   xed_ptrn_func_ptr_t fb_ptrn_function;
   static const xed_uint16_t iform_ids[3][4] = {
   /*PUNPCKLBW     */    { 843, 842, 845, 844,},
   /*PUNPCKLDQ     */    {5120,5119,5122,5121,},
   /*PUNPCKLWD     */    {3602,3601,3604,3603,},
   };
   xed_uint8_t iclass_index = xed_encoder_get_iclasses_index_in_group(xes);
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_REG1) {
   conditions_satisfied = xed_encode_ntluf_MMX_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MMX_B(xes,xed3_operand_get_reg1(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][0]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_MEM0) {
   conditions_satisfied = xed_encode_ntluf_MMX_R(xes,xed3_operand_get_reg0(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_D);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][1]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_REG1) {
   conditions_satisfied = xed_encode_ntluf_XMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_XMM_B(xes,xed3_operand_get_reg1(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][2]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_REFINING66_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_MEM0) {
   conditions_satisfied = xed_encode_ntluf_XMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_DQ);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][3]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_REFINING66_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay) return 1;
   }
     }
   return 0;
   (void) okay;
   (void) conditions_satisfied;
   (void) xes;
}
xed_bool_t xed_encode_group_136(xed_encoder_request_t* xes)
{
   xed_bool_t okay=1;
   xed_bool_t conditions_satisfied=0;
   xed_ptrn_func_ptr_t fb_ptrn_function;
   static const xed_uint16_t iform_ids[3][4] = {
   /*PCMPESTRI     */    {2513,2515,2512,2514,},
   /*PCMPESTRM     */    {6066,6068,6065,6067,},
   /*PCMPISTRI     */    { 847, 849, 846, 848,},
   };
   xed_uint8_t iclass_index = xed_encoder_get_iclasses_index_in_group(xes);
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[15], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_mode(xes) != 2) &&
		 xed_encode_ntluf_XMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_XMM_B(xes,xed3_operand_get_reg1(xes)) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][0]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_IMMUNE66_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_UIMM8_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[15], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_mode(xes) == 2) &&
		 xed_encode_ntluf_XMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_XMM_B(xes,xed3_operand_get_reg1(xes)) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][1]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_IMMUNE66_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_UIMM8_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[20], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_mode(xes) != 2) &&
		 xed_encode_ntluf_XMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_DQ) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][2]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_IMMUNE66_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_UIMM8_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[20], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_mode(xes) == 2) &&
		 xed_encode_ntluf_XMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_DQ) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][3]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_IMMUNE66_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_UIMM8_BIND(xes);
       if (okay) return 1;
   }
     }
   return 0;
   (void) okay;
   (void) conditions_satisfied;
   (void) xes;
}
xed_bool_t xed_encode_group_137(xed_encoder_request_t* xes)
{
   xed_bool_t okay=1;
   xed_bool_t conditions_satisfied=0;
   xed_ptrn_func_ptr_t fb_ptrn_function;
   static const xed_uint16_t iform_ids[4][3] = {
   /*VPMOVB2M      */    {5664,5665,5666,},
   /*VPMOVD2M      */    {4410,4411,4412,},
   /*VPMOVQ2M      */    {5347,5348,5349,},
   /*VPMOVW2M      */    { 850, 851, 852,},
   };
   xed_uint8_t iclass_index = xed_encoder_get_iclasses_index_in_group(xes);
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_REG1) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 xed_encode_ntluf_MASK_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_XMM_B3(xes,xed3_operand_get_reg1(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][0]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_REG1) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 1) &&
		 xed_encode_ntluf_MASK_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_YMM_B3(xes,xed3_operand_get_reg1(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][1]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_REG1) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 2) &&
		 xed_encode_ntluf_MASK_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_ZMM_B3(xes,xed3_operand_get_reg1(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][2]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   return 0;
   (void) okay;
   (void) conditions_satisfied;
   (void) xes;
}
xed_bool_t xed_encode_group_138(xed_encoder_request_t* xes)
{
   xed_bool_t okay=1;
   xed_bool_t conditions_satisfied=0;
   xed_ptrn_func_ptr_t fb_ptrn_function;
   static const xed_uint16_t iform_ids[2][1] = {
   /*VBROADCASTF32X8*/    { 853,},
   /*VBROADCASTI32X8*/    {6758,},
   };
   xed_uint8_t iclass_index = xed_encoder_get_iclasses_index_in_group(xes);
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[14], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 2) &&
		 xed_encode_ntluf_ZMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_QQ);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][0]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_32_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_TUPLE8_BIND(xes);
       if (okay) return 1;
   }
     }
   return 0;
   (void) okay;
   (void) conditions_satisfied;
   (void) xes;
}
xed_bool_t xed_encode_group_139(xed_encoder_request_t* xes)
{
   xed_bool_t okay=1;
   xed_bool_t conditions_satisfied=0;
   xed_ptrn_func_ptr_t fb_ptrn_function;
   static const xed_uint16_t iform_ids[2][1] = {
   /*PSLLDQ        */    {1656,},
   /*PSRLDQ        */    { 859,},
   };
   xed_uint8_t iclass_index = xed_encoder_get_iclasses_index_in_group(xes);
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_IMM0) {
   conditions_satisfied = xed_encode_ntluf_XMM_B(xes,xed3_operand_get_reg0(xes)) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][0]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_REFINING66_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_UIMM8_BIND(xes);
       if (okay) return 1;
   }
     }
   return 0;
   (void) okay;
   (void) conditions_satisfied;
   (void) xes;
}
xed_bool_t xed_encode_group_140(xed_encoder_request_t* xes)
{
   xed_bool_t okay=1;
   xed_bool_t conditions_satisfied=0;
   xed_ptrn_func_ptr_t fb_ptrn_function;
   static const xed_uint16_t iform_ids[4][1] = {
   /*CLRSSBSY      */    {4503,},
   /*RSTORSSP      */    {3375,},
   /*VMPTRLD       */    { 862,},
   /*VMPTRST       */    {4573,},
   };
   xed_uint8_t iclass_index = xed_encoder_get_iclasses_index_in_group(xes);
   if (xes->_n_operand_order == 1 && xes->_operand_order[0] == XED_OPERAND_MEM0) {
   conditions_satisfied = (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_Q);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][0]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay) return 1;
   }
     }
   return 0;
   (void) okay;
   (void) conditions_satisfied;
   (void) xes;
}
xed_bool_t xed_encode_group_141(xed_encoder_request_t* xes)
{
   xed_bool_t okay=1;
   xed_bool_t conditions_satisfied=0;
   xed_ptrn_func_ptr_t fb_ptrn_function;
   static const xed_uint16_t iform_ids[20][6] = {
   /*VBLENDMPS     */    {2973,2975,2971,2974,2976,2972,},
   /*VCVTNE2PS2BF16*/    {2359,2361,2363,2360,2362,2364,},
   /*VDPBF16PS     */    {5578,5580,5582,5579,5581,5583,},
   /*VPANDD        */    {4184,4186,4182,4185,4187,4183,},
   /*VPANDND       */    {3007,3009,3005,3008,3010,3006,},
   /*VPBLENDMD     */    {3849,3851,3847,3850,3852,3848,},
   /*VPDPBUSD      */    {2123,2125,2127,2124,2126,2128,},
   /*VPDPBUSDS     */    {5111,5113,5115,5112,5114,5116,},
   /*VPDPWSSD      */    {4833,4835,4837,4834,4836,4838,},
   /*VPDPWSSDS     */    {4319,4321,4323,4320,4322,4324,},
   /*VPERMI2D      */    {3059,3061,3057,3060,3062,3058,},
   /*VPERMI2PS     */    {2282,2284,2280,2283,2285,2281,},
   /*VPERMT2D      */    {1170,1172,1168,1171,1173,1169,},
   /*VPERMT2PS     */    {5597,5599,5595,5598,5600,5596,},
   /*VPORD         */    {5025,5027,5023,5026,5028,5024,},
   /*VPROLVD       */    {2451,2453,2449,2452,2454,2450,},
   /*VPRORVD       */    {4709,4711,4707,4710,4712,4708,},
   /*VPSHLDVD      */    {2601,2603,2605,2602,2604,2606,},
   /*VPSHRDVD      */    { 871, 873, 875, 872, 874, 876,},
   /*VPXORD        */    {1189,1191,1187,1190,1192,1188,},
   };
   xed_uint8_t iclass_index = xed_encoder_get_iclasses_index_in_group(xes);
   if (xes->_n_operand_order == 4 && memcmp(xed_encode_order[12], xes->_operand_order, sizeof(xed_uint8_t)*4)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 xed_encode_ntluf_XMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_XMM_N3(xes,xed3_operand_get_reg2(xes)) &&
		 xed_encode_ntluf_XMM_B3(xes,xed3_operand_get_reg3(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][0]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 4 && memcmp(xed_encode_order[12], xes->_operand_order, sizeof(xed_uint8_t)*4)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 1) &&
		 xed_encode_ntluf_YMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_YMM_N3(xes,xed3_operand_get_reg2(xes)) &&
		 xed_encode_ntluf_YMM_B3(xes,xed3_operand_get_reg3(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][1]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 4 && memcmp(xed_encode_order[12], xes->_operand_order, sizeof(xed_uint8_t)*4)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 2) &&
		 xed_encode_ntluf_ZMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_ZMM_N3(xes,xed3_operand_get_reg2(xes)) &&
		 xed_encode_ntluf_ZMM_B3(xes,xed3_operand_get_reg3(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][2]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 4 && memcmp(xed_encode_order[13], xes->_operand_order, sizeof(xed_uint8_t)*4)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 xed_encode_ntluf_XMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_XMM_N3(xes,xed3_operand_get_reg2(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_VV);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][3]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_32_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_FULL_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 4 && memcmp(xed_encode_order[13], xes->_operand_order, sizeof(xed_uint8_t)*4)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 1) &&
		 xed_encode_ntluf_YMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_YMM_N3(xes,xed3_operand_get_reg2(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_VV);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][4]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_32_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_FULL_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 4 && memcmp(xed_encode_order[13], xes->_operand_order, sizeof(xed_uint8_t)*4)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 2) &&
		 xed_encode_ntluf_ZMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_ZMM_N3(xes,xed3_operand_get_reg2(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_VV);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][5]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_32_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_FULL_BIND(xes);
       if (okay) return 1;
   }
     }
   return 0;
   (void) okay;
   (void) conditions_satisfied;
   (void) xes;
}
xed_bool_t xed_encode_group_142(xed_encoder_request_t* xes)
{
   xed_bool_t okay=1;
   xed_bool_t conditions_satisfied=0;
   xed_ptrn_func_ptr_t fb_ptrn_function;
   static const xed_uint16_t iform_ids[1][6] = {
   /*RORX          */    { 877, 878, 881, 879, 880, 882,},
   };
   xed_uint8_t iclass_index = xed_encoder_get_iclasses_index_in_group(xes);
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[15], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_mode(xes) != 2) &&
		 (xed3_operand_get_must_use_evex(xes) == 0) &&
		 xed_encode_ntluf_VGPR32_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_VGPR32_B(xes,xed3_operand_get_reg1(xes)) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][0]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_UIMM8_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[15], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_mode(xes) == 2) &&
		 (xed3_operand_get_must_use_evex(xes) == 0) &&
		 xed_encode_ntluf_VGPR32_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_VGPR32_B(xes,xed3_operand_get_reg1(xes)) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][1]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_UIMM8_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[15], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_mode(xes) == 2) &&
		 (xed3_operand_get_must_use_evex(xes) == 0) &&
		 xed_encode_ntluf_VGPR64_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_VGPR64_B(xes,xed3_operand_get_reg1(xes)) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][2]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_UIMM8_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[20], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_mode(xes) != 2) &&
		 (xed3_operand_get_must_use_evex(xes) == 0) &&
		 xed_encode_ntluf_VGPR32_R(xes,xed3_operand_get_reg0(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_D) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][3]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_UIMM8_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[20], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_mode(xes) == 2) &&
		 (xed3_operand_get_must_use_evex(xes) == 0) &&
		 xed_encode_ntluf_VGPR32_R(xes,xed3_operand_get_reg0(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_D) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][4]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_UIMM8_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[20], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_mode(xes) == 2) &&
		 (xed3_operand_get_must_use_evex(xes) == 0) &&
		 xed_encode_ntluf_VGPR64_R(xes,xed3_operand_get_reg0(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_Q) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][5]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_UIMM8_BIND(xes);
       if (okay) return 1;
   }
     }
   return 0;
   (void) okay;
   (void) conditions_satisfied;
   (void) xes;
}
xed_bool_t xed_encode_group_143(xed_encoder_request_t* xes)
{
   xed_bool_t okay=1;
   xed_bool_t conditions_satisfied=0;
   xed_ptrn_func_ptr_t fb_ptrn_function;
   static const xed_uint16_t iform_ids[1][22] = {
   /*MOV           */    { 907, 908, 909, 910, 906, 905, 893, 898, 896, 902, 900, 904, 894, 895, 901, 889, 897, 891, 899, 903, 890, 892,},
   };
   xed_uint8_t iclass_index = xed_encoder_get_iclasses_index_in_group(xes);
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_MEM0 && xes->_operand_order[1] == XED_OPERAND_REG0) {
   conditions_satisfied = (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_B) &&
		 (xed3_operand_get_reg0(xes) == XED_REG_AL) &&
		 (xed3_operand_get_base0(xes) == XED_REG_INVALID) &&
		 (xed3_operand_get_index(xes) == XED_REG_INVALID);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][0]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MEMDISPv_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_OVERRIDE_SEG0_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_MEM0 && xes->_operand_order[1] == XED_OPERAND_REG0) {
   conditions_satisfied = (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_V) &&
		 xed_encode_ntluf_OrAX(xes,xed3_operand_get_reg0(xes)) &&
		 (xed3_operand_get_base0(xes) == XED_REG_INVALID) &&
		 (xed3_operand_get_index(xes) == XED_REG_INVALID);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][1]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MEMDISPv_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_OVERRIDE_SEG0_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_IMM0) {
   conditions_satisfied = xed_encode_ntluf_GPR8_SB(xes,xed3_operand_get_reg0(xes)) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][2]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_UIMM8_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_IMM0) {
   conditions_satisfied = xed_encode_ntluf_GPRv_SB(xes,xed3_operand_get_reg0(xes)) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][3]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_UIMMv_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_MEM0) {
   conditions_satisfied = xed_encode_ntluf_OrAX(xes,xed3_operand_get_reg0(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_V) &&
		 (xed3_operand_get_base0(xes) == XED_REG_INVALID) &&
		 (xed3_operand_get_index(xes) == XED_REG_INVALID);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][4]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MEMDISPv_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_OVERRIDE_SEG0_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_MEM0) {
   conditions_satisfied = (xed3_operand_get_reg0(xes) == XED_REG_AL) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_B) &&
		 (xed3_operand_get_base0(xes) == XED_REG_INVALID) &&
		 (xed3_operand_get_index(xes) == XED_REG_INVALID);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][5]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MEMDISPv_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_OVERRIDE_SEG0_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_REG1) {
   conditions_satisfied = xed_encode_ntluf_GPR8_B(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_GPR8_R(xes,xed3_operand_get_reg1(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][6]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_REG1) {
   conditions_satisfied = xed_encode_ntluf_GPR8_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_GPR8_B(xes,xed3_operand_get_reg1(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][7]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_REG1) {
   conditions_satisfied = xed_encode_ntluf_GPRv_B(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_GPRv_R(xes,xed3_operand_get_reg1(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][8]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_REG1) {
   conditions_satisfied = xed_encode_ntluf_GPRv_B(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_SEG(xes,xed3_operand_get_reg1(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][9]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_REG1) {
   conditions_satisfied = xed_encode_ntluf_GPRv_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_GPRv_B(xes,xed3_operand_get_reg1(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][10]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_REG1) {
   conditions_satisfied = xed_encode_ntluf_SEG_MOV(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_GPR16_B(xes,xed3_operand_get_reg1(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][11]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_MEM0 && xes->_operand_order[1] == XED_OPERAND_REG0) {
   conditions_satisfied = (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_B) &&
		 xed_encode_ntluf_GPR8_R(xes,xed3_operand_get_reg0(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][12]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_MEM0 && xes->_operand_order[1] == XED_OPERAND_REG0) {
   conditions_satisfied = (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_V) &&
		 xed_encode_ntluf_GPRv_R(xes,xed3_operand_get_reg0(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][13]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_MEM0 && xes->_operand_order[1] == XED_OPERAND_REG0) {
   conditions_satisfied = (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_W) &&
		 xed_encode_ntluf_SEG(xes,xed3_operand_get_reg0(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][14]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_IMM0) {
   conditions_satisfied = xed_encode_ntluf_GPR8_B(xes,xed3_operand_get_reg0(xes)) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][15]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_UIMM8_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_MEM0) {
   conditions_satisfied = xed_encode_ntluf_GPR8_R(xes,xed3_operand_get_reg0(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_B);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][16]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_IMM0) {
   conditions_satisfied = xed_encode_ntluf_GPRv_B(xes,xed3_operand_get_reg0(xes)) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][17]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_SIMMz_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_MEM0) {
   conditions_satisfied = xed_encode_ntluf_GPRv_R(xes,xed3_operand_get_reg0(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_V);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][18]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_MEM0) {
   conditions_satisfied = xed_encode_ntluf_SEG_MOV(xes,xed3_operand_get_reg0(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_W);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][19]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_MEM0 && xes->_operand_order[1] == XED_OPERAND_IMM0) {
   conditions_satisfied = (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_B) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][20]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_UIMM8_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_MEM0 && xes->_operand_order[1] == XED_OPERAND_IMM0) {
   conditions_satisfied = (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_V) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][21]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_SIMMz_BIND(xes);
       if (okay) return 1;
   }
     }
   return 0;
   (void) okay;
   (void) conditions_satisfied;
   (void) xes;
}
xed_bool_t xed_encode_group_144(xed_encoder_request_t* xes)
{
   xed_bool_t okay=1;
   xed_bool_t conditions_satisfied=0;
   xed_ptrn_func_ptr_t fb_ptrn_function;
   static const xed_uint16_t iform_ids[2][2] = {
   /*VINSERTF64X4  */    {2563,2564,},
   /*VINSERTI64X4  */    { 911, 912,},
   };
   xed_uint8_t iclass_index = xed_encoder_get_iclasses_index_in_group(xes);
   if (xes->_n_operand_order == 5 && memcmp(xed_encode_order[18], xes->_operand_order, sizeof(xed_uint8_t)*5)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 2) &&
		 xed_encode_ntluf_ZMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_ZMM_N3(xes,xed3_operand_get_reg2(xes)) &&
		 xed_encode_ntluf_YMM_B3(xes,xed3_operand_get_reg3(xes)) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][0]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_UIMM8_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 5 && memcmp(xed_encode_order[19], xes->_operand_order, sizeof(xed_uint8_t)*5)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 2) &&
		 xed_encode_ntluf_ZMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_ZMM_N3(xes,xed3_operand_get_reg2(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_QQ) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][1]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_UIMM8_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_64_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_TUPLE4_BIND(xes);
       if (okay) return 1;
   }
     }
   return 0;
   (void) okay;
   (void) conditions_satisfied;
   (void) xes;
}
xed_bool_t xed_encode_group_145(xed_encoder_request_t* xes)
{
   xed_bool_t okay=1;
   xed_bool_t conditions_satisfied=0;
   xed_ptrn_func_ptr_t fb_ptrn_function;
   static const xed_uint16_t iform_ids[1][5] = {
   /*KMOVW         */    { 930, 929, 926, 928, 927,},
   };
   xed_uint8_t iclass_index = xed_encoder_get_iclasses_index_in_group(xes);
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_REG1) {
   conditions_satisfied = (xed3_operand_get_must_use_evex(xes) == 0) &&
		 xed_encode_ntluf_GPR32_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK_B(xes,xed3_operand_get_reg1(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][0]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_REG1) {
   conditions_satisfied = (xed3_operand_get_must_use_evex(xes) == 0) &&
		 xed_encode_ntluf_MASK_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_GPR32_B(xes,xed3_operand_get_reg1(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][1]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_REG1) {
   conditions_satisfied = (xed3_operand_get_must_use_evex(xes) == 0) &&
		 xed_encode_ntluf_MASK_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK_B(xes,xed3_operand_get_reg1(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][2]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_MEM0 && xes->_operand_order[1] == XED_OPERAND_REG0) {
   conditions_satisfied = (xed3_operand_get_must_use_evex(xes) == 0) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_WRD) &&
		 xed_encode_ntluf_MASK_R(xes,xed3_operand_get_reg0(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][3]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_MEM0) {
   conditions_satisfied = (xed3_operand_get_must_use_evex(xes) == 0) &&
		 xed_encode_ntluf_MASK_R(xes,xed3_operand_get_reg0(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_WRD);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][4]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay) return 1;
   }
     }
   return 0;
   (void) okay;
   (void) conditions_satisfied;
   (void) xes;
}
xed_bool_t xed_encode_group_146(xed_encoder_request_t* xes)
{
   xed_bool_t okay=1;
   xed_bool_t conditions_satisfied=0;
   xed_ptrn_func_ptr_t fb_ptrn_function;
   static const xed_uint16_t iform_ids[3][18] = {
   /*VPSLLD        */    { 934, 937, 935, 933, 938, 936, 943, 947, 939, 945, 949, 941, 944, 948, 940, 946, 950, 942,},
   /*VPSRAD        */    {2318,2321,2319,2317,2322,2320,2327,2331,2323,2329,2333,2325,2328,2332,2324,2330,2334,2326,},
   /*VPSRLD        */    {6634,6637,6635,6633,6638,6636,6643,6647,6639,6645,6649,6641,6644,6648,6640,6646,6650,6642,},
   };
   xed_uint8_t iclass_index = xed_encoder_get_iclasses_index_in_group(xes);
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[7], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 (xed3_operand_get_must_use_evex(xes) == 0) &&
		 xed_encode_ntluf_XMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_XMM_N(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_XMM_B(xes,xed3_operand_get_reg2(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][0]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[7], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 1) &&
		 (xed3_operand_get_must_use_evex(xes) == 0) &&
		 xed_encode_ntluf_YMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_YMM_N(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_XMM_B(xes,xed3_operand_get_reg2(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][1]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[15], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 (xed3_operand_get_must_use_evex(xes) == 0) &&
		 xed_encode_ntluf_XMM_N(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_XMM_B(xes,xed3_operand_get_reg1(xes)) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][2]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_UIMM8_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[14], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 (xed3_operand_get_must_use_evex(xes) == 0) &&
		 xed_encode_ntluf_XMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_XMM_N(xes,xed3_operand_get_reg1(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_DQ);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][3]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[15], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 1) &&
		 (xed3_operand_get_must_use_evex(xes) == 0) &&
		 xed_encode_ntluf_YMM_N(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_YMM_B(xes,xed3_operand_get_reg1(xes)) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][4]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_UIMM8_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[14], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 1) &&
		 (xed3_operand_get_must_use_evex(xes) == 0) &&
		 xed_encode_ntluf_YMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_YMM_N(xes,xed3_operand_get_reg1(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_DQ);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][5]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 4 && memcmp(xed_encode_order[12], xes->_operand_order, sizeof(xed_uint8_t)*4)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 xed_encode_ntluf_XMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_XMM_N3(xes,xed3_operand_get_reg2(xes)) &&
		 xed_encode_ntluf_XMM_B3(xes,xed3_operand_get_reg3(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][6]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 4 && memcmp(xed_encode_order[12], xes->_operand_order, sizeof(xed_uint8_t)*4)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 1) &&
		 xed_encode_ntluf_YMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_YMM_N3(xes,xed3_operand_get_reg2(xes)) &&
		 xed_encode_ntluf_XMM_B3(xes,xed3_operand_get_reg3(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][7]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 4 && memcmp(xed_encode_order[12], xes->_operand_order, sizeof(xed_uint8_t)*4)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 2) &&
		 xed_encode_ntluf_ZMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_ZMM_N3(xes,xed3_operand_get_reg2(xes)) &&
		 xed_encode_ntluf_XMM_B3(xes,xed3_operand_get_reg3(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][8]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 4 && memcmp(xed_encode_order[21], xes->_operand_order, sizeof(xed_uint8_t)*4)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 xed_encode_ntluf_XMM_N3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_XMM_B3(xes,xed3_operand_get_reg2(xes)) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][9]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_UIMM8_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 4 && memcmp(xed_encode_order[21], xes->_operand_order, sizeof(xed_uint8_t)*4)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 1) &&
		 xed_encode_ntluf_YMM_N3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_YMM_B3(xes,xed3_operand_get_reg2(xes)) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][10]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_UIMM8_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 4 && memcmp(xed_encode_order[21], xes->_operand_order, sizeof(xed_uint8_t)*4)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 2) &&
		 xed_encode_ntluf_ZMM_N3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_ZMM_B3(xes,xed3_operand_get_reg2(xes)) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][11]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_UIMM8_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 4 && memcmp(xed_encode_order[13], xes->_operand_order, sizeof(xed_uint8_t)*4)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 xed_encode_ntluf_XMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_XMM_N3(xes,xed3_operand_get_reg2(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_DQ);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][12]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_32_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_MEM128_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 4 && memcmp(xed_encode_order[13], xes->_operand_order, sizeof(xed_uint8_t)*4)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 1) &&
		 xed_encode_ntluf_YMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_YMM_N3(xes,xed3_operand_get_reg2(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_DQ);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][13]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_32_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_MEM128_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 4 && memcmp(xed_encode_order[13], xes->_operand_order, sizeof(xed_uint8_t)*4)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 2) &&
		 xed_encode_ntluf_ZMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_ZMM_N3(xes,xed3_operand_get_reg2(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_DQ);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][14]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_32_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_MEM128_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 4 && memcmp(xed_encode_order[22], xes->_operand_order, sizeof(xed_uint8_t)*4)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 xed_encode_ntluf_XMM_N3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_VV) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][15]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_UIMM8_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_32_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_FULL_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 4 && memcmp(xed_encode_order[22], xes->_operand_order, sizeof(xed_uint8_t)*4)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 1) &&
		 xed_encode_ntluf_YMM_N3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_VV) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][16]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_UIMM8_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_32_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_FULL_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 4 && memcmp(xed_encode_order[22], xes->_operand_order, sizeof(xed_uint8_t)*4)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 2) &&
		 xed_encode_ntluf_ZMM_N3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_VV) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][17]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_UIMM8_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_32_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_FULL_BIND(xes);
       if (okay) return 1;
   }
     }
   return 0;
   (void) okay;
   (void) conditions_satisfied;
   (void) xes;
}
xed_bool_t xed_encode_group_147(xed_encoder_request_t* xes)
{
   xed_bool_t okay=1;
   xed_bool_t conditions_satisfied=0;
   xed_ptrn_func_ptr_t fb_ptrn_function;
   static const xed_uint16_t iform_ids[2][1] = {
   /*CLFLUSHOPT    */    { 951,},
   /*CLWB          */    {4210,},
   };
   xed_uint8_t iclass_index = xed_encoder_get_iclasses_index_in_group(xes);
   if (xes->_n_operand_order == 1 && xes->_operand_order[0] == XED_OPERAND_MEM0) {
   conditions_satisfied = (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_MPREFETCH);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][0]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_REFINING66_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay) return 1;
   }
     }
   return 0;
   (void) okay;
   (void) conditions_satisfied;
   (void) xes;
}
xed_bool_t xed_encode_group_148(xed_encoder_request_t* xes)
{
   xed_bool_t okay=1;
   xed_bool_t conditions_satisfied=0;
   xed_ptrn_func_ptr_t fb_ptrn_function;
   static const xed_uint16_t iform_ids[2][3] = {
   /*VPSCATTERDD   */    {4683,4684,4682,},
   /*VSCATTERDPS   */    { 975, 976, 974,},
   };
   xed_uint8_t iclass_index = xed_encoder_get_iclasses_index_in_group(xes);
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[6], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 (xed3_operand_get_easz(xes) != 1) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_D) &&
		 xed_encode_ntluf_MASKNOT0(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_XMM_R3(xes,xed3_operand_get_reg1(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][0]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_UISA_VMODRM_XMM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_32_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_GSCAT_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[6], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 1) &&
		 (xed3_operand_get_easz(xes) != 1) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_D) &&
		 xed_encode_ntluf_MASKNOT0(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_YMM_R3(xes,xed3_operand_get_reg1(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][1]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_UISA_VMODRM_YMM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_32_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_GSCAT_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[6], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 2) &&
		 (xed3_operand_get_easz(xes) != 1) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_D) &&
		 xed_encode_ntluf_MASKNOT0(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_ZMM_R3(xes,xed3_operand_get_reg1(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][2]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_UISA_VMODRM_ZMM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_32_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_GSCAT_BIND(xes);
       if (okay) return 1;
   }
     }
   return 0;
   (void) okay;
   (void) conditions_satisfied;
   (void) xes;
}
xed_bool_t xed_encode_group_149(xed_encoder_request_t* xes)
{
   xed_bool_t okay=1;
   xed_bool_t conditions_satisfied=0;
   xed_ptrn_func_ptr_t fb_ptrn_function;
   static const xed_uint16_t iform_ids[6][6] = {
   /*VPABSQ        */    {4599,4601,4597,4600,4602,4598,},
   /*VPCONFLICTQ   */    {3640,3642,3638,3641,3643,3639,},
   /*VPLZCNTQ      */    {1398,1400,1396,1399,1401,1397,},
   /*VPOPCNTQ      */    {2722,2724,2720,2723,2725,2721,},
   /*VRCP14PD      */    {5167,5169,5165,5168,5170,5166,},
   /*VRSQRT14PD    */    { 979, 981, 977, 980, 982, 978,},
   };
   xed_uint8_t iclass_index = xed_encoder_get_iclasses_index_in_group(xes);
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[7], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 xed_encode_ntluf_XMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_XMM_B3(xes,xed3_operand_get_reg2(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][0]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[7], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 1) &&
		 xed_encode_ntluf_YMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_YMM_B3(xes,xed3_operand_get_reg2(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][1]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[7], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 2) &&
		 xed_encode_ntluf_ZMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_ZMM_B3(xes,xed3_operand_get_reg2(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][2]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[14], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 xed_encode_ntluf_XMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_VV);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][3]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_64_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_FULL_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[14], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 1) &&
		 xed_encode_ntluf_YMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_VV);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][4]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_64_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_FULL_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[14], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 2) &&
		 xed_encode_ntluf_ZMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_VV);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][5]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_64_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_FULL_BIND(xes);
       if (okay) return 1;
   }
     }
   return 0;
   (void) okay;
   (void) conditions_satisfied;
   (void) xes;
}
xed_bool_t xed_encode_group_150(xed_encoder_request_t* xes)
{
   xed_bool_t okay=1;
   xed_bool_t conditions_satisfied=0;
   xed_ptrn_func_ptr_t fb_ptrn_function;
   static const xed_uint16_t iform_ids[3][2] = {
   /*VPCMPESTRI64  */    { 984, 983,},
   /*VPCMPESTRM64  */    {3258,3257,},
   /*VPCMPISTRI64  */    {5492,5491,},
   };
   xed_uint8_t iclass_index = xed_encoder_get_iclasses_index_in_group(xes);
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[15], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 (xed3_operand_get_mode(xes) == 2) &&
		 (xed3_operand_get_must_use_evex(xes) == 0) &&
		 xed_encode_ntluf_XMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_XMM_B(xes,xed3_operand_get_reg1(xes)) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][0]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_UIMM8_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[20], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 (xed3_operand_get_mode(xes) == 2) &&
		 (xed3_operand_get_must_use_evex(xes) == 0) &&
		 xed_encode_ntluf_XMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_DQ) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][1]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_UIMM8_BIND(xes);
       if (okay) return 1;
   }
     }
   return 0;
   (void) okay;
   (void) conditions_satisfied;
   (void) xes;
}
xed_bool_t xed_encode_group_151(xed_encoder_request_t* xes)
{
   xed_bool_t okay=1;
   xed_bool_t conditions_satisfied=0;
   xed_ptrn_func_ptr_t fb_ptrn_function;
   static const xed_uint16_t iform_ids[2][7] = {
   /*VCVTPS2QQ     */    {1002, 997, 999,1001, 998,1000,1003,},
   /*VCVTPS2UQQ    */    {5318,5313,5315,5317,5314,5316,5319,},
   };
   xed_uint8_t iclass_index = xed_encoder_get_iclasses_index_in_group(xes);
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[7], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_roundc(xes) != 0) &&
		 xed_encode_ntluf_ZMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_YMM_B3(xes,xed3_operand_get_reg2(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][0]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_FIX_ROUND_LEN512_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_AVX512_ROUND_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[7], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 xed_encode_ntluf_XMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_XMM_B3(xes,xed3_operand_get_reg2(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][1]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[7], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 1) &&
		 xed_encode_ntluf_YMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_XMM_B3(xes,xed3_operand_get_reg2(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][2]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[7], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 2) &&
		 xed_encode_ntluf_ZMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_YMM_B3(xes,xed3_operand_get_reg2(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][3]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[14], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 xed_encode_ntluf_XMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_VV);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][4]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_32_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_HALF_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[14], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 1) &&
		 xed_encode_ntluf_YMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_VV);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][5]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_32_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_HALF_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[14], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 2) &&
		 xed_encode_ntluf_ZMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_VV);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][6]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_32_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_HALF_BIND(xes);
       if (okay) return 1;
   }
     }
   return 0;
   (void) okay;
   (void) conditions_satisfied;
   (void) xes;
}
xed_bool_t xed_encode_group_152(xed_encoder_request_t* xes)
{
   xed_bool_t okay=1;
   xed_bool_t conditions_satisfied=0;
   xed_ptrn_func_ptr_t fb_ptrn_function;
   static const xed_uint16_t iform_ids[1][3] = {
   /*VSCALEFSS     */    {1011,1010,1012,},
   };
   xed_uint8_t iclass_index = xed_encoder_get_iclasses_index_in_group(xes);
   if (xes->_n_operand_order == 4 && memcmp(xed_encode_order[12], xes->_operand_order, sizeof(xed_uint8_t)*4)==0) {
   conditions_satisfied = (xed3_operand_get_roundc(xes) != 0) &&
		 xed_encode_ntluf_XMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_XMM_N3(xes,xed3_operand_get_reg2(xes)) &&
		 xed_encode_ntluf_XMM_B3(xes,xed3_operand_get_reg3(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][0]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_FIX_ROUND_LEN128_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_AVX512_ROUND_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 4 && memcmp(xed_encode_order[12], xes->_operand_order, sizeof(xed_uint8_t)*4)==0) {
   conditions_satisfied = xed_encode_ntluf_XMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_XMM_N3(xes,xed3_operand_get_reg2(xes)) &&
		 xed_encode_ntluf_XMM_B3(xes,xed3_operand_get_reg3(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][1]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 4 && memcmp(xed_encode_order[13], xes->_operand_order, sizeof(xed_uint8_t)*4)==0) {
   conditions_satisfied = xed_encode_ntluf_XMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_XMM_N3(xes,xed3_operand_get_reg2(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_D);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][2]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_32_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_SCALAR_BIND(xes);
       if (okay) return 1;
   }
     }
   return 0;
   (void) okay;
   (void) conditions_satisfied;
   (void) xes;
}
xed_bool_t xed_encode_group_153(xed_encoder_request_t* xes)
{
   xed_bool_t okay=1;
   xed_bool_t conditions_satisfied=0;
   xed_ptrn_func_ptr_t fb_ptrn_function;
   static const xed_uint16_t iform_ids[3][1] = {
   /*LFS           */    {4925,},
   /*LGS           */    {1013,},
   /*LSS           */    {1318,},
   };
   xed_uint8_t iclass_index = xed_encoder_get_iclasses_index_in_group(xes);
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_MEM0) {
   conditions_satisfied = xed_encode_ntluf_GPRv_R(xes,xed3_operand_get_reg0(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_P2);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][0]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay) return 1;
   }
     }
   return 0;
   (void) okay;
   (void) conditions_satisfied;
   (void) xes;
}
xed_bool_t xed_encode_group_154(xed_encoder_request_t* xes)
{
   xed_bool_t okay=1;
   xed_bool_t conditions_satisfied=0;
   xed_ptrn_func_ptr_t fb_ptrn_function;
   static const xed_uint16_t iform_ids[1][2] = {
   /*REP_MOVSB     */    {1016,1017,},
   };
   xed_uint8_t iclass_index = xed_encoder_get_iclasses_index_in_group(xes);
   if (xes->_n_operand_order == 0) {
   conditions_satisfied = 1;
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][0]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_OVERRIDE_SEG1_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 0) {
   conditions_satisfied = 1;
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][1]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_OVERRIDE_SEG1_BIND(xes);
       if (okay) return 1;
   }
     }
   return 0;
   (void) okay;
   (void) conditions_satisfied;
   (void) xes;
}
xed_bool_t xed_encode_group_155(xed_encoder_request_t* xes)
{
   xed_bool_t okay=1;
   xed_bool_t conditions_satisfied=0;
   xed_ptrn_func_ptr_t fb_ptrn_function;
   static const xed_uint16_t iform_ids[1][1] = {
   /*LDDQU         */    {1018,},
   };
   xed_uint8_t iclass_index = xed_encoder_get_iclasses_index_in_group(xes);
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_MEM0) {
   conditions_satisfied = xed_encode_ntluf_XMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_DQ);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][0]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_IGNORE66_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay) return 1;
   }
     }
   return 0;
   (void) okay;
   (void) conditions_satisfied;
   (void) xes;
}
xed_bool_t xed_encode_group_156(xed_encoder_request_t* xes)
{
   xed_bool_t okay=1;
   xed_bool_t conditions_satisfied=0;
   xed_ptrn_func_ptr_t fb_ptrn_function;
   static const xed_uint16_t iform_ids[2][4] = {
   /*VINSERTF32X4  */    {1021,1019,1022,1020,},
   /*VINSERTI32X4  */    {5943,5941,5944,5942,},
   };
   xed_uint8_t iclass_index = xed_encoder_get_iclasses_index_in_group(xes);
   if (xes->_n_operand_order == 5 && memcmp(xed_encode_order[18], xes->_operand_order, sizeof(xed_uint8_t)*5)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 1) &&
		 xed_encode_ntluf_YMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_YMM_N3(xes,xed3_operand_get_reg2(xes)) &&
		 xed_encode_ntluf_XMM_B3(xes,xed3_operand_get_reg3(xes)) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][0]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_UIMM8_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 5 && memcmp(xed_encode_order[18], xes->_operand_order, sizeof(xed_uint8_t)*5)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 2) &&
		 xed_encode_ntluf_ZMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_ZMM_N3(xes,xed3_operand_get_reg2(xes)) &&
		 xed_encode_ntluf_XMM_B3(xes,xed3_operand_get_reg3(xes)) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][1]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_UIMM8_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 5 && memcmp(xed_encode_order[19], xes->_operand_order, sizeof(xed_uint8_t)*5)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 1) &&
		 xed_encode_ntluf_YMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_YMM_N3(xes,xed3_operand_get_reg2(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_DQ) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][2]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_UIMM8_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_32_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_TUPLE4_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 5 && memcmp(xed_encode_order[19], xes->_operand_order, sizeof(xed_uint8_t)*5)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 2) &&
		 xed_encode_ntluf_ZMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_ZMM_N3(xes,xed3_operand_get_reg2(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_DQ) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][3]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_UIMM8_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_32_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_TUPLE4_BIND(xes);
       if (okay) return 1;
   }
     }
   return 0;
   (void) okay;
   (void) conditions_satisfied;
   (void) xes;
}
xed_bool_t xed_encode_group_157(xed_encoder_request_t* xes)
{
   xed_bool_t okay=1;
   xed_bool_t conditions_satisfied=0;
   xed_ptrn_func_ptr_t fb_ptrn_function;
   static const xed_uint16_t iform_ids[2][2] = {
   /*MOVHPD        */    {3761,3760,},
   /*MOVLPD        */    {1026,1025,},
   };
   xed_uint8_t iclass_index = xed_encoder_get_iclasses_index_in_group(xes);
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_MEM0 && xes->_operand_order[1] == XED_OPERAND_REG0) {
   conditions_satisfied = (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_Q) &&
		 xed_encode_ntluf_XMM_R(xes,xed3_operand_get_reg0(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][0]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_REFINING66_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_MEM0) {
   conditions_satisfied = xed_encode_ntluf_XMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_Q);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][1]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_REFINING66_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay) return 1;
   }
     }
   return 0;
   (void) okay;
   (void) conditions_satisfied;
   (void) xes;
}
xed_bool_t xed_encode_group_158(xed_encoder_request_t* xes)
{
   xed_bool_t okay=1;
   xed_bool_t conditions_satisfied=0;
   xed_ptrn_func_ptr_t fb_ptrn_function;
   static const xed_uint16_t iform_ids[1][60] = {
   /*NOP           */    {1052,1051,1053,1054,1082,1059,1060,1056,1057,1058,1027,1028,1029,1030,1032,1034,1036,1038,1040,1048,1055,1064,1065,1066,1067,1068,1069,1070,1071,1072,1073,1074,1075,1076,1077,1078,1079,1080,1081,1093,1031,1033,1035,1037,1039,1047,1063,1083,1084,1085,1086,1087,1088,1089,1090,1091,1092,1094,1061,1062,},
   };
   xed_uint8_t iclass_index = xed_encoder_get_iclasses_index_in_group(xes);
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_REG1) {
   conditions_satisfied = xed_encode_ntluf_GPRv_B(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_GPRv_R(xes,xed3_operand_get_reg1(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][0]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_MEM0 && xes->_operand_order[1] == XED_OPERAND_REG0) {
   conditions_satisfied = (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_V) &&
		 xed_encode_ntluf_GPRv_R(xes,xed3_operand_get_reg0(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][1]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 0) {
   conditions_satisfied = 1;
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][2]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 0) {
   conditions_satisfied = 1;
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][3]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_REG1) {
   conditions_satisfied = (xed3_operand_get_mode(xes) == 2) &&
		 xed_encode_ntluf_GPRv_B(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_GPRv_R(xes,xed3_operand_get_reg1(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][4]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_REG1) {
   conditions_satisfied = (xed3_operand_get_mpxmode(xes) == 0) &&
		 xed_encode_ntluf_GPRv_B(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_GPRv_R(xes,xed3_operand_get_reg1(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][5]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_REG1) {
   conditions_satisfied = (xed3_operand_get_mpxmode(xes) == 0) &&
		 xed_encode_ntluf_GPRv_B(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_GPRv_R(xes,xed3_operand_get_reg1(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][6]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_REG1) {
   conditions_satisfied = (xed3_operand_get_mpxmode(xes) == 1) &&
		 xed_encode_ntluf_GPRv_B(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_GPRv_R(xes,xed3_operand_get_reg1(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][7]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_REG1) {
   conditions_satisfied = (xed3_operand_get_mpxmode(xes) == 1) &&
		 xed_encode_ntluf_GPRv_B(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_GPRv_R(xes,xed3_operand_get_reg1(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][8]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_REG1) {
   conditions_satisfied = (xed3_operand_get_mpxmode(xes) == 1) &&
		 xed_encode_ntluf_GPRv_B(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_GPRv_R(xes,xed3_operand_get_reg1(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][9]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 1 && xes->_operand_order[0] == XED_OPERAND_REG0) {
   conditions_satisfied = xed_encode_ntluf_GPRv_B(xes,xed3_operand_get_reg0(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][10]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 1 && xes->_operand_order[0] == XED_OPERAND_REG0) {
   conditions_satisfied = xed_encode_ntluf_GPRv_B(xes,xed3_operand_get_reg0(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][11]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 1 && xes->_operand_order[0] == XED_OPERAND_REG0) {
   conditions_satisfied = xed_encode_ntluf_GPRv_B(xes,xed3_operand_get_reg0(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][12]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 1 && xes->_operand_order[0] == XED_OPERAND_REG0) {
   conditions_satisfied = xed_encode_ntluf_GPRv_B(xes,xed3_operand_get_reg0(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][13]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 1 && xes->_operand_order[0] == XED_OPERAND_REG0) {
   conditions_satisfied = xed_encode_ntluf_GPRv_B(xes,xed3_operand_get_reg0(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][14]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 1 && xes->_operand_order[0] == XED_OPERAND_REG0) {
   conditions_satisfied = xed_encode_ntluf_GPRv_B(xes,xed3_operand_get_reg0(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][15]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 1 && xes->_operand_order[0] == XED_OPERAND_REG0) {
   conditions_satisfied = xed_encode_ntluf_GPRv_B(xes,xed3_operand_get_reg0(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][16]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 1 && xes->_operand_order[0] == XED_OPERAND_REG0) {
   conditions_satisfied = xed_encode_ntluf_GPRv_B(xes,xed3_operand_get_reg0(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][17]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_REG1) {
   conditions_satisfied = xed_encode_ntluf_GPRv_B(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_GPRv_R(xes,xed3_operand_get_reg1(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][18]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_REG1) {
   conditions_satisfied = xed_encode_ntluf_GPRv_B(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_GPRv_R(xes,xed3_operand_get_reg1(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][19]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_REG1) {
   conditions_satisfied = xed_encode_ntluf_GPRv_B(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_GPRv_R(xes,xed3_operand_get_reg1(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][20]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_REG1) {
   conditions_satisfied = xed_encode_ntluf_GPRv_B(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_GPRv_R(xes,xed3_operand_get_reg1(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][21]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_REG1) {
   conditions_satisfied = xed_encode_ntluf_GPRv_B(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_GPRv_R(xes,xed3_operand_get_reg1(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][22]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_REG1) {
   conditions_satisfied = xed_encode_ntluf_GPRv_B(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_GPRv_R(xes,xed3_operand_get_reg1(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][23]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_REG1) {
   conditions_satisfied = xed_encode_ntluf_GPRv_B(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_GPRv_R(xes,xed3_operand_get_reg1(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][24]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_REG1) {
   conditions_satisfied = xed_encode_ntluf_GPRv_B(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_GPRv_R(xes,xed3_operand_get_reg1(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][25]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_REG1) {
   conditions_satisfied = xed_encode_ntluf_GPRv_B(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_GPRv_R(xes,xed3_operand_get_reg1(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][26]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_REG1) {
   conditions_satisfied = xed_encode_ntluf_GPRv_B(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_GPRv_R(xes,xed3_operand_get_reg1(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][27]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_REG1) {
   conditions_satisfied = xed_encode_ntluf_GPRv_B(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_GPRv_R(xes,xed3_operand_get_reg1(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][28]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_REG1) {
   conditions_satisfied = xed_encode_ntluf_GPRv_B(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_GPRv_R(xes,xed3_operand_get_reg1(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][29]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_REG1) {
   conditions_satisfied = xed_encode_ntluf_GPRv_B(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_GPRv_R(xes,xed3_operand_get_reg1(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][30]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_REG1) {
   conditions_satisfied = xed_encode_ntluf_GPRv_B(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_GPRv_R(xes,xed3_operand_get_reg1(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][31]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_REG1) {
   conditions_satisfied = xed_encode_ntluf_GPRv_B(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_GPRv_R(xes,xed3_operand_get_reg1(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][32]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_REG1) {
   conditions_satisfied = xed_encode_ntluf_GPRv_B(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_GPRv_R(xes,xed3_operand_get_reg1(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][33]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_REG1) {
   conditions_satisfied = xed_encode_ntluf_GPRv_B(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_GPRv_R(xes,xed3_operand_get_reg1(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][34]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_REG1) {
   conditions_satisfied = xed_encode_ntluf_GPRv_B(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_GPRv_R(xes,xed3_operand_get_reg1(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][35]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_REG1) {
   conditions_satisfied = xed_encode_ntluf_GPRv_B(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_GPRv_R(xes,xed3_operand_get_reg1(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][36]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_REG1) {
   conditions_satisfied = xed_encode_ntluf_GPRv_B(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_GPRv_R(xes,xed3_operand_get_reg1(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][37]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_REG1) {
   conditions_satisfied = xed_encode_ntluf_GPRv_B(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_GPRv_R(xes,xed3_operand_get_reg1(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][38]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_REG1) {
   conditions_satisfied = xed_encode_ntluf_GPRv_B(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_GPRv_R(xes,xed3_operand_get_reg1(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][39]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 1 && xes->_operand_order[0] == XED_OPERAND_MEM0) {
   conditions_satisfied = (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_V);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][40]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 1 && xes->_operand_order[0] == XED_OPERAND_MEM0) {
   conditions_satisfied = (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_V);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][41]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 1 && xes->_operand_order[0] == XED_OPERAND_MEM0) {
   conditions_satisfied = (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_V);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][42]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 1 && xes->_operand_order[0] == XED_OPERAND_MEM0) {
   conditions_satisfied = (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_V);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][43]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_MEM0 && xes->_operand_order[1] == XED_OPERAND_REG0) {
   conditions_satisfied = (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_V) &&
		 xed_encode_ntluf_GPRv_R(xes,xed3_operand_get_reg0(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][44]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_MEM0 && xes->_operand_order[1] == XED_OPERAND_REG0) {
   conditions_satisfied = (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_V) &&
		 xed_encode_ntluf_GPRv_R(xes,xed3_operand_get_reg0(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][45]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_MEM0 && xes->_operand_order[1] == XED_OPERAND_REG0) {
   conditions_satisfied = (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_V) &&
		 xed_encode_ntluf_GPRv_R(xes,xed3_operand_get_reg0(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][46]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_MEM0 && xes->_operand_order[1] == XED_OPERAND_REG0) {
   conditions_satisfied = (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_V) &&
		 xed_encode_ntluf_GPRv_R(xes,xed3_operand_get_reg0(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][47]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_MEM0 && xes->_operand_order[1] == XED_OPERAND_REG0) {
   conditions_satisfied = (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_V) &&
		 xed_encode_ntluf_GPRv_R(xes,xed3_operand_get_reg0(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][48]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_MEM0 && xes->_operand_order[1] == XED_OPERAND_REG0) {
   conditions_satisfied = (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_V) &&
		 xed_encode_ntluf_GPRv_R(xes,xed3_operand_get_reg0(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][49]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_MEM0 && xes->_operand_order[1] == XED_OPERAND_REG0) {
   conditions_satisfied = (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_V) &&
		 xed_encode_ntluf_GPRv_R(xes,xed3_operand_get_reg0(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][50]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_MEM0 && xes->_operand_order[1] == XED_OPERAND_REG0) {
   conditions_satisfied = (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_V) &&
		 xed_encode_ntluf_GPRv_R(xes,xed3_operand_get_reg0(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][51]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_MEM0 && xes->_operand_order[1] == XED_OPERAND_REG0) {
   conditions_satisfied = (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_V) &&
		 xed_encode_ntluf_GPRv_R(xes,xed3_operand_get_reg0(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][52]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_MEM0 && xes->_operand_order[1] == XED_OPERAND_REG0) {
   conditions_satisfied = (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_V) &&
		 xed_encode_ntluf_GPRv_R(xes,xed3_operand_get_reg0(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][53]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_MEM0 && xes->_operand_order[1] == XED_OPERAND_REG0) {
   conditions_satisfied = (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_V) &&
		 xed_encode_ntluf_GPRv_R(xes,xed3_operand_get_reg0(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][54]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_MEM0 && xes->_operand_order[1] == XED_OPERAND_REG0) {
   conditions_satisfied = (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_V) &&
		 xed_encode_ntluf_GPRv_R(xes,xed3_operand_get_reg0(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][55]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_MEM0 && xes->_operand_order[1] == XED_OPERAND_REG0) {
   conditions_satisfied = (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_V) &&
		 xed_encode_ntluf_GPRv_R(xes,xed3_operand_get_reg0(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][56]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_MEM0 && xes->_operand_order[1] == XED_OPERAND_REG0) {
   conditions_satisfied = (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_V) &&
		 xed_encode_ntluf_GPRv_R(xes,xed3_operand_get_reg0(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][57]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_MEM0) {
   conditions_satisfied = (xed3_operand_get_mpxmode(xes) == 0) &&
		 xed_encode_ntluf_GPRv_B(xes,xed3_operand_get_reg0(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_V);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][58]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_MEM0) {
   conditions_satisfied = (xed3_operand_get_mpxmode(xes) == 0) &&
		 xed_encode_ntluf_GPRv_B(xes,xed3_operand_get_reg0(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_V);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][59]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay) return 1;
   }
     }
   return 0;
   (void) okay;
   (void) conditions_satisfied;
   (void) xes;
}
xed_bool_t xed_encode_group_159(xed_encoder_request_t* xes)
{
   xed_bool_t okay=1;
   xed_bool_t conditions_satisfied=0;
   xed_ptrn_func_ptr_t fb_ptrn_function;
   static const xed_uint16_t iform_ids[2][7] = {
   /*VFIXUPIMMPS   */    {1096,1098,1100,1095,1099,1101,1097,},
   /*VRANGEPS      */    {6468,6463,6465,6467,6464,6466,6469,},
   };
   xed_uint8_t iclass_index = xed_encoder_get_iclasses_index_in_group(xes);
   if (xes->_n_operand_order == 5 && memcmp(xed_encode_order[18], xes->_operand_order, sizeof(xed_uint8_t)*5)==0) {
   conditions_satisfied = (xed3_operand_get_sae(xes) != 0) &&
		 xed_encode_ntluf_ZMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_ZMM_N3(xes,xed3_operand_get_reg2(xes)) &&
		 xed_encode_ntluf_ZMM_B3(xes,xed3_operand_get_reg3(xes)) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][0]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_FIX_ROUND_LEN512_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_SAE_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_UIMM8_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 5 && memcmp(xed_encode_order[18], xes->_operand_order, sizeof(xed_uint8_t)*5)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 xed_encode_ntluf_XMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_XMM_N3(xes,xed3_operand_get_reg2(xes)) &&
		 xed_encode_ntluf_XMM_B3(xes,xed3_operand_get_reg3(xes)) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][1]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_UIMM8_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 5 && memcmp(xed_encode_order[18], xes->_operand_order, sizeof(xed_uint8_t)*5)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 1) &&
		 xed_encode_ntluf_YMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_YMM_N3(xes,xed3_operand_get_reg2(xes)) &&
		 xed_encode_ntluf_YMM_B3(xes,xed3_operand_get_reg3(xes)) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][2]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_UIMM8_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 5 && memcmp(xed_encode_order[18], xes->_operand_order, sizeof(xed_uint8_t)*5)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 2) &&
		 xed_encode_ntluf_ZMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_ZMM_N3(xes,xed3_operand_get_reg2(xes)) &&
		 xed_encode_ntluf_ZMM_B3(xes,xed3_operand_get_reg3(xes)) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][3]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_UIMM8_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 5 && memcmp(xed_encode_order[19], xes->_operand_order, sizeof(xed_uint8_t)*5)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 xed_encode_ntluf_XMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_XMM_N3(xes,xed3_operand_get_reg2(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_VV) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][4]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_UIMM8_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_32_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_FULL_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 5 && memcmp(xed_encode_order[19], xes->_operand_order, sizeof(xed_uint8_t)*5)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 1) &&
		 xed_encode_ntluf_YMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_YMM_N3(xes,xed3_operand_get_reg2(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_VV) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][5]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_UIMM8_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_32_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_FULL_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 5 && memcmp(xed_encode_order[19], xes->_operand_order, sizeof(xed_uint8_t)*5)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 2) &&
		 xed_encode_ntluf_ZMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_ZMM_N3(xes,xed3_operand_get_reg2(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_VV) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][6]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_UIMM8_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_32_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_FULL_BIND(xes);
       if (okay) return 1;
   }
     }
   return 0;
   (void) okay;
   (void) conditions_satisfied;
   (void) xes;
}
xed_bool_t xed_encode_group_160(xed_encoder_request_t* xes)
{
   xed_bool_t okay=1;
   xed_bool_t conditions_satisfied=0;
   xed_ptrn_func_ptr_t fb_ptrn_function;
   static const xed_uint16_t iform_ids[2][7] = {
   /*VCVTPS2UDQ    */    {1103,1105,1107,1102,1106,1108,1104,},
   /*VCVTUDQ2PS    */    {1833,1835,1837,1832,1836,1838,1834,},
   };
   xed_uint8_t iclass_index = xed_encoder_get_iclasses_index_in_group(xes);
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[7], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_roundc(xes) != 0) &&
		 xed_encode_ntluf_ZMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_ZMM_B3(xes,xed3_operand_get_reg2(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][0]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_FIX_ROUND_LEN512_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_AVX512_ROUND_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[7], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 xed_encode_ntluf_XMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_XMM_B3(xes,xed3_operand_get_reg2(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][1]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[7], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 1) &&
		 xed_encode_ntluf_YMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_YMM_B3(xes,xed3_operand_get_reg2(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][2]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[7], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 2) &&
		 xed_encode_ntluf_ZMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_ZMM_B3(xes,xed3_operand_get_reg2(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][3]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[14], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 xed_encode_ntluf_XMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_VV);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][4]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_32_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_FULL_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[14], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 1) &&
		 xed_encode_ntluf_YMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_VV);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][5]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_32_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_FULL_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[14], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 2) &&
		 xed_encode_ntluf_ZMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_VV);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][6]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_32_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_FULL_BIND(xes);
       if (okay) return 1;
   }
     }
   return 0;
   (void) okay;
   (void) conditions_satisfied;
   (void) xes;
}
xed_bool_t xed_encode_group_161(xed_encoder_request_t* xes)
{
   xed_bool_t okay=1;
   xed_bool_t conditions_satisfied=0;
   xed_ptrn_func_ptr_t fb_ptrn_function;
   static const xed_uint16_t iform_ids[1][6] = {
   /*VP2INTERSECTQ */    {1117,1119,1121,1118,1120,1122,},
   };
   xed_uint8_t iclass_index = xed_encoder_get_iclasses_index_in_group(xes);
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[7], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 xed_encode_ntluf_MASK_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_XMM_N3(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_XMM_B3(xes,xed3_operand_get_reg2(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][0]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[7], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 1) &&
		 xed_encode_ntluf_MASK_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_YMM_N3(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_YMM_B3(xes,xed3_operand_get_reg2(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][1]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[7], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 2) &&
		 xed_encode_ntluf_MASK_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_ZMM_N3(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_ZMM_B3(xes,xed3_operand_get_reg2(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][2]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[14], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 xed_encode_ntluf_MASK_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_XMM_N3(xes,xed3_operand_get_reg1(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_VV);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][3]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_64_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_FULL_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[14], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 1) &&
		 xed_encode_ntluf_MASK_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_YMM_N3(xes,xed3_operand_get_reg1(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_VV);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][4]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_64_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_FULL_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[14], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 2) &&
		 xed_encode_ntluf_MASK_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_ZMM_N3(xes,xed3_operand_get_reg1(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_VV);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][5]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_64_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_FULL_BIND(xes);
       if (okay) return 1;
   }
     }
   return 0;
   (void) okay;
   (void) conditions_satisfied;
   (void) xes;
}
xed_bool_t xed_encode_group_162(xed_encoder_request_t* xes)
{
   xed_bool_t okay=1;
   xed_bool_t conditions_satisfied=0;
   xed_ptrn_func_ptr_t fb_ptrn_function;
   static const xed_uint16_t iform_ids[1][5] = {
   /*FCOMP         */    {1124,1125,1126,1127,1123,},
   };
   xed_uint8_t iclass_index = xed_encoder_get_iclasses_index_in_group(xes);
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_REG1) {
   conditions_satisfied = (xed3_operand_get_reg0(xes) == XED_REG_ST0) &&
		 xed_encode_ntluf_X87(xes,xed3_operand_get_reg1(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][0]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_REG1) {
   conditions_satisfied = (xed3_operand_get_reg0(xes) == XED_REG_ST0) &&
		 xed_encode_ntluf_X87(xes,xed3_operand_get_reg1(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][1]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_REG1) {
   conditions_satisfied = (xed3_operand_get_reg0(xes) == XED_REG_ST0) &&
		 xed_encode_ntluf_X87(xes,xed3_operand_get_reg1(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][2]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_MEM0) {
   conditions_satisfied = (xed3_operand_get_reg0(xes) == XED_REG_ST0) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_M64REAL);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][3]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_MEM0) {
   conditions_satisfied = (xed3_operand_get_reg0(xes) == XED_REG_ST0) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_MEM32REAL);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][4]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay) return 1;
   }
     }
   return 0;
   (void) okay;
   (void) conditions_satisfied;
   (void) xes;
}
xed_bool_t xed_encode_group_163(xed_encoder_request_t* xes)
{
   xed_bool_t okay=1;
   xed_bool_t conditions_satisfied=0;
   xed_ptrn_func_ptr_t fb_ptrn_function;
   static const xed_uint16_t iform_ids[1][5] = {
   /*VMOVNTPD      */    {1144,1145,1147,1148,1146,},
   };
   xed_uint8_t iclass_index = xed_encoder_get_iclasses_index_in_group(xes);
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_MEM0 && xes->_operand_order[1] == XED_OPERAND_REG0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 (xed3_operand_get_must_use_evex(xes) == 0) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_DQ) &&
		 xed_encode_ntluf_XMM_R(xes,xed3_operand_get_reg0(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][0]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_MEM0 && xes->_operand_order[1] == XED_OPERAND_REG0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 1) &&
		 (xed3_operand_get_must_use_evex(xes) == 0) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_QQ) &&
		 xed_encode_ntluf_YMM_R(xes,xed3_operand_get_reg0(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][1]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_MEM0 && xes->_operand_order[1] == XED_OPERAND_REG0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_DQ) &&
		 xed_encode_ntluf_XMM_R3(xes,xed3_operand_get_reg0(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][2]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_64_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_FULLMEM_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_MEM0 && xes->_operand_order[1] == XED_OPERAND_REG0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 1) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_QQ) &&
		 xed_encode_ntluf_YMM_R3(xes,xed3_operand_get_reg0(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][3]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_64_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_FULLMEM_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_MEM0 && xes->_operand_order[1] == XED_OPERAND_REG0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 2) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_ZD) &&
		 xed_encode_ntluf_ZMM_R3(xes,xed3_operand_get_reg0(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][4]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_64_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_FULLMEM_BIND(xes);
       if (okay) return 1;
   }
     }
   return 0;
   (void) okay;
   (void) conditions_satisfied;
   (void) xes;
}
xed_bool_t xed_encode_group_164(xed_encoder_request_t* xes)
{
   xed_bool_t okay=1;
   xed_bool_t conditions_satisfied=0;
   xed_ptrn_func_ptr_t fb_ptrn_function;
   static const xed_uint16_t iform_ids[1][11] = {
   /*VCMPPD        */    {1154,1150,1152,1149,1151,1156,1158,1153,1157,1159,1155,},
   };
   xed_uint8_t iclass_index = xed_encoder_get_iclasses_index_in_group(xes);
   if (xes->_n_operand_order == 5 && memcmp(xed_encode_order[18], xes->_operand_order, sizeof(xed_uint8_t)*5)==0) {
   conditions_satisfied = (xed3_operand_get_sae(xes) != 0) &&
		 xed_encode_ntluf_MASK_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_ZMM_N3(xes,xed3_operand_get_reg2(xes)) &&
		 xed_encode_ntluf_ZMM_B3(xes,xed3_operand_get_reg3(xes)) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][0]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_FIX_ROUND_LEN512_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_SAE_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_UIMM8_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 4 && memcmp(xed_encode_order[21], xes->_operand_order, sizeof(xed_uint8_t)*4)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 (xed3_operand_get_must_use_evex(xes) == 0) &&
		 xed_encode_ntluf_XMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_XMM_N(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_XMM_B(xes,xed3_operand_get_reg2(xes)) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][1]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_UIMM8_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 4 && memcmp(xed_encode_order[21], xes->_operand_order, sizeof(xed_uint8_t)*4)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 1) &&
		 (xed3_operand_get_must_use_evex(xes) == 0) &&
		 xed_encode_ntluf_YMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_YMM_N(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_YMM_B(xes,xed3_operand_get_reg2(xes)) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][2]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_UIMM8_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 4 && memcmp(xed_encode_order[22], xes->_operand_order, sizeof(xed_uint8_t)*4)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 (xed3_operand_get_must_use_evex(xes) == 0) &&
		 xed_encode_ntluf_XMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_XMM_N(xes,xed3_operand_get_reg1(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_DQ) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][3]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_UIMM8_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 4 && memcmp(xed_encode_order[22], xes->_operand_order, sizeof(xed_uint8_t)*4)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 1) &&
		 (xed3_operand_get_must_use_evex(xes) == 0) &&
		 xed_encode_ntluf_YMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_YMM_N(xes,xed3_operand_get_reg1(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_QQ) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][4]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_UIMM8_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 5 && memcmp(xed_encode_order[18], xes->_operand_order, sizeof(xed_uint8_t)*5)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 xed_encode_ntluf_MASK_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_XMM_N3(xes,xed3_operand_get_reg2(xes)) &&
		 xed_encode_ntluf_XMM_B3(xes,xed3_operand_get_reg3(xes)) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][5]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_UIMM8_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 5 && memcmp(xed_encode_order[18], xes->_operand_order, sizeof(xed_uint8_t)*5)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 1) &&
		 xed_encode_ntluf_MASK_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_YMM_N3(xes,xed3_operand_get_reg2(xes)) &&
		 xed_encode_ntluf_YMM_B3(xes,xed3_operand_get_reg3(xes)) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][6]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_UIMM8_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 5 && memcmp(xed_encode_order[18], xes->_operand_order, sizeof(xed_uint8_t)*5)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 2) &&
		 xed_encode_ntluf_MASK_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_ZMM_N3(xes,xed3_operand_get_reg2(xes)) &&
		 xed_encode_ntluf_ZMM_B3(xes,xed3_operand_get_reg3(xes)) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][7]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_UIMM8_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 5 && memcmp(xed_encode_order[19], xes->_operand_order, sizeof(xed_uint8_t)*5)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 xed_encode_ntluf_MASK_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_XMM_N3(xes,xed3_operand_get_reg2(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_VV) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][8]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_UIMM8_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_64_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_FULL_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 5 && memcmp(xed_encode_order[19], xes->_operand_order, sizeof(xed_uint8_t)*5)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 1) &&
		 xed_encode_ntluf_MASK_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_YMM_N3(xes,xed3_operand_get_reg2(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_VV) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][9]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_UIMM8_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_64_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_FULL_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 5 && memcmp(xed_encode_order[19], xes->_operand_order, sizeof(xed_uint8_t)*5)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 2) &&
		 xed_encode_ntluf_MASK_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_ZMM_N3(xes,xed3_operand_get_reg2(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_VV) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][10]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_UIMM8_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_64_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_FULL_BIND(xes);
       if (okay) return 1;
   }
     }
   return 0;
   (void) okay;
   (void) conditions_satisfied;
   (void) xes;
}
xed_bool_t xed_encode_group_165(xed_encoder_request_t* xes)
{
   xed_bool_t okay=1;
   xed_bool_t conditions_satisfied=0;
   xed_ptrn_func_ptr_t fb_ptrn_function;
   static const xed_uint16_t iform_ids[2][7] = {
   /*FLDENV        */    {5134,5137,5135,5138,5136,5139,5140,},
   /*FNSTENV       */    {1174,1177,1175,1178,1176,1179,1180,},
   };
   xed_uint8_t iclass_index = xed_encoder_get_iclasses_index_in_group(xes);
   if (xes->_n_operand_order == 1 && xes->_operand_order[0] == XED_OPERAND_MEM0) {
   conditions_satisfied = (xed3_operand_get_mode(xes) == 0) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_MEM14);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][0]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 1 && xes->_operand_order[0] == XED_OPERAND_MEM0) {
   conditions_satisfied = (xed3_operand_get_mode(xes) == 0) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_MEM28);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][1]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 1 && xes->_operand_order[0] == XED_OPERAND_MEM0) {
   conditions_satisfied = (xed3_operand_get_mode(xes) == 1) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_MEM14);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][2]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 1 && xes->_operand_order[0] == XED_OPERAND_MEM0) {
   conditions_satisfied = (xed3_operand_get_mode(xes) == 1) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_MEM28);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][3]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 1 && xes->_operand_order[0] == XED_OPERAND_MEM0) {
   conditions_satisfied = (xed3_operand_get_mode(xes) == 2) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_MEM14);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][4]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 1 && xes->_operand_order[0] == XED_OPERAND_MEM0) {
   conditions_satisfied = (xed3_operand_get_mode(xes) == 2) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_MEM28);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][5]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 1 && xes->_operand_order[0] == XED_OPERAND_MEM0) {
   conditions_satisfied = (xed3_operand_get_mode(xes) == 2) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_MEM28);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][6]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay) return 1;
   }
     }
   return 0;
   (void) okay;
   (void) conditions_satisfied;
   (void) xes;
}
xed_bool_t xed_encode_group_166(xed_encoder_request_t* xes)
{
   xed_bool_t okay=1;
   xed_bool_t conditions_satisfied=0;
   xed_ptrn_func_ptr_t fb_ptrn_function;
   static const xed_uint16_t iform_ids[1][6] = {
   /*JMP           */    {1185,1183,1184,1186,1182,1181,},
   };
   xed_uint8_t iclass_index = xed_encoder_get_iclasses_index_in_group(xes);
   if (xes->_n_operand_order == 1 && xes->_operand_order[0] == XED_OPERAND_RELBR) {
   conditions_satisfied = (xed3_operand_get_mode(xes) != 2) &&
		 (xed3_operand_get_relbr(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][0]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_BRDISP8_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 1 && xes->_operand_order[0] == XED_OPERAND_RELBR) {
   conditions_satisfied = (xed3_operand_get_mode(xes) != 2) &&
		 (xed3_operand_get_relbr(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][1]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_BRDISPz_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 1 && xes->_operand_order[0] == XED_OPERAND_RELBR) {
   conditions_satisfied = (xed3_operand_get_mode(xes) == 2) &&
		 (xed3_operand_get_relbr(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][2]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_FORCE64_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_BRDISP32_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 1 && xes->_operand_order[0] == XED_OPERAND_RELBR) {
   conditions_satisfied = (xed3_operand_get_mode(xes) == 2) &&
		 (xed3_operand_get_relbr(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][3]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_FORCE64_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_BRDISP8_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 1 && xes->_operand_order[0] == XED_OPERAND_REG0) {
   conditions_satisfied = xed_encode_ntluf_GPRv_B(xes,xed3_operand_get_reg0(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][4]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_DF64_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_IMMUNE66_LOOP64_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 1 && xes->_operand_order[0] == XED_OPERAND_MEM0) {
   conditions_satisfied = (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_V);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][5]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_DF64_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_IMMUNE66_LOOP64_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay) return 1;
   }
     }
   return 0;
   (void) okay;
   (void) conditions_satisfied;
   (void) xes;
}
xed_bool_t xed_encode_group_167(xed_encoder_request_t* xes)
{
   xed_bool_t okay=1;
   xed_bool_t conditions_satisfied=0;
   xed_ptrn_func_ptr_t fb_ptrn_function;
   static const xed_uint16_t iform_ids[5][6] = {
   /*ADC_LOCK      */    {5364,5365,5360,5363,5361,5362,},
   /*ADD_LOCK      */    {1596,1597,1592,1595,1593,1594,},
   /*OR_LOCK       */    {3803,3804,3799,3802,3800,3801,},
   /*SBB_LOCK      */    {1197,1198,1193,1196,1194,1195,},
   /*SUB_LOCK      */    {5436,5437,5432,5435,5433,5434,},
   };
   xed_uint8_t iclass_index = xed_encoder_get_iclasses_index_in_group(xes);
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_MEM0 && xes->_operand_order[1] == XED_OPERAND_REG0) {
   conditions_satisfied = (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_B) &&
		 xed_encode_ntluf_GPR8_R(xes,xed3_operand_get_reg0(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][0]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_MEM0 && xes->_operand_order[1] == XED_OPERAND_REG0) {
   conditions_satisfied = (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_V) &&
		 xed_encode_ntluf_GPRv_R(xes,xed3_operand_get_reg0(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][1]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_MEM0 && xes->_operand_order[1] == XED_OPERAND_IMM0) {
   conditions_satisfied = (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_B) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][2]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_SIMM8_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_MEM0 && xes->_operand_order[1] == XED_OPERAND_IMM0) {
   conditions_satisfied = (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_V) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][3]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_SIMM8_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_MEM0 && xes->_operand_order[1] == XED_OPERAND_IMM0) {
   conditions_satisfied = (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_V) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][4]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_SIMMz_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_MEM0 && xes->_operand_order[1] == XED_OPERAND_IMM0) {
   conditions_satisfied = (xed3_operand_get_mode(xes) != 2) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_B) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][5]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_SIMM8_BIND(xes);
       if (okay) return 1;
   }
     }
   return 0;
   (void) okay;
   (void) conditions_satisfied;
   (void) xes;
}
xed_bool_t xed_encode_group_168(xed_encoder_request_t* xes)
{
   xed_bool_t okay=1;
   xed_bool_t conditions_satisfied=0;
   xed_ptrn_func_ptr_t fb_ptrn_function;
   static const xed_uint16_t iform_ids[23][6] = {
   /*VBLENDMPD     */    {4084,4086,4082,4085,4087,4083,},
   /*VPANDNQ       */    {5962,5964,5960,5963,5965,5961,},
   /*VPANDQ        */    {1235,1237,1233,1236,1238,1234,},
   /*VPBLENDMQ     */    {1202,1204,1200,1203,1205,1201,},
   /*VPERMI2PD     */    {1425,1427,1423,1426,1428,1424,},
   /*VPERMI2Q      */    {6925,6927,6923,6926,6928,6924,},
   /*VPERMT2PD     */    {1626,1628,1624,1627,1629,1625,},
   /*VPERMT2Q      */    {2380,2382,2378,2381,2383,2379,},
   /*VPMADD52HUQ   */    {6622,6624,6626,6623,6625,6627,},
   /*VPMADD52LUQ   */    {5405,5407,5409,5406,5408,5410,},
   /*VPMAXSQ       */    {2276,2278,2274,2277,2279,2275,},
   /*VPMAXUQ       */    {2021,2023,2019,2022,2024,2020,},
   /*VPMINSQ       */    {2061,2063,2059,2062,2064,2060,},
   /*VPMINUQ       */    {2824,2826,2822,2825,2827,2823,},
   /*VPMULLQ       */    {5188,5190,5192,5189,5191,5193,},
   /*VPMULTISHIFTQB*/    {6503,6505,6507,6504,6506,6508,},
   /*VPORQ         */    {5607,5609,5605,5608,5610,5606,},
   /*VPROLVQ       */    {4157,4159,4155,4158,4160,4156,},
   /*VPRORVQ       */    {6958,6960,6956,6959,6961,6957,},
   /*VPSHLDVQ      */    {6943,6945,6947,6944,6946,6948,},
   /*VPSHRDVQ      */    {6741,6743,6745,6742,6744,6746,},
   /*VPSRAVQ       */    {3930,3932,3928,3931,3933,3929,},
   /*VPXORQ        */    {6655,6657,6653,6656,6658,6654,},
   };
   xed_uint8_t iclass_index = xed_encoder_get_iclasses_index_in_group(xes);
   if (xes->_n_operand_order == 4 && memcmp(xed_encode_order[12], xes->_operand_order, sizeof(xed_uint8_t)*4)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 xed_encode_ntluf_XMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_XMM_N3(xes,xed3_operand_get_reg2(xes)) &&
		 xed_encode_ntluf_XMM_B3(xes,xed3_operand_get_reg3(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][0]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 4 && memcmp(xed_encode_order[12], xes->_operand_order, sizeof(xed_uint8_t)*4)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 1) &&
		 xed_encode_ntluf_YMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_YMM_N3(xes,xed3_operand_get_reg2(xes)) &&
		 xed_encode_ntluf_YMM_B3(xes,xed3_operand_get_reg3(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][1]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 4 && memcmp(xed_encode_order[12], xes->_operand_order, sizeof(xed_uint8_t)*4)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 2) &&
		 xed_encode_ntluf_ZMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_ZMM_N3(xes,xed3_operand_get_reg2(xes)) &&
		 xed_encode_ntluf_ZMM_B3(xes,xed3_operand_get_reg3(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][2]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 4 && memcmp(xed_encode_order[13], xes->_operand_order, sizeof(xed_uint8_t)*4)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 xed_encode_ntluf_XMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_XMM_N3(xes,xed3_operand_get_reg2(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_VV);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][3]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_64_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_FULL_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 4 && memcmp(xed_encode_order[13], xes->_operand_order, sizeof(xed_uint8_t)*4)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 1) &&
		 xed_encode_ntluf_YMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_YMM_N3(xes,xed3_operand_get_reg2(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_VV);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][4]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_64_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_FULL_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 4 && memcmp(xed_encode_order[13], xes->_operand_order, sizeof(xed_uint8_t)*4)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 2) &&
		 xed_encode_ntluf_ZMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_ZMM_N3(xes,xed3_operand_get_reg2(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_VV);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][5]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_64_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_FULL_BIND(xes);
       if (okay) return 1;
   }
     }
   return 0;
   (void) okay;
   (void) conditions_satisfied;
   (void) xes;
}
xed_bool_t xed_encode_group_169(xed_encoder_request_t* xes)
{
   xed_bool_t okay=1;
   xed_bool_t conditions_satisfied=0;
   xed_ptrn_func_ptr_t fb_ptrn_function;
   static const xed_uint16_t iform_ids[2][1] = {
   /*WRSSQ         */    {1207,},
   /*WRUSSQ        */    {4814,},
   };
   xed_uint8_t iclass_index = xed_encoder_get_iclasses_index_in_group(xes);
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_MEM0 && xes->_operand_order[1] == XED_OPERAND_REG0) {
   conditions_satisfied = (xed3_operand_get_mode(xes) == 2) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_Q) &&
		 xed_encode_ntluf_GPR64_R(xes,xed3_operand_get_reg0(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][0]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay) return 1;
   }
     }
   return 0;
   (void) okay;
   (void) conditions_satisfied;
   (void) xes;
}
xed_bool_t xed_encode_group_170(xed_encoder_request_t* xes)
{
   xed_bool_t okay=1;
   xed_bool_t conditions_satisfied=0;
   xed_ptrn_func_ptr_t fb_ptrn_function;
   static const xed_uint16_t iform_ids[2][1] = {
   /*VMLOAD        */    {1208,},
   /*VMRUN         */    {4270,},
   };
   xed_uint8_t iclass_index = xed_encoder_get_iclasses_index_in_group(xes);
   if (xes->_n_operand_order == 1 && xes->_operand_order[0] == XED_OPERAND_REG0) {
   conditions_satisfied = xed_encode_ntluf_ArAX(xes,xed3_operand_get_reg0(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][0]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   return 0;
   (void) okay;
   (void) conditions_satisfied;
   (void) xes;
}
xed_bool_t xed_encode_group_171(xed_encoder_request_t* xes)
{
   xed_bool_t okay=1;
   xed_bool_t conditions_satisfied=0;
   xed_ptrn_func_ptr_t fb_ptrn_function;
   static const xed_uint16_t iform_ids[1][1] = {
   /*PSMASH        */    {1209,},
   };
   xed_uint8_t iclass_index = xed_encoder_get_iclasses_index_in_group(xes);
   if (xes->_n_operand_order == 1 && xes->_operand_order[0] == XED_OPERAND_REG0) {
   conditions_satisfied = (xed3_operand_get_mode(xes) == 2) &&
		 (xed3_operand_get_reg0(xes) == XED_REG_RAX);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][0]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   return 0;
   (void) okay;
   (void) conditions_satisfied;
   (void) xes;
}
xed_bool_t xed_encode_group_172(xed_encoder_request_t* xes)
{
   xed_bool_t okay=1;
   xed_bool_t conditions_satisfied=0;
   xed_ptrn_func_ptr_t fb_ptrn_function;
   static const xed_uint16_t iform_ids[1][2] = {
   /*PEXTRW_SSE4   */    {1211,1210,},
   };
   xed_uint8_t iclass_index = xed_encoder_get_iclasses_index_in_group(xes);
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[15], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = xed_encode_ntluf_GPR32_B(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_XMM_R(xes,xed3_operand_get_reg1(xes)) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][0]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_REFINING66_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_UIMM8_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[17], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_W) &&
		 xed_encode_ntluf_XMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][1]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_REFINING66_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_UIMM8_BIND(xes);
       if (okay) return 1;
   }
     }
   return 0;
   (void) okay;
   (void) conditions_satisfied;
   (void) xes;
}
xed_bool_t xed_encode_group_173(xed_encoder_request_t* xes)
{
   xed_bool_t okay=1;
   xed_bool_t conditions_satisfied=0;
   xed_ptrn_func_ptr_t fb_ptrn_function;
   static const xed_uint16_t iform_ids[8][2] = {
   /*FIADD         */    {5825,5824,},
   /*FICOM         */    {5246,5245,},
   /*FICOMP        */    {3865,3864,},
   /*FIDIV         */    {1240,1239,},
   /*FIDIVR        */    {6384,6383,},
   /*FIMUL         */    {3294,3293,},
   /*FISUB         */    {2367,2366,},
   /*FISUBR        */    {4490,4489,},
   };
   xed_uint8_t iclass_index = xed_encoder_get_iclasses_index_in_group(xes);
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_MEM0) {
   conditions_satisfied = (xed3_operand_get_reg0(xes) == XED_REG_ST0) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_MEM16INT);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][0]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_MEM0) {
   conditions_satisfied = (xed3_operand_get_reg0(xes) == XED_REG_ST0) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_MEM32INT);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][1]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay) return 1;
   }
     }
   return 0;
   (void) okay;
   (void) conditions_satisfied;
   (void) xes;
}
xed_bool_t xed_encode_group_174(xed_encoder_request_t* xes)
{
   xed_bool_t okay=1;
   xed_bool_t conditions_satisfied=0;
   xed_ptrn_func_ptr_t fb_ptrn_function;
   static const xed_uint16_t iform_ids[2][2] = {
   /*LWPINS        */    {1864,1863,},
   /*LWPVAL        */    {1244,1243,},
   };
   xed_uint8_t iclass_index = xed_encoder_get_iclasses_index_in_group(xes);
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[15], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 xed_encode_ntluf_VGPRy_N(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_GPR32_B(xes,xed3_operand_get_reg1(xes)) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][0]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_UIMM32_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[20], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 xed_encode_ntluf_VGPRy_N(xes,xed3_operand_get_reg0(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_D) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][1]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_UIMM32_BIND(xes);
       if (okay) return 1;
   }
     }
   return 0;
   (void) okay;
   (void) conditions_satisfied;
   (void) xes;
}
xed_bool_t xed_encode_group_175(xed_encoder_request_t* xes)
{
   xed_bool_t okay=1;
   xed_bool_t conditions_satisfied=0;
   xed_ptrn_func_ptr_t fb_ptrn_function;
   static const xed_uint16_t iform_ids[10][1] = {
   /*CDQE          */    {1251,},
   /*CQO           */    {4935,},
   /*IRETQ         */    {6385,},
   /*REPE_SCASQ    */    {5798,},
   /*REPNE_SCASQ   */    {1694,},
   /*SCASQ         */    {4128,},
   /*STOSQ         */    {3117,},
   /*SWAPGS        */    {6122,},
   /*SYSRET        */    {1867,},
   /*SYSRET64      */    {5593,},
   };
   xed_uint8_t iclass_index = xed_encoder_get_iclasses_index_in_group(xes);
   if (xes->_n_operand_order == 0) {
   conditions_satisfied = (xed3_operand_get_mode(xes) == 2);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][0]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   return 0;
   (void) okay;
   (void) conditions_satisfied;
   (void) xes;
}
xed_bool_t xed_encode_group_176(xed_encoder_request_t* xes)
{
   xed_bool_t okay=1;
   xed_bool_t conditions_satisfied=0;
   xed_ptrn_func_ptr_t fb_ptrn_function;
   static const xed_uint16_t iform_ids[9][4] = {
   /*BLCFILL       */    {5155,5156,5153,5154,},
   /*BLCI          */    {2032,2033,2030,2031,},
   /*BLCIC         */    {4612,4613,4610,4611,},
   /*BLCMSK        */    {1960,1961,1958,1959,},
   /*BLCS          */    {2768,2769,2766,2767,},
   /*BLSFILL       */    {1265,1266,1263,1264,},
   /*BLSIC         */    {4992,4993,4990,4991,},
   /*T1MSKC        */    {3486,3487,3484,3485,},
   /*TZMSK         */    {4785,4786,4783,4784,},
   };
   xed_uint8_t iclass_index = xed_encoder_get_iclasses_index_in_group(xes);
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_REG1) {
   conditions_satisfied = (xed3_operand_get_mode(xes) != 2) &&
		 (xed3_operand_get_vl(xes) == 0) &&
		 xed_encode_ntluf_VGPR32_N(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_GPR32_B(xes,xed3_operand_get_reg1(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][0]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_REG1) {
   conditions_satisfied = (xed3_operand_get_mode(xes) == 2) &&
		 (xed3_operand_get_vl(xes) == 0) &&
		 xed_encode_ntluf_VGPRy_N(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_GPRy_B(xes,xed3_operand_get_reg1(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][1]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_MEM0) {
   conditions_satisfied = (xed3_operand_get_mode(xes) != 2) &&
		 (xed3_operand_get_vl(xes) == 0) &&
		 xed_encode_ntluf_VGPR32_N(xes,xed3_operand_get_reg0(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_D);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][2]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_MEM0) {
   conditions_satisfied = (xed3_operand_get_mode(xes) == 2) &&
		 (xed3_operand_get_vl(xes) == 0) &&
		 xed_encode_ntluf_VGPRy_N(xes,xed3_operand_get_reg0(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_Y);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][3]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay) return 1;
   }
     }
   return 0;
   (void) okay;
   (void) conditions_satisfied;
   (void) xes;
}
xed_bool_t xed_encode_group_177(xed_encoder_request_t* xes)
{
   xed_bool_t okay=1;
   xed_bool_t conditions_satisfied=0;
   xed_ptrn_func_ptr_t fb_ptrn_function;
   static const xed_uint16_t iform_ids[1][18] = {
   /*AND           */    {1286,1285,1278,1281,1280,1283,1277,1279,1274,1270,1282,1276,1272,1284,1269,1275,1271,1273,},
   };
   xed_uint8_t iclass_index = xed_encoder_get_iclasses_index_in_group(xes);
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_IMM0) {
   conditions_satisfied = xed_encode_ntluf_OrAX(xes,xed3_operand_get_reg0(xes)) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][0]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_SIMMz_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_IMM0) {
   conditions_satisfied = (xed3_operand_get_reg0(xes) == XED_REG_AL) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][1]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_SIMM8_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_REG1) {
   conditions_satisfied = xed_encode_ntluf_GPR8_B(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_GPR8_R(xes,xed3_operand_get_reg1(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][2]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_REG1) {
   conditions_satisfied = xed_encode_ntluf_GPR8_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_GPR8_B(xes,xed3_operand_get_reg1(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][3]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_REG1) {
   conditions_satisfied = xed_encode_ntluf_GPRv_B(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_GPRv_R(xes,xed3_operand_get_reg1(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][4]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_REG1) {
   conditions_satisfied = xed_encode_ntluf_GPRv_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_GPRv_B(xes,xed3_operand_get_reg1(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][5]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_MEM0 && xes->_operand_order[1] == XED_OPERAND_REG0) {
   conditions_satisfied = (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_B) &&
		 xed_encode_ntluf_GPR8_R(xes,xed3_operand_get_reg0(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][6]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_MEM0 && xes->_operand_order[1] == XED_OPERAND_REG0) {
   conditions_satisfied = (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_V) &&
		 xed_encode_ntluf_GPRv_R(xes,xed3_operand_get_reg0(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][7]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_IMM0) {
   conditions_satisfied = (xed3_operand_get_mode(xes) != 2) &&
		 xed_encode_ntluf_GPR8_B(xes,xed3_operand_get_reg0(xes)) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][8]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_UIMM8_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_IMM0) {
   conditions_satisfied = xed_encode_ntluf_GPR8_B(xes,xed3_operand_get_reg0(xes)) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][9]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_UIMM8_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_MEM0) {
   conditions_satisfied = xed_encode_ntluf_GPR8_R(xes,xed3_operand_get_reg0(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_B);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][10]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_IMM0) {
   conditions_satisfied = xed_encode_ntluf_GPRv_B(xes,xed3_operand_get_reg0(xes)) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][11]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_SIMM8_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_IMM0) {
   conditions_satisfied = xed_encode_ntluf_GPRv_B(xes,xed3_operand_get_reg0(xes)) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][12]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_SIMMz_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_MEM0) {
   conditions_satisfied = xed_encode_ntluf_GPRv_R(xes,xed3_operand_get_reg0(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_V);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][13]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_MEM0 && xes->_operand_order[1] == XED_OPERAND_IMM0) {
   conditions_satisfied = (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_B) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][14]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_UIMM8_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_MEM0 && xes->_operand_order[1] == XED_OPERAND_IMM0) {
   conditions_satisfied = (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_V) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][15]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_SIMM8_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_MEM0 && xes->_operand_order[1] == XED_OPERAND_IMM0) {
   conditions_satisfied = (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_V) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][16]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_SIMMz_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_MEM0 && xes->_operand_order[1] == XED_OPERAND_IMM0) {
   conditions_satisfied = (xed3_operand_get_mode(xes) != 2) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_B) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][17]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_UIMM8_BIND(xes);
       if (okay) return 1;
   }
     }
   return 0;
   (void) okay;
   (void) conditions_satisfied;
   (void) xes;
}
xed_bool_t xed_encode_group_178(xed_encoder_request_t* xes)
{
   xed_bool_t okay=1;
   xed_bool_t conditions_satisfied=0;
   xed_ptrn_func_ptr_t fb_ptrn_function;
   static const xed_uint16_t iform_ids[9][6] = {
   /*VPBLENDMW     */    {1952,1954,1956,1953,1955,1957,},
   /*VPERMI2W      */    {1504,1506,1508,1505,1507,1509,},
   /*VPERMT2W      */    {2680,2682,2684,2681,2683,2685,},
   /*VPERMW        */    {4413,4415,4417,4414,4416,4418,},
   /*VPSHLDVW      */    {4855,4857,4859,4856,4858,4860,},
   /*VPSHRDVW      */    {4356,4358,4360,4357,4359,4361,},
   /*VPSLLVW       */    {1287,1289,1291,1288,1290,1292,},
   /*VPSRAVW       */    {4051,4053,4055,4052,4054,4056,},
   /*VPSRLVW       */    {3408,3410,3412,3409,3411,3413,},
   };
   xed_uint8_t iclass_index = xed_encoder_get_iclasses_index_in_group(xes);
   if (xes->_n_operand_order == 4 && memcmp(xed_encode_order[12], xes->_operand_order, sizeof(xed_uint8_t)*4)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 xed_encode_ntluf_XMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_XMM_N3(xes,xed3_operand_get_reg2(xes)) &&
		 xed_encode_ntluf_XMM_B3(xes,xed3_operand_get_reg3(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][0]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 4 && memcmp(xed_encode_order[12], xes->_operand_order, sizeof(xed_uint8_t)*4)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 1) &&
		 xed_encode_ntluf_YMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_YMM_N3(xes,xed3_operand_get_reg2(xes)) &&
		 xed_encode_ntluf_YMM_B3(xes,xed3_operand_get_reg3(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][1]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 4 && memcmp(xed_encode_order[12], xes->_operand_order, sizeof(xed_uint8_t)*4)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 2) &&
		 xed_encode_ntluf_ZMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_ZMM_N3(xes,xed3_operand_get_reg2(xes)) &&
		 xed_encode_ntluf_ZMM_B3(xes,xed3_operand_get_reg3(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][2]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 4 && memcmp(xed_encode_order[13], xes->_operand_order, sizeof(xed_uint8_t)*4)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 xed_encode_ntluf_XMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_XMM_N3(xes,xed3_operand_get_reg2(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_DQ);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][3]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_16_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_FULLMEM_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 4 && memcmp(xed_encode_order[13], xes->_operand_order, sizeof(xed_uint8_t)*4)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 1) &&
		 xed_encode_ntluf_YMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_YMM_N3(xes,xed3_operand_get_reg2(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_QQ);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][4]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_16_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_FULLMEM_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 4 && memcmp(xed_encode_order[13], xes->_operand_order, sizeof(xed_uint8_t)*4)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 2) &&
		 xed_encode_ntluf_ZMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_ZMM_N3(xes,xed3_operand_get_reg2(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_ZD);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][5]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_16_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_FULLMEM_BIND(xes);
       if (okay) return 1;
   }
     }
   return 0;
   (void) okay;
   (void) conditions_satisfied;
   (void) xes;
}
xed_bool_t xed_encode_group_179(xed_encoder_request_t* xes)
{
   xed_bool_t okay=1;
   xed_bool_t conditions_satisfied=0;
   xed_ptrn_func_ptr_t fb_ptrn_function;
   static const xed_uint16_t iform_ids[1][2] = {
   /*PINSRB        */    {1295,1294,},
   };
   xed_uint8_t iclass_index = xed_encoder_get_iclasses_index_in_group(xes);
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[15], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = xed_encode_ntluf_XMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_GPR32_B(xes,xed3_operand_get_reg1(xes)) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][0]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_REFINING66_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_UIMM8_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[20], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = xed_encode_ntluf_XMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_B) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][1]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_REFINING66_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_UIMM8_BIND(xes);
       if (okay) return 1;
   }
     }
   return 0;
   (void) okay;
   (void) conditions_satisfied;
   (void) xes;
}
xed_bool_t xed_encode_group_180(xed_encoder_request_t* xes)
{
   xed_bool_t okay=1;
   xed_bool_t conditions_satisfied=0;
   xed_ptrn_func_ptr_t fb_ptrn_function;
   static const xed_uint16_t iform_ids[2][4] = {
   /*VSHUFF64X2    */    {1298,1296,1299,1297,},
   /*VSHUFI64X2    */    {4831,4829,4832,4830,},
   };
   xed_uint8_t iclass_index = xed_encoder_get_iclasses_index_in_group(xes);
   if (xes->_n_operand_order == 5 && memcmp(xed_encode_order[18], xes->_operand_order, sizeof(xed_uint8_t)*5)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 1) &&
		 xed_encode_ntluf_YMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_YMM_N3(xes,xed3_operand_get_reg2(xes)) &&
		 xed_encode_ntluf_YMM_B3(xes,xed3_operand_get_reg3(xes)) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][0]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_UIMM8_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 5 && memcmp(xed_encode_order[18], xes->_operand_order, sizeof(xed_uint8_t)*5)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 2) &&
		 xed_encode_ntluf_ZMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_ZMM_N3(xes,xed3_operand_get_reg2(xes)) &&
		 xed_encode_ntluf_ZMM_B3(xes,xed3_operand_get_reg3(xes)) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][1]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_UIMM8_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 5 && memcmp(xed_encode_order[19], xes->_operand_order, sizeof(xed_uint8_t)*5)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 1) &&
		 xed_encode_ntluf_YMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_YMM_N3(xes,xed3_operand_get_reg2(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_VV) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][2]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_UIMM8_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_64_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_FULL_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 5 && memcmp(xed_encode_order[19], xes->_operand_order, sizeof(xed_uint8_t)*5)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 2) &&
		 xed_encode_ntluf_ZMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_ZMM_N3(xes,xed3_operand_get_reg2(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_VV) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][3]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_UIMM8_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_64_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_FULL_BIND(xes);
       if (okay) return 1;
   }
     }
   return 0;
   (void) okay;
   (void) conditions_satisfied;
   (void) xes;
}
xed_bool_t xed_encode_group_181(xed_encoder_request_t* xes)
{
   xed_bool_t okay=1;
   xed_bool_t conditions_satisfied=0;
   xed_ptrn_func_ptr_t fb_ptrn_function;
   static const xed_uint16_t iform_ids[3][3] = {
   /*VGETEXPSS     */    {3700,3699,3701,},
   /*VRCP28SS      */    {1765,1764,1766,},
   /*VRSQRT28SS    */    {1309,1308,1310,},
   };
   xed_uint8_t iclass_index = xed_encoder_get_iclasses_index_in_group(xes);
   if (xes->_n_operand_order == 4 && memcmp(xed_encode_order[12], xes->_operand_order, sizeof(xed_uint8_t)*4)==0) {
   conditions_satisfied = (xed3_operand_get_sae(xes) != 0) &&
		 xed_encode_ntluf_XMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_XMM_N3(xes,xed3_operand_get_reg2(xes)) &&
		 xed_encode_ntluf_XMM_B3(xes,xed3_operand_get_reg3(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][0]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_FIX_ROUND_LEN128_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_SAE_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 4 && memcmp(xed_encode_order[12], xes->_operand_order, sizeof(xed_uint8_t)*4)==0) {
   conditions_satisfied = xed_encode_ntluf_XMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_XMM_N3(xes,xed3_operand_get_reg2(xes)) &&
		 xed_encode_ntluf_XMM_B3(xes,xed3_operand_get_reg3(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][1]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 4 && memcmp(xed_encode_order[13], xes->_operand_order, sizeof(xed_uint8_t)*4)==0) {
   conditions_satisfied = xed_encode_ntluf_XMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_XMM_N3(xes,xed3_operand_get_reg2(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_D);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][2]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_32_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_SCALAR_BIND(xes);
       if (okay) return 1;
   }
     }
   return 0;
   (void) okay;
   (void) conditions_satisfied;
   (void) xes;
}
xed_bool_t xed_encode_group_182(xed_encoder_request_t* xes)
{
   xed_bool_t okay=1;
   xed_bool_t conditions_satisfied=0;
   xed_ptrn_func_ptr_t fb_ptrn_function;
   static const xed_uint16_t iform_ids[2][2] = {
   /*VEXTRACTF64X4 */    {1319,1320,},
   /*VEXTRACTI64X4 */    {6280,6281,},
   };
   xed_uint8_t iclass_index = xed_encoder_get_iclasses_index_in_group(xes);
   if (xes->_n_operand_order == 4 && memcmp(xed_encode_order[21], xes->_operand_order, sizeof(xed_uint8_t)*4)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 2) &&
		 xed_encode_ntluf_YMM_B3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_ZMM_R3(xes,xed3_operand_get_reg2(xes)) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][0]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_UIMM8_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 4 && memcmp(xed_encode_order[26], xes->_operand_order, sizeof(xed_uint8_t)*4)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 2) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_QQ) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_ZMM_R3(xes,xed3_operand_get_reg1(xes)) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][1]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_UIMM8_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_64_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_TUPLE4_BIND(xes);
       if (okay) return 1;
   }
     }
   return 0;
   (void) okay;
   (void) conditions_satisfied;
   (void) xes;
}
xed_bool_t xed_encode_group_183(xed_encoder_request_t* xes)
{
   xed_bool_t okay=1;
   xed_bool_t conditions_satisfied=0;
   xed_ptrn_func_ptr_t fb_ptrn_function;
   static const xed_uint16_t iform_ids[7][1] = {
   /*FADDP         */    {4788,},
   /*FDIVP         */    {4920,},
   /*FDIVRP        */    {3551,},
   /*FMULP         */    {5968,},
   /*FSTPNCE       */    {6679,},
   /*FSUBP         */    {4667,},
   /*FSUBRP        */    {1322,},
   };
   xed_uint8_t iclass_index = xed_encoder_get_iclasses_index_in_group(xes);
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_REG1) {
   conditions_satisfied = xed_encode_ntluf_X87(xes,xed3_operand_get_reg0(xes)) &&
		 (xed3_operand_get_reg1(xes) == XED_REG_ST0);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][0]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   return 0;
   (void) okay;
   (void) conditions_satisfied;
   (void) xes;
}
xed_bool_t xed_encode_group_184(xed_encoder_request_t* xes)
{
   xed_bool_t okay=1;
   xed_bool_t conditions_satisfied=0;
   xed_ptrn_func_ptr_t fb_ptrn_function;
   static const xed_uint16_t iform_ids[2][4] = {
   /*VEXTRACTF32X4 */    {1325,1323,1326,1324,},
   /*VEXTRACTI32X4 */    {3556,3554,3557,3555,},
   };
   xed_uint8_t iclass_index = xed_encoder_get_iclasses_index_in_group(xes);
   if (xes->_n_operand_order == 4 && memcmp(xed_encode_order[21], xes->_operand_order, sizeof(xed_uint8_t)*4)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 1) &&
		 xed_encode_ntluf_XMM_B3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_YMM_R3(xes,xed3_operand_get_reg2(xes)) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][0]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_UIMM8_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 4 && memcmp(xed_encode_order[21], xes->_operand_order, sizeof(xed_uint8_t)*4)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 2) &&
		 xed_encode_ntluf_XMM_B3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_ZMM_R3(xes,xed3_operand_get_reg2(xes)) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][1]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_UIMM8_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 4 && memcmp(xed_encode_order[26], xes->_operand_order, sizeof(xed_uint8_t)*4)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 1) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_DQ) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_YMM_R3(xes,xed3_operand_get_reg1(xes)) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][2]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_UIMM8_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_32_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_TUPLE4_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 4 && memcmp(xed_encode_order[26], xes->_operand_order, sizeof(xed_uint8_t)*4)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 2) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_DQ) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_ZMM_R3(xes,xed3_operand_get_reg1(xes)) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][3]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_UIMM8_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_32_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_TUPLE4_BIND(xes);
       if (okay) return 1;
   }
     }
   return 0;
   (void) okay;
   (void) conditions_satisfied;
   (void) xes;
}
xed_bool_t xed_encode_group_185(xed_encoder_request_t* xes)
{
   xed_bool_t okay=1;
   xed_bool_t conditions_satisfied=0;
   xed_ptrn_func_ptr_t fb_ptrn_function;
   static const xed_uint16_t iform_ids[1][15] = {
   /*VCVTSI2SS     */    {1339,1340,1344,1332,1334,1336,1331,1333,1335,1337,1338,1343,1341,1342,1345,},
   };
   xed_uint8_t iclass_index = xed_encoder_get_iclasses_index_in_group(xes);
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[7], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_roundc(xes) != 0) &&
		 (xed3_operand_get_mode(xes) != 2) &&
		 xed_encode_ntluf_XMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_XMM_N3(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_GPR32_B(xes,xed3_operand_get_reg2(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][0]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_FIX_ROUND_LEN128_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_AVX512_ROUND_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[7], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_roundc(xes) != 0) &&
		 (xed3_operand_get_mode(xes) == 2) &&
		 xed_encode_ntluf_XMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_XMM_N3(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_GPR32_B(xes,xed3_operand_get_reg2(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][1]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_FIX_ROUND_LEN128_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_AVX512_ROUND_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[7], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_roundc(xes) != 0) &&
		 (xed3_operand_get_mode(xes) == 2) &&
		 xed_encode_ntluf_XMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_XMM_N3(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_GPR64_B(xes,xed3_operand_get_reg2(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][2]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_FIX_ROUND_LEN128_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_AVX512_ROUND_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[7], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_mode(xes) != 2) &&
		 (xed3_operand_get_must_use_evex(xes) == 0) &&
		 xed_encode_ntluf_XMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_XMM_N(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_GPR32_B(xes,xed3_operand_get_reg2(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][3]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[7], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_mode(xes) == 2) &&
		 (xed3_operand_get_must_use_evex(xes) == 0) &&
		 xed_encode_ntluf_XMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_XMM_N(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_GPR32_B(xes,xed3_operand_get_reg2(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][4]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[7], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_mode(xes) == 2) &&
		 (xed3_operand_get_must_use_evex(xes) == 0) &&
		 xed_encode_ntluf_XMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_XMM_N(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_GPR64_B(xes,xed3_operand_get_reg2(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][5]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[14], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_mode(xes) != 2) &&
		 (xed3_operand_get_must_use_evex(xes) == 0) &&
		 xed_encode_ntluf_XMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_XMM_N(xes,xed3_operand_get_reg1(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_D);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][6]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[14], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_mode(xes) == 2) &&
		 (xed3_operand_get_must_use_evex(xes) == 0) &&
		 xed_encode_ntluf_XMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_XMM_N(xes,xed3_operand_get_reg1(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_D);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][7]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[14], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_mode(xes) == 2) &&
		 (xed3_operand_get_must_use_evex(xes) == 0) &&
		 xed_encode_ntluf_XMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_XMM_N(xes,xed3_operand_get_reg1(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_Q);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][8]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[7], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_mode(xes) != 2) &&
		 xed_encode_ntluf_XMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_XMM_N3(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_GPR32_B(xes,xed3_operand_get_reg2(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][9]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_FIX_ROUND_LEN128_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[7], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_mode(xes) == 2) &&
		 xed_encode_ntluf_XMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_XMM_N3(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_GPR32_B(xes,xed3_operand_get_reg2(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][10]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_FIX_ROUND_LEN128_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[7], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_mode(xes) == 2) &&
		 xed_encode_ntluf_XMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_XMM_N3(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_GPR64_B(xes,xed3_operand_get_reg2(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][11]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_FIX_ROUND_LEN128_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[14], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_mode(xes) != 2) &&
		 xed_encode_ntluf_XMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_XMM_N3(xes,xed3_operand_get_reg1(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_D);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][12]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_32_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_GPR_READER_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_FIX_ROUND_LEN128_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[14], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_mode(xes) == 2) &&
		 xed_encode_ntluf_XMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_XMM_N3(xes,xed3_operand_get_reg1(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_D);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][13]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_32_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_GPR_READER_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_FIX_ROUND_LEN128_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[14], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_mode(xes) == 2) &&
		 xed_encode_ntluf_XMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_XMM_N3(xes,xed3_operand_get_reg1(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_Q);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][14]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_64_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_GPR_READER_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_FIX_ROUND_LEN128_BIND(xes);
       if (okay) return 1;
   }
     }
   return 0;
   (void) okay;
   (void) conditions_satisfied;
   (void) xes;
}
xed_bool_t xed_encode_group_186(xed_encoder_request_t* xes)
{
   xed_bool_t okay=1;
   xed_bool_t conditions_satisfied=0;
   xed_ptrn_func_ptr_t fb_ptrn_function;
   static const xed_uint16_t iform_ids[1][6] = {
   /*VP2INTERSECTD */    {1346,1348,1350,1347,1349,1351,},
   };
   xed_uint8_t iclass_index = xed_encoder_get_iclasses_index_in_group(xes);
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[7], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 xed_encode_ntluf_MASK_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_XMM_N3(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_XMM_B3(xes,xed3_operand_get_reg2(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][0]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[7], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 1) &&
		 xed_encode_ntluf_MASK_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_YMM_N3(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_YMM_B3(xes,xed3_operand_get_reg2(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][1]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[7], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 2) &&
		 xed_encode_ntluf_MASK_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_ZMM_N3(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_ZMM_B3(xes,xed3_operand_get_reg2(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][2]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[14], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 xed_encode_ntluf_MASK_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_XMM_N3(xes,xed3_operand_get_reg1(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_VV);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][3]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_32_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_FULL_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[14], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 1) &&
		 xed_encode_ntluf_MASK_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_YMM_N3(xes,xed3_operand_get_reg1(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_VV);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][4]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_32_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_FULL_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[14], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 2) &&
		 xed_encode_ntluf_MASK_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_ZMM_N3(xes,xed3_operand_get_reg1(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_VV);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][5]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_32_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_FULL_BIND(xes);
       if (okay) return 1;
   }
     }
   return 0;
   (void) okay;
   (void) conditions_satisfied;
   (void) xes;
}
xed_bool_t xed_encode_group_187(xed_encoder_request_t* xes)
{
   xed_bool_t okay=1;
   xed_bool_t conditions_satisfied=0;
   xed_ptrn_func_ptr_t fb_ptrn_function;
   static const xed_uint16_t iform_ids[2][2] = {
   /*VAESIMC       */    {6104,6105,},
   /*VPHMINPOSUW   */    {1359,1358,},
   };
   xed_uint8_t iclass_index = xed_encoder_get_iclasses_index_in_group(xes);
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_REG1) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 (xed3_operand_get_must_use_evex(xes) == 0) &&
		 xed_encode_ntluf_XMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_XMM_B(xes,xed3_operand_get_reg1(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][0]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_MEM0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 (xed3_operand_get_must_use_evex(xes) == 0) &&
		 xed_encode_ntluf_XMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_DQ);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][1]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay) return 1;
   }
     }
   return 0;
   (void) okay;
   (void) conditions_satisfied;
   (void) xes;
}
xed_bool_t xed_encode_group_188(xed_encoder_request_t* xes)
{
   xed_bool_t okay=1;
   xed_bool_t conditions_satisfied=0;
   xed_ptrn_func_ptr_t fb_ptrn_function;
   static const xed_uint16_t iform_ids[17][5] = {
   /*VADDSS        */    {1842,1840,1839,1841,1843,},
   /*VDIVSS        */    {5205,5203,5202,5204,5206,},
   /*VFMADD132SS   */    {6400,6398,6397,6399,6401,},
   /*VFMADD213SS   */    {2153,2151,2150,2152,2154,},
   /*VFMADD231SS   */    {5954,5952,5951,5953,5955,},
   /*VFMSUB132SS   */    {4399,4397,4396,4398,4400,},
   /*VFMSUB213SS   */    {1364,1362,1361,1363,1365,},
   /*VFMSUB231SS   */    {6488,6486,6485,6487,6489,},
   /*VFNMADD132SS  */    {3317,3315,3314,3316,3318,},
   /*VFNMADD213SS  */    {4696,4694,4693,4695,4697,},
   /*VFNMADD231SS  */    {6410,6408,6407,6409,6411,},
   /*VFNMSUB132SS  */    {3182,3180,3179,3181,3183,},
   /*VFNMSUB213SS  */    {4966,4964,4963,4965,4967,},
   /*VFNMSUB231SS  */    {3911,3909,3908,3910,3912,},
   /*VMULSS        */    {2238,2236,2235,2237,2239,},
   /*VSQRTSS       */    {4264,4262,4261,4263,4265,},
   /*VSUBSS        */    {2626,2624,2623,2625,2627,},
   };
   xed_uint8_t iclass_index = xed_encoder_get_iclasses_index_in_group(xes);
   if (xes->_n_operand_order == 4 && memcmp(xed_encode_order[12], xes->_operand_order, sizeof(xed_uint8_t)*4)==0) {
   conditions_satisfied = (xed3_operand_get_roundc(xes) != 0) &&
		 xed_encode_ntluf_XMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_XMM_N3(xes,xed3_operand_get_reg2(xes)) &&
		 xed_encode_ntluf_XMM_B3(xes,xed3_operand_get_reg3(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][0]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_FIX_ROUND_LEN128_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_AVX512_ROUND_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[7], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_must_use_evex(xes) == 0) &&
		 xed_encode_ntluf_XMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_XMM_N(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_XMM_B(xes,xed3_operand_get_reg2(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][1]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[14], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_must_use_evex(xes) == 0) &&
		 xed_encode_ntluf_XMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_XMM_N(xes,xed3_operand_get_reg1(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_D);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][2]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 4 && memcmp(xed_encode_order[12], xes->_operand_order, sizeof(xed_uint8_t)*4)==0) {
   conditions_satisfied = xed_encode_ntluf_XMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_XMM_N3(xes,xed3_operand_get_reg2(xes)) &&
		 xed_encode_ntluf_XMM_B3(xes,xed3_operand_get_reg3(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][3]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 4 && memcmp(xed_encode_order[13], xes->_operand_order, sizeof(xed_uint8_t)*4)==0) {
   conditions_satisfied = xed_encode_ntluf_XMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_XMM_N3(xes,xed3_operand_get_reg2(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_D);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][4]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_32_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_SCALAR_BIND(xes);
       if (okay) return 1;
   }
     }
   return 0;
   (void) okay;
   (void) conditions_satisfied;
   (void) xes;
}
xed_bool_t xed_encode_group_189(xed_encoder_request_t* xes)
{
   xed_bool_t okay=1;
   xed_bool_t conditions_satisfied=0;
   xed_ptrn_func_ptr_t fb_ptrn_function;
   static const xed_uint16_t iform_ids[2][11] = {
   /*VMAXPD        */    {4276,4272,4274,4271,4273,4278,4280,4275,4279,4281,4277,},
   /*VMINPD        */    {1371,1367,1369,1366,1368,1373,1375,1370,1374,1376,1372,},
   };
   xed_uint8_t iclass_index = xed_encoder_get_iclasses_index_in_group(xes);
   if (xes->_n_operand_order == 4 && memcmp(xed_encode_order[12], xes->_operand_order, sizeof(xed_uint8_t)*4)==0) {
   conditions_satisfied = (xed3_operand_get_sae(xes) != 0) &&
		 xed_encode_ntluf_ZMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_ZMM_N3(xes,xed3_operand_get_reg2(xes)) &&
		 xed_encode_ntluf_ZMM_B3(xes,xed3_operand_get_reg3(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][0]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_FIX_ROUND_LEN512_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_SAE_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[7], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 (xed3_operand_get_must_use_evex(xes) == 0) &&
		 xed_encode_ntluf_XMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_XMM_N(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_XMM_B(xes,xed3_operand_get_reg2(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][1]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[7], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 1) &&
		 (xed3_operand_get_must_use_evex(xes) == 0) &&
		 xed_encode_ntluf_YMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_YMM_N(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_YMM_B(xes,xed3_operand_get_reg2(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][2]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[14], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 (xed3_operand_get_must_use_evex(xes) == 0) &&
		 xed_encode_ntluf_XMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_XMM_N(xes,xed3_operand_get_reg1(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_DQ);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][3]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[14], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 1) &&
		 (xed3_operand_get_must_use_evex(xes) == 0) &&
		 xed_encode_ntluf_YMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_YMM_N(xes,xed3_operand_get_reg1(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_QQ);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][4]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 4 && memcmp(xed_encode_order[12], xes->_operand_order, sizeof(xed_uint8_t)*4)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 xed_encode_ntluf_XMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_XMM_N3(xes,xed3_operand_get_reg2(xes)) &&
		 xed_encode_ntluf_XMM_B3(xes,xed3_operand_get_reg3(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][5]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 4 && memcmp(xed_encode_order[12], xes->_operand_order, sizeof(xed_uint8_t)*4)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 1) &&
		 xed_encode_ntluf_YMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_YMM_N3(xes,xed3_operand_get_reg2(xes)) &&
		 xed_encode_ntluf_YMM_B3(xes,xed3_operand_get_reg3(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][6]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 4 && memcmp(xed_encode_order[12], xes->_operand_order, sizeof(xed_uint8_t)*4)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 2) &&
		 xed_encode_ntluf_ZMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_ZMM_N3(xes,xed3_operand_get_reg2(xes)) &&
		 xed_encode_ntluf_ZMM_B3(xes,xed3_operand_get_reg3(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][7]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 4 && memcmp(xed_encode_order[13], xes->_operand_order, sizeof(xed_uint8_t)*4)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 xed_encode_ntluf_XMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_XMM_N3(xes,xed3_operand_get_reg2(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_VV);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][8]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_64_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_FULL_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 4 && memcmp(xed_encode_order[13], xes->_operand_order, sizeof(xed_uint8_t)*4)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 1) &&
		 xed_encode_ntluf_YMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_YMM_N3(xes,xed3_operand_get_reg2(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_VV);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][9]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_64_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_FULL_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 4 && memcmp(xed_encode_order[13], xes->_operand_order, sizeof(xed_uint8_t)*4)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 2) &&
		 xed_encode_ntluf_ZMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_ZMM_N3(xes,xed3_operand_get_reg2(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_VV);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][10]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_64_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_FULL_BIND(xes);
       if (okay) return 1;
   }
     }
   return 0;
   (void) okay;
   (void) conditions_satisfied;
   (void) xes;
}
xed_bool_t xed_encode_group_190(xed_encoder_request_t* xes)
{
   xed_bool_t okay=1;
   xed_bool_t conditions_satisfied=0;
   xed_ptrn_func_ptr_t fb_ptrn_function;
   static const xed_uint16_t iform_ids[4][1] = {
   /*V4FMADDPS     */    {2194,},
   /*V4FNMADDPS    */    {3958,},
   /*VP4DPWSSD     */    {4930,},
   /*VP4DPWSSDS    */    {1377,},
   };
   xed_uint8_t iclass_index = xed_encoder_get_iclasses_index_in_group(xes);
   if (xes->_n_operand_order == 4 && memcmp(xed_encode_order[13], xes->_operand_order, sizeof(xed_uint8_t)*4)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 2) &&
		 xed_encode_ntluf_ZMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_ZMM_N3(xes,xed3_operand_get_reg2(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_DQ);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][0]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_32_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_TUPLE1_4X_BIND(xes);
       if (okay) return 1;
   }
     }
   return 0;
   (void) okay;
   (void) conditions_satisfied;
   (void) xes;
}
xed_bool_t xed_encode_group_191(xed_encoder_request_t* xes)
{
   xed_bool_t okay=1;
   xed_bool_t conditions_satisfied=0;
   xed_ptrn_func_ptr_t fb_ptrn_function;
   static const xed_uint16_t iform_ids[1][4] = {
   /*VEXTRACTPS    */    {1381,1380,1382,1383,},
   };
   xed_uint8_t iclass_index = xed_encoder_get_iclasses_index_in_group(xes);
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[15], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 (xed3_operand_get_must_use_evex(xes) == 0) &&
		 xed_encode_ntluf_GPR32_B(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_XMM_R(xes,xed3_operand_get_reg1(xes)) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][0]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_UIMM8_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[17], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 (xed3_operand_get_must_use_evex(xes) == 0) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_D) &&
		 xed_encode_ntluf_XMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][1]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_UIMM8_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[15], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 xed_encode_ntluf_GPR32_B(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_XMM_R3(xes,xed3_operand_get_reg1(xes)) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][2]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_UIMM8_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[17], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_D) &&
		 xed_encode_ntluf_XMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][3]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_UIMM8_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_32_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_GPR_WRITER_STORE_BIND(xes);
       if (okay) return 1;
   }
     }
   return 0;
   (void) okay;
   (void) conditions_satisfied;
   (void) xes;
}
xed_bool_t xed_encode_group_192(xed_encoder_request_t* xes)
{
   xed_bool_t okay=1;
   xed_bool_t conditions_satisfied=0;
   xed_ptrn_func_ptr_t fb_ptrn_function;
   static const xed_uint16_t iform_ids[4][6] = {
   /*VALIGNQ       */    {1978,1980,1976,1979,1981,1977,},
   /*VPSHLDQ       */    {3298,3300,3302,3299,3301,3303,},
   /*VPSHRDQ       */    {2852,2854,2856,2853,2855,2857,},
   /*VPTERNLOGQ    */    {1404,1406,1402,1405,1407,1403,},
   };
   xed_uint8_t iclass_index = xed_encoder_get_iclasses_index_in_group(xes);
   if (xes->_n_operand_order == 5 && memcmp(xed_encode_order[18], xes->_operand_order, sizeof(xed_uint8_t)*5)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 xed_encode_ntluf_XMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_XMM_N3(xes,xed3_operand_get_reg2(xes)) &&
		 xed_encode_ntluf_XMM_B3(xes,xed3_operand_get_reg3(xes)) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][0]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_UIMM8_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 5 && memcmp(xed_encode_order[18], xes->_operand_order, sizeof(xed_uint8_t)*5)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 1) &&
		 xed_encode_ntluf_YMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_YMM_N3(xes,xed3_operand_get_reg2(xes)) &&
		 xed_encode_ntluf_YMM_B3(xes,xed3_operand_get_reg3(xes)) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][1]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_UIMM8_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 5 && memcmp(xed_encode_order[18], xes->_operand_order, sizeof(xed_uint8_t)*5)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 2) &&
		 xed_encode_ntluf_ZMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_ZMM_N3(xes,xed3_operand_get_reg2(xes)) &&
		 xed_encode_ntluf_ZMM_B3(xes,xed3_operand_get_reg3(xes)) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][2]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_UIMM8_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 5 && memcmp(xed_encode_order[19], xes->_operand_order, sizeof(xed_uint8_t)*5)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 xed_encode_ntluf_XMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_XMM_N3(xes,xed3_operand_get_reg2(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_VV) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][3]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_UIMM8_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_64_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_FULL_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 5 && memcmp(xed_encode_order[19], xes->_operand_order, sizeof(xed_uint8_t)*5)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 1) &&
		 xed_encode_ntluf_YMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_YMM_N3(xes,xed3_operand_get_reg2(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_VV) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][4]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_UIMM8_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_64_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_FULL_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 5 && memcmp(xed_encode_order[19], xes->_operand_order, sizeof(xed_uint8_t)*5)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 2) &&
		 xed_encode_ntluf_ZMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_ZMM_N3(xes,xed3_operand_get_reg2(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_VV) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][5]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_UIMM8_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_64_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_FULL_BIND(xes);
       if (okay) return 1;
   }
     }
   return 0;
   (void) okay;
   (void) conditions_satisfied;
   (void) xes;
}
xed_bool_t xed_encode_group_193(xed_encoder_request_t* xes)
{
   xed_bool_t okay=1;
   xed_bool_t conditions_satisfied=0;
   xed_ptrn_func_ptr_t fb_ptrn_function;
   static const xed_uint16_t iform_ids[1][4] = {
   /*MOV_DR        */    {1408,1410,1409,1411,},
   };
   xed_uint8_t iclass_index = xed_encoder_get_iclasses_index_in_group(xes);
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_REG1) {
   conditions_satisfied = (xed3_operand_get_mode(xes) != 2) &&
		 xed_encode_ntluf_DR_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_GPR32_B(xes,xed3_operand_get_reg1(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][0]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_CR_WIDTH_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_REG1) {
   conditions_satisfied = (xed3_operand_get_mode(xes) != 2) &&
		 xed_encode_ntluf_GPR32_B(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_DR_R(xes,xed3_operand_get_reg1(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][1]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_CR_WIDTH_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_REG1) {
   conditions_satisfied = (xed3_operand_get_mode(xes) == 2) &&
		 xed_encode_ntluf_DR_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_GPR64_B(xes,xed3_operand_get_reg1(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][2]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_CR_WIDTH_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_REG1) {
   conditions_satisfied = (xed3_operand_get_mode(xes) == 2) &&
		 xed_encode_ntluf_GPR64_B(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_DR_R(xes,xed3_operand_get_reg1(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][3]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_CR_WIDTH_BIND(xes);
       if (okay) return 1;
   }
     }
   return 0;
   (void) okay;
   (void) conditions_satisfied;
   (void) xes;
}
xed_bool_t xed_encode_group_194(xed_encoder_request_t* xes)
{
   xed_bool_t okay=1;
   xed_bool_t conditions_satisfied=0;
   xed_ptrn_func_ptr_t fb_ptrn_function;
   static const xed_uint16_t iform_ids[1][6] = {
   /*VPOPCNTW      */    {1429,1431,1433,1430,1432,1434,},
   };
   xed_uint8_t iclass_index = xed_encoder_get_iclasses_index_in_group(xes);
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[7], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 xed_encode_ntluf_XMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_XMM_B3(xes,xed3_operand_get_reg2(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][0]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[7], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 1) &&
		 xed_encode_ntluf_YMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_YMM_B3(xes,xed3_operand_get_reg2(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][1]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[7], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 2) &&
		 xed_encode_ntluf_ZMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_ZMM_B3(xes,xed3_operand_get_reg2(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][2]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[14], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 xed_encode_ntluf_XMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_DQ);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][3]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_16_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_FULLMEM_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[14], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 1) &&
		 xed_encode_ntluf_YMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_QQ);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][4]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_16_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_FULLMEM_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[14], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 2) &&
		 xed_encode_ntluf_ZMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_ZD);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][5]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_16_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_FULLMEM_BIND(xes);
       if (okay) return 1;
   }
     }
   return 0;
   (void) okay;
   (void) conditions_satisfied;
   (void) xes;
}
xed_bool_t xed_encode_group_195(xed_encoder_request_t* xes)
{
   xed_bool_t okay=1;
   xed_bool_t conditions_satisfied=0;
   xed_ptrn_func_ptr_t fb_ptrn_function;
   static const xed_uint16_t iform_ids[1][9] = {
   /*VCVTTSD2USI   */    {1437,1438,1442,1435,1436,1441,1439,1440,1443,},
   };
   xed_uint8_t iclass_index = xed_encoder_get_iclasses_index_in_group(xes);
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_REG1) {
   conditions_satisfied = (xed3_operand_get_sae(xes) != 0) &&
		 (xed3_operand_get_mode(xes) != 2) &&
		 xed_encode_ntluf_GPR32_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_XMM_B3(xes,xed3_operand_get_reg1(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][0]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_FIX_ROUND_LEN128_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_SAE_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_REG1) {
   conditions_satisfied = (xed3_operand_get_sae(xes) != 0) &&
		 (xed3_operand_get_mode(xes) == 2) &&
		 xed_encode_ntluf_GPR32_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_XMM_B3(xes,xed3_operand_get_reg1(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][1]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_FIX_ROUND_LEN128_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_SAE_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_REG1) {
   conditions_satisfied = (xed3_operand_get_sae(xes) != 0) &&
		 (xed3_operand_get_mode(xes) == 2) &&
		 xed_encode_ntluf_GPR64_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_XMM_B3(xes,xed3_operand_get_reg1(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][2]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_FIX_ROUND_LEN128_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_SAE_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_REG1) {
   conditions_satisfied = (xed3_operand_get_mode(xes) != 2) &&
		 xed_encode_ntluf_GPR32_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_XMM_B3(xes,xed3_operand_get_reg1(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][3]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_FIX_ROUND_LEN128_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_REG1) {
   conditions_satisfied = (xed3_operand_get_mode(xes) == 2) &&
		 xed_encode_ntluf_GPR32_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_XMM_B3(xes,xed3_operand_get_reg1(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][4]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_FIX_ROUND_LEN128_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_REG1) {
   conditions_satisfied = (xed3_operand_get_mode(xes) == 2) &&
		 xed_encode_ntluf_GPR64_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_XMM_B3(xes,xed3_operand_get_reg1(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][5]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_FIX_ROUND_LEN128_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_MEM0) {
   conditions_satisfied = (xed3_operand_get_mode(xes) != 2) &&
		 xed_encode_ntluf_GPR32_R(xes,xed3_operand_get_reg0(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_Q);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][6]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_64_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_GPR_WRITER_LDOP_Q_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_FIX_ROUND_LEN128_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_MEM0) {
   conditions_satisfied = (xed3_operand_get_mode(xes) == 2) &&
		 xed_encode_ntluf_GPR32_R(xes,xed3_operand_get_reg0(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_Q);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][7]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_64_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_GPR_WRITER_LDOP_Q_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_FIX_ROUND_LEN128_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_MEM0) {
   conditions_satisfied = (xed3_operand_get_mode(xes) == 2) &&
		 xed_encode_ntluf_GPR64_R(xes,xed3_operand_get_reg0(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_Q);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][8]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_64_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_GPR_WRITER_LDOP_Q_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_FIX_ROUND_LEN128_BIND(xes);
       if (okay) return 1;
   }
     }
   return 0;
   (void) okay;
   (void) conditions_satisfied;
   (void) xes;
}
xed_bool_t xed_encode_group_196(xed_encoder_request_t* xes)
{
   xed_bool_t okay=1;
   xed_bool_t conditions_satisfied=0;
   xed_ptrn_func_ptr_t fb_ptrn_function;
   static const xed_uint16_t iform_ids[3][2] = {
   /*CMPPD         */    {3224,3223,},
   /*ROUNDPD       */    {5886,5885,},
   /*SHUFPD        */    {1446,1445,},
   };
   xed_uint8_t iclass_index = xed_encoder_get_iclasses_index_in_group(xes);
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[15], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = xed_encode_ntluf_XMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_XMM_B(xes,xed3_operand_get_reg1(xes)) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][0]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_REFINING66_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_UIMM8_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[20], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = xed_encode_ntluf_XMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_PD) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][1]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_REFINING66_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_UIMM8_BIND(xes);
       if (okay) return 1;
   }
     }
   return 0;
   (void) okay;
   (void) conditions_satisfied;
   (void) xes;
}
xed_bool_t xed_encode_group_197(xed_encoder_request_t* xes)
{
   xed_bool_t okay=1;
   xed_bool_t conditions_satisfied=0;
   xed_ptrn_func_ptr_t fb_ptrn_function;
   static const xed_uint16_t iform_ids[2][4] = {
   /*CVTSI2SD      */    {2375,2377,2374,2376,},
   /*CVTSI2SS      */    {1448,1450,1447,1449,},
   };
   xed_uint8_t iclass_index = xed_encoder_get_iclasses_index_in_group(xes);
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_REG1) {
   conditions_satisfied = xed_encode_ntluf_XMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_GPR32_B(xes,xed3_operand_get_reg1(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][0]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_IGNORE66_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_REG1) {
   conditions_satisfied = xed_encode_ntluf_XMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_GPR64_B(xes,xed3_operand_get_reg1(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][1]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_IGNORE66_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_MEM0) {
   conditions_satisfied = xed_encode_ntluf_XMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_D);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][2]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_IGNORE66_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_MEM0) {
   conditions_satisfied = xed_encode_ntluf_XMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_Q);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][3]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_IGNORE66_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay) return 1;
   }
     }
   return 0;
   (void) okay;
   (void) conditions_satisfied;
   (void) xes;
}
xed_bool_t xed_encode_group_198(xed_encoder_request_t* xes)
{
   xed_bool_t okay=1;
   xed_bool_t conditions_satisfied=0;
   xed_ptrn_func_ptr_t fb_ptrn_function;
   static const xed_uint16_t iform_ids[2][2] = {
   /*VEXTRACTF32X8 */    {3697,3698,},
   /*VEXTRACTI32X8 */    {1451,1452,},
   };
   xed_uint8_t iclass_index = xed_encoder_get_iclasses_index_in_group(xes);
   if (xes->_n_operand_order == 4 && memcmp(xed_encode_order[21], xes->_operand_order, sizeof(xed_uint8_t)*4)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 2) &&
		 xed_encode_ntluf_YMM_B3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_ZMM_R3(xes,xed3_operand_get_reg2(xes)) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][0]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_UIMM8_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 4 && memcmp(xed_encode_order[26], xes->_operand_order, sizeof(xed_uint8_t)*4)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 2) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_QQ) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_ZMM_R3(xes,xed3_operand_get_reg1(xes)) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][1]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_UIMM8_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_32_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_TUPLE8_BIND(xes);
       if (okay) return 1;
   }
     }
   return 0;
   (void) okay;
   (void) conditions_satisfied;
   (void) xes;
}
xed_bool_t xed_encode_group_199(xed_encoder_request_t* xes)
{
   xed_bool_t okay=1;
   xed_bool_t conditions_satisfied=0;
   xed_ptrn_func_ptr_t fb_ptrn_function;
   static const xed_uint16_t iform_ids[3][10] = {
   /*VGF2P8AFFINEINVQB*/    {3839,3841,3840,3842,3833,3835,3837,3834,3836,3838,},
   /*VGF2P8AFFINEQB*/    {4628,4630,4629,4631,4622,4624,4626,4623,4625,4627,},
   /*VSHUFPD       */    {1457,1459,1456,1458,1462,1464,1460,1463,1465,1461,},
   };
   xed_uint8_t iclass_index = xed_encoder_get_iclasses_index_in_group(xes);
   if (xes->_n_operand_order == 4 && memcmp(xed_encode_order[21], xes->_operand_order, sizeof(xed_uint8_t)*4)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 (xed3_operand_get_must_use_evex(xes) == 0) &&
		 xed_encode_ntluf_XMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_XMM_N(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_XMM_B(xes,xed3_operand_get_reg2(xes)) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][0]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_UIMM8_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 4 && memcmp(xed_encode_order[21], xes->_operand_order, sizeof(xed_uint8_t)*4)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 1) &&
		 (xed3_operand_get_must_use_evex(xes) == 0) &&
		 xed_encode_ntluf_YMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_YMM_N(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_YMM_B(xes,xed3_operand_get_reg2(xes)) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][1]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_UIMM8_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 4 && memcmp(xed_encode_order[22], xes->_operand_order, sizeof(xed_uint8_t)*4)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 (xed3_operand_get_must_use_evex(xes) == 0) &&
		 xed_encode_ntluf_XMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_XMM_N(xes,xed3_operand_get_reg1(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_DQ) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][2]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_UIMM8_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 4 && memcmp(xed_encode_order[22], xes->_operand_order, sizeof(xed_uint8_t)*4)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 1) &&
		 (xed3_operand_get_must_use_evex(xes) == 0) &&
		 xed_encode_ntluf_YMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_YMM_N(xes,xed3_operand_get_reg1(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_QQ) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][3]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_UIMM8_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 5 && memcmp(xed_encode_order[18], xes->_operand_order, sizeof(xed_uint8_t)*5)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 xed_encode_ntluf_XMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_XMM_N3(xes,xed3_operand_get_reg2(xes)) &&
		 xed_encode_ntluf_XMM_B3(xes,xed3_operand_get_reg3(xes)) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][4]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_UIMM8_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 5 && memcmp(xed_encode_order[18], xes->_operand_order, sizeof(xed_uint8_t)*5)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 1) &&
		 xed_encode_ntluf_YMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_YMM_N3(xes,xed3_operand_get_reg2(xes)) &&
		 xed_encode_ntluf_YMM_B3(xes,xed3_operand_get_reg3(xes)) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][5]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_UIMM8_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 5 && memcmp(xed_encode_order[18], xes->_operand_order, sizeof(xed_uint8_t)*5)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 2) &&
		 xed_encode_ntluf_ZMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_ZMM_N3(xes,xed3_operand_get_reg2(xes)) &&
		 xed_encode_ntluf_ZMM_B3(xes,xed3_operand_get_reg3(xes)) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][6]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_UIMM8_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 5 && memcmp(xed_encode_order[19], xes->_operand_order, sizeof(xed_uint8_t)*5)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 xed_encode_ntluf_XMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_XMM_N3(xes,xed3_operand_get_reg2(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_VV) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][7]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_UIMM8_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_64_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_FULL_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 5 && memcmp(xed_encode_order[19], xes->_operand_order, sizeof(xed_uint8_t)*5)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 1) &&
		 xed_encode_ntluf_YMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_YMM_N3(xes,xed3_operand_get_reg2(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_VV) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][8]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_UIMM8_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_64_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_FULL_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 5 && memcmp(xed_encode_order[19], xes->_operand_order, sizeof(xed_uint8_t)*5)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 2) &&
		 xed_encode_ntluf_ZMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_ZMM_N3(xes,xed3_operand_get_reg2(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_VV) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][9]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_UIMM8_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_64_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_FULL_BIND(xes);
       if (okay) return 1;
   }
     }
   return 0;
   (void) okay;
   (void) conditions_satisfied;
   (void) xes;
}
xed_bool_t xed_encode_group_200(xed_encoder_request_t* xes)
{
   xed_bool_t okay=1;
   xed_bool_t conditions_satisfied=0;
   xed_ptrn_func_ptr_t fb_ptrn_function;
   static const xed_uint16_t iform_ids[2][2] = {
   /*POPFQ         */    {6563,6564,},
   /*PUSHFQ        */    {1470,1471,},
   };
   xed_uint8_t iclass_index = xed_encoder_get_iclasses_index_in_group(xes);
   if (xes->_n_operand_order == 0) {
   conditions_satisfied = (xed3_operand_get_mode(xes) == 2);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][0]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_DF64_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 0) {
   conditions_satisfied = (xed3_operand_get_mode(xes) == 2);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][1]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_DF64_BIND(xes);
       if (okay) return 1;
   }
     }
   return 0;
   (void) okay;
   (void) conditions_satisfied;
   (void) xes;
}
xed_bool_t xed_encode_group_201(xed_encoder_request_t* xes)
{
   xed_bool_t okay=1;
   xed_bool_t conditions_satisfied=0;
   xed_ptrn_func_ptr_t fb_ptrn_function;
   static const xed_uint16_t iform_ids[1][2] = {
   /*ROUNDSD       */    {1503,1502,},
   };
   xed_uint8_t iclass_index = xed_encoder_get_iclasses_index_in_group(xes);
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[15], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = xed_encode_ntluf_XMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_XMM_B(xes,xed3_operand_get_reg1(xes)) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][0]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_REFINING66_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_UIMM8_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[20], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = xed_encode_ntluf_XMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_Q) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][1]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_REFINING66_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_UIMM8_BIND(xes);
       if (okay) return 1;
   }
     }
   return 0;
   (void) okay;
   (void) conditions_satisfied;
   (void) xes;
}
xed_bool_t xed_encode_group_202(xed_encoder_request_t* xes)
{
   xed_bool_t okay=1;
   xed_bool_t conditions_satisfied=0;
   xed_ptrn_func_ptr_t fb_ptrn_function;
   static const xed_uint16_t iform_ids[1][3] = {
   /*FXCH          */    {1510,1511,1512,},
   };
   xed_uint8_t iclass_index = xed_encoder_get_iclasses_index_in_group(xes);
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_REG1) {
   conditions_satisfied = (xed3_operand_get_reg0(xes) == XED_REG_ST0) &&
		 xed_encode_ntluf_X87(xes,xed3_operand_get_reg1(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][0]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_REG1) {
   conditions_satisfied = (xed3_operand_get_reg0(xes) == XED_REG_ST0) &&
		 xed_encode_ntluf_X87(xes,xed3_operand_get_reg1(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][1]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_REG1) {
   conditions_satisfied = (xed3_operand_get_reg0(xes) == XED_REG_ST0) &&
		 xed_encode_ntluf_X87(xes,xed3_operand_get_reg1(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][2]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   return 0;
   (void) okay;
   (void) conditions_satisfied;
   (void) xes;
}
xed_bool_t xed_encode_group_203(xed_encoder_request_t* xes)
{
   xed_bool_t okay=1;
   xed_bool_t conditions_satisfied=0;
   xed_ptrn_func_ptr_t fb_ptrn_function;
   static const xed_uint16_t iform_ids[2][4] = {
   /*CMPXCHG       */    {3378,3380,3377,3379,},
   /*XADD          */    {1514,1516,1513,1515,},
   };
   xed_uint8_t iclass_index = xed_encoder_get_iclasses_index_in_group(xes);
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_REG1) {
   conditions_satisfied = xed_encode_ntluf_GPR8_B(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_GPR8_R(xes,xed3_operand_get_reg1(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][0]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_REG1) {
   conditions_satisfied = xed_encode_ntluf_GPRv_B(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_GPRv_R(xes,xed3_operand_get_reg1(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][1]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_MEM0 && xes->_operand_order[1] == XED_OPERAND_REG0) {
   conditions_satisfied = (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_B) &&
		 xed_encode_ntluf_GPR8_R(xes,xed3_operand_get_reg0(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][2]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_MEM0 && xes->_operand_order[1] == XED_OPERAND_REG0) {
   conditions_satisfied = (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_V) &&
		 xed_encode_ntluf_GPRv_R(xes,xed3_operand_get_reg0(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][3]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay) return 1;
   }
     }
   return 0;
   (void) okay;
   (void) conditions_satisfied;
   (void) xes;
}
xed_bool_t xed_encode_group_204(xed_encoder_request_t* xes)
{
   xed_bool_t okay=1;
   xed_bool_t conditions_satisfied=0;
   xed_ptrn_func_ptr_t fb_ptrn_function;
   static const xed_uint16_t iform_ids[2][4] = {
   /*ADCX          */    {1524,1522,1525,1523,},
   /*ADOX          */    {6561,6559,6562,6560,},
   };
   xed_uint8_t iclass_index = xed_encoder_get_iclasses_index_in_group(xes);
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_REG1) {
   conditions_satisfied = (xed3_operand_get_mode(xes) == 2) &&
		 xed_encode_ntluf_GPR64_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_GPR64_B(xes,xed3_operand_get_reg1(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][0]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_IMMUNE66_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_REG1) {
   conditions_satisfied = xed_encode_ntluf_GPR32_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_GPR32_B(xes,xed3_operand_get_reg1(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][1]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_IMMUNE66_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_MEM0) {
   conditions_satisfied = (xed3_operand_get_mode(xes) == 2) &&
		 xed_encode_ntluf_GPR64_R(xes,xed3_operand_get_reg0(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_Q);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][2]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_IMMUNE66_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_MEM0) {
   conditions_satisfied = xed_encode_ntluf_GPR32_R(xes,xed3_operand_get_reg0(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_D);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][3]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_IMMUNE66_BIND(xes);
       if (okay) return 1;
   }
     }
   return 0;
   (void) okay;
   (void) conditions_satisfied;
   (void) xes;
}
xed_bool_t xed_encode_group_205(xed_encoder_request_t* xes)
{
   xed_bool_t okay=1;
   xed_bool_t conditions_satisfied=0;
   xed_ptrn_func_ptr_t fb_ptrn_function;
   static const xed_uint16_t iform_ids[1][4] = {
   /*CRC32         */    {1541,1543,1540,1542,},
   };
   xed_uint8_t iclass_index = xed_encoder_get_iclasses_index_in_group(xes);
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_REG1) {
   conditions_satisfied = xed_encode_ntluf_GPRy_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_GPR8_B(xes,xed3_operand_get_reg1(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][0]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_REG1) {
   conditions_satisfied = xed_encode_ntluf_GPRy_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_GPRv_B(xes,xed3_operand_get_reg1(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][1]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_MEM0) {
   conditions_satisfied = xed_encode_ntluf_GPRy_R(xes,xed3_operand_get_reg0(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_B);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][2]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_MEM0) {
   conditions_satisfied = xed_encode_ntluf_GPRy_R(xes,xed3_operand_get_reg0(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_V);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][3]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay) return 1;
   }
     }
   return 0;
   (void) okay;
   (void) conditions_satisfied;
   (void) xes;
}
xed_bool_t xed_encode_group_206(xed_encoder_request_t* xes)
{
   xed_bool_t okay=1;
   xed_bool_t conditions_satisfied=0;
   xed_ptrn_func_ptr_t fb_ptrn_function;
   static const xed_uint16_t iform_ids[2][1] = {
   /*VZEROALL      */    {2458,},
   /*VZEROUPPER    */    {1553,},
   };
   xed_uint8_t iclass_index = xed_encoder_get_iclasses_index_in_group(xes);
   if (xes->_n_operand_order == 0) {
   conditions_satisfied = (xed3_operand_get_must_use_evex(xes) == 0);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][0]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   return 0;
   (void) okay;
   (void) conditions_satisfied;
   (void) xes;
}
xed_bool_t xed_encode_group_207(xed_encoder_request_t* xes)
{
   xed_bool_t okay=1;
   xed_bool_t conditions_satisfied=0;
   xed_ptrn_func_ptr_t fb_ptrn_function;
   static const xed_uint16_t iform_ids[1][14] = {
   /*TEST          */    {1572,1571,1568,1570,1567,1569,1561,1562,1565,1566,1559,1560,1563,1564,},
   };
   xed_uint8_t iclass_index = xed_encoder_get_iclasses_index_in_group(xes);
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_IMM0) {
   conditions_satisfied = xed_encode_ntluf_OrAX(xes,xed3_operand_get_reg0(xes)) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][0]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_SIMMz_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_IMM0) {
   conditions_satisfied = (xed3_operand_get_reg0(xes) == XED_REG_AL) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][1]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_SIMM8_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_REG1) {
   conditions_satisfied = xed_encode_ntluf_GPR8_B(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_GPR8_R(xes,xed3_operand_get_reg1(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][2]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_REG1) {
   conditions_satisfied = xed_encode_ntluf_GPRv_B(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_GPRv_R(xes,xed3_operand_get_reg1(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][3]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_MEM0 && xes->_operand_order[1] == XED_OPERAND_REG0) {
   conditions_satisfied = (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_B) &&
		 xed_encode_ntluf_GPR8_R(xes,xed3_operand_get_reg0(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][4]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_MEM0 && xes->_operand_order[1] == XED_OPERAND_REG0) {
   conditions_satisfied = (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_V) &&
		 xed_encode_ntluf_GPRv_R(xes,xed3_operand_get_reg0(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][5]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_IMM0) {
   conditions_satisfied = xed_encode_ntluf_GPR8_B(xes,xed3_operand_get_reg0(xes)) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][6]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_SIMM8_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_IMM0) {
   conditions_satisfied = xed_encode_ntluf_GPR8_B(xes,xed3_operand_get_reg0(xes)) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][7]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_SIMM8_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_IMM0) {
   conditions_satisfied = xed_encode_ntluf_GPRv_B(xes,xed3_operand_get_reg0(xes)) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][8]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_SIMMz_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_IMM0) {
   conditions_satisfied = xed_encode_ntluf_GPRv_B(xes,xed3_operand_get_reg0(xes)) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][9]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_SIMMz_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_MEM0 && xes->_operand_order[1] == XED_OPERAND_IMM0) {
   conditions_satisfied = (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_B) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][10]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_SIMM8_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_MEM0 && xes->_operand_order[1] == XED_OPERAND_IMM0) {
   conditions_satisfied = (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_B) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][11]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_SIMM8_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_MEM0 && xes->_operand_order[1] == XED_OPERAND_IMM0) {
   conditions_satisfied = (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_V) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][12]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_SIMMz_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_MEM0 && xes->_operand_order[1] == XED_OPERAND_IMM0) {
   conditions_satisfied = (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_V) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][13]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_SIMMz_BIND(xes);
       if (okay) return 1;
   }
     }
   return 0;
   (void) okay;
   (void) conditions_satisfied;
   (void) xes;
}
xed_bool_t xed_encode_group_208(xed_encoder_request_t* xes)
{
   xed_bool_t okay=1;
   xed_bool_t conditions_satisfied=0;
   xed_ptrn_func_ptr_t fb_ptrn_function;
   static const xed_uint16_t iform_ids[2][5] = {
   /*VMOVNTDQ      */    {5693,5694,5696,5697,5695,},
   /*VMOVNTPS      */    {1573,1574,1576,1577,1575,},
   };
   xed_uint8_t iclass_index = xed_encoder_get_iclasses_index_in_group(xes);
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_MEM0 && xes->_operand_order[1] == XED_OPERAND_REG0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 (xed3_operand_get_must_use_evex(xes) == 0) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_DQ) &&
		 xed_encode_ntluf_XMM_R(xes,xed3_operand_get_reg0(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][0]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_MEM0 && xes->_operand_order[1] == XED_OPERAND_REG0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 1) &&
		 (xed3_operand_get_must_use_evex(xes) == 0) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_QQ) &&
		 xed_encode_ntluf_YMM_R(xes,xed3_operand_get_reg0(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][1]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_MEM0 && xes->_operand_order[1] == XED_OPERAND_REG0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_DQ) &&
		 xed_encode_ntluf_XMM_R3(xes,xed3_operand_get_reg0(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][2]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_32_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_FULLMEM_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_MEM0 && xes->_operand_order[1] == XED_OPERAND_REG0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 1) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_QQ) &&
		 xed_encode_ntluf_YMM_R3(xes,xed3_operand_get_reg0(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][3]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_32_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_FULLMEM_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_MEM0 && xes->_operand_order[1] == XED_OPERAND_REG0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 2) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_ZD) &&
		 xed_encode_ntluf_ZMM_R3(xes,xed3_operand_get_reg0(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][4]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_32_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_FULLMEM_BIND(xes);
       if (okay) return 1;
   }
     }
   return 0;
   (void) okay;
   (void) conditions_satisfied;
   (void) xes;
}
xed_bool_t xed_encode_group_209(xed_encoder_request_t* xes)
{
   xed_bool_t okay=1;
   xed_bool_t conditions_satisfied=0;
   xed_ptrn_func_ptr_t fb_ptrn_function;
   static const xed_uint16_t iform_ids[4][2] = {
   /*DEC_LOCK      */    {6480,6481,},
   /*INC_LOCK      */    {4221,4222,},
   /*NEG_LOCK      */    {1590,1591,},
   /*NOT_LOCK      */    {4713,4714,},
   };
   xed_uint8_t iclass_index = xed_encoder_get_iclasses_index_in_group(xes);
   if (xes->_n_operand_order == 1 && xes->_operand_order[0] == XED_OPERAND_MEM0) {
   conditions_satisfied = (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_B);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][0]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 1 && xes->_operand_order[0] == XED_OPERAND_MEM0) {
   conditions_satisfied = (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_V);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][1]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay) return 1;
   }
     }
   return 0;
   (void) okay;
   (void) conditions_satisfied;
   (void) xes;
}
xed_bool_t xed_encode_group_210(xed_encoder_request_t* xes)
{
   xed_bool_t okay=1;
   xed_bool_t conditions_satisfied=0;
   xed_ptrn_func_ptr_t fb_ptrn_function;
   static const xed_uint16_t iform_ids[1][6] = {
   /*VCVTNEPS2BF16 */    {1604,1606,1608,1605,1607,1609,},
   };
   xed_uint8_t iclass_index = xed_encoder_get_iclasses_index_in_group(xes);
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[7], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 xed_encode_ntluf_XMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_XMM_B3(xes,xed3_operand_get_reg2(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][0]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[7], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 1) &&
		 xed_encode_ntluf_XMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_YMM_B3(xes,xed3_operand_get_reg2(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][1]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[7], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 2) &&
		 xed_encode_ntluf_YMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_ZMM_B3(xes,xed3_operand_get_reg2(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][2]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[14], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 xed_encode_ntluf_XMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_VV);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][3]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_32_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_FULL_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[14], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 1) &&
		 xed_encode_ntluf_XMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_VV);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][4]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_32_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_FULL_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[14], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 2) &&
		 xed_encode_ntluf_YMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_VV);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][5]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_32_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_FULL_BIND(xes);
       if (okay) return 1;
   }
     }
   return 0;
   (void) okay;
   (void) conditions_satisfied;
   (void) xes;
}
xed_bool_t xed_encode_group_211(xed_encoder_request_t* xes)
{
   xed_bool_t okay=1;
   xed_bool_t conditions_satisfied=0;
   xed_ptrn_func_ptr_t fb_ptrn_function;
   static const xed_uint16_t iform_ids[4][6] = {
   /*VPROTB        */    {4939,4941,4938,4937,4940,4936,},
   /*VPROTD        */    {4738,4740,4737,4736,4739,4735,},
   /*VPROTQ        */    {1621,1623,1620,1619,1622,1618,},
   /*VPROTW        */    {3787,3789,3786,3785,3788,3784,},
   };
   xed_uint8_t iclass_index = xed_encoder_get_iclasses_index_in_group(xes);
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[7], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 xed_encode_ntluf_XMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_XMM_B(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_XMM_N(xes,xed3_operand_get_reg2(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][0]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[7], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 xed_encode_ntluf_XMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_XMM_N(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_XMM_B(xes,xed3_operand_get_reg2(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][1]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[24], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 xed_encode_ntluf_XMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_DQ) &&
		 xed_encode_ntluf_XMM_N(xes,xed3_operand_get_reg1(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][2]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[15], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 xed_encode_ntluf_XMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_XMM_B(xes,xed3_operand_get_reg1(xes)) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][3]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_UIMM8_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[14], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 xed_encode_ntluf_XMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_XMM_N(xes,xed3_operand_get_reg1(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_DQ);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][4]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[20], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 xed_encode_ntluf_XMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_DQ) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][5]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_UIMM8_BIND(xes);
       if (okay) return 1;
   }
     }
   return 0;
   (void) okay;
   (void) conditions_satisfied;
   (void) xes;
}
xed_bool_t xed_encode_group_212(xed_encoder_request_t* xes)
{
   xed_bool_t okay=1;
   xed_bool_t conditions_satisfied=0;
   xed_ptrn_func_ptr_t fb_ptrn_function;
   static const xed_uint16_t iform_ids[2][6] = {
   /*VPCMPD        */    {3745,3747,3743,3746,3748,3744,},
   /*VPCMPUD       */    {1632,1634,1630,1633,1635,1631,},
   };
   xed_uint8_t iclass_index = xed_encoder_get_iclasses_index_in_group(xes);
   if (xes->_n_operand_order == 5 && memcmp(xed_encode_order[18], xes->_operand_order, sizeof(xed_uint8_t)*5)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 xed_encode_ntluf_MASK_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_XMM_N3(xes,xed3_operand_get_reg2(xes)) &&
		 xed_encode_ntluf_XMM_B3(xes,xed3_operand_get_reg3(xes)) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][0]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_UIMM8_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 5 && memcmp(xed_encode_order[18], xes->_operand_order, sizeof(xed_uint8_t)*5)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 1) &&
		 xed_encode_ntluf_MASK_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_YMM_N3(xes,xed3_operand_get_reg2(xes)) &&
		 xed_encode_ntluf_YMM_B3(xes,xed3_operand_get_reg3(xes)) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][1]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_UIMM8_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 5 && memcmp(xed_encode_order[18], xes->_operand_order, sizeof(xed_uint8_t)*5)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 2) &&
		 xed_encode_ntluf_MASK_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_ZMM_N3(xes,xed3_operand_get_reg2(xes)) &&
		 xed_encode_ntluf_ZMM_B3(xes,xed3_operand_get_reg3(xes)) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][2]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_UIMM8_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 5 && memcmp(xed_encode_order[19], xes->_operand_order, sizeof(xed_uint8_t)*5)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 xed_encode_ntluf_MASK_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_XMM_N3(xes,xed3_operand_get_reg2(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_VV) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][3]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_UIMM8_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_32_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_FULL_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 5 && memcmp(xed_encode_order[19], xes->_operand_order, sizeof(xed_uint8_t)*5)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 1) &&
		 xed_encode_ntluf_MASK_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_YMM_N3(xes,xed3_operand_get_reg2(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_VV) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][4]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_UIMM8_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_32_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_FULL_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 5 && memcmp(xed_encode_order[19], xes->_operand_order, sizeof(xed_uint8_t)*5)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 2) &&
		 xed_encode_ntluf_MASK_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_ZMM_N3(xes,xed3_operand_get_reg2(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_VV) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][5]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_UIMM8_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_32_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_FULL_BIND(xes);
       if (okay) return 1;
   }
     }
   return 0;
   (void) okay;
   (void) conditions_satisfied;
   (void) xes;
}
xed_bool_t xed_encode_group_213(xed_encoder_request_t* xes)
{
   xed_bool_t okay=1;
   xed_bool_t conditions_satisfied=0;
   xed_ptrn_func_ptr_t fb_ptrn_function;
   static const xed_uint16_t iform_ids[2][4] = {
   /*MOVAPS        */    {1641,1639,1640,1638,},
   /*MOVUPS        */    {4543,4541,4542,4540,},
   };
   xed_uint8_t iclass_index = xed_encoder_get_iclasses_index_in_group(xes);
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_REG1) {
   conditions_satisfied = xed_encode_ntluf_XMM_B(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_XMM_R(xes,xed3_operand_get_reg1(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][0]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_REG1) {
   conditions_satisfied = xed_encode_ntluf_XMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_XMM_B(xes,xed3_operand_get_reg1(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][1]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_MEM0 && xes->_operand_order[1] == XED_OPERAND_REG0) {
   conditions_satisfied = (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_PS) &&
		 xed_encode_ntluf_XMM_R(xes,xed3_operand_get_reg0(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][2]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_MEM0) {
   conditions_satisfied = xed_encode_ntluf_XMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_PS);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][3]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay) return 1;
   }
     }
   return 0;
   (void) okay;
   (void) conditions_satisfied;
   (void) xes;
}
xed_bool_t xed_encode_group_214(xed_encoder_request_t* xes)
{
   xed_bool_t okay=1;
   xed_bool_t conditions_satisfied=0;
   xed_ptrn_func_ptr_t fb_ptrn_function;
   static const xed_uint16_t iform_ids[1][4] = {
   /*BOUND         */    {1642,1644,1643,1645,},
   };
   xed_uint8_t iclass_index = xed_encoder_get_iclasses_index_in_group(xes);
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_MEM0) {
   conditions_satisfied = (xed3_operand_get_mode(xes) == 0) &&
		 xed_encode_ntluf_GPRv_R(xes,xed3_operand_get_reg0(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_A16);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][0]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_MEM0) {
   conditions_satisfied = (xed3_operand_get_mode(xes) == 0) &&
		 xed_encode_ntluf_GPRv_R(xes,xed3_operand_get_reg0(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_A32);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][1]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_MEM0) {
   conditions_satisfied = (xed3_operand_get_mode(xes) == 1) &&
		 xed_encode_ntluf_GPRv_R(xes,xed3_operand_get_reg0(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_A16);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][2]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_MEM0) {
   conditions_satisfied = (xed3_operand_get_mode(xes) == 1) &&
		 xed_encode_ntluf_GPRv_R(xes,xed3_operand_get_reg0(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_A32);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][3]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay) return 1;
   }
     }
   return 0;
   (void) okay;
   (void) conditions_satisfied;
   (void) xes;
}
xed_bool_t xed_encode_group_215(xed_encoder_request_t* xes)
{
   xed_bool_t okay=1;
   xed_bool_t conditions_satisfied=0;
   xed_ptrn_func_ptr_t fb_ptrn_function;
   static const xed_uint16_t iform_ids[1][8] = {
   /*VMOVSS        */    {1649,1647,1648,1646,1653,1652,1651,1650,},
   };
   xed_uint8_t iclass_index = xed_encoder_get_iclasses_index_in_group(xes);
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[7], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_must_use_evex(xes) == 0) &&
		 xed_encode_ntluf_XMM_B(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_XMM_N(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_XMM_R(xes,xed3_operand_get_reg2(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][0]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[7], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_must_use_evex(xes) == 0) &&
		 xed_encode_ntluf_XMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_XMM_N(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_XMM_B(xes,xed3_operand_get_reg2(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][1]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_MEM0 && xes->_operand_order[1] == XED_OPERAND_REG0) {
   conditions_satisfied = (xed3_operand_get_must_use_evex(xes) == 0) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_D) &&
		 xed_encode_ntluf_XMM_R(xes,xed3_operand_get_reg0(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][2]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_MEM0) {
   conditions_satisfied = (xed3_operand_get_must_use_evex(xes) == 0) &&
		 xed_encode_ntluf_XMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_D);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][3]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 4 && memcmp(xed_encode_order[12], xes->_operand_order, sizeof(xed_uint8_t)*4)==0) {
   conditions_satisfied = xed_encode_ntluf_XMM_B3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_XMM_N3(xes,xed3_operand_get_reg2(xes)) &&
		 xed_encode_ntluf_XMM_R3(xes,xed3_operand_get_reg3(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][4]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 4 && memcmp(xed_encode_order[12], xes->_operand_order, sizeof(xed_uint8_t)*4)==0) {
   conditions_satisfied = xed_encode_ntluf_XMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_XMM_N3(xes,xed3_operand_get_reg2(xes)) &&
		 xed_encode_ntluf_XMM_B3(xes,xed3_operand_get_reg3(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][5]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[6], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_D) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_XMM_R3(xes,xed3_operand_get_reg1(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][6]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_32_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_SCALAR_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[14], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = xed_encode_ntluf_XMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_D);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][7]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_32_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_SCALAR_BIND(xes);
       if (okay) return 1;
   }
     }
   return 0;
   (void) okay;
   (void) conditions_satisfied;
   (void) xes;
}
xed_bool_t xed_encode_group_216(xed_encoder_request_t* xes)
{
   xed_bool_t okay=1;
   xed_bool_t conditions_satisfied=0;
   xed_ptrn_func_ptr_t fb_ptrn_function;
   static const xed_uint16_t iform_ids[2][1] = {
   /*VLDMXCSR      */    {1933,},
   /*VSTMXCSR      */    {1655,},
   };
   xed_uint8_t iclass_index = xed_encoder_get_iclasses_index_in_group(xes);
   if (xes->_n_operand_order == 1 && xes->_operand_order[0] == XED_OPERAND_MEM0) {
   conditions_satisfied = (xed3_operand_get_must_use_evex(xes) == 0) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_D);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][0]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay) return 1;
   }
     }
   return 0;
   (void) okay;
   (void) conditions_satisfied;
   (void) xes;
}
xed_bool_t xed_encode_group_217(xed_encoder_request_t* xes)
{
   xed_bool_t okay=1;
   xed_bool_t conditions_satisfied=0;
   xed_ptrn_func_ptr_t fb_ptrn_function;
   static const xed_uint16_t iform_ids[2][4] = {
   /*CVTSS2SI      */    {1658,1660,1657,1659,},
   /*CVTTSS2SI     */    {2849,2851,2848,2850,},
   };
   xed_uint8_t iclass_index = xed_encoder_get_iclasses_index_in_group(xes);
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_REG1) {
   conditions_satisfied = xed_encode_ntluf_GPR32_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_XMM_B(xes,xed3_operand_get_reg1(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][0]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_IGNORE66_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_REG1) {
   conditions_satisfied = xed_encode_ntluf_GPR64_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_XMM_B(xes,xed3_operand_get_reg1(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][1]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_IGNORE66_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_MEM0) {
   conditions_satisfied = xed_encode_ntluf_GPR32_R(xes,xed3_operand_get_reg0(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_SS);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][2]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_IGNORE66_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_MEM0) {
   conditions_satisfied = xed_encode_ntluf_GPR64_R(xes,xed3_operand_get_reg0(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_SS);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][3]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_IGNORE66_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay) return 1;
   }
     }
   return 0;
   (void) okay;
   (void) conditions_satisfied;
   (void) xes;
}
xed_bool_t xed_encode_group_218(xed_encoder_request_t* xes)
{
   xed_bool_t okay=1;
   xed_bool_t conditions_satisfied=0;
   xed_ptrn_func_ptr_t fb_ptrn_function;
   static const xed_uint16_t iform_ids[2][6] = {
   /*VPCMPQ        */    {1663,1665,1661,1664,1666,1662,},
   /*VPCMPUQ       */    {5836,5838,5834,5837,5839,5835,},
   };
   xed_uint8_t iclass_index = xed_encoder_get_iclasses_index_in_group(xes);
   if (xes->_n_operand_order == 5 && memcmp(xed_encode_order[18], xes->_operand_order, sizeof(xed_uint8_t)*5)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 xed_encode_ntluf_MASK_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_XMM_N3(xes,xed3_operand_get_reg2(xes)) &&
		 xed_encode_ntluf_XMM_B3(xes,xed3_operand_get_reg3(xes)) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][0]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_UIMM8_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 5 && memcmp(xed_encode_order[18], xes->_operand_order, sizeof(xed_uint8_t)*5)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 1) &&
		 xed_encode_ntluf_MASK_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_YMM_N3(xes,xed3_operand_get_reg2(xes)) &&
		 xed_encode_ntluf_YMM_B3(xes,xed3_operand_get_reg3(xes)) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][1]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_UIMM8_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 5 && memcmp(xed_encode_order[18], xes->_operand_order, sizeof(xed_uint8_t)*5)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 2) &&
		 xed_encode_ntluf_MASK_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_ZMM_N3(xes,xed3_operand_get_reg2(xes)) &&
		 xed_encode_ntluf_ZMM_B3(xes,xed3_operand_get_reg3(xes)) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][2]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_UIMM8_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 5 && memcmp(xed_encode_order[19], xes->_operand_order, sizeof(xed_uint8_t)*5)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 xed_encode_ntluf_MASK_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_XMM_N3(xes,xed3_operand_get_reg2(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_VV) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][3]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_UIMM8_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_64_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_FULL_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 5 && memcmp(xed_encode_order[19], xes->_operand_order, sizeof(xed_uint8_t)*5)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 1) &&
		 xed_encode_ntluf_MASK_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_YMM_N3(xes,xed3_operand_get_reg2(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_VV) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][4]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_UIMM8_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_64_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_FULL_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 5 && memcmp(xed_encode_order[19], xes->_operand_order, sizeof(xed_uint8_t)*5)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 2) &&
		 xed_encode_ntluf_MASK_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_ZMM_N3(xes,xed3_operand_get_reg2(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_VV) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][5]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_UIMM8_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_64_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_FULL_BIND(xes);
       if (okay) return 1;
   }
     }
   return 0;
   (void) okay;
   (void) conditions_satisfied;
   (void) xes;
}
xed_bool_t xed_encode_group_219(xed_encoder_request_t* xes)
{
   xed_bool_t okay=1;
   xed_bool_t conditions_satisfied=0;
   xed_ptrn_func_ptr_t fb_ptrn_function;
   static const xed_uint16_t iform_ids[3][1] = {
   /*CLDEMOTE      */    {1667,},
   /*INVLPG        */    {6895,},
   /*PREFETCHWT1   */    {2558,},
   };
   xed_uint8_t iclass_index = xed_encoder_get_iclasses_index_in_group(xes);
   if (xes->_n_operand_order == 1 && xes->_operand_order[0] == XED_OPERAND_MEM0) {
   conditions_satisfied = (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_B);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][0]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay) return 1;
   }
     }
   return 0;
   (void) okay;
   (void) conditions_satisfied;
   (void) xes;
}
xed_bool_t xed_encode_group_220(xed_encoder_request_t* xes)
{
   xed_bool_t okay=1;
   xed_bool_t conditions_satisfied=0;
   xed_ptrn_func_ptr_t fb_ptrn_function;
   static const xed_uint16_t iform_ids[1][2] = {
   /*RET_NEAR      */    {1692,1691,},
   };
   xed_uint8_t iclass_index = xed_encoder_get_iclasses_index_in_group(xes);
   if (xes->_n_operand_order == 0) {
   conditions_satisfied = 1;
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][0]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_DF64_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_IMMUNE66_LOOP64_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 1 && xes->_operand_order[0] == XED_OPERAND_IMM0) {
   conditions_satisfied = (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][1]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_DF64_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_UIMM16_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_IMMUNE66_LOOP64_BIND(xes);
       if (okay) return 1;
   }
     }
   return 0;
   (void) okay;
   (void) conditions_satisfied;
   (void) xes;
}
xed_bool_t xed_encode_group_221(xed_encoder_request_t* xes)
{
   xed_bool_t okay=1;
   xed_bool_t conditions_satisfied=0;
   xed_ptrn_func_ptr_t fb_ptrn_function;
   static const xed_uint16_t iform_ids[2][3] = {
   /*VPSCATTERQQ   */    {1696,1697,1695,},
   /*VSCATTERQPD   */    {5109,5110,5108,},
   };
   xed_uint8_t iclass_index = xed_encoder_get_iclasses_index_in_group(xes);
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[6], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 (xed3_operand_get_easz(xes) != 1) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_Q) &&
		 xed_encode_ntluf_MASKNOT0(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_XMM_R3(xes,xed3_operand_get_reg1(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][0]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_UISA_VMODRM_XMM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_64_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_GSCAT_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[6], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 1) &&
		 (xed3_operand_get_easz(xes) != 1) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_Q) &&
		 xed_encode_ntluf_MASKNOT0(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_YMM_R3(xes,xed3_operand_get_reg1(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][1]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_UISA_VMODRM_YMM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_64_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_GSCAT_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[6], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 2) &&
		 (xed3_operand_get_easz(xes) != 1) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_Q) &&
		 xed_encode_ntluf_MASKNOT0(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_ZMM_R3(xes,xed3_operand_get_reg1(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][2]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_UISA_VMODRM_ZMM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_64_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_GSCAT_BIND(xes);
       if (okay) return 1;
   }
     }
   return 0;
   (void) okay;
   (void) conditions_satisfied;
   (void) xes;
}
xed_bool_t xed_encode_group_222(xed_encoder_request_t* xes)
{
   xed_bool_t okay=1;
   xed_bool_t conditions_satisfied=0;
   xed_ptrn_func_ptr_t fb_ptrn_function;
   static const xed_uint16_t iform_ids[2][5] = {
   /*VCOMISS       */    {2758,2756,2755,2757,2759,},
   /*VUCOMISS      */    {1716,1714,1713,1715,1717,},
   };
   xed_uint8_t iclass_index = xed_encoder_get_iclasses_index_in_group(xes);
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_REG1) {
   conditions_satisfied = (xed3_operand_get_sae(xes) != 0) &&
		 xed_encode_ntluf_XMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_XMM_B3(xes,xed3_operand_get_reg1(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][0]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_FIX_ROUND_LEN128_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_SAE_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_REG1) {
   conditions_satisfied = (xed3_operand_get_must_use_evex(xes) == 0) &&
		 xed_encode_ntluf_XMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_XMM_B(xes,xed3_operand_get_reg1(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][1]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_MEM0) {
   conditions_satisfied = (xed3_operand_get_must_use_evex(xes) == 0) &&
		 xed_encode_ntluf_XMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_D);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][2]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_REG1) {
   conditions_satisfied = xed_encode_ntluf_XMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_XMM_B3(xes,xed3_operand_get_reg1(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][3]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_FIX_ROUND_LEN128_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_MEM0) {
   conditions_satisfied = xed_encode_ntluf_XMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_D);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][4]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_32_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_SCALAR_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_FIX_ROUND_LEN128_BIND(xes);
       if (okay) return 1;
   }
     }
   return 0;
   (void) okay;
   (void) conditions_satisfied;
   (void) xes;
}
xed_bool_t xed_encode_group_223(xed_encoder_request_t* xes)
{
   xed_bool_t okay=1;
   xed_bool_t conditions_satisfied=0;
   xed_ptrn_func_ptr_t fb_ptrn_function;
   static const xed_uint16_t iform_ids[3][7] = {
   /*VGETMANTPS    */    {2699,2701,2703,2698,2702,2704,2700,},
   /*VREDUCEPS     */    {2110,2105,2107,2109,2106,2108,2111,},
   /*VRNDSCALEPS   */    {1730,1732,1734,1729,1733,1735,1731,},
   };
   xed_uint8_t iclass_index = xed_encoder_get_iclasses_index_in_group(xes);
   if (xes->_n_operand_order == 4 && memcmp(xed_encode_order[21], xes->_operand_order, sizeof(xed_uint8_t)*4)==0) {
   conditions_satisfied = (xed3_operand_get_sae(xes) != 0) &&
		 xed_encode_ntluf_ZMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_ZMM_B3(xes,xed3_operand_get_reg2(xes)) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][0]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_FIX_ROUND_LEN512_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_SAE_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_UIMM8_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 4 && memcmp(xed_encode_order[21], xes->_operand_order, sizeof(xed_uint8_t)*4)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 xed_encode_ntluf_XMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_XMM_B3(xes,xed3_operand_get_reg2(xes)) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][1]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_UIMM8_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 4 && memcmp(xed_encode_order[21], xes->_operand_order, sizeof(xed_uint8_t)*4)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 1) &&
		 xed_encode_ntluf_YMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_YMM_B3(xes,xed3_operand_get_reg2(xes)) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][2]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_UIMM8_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 4 && memcmp(xed_encode_order[21], xes->_operand_order, sizeof(xed_uint8_t)*4)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 2) &&
		 xed_encode_ntluf_ZMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_ZMM_B3(xes,xed3_operand_get_reg2(xes)) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][3]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_UIMM8_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 4 && memcmp(xed_encode_order[22], xes->_operand_order, sizeof(xed_uint8_t)*4)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 xed_encode_ntluf_XMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_VV) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][4]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_UIMM8_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_32_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_FULL_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 4 && memcmp(xed_encode_order[22], xes->_operand_order, sizeof(xed_uint8_t)*4)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 1) &&
		 xed_encode_ntluf_YMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_VV) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][5]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_UIMM8_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_32_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_FULL_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 4 && memcmp(xed_encode_order[22], xes->_operand_order, sizeof(xed_uint8_t)*4)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 2) &&
		 xed_encode_ntluf_ZMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_VV) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][6]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_UIMM8_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_32_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_FULL_BIND(xes);
       if (okay) return 1;
   }
     }
   return 0;
   (void) okay;
   (void) conditions_satisfied;
   (void) xes;
}
xed_bool_t xed_encode_group_224(xed_encoder_request_t* xes)
{
   xed_bool_t okay=1;
   xed_bool_t conditions_satisfied=0;
   xed_ptrn_func_ptr_t fb_ptrn_function;
   static const xed_uint16_t iform_ids[1][2] = {
   /*CVTPS2PD      */    {1737,1736,},
   };
   xed_uint8_t iclass_index = xed_encoder_get_iclasses_index_in_group(xes);
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_REG1) {
   conditions_satisfied = xed_encode_ntluf_XMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_XMM_B(xes,xed3_operand_get_reg1(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][0]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_MEM0) {
   conditions_satisfied = xed_encode_ntluf_XMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_Q);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][1]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay) return 1;
   }
     }
   return 0;
   (void) okay;
   (void) conditions_satisfied;
   (void) xes;
}
xed_bool_t xed_encode_group_225(xed_encoder_request_t* xes)
{
   xed_bool_t okay=1;
   xed_bool_t conditions_satisfied=0;
   xed_ptrn_func_ptr_t fb_ptrn_function;
   static const xed_uint16_t iform_ids[3][2] = {
   /*VMOVMSKPD     */    {1738,1739,},
   /*VMOVMSKPS     */    {2117,2118,},
   /*VPMOVMSKB     */    {5732,5733,},
   };
   xed_uint8_t iclass_index = xed_encoder_get_iclasses_index_in_group(xes);
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_REG1) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 (xed3_operand_get_must_use_evex(xes) == 0) &&
		 xed_encode_ntluf_GPR32_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_XMM_B(xes,xed3_operand_get_reg1(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][0]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_REG1) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 1) &&
		 (xed3_operand_get_must_use_evex(xes) == 0) &&
		 xed_encode_ntluf_GPR32_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_YMM_B(xes,xed3_operand_get_reg1(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][1]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   return 0;
   (void) okay;
   (void) conditions_satisfied;
   (void) xes;
}
xed_bool_t xed_encode_group_226(xed_encoder_request_t* xes)
{
   xed_bool_t okay=1;
   xed_bool_t conditions_satisfied=0;
   xed_ptrn_func_ptr_t fb_ptrn_function;
   static const xed_uint16_t iform_ids[1][2] = {
   /*MOVDIRI       */    {1746,1747,},
   };
   xed_uint8_t iclass_index = xed_encoder_get_iclasses_index_in_group(xes);
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_MEM0 && xes->_operand_order[1] == XED_OPERAND_REG0) {
   conditions_satisfied = (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_D) &&
		 xed_encode_ntluf_GPR32_R(xes,xed3_operand_get_reg0(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][0]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_MEM0 && xes->_operand_order[1] == XED_OPERAND_REG0) {
   conditions_satisfied = (xed3_operand_get_mode(xes) == 2) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_Q) &&
		 xed_encode_ntluf_GPR64_R(xes,xed3_operand_get_reg0(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][1]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay) return 1;
   }
     }
   return 0;
   (void) okay;
   (void) conditions_satisfied;
   (void) xes;
}
xed_bool_t xed_encode_group_227(xed_encoder_request_t* xes)
{
   xed_bool_t okay=1;
   xed_bool_t conditions_satisfied=0;
   xed_ptrn_func_ptr_t fb_ptrn_function;
   static const xed_uint16_t iform_ids[2][10] = {
   /*VPMOVSXBW     */    {1748,1750,1749,1751,1752,1754,1756,1753,1755,1757,},
   /*VPMOVZXBW     */    {6549,6551,6550,6552,6553,6555,6557,6554,6556,6558,},
   };
   xed_uint8_t iclass_index = xed_encoder_get_iclasses_index_in_group(xes);
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_REG1) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 (xed3_operand_get_must_use_evex(xes) == 0) &&
		 xed_encode_ntluf_XMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_XMM_B(xes,xed3_operand_get_reg1(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][0]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_REG1) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 1) &&
		 (xed3_operand_get_must_use_evex(xes) == 0) &&
		 xed_encode_ntluf_YMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_XMM_B(xes,xed3_operand_get_reg1(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][1]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_MEM0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 (xed3_operand_get_must_use_evex(xes) == 0) &&
		 xed_encode_ntluf_XMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_Q);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][2]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_MEM0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 1) &&
		 (xed3_operand_get_must_use_evex(xes) == 0) &&
		 xed_encode_ntluf_YMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_DQ);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][3]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[7], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 xed_encode_ntluf_XMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_XMM_B3(xes,xed3_operand_get_reg2(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][4]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[7], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 1) &&
		 xed_encode_ntluf_YMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_XMM_B3(xes,xed3_operand_get_reg2(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][5]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[7], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 2) &&
		 xed_encode_ntluf_ZMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_YMM_B3(xes,xed3_operand_get_reg2(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][6]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[14], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 xed_encode_ntluf_XMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_Q);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][7]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_8_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_HALFMEM_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[14], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 1) &&
		 xed_encode_ntluf_YMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_DQ);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][8]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_8_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_HALFMEM_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[14], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 2) &&
		 xed_encode_ntluf_ZMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_QQ);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][9]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_8_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_HALFMEM_BIND(xes);
       if (okay) return 1;
   }
     }
   return 0;
   (void) okay;
   (void) conditions_satisfied;
   (void) xes;
}
xed_bool_t xed_encode_group_228(xed_encoder_request_t* xes)
{
   xed_bool_t okay=1;
   xed_bool_t conditions_satisfied=0;
   xed_ptrn_func_ptr_t fb_ptrn_function;
   static const xed_uint16_t iform_ids[3][3] = {
   /*VGETEXPSD     */    {1762,1761,1763,},
   /*VRCP28SD      */    {2270,2269,2271,},
   /*VRSQRT28SD    */    {4705,4704,4706,},
   };
   xed_uint8_t iclass_index = xed_encoder_get_iclasses_index_in_group(xes);
   if (xes->_n_operand_order == 4 && memcmp(xed_encode_order[12], xes->_operand_order, sizeof(xed_uint8_t)*4)==0) {
   conditions_satisfied = (xed3_operand_get_sae(xes) != 0) &&
		 xed_encode_ntluf_XMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_XMM_N3(xes,xed3_operand_get_reg2(xes)) &&
		 xed_encode_ntluf_XMM_B3(xes,xed3_operand_get_reg3(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][0]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_FIX_ROUND_LEN128_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_SAE_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 4 && memcmp(xed_encode_order[12], xes->_operand_order, sizeof(xed_uint8_t)*4)==0) {
   conditions_satisfied = xed_encode_ntluf_XMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_XMM_N3(xes,xed3_operand_get_reg2(xes)) &&
		 xed_encode_ntluf_XMM_B3(xes,xed3_operand_get_reg3(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][1]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 4 && memcmp(xed_encode_order[13], xes->_operand_order, sizeof(xed_uint8_t)*4)==0) {
   conditions_satisfied = xed_encode_ntluf_XMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_XMM_N3(xes,xed3_operand_get_reg2(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_Q);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][2]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_64_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_SCALAR_BIND(xes);
       if (okay) return 1;
   }
     }
   return 0;
   (void) okay;
   (void) conditions_satisfied;
   (void) xes;
}
xed_bool_t xed_encode_group_229(xed_encoder_request_t* xes)
{
   xed_bool_t okay=1;
   xed_bool_t conditions_satisfied=0;
   xed_ptrn_func_ptr_t fb_ptrn_function;
   static const xed_uint16_t iform_ids[3][4] = {
   /*VBLENDVPD     */    {2635,2637,2634,2636,},
   /*VBLENDVPS     */    {6329,6331,6328,6330,},
   /*VPBLENDVB     */    {1768,1770,1767,1769,},
   };
   xed_uint8_t iclass_index = xed_encoder_get_iclasses_index_in_group(xes);
   if (xes->_n_operand_order == 4 && memcmp(xed_encode_order[12], xes->_operand_order, sizeof(xed_uint8_t)*4)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 (xed3_operand_get_must_use_evex(xes) == 0) &&
		 xed_encode_ntluf_XMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_XMM_N(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_XMM_B(xes,xed3_operand_get_reg2(xes)) &&
		 xed_encode_ntluf_XMM_SE(xes,xed3_operand_get_reg3(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][0]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_SE_IMM8_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 4 && memcmp(xed_encode_order[12], xes->_operand_order, sizeof(xed_uint8_t)*4)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 1) &&
		 (xed3_operand_get_must_use_evex(xes) == 0) &&
		 xed_encode_ntluf_YMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_YMM_N(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_YMM_B(xes,xed3_operand_get_reg2(xes)) &&
		 xed_encode_ntluf_YMM_SE(xes,xed3_operand_get_reg3(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][1]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_SE_IMM8_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 4 && memcmp(xed_encode_order[11], xes->_operand_order, sizeof(xed_uint8_t)*4)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 (xed3_operand_get_must_use_evex(xes) == 0) &&
		 xed_encode_ntluf_XMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_XMM_N(xes,xed3_operand_get_reg1(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_DQ) &&
		 xed_encode_ntluf_XMM_SE(xes,xed3_operand_get_reg2(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][2]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_SE_IMM8_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 4 && memcmp(xed_encode_order[11], xes->_operand_order, sizeof(xed_uint8_t)*4)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 1) &&
		 (xed3_operand_get_must_use_evex(xes) == 0) &&
		 xed_encode_ntluf_YMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_YMM_N(xes,xed3_operand_get_reg1(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_QQ) &&
		 xed_encode_ntluf_YMM_SE(xes,xed3_operand_get_reg2(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][3]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_SE_IMM8_BIND(xes);
       if (okay) return 1;
   }
     }
   return 0;
   (void) okay;
   (void) conditions_satisfied;
   (void) xes;
}
xed_bool_t xed_encode_group_230(xed_encoder_request_t* xes)
{
   xed_bool_t okay=1;
   xed_bool_t conditions_satisfied=0;
   xed_ptrn_func_ptr_t fb_ptrn_function;
   static const xed_uint16_t iform_ids[3][7] = {
   /*VGETMANTPD    */    {6287,6289,6291,6286,6290,6292,6288,},
   /*VREDUCEPD     */    {1792,1787,1789,1791,1788,1790,1793,},
   /*VRNDSCALEPD   */    {6708,6710,6712,6707,6711,6713,6709,},
   };
   xed_uint8_t iclass_index = xed_encoder_get_iclasses_index_in_group(xes);
   if (xes->_n_operand_order == 4 && memcmp(xed_encode_order[21], xes->_operand_order, sizeof(xed_uint8_t)*4)==0) {
   conditions_satisfied = (xed3_operand_get_sae(xes) != 0) &&
		 xed_encode_ntluf_ZMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_ZMM_B3(xes,xed3_operand_get_reg2(xes)) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][0]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_FIX_ROUND_LEN512_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_SAE_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_UIMM8_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 4 && memcmp(xed_encode_order[21], xes->_operand_order, sizeof(xed_uint8_t)*4)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 xed_encode_ntluf_XMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_XMM_B3(xes,xed3_operand_get_reg2(xes)) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][1]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_UIMM8_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 4 && memcmp(xed_encode_order[21], xes->_operand_order, sizeof(xed_uint8_t)*4)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 1) &&
		 xed_encode_ntluf_YMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_YMM_B3(xes,xed3_operand_get_reg2(xes)) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][2]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_UIMM8_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 4 && memcmp(xed_encode_order[21], xes->_operand_order, sizeof(xed_uint8_t)*4)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 2) &&
		 xed_encode_ntluf_ZMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_ZMM_B3(xes,xed3_operand_get_reg2(xes)) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][3]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_UIMM8_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 4 && memcmp(xed_encode_order[22], xes->_operand_order, sizeof(xed_uint8_t)*4)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 xed_encode_ntluf_XMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_VV) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][4]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_UIMM8_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_64_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_FULL_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 4 && memcmp(xed_encode_order[22], xes->_operand_order, sizeof(xed_uint8_t)*4)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 1) &&
		 xed_encode_ntluf_YMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_VV) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][5]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_UIMM8_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_64_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_FULL_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 4 && memcmp(xed_encode_order[22], xes->_operand_order, sizeof(xed_uint8_t)*4)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 2) &&
		 xed_encode_ntluf_ZMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_VV) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][6]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_UIMM8_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_64_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_FULL_BIND(xes);
       if (okay) return 1;
   }
     }
   return 0;
   (void) okay;
   (void) conditions_satisfied;
   (void) xes;
}
xed_bool_t xed_encode_group_231(xed_encoder_request_t* xes)
{
   xed_bool_t okay=1;
   xed_bool_t conditions_satisfied=0;
   xed_ptrn_func_ptr_t fb_ptrn_function;
   static const xed_uint16_t iform_ids[1][16] = {
   /*VPBROADCASTD  */    {1804,1806,1803,1805,1813,1814,1812,1817,1818,1816,1809,1810,1808,1811,1815,1807,},
   };
   xed_uint8_t iclass_index = xed_encoder_get_iclasses_index_in_group(xes);
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_REG1) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 (xed3_operand_get_must_use_evex(xes) == 0) &&
		 xed_encode_ntluf_XMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_XMM_B(xes,xed3_operand_get_reg1(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][0]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_REG1) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 1) &&
		 (xed3_operand_get_must_use_evex(xes) == 0) &&
		 xed_encode_ntluf_YMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_XMM_B(xes,xed3_operand_get_reg1(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][1]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_MEM0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 (xed3_operand_get_must_use_evex(xes) == 0) &&
		 xed_encode_ntluf_XMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_D);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][2]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_MEM0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 1) &&
		 (xed3_operand_get_must_use_evex(xes) == 0) &&
		 xed_encode_ntluf_YMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_D);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][3]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[7], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 (xed3_operand_get_mode(xes) != 2) &&
		 xed_encode_ntluf_XMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_GPR32_B(xes,xed3_operand_get_reg2(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][4]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[7], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 (xed3_operand_get_mode(xes) == 2) &&
		 xed_encode_ntluf_XMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_GPR32_B(xes,xed3_operand_get_reg2(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][5]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[7], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 xed_encode_ntluf_XMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_XMM_B3(xes,xed3_operand_get_reg2(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][6]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[7], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 1) &&
		 (xed3_operand_get_mode(xes) != 2) &&
		 xed_encode_ntluf_YMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_GPR32_B(xes,xed3_operand_get_reg2(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][7]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[7], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 1) &&
		 (xed3_operand_get_mode(xes) == 2) &&
		 xed_encode_ntluf_YMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_GPR32_B(xes,xed3_operand_get_reg2(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][8]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[7], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 1) &&
		 xed_encode_ntluf_YMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_XMM_B3(xes,xed3_operand_get_reg2(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][9]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[7], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 2) &&
		 (xed3_operand_get_mode(xes) != 2) &&
		 xed_encode_ntluf_ZMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_GPR32_B(xes,xed3_operand_get_reg2(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][10]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[7], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 2) &&
		 (xed3_operand_get_mode(xes) == 2) &&
		 xed_encode_ntluf_ZMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_GPR32_B(xes,xed3_operand_get_reg2(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][11]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[7], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 2) &&
		 xed_encode_ntluf_ZMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_XMM_B3(xes,xed3_operand_get_reg2(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][12]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[14], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 xed_encode_ntluf_XMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_D);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][13]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_32_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_TUPLE1_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[14], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 1) &&
		 xed_encode_ntluf_YMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_D);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][14]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_32_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_TUPLE1_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[14], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 2) &&
		 xed_encode_ntluf_ZMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_D);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][15]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_32_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_TUPLE1_BIND(xes);
       if (okay) return 1;
   }
     }
   return 0;
   (void) okay;
   (void) conditions_satisfied;
   (void) xes;
}
xed_bool_t xed_encode_group_232(xed_encoder_request_t* xes)
{
   xed_bool_t okay=1;
   xed_bool_t conditions_satisfied=0;
   xed_ptrn_func_ptr_t fb_ptrn_function;
   static const xed_uint16_t iform_ids[2][2] = {
   /*SYSENTER      */    {1830,1831,},
   /*SYSEXIT       */    {2424,2425,},
   };
   xed_uint8_t iclass_index = xed_encoder_get_iclasses_index_in_group(xes);
   if (xes->_n_operand_order == 0) {
   conditions_satisfied = (xed3_operand_get_mode(xes) != 2);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][0]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 0) {
   conditions_satisfied = (xed3_operand_get_mode(xes) == 2);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][1]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   return 0;
   (void) okay;
   (void) conditions_satisfied;
   (void) xes;
}
xed_bool_t xed_encode_group_233(xed_encoder_request_t* xes)
{
   xed_bool_t okay=1;
   xed_bool_t conditions_satisfied=0;
   xed_ptrn_func_ptr_t fb_ptrn_function;
   static const xed_uint16_t iform_ids[2][6] = {
   /*VPCMPUW       */    {1847,1849,1851,1848,1850,1852,},
   /*VPCMPW        */    {5056,5058,5060,5057,5059,5061,},
   };
   xed_uint8_t iclass_index = xed_encoder_get_iclasses_index_in_group(xes);
   if (xes->_n_operand_order == 5 && memcmp(xed_encode_order[18], xes->_operand_order, sizeof(xed_uint8_t)*5)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 xed_encode_ntluf_MASK_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_XMM_N3(xes,xed3_operand_get_reg2(xes)) &&
		 xed_encode_ntluf_XMM_B3(xes,xed3_operand_get_reg3(xes)) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][0]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_UIMM8_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 5 && memcmp(xed_encode_order[18], xes->_operand_order, sizeof(xed_uint8_t)*5)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 1) &&
		 xed_encode_ntluf_MASK_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_YMM_N3(xes,xed3_operand_get_reg2(xes)) &&
		 xed_encode_ntluf_YMM_B3(xes,xed3_operand_get_reg3(xes)) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][1]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_UIMM8_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 5 && memcmp(xed_encode_order[18], xes->_operand_order, sizeof(xed_uint8_t)*5)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 2) &&
		 xed_encode_ntluf_MASK_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_ZMM_N3(xes,xed3_operand_get_reg2(xes)) &&
		 xed_encode_ntluf_ZMM_B3(xes,xed3_operand_get_reg3(xes)) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][2]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_UIMM8_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 5 && memcmp(xed_encode_order[19], xes->_operand_order, sizeof(xed_uint8_t)*5)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 xed_encode_ntluf_MASK_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_XMM_N3(xes,xed3_operand_get_reg2(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_DQ) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][3]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_UIMM8_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_16_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_FULLMEM_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 5 && memcmp(xed_encode_order[19], xes->_operand_order, sizeof(xed_uint8_t)*5)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 1) &&
		 xed_encode_ntluf_MASK_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_YMM_N3(xes,xed3_operand_get_reg2(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_QQ) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][4]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_UIMM8_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_16_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_FULLMEM_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 5 && memcmp(xed_encode_order[19], xes->_operand_order, sizeof(xed_uint8_t)*5)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 2) &&
		 xed_encode_ntluf_MASK_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_ZMM_N3(xes,xed3_operand_get_reg2(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_ZD) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][5]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_UIMM8_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_16_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_FULLMEM_BIND(xes);
       if (okay) return 1;
   }
     }
   return 0;
   (void) okay;
   (void) conditions_satisfied;
   (void) xes;
}
xed_bool_t xed_encode_group_234(xed_encoder_request_t* xes)
{
   xed_bool_t okay=1;
   xed_bool_t conditions_satisfied=0;
   xed_ptrn_func_ptr_t fb_ptrn_function;
   static const xed_uint16_t iform_ids[1][1] = {
   /*LEAVE         */    {1857,},
   };
   xed_uint8_t iclass_index = xed_encoder_get_iclasses_index_in_group(xes);
   if (xes->_n_operand_order == 0) {
   conditions_satisfied = 1;
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][0]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_DF64_BIND(xes);
       if (okay) return 1;
   }
     }
   return 0;
   (void) okay;
   (void) conditions_satisfied;
   (void) xes;
}
xed_bool_t xed_encode_group_235(xed_encoder_request_t* xes)
{
   xed_bool_t okay=1;
   xed_bool_t conditions_satisfied=0;
   xed_ptrn_func_ptr_t fb_ptrn_function;
   static const xed_uint16_t iform_ids[1][2] = {
   /*REP_MOVSQ     */    {1885,1886,},
   };
   xed_uint8_t iclass_index = xed_encoder_get_iclasses_index_in_group(xes);
   if (xes->_n_operand_order == 0) {
   conditions_satisfied = (xed3_operand_get_mode(xes) == 2);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][0]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_OVERRIDE_SEG1_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 0) {
   conditions_satisfied = (xed3_operand_get_mode(xes) == 2);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][1]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_OVERRIDE_SEG1_BIND(xes);
       if (okay) return 1;
   }
     }
   return 0;
   (void) okay;
   (void) conditions_satisfied;
   (void) xes;
}
xed_bool_t xed_encode_group_236(xed_encoder_request_t* xes)
{
   xed_bool_t okay=1;
   xed_bool_t conditions_satisfied=0;
   xed_ptrn_func_ptr_t fb_ptrn_function;
   static const xed_uint16_t iform_ids[1][2] = {
   /*CMPSS         */    {1888,1887,},
   };
   xed_uint8_t iclass_index = xed_encoder_get_iclasses_index_in_group(xes);
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[15], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = xed_encode_ntluf_XMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_XMM_B(xes,xed3_operand_get_reg1(xes)) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][0]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_IGNORE66_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_UIMM8_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[20], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = xed_encode_ntluf_XMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_SS) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][1]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_IGNORE66_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_UIMM8_BIND(xes);
       if (okay) return 1;
   }
     }
   return 0;
   (void) okay;
   (void) conditions_satisfied;
   (void) xes;
}
xed_bool_t xed_encode_group_237(xed_encoder_request_t* xes)
{
   xed_bool_t okay=1;
   xed_bool_t conditions_satisfied=0;
   xed_ptrn_func_ptr_t fb_ptrn_function;
   static const xed_uint16_t iform_ids[1][1] = {
   /*JCXZ          */    {1889,},
   };
   xed_uint8_t iclass_index = xed_encoder_get_iclasses_index_in_group(xes);
   if (xes->_n_operand_order == 1 && xes->_operand_order[0] == XED_OPERAND_RELBR) {
   conditions_satisfied = (xed3_operand_get_easz(xes) == 1) &&
		 (xed3_operand_get_relbr(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][0]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_BRDISP8_BIND(xes);
       if (okay) return 1;
   }
     }
   return 0;
   (void) okay;
   (void) conditions_satisfied;
   (void) xes;
}
xed_bool_t xed_encode_group_238(xed_encoder_request_t* xes)
{
   xed_bool_t okay=1;
   xed_bool_t conditions_satisfied=0;
   xed_ptrn_func_ptr_t fb_ptrn_function;
   static const xed_uint16_t iform_ids[1][4] = {
   /*FCOM          */    {1892,1893,1891,1890,},
   };
   xed_uint8_t iclass_index = xed_encoder_get_iclasses_index_in_group(xes);
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_REG1) {
   conditions_satisfied = (xed3_operand_get_reg0(xes) == XED_REG_ST0) &&
		 xed_encode_ntluf_X87(xes,xed3_operand_get_reg1(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][0]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_REG1) {
   conditions_satisfied = (xed3_operand_get_reg0(xes) == XED_REG_ST0) &&
		 xed_encode_ntluf_X87(xes,xed3_operand_get_reg1(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][1]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_MEM0) {
   conditions_satisfied = (xed3_operand_get_reg0(xes) == XED_REG_ST0) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_M64REAL);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][2]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_MEM0) {
   conditions_satisfied = (xed3_operand_get_reg0(xes) == XED_REG_ST0) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_MEM32REAL);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][3]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay) return 1;
   }
     }
   return 0;
   (void) okay;
   (void) conditions_satisfied;
   (void) xes;
}
xed_bool_t xed_encode_group_239(xed_encoder_request_t* xes)
{
   xed_bool_t okay=1;
   xed_bool_t conditions_satisfied=0;
   xed_ptrn_func_ptr_t fb_ptrn_function;
   static const xed_uint16_t iform_ids[2][2] = {
   /*UD0           */    {5404,5403,},
   /*UD1           */    {1896,1895,},
   };
   xed_uint8_t iclass_index = xed_encoder_get_iclasses_index_in_group(xes);
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_REG1) {
   conditions_satisfied = xed_encode_ntluf_GPR32_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_GPR32_B(xes,xed3_operand_get_reg1(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][0]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_MEM0) {
   conditions_satisfied = xed_encode_ntluf_GPR32_R(xes,xed3_operand_get_reg0(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_D);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][1]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay) return 1;
   }
     }
   return 0;
   (void) okay;
   (void) conditions_satisfied;
   (void) xes;
}
xed_bool_t xed_encode_group_240(xed_encoder_request_t* xes)
{
   xed_bool_t okay=1;
   xed_bool_t conditions_satisfied=0;
   xed_ptrn_func_ptr_t fb_ptrn_function;
   static const xed_uint16_t iform_ids[5][4] = {
   /*DIV           */    {1908,1910,1907,1909,},
   /*IDIV          */    {2517,2519,2516,2518,},
   /*MUL           */    {3703,3705,3702,3704,},
   /*NEG           */    {2114,2116,2113,2115,},
   /*NOT           */    {2671,2673,2670,2672,},
   };
   xed_uint8_t iclass_index = xed_encoder_get_iclasses_index_in_group(xes);
   if (xes->_n_operand_order == 1 && xes->_operand_order[0] == XED_OPERAND_REG0) {
   conditions_satisfied = xed_encode_ntluf_GPR8_B(xes,xed3_operand_get_reg0(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][0]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 1 && xes->_operand_order[0] == XED_OPERAND_REG0) {
   conditions_satisfied = xed_encode_ntluf_GPRv_B(xes,xed3_operand_get_reg0(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][1]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 1 && xes->_operand_order[0] == XED_OPERAND_MEM0) {
   conditions_satisfied = (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_B);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][2]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 1 && xes->_operand_order[0] == XED_OPERAND_MEM0) {
   conditions_satisfied = (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_V);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][3]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay) return 1;
   }
     }
   return 0;
   (void) okay;
   (void) conditions_satisfied;
   (void) xes;
}
xed_bool_t xed_encode_group_241(xed_encoder_request_t* xes)
{
   xed_bool_t okay=1;
   xed_bool_t conditions_satisfied=0;
   xed_ptrn_func_ptr_t fb_ptrn_function;
   static const xed_uint16_t iform_ids[1][10] = {
   /*IMUL          */    {1912,1914,1911,1913,1920,1918,1916,1919,1917,1915,},
   };
   xed_uint8_t iclass_index = xed_encoder_get_iclasses_index_in_group(xes);
   if (xes->_n_operand_order == 1 && xes->_operand_order[0] == XED_OPERAND_REG0) {
   conditions_satisfied = xed_encode_ntluf_GPR8_B(xes,xed3_operand_get_reg0(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][0]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 1 && xes->_operand_order[0] == XED_OPERAND_REG0) {
   conditions_satisfied = xed_encode_ntluf_GPRv_B(xes,xed3_operand_get_reg0(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][1]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 1 && xes->_operand_order[0] == XED_OPERAND_MEM0) {
   conditions_satisfied = (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_B);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][2]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 1 && xes->_operand_order[0] == XED_OPERAND_MEM0) {
   conditions_satisfied = (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_V);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][3]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_REG1) {
   conditions_satisfied = xed_encode_ntluf_GPRv_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_GPRv_B(xes,xed3_operand_get_reg1(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][4]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[15], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = xed_encode_ntluf_GPRv_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_GPRv_B(xes,xed3_operand_get_reg1(xes)) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][5]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_SIMM8_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[15], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = xed_encode_ntluf_GPRv_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_GPRv_B(xes,xed3_operand_get_reg1(xes)) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][6]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_SIMMz_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_MEM0) {
   conditions_satisfied = xed_encode_ntluf_GPRv_R(xes,xed3_operand_get_reg0(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_V);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][7]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[20], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = xed_encode_ntluf_GPRv_R(xes,xed3_operand_get_reg0(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_V) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][8]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_SIMM8_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[20], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = xed_encode_ntluf_GPRv_R(xes,xed3_operand_get_reg0(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_V) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][9]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_SIMMz_BIND(xes);
       if (okay) return 1;
   }
     }
   return 0;
   (void) okay;
   (void) conditions_satisfied;
   (void) xes;
}
xed_bool_t xed_encode_group_242(xed_encoder_request_t* xes)
{
   xed_bool_t okay=1;
   xed_bool_t conditions_satisfied=0;
   xed_ptrn_func_ptr_t fb_ptrn_function;
   static const xed_uint16_t iform_ids[1][2] = {
   /*VPEXTRW_C5    */    {1934,1935,},
   };
   xed_uint8_t iclass_index = xed_encoder_get_iclasses_index_in_group(xes);
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[15], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 (xed3_operand_get_mode(xes) != 2) &&
		 xed_encode_ntluf_GPR32_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_XMM_B3(xes,xed3_operand_get_reg1(xes)) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][0]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_UIMM8_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[15], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 (xed3_operand_get_mode(xes) == 2) &&
		 xed_encode_ntluf_GPR32_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_XMM_B3(xes,xed3_operand_get_reg1(xes)) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][1]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_UIMM8_BIND(xes);
       if (okay) return 1;
   }
     }
   return 0;
   (void) okay;
   (void) conditions_satisfied;
   (void) xes;
}
xed_bool_t xed_encode_group_243(xed_encoder_request_t* xes)
{
   xed_bool_t okay=1;
   xed_bool_t conditions_satisfied=0;
   xed_ptrn_func_ptr_t fb_ptrn_function;
   static const xed_uint16_t iform_ids[4][6] = {
   /*ANDN          */    {5397,5398,5400,5395,5396,5399,},
   /*MULX          */    {1962,1963,1966,1964,1965,1967,},
   /*PDEP          */    {6276,6277,6279,6274,6275,6278,},
   /*PEXT          */    {6114,6115,6117,6112,6113,6116,},
   };
   xed_uint8_t iclass_index = xed_encoder_get_iclasses_index_in_group(xes);
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[7], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_mode(xes) != 2) &&
		 (xed3_operand_get_must_use_evex(xes) == 0) &&
		 xed_encode_ntluf_VGPR32_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_VGPR32_N(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_VGPR32_B(xes,xed3_operand_get_reg2(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][0]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[7], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_mode(xes) == 2) &&
		 (xed3_operand_get_must_use_evex(xes) == 0) &&
		 xed_encode_ntluf_VGPR32_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_VGPR32_N(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_VGPR32_B(xes,xed3_operand_get_reg2(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][1]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[7], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_mode(xes) == 2) &&
		 (xed3_operand_get_must_use_evex(xes) == 0) &&
		 xed_encode_ntluf_VGPR64_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_VGPR64_N(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_VGPR64_B(xes,xed3_operand_get_reg2(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][2]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[14], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_mode(xes) != 2) &&
		 (xed3_operand_get_must_use_evex(xes) == 0) &&
		 xed_encode_ntluf_VGPR32_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_VGPR32_N(xes,xed3_operand_get_reg1(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_D);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][3]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[14], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_mode(xes) == 2) &&
		 (xed3_operand_get_must_use_evex(xes) == 0) &&
		 xed_encode_ntluf_VGPR32_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_VGPR32_N(xes,xed3_operand_get_reg1(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_D);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][4]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[14], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_mode(xes) == 2) &&
		 (xed3_operand_get_must_use_evex(xes) == 0) &&
		 xed_encode_ntluf_VGPR64_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_VGPR64_N(xes,xed3_operand_get_reg1(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_Q);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][5]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay) return 1;
   }
     }
   return 0;
   (void) okay;
   (void) conditions_satisfied;
   (void) xes;
}
xed_bool_t xed_encode_group_244(xed_encoder_request_t* xes)
{
   xed_bool_t okay=1;
   xed_bool_t conditions_satisfied=0;
   xed_ptrn_func_ptr_t fb_ptrn_function;
   static const xed_uint16_t iform_ids[2][5] = {
   /*VGATHERQPD    */    {5475,5474,5477,5478,5476,},
   /*VPGATHERQQ    */    {1969,1968,1971,1972,1970,},
   };
   xed_uint8_t iclass_index = xed_encoder_get_iclasses_index_in_group(xes);
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[24], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 (xed3_operand_get_easz(xes) != 1) &&
		 (xed3_operand_get_must_use_evex(xes) == 0) &&
		 xed_encode_ntluf_XMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_Q) &&
		 xed_encode_ntluf_XMM_N(xes,xed3_operand_get_reg1(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][0]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_VMODRM_XMM_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[24], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 1) &&
		 (xed3_operand_get_easz(xes) != 1) &&
		 (xed3_operand_get_must_use_evex(xes) == 0) &&
		 xed_encode_ntluf_YMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_Q) &&
		 xed_encode_ntluf_YMM_N(xes,xed3_operand_get_reg1(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][1]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_VMODRM_YMM_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[14], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 (xed3_operand_get_easz(xes) != 1) &&
		 xed_encode_ntluf_XMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASKNOT0(xes,xed3_operand_get_reg1(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_Q);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][2]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_UISA_VMODRM_XMM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_64_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_GSCAT_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[14], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 1) &&
		 (xed3_operand_get_easz(xes) != 1) &&
		 xed_encode_ntluf_YMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASKNOT0(xes,xed3_operand_get_reg1(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_Q);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][3]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_UISA_VMODRM_YMM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_64_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_GSCAT_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[14], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 2) &&
		 (xed3_operand_get_easz(xes) != 1) &&
		 xed_encode_ntluf_ZMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASKNOT0(xes,xed3_operand_get_reg1(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_Q);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][4]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_UISA_VMODRM_ZMM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_64_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_GSCAT_BIND(xes);
       if (okay) return 1;
   }
     }
   return 0;
   (void) okay;
   (void) conditions_satisfied;
   (void) xes;
}
xed_bool_t xed_encode_group_245(xed_encoder_request_t* xes)
{
   xed_bool_t okay=1;
   xed_bool_t conditions_satisfied=0;
   xed_ptrn_func_ptr_t fb_ptrn_function;
   static const xed_uint16_t iform_ids[2][1] = {
   /*LDS           */    {1973,},
   /*LES           */    {2528,},
   };
   xed_uint8_t iclass_index = xed_encoder_get_iclasses_index_in_group(xes);
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_MEM0) {
   conditions_satisfied = (xed3_operand_get_mode(xes) != 2) &&
		 xed_encode_ntluf_GPRz_R(xes,xed3_operand_get_reg0(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_P);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][0]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay) return 1;
   }
     }
   return 0;
   (void) okay;
   (void) conditions_satisfied;
   (void) xes;
}
xed_bool_t xed_encode_group_246(xed_encoder_request_t* xes)
{
   xed_bool_t okay=1;
   xed_bool_t conditions_satisfied=0;
   xed_ptrn_func_ptr_t fb_ptrn_function;
   static const xed_uint16_t iform_ids[1][5] = {
   /*KMOVB         */    {1986,1985,1982,1984,1983,},
   };
   xed_uint8_t iclass_index = xed_encoder_get_iclasses_index_in_group(xes);
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_REG1) {
   conditions_satisfied = (xed3_operand_get_must_use_evex(xes) == 0) &&
		 xed_encode_ntluf_GPR32_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK_B(xes,xed3_operand_get_reg1(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][0]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_REG1) {
   conditions_satisfied = (xed3_operand_get_must_use_evex(xes) == 0) &&
		 xed_encode_ntluf_MASK_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_GPR32_B(xes,xed3_operand_get_reg1(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][1]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_REG1) {
   conditions_satisfied = (xed3_operand_get_must_use_evex(xes) == 0) &&
		 xed_encode_ntluf_MASK_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK_B(xes,xed3_operand_get_reg1(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][2]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_MEM0 && xes->_operand_order[1] == XED_OPERAND_REG0) {
   conditions_satisfied = (xed3_operand_get_must_use_evex(xes) == 0) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_B) &&
		 xed_encode_ntluf_MASK_R(xes,xed3_operand_get_reg0(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][3]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_MEM0) {
   conditions_satisfied = (xed3_operand_get_must_use_evex(xes) == 0) &&
		 xed_encode_ntluf_MASK_R(xes,xed3_operand_get_reg0(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_B);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][4]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay) return 1;
   }
     }
   return 0;
   (void) okay;
   (void) conditions_satisfied;
   (void) xes;
}
xed_bool_t xed_encode_group_247(xed_encoder_request_t* xes)
{
   xed_bool_t okay=1;
   xed_bool_t conditions_satisfied=0;
   xed_ptrn_func_ptr_t fb_ptrn_function;
   static const xed_uint16_t iform_ids[2][2] = {
   /*INSERTPS      */    {6568,6567,},
   /*ROUNDSS       */    {1988,1987,},
   };
   xed_uint8_t iclass_index = xed_encoder_get_iclasses_index_in_group(xes);
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[15], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = xed_encode_ntluf_XMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_XMM_B(xes,xed3_operand_get_reg1(xes)) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][0]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_REFINING66_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_UIMM8_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[20], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = xed_encode_ntluf_XMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_D) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][1]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_REFINING66_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_UIMM8_BIND(xes);
       if (okay) return 1;
   }
     }
   return 0;
   (void) okay;
   (void) conditions_satisfied;
   (void) xes;
}
xed_bool_t xed_encode_group_248(xed_encoder_request_t* xes)
{
   xed_bool_t okay=1;
   xed_bool_t conditions_satisfied=0;
   xed_ptrn_func_ptr_t fb_ptrn_function;
   static const xed_uint16_t iform_ids[1][2] = {
   /*CVTPI2PS      */    {1990,1989,},
   };
   xed_uint8_t iclass_index = xed_encoder_get_iclasses_index_in_group(xes);
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_REG1) {
   conditions_satisfied = xed_encode_ntluf_XMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MMX_B(xes,xed3_operand_get_reg1(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][0]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_MEM0) {
   conditions_satisfied = xed_encode_ntluf_XMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_Q);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][1]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay) return 1;
   }
     }
   return 0;
   (void) okay;
   (void) conditions_satisfied;
   (void) xes;
}
xed_bool_t xed_encode_group_249(xed_encoder_request_t* xes)
{
   xed_bool_t okay=1;
   xed_bool_t conditions_satisfied=0;
   xed_ptrn_func_ptr_t fb_ptrn_function;
   static const xed_uint16_t iform_ids[5][4] = {
   /*VPTEST        */    {6612,6614,6611,6613,},
   /*VRCPPS        */    {5424,5426,5423,5425,},
   /*VRSQRTPS      */    {1999,2001,1998,2000,},
   /*VTESTPD       */    {5429,5431,5428,5430,},
   /*VTESTPS       */    {4079,4081,4078,4080,},
   };
   xed_uint8_t iclass_index = xed_encoder_get_iclasses_index_in_group(xes);
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_REG1) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 (xed3_operand_get_must_use_evex(xes) == 0) &&
		 xed_encode_ntluf_XMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_XMM_B(xes,xed3_operand_get_reg1(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][0]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_REG1) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 1) &&
		 (xed3_operand_get_must_use_evex(xes) == 0) &&
		 xed_encode_ntluf_YMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_YMM_B(xes,xed3_operand_get_reg1(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][1]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_MEM0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 (xed3_operand_get_must_use_evex(xes) == 0) &&
		 xed_encode_ntluf_XMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_DQ);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][2]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_MEM0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 1) &&
		 (xed3_operand_get_must_use_evex(xes) == 0) &&
		 xed_encode_ntluf_YMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_QQ);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][3]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay) return 1;
   }
     }
   return 0;
   (void) okay;
   (void) conditions_satisfied;
   (void) xes;
}
xed_bool_t xed_encode_group_250(xed_encoder_request_t* xes)
{
   xed_bool_t okay=1;
   xed_bool_t conditions_satisfied=0;
   xed_ptrn_func_ptr_t fb_ptrn_function;
   static const xed_uint16_t iform_ids[2][6] = {
   /*VPTESTMQ      */    {2015,2017,2013,2016,2018,2014,},
   /*VPTESTNMQ     */    {2370,2372,2368,2371,2373,2369,},
   };
   xed_uint8_t iclass_index = xed_encoder_get_iclasses_index_in_group(xes);
   if (xes->_n_operand_order == 4 && memcmp(xed_encode_order[12], xes->_operand_order, sizeof(xed_uint8_t)*4)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 xed_encode_ntluf_MASK_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_XMM_N3(xes,xed3_operand_get_reg2(xes)) &&
		 xed_encode_ntluf_XMM_B3(xes,xed3_operand_get_reg3(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][0]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 4 && memcmp(xed_encode_order[12], xes->_operand_order, sizeof(xed_uint8_t)*4)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 1) &&
		 xed_encode_ntluf_MASK_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_YMM_N3(xes,xed3_operand_get_reg2(xes)) &&
		 xed_encode_ntluf_YMM_B3(xes,xed3_operand_get_reg3(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][1]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 4 && memcmp(xed_encode_order[12], xes->_operand_order, sizeof(xed_uint8_t)*4)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 2) &&
		 xed_encode_ntluf_MASK_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_ZMM_N3(xes,xed3_operand_get_reg2(xes)) &&
		 xed_encode_ntluf_ZMM_B3(xes,xed3_operand_get_reg3(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][2]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 4 && memcmp(xed_encode_order[13], xes->_operand_order, sizeof(xed_uint8_t)*4)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 xed_encode_ntluf_MASK_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_XMM_N3(xes,xed3_operand_get_reg2(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_VV);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][3]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_64_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_FULL_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 4 && memcmp(xed_encode_order[13], xes->_operand_order, sizeof(xed_uint8_t)*4)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 1) &&
		 xed_encode_ntluf_MASK_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_YMM_N3(xes,xed3_operand_get_reg2(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_VV);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][4]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_64_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_FULL_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 4 && memcmp(xed_encode_order[13], xes->_operand_order, sizeof(xed_uint8_t)*4)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 2) &&
		 xed_encode_ntluf_MASK_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_ZMM_N3(xes,xed3_operand_get_reg2(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_VV);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][5]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_64_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_FULL_BIND(xes);
       if (okay) return 1;
   }
     }
   return 0;
   (void) okay;
   (void) conditions_satisfied;
   (void) xes;
}
xed_bool_t xed_encode_group_251(xed_encoder_request_t* xes)
{
   xed_bool_t okay=1;
   xed_bool_t conditions_satisfied=0;
   xed_ptrn_func_ptr_t fb_ptrn_function;
   static const xed_uint16_t iform_ids[2][4] = {
   /*MONITOR       */    {2038,2037,2040,2039,},
   /*MONITORX      */    {2479,2478,2481,2480,},
   };
   xed_uint8_t iclass_index = xed_encoder_get_iclasses_index_in_group(xes);
   if (xes->_n_operand_order == 0) {
   conditions_satisfied = (xed3_operand_get_mode(xes) != 2) &&
		 (xed3_operand_get_easz(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][0]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 0) {
   conditions_satisfied = (xed3_operand_get_mode(xes) != 2) &&
		 (xed3_operand_get_easz(xes) == 2);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][1]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 0) {
   conditions_satisfied = (xed3_operand_get_mode(xes) == 2) &&
		 (xed3_operand_get_easz(xes) == 2);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][2]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 0) {
   conditions_satisfied = (xed3_operand_get_mode(xes) == 2) &&
		 (xed3_operand_get_easz(xes) == 3);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][3]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   return 0;
   (void) okay;
   (void) conditions_satisfied;
   (void) xes;
}
xed_bool_t xed_encode_group_252(xed_encoder_request_t* xes)
{
   xed_bool_t okay=1;
   xed_bool_t conditions_satisfied=0;
   xed_ptrn_func_ptr_t fb_ptrn_function;
   static const xed_uint16_t iform_ids[1][13] = {
   /*VCVTSI2SD     */    {2052,2042,2044,2046,2041,2043,2045,2047,2048,2051,2049,2050,2053,},
   };
   xed_uint8_t iclass_index = xed_encoder_get_iclasses_index_in_group(xes);
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[7], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_mode(xes) == 2) &&
		 (xed3_operand_get_roundc(xes) != 0) &&
		 xed_encode_ntluf_XMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_XMM_N3(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_GPR64_B(xes,xed3_operand_get_reg2(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][0]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_FIX_ROUND_LEN128_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_AVX512_ROUND_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[7], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_mode(xes) != 2) &&
		 (xed3_operand_get_must_use_evex(xes) == 0) &&
		 xed_encode_ntluf_XMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_XMM_N(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_GPR32_B(xes,xed3_operand_get_reg2(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][1]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[7], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_mode(xes) == 2) &&
		 (xed3_operand_get_must_use_evex(xes) == 0) &&
		 xed_encode_ntluf_XMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_XMM_N(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_GPR32_B(xes,xed3_operand_get_reg2(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][2]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[7], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_mode(xes) == 2) &&
		 (xed3_operand_get_must_use_evex(xes) == 0) &&
		 xed_encode_ntluf_XMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_XMM_N(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_GPR64_B(xes,xed3_operand_get_reg2(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][3]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[14], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_mode(xes) != 2) &&
		 (xed3_operand_get_must_use_evex(xes) == 0) &&
		 xed_encode_ntluf_XMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_XMM_N(xes,xed3_operand_get_reg1(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_D);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][4]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[14], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_mode(xes) == 2) &&
		 (xed3_operand_get_must_use_evex(xes) == 0) &&
		 xed_encode_ntluf_XMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_XMM_N(xes,xed3_operand_get_reg1(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_D);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][5]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[14], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_mode(xes) == 2) &&
		 (xed3_operand_get_must_use_evex(xes) == 0) &&
		 xed_encode_ntluf_XMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_XMM_N(xes,xed3_operand_get_reg1(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_Q);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][6]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[7], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_mode(xes) != 2) &&
		 xed_encode_ntluf_XMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_XMM_N3(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_GPR32_B(xes,xed3_operand_get_reg2(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][7]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_FIX_ROUND_LEN128_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[7], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_mode(xes) == 2) &&
		 xed_encode_ntluf_XMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_XMM_N3(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_GPR32_B(xes,xed3_operand_get_reg2(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][8]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_FIX_ROUND_LEN128_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[7], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_mode(xes) == 2) &&
		 xed_encode_ntluf_XMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_XMM_N3(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_GPR64_B(xes,xed3_operand_get_reg2(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][9]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_FIX_ROUND_LEN128_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[14], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_mode(xes) != 2) &&
		 xed_encode_ntluf_XMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_XMM_N3(xes,xed3_operand_get_reg1(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_D);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][10]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_32_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_GPR_READER_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_FIX_ROUND_LEN128_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[14], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_mode(xes) == 2) &&
		 xed_encode_ntluf_XMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_XMM_N3(xes,xed3_operand_get_reg1(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_D);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][11]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_32_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_GPR_READER_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_FIX_ROUND_LEN128_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[14], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_mode(xes) == 2) &&
		 xed_encode_ntluf_XMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_XMM_N3(xes,xed3_operand_get_reg1(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_Q);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][12]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_64_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_GPR_READER_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_FIX_ROUND_LEN128_BIND(xes);
       if (okay) return 1;
   }
     }
   return 0;
   (void) okay;
   (void) conditions_satisfied;
   (void) xes;
}
xed_bool_t xed_encode_group_253(xed_encoder_request_t* xes)
{
   xed_bool_t okay=1;
   xed_bool_t conditions_satisfied=0;
   xed_ptrn_func_ptr_t fb_ptrn_function;
   static const xed_uint16_t iform_ids[1][4] = {
   /*MOV_CR        */    {2055,2057,2056,2058,},
   };
   xed_uint8_t iclass_index = xed_encoder_get_iclasses_index_in_group(xes);
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_REG1) {
   conditions_satisfied = (xed3_operand_get_mode(xes) != 2) &&
		 xed_encode_ntluf_CR_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_GPR32_B(xes,xed3_operand_get_reg1(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][0]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_CR_WIDTH_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_REG1) {
   conditions_satisfied = (xed3_operand_get_mode(xes) != 2) &&
		 xed_encode_ntluf_GPR32_B(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_CR_R(xes,xed3_operand_get_reg1(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][1]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_CR_WIDTH_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_REG1) {
   conditions_satisfied = (xed3_operand_get_mode(xes) == 2) &&
		 xed_encode_ntluf_CR_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_GPR64_B(xes,xed3_operand_get_reg1(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][2]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_CR_WIDTH_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_REG1) {
   conditions_satisfied = (xed3_operand_get_mode(xes) == 2) &&
		 xed_encode_ntluf_GPR64_B(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_CR_R(xes,xed3_operand_get_reg1(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][3]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_CR_WIDTH_BIND(xes);
       if (okay) return 1;
   }
     }
   return 0;
   (void) okay;
   (void) conditions_satisfied;
   (void) xes;
}
xed_bool_t xed_encode_group_254(xed_encoder_request_t* xes)
{
   xed_bool_t okay=1;
   xed_bool_t conditions_satisfied=0;
   xed_ptrn_func_ptr_t fb_ptrn_function;
   static const xed_uint16_t iform_ids[2][1] = {
   /*INCSSPQ       */    {4025,},
   /*RDSSPQ        */    {2073,},
   };
   xed_uint8_t iclass_index = xed_encoder_get_iclasses_index_in_group(xes);
   if (xes->_n_operand_order == 1 && xes->_operand_order[0] == XED_OPERAND_REG0) {
   conditions_satisfied = (xed3_operand_get_mode(xes) == 2) &&
		 xed_encode_ntluf_GPR64_B(xes,xed3_operand_get_reg0(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][0]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   return 0;
   (void) okay;
   (void) conditions_satisfied;
   (void) xes;
}
xed_bool_t xed_encode_group_255(xed_encoder_request_t* xes)
{
   xed_bool_t okay=1;
   xed_bool_t conditions_satisfied=0;
   xed_ptrn_func_ptr_t fb_ptrn_function;
   static const xed_uint16_t iform_ids[1][1] = {
   /*VMXON         */    {2078,},
   };
   xed_uint8_t iclass_index = xed_encoder_get_iclasses_index_in_group(xes);
   if (xes->_n_operand_order == 1 && xes->_operand_order[0] == XED_OPERAND_MEM0) {
   conditions_satisfied = (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_Q);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][0]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_IGNORE66_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay) return 1;
   }
     }
   return 0;
   (void) okay;
   (void) conditions_satisfied;
   (void) xes;
}
xed_bool_t xed_encode_group_256(xed_encoder_request_t* xes)
{
   xed_bool_t okay=1;
   xed_bool_t conditions_satisfied=0;
   xed_ptrn_func_ptr_t fb_ptrn_function;
   static const xed_uint16_t iform_ids[2][2] = {
   /*REP_INSB      */    {2084,2085,},
   /*REP_STOSB     */    {5586,5587,},
   };
   xed_uint8_t iclass_index = xed_encoder_get_iclasses_index_in_group(xes);
   if (xes->_n_operand_order == 0) {
   conditions_satisfied = 1;
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][0]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 0) {
   conditions_satisfied = 1;
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][1]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   return 0;
   (void) okay;
   (void) conditions_satisfied;
   (void) xes;
}
xed_bool_t xed_encode_group_257(xed_encoder_request_t* xes)
{
   xed_bool_t okay=1;
   xed_bool_t conditions_satisfied=0;
   xed_ptrn_func_ptr_t fb_ptrn_function;
   static const xed_uint16_t iform_ids[2][5] = {
   /*VGATHERQPS    */    {2093,2092,2095,2096,2094,},
   /*VPGATHERQD    */    {6950,6949,6952,6953,6951,},
   };
   xed_uint8_t iclass_index = xed_encoder_get_iclasses_index_in_group(xes);
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[24], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 (xed3_operand_get_easz(xes) != 1) &&
		 (xed3_operand_get_must_use_evex(xes) == 0) &&
		 xed_encode_ntluf_XMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_D) &&
		 xed_encode_ntluf_XMM_N(xes,xed3_operand_get_reg1(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][0]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_VMODRM_XMM_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[24], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 1) &&
		 (xed3_operand_get_easz(xes) != 1) &&
		 (xed3_operand_get_must_use_evex(xes) == 0) &&
		 xed_encode_ntluf_XMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_D) &&
		 xed_encode_ntluf_XMM_N(xes,xed3_operand_get_reg1(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][1]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_VMODRM_YMM_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[14], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 (xed3_operand_get_easz(xes) != 1) &&
		 xed_encode_ntluf_XMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASKNOT0(xes,xed3_operand_get_reg1(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_D);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][2]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_UISA_VMODRM_XMM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_32_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_GSCAT_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[14], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 1) &&
		 (xed3_operand_get_easz(xes) != 1) &&
		 xed_encode_ntluf_XMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASKNOT0(xes,xed3_operand_get_reg1(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_D);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][3]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_UISA_VMODRM_YMM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_32_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_GSCAT_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[14], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 2) &&
		 (xed3_operand_get_easz(xes) != 1) &&
		 xed_encode_ntluf_YMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASKNOT0(xes,xed3_operand_get_reg1(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_D);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][4]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_UISA_VMODRM_ZMM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_32_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_GSCAT_BIND(xes);
       if (okay) return 1;
   }
     }
   return 0;
   (void) okay;
   (void) conditions_satisfied;
   (void) xes;
}
xed_bool_t xed_encode_group_258(xed_encoder_request_t* xes)
{
   xed_bool_t okay=1;
   xed_bool_t conditions_satisfied=0;
   xed_ptrn_func_ptr_t fb_ptrn_function;
   static const xed_uint16_t iform_ids[3][6] = {
   /*VPMOVQW       */    {2101,2103,2099,2102,2104,2100,},
   /*VPMOVSQW      */    {2552,2554,2550,2553,2555,2551,},
   /*VPMOVUSQW     */    {4493,4495,4491,4494,4496,4492,},
   };
   xed_uint8_t iclass_index = xed_encoder_get_iclasses_index_in_group(xes);
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[7], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 xed_encode_ntluf_XMM_B3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_XMM_R3(xes,xed3_operand_get_reg2(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][0]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[7], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 1) &&
		 xed_encode_ntluf_XMM_B3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_YMM_R3(xes,xed3_operand_get_reg2(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][1]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[7], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 2) &&
		 xed_encode_ntluf_XMM_B3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_ZMM_R3(xes,xed3_operand_get_reg2(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][2]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[6], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_D) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_XMM_R3(xes,xed3_operand_get_reg1(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][3]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_16_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_QUARTERMEM_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[6], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 1) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_Q) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_YMM_R3(xes,xed3_operand_get_reg1(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][4]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_16_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_QUARTERMEM_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[6], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 2) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_DQ) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_ZMM_R3(xes,xed3_operand_get_reg1(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][5]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_16_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_QUARTERMEM_BIND(xes);
       if (okay) return 1;
   }
     }
   return 0;
   (void) okay;
   (void) conditions_satisfied;
   (void) xes;
}
xed_bool_t xed_encode_group_259(xed_encoder_request_t* xes)
{
   xed_bool_t okay=1;
   xed_bool_t conditions_satisfied=0;
   xed_ptrn_func_ptr_t fb_ptrn_function;
   static const xed_uint16_t iform_ids[2][2] = {
   /*VRCP14SS      */    {5233,5234,},
   /*VRSQRT14SS    */    {2129,2130,},
   };
   xed_uint8_t iclass_index = xed_encoder_get_iclasses_index_in_group(xes);
   if (xes->_n_operand_order == 4 && memcmp(xed_encode_order[12], xes->_operand_order, sizeof(xed_uint8_t)*4)==0) {
   conditions_satisfied = xed_encode_ntluf_XMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_XMM_N3(xes,xed3_operand_get_reg2(xes)) &&
		 xed_encode_ntluf_XMM_B3(xes,xed3_operand_get_reg3(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][0]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 4 && memcmp(xed_encode_order[13], xes->_operand_order, sizeof(xed_uint8_t)*4)==0) {
   conditions_satisfied = xed_encode_ntluf_XMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_XMM_N3(xes,xed3_operand_get_reg2(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_D);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][1]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_32_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_SCALAR_BIND(xes);
       if (okay) return 1;
   }
     }
   return 0;
   (void) okay;
   (void) conditions_satisfied;
   (void) xes;
}
xed_bool_t xed_encode_group_260(xed_encoder_request_t* xes)
{
   xed_bool_t okay=1;
   xed_bool_t conditions_satisfied=0;
   xed_ptrn_func_ptr_t fb_ptrn_function;
   static const xed_uint16_t iform_ids[1][6] = {
   /*VPOPCNTB      */    {2138,2140,2142,2139,2141,2143,},
   };
   xed_uint8_t iclass_index = xed_encoder_get_iclasses_index_in_group(xes);
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[7], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 xed_encode_ntluf_XMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_XMM_B3(xes,xed3_operand_get_reg2(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][0]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[7], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 1) &&
		 xed_encode_ntluf_YMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_YMM_B3(xes,xed3_operand_get_reg2(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][1]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[7], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 2) &&
		 xed_encode_ntluf_ZMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_ZMM_B3(xes,xed3_operand_get_reg2(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][2]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[14], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 xed_encode_ntluf_XMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_DQ);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][3]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_8_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_FULLMEM_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[14], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 1) &&
		 xed_encode_ntluf_YMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_QQ);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][4]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_8_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_FULLMEM_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[14], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 2) &&
		 xed_encode_ntluf_ZMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_ZD);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][5]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_8_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_FULLMEM_BIND(xes);
       if (okay) return 1;
   }
     }
   return 0;
   (void) okay;
   (void) conditions_satisfied;
   (void) xes;
}
xed_bool_t xed_encode_group_261(xed_encoder_request_t* xes)
{
   xed_bool_t okay=1;
   xed_bool_t conditions_satisfied=0;
   xed_ptrn_func_ptr_t fb_ptrn_function;
   static const xed_uint16_t iform_ids[1][2] = {
   /*PMOVMSKB      */    {2148,2149,},
   };
   xed_uint8_t iclass_index = xed_encoder_get_iclasses_index_in_group(xes);
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_REG1) {
   conditions_satisfied = xed_encode_ntluf_GPR32_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MMX_B(xes,xed3_operand_get_reg1(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][0]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_REG1) {
   conditions_satisfied = xed_encode_ntluf_GPR32_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_XMM_B(xes,xed3_operand_get_reg1(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][1]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_REFINING66_BIND(xes);
       if (okay) return 1;
   }
     }
   return 0;
   (void) okay;
   (void) conditions_satisfied;
   (void) xes;
}
xed_bool_t xed_encode_group_262(xed_encoder_request_t* xes)
{
   xed_bool_t okay=1;
   xed_bool_t conditions_satisfied=0;
   xed_ptrn_func_ptr_t fb_ptrn_function;
   static const xed_uint16_t iform_ids[2][7] = {
   /*VCVTTPS2UDQ   */    {2160,2162,2164,2159,2163,2165,2161,},
   /*VGETEXPPS     */    {4984,4986,4988,4983,4987,4989,4985,},
   };
   xed_uint8_t iclass_index = xed_encoder_get_iclasses_index_in_group(xes);
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[7], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_sae(xes) != 0) &&
		 xed_encode_ntluf_ZMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_ZMM_B3(xes,xed3_operand_get_reg2(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][0]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_FIX_ROUND_LEN512_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_SAE_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[7], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 xed_encode_ntluf_XMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_XMM_B3(xes,xed3_operand_get_reg2(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][1]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[7], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 1) &&
		 xed_encode_ntluf_YMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_YMM_B3(xes,xed3_operand_get_reg2(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][2]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[7], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 2) &&
		 xed_encode_ntluf_ZMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_ZMM_B3(xes,xed3_operand_get_reg2(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][3]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[14], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 xed_encode_ntluf_XMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_VV);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][4]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_32_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_FULL_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[14], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 1) &&
		 xed_encode_ntluf_YMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_VV);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][5]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_32_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_FULL_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[14], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 2) &&
		 xed_encode_ntluf_ZMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_VV);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][6]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_32_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_FULL_BIND(xes);
       if (okay) return 1;
   }
     }
   return 0;
   (void) okay;
   (void) conditions_satisfied;
   (void) xes;
}
xed_bool_t xed_encode_group_263(xed_encoder_request_t* xes)
{
   xed_bool_t okay=1;
   xed_bool_t conditions_satisfied=0;
   xed_ptrn_func_ptr_t fb_ptrn_function;
   static const xed_uint16_t iform_ids[2][6] = {
   /*VPTESTMD      */    {2189,2191,2187,2190,2192,2188,},
   /*VPTESTNMD     */    {2816,2818,2814,2817,2819,2815,},
   };
   xed_uint8_t iclass_index = xed_encoder_get_iclasses_index_in_group(xes);
   if (xes->_n_operand_order == 4 && memcmp(xed_encode_order[12], xes->_operand_order, sizeof(xed_uint8_t)*4)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 xed_encode_ntluf_MASK_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_XMM_N3(xes,xed3_operand_get_reg2(xes)) &&
		 xed_encode_ntluf_XMM_B3(xes,xed3_operand_get_reg3(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][0]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 4 && memcmp(xed_encode_order[12], xes->_operand_order, sizeof(xed_uint8_t)*4)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 1) &&
		 xed_encode_ntluf_MASK_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_YMM_N3(xes,xed3_operand_get_reg2(xes)) &&
		 xed_encode_ntluf_YMM_B3(xes,xed3_operand_get_reg3(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][1]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 4 && memcmp(xed_encode_order[12], xes->_operand_order, sizeof(xed_uint8_t)*4)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 2) &&
		 xed_encode_ntluf_MASK_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_ZMM_N3(xes,xed3_operand_get_reg2(xes)) &&
		 xed_encode_ntluf_ZMM_B3(xes,xed3_operand_get_reg3(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][2]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 4 && memcmp(xed_encode_order[13], xes->_operand_order, sizeof(xed_uint8_t)*4)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 xed_encode_ntluf_MASK_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_XMM_N3(xes,xed3_operand_get_reg2(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_VV);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][3]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_32_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_FULL_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 4 && memcmp(xed_encode_order[13], xes->_operand_order, sizeof(xed_uint8_t)*4)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 1) &&
		 xed_encode_ntluf_MASK_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_YMM_N3(xes,xed3_operand_get_reg2(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_VV);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][4]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_32_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_FULL_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 4 && memcmp(xed_encode_order[13], xes->_operand_order, sizeof(xed_uint8_t)*4)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 2) &&
		 xed_encode_ntluf_MASK_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_ZMM_N3(xes,xed3_operand_get_reg2(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_VV);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][5]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_32_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_FULL_BIND(xes);
       if (okay) return 1;
   }
     }
   return 0;
   (void) okay;
   (void) conditions_satisfied;
   (void) xes;
}
xed_bool_t xed_encode_group_264(xed_encoder_request_t* xes)
{
   xed_bool_t okay=1;
   xed_bool_t conditions_satisfied=0;
   xed_ptrn_func_ptr_t fb_ptrn_function;
   static const xed_uint16_t iform_ids[2][1] = {
   /*FFREE         */    {2195,},
   /*FFREEP        */    {6490,},
   };
   xed_uint8_t iclass_index = xed_encoder_get_iclasses_index_in_group(xes);
   if (xes->_n_operand_order == 1 && xes->_operand_order[0] == XED_OPERAND_REG0) {
   conditions_satisfied = xed_encode_ntluf_X87(xes,xed3_operand_get_reg0(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][0]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   return 0;
   (void) okay;
   (void) conditions_satisfied;
   (void) xes;
}
xed_bool_t xed_encode_group_265(xed_encoder_request_t* xes)
{
   xed_bool_t okay=1;
   xed_bool_t conditions_satisfied=0;
   xed_ptrn_func_ptr_t fb_ptrn_function;
   static const xed_uint16_t iform_ids[5][18] = {
   /*ADC           */    {4567,4566,4559,4563,4561,4565,4558,4560,4555,4551,4562,4557,4553,4564,4550,4556,4552,4554,},
   /*ADD           */    {3979,3978,3971,3975,3973,3977,3970,3972,3967,3963,3974,3969,3965,3976,3962,3968,3964,3966,},
   /*CMP           */    {2224,2223,2216,2220,2218,2222,2215,2217,2212,2208,2219,2214,2210,2221,2207,2213,2209,2211,},
   /*SBB           */    {3369,3368,3361,3364,3363,3366,3360,3362,3357,3353,3365,3359,3355,3367,3352,3358,3354,3356,},
   /*SUB           */    {2511,2510,2503,2506,2505,2508,2502,2504,2499,2495,2507,2501,2497,2509,2494,2500,2496,2498,},
   };
   xed_uint8_t iclass_index = xed_encoder_get_iclasses_index_in_group(xes);
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_IMM0) {
   conditions_satisfied = xed_encode_ntluf_OrAX(xes,xed3_operand_get_reg0(xes)) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][0]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_SIMMz_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_IMM0) {
   conditions_satisfied = (xed3_operand_get_reg0(xes) == XED_REG_AL) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][1]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_SIMM8_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_REG1) {
   conditions_satisfied = xed_encode_ntluf_GPR8_B(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_GPR8_R(xes,xed3_operand_get_reg1(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][2]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_REG1) {
   conditions_satisfied = xed_encode_ntluf_GPR8_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_GPR8_B(xes,xed3_operand_get_reg1(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][3]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_REG1) {
   conditions_satisfied = xed_encode_ntluf_GPRv_B(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_GPRv_R(xes,xed3_operand_get_reg1(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][4]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_REG1) {
   conditions_satisfied = xed_encode_ntluf_GPRv_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_GPRv_B(xes,xed3_operand_get_reg1(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][5]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_MEM0 && xes->_operand_order[1] == XED_OPERAND_REG0) {
   conditions_satisfied = (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_B) &&
		 xed_encode_ntluf_GPR8_R(xes,xed3_operand_get_reg0(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][6]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_MEM0 && xes->_operand_order[1] == XED_OPERAND_REG0) {
   conditions_satisfied = (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_V) &&
		 xed_encode_ntluf_GPRv_R(xes,xed3_operand_get_reg0(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][7]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_IMM0) {
   conditions_satisfied = (xed3_operand_get_mode(xes) != 2) &&
		 xed_encode_ntluf_GPR8_B(xes,xed3_operand_get_reg0(xes)) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][8]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_SIMM8_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_IMM0) {
   conditions_satisfied = xed_encode_ntluf_GPR8_B(xes,xed3_operand_get_reg0(xes)) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][9]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_SIMM8_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_MEM0) {
   conditions_satisfied = xed_encode_ntluf_GPR8_R(xes,xed3_operand_get_reg0(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_B);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][10]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_IMM0) {
   conditions_satisfied = xed_encode_ntluf_GPRv_B(xes,xed3_operand_get_reg0(xes)) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][11]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_SIMM8_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_IMM0) {
   conditions_satisfied = xed_encode_ntluf_GPRv_B(xes,xed3_operand_get_reg0(xes)) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][12]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_SIMMz_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_MEM0) {
   conditions_satisfied = xed_encode_ntluf_GPRv_R(xes,xed3_operand_get_reg0(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_V);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][13]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_MEM0 && xes->_operand_order[1] == XED_OPERAND_IMM0) {
   conditions_satisfied = (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_B) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][14]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_SIMM8_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_MEM0 && xes->_operand_order[1] == XED_OPERAND_IMM0) {
   conditions_satisfied = (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_V) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][15]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_SIMM8_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_MEM0 && xes->_operand_order[1] == XED_OPERAND_IMM0) {
   conditions_satisfied = (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_V) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][16]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_SIMMz_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_MEM0 && xes->_operand_order[1] == XED_OPERAND_IMM0) {
   conditions_satisfied = (xed3_operand_get_mode(xes) != 2) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_B) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][17]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_SIMM8_BIND(xes);
       if (okay) return 1;
   }
     }
   return 0;
   (void) okay;
   (void) conditions_satisfied;
   (void) xes;
}
xed_bool_t xed_encode_group_266(xed_encoder_request_t* xes)
{
   xed_bool_t okay=1;
   xed_bool_t conditions_satisfied=0;
   xed_ptrn_func_ptr_t fb_ptrn_function;
   static const xed_uint16_t iform_ids[8][2] = {
   /*ADDSD         */    {3617,3616,},
   /*CVTSD2SS      */    {4809,4808,},
   /*DIVSD         */    {5770,5769,},
   /*MAXSD         */    {3568,3567,},
   /*MINSD         */    {3763,3762,},
   /*MULSD         */    {2252,2251,},
   /*SQRTSD        */    {3540,3539,},
   /*SUBSD         */    {6224,6223,},
   };
   xed_uint8_t iclass_index = xed_encoder_get_iclasses_index_in_group(xes);
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_REG1) {
   conditions_satisfied = xed_encode_ntluf_XMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_XMM_B(xes,xed3_operand_get_reg1(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][0]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_IGNORE66_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_MEM0) {
   conditions_satisfied = xed_encode_ntluf_XMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_SD);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][1]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_IGNORE66_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay) return 1;
   }
     }
   return 0;
   (void) okay;
   (void) conditions_satisfied;
   (void) xes;
}
xed_bool_t xed_encode_group_267(xed_encoder_request_t* xes)
{
   xed_bool_t okay=1;
   xed_bool_t conditions_satisfied=0;
   xed_ptrn_func_ptr_t fb_ptrn_function;
   static const xed_uint16_t iform_ids[2][2] = {
   /*PMOVSXBQ      */    {2273,2272,},
   /*PMOVZXBQ      */    {6062,6061,},
   };
   xed_uint8_t iclass_index = xed_encoder_get_iclasses_index_in_group(xes);
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_REG1) {
   conditions_satisfied = xed_encode_ntluf_XMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_XMM_B(xes,xed3_operand_get_reg1(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][0]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_REFINING66_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_MEM0) {
   conditions_satisfied = xed_encode_ntluf_XMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_W);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][1]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_REFINING66_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay) return 1;
   }
     }
   return 0;
   (void) okay;
   (void) conditions_satisfied;
   (void) xes;
}
xed_bool_t xed_encode_group_268(xed_encoder_request_t* xes)
{
   xed_bool_t okay=1;
   xed_bool_t conditions_satisfied=0;
   xed_ptrn_func_ptr_t fb_ptrn_function;
   static const xed_uint16_t iform_ids[3][2] = {
   /*BTC_LOCK      */    {2923,2922,},
   /*BTR_LOCK      */    {2287,2286,},
   /*BTS_LOCK      */    {4615,4614,},
   };
   xed_uint8_t iclass_index = xed_encoder_get_iclasses_index_in_group(xes);
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_MEM0 && xes->_operand_order[1] == XED_OPERAND_REG0) {
   conditions_satisfied = (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_V) &&
		 xed_encode_ntluf_GPRv_R(xes,xed3_operand_get_reg0(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][0]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_MEM0 && xes->_operand_order[1] == XED_OPERAND_IMM0) {
   conditions_satisfied = (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_V) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][1]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_UIMM8_BIND(xes);
       if (okay) return 1;
   }
     }
   return 0;
   (void) okay;
   (void) conditions_satisfied;
   (void) xes;
}
xed_bool_t xed_encode_group_269(xed_encoder_request_t* xes)
{
   xed_bool_t okay=1;
   xed_bool_t conditions_satisfied=0;
   xed_ptrn_func_ptr_t fb_ptrn_function;
   static const xed_uint16_t iform_ids[2][1] = {
   /*ENQCMD        */    {3946,},
   /*ENQCMDS       */    {2299,},
   };
   xed_uint8_t iclass_index = xed_encoder_get_iclasses_index_in_group(xes);
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_MEM0) {
   conditions_satisfied = xed_encode_ntluf_A_GPR_R(xes,xed3_operand_get_reg0(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_ZD);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][0]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay) return 1;
   }
     }
   return 0;
   (void) okay;
   (void) conditions_satisfied;
   (void) xes;
}
xed_bool_t xed_encode_group_270(xed_encoder_request_t* xes)
{
   xed_bool_t okay=1;
   xed_bool_t conditions_satisfied=0;
   xed_ptrn_func_ptr_t fb_ptrn_function;
   static const xed_uint16_t iform_ids[1][15] = {
   /*VCVTSS2SI     */    {2308,2309,2313,2301,2303,2305,2300,2302,2304,2306,2307,2312,2310,2311,2314,},
   };
   xed_uint8_t iclass_index = xed_encoder_get_iclasses_index_in_group(xes);
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_REG1) {
   conditions_satisfied = (xed3_operand_get_roundc(xes) != 0) &&
		 (xed3_operand_get_mode(xes) != 2) &&
		 xed_encode_ntluf_GPR32_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_XMM_B3(xes,xed3_operand_get_reg1(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][0]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_FIX_ROUND_LEN128_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_AVX512_ROUND_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_REG1) {
   conditions_satisfied = (xed3_operand_get_roundc(xes) != 0) &&
		 (xed3_operand_get_mode(xes) == 2) &&
		 xed_encode_ntluf_GPR32_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_XMM_B3(xes,xed3_operand_get_reg1(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][1]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_FIX_ROUND_LEN128_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_AVX512_ROUND_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_REG1) {
   conditions_satisfied = (xed3_operand_get_roundc(xes) != 0) &&
		 (xed3_operand_get_mode(xes) == 2) &&
		 xed_encode_ntluf_GPR64_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_XMM_B3(xes,xed3_operand_get_reg1(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][2]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_FIX_ROUND_LEN128_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_AVX512_ROUND_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_REG1) {
   conditions_satisfied = (xed3_operand_get_mode(xes) != 2) &&
		 (xed3_operand_get_must_use_evex(xes) == 0) &&
		 xed_encode_ntluf_GPR32_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_XMM_B(xes,xed3_operand_get_reg1(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][3]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_REG1) {
   conditions_satisfied = (xed3_operand_get_mode(xes) == 2) &&
		 (xed3_operand_get_must_use_evex(xes) == 0) &&
		 xed_encode_ntluf_GPR32_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_XMM_B(xes,xed3_operand_get_reg1(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][4]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_REG1) {
   conditions_satisfied = (xed3_operand_get_mode(xes) == 2) &&
		 (xed3_operand_get_must_use_evex(xes) == 0) &&
		 xed_encode_ntluf_GPR64_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_XMM_B(xes,xed3_operand_get_reg1(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][5]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_MEM0) {
   conditions_satisfied = (xed3_operand_get_mode(xes) != 2) &&
		 (xed3_operand_get_must_use_evex(xes) == 0) &&
		 xed_encode_ntluf_GPR32_R(xes,xed3_operand_get_reg0(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_D);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][6]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_MEM0) {
   conditions_satisfied = (xed3_operand_get_mode(xes) == 2) &&
		 (xed3_operand_get_must_use_evex(xes) == 0) &&
		 xed_encode_ntluf_GPR32_R(xes,xed3_operand_get_reg0(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_D);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][7]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_MEM0) {
   conditions_satisfied = (xed3_operand_get_mode(xes) == 2) &&
		 (xed3_operand_get_must_use_evex(xes) == 0) &&
		 xed_encode_ntluf_GPR64_R(xes,xed3_operand_get_reg0(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_D);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][8]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_REG1) {
   conditions_satisfied = (xed3_operand_get_mode(xes) != 2) &&
		 xed_encode_ntluf_GPR32_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_XMM_B3(xes,xed3_operand_get_reg1(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][9]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_FIX_ROUND_LEN128_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_REG1) {
   conditions_satisfied = (xed3_operand_get_mode(xes) == 2) &&
		 xed_encode_ntluf_GPR32_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_XMM_B3(xes,xed3_operand_get_reg1(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][10]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_FIX_ROUND_LEN128_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_REG1) {
   conditions_satisfied = (xed3_operand_get_mode(xes) == 2) &&
		 xed_encode_ntluf_GPR64_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_XMM_B3(xes,xed3_operand_get_reg1(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][11]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_FIX_ROUND_LEN128_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_MEM0) {
   conditions_satisfied = (xed3_operand_get_mode(xes) != 2) &&
		 xed_encode_ntluf_GPR32_R(xes,xed3_operand_get_reg0(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_D);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][12]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_32_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_GPR_WRITER_LDOP_D_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_FIX_ROUND_LEN128_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_MEM0) {
   conditions_satisfied = (xed3_operand_get_mode(xes) == 2) &&
		 xed_encode_ntluf_GPR32_R(xes,xed3_operand_get_reg0(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_D);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][13]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_32_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_GPR_WRITER_LDOP_D_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_FIX_ROUND_LEN128_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_MEM0) {
   conditions_satisfied = (xed3_operand_get_mode(xes) == 2) &&
		 xed_encode_ntluf_GPR64_R(xes,xed3_operand_get_reg0(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_D);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][14]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_32_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_GPR_WRITER_LDOP_D_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_FIX_ROUND_LEN128_BIND(xes);
       if (okay) return 1;
   }
     }
   return 0;
   (void) okay;
   (void) conditions_satisfied;
   (void) xes;
}
xed_bool_t xed_encode_group_271(xed_encoder_request_t* xes)
{
   xed_bool_t okay=1;
   xed_bool_t conditions_satisfied=0;
   xed_ptrn_func_ptr_t fb_ptrn_function;
   static const xed_uint16_t iform_ids[3][2] = {
   /*GF2P8AFFINEINVQB*/    {2846,2847,},
   /*GF2P8AFFINEQB */    {4853,4854,},
   /*SHA1RNDS4     */    {2315,2316,},
   };
   xed_uint8_t iclass_index = xed_encoder_get_iclasses_index_in_group(xes);
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[15], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = xed_encode_ntluf_XMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_XMM_B(xes,xed3_operand_get_reg1(xes)) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][0]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_UIMM8_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[20], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = xed_encode_ntluf_XMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_DQ) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][1]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_UIMM8_BIND(xes);
       if (okay) return 1;
   }
     }
   return 0;
   (void) okay;
   (void) conditions_satisfied;
   (void) xes;
}
xed_bool_t xed_encode_group_272(xed_encoder_request_t* xes)
{
   xed_bool_t okay=1;
   xed_bool_t conditions_satisfied=0;
   xed_ptrn_func_ptr_t fb_ptrn_function;
   static const xed_uint16_t iform_ids[2][12] = {
   /*VMOVDQA64     */    {2341,2339,2345,2343,2337,2335,2342,2340,2346,2344,2338,2336,},
   /*VMOVDQU64     */    {4845,4843,4849,4847,4841,4839,4846,4844,4850,4848,4842,4840,},
   };
   xed_uint8_t iclass_index = xed_encoder_get_iclasses_index_in_group(xes);
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[7], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 xed_encode_ntluf_XMM_B3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_XMM_R3(xes,xed3_operand_get_reg2(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][0]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[7], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 xed_encode_ntluf_XMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_XMM_B3(xes,xed3_operand_get_reg2(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][1]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[7], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 1) &&
		 xed_encode_ntluf_YMM_B3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_YMM_R3(xes,xed3_operand_get_reg2(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][2]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[7], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 1) &&
		 xed_encode_ntluf_YMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_YMM_B3(xes,xed3_operand_get_reg2(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][3]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[7], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 2) &&
		 xed_encode_ntluf_ZMM_B3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_ZMM_R3(xes,xed3_operand_get_reg2(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][4]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[7], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 2) &&
		 xed_encode_ntluf_ZMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_ZMM_B3(xes,xed3_operand_get_reg2(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][5]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[6], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_DQ) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_XMM_R3(xes,xed3_operand_get_reg1(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][6]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_64_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_FULLMEM_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[14], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 xed_encode_ntluf_XMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_DQ);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][7]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_64_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_FULLMEM_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[6], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 1) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_QQ) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_YMM_R3(xes,xed3_operand_get_reg1(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][8]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_64_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_FULLMEM_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[14], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 1) &&
		 xed_encode_ntluf_YMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_QQ);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][9]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_64_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_FULLMEM_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[6], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 2) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_ZD) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_ZMM_R3(xes,xed3_operand_get_reg1(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][10]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_64_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_FULLMEM_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[14], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 2) &&
		 xed_encode_ntluf_ZMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_ZD);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][11]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_64_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_FULLMEM_BIND(xes);
       if (okay) return 1;
   }
     }
   return 0;
   (void) okay;
   (void) conditions_satisfied;
   (void) xes;
}
xed_bool_t xed_encode_group_273(xed_encoder_request_t* xes)
{
   xed_bool_t okay=1;
   xed_bool_t conditions_satisfied=0;
   xed_ptrn_func_ptr_t fb_ptrn_function;
   static const xed_uint16_t iform_ids[1][11] = {
   /*VSQRTPD       */    {2352,2348,2350,2347,2349,2354,2356,2351,2355,2357,2353,},
   };
   xed_uint8_t iclass_index = xed_encoder_get_iclasses_index_in_group(xes);
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[7], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_roundc(xes) != 0) &&
		 xed_encode_ntluf_ZMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_ZMM_B3(xes,xed3_operand_get_reg2(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][0]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_FIX_ROUND_LEN512_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_AVX512_ROUND_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_REG1) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 (xed3_operand_get_must_use_evex(xes) == 0) &&
		 xed_encode_ntluf_XMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_XMM_B(xes,xed3_operand_get_reg1(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][1]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_REG1) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 1) &&
		 (xed3_operand_get_must_use_evex(xes) == 0) &&
		 xed_encode_ntluf_YMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_YMM_B(xes,xed3_operand_get_reg1(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][2]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_MEM0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 (xed3_operand_get_must_use_evex(xes) == 0) &&
		 xed_encode_ntluf_XMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_DQ);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][3]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_MEM0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 1) &&
		 (xed3_operand_get_must_use_evex(xes) == 0) &&
		 xed_encode_ntluf_YMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_QQ);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][4]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[7], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 xed_encode_ntluf_XMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_XMM_B3(xes,xed3_operand_get_reg2(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][5]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[7], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 1) &&
		 xed_encode_ntluf_YMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_YMM_B3(xes,xed3_operand_get_reg2(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][6]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[7], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 2) &&
		 xed_encode_ntluf_ZMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_ZMM_B3(xes,xed3_operand_get_reg2(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][7]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[14], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 xed_encode_ntluf_XMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_VV);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][8]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_64_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_FULL_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[14], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 1) &&
		 xed_encode_ntluf_YMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_VV);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][9]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_64_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_FULL_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[14], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 2) &&
		 xed_encode_ntluf_ZMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_VV);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][10]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_64_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_FULL_BIND(xes);
       if (okay) return 1;
   }
     }
   return 0;
   (void) okay;
   (void) conditions_satisfied;
   (void) xes;
}
xed_bool_t xed_encode_group_274(xed_encoder_request_t* xes)
{
   xed_bool_t okay=1;
   xed_bool_t conditions_satisfied=0;
   xed_ptrn_func_ptr_t fb_ptrn_function;
   static const xed_uint16_t iform_ids[1][4] = {
   /*VPEXTRB       */    {2396,2395,2397,2398,},
   };
   xed_uint8_t iclass_index = xed_encoder_get_iclasses_index_in_group(xes);
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[15], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 (xed3_operand_get_must_use_evex(xes) == 0) &&
		 xed_encode_ntluf_GPR32_B(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_XMM_R(xes,xed3_operand_get_reg1(xes)) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][0]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_UIMM8_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[17], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 (xed3_operand_get_must_use_evex(xes) == 0) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_B) &&
		 xed_encode_ntluf_XMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][1]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_UIMM8_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[15], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 xed_encode_ntluf_GPR32_B(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_XMM_R3(xes,xed3_operand_get_reg1(xes)) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][2]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_UIMM8_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[17], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_B) &&
		 xed_encode_ntluf_XMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][3]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_UIMM8_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_8_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_GPR_WRITER_STORE_BYTE_BIND(xes);
       if (okay) return 1;
   }
     }
   return 0;
   (void) okay;
   (void) conditions_satisfied;
   (void) xes;
}
xed_bool_t xed_encode_group_275(xed_encoder_request_t* xes)
{
   xed_bool_t okay=1;
   xed_bool_t conditions_satisfied=0;
   xed_ptrn_func_ptr_t fb_ptrn_function;
   static const xed_uint16_t iform_ids[2][2] = {
   /*EXTRACTPS     */    {3727,3726,},
   /*PEXTRD        */    {2400,2399,},
   };
   xed_uint8_t iclass_index = xed_encoder_get_iclasses_index_in_group(xes);
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[15], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = xed_encode_ntluf_GPR32_B(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_XMM_R(xes,xed3_operand_get_reg1(xes)) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][0]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_REFINING66_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_UIMM8_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[17], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_D) &&
		 xed_encode_ntluf_XMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][1]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_REFINING66_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_UIMM8_BIND(xes);
       if (okay) return 1;
   }
     }
   return 0;
   (void) okay;
   (void) conditions_satisfied;
   (void) xes;
}
xed_bool_t xed_encode_group_276(xed_encoder_request_t* xes)
{
   xed_bool_t okay=1;
   xed_bool_t conditions_satisfied=0;
   xed_ptrn_func_ptr_t fb_ptrn_function;
   static const xed_uint16_t iform_ids[1][2] = {
   /*INSERTQ       */    {2418,2417,},
   };
   xed_uint8_t iclass_index = xed_encoder_get_iclasses_index_in_group(xes);
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_REG1) {
   conditions_satisfied = xed_encode_ntluf_XMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_XMM_B(xes,xed3_operand_get_reg1(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][0]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 4 && memcmp(xed_encode_order[27], xes->_operand_order, sizeof(xed_uint8_t)*4)==0) {
   conditions_satisfied = xed_encode_ntluf_XMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_XMM_B(xes,xed3_operand_get_reg1(xes)) &&
		 (xed3_operand_get_imm0(xes) == 1) &&
		 (xed3_operand_get_imm1(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][1]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_UIMM8_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_UIMM8_1_BIND(xes);
       if (okay) return 1;
   }
     }
   return 0;
   (void) okay;
   (void) conditions_satisfied;
   (void) xes;
}
xed_bool_t xed_encode_group_277(xed_encoder_request_t* xes)
{
   xed_bool_t okay=1;
   xed_bool_t conditions_satisfied=0;
   xed_ptrn_func_ptr_t fb_ptrn_function;
   static const xed_uint16_t iform_ids[2][1] = {
   /*VBROADCASTF128*/    {5594,},
   /*VBROADCASTI128*/    {2419,},
   };
   xed_uint8_t iclass_index = xed_encoder_get_iclasses_index_in_group(xes);
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_MEM0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 1) &&
		 (xed3_operand_get_must_use_evex(xes) == 0) &&
		 xed_encode_ntluf_YMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_DQ);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][0]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay) return 1;
   }
     }
   return 0;
   (void) okay;
   (void) conditions_satisfied;
   (void) xes;
}
xed_bool_t xed_encode_group_278(xed_encoder_request_t* xes)
{
   xed_bool_t okay=1;
   xed_bool_t conditions_satisfied=0;
   xed_ptrn_func_ptr_t fb_ptrn_function;
   static const xed_uint16_t iform_ids[1][8] = {
   /*VPINSRD       */    {2436,2434,2435,2433,2437,2438,2439,2440,},
   };
   xed_uint8_t iclass_index = xed_encoder_get_iclasses_index_in_group(xes);
   if (xes->_n_operand_order == 4 && memcmp(xed_encode_order[21], xes->_operand_order, sizeof(xed_uint8_t)*4)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 (xed3_operand_get_mode(xes) != 2) &&
		 (xed3_operand_get_must_use_evex(xes) == 0) &&
		 xed_encode_ntluf_XMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_XMM_N(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_GPR32_B(xes,xed3_operand_get_reg2(xes)) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][0]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_UIMM8_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 4 && memcmp(xed_encode_order[21], xes->_operand_order, sizeof(xed_uint8_t)*4)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 (xed3_operand_get_mode(xes) == 2) &&
		 (xed3_operand_get_must_use_evex(xes) == 0) &&
		 xed_encode_ntluf_XMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_XMM_N(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_GPR32_B(xes,xed3_operand_get_reg2(xes)) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][1]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_UIMM8_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 4 && memcmp(xed_encode_order[22], xes->_operand_order, sizeof(xed_uint8_t)*4)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 (xed3_operand_get_mode(xes) != 2) &&
		 (xed3_operand_get_must_use_evex(xes) == 0) &&
		 xed_encode_ntluf_XMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_XMM_N(xes,xed3_operand_get_reg1(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_D) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][2]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_UIMM8_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 4 && memcmp(xed_encode_order[22], xes->_operand_order, sizeof(xed_uint8_t)*4)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 (xed3_operand_get_mode(xes) == 2) &&
		 (xed3_operand_get_must_use_evex(xes) == 0) &&
		 xed_encode_ntluf_XMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_XMM_N(xes,xed3_operand_get_reg1(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_D) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][3]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_UIMM8_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 4 && memcmp(xed_encode_order[21], xes->_operand_order, sizeof(xed_uint8_t)*4)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 (xed3_operand_get_mode(xes) != 2) &&
		 xed_encode_ntluf_XMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_XMM_N3(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_GPR32_B(xes,xed3_operand_get_reg2(xes)) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][4]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_UIMM8_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 4 && memcmp(xed_encode_order[21], xes->_operand_order, sizeof(xed_uint8_t)*4)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 (xed3_operand_get_mode(xes) == 2) &&
		 xed_encode_ntluf_XMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_XMM_N3(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_GPR32_B(xes,xed3_operand_get_reg2(xes)) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][5]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_UIMM8_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 4 && memcmp(xed_encode_order[22], xes->_operand_order, sizeof(xed_uint8_t)*4)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 (xed3_operand_get_mode(xes) != 2) &&
		 xed_encode_ntluf_XMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_XMM_N3(xes,xed3_operand_get_reg1(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_D) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][6]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_UIMM8_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_32_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_GPR_READER_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 4 && memcmp(xed_encode_order[22], xes->_operand_order, sizeof(xed_uint8_t)*4)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 (xed3_operand_get_mode(xes) == 2) &&
		 xed_encode_ntluf_XMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_XMM_N3(xes,xed3_operand_get_reg1(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_D) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][7]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_UIMM8_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_32_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_GPR_READER_BIND(xes);
       if (okay) return 1;
   }
     }
   return 0;
   (void) okay;
   (void) conditions_satisfied;
   (void) xes;
}
xed_bool_t xed_encode_group_279(xed_encoder_request_t* xes)
{
   xed_bool_t okay=1;
   xed_bool_t conditions_satisfied=0;
   xed_ptrn_func_ptr_t fb_ptrn_function;
   static const xed_uint16_t iform_ids[2][2] = {
   /*CVTPS2PI      */    {2442,2441,},
   /*CVTTPS2PI     */    {2457,2456,},
   };
   xed_uint8_t iclass_index = xed_encoder_get_iclasses_index_in_group(xes);
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_REG1) {
   conditions_satisfied = xed_encode_ntluf_MMX_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_XMM_B(xes,xed3_operand_get_reg1(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][0]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_MEM0) {
   conditions_satisfied = xed_encode_ntluf_MMX_R(xes,xed3_operand_get_reg0(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_Q);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][1]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay) return 1;
   }
     }
   return 0;
   (void) okay;
   (void) conditions_satisfied;
   (void) xes;
}
xed_bool_t xed_encode_group_280(xed_encoder_request_t* xes)
{
   xed_bool_t okay=1;
   xed_bool_t conditions_satisfied=0;
   xed_ptrn_func_ptr_t fb_ptrn_function;
   static const xed_uint16_t iform_ids[1][4] = {
   /*BNDSTX        */    {2445,2446,2447,2448,},
   };
   xed_uint8_t iclass_index = xed_encoder_get_iclasses_index_in_group(xes);
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_MEM0 && xes->_operand_order[1] == XED_OPERAND_REG0) {
   conditions_satisfied = (xed3_operand_get_mpxmode(xes) == 1) &&
		 (xed3_operand_get_mode(xes) != 2) &&
		 (xed3_operand_get_easz(xes) == 2) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_BND32) &&
		 xed_encode_ntluf_BND_R(xes,xed3_operand_get_reg0(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][0]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_MEM0 && xes->_operand_order[1] == XED_OPERAND_REG0) {
   conditions_satisfied = (xed3_operand_get_mpxmode(xes) == 1) &&
		 (xed3_operand_get_mode(xes) == 2) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_BND64) &&
		 xed_encode_ntluf_BND_R(xes,xed3_operand_get_reg0(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][1]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_MEM0 && xes->_operand_order[1] == XED_OPERAND_REG0) {
   conditions_satisfied = (xed3_operand_get_mpxmode(xes) == 1) &&
		 (xed3_operand_get_mode(xes) == 2) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_BND64) &&
		 xed_encode_ntluf_BND_R(xes,xed3_operand_get_reg0(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][2]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_MEM0 && xes->_operand_order[1] == XED_OPERAND_REG0) {
   conditions_satisfied = (xed3_operand_get_mpxmode(xes) == 1) &&
		 (xed3_operand_get_mode(xes) == 2) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_BND64) &&
		 xed_encode_ntluf_BND_R(xes,xed3_operand_get_reg0(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][3]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay) return 1;
   }
     }
   return 0;
   (void) okay;
   (void) conditions_satisfied;
   (void) xes;
}
xed_bool_t xed_encode_group_281(xed_encoder_request_t* xes)
{
   xed_bool_t okay=1;
   xed_bool_t conditions_satisfied=0;
   xed_ptrn_func_ptr_t fb_ptrn_function;
   static const xed_uint16_t iform_ids[2][1] = {
   /*LDMXCSR       */    {5264,},
   /*STMXCSR       */    {2464,},
   };
   xed_uint8_t iclass_index = xed_encoder_get_iclasses_index_in_group(xes);
   if (xes->_n_operand_order == 1 && xes->_operand_order[0] == XED_OPERAND_MEM0) {
   conditions_satisfied = (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_D);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][0]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay) return 1;
   }
     }
   return 0;
   (void) okay;
   (void) conditions_satisfied;
   (void) xes;
}
xed_bool_t xed_encode_group_282(xed_encoder_request_t* xes)
{
   xed_bool_t okay=1;
   xed_bool_t conditions_satisfied=0;
   xed_ptrn_func_ptr_t fb_ptrn_function;
   static const xed_uint16_t iform_ids[1][2] = {
   /*EXTRQ         */    {2466,2465,},
   };
   xed_uint8_t iclass_index = xed_encoder_get_iclasses_index_in_group(xes);
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_REG1) {
   conditions_satisfied = xed_encode_ntluf_XMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_XMM_B(xes,xed3_operand_get_reg1(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][0]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_REFINING66_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[28], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = xed_encode_ntluf_XMM_B(xes,xed3_operand_get_reg0(xes)) &&
		 (xed3_operand_get_imm0(xes) == 1) &&
		 (xed3_operand_get_imm1(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][1]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_REFINING66_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_UIMM8_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_UIMM8_1_BIND(xes);
       if (okay) return 1;
   }
     }
   return 0;
   (void) okay;
   (void) conditions_satisfied;
   (void) xes;
}
xed_bool_t xed_encode_group_283(xed_encoder_request_t* xes)
{
   xed_bool_t okay=1;
   xed_bool_t conditions_satisfied=0;
   xed_ptrn_func_ptr_t fb_ptrn_function;
   static const xed_uint16_t iform_ids[6][1] = {
   /*CMPSB         */    {6303,},
   /*LODSB         */    {4924,},
   /*OUTSB         */    {3945,},
   /*REPE_CMPSB    */    {3899,},
   /*REPNE_CMPSB   */    {3275,},
   /*XLAT          */    {2476,},
   };
   xed_uint8_t iclass_index = xed_encoder_get_iclasses_index_in_group(xes);
   if (xes->_n_operand_order == 0) {
   conditions_satisfied = 1;
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][0]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_OVERRIDE_SEG0_BIND(xes);
       if (okay) return 1;
   }
     }
   return 0;
   (void) okay;
   (void) conditions_satisfied;
   (void) xes;
}
xed_bool_t xed_encode_group_284(xed_encoder_request_t* xes)
{
   xed_bool_t okay=1;
   xed_bool_t conditions_satisfied=0;
   xed_ptrn_func_ptr_t fb_ptrn_function;
   static const xed_uint16_t iform_ids[1][8] = {
   /*REP_INSD      */    {2484,2488,2485,2489,2486,2487,2490,2491,},
   };
   xed_uint8_t iclass_index = xed_encoder_get_iclasses_index_in_group(xes);
   if (xes->_n_operand_order == 0) {
   conditions_satisfied = (xed3_operand_get_mode(xes) == 0);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][0]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 0) {
   conditions_satisfied = (xed3_operand_get_mode(xes) == 0);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][1]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 0) {
   conditions_satisfied = (xed3_operand_get_mode(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][2]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 0) {
   conditions_satisfied = (xed3_operand_get_mode(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][3]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 0) {
   conditions_satisfied = (xed3_operand_get_mode(xes) == 2);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][4]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 0) {
   conditions_satisfied = (xed3_operand_get_mode(xes) == 2);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][5]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 0) {
   conditions_satisfied = (xed3_operand_get_mode(xes) == 2);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][6]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 0) {
   conditions_satisfied = (xed3_operand_get_mode(xes) == 2);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][7]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   return 0;
   (void) okay;
   (void) conditions_satisfied;
   (void) xes;
}
xed_bool_t xed_encode_group_285(xed_encoder_request_t* xes)
{
   xed_bool_t okay=1;
   xed_bool_t conditions_satisfied=0;
   xed_ptrn_func_ptr_t fb_ptrn_function;
   static const xed_uint16_t iform_ids[2][2] = {
   /*CMPXCHG_LOCK  */    {6015,6016,},
   /*XADD_LOCK     */    {2526,2527,},
   };
   xed_uint8_t iclass_index = xed_encoder_get_iclasses_index_in_group(xes);
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_MEM0 && xes->_operand_order[1] == XED_OPERAND_REG0) {
   conditions_satisfied = (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_B) &&
		 xed_encode_ntluf_GPR8_R(xes,xed3_operand_get_reg0(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][0]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_MEM0 && xes->_operand_order[1] == XED_OPERAND_REG0) {
   conditions_satisfied = (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_V) &&
		 xed_encode_ntluf_GPRv_R(xes,xed3_operand_get_reg0(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][1]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay) return 1;
   }
     }
   return 0;
   (void) okay;
   (void) conditions_satisfied;
   (void) xes;
}
xed_bool_t xed_encode_group_286(xed_encoder_request_t* xes)
{
   xed_bool_t okay=1;
   xed_bool_t conditions_satisfied=0;
   xed_ptrn_func_ptr_t fb_ptrn_function;
   static const xed_uint16_t iform_ids[1][2] = {
   /*RDPID         */    {2529,2530,},
   };
   xed_uint8_t iclass_index = xed_encoder_get_iclasses_index_in_group(xes);
   if (xes->_n_operand_order == 1 && xes->_operand_order[0] == XED_OPERAND_REG0) {
   conditions_satisfied = (xed3_operand_get_mode(xes) != 2) &&
		 xed_encode_ntluf_GPR32_B(xes,xed3_operand_get_reg0(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][0]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 1 && xes->_operand_order[0] == XED_OPERAND_REG0) {
   conditions_satisfied = (xed3_operand_get_mode(xes) == 2) &&
		 xed_encode_ntluf_GPR64_B(xes,xed3_operand_get_reg0(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][1]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   return 0;
   (void) okay;
   (void) conditions_satisfied;
   (void) xes;
}
xed_bool_t xed_encode_group_287(xed_encoder_request_t* xes)
{
   xed_bool_t okay=1;
   xed_bool_t conditions_satisfied=0;
   xed_ptrn_func_ptr_t fb_ptrn_function;
   static const xed_uint16_t iform_ids[1][1] = {
   /*BSWAP         */    {2531,},
   };
   xed_uint8_t iclass_index = xed_encoder_get_iclasses_index_in_group(xes);
   if (xes->_n_operand_order == 1 && xes->_operand_order[0] == XED_OPERAND_REG0) {
   conditions_satisfied = xed_encode_ntluf_GPRv_SB(xes,xed3_operand_get_reg0(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][0]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   return 0;
   (void) okay;
   (void) conditions_satisfied;
   (void) xes;
}
xed_bool_t xed_encode_group_288(xed_encoder_request_t* xes)
{
   xed_bool_t okay=1;
   xed_bool_t conditions_satisfied=0;
   xed_ptrn_func_ptr_t fb_ptrn_function;
   static const xed_uint16_t iform_ids[1][18] = {
   /*XOR           */    {2549,2548,2541,2544,2543,2546,2540,2542,2537,2533,2545,2539,2535,2547,2532,2538,2534,2536,},
   };
   xed_uint8_t iclass_index = xed_encoder_get_iclasses_index_in_group(xes);
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_IMM0) {
   conditions_satisfied = xed_encode_ntluf_OrAX(xes,xed3_operand_get_reg0(xes)) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][0]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_SIMMz_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_IMM0) {
   conditions_satisfied = (xed3_operand_get_reg0(xes) == XED_REG_AL) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][1]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_UIMM8_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_REG1) {
   conditions_satisfied = xed_encode_ntluf_GPR8_B(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_GPR8_R(xes,xed3_operand_get_reg1(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][2]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_REG1) {
   conditions_satisfied = xed_encode_ntluf_GPR8_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_GPR8_B(xes,xed3_operand_get_reg1(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][3]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_REG1) {
   conditions_satisfied = xed_encode_ntluf_GPRv_B(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_GPRv_R(xes,xed3_operand_get_reg1(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][4]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_REG1) {
   conditions_satisfied = xed_encode_ntluf_GPRv_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_GPRv_B(xes,xed3_operand_get_reg1(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][5]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_MEM0 && xes->_operand_order[1] == XED_OPERAND_REG0) {
   conditions_satisfied = (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_B) &&
		 xed_encode_ntluf_GPR8_R(xes,xed3_operand_get_reg0(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][6]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_MEM0 && xes->_operand_order[1] == XED_OPERAND_REG0) {
   conditions_satisfied = (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_V) &&
		 xed_encode_ntluf_GPRv_R(xes,xed3_operand_get_reg0(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][7]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_IMM0) {
   conditions_satisfied = (xed3_operand_get_mode(xes) != 2) &&
		 xed_encode_ntluf_GPR8_B(xes,xed3_operand_get_reg0(xes)) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][8]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_UIMM8_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_IMM0) {
   conditions_satisfied = xed_encode_ntluf_GPR8_B(xes,xed3_operand_get_reg0(xes)) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][9]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_UIMM8_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_MEM0) {
   conditions_satisfied = xed_encode_ntluf_GPR8_R(xes,xed3_operand_get_reg0(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_B);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][10]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_IMM0) {
   conditions_satisfied = xed_encode_ntluf_GPRv_B(xes,xed3_operand_get_reg0(xes)) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][11]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_SIMM8_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_IMM0) {
   conditions_satisfied = xed_encode_ntluf_GPRv_B(xes,xed3_operand_get_reg0(xes)) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][12]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_SIMMz_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_MEM0) {
   conditions_satisfied = xed_encode_ntluf_GPRv_R(xes,xed3_operand_get_reg0(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_V);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][13]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_MEM0 && xes->_operand_order[1] == XED_OPERAND_IMM0) {
   conditions_satisfied = (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_B) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][14]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_UIMM8_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_MEM0 && xes->_operand_order[1] == XED_OPERAND_IMM0) {
   conditions_satisfied = (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_V) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][15]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_SIMM8_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_MEM0 && xes->_operand_order[1] == XED_OPERAND_IMM0) {
   conditions_satisfied = (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_V) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][16]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_SIMMz_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_MEM0 && xes->_operand_order[1] == XED_OPERAND_IMM0) {
   conditions_satisfied = (xed3_operand_get_mode(xes) != 2) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_B) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][17]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_UIMM8_BIND(xes);
       if (okay) return 1;
   }
     }
   return 0;
   (void) okay;
   (void) conditions_satisfied;
   (void) xes;
}
xed_bool_t xed_encode_group_289(xed_encoder_request_t* xes)
{
   xed_bool_t okay=1;
   xed_bool_t conditions_satisfied=0;
   xed_ptrn_func_ptr_t fb_ptrn_function;
   static const xed_uint16_t iform_ids[1][1] = {
   /*RMPUPDATE     */    {2559,},
   };
   xed_uint8_t iclass_index = xed_encoder_get_iclasses_index_in_group(xes);
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_REG1) {
   conditions_satisfied = (xed3_operand_get_mode(xes) == 2) &&
		 (xed3_operand_get_reg0(xes) == XED_REG_RAX) &&
		 (xed3_operand_get_reg1(xes) == XED_REG_RCX);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][0]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   return 0;
   (void) okay;
   (void) conditions_satisfied;
   (void) xes;
}
xed_bool_t xed_encode_group_290(xed_encoder_request_t* xes)
{
   xed_bool_t okay=1;
   xed_bool_t conditions_satisfied=0;
   xed_ptrn_func_ptr_t fb_ptrn_function;
   static const xed_uint16_t iform_ids[1][13] = {
   /*VPBROADCASTB  */    {2578,2580,2577,2579,2583,2581,2586,2584,2589,2587,2582,2585,2588,},
   };
   xed_uint8_t iclass_index = xed_encoder_get_iclasses_index_in_group(xes);
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_REG1) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 (xed3_operand_get_must_use_evex(xes) == 0) &&
		 xed_encode_ntluf_XMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_XMM_B(xes,xed3_operand_get_reg1(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][0]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_REG1) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 1) &&
		 (xed3_operand_get_must_use_evex(xes) == 0) &&
		 xed_encode_ntluf_YMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_XMM_B(xes,xed3_operand_get_reg1(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][1]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_MEM0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 (xed3_operand_get_must_use_evex(xes) == 0) &&
		 xed_encode_ntluf_XMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_B);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][2]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_MEM0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 1) &&
		 (xed3_operand_get_must_use_evex(xes) == 0) &&
		 xed_encode_ntluf_YMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_B);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][3]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[7], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 xed_encode_ntluf_XMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_GPR32_B(xes,xed3_operand_get_reg2(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][4]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[7], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 xed_encode_ntluf_XMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_XMM_B3(xes,xed3_operand_get_reg2(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][5]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[7], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 1) &&
		 xed_encode_ntluf_YMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_GPR32_B(xes,xed3_operand_get_reg2(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][6]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[7], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 1) &&
		 xed_encode_ntluf_YMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_XMM_B3(xes,xed3_operand_get_reg2(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][7]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[7], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 2) &&
		 xed_encode_ntluf_ZMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_GPR32_B(xes,xed3_operand_get_reg2(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][8]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[7], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 2) &&
		 xed_encode_ntluf_ZMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_XMM_B3(xes,xed3_operand_get_reg2(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][9]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[14], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 xed_encode_ntluf_XMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_B);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][10]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_8_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_TUPLE1_BYTE_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[14], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 1) &&
		 xed_encode_ntluf_YMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_B);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][11]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_8_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_TUPLE1_BYTE_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[14], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 2) &&
		 xed_encode_ntluf_ZMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_B);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][12]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_8_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_TUPLE1_BYTE_BIND(xes);
       if (okay) return 1;
   }
     }
   return 0;
   (void) okay;
   (void) conditions_satisfied;
   (void) xes;
}
xed_bool_t xed_encode_group_291(xed_encoder_request_t* xes)
{
   xed_bool_t okay=1;
   xed_bool_t conditions_satisfied=0;
   xed_ptrn_func_ptr_t fb_ptrn_function;
   static const xed_uint16_t iform_ids[2][10] = {
   /*VPMOVSXDQ     */    {3237,3239,3238,3240,3243,3245,3241,3244,3246,3242,},
   /*VPMOVZXDQ     */    {2591,2593,2592,2594,2597,2599,2595,2598,2600,2596,},
   };
   xed_uint8_t iclass_index = xed_encoder_get_iclasses_index_in_group(xes);
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_REG1) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 (xed3_operand_get_must_use_evex(xes) == 0) &&
		 xed_encode_ntluf_XMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_XMM_B(xes,xed3_operand_get_reg1(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][0]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_REG1) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 1) &&
		 (xed3_operand_get_must_use_evex(xes) == 0) &&
		 xed_encode_ntluf_YMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_XMM_B(xes,xed3_operand_get_reg1(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][1]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_MEM0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 (xed3_operand_get_must_use_evex(xes) == 0) &&
		 xed_encode_ntluf_XMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_Q);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][2]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_MEM0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 1) &&
		 (xed3_operand_get_must_use_evex(xes) == 0) &&
		 xed_encode_ntluf_YMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_DQ);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][3]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[7], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 xed_encode_ntluf_XMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_XMM_B3(xes,xed3_operand_get_reg2(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][4]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[7], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 1) &&
		 xed_encode_ntluf_YMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_XMM_B3(xes,xed3_operand_get_reg2(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][5]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[7], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 2) &&
		 xed_encode_ntluf_ZMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_YMM_B3(xes,xed3_operand_get_reg2(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][6]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[14], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 xed_encode_ntluf_XMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_Q);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][7]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_32_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_HALFMEM_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[14], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 1) &&
		 xed_encode_ntluf_YMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_DQ);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][8]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_32_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_HALFMEM_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[14], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 2) &&
		 xed_encode_ntluf_ZMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_QQ);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][9]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_32_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_HALFMEM_BIND(xes);
       if (okay) return 1;
   }
     }
   return 0;
   (void) okay;
   (void) conditions_satisfied;
   (void) xes;
}
xed_bool_t xed_encode_group_292(xed_encoder_request_t* xes)
{
   xed_bool_t okay=1;
   xed_bool_t conditions_satisfied=0;
   xed_ptrn_func_ptr_t fb_ptrn_function;
   static const xed_uint16_t iform_ids[1][2] = {
   /*MOVSXD        */    {2629,2628,},
   };
   xed_uint8_t iclass_index = xed_encoder_get_iclasses_index_in_group(xes);
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_REG1) {
   conditions_satisfied = (xed3_operand_get_mode(xes) == 2) &&
		 xed_encode_ntluf_GPRv_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_GPRz_B(xes,xed3_operand_get_reg1(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][0]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_MEM0) {
   conditions_satisfied = (xed3_operand_get_mode(xes) == 2) &&
		 xed_encode_ntluf_GPRv_R(xes,xed3_operand_get_reg0(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_Z);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][1]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay) return 1;
   }
     }
   return 0;
   (void) okay;
   (void) conditions_satisfied;
   (void) xes;
}
xed_bool_t xed_encode_group_293(xed_encoder_request_t* xes)
{
   xed_bool_t okay=1;
   xed_bool_t conditions_satisfied=0;
   xed_ptrn_func_ptr_t fb_ptrn_function;
   static const xed_uint16_t iform_ids[1][1] = {
   /*VMASKMOVDQU   */    {2649,},
   };
   xed_uint8_t iclass_index = xed_encoder_get_iclasses_index_in_group(xes);
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_REG1) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 (xed3_operand_get_must_use_evex(xes) == 0) &&
		 xed_encode_ntluf_XMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_XMM_B(xes,xed3_operand_get_reg1(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][0]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   return 0;
   (void) okay;
   (void) conditions_satisfied;
   (void) xes;
}
xed_bool_t xed_encode_group_294(xed_encoder_request_t* xes)
{
   xed_bool_t okay=1;
   xed_bool_t conditions_satisfied=0;
   xed_ptrn_func_ptr_t fb_ptrn_function;
   static const xed_uint16_t iform_ids[2][5] = {
   /*VGATHERDPS    */    {2842,2841,2844,2845,2843,},
   /*VPGATHERDD    */    {2658,2657,2660,2661,2659,},
   };
   xed_uint8_t iclass_index = xed_encoder_get_iclasses_index_in_group(xes);
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[24], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 (xed3_operand_get_easz(xes) != 1) &&
		 (xed3_operand_get_must_use_evex(xes) == 0) &&
		 xed_encode_ntluf_XMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_D) &&
		 xed_encode_ntluf_XMM_N(xes,xed3_operand_get_reg1(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][0]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_VMODRM_XMM_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[24], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 1) &&
		 (xed3_operand_get_easz(xes) != 1) &&
		 (xed3_operand_get_must_use_evex(xes) == 0) &&
		 xed_encode_ntluf_YMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_D) &&
		 xed_encode_ntluf_YMM_N(xes,xed3_operand_get_reg1(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][1]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_VMODRM_YMM_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[14], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 (xed3_operand_get_easz(xes) != 1) &&
		 xed_encode_ntluf_XMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASKNOT0(xes,xed3_operand_get_reg1(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_D);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][2]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_UISA_VMODRM_XMM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_32_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_GSCAT_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[14], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 1) &&
		 (xed3_operand_get_easz(xes) != 1) &&
		 xed_encode_ntluf_YMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASKNOT0(xes,xed3_operand_get_reg1(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_D);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][3]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_UISA_VMODRM_YMM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_32_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_GSCAT_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[14], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 2) &&
		 (xed3_operand_get_easz(xes) != 1) &&
		 xed_encode_ntluf_ZMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASKNOT0(xes,xed3_operand_get_reg1(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_D);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][4]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_UISA_VMODRM_ZMM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_32_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_GSCAT_BIND(xes);
       if (okay) return 1;
   }
     }
   return 0;
   (void) okay;
   (void) conditions_satisfied;
   (void) xes;
}
xed_bool_t xed_encode_group_295(xed_encoder_request_t* xes)
{
   xed_bool_t okay=1;
   xed_bool_t conditions_satisfied=0;
   xed_ptrn_func_ptr_t fb_ptrn_function;
   static const xed_uint16_t iform_ids[2][4] = {
   /*VFRCZPD       */    {5957,5959,5956,5958,},
   /*VFRCZPS       */    {2675,2677,2674,2676,},
   };
   xed_uint8_t iclass_index = xed_encoder_get_iclasses_index_in_group(xes);
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_REG1) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 xed_encode_ntluf_XMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_XMM_B(xes,xed3_operand_get_reg1(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][0]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_REG1) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 1) &&
		 xed_encode_ntluf_YMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_YMM_B(xes,xed3_operand_get_reg1(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][1]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_MEM0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 xed_encode_ntluf_XMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_DQ);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][2]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_MEM0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 1) &&
		 xed_encode_ntluf_YMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_QQ);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][3]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay) return 1;
   }
     }
   return 0;
   (void) okay;
   (void) conditions_satisfied;
   (void) xes;
}
xed_bool_t xed_encode_group_296(xed_encoder_request_t* xes)
{
   xed_bool_t okay=1;
   xed_bool_t conditions_satisfied=0;
   xed_ptrn_func_ptr_t fb_ptrn_function;
   static const xed_uint16_t iform_ids[2][2] = {
   /*COMISS        */    {5919,5918,},
   /*UCOMISS       */    {2679,2678,},
   };
   xed_uint8_t iclass_index = xed_encoder_get_iclasses_index_in_group(xes);
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_REG1) {
   conditions_satisfied = xed_encode_ntluf_XMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_XMM_B(xes,xed3_operand_get_reg1(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][0]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_MEM0) {
   conditions_satisfied = xed_encode_ntluf_XMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_SS);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][1]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay) return 1;
   }
     }
   return 0;
   (void) okay;
   (void) conditions_satisfied;
   (void) xes;
}
xed_bool_t xed_encode_group_297(xed_encoder_request_t* xes)
{
   xed_bool_t okay=1;
   xed_bool_t conditions_satisfied=0;
   xed_ptrn_func_ptr_t fb_ptrn_function;
   static const xed_uint16_t iform_ids[2][2] = {
   /*VINSERTF128   */    {2706,2705,},
   /*VINSERTI128   */    {3437,3436,},
   };
   xed_uint8_t iclass_index = xed_encoder_get_iclasses_index_in_group(xes);
   if (xes->_n_operand_order == 4 && memcmp(xed_encode_order[21], xes->_operand_order, sizeof(xed_uint8_t)*4)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 1) &&
		 (xed3_operand_get_must_use_evex(xes) == 0) &&
		 xed_encode_ntluf_YMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_YMM_N(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_XMM_B(xes,xed3_operand_get_reg2(xes)) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][0]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_UIMM8_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 4 && memcmp(xed_encode_order[22], xes->_operand_order, sizeof(xed_uint8_t)*4)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 1) &&
		 (xed3_operand_get_must_use_evex(xes) == 0) &&
		 xed_encode_ntluf_YMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_YMM_N(xes,xed3_operand_get_reg1(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_DQ) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][1]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_UIMM8_BIND(xes);
       if (okay) return 1;
   }
     }
   return 0;
   (void) okay;
   (void) conditions_satisfied;
   (void) xes;
}
xed_bool_t xed_encode_group_298(xed_encoder_request_t* xes)
{
   xed_bool_t okay=1;
   xed_bool_t conditions_satisfied=0;
   xed_ptrn_func_ptr_t fb_ptrn_function;
   static const xed_uint16_t iform_ids[2][4] = {
   /*VEXTRACTF64X2 */    {2708,2710,2709,2711,},
   /*VEXTRACTI64X2 */    {5997,5999,5998,6000,},
   };
   xed_uint8_t iclass_index = xed_encoder_get_iclasses_index_in_group(xes);
   if (xes->_n_operand_order == 4 && memcmp(xed_encode_order[21], xes->_operand_order, sizeof(xed_uint8_t)*4)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 1) &&
		 xed_encode_ntluf_XMM_B3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_YMM_R3(xes,xed3_operand_get_reg2(xes)) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][0]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_UIMM8_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 4 && memcmp(xed_encode_order[21], xes->_operand_order, sizeof(xed_uint8_t)*4)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 2) &&
		 xed_encode_ntluf_XMM_B3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_ZMM_R3(xes,xed3_operand_get_reg2(xes)) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][1]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_UIMM8_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 4 && memcmp(xed_encode_order[26], xes->_operand_order, sizeof(xed_uint8_t)*4)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 1) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_DQ) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_YMM_R3(xes,xed3_operand_get_reg1(xes)) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][2]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_UIMM8_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_64_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_TUPLE2_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 4 && memcmp(xed_encode_order[26], xes->_operand_order, sizeof(xed_uint8_t)*4)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 2) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_DQ) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_ZMM_R3(xes,xed3_operand_get_reg1(xes)) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][3]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_UIMM8_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_64_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_TUPLE2_BIND(xes);
       if (okay) return 1;
   }
     }
   return 0;
   (void) okay;
   (void) conditions_satisfied;
   (void) xes;
}
xed_bool_t xed_encode_group_299(xed_encoder_request_t* xes)
{
   xed_bool_t okay=1;
   xed_bool_t conditions_satisfied=0;
   xed_ptrn_func_ptr_t fb_ptrn_function;
   static const xed_uint16_t iform_ids[2][5] = {
   /*VMAXSD        */    {2934,2932,2931,2933,2935,},
   /*VMINSD        */    {2715,2713,2712,2714,2716,},
   };
   xed_uint8_t iclass_index = xed_encoder_get_iclasses_index_in_group(xes);
   if (xes->_n_operand_order == 4 && memcmp(xed_encode_order[12], xes->_operand_order, sizeof(xed_uint8_t)*4)==0) {
   conditions_satisfied = (xed3_operand_get_sae(xes) != 0) &&
		 xed_encode_ntluf_XMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_XMM_N3(xes,xed3_operand_get_reg2(xes)) &&
		 xed_encode_ntluf_XMM_B3(xes,xed3_operand_get_reg3(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][0]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_FIX_ROUND_LEN128_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_SAE_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[7], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_must_use_evex(xes) == 0) &&
		 xed_encode_ntluf_XMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_XMM_N(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_XMM_B(xes,xed3_operand_get_reg2(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][1]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[14], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_must_use_evex(xes) == 0) &&
		 xed_encode_ntluf_XMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_XMM_N(xes,xed3_operand_get_reg1(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_Q);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][2]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 4 && memcmp(xed_encode_order[12], xes->_operand_order, sizeof(xed_uint8_t)*4)==0) {
   conditions_satisfied = xed_encode_ntluf_XMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_XMM_N3(xes,xed3_operand_get_reg2(xes)) &&
		 xed_encode_ntluf_XMM_B3(xes,xed3_operand_get_reg3(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][3]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 4 && memcmp(xed_encode_order[13], xes->_operand_order, sizeof(xed_uint8_t)*4)==0) {
   conditions_satisfied = xed_encode_ntluf_XMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_XMM_N3(xes,xed3_operand_get_reg2(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_Q);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][4]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_64_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_SCALAR_BIND(xes);
       if (okay) return 1;
   }
     }
   return 0;
   (void) okay;
   (void) conditions_satisfied;
   (void) xes;
}
xed_bool_t xed_encode_group_300(xed_encoder_request_t* xes)
{
   xed_bool_t okay=1;
   xed_bool_t conditions_satisfied=0;
   xed_ptrn_func_ptr_t fb_ptrn_function;
   static const xed_uint16_t iform_ids[1][4] = {
   /*FLD           */    {2789,2791,2788,2790,},
   };
   xed_uint8_t iclass_index = xed_encoder_get_iclasses_index_in_group(xes);
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_REG1) {
   conditions_satisfied = (xed3_operand_get_reg0(xes) == XED_REG_ST0) &&
		 xed_encode_ntluf_X87(xes,xed3_operand_get_reg1(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][0]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_MEM0) {
   conditions_satisfied = (xed3_operand_get_reg0(xes) == XED_REG_ST0) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_M64REAL);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][1]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_MEM0) {
   conditions_satisfied = (xed3_operand_get_reg0(xes) == XED_REG_ST0) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_MEM32REAL);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][2]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_MEM0) {
   conditions_satisfied = (xed3_operand_get_reg0(xes) == XED_REG_ST0) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_MEM80REAL);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][3]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay) return 1;
   }
     }
   return 0;
   (void) okay;
   (void) conditions_satisfied;
   (void) xes;
}
xed_bool_t xed_encode_group_301(xed_encoder_request_t* xes)
{
   xed_bool_t okay=1;
   xed_bool_t conditions_satisfied=0;
   xed_ptrn_func_ptr_t fb_ptrn_function;
   static const xed_uint16_t iform_ids[1][20] = {
   /*VPERMILPD     */    {2863,2865,2867,2862,2869,2864,2866,2868,2876,2880,2872,2874,2878,2870,2877,2881,2873,2875,2879,2871,},
   };
   xed_uint8_t iclass_index = xed_encoder_get_iclasses_index_in_group(xes);
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[7], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 (xed3_operand_get_must_use_evex(xes) == 0) &&
		 xed_encode_ntluf_XMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_XMM_N(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_XMM_B(xes,xed3_operand_get_reg2(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][0]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[7], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 1) &&
		 (xed3_operand_get_must_use_evex(xes) == 0) &&
		 xed_encode_ntluf_YMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_YMM_N(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_YMM_B(xes,xed3_operand_get_reg2(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][1]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[15], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 (xed3_operand_get_must_use_evex(xes) == 0) &&
		 xed_encode_ntluf_XMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_XMM_B(xes,xed3_operand_get_reg1(xes)) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][2]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_UIMM8_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[14], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 (xed3_operand_get_must_use_evex(xes) == 0) &&
		 xed_encode_ntluf_XMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_XMM_N(xes,xed3_operand_get_reg1(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_DQ);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][3]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[15], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 1) &&
		 (xed3_operand_get_must_use_evex(xes) == 0) &&
		 xed_encode_ntluf_YMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_YMM_B(xes,xed3_operand_get_reg1(xes)) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][4]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_UIMM8_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[14], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 1) &&
		 (xed3_operand_get_must_use_evex(xes) == 0) &&
		 xed_encode_ntluf_YMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_YMM_N(xes,xed3_operand_get_reg1(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_QQ);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][5]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[20], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 (xed3_operand_get_must_use_evex(xes) == 0) &&
		 xed_encode_ntluf_XMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_DQ) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][6]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_UIMM8_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[20], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 1) &&
		 (xed3_operand_get_must_use_evex(xes) == 0) &&
		 xed_encode_ntluf_YMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_QQ) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][7]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_UIMM8_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 4 && memcmp(xed_encode_order[12], xes->_operand_order, sizeof(xed_uint8_t)*4)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 xed_encode_ntluf_XMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_XMM_N3(xes,xed3_operand_get_reg2(xes)) &&
		 xed_encode_ntluf_XMM_B3(xes,xed3_operand_get_reg3(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][8]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 4 && memcmp(xed_encode_order[12], xes->_operand_order, sizeof(xed_uint8_t)*4)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 1) &&
		 xed_encode_ntluf_YMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_YMM_N3(xes,xed3_operand_get_reg2(xes)) &&
		 xed_encode_ntluf_YMM_B3(xes,xed3_operand_get_reg3(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][9]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 4 && memcmp(xed_encode_order[12], xes->_operand_order, sizeof(xed_uint8_t)*4)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 2) &&
		 xed_encode_ntluf_ZMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_ZMM_N3(xes,xed3_operand_get_reg2(xes)) &&
		 xed_encode_ntluf_ZMM_B3(xes,xed3_operand_get_reg3(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][10]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 4 && memcmp(xed_encode_order[21], xes->_operand_order, sizeof(xed_uint8_t)*4)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 xed_encode_ntluf_XMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_XMM_B3(xes,xed3_operand_get_reg2(xes)) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][11]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_UIMM8_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 4 && memcmp(xed_encode_order[21], xes->_operand_order, sizeof(xed_uint8_t)*4)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 1) &&
		 xed_encode_ntluf_YMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_YMM_B3(xes,xed3_operand_get_reg2(xes)) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][12]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_UIMM8_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 4 && memcmp(xed_encode_order[21], xes->_operand_order, sizeof(xed_uint8_t)*4)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 2) &&
		 xed_encode_ntluf_ZMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_ZMM_B3(xes,xed3_operand_get_reg2(xes)) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][13]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_UIMM8_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 4 && memcmp(xed_encode_order[13], xes->_operand_order, sizeof(xed_uint8_t)*4)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 xed_encode_ntluf_XMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_XMM_N3(xes,xed3_operand_get_reg2(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_VV);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][14]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_64_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_FULL_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 4 && memcmp(xed_encode_order[13], xes->_operand_order, sizeof(xed_uint8_t)*4)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 1) &&
		 xed_encode_ntluf_YMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_YMM_N3(xes,xed3_operand_get_reg2(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_VV);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][15]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_64_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_FULL_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 4 && memcmp(xed_encode_order[13], xes->_operand_order, sizeof(xed_uint8_t)*4)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 2) &&
		 xed_encode_ntluf_ZMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_ZMM_N3(xes,xed3_operand_get_reg2(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_VV);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][16]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_64_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_FULL_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 4 && memcmp(xed_encode_order[22], xes->_operand_order, sizeof(xed_uint8_t)*4)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 xed_encode_ntluf_XMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_VV) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][17]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_UIMM8_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_64_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_FULL_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 4 && memcmp(xed_encode_order[22], xes->_operand_order, sizeof(xed_uint8_t)*4)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 1) &&
		 xed_encode_ntluf_YMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_VV) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][18]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_UIMM8_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_64_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_FULL_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 4 && memcmp(xed_encode_order[22], xes->_operand_order, sizeof(xed_uint8_t)*4)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 2) &&
		 xed_encode_ntluf_ZMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_VV) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][19]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_UIMM8_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_64_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_FULL_BIND(xes);
       if (okay) return 1;
   }
     }
   return 0;
   (void) okay;
   (void) conditions_satisfied;
   (void) xes;
}
xed_bool_t xed_encode_group_302(xed_encoder_request_t* xes)
{
   xed_bool_t okay=1;
   xed_bool_t conditions_satisfied=0;
   xed_ptrn_func_ptr_t fb_ptrn_function;
   static const xed_uint16_t iform_ids[1][4] = {
   /*VPINSRB       */    {2888,2887,2889,2890,},
   };
   xed_uint8_t iclass_index = xed_encoder_get_iclasses_index_in_group(xes);
   if (xes->_n_operand_order == 4 && memcmp(xed_encode_order[21], xes->_operand_order, sizeof(xed_uint8_t)*4)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 (xed3_operand_get_must_use_evex(xes) == 0) &&
		 xed_encode_ntluf_XMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_XMM_N(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_GPR32_B(xes,xed3_operand_get_reg2(xes)) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][0]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_UIMM8_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 4 && memcmp(xed_encode_order[22], xes->_operand_order, sizeof(xed_uint8_t)*4)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 (xed3_operand_get_must_use_evex(xes) == 0) &&
		 xed_encode_ntluf_XMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_XMM_N(xes,xed3_operand_get_reg1(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_B) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][1]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_UIMM8_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 4 && memcmp(xed_encode_order[21], xes->_operand_order, sizeof(xed_uint8_t)*4)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 xed_encode_ntluf_XMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_XMM_N3(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_GPR32_B(xes,xed3_operand_get_reg2(xes)) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][2]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_UIMM8_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 4 && memcmp(xed_encode_order[22], xes->_operand_order, sizeof(xed_uint8_t)*4)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 xed_encode_ntluf_XMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_XMM_N3(xes,xed3_operand_get_reg1(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_B) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][3]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_UIMM8_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_8_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_GPR_READER_BYTE_BIND(xes);
       if (okay) return 1;
   }
     }
   return 0;
   (void) okay;
   (void) conditions_satisfied;
   (void) xes;
}
xed_bool_t xed_encode_group_303(xed_encoder_request_t* xes)
{
   xed_bool_t okay=1;
   xed_bool_t conditions_satisfied=0;
   xed_ptrn_func_ptr_t fb_ptrn_function;
   static const xed_uint16_t iform_ids[1][4] = {
   /*VPINSRQ       */    {2892,2891,2893,2894,},
   };
   xed_uint8_t iclass_index = xed_encoder_get_iclasses_index_in_group(xes);
   if (xes->_n_operand_order == 4 && memcmp(xed_encode_order[21], xes->_operand_order, sizeof(xed_uint8_t)*4)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 (xed3_operand_get_mode(xes) == 2) &&
		 (xed3_operand_get_must_use_evex(xes) == 0) &&
		 xed_encode_ntluf_XMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_XMM_N(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_GPR64_B(xes,xed3_operand_get_reg2(xes)) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][0]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_UIMM8_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 4 && memcmp(xed_encode_order[22], xes->_operand_order, sizeof(xed_uint8_t)*4)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 (xed3_operand_get_mode(xes) == 2) &&
		 (xed3_operand_get_must_use_evex(xes) == 0) &&
		 xed_encode_ntluf_XMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_XMM_N(xes,xed3_operand_get_reg1(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_Q) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][1]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_UIMM8_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 4 && memcmp(xed_encode_order[21], xes->_operand_order, sizeof(xed_uint8_t)*4)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 (xed3_operand_get_mode(xes) == 2) &&
		 xed_encode_ntluf_XMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_XMM_N3(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_GPR64_B(xes,xed3_operand_get_reg2(xes)) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][2]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_UIMM8_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 4 && memcmp(xed_encode_order[22], xes->_operand_order, sizeof(xed_uint8_t)*4)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 (xed3_operand_get_mode(xes) == 2) &&
		 xed_encode_ntluf_XMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_XMM_N3(xes,xed3_operand_get_reg1(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_Q) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][3]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_UIMM8_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_64_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_GPR_READER_BIND(xes);
       if (okay) return 1;
   }
     }
   return 0;
   (void) okay;
   (void) conditions_satisfied;
   (void) xes;
}
xed_bool_t xed_encode_group_304(xed_encoder_request_t* xes)
{
   xed_bool_t okay=1;
   xed_bool_t conditions_satisfied=0;
   xed_ptrn_func_ptr_t fb_ptrn_function;
   static const xed_uint16_t iform_ids[1][15] = {
   /*VCVTTSS2SI    */    {2903,2904,2908,2896,2898,2900,2895,2897,2899,2901,2902,2907,2905,2906,2909,},
   };
   xed_uint8_t iclass_index = xed_encoder_get_iclasses_index_in_group(xes);
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_REG1) {
   conditions_satisfied = (xed3_operand_get_sae(xes) != 0) &&
		 (xed3_operand_get_mode(xes) != 2) &&
		 xed_encode_ntluf_GPR32_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_XMM_B3(xes,xed3_operand_get_reg1(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][0]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_FIX_ROUND_LEN128_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_SAE_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_REG1) {
   conditions_satisfied = (xed3_operand_get_sae(xes) != 0) &&
		 (xed3_operand_get_mode(xes) == 2) &&
		 xed_encode_ntluf_GPR32_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_XMM_B3(xes,xed3_operand_get_reg1(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][1]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_FIX_ROUND_LEN128_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_SAE_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_REG1) {
   conditions_satisfied = (xed3_operand_get_sae(xes) != 0) &&
		 (xed3_operand_get_mode(xes) == 2) &&
		 xed_encode_ntluf_GPR64_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_XMM_B3(xes,xed3_operand_get_reg1(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][2]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_FIX_ROUND_LEN128_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_SAE_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_REG1) {
   conditions_satisfied = (xed3_operand_get_mode(xes) != 2) &&
		 (xed3_operand_get_must_use_evex(xes) == 0) &&
		 xed_encode_ntluf_GPR32_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_XMM_B(xes,xed3_operand_get_reg1(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][3]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_REG1) {
   conditions_satisfied = (xed3_operand_get_mode(xes) == 2) &&
		 (xed3_operand_get_must_use_evex(xes) == 0) &&
		 xed_encode_ntluf_GPR32_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_XMM_B(xes,xed3_operand_get_reg1(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][4]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_REG1) {
   conditions_satisfied = (xed3_operand_get_mode(xes) == 2) &&
		 (xed3_operand_get_must_use_evex(xes) == 0) &&
		 xed_encode_ntluf_GPR64_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_XMM_B(xes,xed3_operand_get_reg1(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][5]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_MEM0) {
   conditions_satisfied = (xed3_operand_get_mode(xes) != 2) &&
		 (xed3_operand_get_must_use_evex(xes) == 0) &&
		 xed_encode_ntluf_GPR32_R(xes,xed3_operand_get_reg0(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_D);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][6]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_MEM0) {
   conditions_satisfied = (xed3_operand_get_mode(xes) == 2) &&
		 (xed3_operand_get_must_use_evex(xes) == 0) &&
		 xed_encode_ntluf_GPR32_R(xes,xed3_operand_get_reg0(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_D);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][7]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_MEM0) {
   conditions_satisfied = (xed3_operand_get_mode(xes) == 2) &&
		 (xed3_operand_get_must_use_evex(xes) == 0) &&
		 xed_encode_ntluf_GPR64_R(xes,xed3_operand_get_reg0(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_D);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][8]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_REG1) {
   conditions_satisfied = (xed3_operand_get_mode(xes) != 2) &&
		 xed_encode_ntluf_GPR32_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_XMM_B3(xes,xed3_operand_get_reg1(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][9]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_FIX_ROUND_LEN128_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_REG1) {
   conditions_satisfied = (xed3_operand_get_mode(xes) == 2) &&
		 xed_encode_ntluf_GPR32_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_XMM_B3(xes,xed3_operand_get_reg1(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][10]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_FIX_ROUND_LEN128_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_REG1) {
   conditions_satisfied = (xed3_operand_get_mode(xes) == 2) &&
		 xed_encode_ntluf_GPR64_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_XMM_B3(xes,xed3_operand_get_reg1(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][11]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_FIX_ROUND_LEN128_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_MEM0) {
   conditions_satisfied = (xed3_operand_get_mode(xes) != 2) &&
		 xed_encode_ntluf_GPR32_R(xes,xed3_operand_get_reg0(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_D);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][12]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_32_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_GPR_WRITER_LDOP_D_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_FIX_ROUND_LEN128_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_MEM0) {
   conditions_satisfied = (xed3_operand_get_mode(xes) == 2) &&
		 xed_encode_ntluf_GPR32_R(xes,xed3_operand_get_reg0(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_D);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][13]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_32_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_GPR_WRITER_LDOP_D_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_FIX_ROUND_LEN128_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_MEM0) {
   conditions_satisfied = (xed3_operand_get_mode(xes) == 2) &&
		 xed_encode_ntluf_GPR64_R(xes,xed3_operand_get_reg0(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_D);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][14]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_32_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_GPR_WRITER_LDOP_D_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_FIX_ROUND_LEN128_BIND(xes);
       if (okay) return 1;
   }
     }
   return 0;
   (void) okay;
   (void) conditions_satisfied;
   (void) xes;
}
xed_bool_t xed_encode_group_305(xed_encoder_request_t* xes)
{
   xed_bool_t okay=1;
   xed_bool_t conditions_satisfied=0;
   xed_ptrn_func_ptr_t fb_ptrn_function;
   static const xed_uint16_t iform_ids[5][2] = {
   /*LLDT          */    {2912,2911,},
   /*LMSW          */    {3806,3805,},
   /*LTR           */    {6217,6216,},
   /*VERR          */    {3087,3086,},
   /*VERW          */    {5103,5102,},
   };
   xed_uint8_t iclass_index = xed_encoder_get_iclasses_index_in_group(xes);
   if (xes->_n_operand_order == 1 && xes->_operand_order[0] == XED_OPERAND_REG0) {
   conditions_satisfied = xed_encode_ntluf_GPR16_B(xes,xed3_operand_get_reg0(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][0]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 1 && xes->_operand_order[0] == XED_OPERAND_MEM0) {
   conditions_satisfied = (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_W);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][1]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay) return 1;
   }
     }
   return 0;
   (void) okay;
   (void) conditions_satisfied;
   (void) xes;
}
xed_bool_t xed_encode_group_306(xed_encoder_request_t* xes)
{
   xed_bool_t okay=1;
   xed_bool_t conditions_satisfied=0;
   xed_ptrn_func_ptr_t fb_ptrn_function;
   static const xed_uint16_t iform_ids[2][6] = {
   /*VPROLD        */    {2915,2917,2913,2916,2918,2914,},
   /*VPRORD        */    {4104,4106,4102,4105,4107,4103,},
   };
   xed_uint8_t iclass_index = xed_encoder_get_iclasses_index_in_group(xes);
   if (xes->_n_operand_order == 4 && memcmp(xed_encode_order[21], xes->_operand_order, sizeof(xed_uint8_t)*4)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 xed_encode_ntluf_XMM_N3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_XMM_B3(xes,xed3_operand_get_reg2(xes)) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][0]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_UIMM8_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 4 && memcmp(xed_encode_order[21], xes->_operand_order, sizeof(xed_uint8_t)*4)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 1) &&
		 xed_encode_ntluf_YMM_N3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_YMM_B3(xes,xed3_operand_get_reg2(xes)) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][1]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_UIMM8_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 4 && memcmp(xed_encode_order[21], xes->_operand_order, sizeof(xed_uint8_t)*4)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 2) &&
		 xed_encode_ntluf_ZMM_N3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_ZMM_B3(xes,xed3_operand_get_reg2(xes)) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][2]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_UIMM8_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 4 && memcmp(xed_encode_order[22], xes->_operand_order, sizeof(xed_uint8_t)*4)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 xed_encode_ntluf_XMM_N3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_VV) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][3]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_UIMM8_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_32_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_FULL_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 4 && memcmp(xed_encode_order[22], xes->_operand_order, sizeof(xed_uint8_t)*4)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 1) &&
		 xed_encode_ntluf_YMM_N3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_VV) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][4]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_UIMM8_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_32_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_FULL_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 4 && memcmp(xed_encode_order[22], xes->_operand_order, sizeof(xed_uint8_t)*4)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 2) &&
		 xed_encode_ntluf_ZMM_N3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_VV) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][5]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_UIMM8_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_32_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_FULL_BIND(xes);
       if (okay) return 1;
   }
     }
   return 0;
   (void) okay;
   (void) conditions_satisfied;
   (void) xes;
}
xed_bool_t xed_encode_group_307(xed_encoder_request_t* xes)
{
   xed_bool_t okay=1;
   xed_bool_t conditions_satisfied=0;
   xed_ptrn_func_ptr_t fb_ptrn_function;
   static const xed_uint16_t iform_ids[1][1] = {
   /*MOVQ2DQ       */    {2921,},
   };
   xed_uint8_t iclass_index = xed_encoder_get_iclasses_index_in_group(xes);
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_REG1) {
   conditions_satisfied = xed_encode_ntluf_XMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MMX_B(xes,xed3_operand_get_reg1(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][0]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_IGNORE66_BIND(xes);
       if (okay) return 1;
   }
     }
   return 0;
   (void) okay;
   (void) conditions_satisfied;
   (void) xes;
}
xed_bool_t xed_encode_group_308(xed_encoder_request_t* xes)
{
   xed_bool_t okay=1;
   xed_bool_t conditions_satisfied=0;
   xed_ptrn_func_ptr_t fb_ptrn_function;
   static const xed_uint16_t iform_ids[2][6] = {
   /*VCOMPRESSPD   */    {2940,2942,2938,2939,2941,2937,},
   /*VPCOMPRESSQ   */    {6325,6327,6323,6324,6326,6322,},
   };
   xed_uint8_t iclass_index = xed_encoder_get_iclasses_index_in_group(xes);
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[7], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 xed_encode_ntluf_XMM_B3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_XMM_R3(xes,xed3_operand_get_reg2(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][0]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[7], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 1) &&
		 xed_encode_ntluf_YMM_B3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_YMM_R3(xes,xed3_operand_get_reg2(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][1]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[7], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 2) &&
		 xed_encode_ntluf_ZMM_B3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_ZMM_R3(xes,xed3_operand_get_reg2(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][2]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[6], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_DQ) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_XMM_R3(xes,xed3_operand_get_reg1(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][3]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_64_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_GSCAT_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[6], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 1) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_QQ) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_YMM_R3(xes,xed3_operand_get_reg1(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][4]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_64_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_GSCAT_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[6], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 2) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_ZD) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_ZMM_R3(xes,xed3_operand_get_reg1(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][5]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_64_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_GSCAT_BIND(xes);
       if (okay) return 1;
   }
     }
   return 0;
   (void) okay;
   (void) conditions_satisfied;
   (void) xes;
}
xed_bool_t xed_encode_group_309(xed_encoder_request_t* xes)
{
   xed_bool_t okay=1;
   xed_bool_t conditions_satisfied=0;
   xed_ptrn_func_ptr_t fb_ptrn_function;
   static const xed_uint16_t iform_ids[1][4] = {
   /*VPINSRW       */    {2944,2943,2945,2946,},
   };
   xed_uint8_t iclass_index = xed_encoder_get_iclasses_index_in_group(xes);
   if (xes->_n_operand_order == 4 && memcmp(xed_encode_order[21], xes->_operand_order, sizeof(xed_uint8_t)*4)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 (xed3_operand_get_must_use_evex(xes) == 0) &&
		 xed_encode_ntluf_XMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_XMM_N(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_GPR32_B(xes,xed3_operand_get_reg2(xes)) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][0]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_UIMM8_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 4 && memcmp(xed_encode_order[22], xes->_operand_order, sizeof(xed_uint8_t)*4)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 (xed3_operand_get_must_use_evex(xes) == 0) &&
		 xed_encode_ntluf_XMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_XMM_N(xes,xed3_operand_get_reg1(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_W) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][1]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_UIMM8_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 4 && memcmp(xed_encode_order[21], xes->_operand_order, sizeof(xed_uint8_t)*4)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 xed_encode_ntluf_XMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_XMM_N3(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_GPR32_B(xes,xed3_operand_get_reg2(xes)) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][2]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_UIMM8_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 4 && memcmp(xed_encode_order[22], xes->_operand_order, sizeof(xed_uint8_t)*4)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 xed_encode_ntluf_XMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_XMM_N3(xes,xed3_operand_get_reg1(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_WRD) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][3]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_UIMM8_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_16_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_GPR_READER_WORD_BIND(xes);
       if (okay) return 1;
   }
     }
   return 0;
   (void) okay;
   (void) conditions_satisfied;
   (void) xes;
}
xed_bool_t xed_encode_group_310(xed_encoder_request_t* xes)
{
   xed_bool_t okay=1;
   xed_bool_t conditions_satisfied=0;
   xed_ptrn_func_ptr_t fb_ptrn_function;
   static const xed_uint16_t iform_ids[1][3] = {
   /*FST           */    {2953,2952,2951,},
   };
   xed_uint8_t iclass_index = xed_encoder_get_iclasses_index_in_group(xes);
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_REG1) {
   conditions_satisfied = xed_encode_ntluf_X87(xes,xed3_operand_get_reg0(xes)) &&
		 (xed3_operand_get_reg1(xes) == XED_REG_ST0);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][0]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_MEM0 && xes->_operand_order[1] == XED_OPERAND_REG0) {
   conditions_satisfied = (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_M64REAL) &&
		 (xed3_operand_get_reg0(xes) == XED_REG_ST0);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][1]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_MEM0 && xes->_operand_order[1] == XED_OPERAND_REG0) {
   conditions_satisfied = (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_MEM32REAL) &&
		 (xed3_operand_get_reg0(xes) == XED_REG_ST0);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][2]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay) return 1;
   }
     }
   return 0;
   (void) okay;
   (void) conditions_satisfied;
   (void) xes;
}
xed_bool_t xed_encode_group_311(xed_encoder_request_t* xes)
{
   xed_bool_t okay=1;
   xed_bool_t conditions_satisfied=0;
   xed_ptrn_func_ptr_t fb_ptrn_function;
   static const xed_uint16_t iform_ids[1][2] = {
   /*ROUNDPS       */    {2968,2967,},
   };
   xed_uint8_t iclass_index = xed_encoder_get_iclasses_index_in_group(xes);
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[15], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = xed_encode_ntluf_XMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_XMM_B(xes,xed3_operand_get_reg1(xes)) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][0]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_REFINING66_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_UIMM8_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[20], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = xed_encode_ntluf_XMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_PS) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][1]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_REFINING66_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_UIMM8_BIND(xes);
       if (okay) return 1;
   }
     }
   return 0;
   (void) okay;
   (void) conditions_satisfied;
   (void) xes;
}
xed_bool_t xed_encode_group_312(xed_encoder_request_t* xes)
{
   xed_bool_t okay=1;
   xed_bool_t conditions_satisfied=0;
   xed_ptrn_func_ptr_t fb_ptrn_function;
   static const xed_uint16_t iform_ids[1][4] = {
   /*PALIGNR       */    {2978,2977,2980,2979,},
   };
   xed_uint8_t iclass_index = xed_encoder_get_iclasses_index_in_group(xes);
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[15], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = xed_encode_ntluf_MMX_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MMX_B(xes,xed3_operand_get_reg1(xes)) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][0]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_UIMM8_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[20], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = xed_encode_ntluf_MMX_R(xes,xed3_operand_get_reg0(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_Q) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][1]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_UIMM8_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[15], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = xed_encode_ntluf_XMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_XMM_B(xes,xed3_operand_get_reg1(xes)) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][2]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_REFINING66_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_UIMM8_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[20], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = xed_encode_ntluf_XMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_DQ) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][3]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_REFINING66_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_UIMM8_BIND(xes);
       if (okay) return 1;
   }
     }
   return 0;
   (void) okay;
   (void) conditions_satisfied;
   (void) xes;
}
xed_bool_t xed_encode_group_313(xed_encoder_request_t* xes)
{
   xed_bool_t okay=1;
   xed_bool_t conditions_satisfied=0;
   xed_ptrn_func_ptr_t fb_ptrn_function;
   static const xed_uint16_t iform_ids[2][2] = {
   /*VINSERTF32X8  */    {4863,4864,},
   /*VINSERTI32X8  */    {2990,2991,},
   };
   xed_uint8_t iclass_index = xed_encoder_get_iclasses_index_in_group(xes);
   if (xes->_n_operand_order == 5 && memcmp(xed_encode_order[18], xes->_operand_order, sizeof(xed_uint8_t)*5)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 2) &&
		 xed_encode_ntluf_ZMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_ZMM_N3(xes,xed3_operand_get_reg2(xes)) &&
		 xed_encode_ntluf_YMM_B3(xes,xed3_operand_get_reg3(xes)) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][0]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_UIMM8_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 5 && memcmp(xed_encode_order[19], xes->_operand_order, sizeof(xed_uint8_t)*5)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 2) &&
		 xed_encode_ntluf_ZMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_ZMM_N3(xes,xed3_operand_get_reg2(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_QQ) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][1]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_UIMM8_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_32_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_TUPLE8_BIND(xes);
       if (okay) return 1;
   }
     }
   return 0;
   (void) okay;
   (void) conditions_satisfied;
   (void) xes;
}
xed_bool_t xed_encode_group_314(xed_encoder_request_t* xes)
{
   xed_bool_t okay=1;
   xed_bool_t conditions_satisfied=0;
   xed_ptrn_func_ptr_t fb_ptrn_function;
   static const xed_uint16_t iform_ids[1][11] = {
   /*VCVTPH2PS     */    {2999,2995,2997,2994,2996,3001,3003,2998,3002,3004,3000,},
   };
   xed_uint8_t iclass_index = xed_encoder_get_iclasses_index_in_group(xes);
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[7], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_sae(xes) != 0) &&
		 xed_encode_ntluf_ZMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_YMM_B3(xes,xed3_operand_get_reg2(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][0]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_FIX_ROUND_LEN512_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_SAE_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_REG1) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 (xed3_operand_get_must_use_evex(xes) == 0) &&
		 xed_encode_ntluf_XMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_XMM_B(xes,xed3_operand_get_reg1(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][1]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_REG1) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 1) &&
		 (xed3_operand_get_must_use_evex(xes) == 0) &&
		 xed_encode_ntluf_YMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_XMM_B(xes,xed3_operand_get_reg1(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][2]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_MEM0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 (xed3_operand_get_must_use_evex(xes) == 0) &&
		 xed_encode_ntluf_XMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_Q);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][3]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_MEM0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 1) &&
		 (xed3_operand_get_must_use_evex(xes) == 0) &&
		 xed_encode_ntluf_YMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_DQ);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][4]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[7], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 xed_encode_ntluf_XMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_XMM_B3(xes,xed3_operand_get_reg2(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][5]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[7], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 1) &&
		 xed_encode_ntluf_YMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_XMM_B3(xes,xed3_operand_get_reg2(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][6]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[7], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 2) &&
		 xed_encode_ntluf_ZMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_YMM_B3(xes,xed3_operand_get_reg2(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][7]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[14], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 xed_encode_ntluf_XMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_Q);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][8]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_16_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_HALFMEM_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[14], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 1) &&
		 xed_encode_ntluf_YMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_DQ);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][9]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_16_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_HALFMEM_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[14], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 2) &&
		 xed_encode_ntluf_ZMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_QQ);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][10]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_16_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_HALFMEM_BIND(xes);
       if (okay) return 1;
   }
     }
   return 0;
   (void) okay;
   (void) conditions_satisfied;
   (void) xes;
}
xed_bool_t xed_encode_group_315(xed_encoder_request_t* xes)
{
   xed_bool_t okay=1;
   xed_bool_t conditions_satisfied=0;
   xed_ptrn_func_ptr_t fb_ptrn_function;
   static const xed_uint16_t iform_ids[1][6] = {
   /*VPEXPANDB     */    {3034,3036,3038,3033,3035,3037,},
   };
   xed_uint8_t iclass_index = xed_encoder_get_iclasses_index_in_group(xes);
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[7], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 xed_encode_ntluf_XMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_XMM_B3(xes,xed3_operand_get_reg2(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][0]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[7], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 1) &&
		 xed_encode_ntluf_YMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_YMM_B3(xes,xed3_operand_get_reg2(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][1]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[7], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 2) &&
		 xed_encode_ntluf_ZMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_ZMM_B3(xes,xed3_operand_get_reg2(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][2]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[14], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 xed_encode_ntluf_XMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_DQ);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][3]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_8_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_GSCAT_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[14], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 1) &&
		 xed_encode_ntluf_YMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_QQ);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][4]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_8_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_GSCAT_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[14], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 2) &&
		 xed_encode_ntluf_ZMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_ZD);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][5]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_8_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_GSCAT_BIND(xes);
       if (okay) return 1;
   }
     }
   return 0;
   (void) okay;
   (void) conditions_satisfied;
   (void) xes;
}
xed_bool_t xed_encode_group_316(xed_encoder_request_t* xes)
{
   xed_bool_t okay=1;
   xed_bool_t conditions_satisfied=0;
   xed_ptrn_func_ptr_t fb_ptrn_function;
   static const xed_uint16_t iform_ids[2][4] = {
   /*VSHUFF32X4    */    {5513,5511,5514,5512,},
   /*VSHUFI32X4    */    {3042,3040,3043,3041,},
   };
   xed_uint8_t iclass_index = xed_encoder_get_iclasses_index_in_group(xes);
   if (xes->_n_operand_order == 5 && memcmp(xed_encode_order[18], xes->_operand_order, sizeof(xed_uint8_t)*5)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 1) &&
		 xed_encode_ntluf_YMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_YMM_N3(xes,xed3_operand_get_reg2(xes)) &&
		 xed_encode_ntluf_YMM_B3(xes,xed3_operand_get_reg3(xes)) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][0]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_UIMM8_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 5 && memcmp(xed_encode_order[18], xes->_operand_order, sizeof(xed_uint8_t)*5)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 2) &&
		 xed_encode_ntluf_ZMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_ZMM_N3(xes,xed3_operand_get_reg2(xes)) &&
		 xed_encode_ntluf_ZMM_B3(xes,xed3_operand_get_reg3(xes)) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][1]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_UIMM8_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 5 && memcmp(xed_encode_order[19], xes->_operand_order, sizeof(xed_uint8_t)*5)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 1) &&
		 xed_encode_ntluf_YMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_YMM_N3(xes,xed3_operand_get_reg2(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_VV) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][2]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_UIMM8_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_32_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_FULL_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 5 && memcmp(xed_encode_order[19], xes->_operand_order, sizeof(xed_uint8_t)*5)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 2) &&
		 xed_encode_ntluf_ZMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_ZMM_N3(xes,xed3_operand_get_reg2(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_VV) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][3]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_UIMM8_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_32_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_FULL_BIND(xes);
       if (okay) return 1;
   }
     }
   return 0;
   (void) okay;
   (void) conditions_satisfied;
   (void) xes;
}
xed_bool_t xed_encode_group_317(xed_encoder_request_t* xes)
{
   xed_bool_t okay=1;
   xed_bool_t conditions_satisfied=0;
   xed_ptrn_func_ptr_t fb_ptrn_function;
   static const xed_uint16_t iform_ids[2][11] = {
   /*VMAXPS        */    {4176,4172,4174,4171,4173,4178,4180,4175,4179,4181,4177,},
   /*VMINPS        */    {3050,3046,3048,3045,3047,3052,3054,3049,3053,3055,3051,},
   };
   xed_uint8_t iclass_index = xed_encoder_get_iclasses_index_in_group(xes);
   if (xes->_n_operand_order == 4 && memcmp(xed_encode_order[12], xes->_operand_order, sizeof(xed_uint8_t)*4)==0) {
   conditions_satisfied = (xed3_operand_get_sae(xes) != 0) &&
		 xed_encode_ntluf_ZMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_ZMM_N3(xes,xed3_operand_get_reg2(xes)) &&
		 xed_encode_ntluf_ZMM_B3(xes,xed3_operand_get_reg3(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][0]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_FIX_ROUND_LEN512_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_SAE_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[7], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 (xed3_operand_get_must_use_evex(xes) == 0) &&
		 xed_encode_ntluf_XMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_XMM_N(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_XMM_B(xes,xed3_operand_get_reg2(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][1]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[7], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 1) &&
		 (xed3_operand_get_must_use_evex(xes) == 0) &&
		 xed_encode_ntluf_YMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_YMM_N(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_YMM_B(xes,xed3_operand_get_reg2(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][2]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[14], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 (xed3_operand_get_must_use_evex(xes) == 0) &&
		 xed_encode_ntluf_XMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_XMM_N(xes,xed3_operand_get_reg1(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_DQ);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][3]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[14], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 1) &&
		 (xed3_operand_get_must_use_evex(xes) == 0) &&
		 xed_encode_ntluf_YMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_YMM_N(xes,xed3_operand_get_reg1(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_QQ);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][4]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 4 && memcmp(xed_encode_order[12], xes->_operand_order, sizeof(xed_uint8_t)*4)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 xed_encode_ntluf_XMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_XMM_N3(xes,xed3_operand_get_reg2(xes)) &&
		 xed_encode_ntluf_XMM_B3(xes,xed3_operand_get_reg3(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][5]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 4 && memcmp(xed_encode_order[12], xes->_operand_order, sizeof(xed_uint8_t)*4)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 1) &&
		 xed_encode_ntluf_YMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_YMM_N3(xes,xed3_operand_get_reg2(xes)) &&
		 xed_encode_ntluf_YMM_B3(xes,xed3_operand_get_reg3(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][6]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 4 && memcmp(xed_encode_order[12], xes->_operand_order, sizeof(xed_uint8_t)*4)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 2) &&
		 xed_encode_ntluf_ZMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_ZMM_N3(xes,xed3_operand_get_reg2(xes)) &&
		 xed_encode_ntluf_ZMM_B3(xes,xed3_operand_get_reg3(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][7]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 4 && memcmp(xed_encode_order[13], xes->_operand_order, sizeof(xed_uint8_t)*4)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 xed_encode_ntluf_XMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_XMM_N3(xes,xed3_operand_get_reg2(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_VV);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][8]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_32_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_FULL_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 4 && memcmp(xed_encode_order[13], xes->_operand_order, sizeof(xed_uint8_t)*4)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 1) &&
		 xed_encode_ntluf_YMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_YMM_N3(xes,xed3_operand_get_reg2(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_VV);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][9]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_32_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_FULL_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 4 && memcmp(xed_encode_order[13], xes->_operand_order, sizeof(xed_uint8_t)*4)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 2) &&
		 xed_encode_ntluf_ZMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_ZMM_N3(xes,xed3_operand_get_reg2(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_VV);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][10]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_32_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_FULL_BIND(xes);
       if (okay) return 1;
   }
     }
   return 0;
   (void) okay;
   (void) conditions_satisfied;
   (void) xes;
}
xed_bool_t xed_encode_group_318(xed_encoder_request_t* xes)
{
   xed_bool_t okay=1;
   xed_bool_t conditions_satisfied=0;
   xed_ptrn_func_ptr_t fb_ptrn_function;
   static const xed_uint16_t iform_ids[1][6] = {
   /*VFPCLASSPS    */    {3088,3090,3092,3089,3091,3093,},
   };
   xed_uint8_t iclass_index = xed_encoder_get_iclasses_index_in_group(xes);
   if (xes->_n_operand_order == 4 && memcmp(xed_encode_order[21], xes->_operand_order, sizeof(xed_uint8_t)*4)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 xed_encode_ntluf_MASK_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_XMM_B3(xes,xed3_operand_get_reg2(xes)) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][0]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_UIMM8_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 4 && memcmp(xed_encode_order[21], xes->_operand_order, sizeof(xed_uint8_t)*4)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 1) &&
		 xed_encode_ntluf_MASK_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_YMM_B3(xes,xed3_operand_get_reg2(xes)) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][1]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_UIMM8_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 4 && memcmp(xed_encode_order[21], xes->_operand_order, sizeof(xed_uint8_t)*4)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 2) &&
		 xed_encode_ntluf_MASK_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_ZMM_B3(xes,xed3_operand_get_reg2(xes)) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][2]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_UIMM8_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 4 && memcmp(xed_encode_order[22], xes->_operand_order, sizeof(xed_uint8_t)*4)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 xed_encode_ntluf_MASK_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_VV) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][3]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_UIMM8_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_32_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_FULL_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 4 && memcmp(xed_encode_order[22], xes->_operand_order, sizeof(xed_uint8_t)*4)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 1) &&
		 xed_encode_ntluf_MASK_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_VV) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][4]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_UIMM8_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_32_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_FULL_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 4 && memcmp(xed_encode_order[22], xes->_operand_order, sizeof(xed_uint8_t)*4)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 2) &&
		 xed_encode_ntluf_MASK_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_VV) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][5]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_UIMM8_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_32_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_FULL_BIND(xes);
       if (okay) return 1;
   }
     }
   return 0;
   (void) okay;
   (void) conditions_satisfied;
   (void) xes;
}
xed_bool_t xed_encode_group_319(xed_encoder_request_t* xes)
{
   xed_bool_t okay=1;
   xed_bool_t conditions_satisfied=0;
   xed_ptrn_func_ptr_t fb_ptrn_function;
   static const xed_uint16_t iform_ids[4][10] = {
   /*VAESDEC       */    {4530,4538,4531,4539,4532,4534,4536,4533,4535,4537,},
   /*VAESDECLAST   */    {4108,4116,4109,4117,4110,4112,4114,4111,4113,4115,},
   /*VAESENC       */    {3583,3591,3584,3592,3585,3587,3589,3586,3588,3590,},
   /*VAESENCLAST   */    {3118,3126,3119,3127,3120,3122,3124,3121,3123,3125,},
   };
   xed_uint8_t iclass_index = xed_encoder_get_iclasses_index_in_group(xes);
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[7], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 (xed3_operand_get_must_use_evex(xes) == 0) &&
		 xed_encode_ntluf_XMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_XMM_N(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_XMM_B(xes,xed3_operand_get_reg2(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][0]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[7], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 1) &&
		 (xed3_operand_get_must_use_evex(xes) == 0) &&
		 xed_encode_ntluf_YMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_YMM_N(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_YMM_B(xes,xed3_operand_get_reg2(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][1]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[14], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 (xed3_operand_get_must_use_evex(xes) == 0) &&
		 xed_encode_ntluf_XMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_XMM_N(xes,xed3_operand_get_reg1(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_DQ);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][2]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[14], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 1) &&
		 (xed3_operand_get_must_use_evex(xes) == 0) &&
		 xed_encode_ntluf_YMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_YMM_N(xes,xed3_operand_get_reg1(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_QQ);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][3]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[7], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 xed_encode_ntluf_XMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_XMM_N3(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_XMM_B3(xes,xed3_operand_get_reg2(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][4]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[7], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 1) &&
		 xed_encode_ntluf_YMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_YMM_N3(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_YMM_B3(xes,xed3_operand_get_reg2(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][5]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[7], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 2) &&
		 xed_encode_ntluf_ZMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_ZMM_N3(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_ZMM_B3(xes,xed3_operand_get_reg2(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][6]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[14], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 xed_encode_ntluf_XMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_XMM_N3(xes,xed3_operand_get_reg1(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_DQ);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][7]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_128_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_FULLMEM_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[14], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 1) &&
		 xed_encode_ntluf_YMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_YMM_N3(xes,xed3_operand_get_reg1(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_QQ);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][8]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_128_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_FULLMEM_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[14], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 2) &&
		 xed_encode_ntluf_ZMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_ZMM_N3(xes,xed3_operand_get_reg1(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_ZD);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][9]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_128_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_FULLMEM_BIND(xes);
       if (okay) return 1;
   }
     }
   return 0;
   (void) okay;
   (void) conditions_satisfied;
   (void) xes;
}
xed_bool_t xed_encode_group_320(xed_encoder_request_t* xes)
{
   xed_bool_t okay=1;
   xed_bool_t conditions_satisfied=0;
   xed_ptrn_func_ptr_t fb_ptrn_function;
   static const xed_uint16_t iform_ids[1][2] = {
   /*VDPPD         */    {3129,3128,},
   };
   xed_uint8_t iclass_index = xed_encoder_get_iclasses_index_in_group(xes);
   if (xes->_n_operand_order == 4 && memcmp(xed_encode_order[21], xes->_operand_order, sizeof(xed_uint8_t)*4)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 (xed3_operand_get_must_use_evex(xes) == 0) &&
		 xed_encode_ntluf_XMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_XMM_N(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_XMM_B(xes,xed3_operand_get_reg2(xes)) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][0]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_UIMM8_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 4 && memcmp(xed_encode_order[22], xes->_operand_order, sizeof(xed_uint8_t)*4)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 (xed3_operand_get_must_use_evex(xes) == 0) &&
		 xed_encode_ntluf_XMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_XMM_N(xes,xed3_operand_get_reg1(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_DQ) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][1]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_UIMM8_BIND(xes);
       if (okay) return 1;
   }
     }
   return 0;
   (void) okay;
   (void) conditions_satisfied;
   (void) xes;
}
xed_bool_t xed_encode_group_321(xed_encoder_request_t* xes)
{
   xed_bool_t okay=1;
   xed_bool_t conditions_satisfied=0;
   xed_ptrn_func_ptr_t fb_ptrn_function;
   static const xed_uint16_t iform_ids[2][4] = {
   /*VROUNDPD      */    {3874,3876,3873,3875,},
   /*VROUNDPS      */    {3143,3145,3142,3144,},
   };
   xed_uint8_t iclass_index = xed_encoder_get_iclasses_index_in_group(xes);
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[15], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 (xed3_operand_get_must_use_evex(xes) == 0) &&
		 xed_encode_ntluf_XMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_XMM_B(xes,xed3_operand_get_reg1(xes)) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][0]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_UIMM8_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[15], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 1) &&
		 (xed3_operand_get_must_use_evex(xes) == 0) &&
		 xed_encode_ntluf_YMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_YMM_B(xes,xed3_operand_get_reg1(xes)) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][1]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_UIMM8_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[20], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 (xed3_operand_get_must_use_evex(xes) == 0) &&
		 xed_encode_ntluf_XMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_DQ) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][2]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_UIMM8_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[20], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 1) &&
		 (xed3_operand_get_must_use_evex(xes) == 0) &&
		 xed_encode_ntluf_YMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_QQ) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][3]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_UIMM8_BIND(xes);
       if (okay) return 1;
   }
     }
   return 0;
   (void) okay;
   (void) conditions_satisfied;
   (void) xes;
}
xed_bool_t xed_encode_group_322(xed_encoder_request_t* xes)
{
   xed_bool_t okay=1;
   xed_bool_t conditions_satisfied=0;
   xed_ptrn_func_ptr_t fb_ptrn_function;
   static const xed_uint16_t iform_ids[3][3] = {
   /*VEXP2PD       */    {3157,3156,3158,},
   /*VRCP28PD      */    {3207,3206,3208,},
   /*VRSQRT28PD    */    {5262,5261,5263,},
   };
   xed_uint8_t iclass_index = xed_encoder_get_iclasses_index_in_group(xes);
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[7], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_sae(xes) != 0) &&
		 xed_encode_ntluf_ZMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_ZMM_B3(xes,xed3_operand_get_reg2(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][0]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_FIX_ROUND_LEN512_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_SAE_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[7], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 2) &&
		 xed_encode_ntluf_ZMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_ZMM_B3(xes,xed3_operand_get_reg2(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][1]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[14], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 2) &&
		 xed_encode_ntluf_ZMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_VV);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][2]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_64_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_FULL_BIND(xes);
       if (okay) return 1;
   }
     }
   return 0;
   (void) okay;
   (void) conditions_satisfied;
   (void) xes;
}
xed_bool_t xed_encode_group_323(xed_encoder_request_t* xes)
{
   xed_bool_t okay=1;
   xed_bool_t conditions_satisfied=0;
   xed_ptrn_func_ptr_t fb_ptrn_function;
   static const xed_uint16_t iform_ids[1][1] = {
   /*MOVNTSD       */    {3162,},
   };
   xed_uint8_t iclass_index = xed_encoder_get_iclasses_index_in_group(xes);
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_MEM0 && xes->_operand_order[1] == XED_OPERAND_REG0) {
   conditions_satisfied = (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_Q) &&
		 xed_encode_ntluf_XMM_R(xes,xed3_operand_get_reg0(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][0]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay) return 1;
   }
     }
   return 0;
   (void) okay;
   (void) conditions_satisfied;
   (void) xes;
}
xed_bool_t xed_encode_group_324(xed_encoder_request_t* xes)
{
   xed_bool_t okay=1;
   xed_bool_t conditions_satisfied=0;
   xed_ptrn_func_ptr_t fb_ptrn_function;
   static const xed_uint16_t iform_ids[2][1] = {
   /*MOVNTDQ       */    {3167,},
   /*MOVNTPD       */    {4032,},
   };
   xed_uint8_t iclass_index = xed_encoder_get_iclasses_index_in_group(xes);
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_MEM0 && xes->_operand_order[1] == XED_OPERAND_REG0) {
   conditions_satisfied = (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_DQ) &&
		 xed_encode_ntluf_XMM_R(xes,xed3_operand_get_reg0(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][0]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_REFINING66_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay) return 1;
   }
     }
   return 0;
   (void) okay;
   (void) conditions_satisfied;
   (void) xes;
}
xed_bool_t xed_encode_group_325(xed_encoder_request_t* xes)
{
   xed_bool_t okay=1;
   xed_bool_t conditions_satisfied=0;
   xed_ptrn_func_ptr_t fb_ptrn_function;
   static const xed_uint16_t iform_ids[3][3] = {
   /*BNDCL         */    {4472,4471,4470,},
   /*BNDCN         */    {3186,3185,3184,},
   /*BNDCU         */    {4440,4439,4438,},
   };
   xed_uint8_t iclass_index = xed_encoder_get_iclasses_index_in_group(xes);
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_REG1) {
   conditions_satisfied = (xed3_operand_get_mpxmode(xes) == 1) &&
		 (xed3_operand_get_mode(xes) != 2) &&
		 xed_encode_ntluf_BND_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_GPR32_B(xes,xed3_operand_get_reg1(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][0]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_REG1) {
   conditions_satisfied = (xed3_operand_get_mpxmode(xes) == 1) &&
		 (xed3_operand_get_mode(xes) == 2) &&
		 xed_encode_ntluf_BND_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_GPR64_B(xes,xed3_operand_get_reg1(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][1]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_AGEN) {
   conditions_satisfied = (xed3_operand_get_mpxmode(xes) == 1) &&
		 xed_encode_ntluf_BND_R(xes,xed3_operand_get_reg0(xes)) &&
		 (xed3_operand_get_agen(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][2]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay) return 1;
   }
     }
   return 0;
   (void) okay;
   (void) conditions_satisfied;
   (void) xes;
}
xed_bool_t xed_encode_group_326(xed_encoder_request_t* xes)
{
   xed_bool_t okay=1;
   xed_bool_t conditions_satisfied=0;
   xed_ptrn_func_ptr_t fb_ptrn_function;
   static const xed_uint16_t iform_ids[2][6] = {
   /*VPCMPB        */    {6387,6389,6391,6388,6390,6392,},
   /*VPCMPUB       */    {3187,3189,3191,3188,3190,3192,},
   };
   xed_uint8_t iclass_index = xed_encoder_get_iclasses_index_in_group(xes);
   if (xes->_n_operand_order == 5 && memcmp(xed_encode_order[18], xes->_operand_order, sizeof(xed_uint8_t)*5)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 xed_encode_ntluf_MASK_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_XMM_N3(xes,xed3_operand_get_reg2(xes)) &&
		 xed_encode_ntluf_XMM_B3(xes,xed3_operand_get_reg3(xes)) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][0]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_UIMM8_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 5 && memcmp(xed_encode_order[18], xes->_operand_order, sizeof(xed_uint8_t)*5)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 1) &&
		 xed_encode_ntluf_MASK_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_YMM_N3(xes,xed3_operand_get_reg2(xes)) &&
		 xed_encode_ntluf_YMM_B3(xes,xed3_operand_get_reg3(xes)) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][1]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_UIMM8_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 5 && memcmp(xed_encode_order[18], xes->_operand_order, sizeof(xed_uint8_t)*5)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 2) &&
		 xed_encode_ntluf_MASK_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_ZMM_N3(xes,xed3_operand_get_reg2(xes)) &&
		 xed_encode_ntluf_ZMM_B3(xes,xed3_operand_get_reg3(xes)) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][2]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_UIMM8_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 5 && memcmp(xed_encode_order[19], xes->_operand_order, sizeof(xed_uint8_t)*5)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 xed_encode_ntluf_MASK_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_XMM_N3(xes,xed3_operand_get_reg2(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_DQ) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][3]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_UIMM8_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_8_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_FULLMEM_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 5 && memcmp(xed_encode_order[19], xes->_operand_order, sizeof(xed_uint8_t)*5)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 1) &&
		 xed_encode_ntluf_MASK_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_YMM_N3(xes,xed3_operand_get_reg2(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_QQ) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][4]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_UIMM8_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_8_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_FULLMEM_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 5 && memcmp(xed_encode_order[19], xes->_operand_order, sizeof(xed_uint8_t)*5)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 2) &&
		 xed_encode_ntluf_MASK_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_ZMM_N3(xes,xed3_operand_get_reg2(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_ZD) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][5]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_UIMM8_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_8_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_FULLMEM_BIND(xes);
       if (okay) return 1;
   }
     }
   return 0;
   (void) okay;
   (void) conditions_satisfied;
   (void) xes;
}
xed_bool_t xed_encode_group_327(xed_encoder_request_t* xes)
{
   xed_bool_t okay=1;
   xed_bool_t conditions_satisfied=0;
   xed_ptrn_func_ptr_t fb_ptrn_function;
   static const xed_uint16_t iform_ids[1][2] = {
   /*VROUNDSS      */    {3205,3204,},
   };
   xed_uint8_t iclass_index = xed_encoder_get_iclasses_index_in_group(xes);
   if (xes->_n_operand_order == 4 && memcmp(xed_encode_order[21], xes->_operand_order, sizeof(xed_uint8_t)*4)==0) {
   conditions_satisfied = (xed3_operand_get_must_use_evex(xes) == 0) &&
		 xed_encode_ntluf_XMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_XMM_N(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_XMM_B(xes,xed3_operand_get_reg2(xes)) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][0]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_UIMM8_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 4 && memcmp(xed_encode_order[22], xes->_operand_order, sizeof(xed_uint8_t)*4)==0) {
   conditions_satisfied = (xed3_operand_get_must_use_evex(xes) == 0) &&
		 xed_encode_ntluf_XMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_XMM_N(xes,xed3_operand_get_reg1(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_D) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][1]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_UIMM8_BIND(xes);
       if (okay) return 1;
   }
     }
   return 0;
   (void) okay;
   (void) conditions_satisfied;
   (void) xes;
}
xed_bool_t xed_encode_group_328(xed_encoder_request_t* xes)
{
   xed_bool_t okay=1;
   xed_bool_t conditions_satisfied=0;
   xed_ptrn_func_ptr_t fb_ptrn_function;
   static const xed_uint16_t iform_ids[2][10] = {
   /*VPMOVSXWD     */    {3209,3211,3210,3212,3215,3217,3213,3216,3218,3214,},
   /*VPMOVZXWD     */    {6933,6935,6934,6936,6939,6941,6937,6940,6942,6938,},
   };
   xed_uint8_t iclass_index = xed_encoder_get_iclasses_index_in_group(xes);
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_REG1) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 (xed3_operand_get_must_use_evex(xes) == 0) &&
		 xed_encode_ntluf_XMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_XMM_B(xes,xed3_operand_get_reg1(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][0]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_REG1) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 1) &&
		 (xed3_operand_get_must_use_evex(xes) == 0) &&
		 xed_encode_ntluf_YMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_XMM_B(xes,xed3_operand_get_reg1(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][1]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_MEM0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 (xed3_operand_get_must_use_evex(xes) == 0) &&
		 xed_encode_ntluf_XMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_Q);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][2]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_MEM0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 1) &&
		 (xed3_operand_get_must_use_evex(xes) == 0) &&
		 xed_encode_ntluf_YMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_DQ);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][3]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[7], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 xed_encode_ntluf_XMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_XMM_B3(xes,xed3_operand_get_reg2(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][4]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[7], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 1) &&
		 xed_encode_ntluf_YMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_XMM_B3(xes,xed3_operand_get_reg2(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][5]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[7], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 2) &&
		 xed_encode_ntluf_ZMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_YMM_B3(xes,xed3_operand_get_reg2(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][6]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[14], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 xed_encode_ntluf_XMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_Q);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][7]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_16_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_HALFMEM_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[14], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 1) &&
		 xed_encode_ntluf_YMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_DQ);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][8]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_16_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_HALFMEM_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[14], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 2) &&
		 xed_encode_ntluf_ZMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_QQ);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][9]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_16_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_HALFMEM_BIND(xes);
       if (okay) return 1;
   }
     }
   return 0;
   (void) okay;
   (void) conditions_satisfied;
   (void) xes;
}
xed_bool_t xed_encode_group_329(xed_encoder_request_t* xes)
{
   xed_bool_t okay=1;
   xed_bool_t conditions_satisfied=0;
   xed_ptrn_func_ptr_t fb_ptrn_function;
   static const xed_uint16_t iform_ids[2][3] = {
   /*FISTP         */    {3888,3887,3886,},
   /*FISTTP        */    {3228,3229,3227,},
   };
   xed_uint8_t iclass_index = xed_encoder_get_iclasses_index_in_group(xes);
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_MEM0 && xes->_operand_order[1] == XED_OPERAND_REG0) {
   conditions_satisfied = (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_M64INT) &&
		 (xed3_operand_get_reg0(xes) == XED_REG_ST0);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][0]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_MEM0 && xes->_operand_order[1] == XED_OPERAND_REG0) {
   conditions_satisfied = (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_MEM16INT) &&
		 (xed3_operand_get_reg0(xes) == XED_REG_ST0);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][1]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_MEM0 && xes->_operand_order[1] == XED_OPERAND_REG0) {
   conditions_satisfied = (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_MEM32INT) &&
		 (xed3_operand_get_reg0(xes) == XED_REG_ST0);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][2]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay) return 1;
   }
     }
   return 0;
   (void) okay;
   (void) conditions_satisfied;
   (void) xes;
}
xed_bool_t xed_encode_group_330(xed_encoder_request_t* xes)
{
   xed_bool_t okay=1;
   xed_bool_t conditions_satisfied=0;
   xed_ptrn_func_ptr_t fb_ptrn_function;
   static const xed_uint16_t iform_ids[2][7] = {
   /*VCVTTPS2QQ    */    {5984,5979,5981,5983,5980,5982,5985,},
   /*VCVTTPS2UQQ   */    {3235,3230,3232,3234,3231,3233,3236,},
   };
   xed_uint8_t iclass_index = xed_encoder_get_iclasses_index_in_group(xes);
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[7], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_sae(xes) != 0) &&
		 xed_encode_ntluf_ZMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_YMM_B3(xes,xed3_operand_get_reg2(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][0]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_FIX_ROUND_LEN512_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_SAE_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[7], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 xed_encode_ntluf_XMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_XMM_B3(xes,xed3_operand_get_reg2(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][1]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[7], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 1) &&
		 xed_encode_ntluf_YMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_XMM_B3(xes,xed3_operand_get_reg2(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][2]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[7], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 2) &&
		 xed_encode_ntluf_ZMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_YMM_B3(xes,xed3_operand_get_reg2(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][3]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[14], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 xed_encode_ntluf_XMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_VV);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][4]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_32_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_HALF_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[14], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 1) &&
		 xed_encode_ntluf_YMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_VV);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][5]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_32_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_HALF_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[14], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 2) &&
		 xed_encode_ntluf_ZMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_VV);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][6]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_32_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_HALF_BIND(xes);
       if (okay) return 1;
   }
     }
   return 0;
   (void) okay;
   (void) conditions_satisfied;
   (void) xes;
}
xed_bool_t xed_encode_group_331(xed_encoder_request_t* xes)
{
   xed_bool_t okay=1;
   xed_bool_t conditions_satisfied=0;
   xed_ptrn_func_ptr_t fb_ptrn_function;
   static const xed_uint16_t iform_ids[2][10] = {
   /*VMOVSHDUP     */    {4224,4226,4223,4225,4229,4231,4227,4230,4232,4228,},
   /*VMOVSLDUP     */    {3248,3250,3247,3249,3253,3255,3251,3254,3256,3252,},
   };
   xed_uint8_t iclass_index = xed_encoder_get_iclasses_index_in_group(xes);
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_REG1) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 (xed3_operand_get_must_use_evex(xes) == 0) &&
		 xed_encode_ntluf_XMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_XMM_B(xes,xed3_operand_get_reg1(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][0]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_REG1) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 1) &&
		 (xed3_operand_get_must_use_evex(xes) == 0) &&
		 xed_encode_ntluf_YMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_YMM_B(xes,xed3_operand_get_reg1(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][1]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_MEM0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 (xed3_operand_get_must_use_evex(xes) == 0) &&
		 xed_encode_ntluf_XMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_DQ);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][2]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_MEM0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 1) &&
		 (xed3_operand_get_must_use_evex(xes) == 0) &&
		 xed_encode_ntluf_YMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_QQ);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][3]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[7], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 xed_encode_ntluf_XMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_XMM_B3(xes,xed3_operand_get_reg2(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][4]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[7], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 1) &&
		 xed_encode_ntluf_YMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_YMM_B3(xes,xed3_operand_get_reg2(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][5]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[7], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 2) &&
		 xed_encode_ntluf_ZMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_ZMM_B3(xes,xed3_operand_get_reg2(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][6]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[14], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 xed_encode_ntluf_XMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_DQ);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][7]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_32_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_FULLMEM_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[14], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 1) &&
		 xed_encode_ntluf_YMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_QQ);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][8]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_32_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_FULLMEM_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[14], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 2) &&
		 xed_encode_ntluf_ZMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_ZD);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][9]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_32_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_FULLMEM_BIND(xes);
       if (okay) return 1;
   }
     }
   return 0;
   (void) okay;
   (void) conditions_satisfied;
   (void) xes;
}
xed_bool_t xed_encode_group_332(xed_encoder_request_t* xes)
{
   xed_bool_t okay=1;
   xed_bool_t conditions_satisfied=0;
   xed_ptrn_func_ptr_t fb_ptrn_function;
   static const xed_uint16_t iform_ids[1][11] = {
   /*PUSH          */    {3266,3268,3265,3267,3271,3270,3269,3272,3273,3264,3263,},
   };
   xed_uint8_t iclass_index = xed_encoder_get_iclasses_index_in_group(xes);
   if (xes->_n_operand_order == 1 && xes->_operand_order[0] == XED_OPERAND_REG0) {
   conditions_satisfied = (xed3_operand_get_mode(xes) != 2) &&
		 (xed3_operand_get_reg0(xes) == XED_REG_CS);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][0]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 1 && xes->_operand_order[0] == XED_OPERAND_REG0) {
   conditions_satisfied = (xed3_operand_get_mode(xes) != 2) &&
		 (xed3_operand_get_reg0(xes) == XED_REG_DS);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][1]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 1 && xes->_operand_order[0] == XED_OPERAND_REG0) {
   conditions_satisfied = (xed3_operand_get_mode(xes) != 2) &&
		 (xed3_operand_get_reg0(xes) == XED_REG_ES);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][2]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 1 && xes->_operand_order[0] == XED_OPERAND_REG0) {
   conditions_satisfied = (xed3_operand_get_mode(xes) != 2) &&
		 (xed3_operand_get_reg0(xes) == XED_REG_SS);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][3]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 1 && xes->_operand_order[0] == XED_OPERAND_IMM0) {
   conditions_satisfied = (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][4]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_DF64_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_SIMM8_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 1 && xes->_operand_order[0] == XED_OPERAND_IMM0) {
   conditions_satisfied = (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][5]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_DF64_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_SIMMz_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 1 && xes->_operand_order[0] == XED_OPERAND_REG0) {
   conditions_satisfied = xed_encode_ntluf_GPRv_SB(xes,xed3_operand_get_reg0(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][6]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_DF64_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 1 && xes->_operand_order[0] == XED_OPERAND_REG0) {
   conditions_satisfied = (xed3_operand_get_reg0(xes) == XED_REG_FS);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][7]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_DF64_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 1 && xes->_operand_order[0] == XED_OPERAND_REG0) {
   conditions_satisfied = (xed3_operand_get_reg0(xes) == XED_REG_GS);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][8]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_DF64_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 1 && xes->_operand_order[0] == XED_OPERAND_REG0) {
   conditions_satisfied = xed_encode_ntluf_GPRv_B(xes,xed3_operand_get_reg0(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][9]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_DF64_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 1 && xes->_operand_order[0] == XED_OPERAND_MEM0) {
   conditions_satisfied = (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_V);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][10]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_DF64_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay) return 1;
   }
     }
   return 0;
   (void) okay;
   (void) conditions_satisfied;
   (void) xes;
}
xed_bool_t xed_encode_group_333(xed_encoder_request_t* xes)
{
   xed_bool_t okay=1;
   xed_bool_t conditions_satisfied=0;
   xed_ptrn_func_ptr_t fb_ptrn_function;
   static const xed_uint16_t iform_ids[1][1] = {
   /*XBEGIN        */    {3282,},
   };
   xed_uint8_t iclass_index = xed_encoder_get_iclasses_index_in_group(xes);
   if (xes->_n_operand_order == 1 && xes->_operand_order[0] == XED_OPERAND_RELBR) {
   conditions_satisfied = (xed3_operand_get_relbr(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][0]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_BRDISPz_BIND(xes);
       if (okay) return 1;
   }
     }
   return 0;
   (void) okay;
   (void) conditions_satisfied;
   (void) xes;
}
xed_bool_t xed_encode_group_334(xed_encoder_request_t* xes)
{
   xed_bool_t okay=1;
   xed_bool_t conditions_satisfied=0;
   xed_ptrn_func_ptr_t fb_ptrn_function;
   static const xed_uint16_t iform_ids[1][1] = {
   /*FBLD          */    {3295,},
   };
   xed_uint8_t iclass_index = xed_encoder_get_iclasses_index_in_group(xes);
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_MEM0) {
   conditions_satisfied = (xed3_operand_get_reg0(xes) == XED_REG_ST0) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_MEM80DEC);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][0]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay) return 1;
   }
     }
   return 0;
   (void) okay;
   (void) conditions_satisfied;
   (void) xes;
}
xed_bool_t xed_encode_group_335(xed_encoder_request_t* xes)
{
   xed_bool_t okay=1;
   xed_bool_t conditions_satisfied=0;
   xed_ptrn_func_ptr_t fb_ptrn_function;
   static const xed_uint16_t iform_ids[1][2] = {
   /*VFRCZSD       */    {3311,3310,},
   };
   xed_uint8_t iclass_index = xed_encoder_get_iclasses_index_in_group(xes);
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_REG1) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 xed_encode_ntluf_XMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_XMM_B(xes,xed3_operand_get_reg1(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][0]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_MEM0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 xed_encode_ntluf_XMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_Q);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][1]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay) return 1;
   }
     }
   return 0;
   (void) okay;
   (void) conditions_satisfied;
   (void) xes;
}
xed_bool_t xed_encode_group_336(xed_encoder_request_t* xes)
{
   xed_bool_t okay=1;
   xed_bool_t conditions_satisfied=0;
   xed_ptrn_func_ptr_t fb_ptrn_function;
   static const xed_uint16_t iform_ids[2][2] = {
   /*CVTPD2PI      */    {6263,6262,},
   /*CVTTPD2PI     */    {3313,3312,},
   };
   xed_uint8_t iclass_index = xed_encoder_get_iclasses_index_in_group(xes);
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_REG1) {
   conditions_satisfied = xed_encode_ntluf_MMX_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_XMM_B(xes,xed3_operand_get_reg1(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][0]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_REFINING66_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_MEM0) {
   conditions_satisfied = xed_encode_ntluf_MMX_R(xes,xed3_operand_get_reg0(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_PD);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][1]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_REFINING66_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay) return 1;
   }
     }
   return 0;
   (void) okay;
   (void) conditions_satisfied;
   (void) xes;
}
xed_bool_t xed_encode_group_337(xed_encoder_request_t* xes)
{
   xed_bool_t okay=1;
   xed_bool_t conditions_satisfied=0;
   xed_ptrn_func_ptr_t fb_ptrn_function;
   static const xed_uint16_t iform_ids[2][2] = {
   /*VBROADCASTF32X4*/    {3337,3336,},
   /*VBROADCASTI32X4*/    {4943,4942,},
   };
   xed_uint8_t iclass_index = xed_encoder_get_iclasses_index_in_group(xes);
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[14], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 1) &&
		 xed_encode_ntluf_YMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_DQ);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][0]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_32_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_TUPLE4_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[14], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 2) &&
		 xed_encode_ntluf_ZMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_DQ);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][1]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_32_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_TUPLE4_BIND(xes);
       if (okay) return 1;
   }
     }
   return 0;
   (void) okay;
   (void) conditions_satisfied;
   (void) xes;
}
xed_bool_t xed_encode_group_338(xed_encoder_request_t* xes)
{
   xed_bool_t okay=1;
   xed_bool_t conditions_satisfied=0;
   xed_ptrn_func_ptr_t fb_ptrn_function;
   static const xed_uint16_t iform_ids[2][4] = {
   /*MOVAPD        */    {4750,4748,4749,4747,},
   /*MOVUPD        */    {3341,3339,3340,3338,},
   };
   xed_uint8_t iclass_index = xed_encoder_get_iclasses_index_in_group(xes);
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_REG1) {
   conditions_satisfied = xed_encode_ntluf_XMM_B(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_XMM_R(xes,xed3_operand_get_reg1(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][0]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_REFINING66_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_REG1) {
   conditions_satisfied = xed_encode_ntluf_XMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_XMM_B(xes,xed3_operand_get_reg1(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][1]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_REFINING66_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_MEM0 && xes->_operand_order[1] == XED_OPERAND_REG0) {
   conditions_satisfied = (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_PD) &&
		 xed_encode_ntluf_XMM_R(xes,xed3_operand_get_reg0(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][2]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_REFINING66_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_MEM0) {
   conditions_satisfied = xed_encode_ntluf_XMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_PD);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][3]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_REFINING66_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay) return 1;
   }
     }
   return 0;
   (void) okay;
   (void) conditions_satisfied;
   (void) xes;
}
xed_bool_t xed_encode_group_339(xed_encoder_request_t* xes)
{
   xed_bool_t okay=1;
   xed_bool_t conditions_satisfied=0;
   xed_ptrn_func_ptr_t fb_ptrn_function;
   static const xed_uint16_t iform_ids[1][2] = {
   /*VFRCZSS       */    {3397,3396,},
   };
   xed_uint8_t iclass_index = xed_encoder_get_iclasses_index_in_group(xes);
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_REG1) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 xed_encode_ntluf_XMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_XMM_B(xes,xed3_operand_get_reg1(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][0]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_MEM0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 xed_encode_ntluf_XMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_D);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][1]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay) return 1;
   }
     }
   return 0;
   (void) okay;
   (void) conditions_satisfied;
   (void) xes;
}
xed_bool_t xed_encode_group_340(xed_encoder_request_t* xes)
{
   xed_bool_t okay=1;
   xed_bool_t conditions_satisfied=0;
   xed_ptrn_func_ptr_t fb_ptrn_function;
   static const xed_uint16_t iform_ids[1][1] = {
   /*VMCLEAR       */    {3424,},
   };
   xed_uint8_t iclass_index = xed_encoder_get_iclasses_index_in_group(xes);
   if (xes->_n_operand_order == 1 && xes->_operand_order[0] == XED_OPERAND_MEM0) {
   conditions_satisfied = (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_Q);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][0]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_REFINING66_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay) return 1;
   }
     }
   return 0;
   (void) okay;
   (void) conditions_satisfied;
   (void) xes;
}
xed_bool_t xed_encode_group_341(xed_encoder_request_t* xes)
{
   xed_bool_t okay=1;
   xed_bool_t conditions_satisfied=0;
   xed_ptrn_func_ptr_t fb_ptrn_function;
   static const xed_uint16_t iform_ids[2][12] = {
   /*VMOVDQA32     */    {3471,3469,3475,3473,3467,3465,3472,3470,3476,3474,3468,3466,},
   /*VMOVDQU32     */    {5177,5175,5181,5179,5173,5171,5178,5176,5182,5180,5174,5172,},
   };
   xed_uint8_t iclass_index = xed_encoder_get_iclasses_index_in_group(xes);
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[7], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 xed_encode_ntluf_XMM_B3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_XMM_R3(xes,xed3_operand_get_reg2(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][0]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[7], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 xed_encode_ntluf_XMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_XMM_B3(xes,xed3_operand_get_reg2(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][1]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[7], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 1) &&
		 xed_encode_ntluf_YMM_B3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_YMM_R3(xes,xed3_operand_get_reg2(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][2]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[7], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 1) &&
		 xed_encode_ntluf_YMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_YMM_B3(xes,xed3_operand_get_reg2(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][3]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[7], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 2) &&
		 xed_encode_ntluf_ZMM_B3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_ZMM_R3(xes,xed3_operand_get_reg2(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][4]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[7], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 2) &&
		 xed_encode_ntluf_ZMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_ZMM_B3(xes,xed3_operand_get_reg2(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][5]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[6], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_DQ) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_XMM_R3(xes,xed3_operand_get_reg1(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][6]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_32_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_FULLMEM_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[14], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 xed_encode_ntluf_XMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_DQ);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][7]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_32_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_FULLMEM_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[6], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 1) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_QQ) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_YMM_R3(xes,xed3_operand_get_reg1(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][8]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_32_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_FULLMEM_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[14], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 1) &&
		 xed_encode_ntluf_YMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_QQ);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][9]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_32_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_FULLMEM_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[6], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 2) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_ZD) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_ZMM_R3(xes,xed3_operand_get_reg1(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][10]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_32_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_FULLMEM_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[14], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 2) &&
		 xed_encode_ntluf_ZMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_ZD);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][11]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_32_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_FULLMEM_BIND(xes);
       if (okay) return 1;
   }
     }
   return 0;
   (void) okay;
   (void) conditions_satisfied;
   (void) xes;
}
xed_bool_t xed_encode_group_342(xed_encoder_request_t* xes)
{
   xed_bool_t okay=1;
   xed_bool_t conditions_satisfied=0;
   xed_ptrn_func_ptr_t fb_ptrn_function;
   static const xed_uint16_t iform_ids[3][6] = {
   /*REP_INSW      */    {4129,4132,4130,4133,4131,4134,},
   /*REP_STOSD     */    {6425,6428,6426,6429,6427,6430,},
   /*REP_STOSW     */    {3488,3491,3489,3492,3490,3493,},
   };
   xed_uint8_t iclass_index = xed_encoder_get_iclasses_index_in_group(xes);
   if (xes->_n_operand_order == 0) {
   conditions_satisfied = (xed3_operand_get_mode(xes) == 0);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][0]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 0) {
   conditions_satisfied = (xed3_operand_get_mode(xes) == 0);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][1]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 0) {
   conditions_satisfied = (xed3_operand_get_mode(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][2]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 0) {
   conditions_satisfied = (xed3_operand_get_mode(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][3]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 0) {
   conditions_satisfied = (xed3_operand_get_mode(xes) == 2);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][4]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 0) {
   conditions_satisfied = (xed3_operand_get_mode(xes) == 2);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][5]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   return 0;
   (void) okay;
   (void) conditions_satisfied;
   (void) xes;
}
xed_bool_t xed_encode_group_343(xed_encoder_request_t* xes)
{
   xed_bool_t okay=1;
   xed_bool_t conditions_satisfied=0;
   xed_ptrn_func_ptr_t fb_ptrn_function;
   static const xed_uint16_t iform_ids[1][6] = {
   /*FSTP          */    {3497,3498,3499,3496,3494,3495,},
   };
   xed_uint8_t iclass_index = xed_encoder_get_iclasses_index_in_group(xes);
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_REG1) {
   conditions_satisfied = xed_encode_ntluf_X87(xes,xed3_operand_get_reg0(xes)) &&
		 (xed3_operand_get_reg1(xes) == XED_REG_ST0);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][0]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_REG1) {
   conditions_satisfied = xed_encode_ntluf_X87(xes,xed3_operand_get_reg0(xes)) &&
		 (xed3_operand_get_reg1(xes) == XED_REG_ST0);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][1]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_REG1) {
   conditions_satisfied = xed_encode_ntluf_X87(xes,xed3_operand_get_reg0(xes)) &&
		 (xed3_operand_get_reg1(xes) == XED_REG_ST0);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][2]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_MEM0 && xes->_operand_order[1] == XED_OPERAND_REG0) {
   conditions_satisfied = (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_M64REAL) &&
		 (xed3_operand_get_reg0(xes) == XED_REG_ST0);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][3]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_MEM0 && xes->_operand_order[1] == XED_OPERAND_REG0) {
   conditions_satisfied = (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_MEM32REAL) &&
		 (xed3_operand_get_reg0(xes) == XED_REG_ST0);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][4]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_MEM0 && xes->_operand_order[1] == XED_OPERAND_REG0) {
   conditions_satisfied = (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_MEM80REAL) &&
		 (xed3_operand_get_reg0(xes) == XED_REG_ST0);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][5]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay) return 1;
   }
     }
   return 0;
   (void) okay;
   (void) conditions_satisfied;
   (void) xes;
}
xed_bool_t xed_encode_group_344(xed_encoder_request_t* xes)
{
   xed_bool_t okay=1;
   xed_bool_t conditions_satisfied=0;
   xed_ptrn_func_ptr_t fb_ptrn_function;
   static const xed_uint16_t iform_ids[1][10] = {
   /*VPABSW        */    {3542,3544,3541,3543,3545,3547,3549,3546,3548,3550,},
   };
   xed_uint8_t iclass_index = xed_encoder_get_iclasses_index_in_group(xes);
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_REG1) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 (xed3_operand_get_must_use_evex(xes) == 0) &&
		 xed_encode_ntluf_XMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_XMM_B(xes,xed3_operand_get_reg1(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][0]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_REG1) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 1) &&
		 (xed3_operand_get_must_use_evex(xes) == 0) &&
		 xed_encode_ntluf_YMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_YMM_B(xes,xed3_operand_get_reg1(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][1]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_MEM0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 (xed3_operand_get_must_use_evex(xes) == 0) &&
		 xed_encode_ntluf_XMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_DQ);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][2]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_MEM0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 1) &&
		 (xed3_operand_get_must_use_evex(xes) == 0) &&
		 xed_encode_ntluf_YMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_QQ);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][3]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[7], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 xed_encode_ntluf_XMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_XMM_B3(xes,xed3_operand_get_reg2(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][4]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[7], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 1) &&
		 xed_encode_ntluf_YMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_YMM_B3(xes,xed3_operand_get_reg2(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][5]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[7], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 2) &&
		 xed_encode_ntluf_ZMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_ZMM_B3(xes,xed3_operand_get_reg2(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][6]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[14], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 xed_encode_ntluf_XMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_DQ);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][7]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_16_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_FULLMEM_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[14], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 1) &&
		 xed_encode_ntluf_YMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_QQ);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][8]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_16_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_FULLMEM_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[14], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 2) &&
		 xed_encode_ntluf_ZMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_ZD);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][9]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_16_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_FULLMEM_BIND(xes);
       if (okay) return 1;
   }
     }
   return 0;
   (void) okay;
   (void) conditions_satisfied;
   (void) xes;
}
xed_bool_t xed_encode_group_345(xed_encoder_request_t* xes)
{
   xed_bool_t okay=1;
   xed_bool_t conditions_satisfied=0;
   xed_ptrn_func_ptr_t fb_ptrn_function;
   static const xed_uint16_t iform_ids[1][6] = {
   /*VPEXPANDW     */    {3559,3561,3563,3558,3560,3562,},
   };
   xed_uint8_t iclass_index = xed_encoder_get_iclasses_index_in_group(xes);
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[7], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 xed_encode_ntluf_XMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_XMM_B3(xes,xed3_operand_get_reg2(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][0]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[7], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 1) &&
		 xed_encode_ntluf_YMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_YMM_B3(xes,xed3_operand_get_reg2(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][1]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[7], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 2) &&
		 xed_encode_ntluf_ZMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_ZMM_B3(xes,xed3_operand_get_reg2(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][2]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[14], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 xed_encode_ntluf_XMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_DQ);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][3]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_16_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_GSCAT_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[14], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 1) &&
		 xed_encode_ntluf_YMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_QQ);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][4]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_16_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_GSCAT_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[14], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 2) &&
		 xed_encode_ntluf_ZMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_ZD);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][5]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_16_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_GSCAT_BIND(xes);
       if (okay) return 1;
   }
     }
   return 0;
   (void) okay;
   (void) conditions_satisfied;
   (void) xes;
}
xed_bool_t xed_encode_group_346(xed_encoder_request_t* xes)
{
   xed_bool_t okay=1;
   xed_bool_t conditions_satisfied=0;
   xed_ptrn_func_ptr_t fb_ptrn_function;
   static const xed_uint16_t iform_ids[1][2] = {
   /*PEXTRW        */    {3577,3578,},
   };
   xed_uint8_t iclass_index = xed_encoder_get_iclasses_index_in_group(xes);
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[15], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = xed_encode_ntluf_GPR32_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MMX_B(xes,xed3_operand_get_reg1(xes)) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][0]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_UIMM8_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[15], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = xed_encode_ntluf_GPR32_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_XMM_B(xes,xed3_operand_get_reg1(xes)) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][1]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_REFINING66_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_UIMM8_BIND(xes);
       if (okay) return 1;
   }
     }
   return 0;
   (void) okay;
   (void) conditions_satisfied;
   (void) xes;
}
xed_bool_t xed_encode_group_347(xed_encoder_request_t* xes)
{
   xed_bool_t okay=1;
   xed_bool_t conditions_satisfied=0;
   xed_ptrn_func_ptr_t fb_ptrn_function;
   static const xed_uint16_t iform_ids[1][4] = {
   /*MOVSS         */    {3582,3580,3581,3579,},
   };
   xed_uint8_t iclass_index = xed_encoder_get_iclasses_index_in_group(xes);
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_REG1) {
   conditions_satisfied = xed_encode_ntluf_XMM_B(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_XMM_R(xes,xed3_operand_get_reg1(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][0]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_IGNORE66_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_REG1) {
   conditions_satisfied = xed_encode_ntluf_XMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_XMM_B(xes,xed3_operand_get_reg1(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][1]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_IGNORE66_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_MEM0 && xes->_operand_order[1] == XED_OPERAND_REG0) {
   conditions_satisfied = (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_SS) &&
		 xed_encode_ntluf_XMM_R(xes,xed3_operand_get_reg0(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][2]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_IGNORE66_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_MEM0) {
   conditions_satisfied = xed_encode_ntluf_XMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_SS);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][3]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_IGNORE66_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay) return 1;
   }
     }
   return 0;
   (void) okay;
   (void) conditions_satisfied;
   (void) xes;
}
xed_bool_t xed_encode_group_348(xed_encoder_request_t* xes)
{
   xed_bool_t okay=1;
   xed_bool_t conditions_satisfied=0;
   xed_ptrn_func_ptr_t fb_ptrn_function;
   static const xed_uint16_t iform_ids[2][4] = {
   /*CVTSD2SI      */    {3598,3600,3597,3599,},
   /*CVTTSD2SI     */    {4099,4101,4098,4100,},
   };
   xed_uint8_t iclass_index = xed_encoder_get_iclasses_index_in_group(xes);
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_REG1) {
   conditions_satisfied = xed_encode_ntluf_GPR32_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_XMM_B(xes,xed3_operand_get_reg1(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][0]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_IGNORE66_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_REG1) {
   conditions_satisfied = xed_encode_ntluf_GPR64_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_XMM_B(xes,xed3_operand_get_reg1(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][1]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_IGNORE66_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_MEM0) {
   conditions_satisfied = xed_encode_ntluf_GPR32_R(xes,xed3_operand_get_reg0(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_SD);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][2]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_IGNORE66_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_MEM0) {
   conditions_satisfied = xed_encode_ntluf_GPR64_R(xes,xed3_operand_get_reg0(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_SD);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][3]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_IGNORE66_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay) return 1;
   }
     }
   return 0;
   (void) okay;
   (void) conditions_satisfied;
   (void) xes;
}
xed_bool_t xed_encode_group_349(xed_encoder_request_t* xes)
{
   xed_bool_t okay=1;
   xed_bool_t conditions_satisfied=0;
   xed_ptrn_func_ptr_t fb_ptrn_function;
   static const xed_uint16_t iform_ids[1][1] = {
   /*MOVNTQ        */    {3618,},
   };
   xed_uint8_t iclass_index = xed_encoder_get_iclasses_index_in_group(xes);
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_MEM0 && xes->_operand_order[1] == XED_OPERAND_REG0) {
   conditions_satisfied = (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_Q) &&
		 xed_encode_ntluf_MMX_R(xes,xed3_operand_get_reg0(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][0]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay) return 1;
   }
     }
   return 0;
   (void) okay;
   (void) conditions_satisfied;
   (void) xes;
}
xed_bool_t xed_encode_group_350(xed_encoder_request_t* xes)
{
   xed_bool_t okay=1;
   xed_bool_t conditions_satisfied=0;
   xed_ptrn_func_ptr_t fb_ptrn_function;
   static const xed_uint16_t iform_ids[1][9] = {
   /*VCVTUSI2SS    */    {3621,3622,3626,3619,3620,3625,3623,3624,3627,},
   };
   xed_uint8_t iclass_index = xed_encoder_get_iclasses_index_in_group(xes);
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[7], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_roundc(xes) != 0) &&
		 (xed3_operand_get_mode(xes) != 2) &&
		 xed_encode_ntluf_XMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_XMM_N3(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_GPR32_B(xes,xed3_operand_get_reg2(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][0]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_FIX_ROUND_LEN128_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_AVX512_ROUND_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[7], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_roundc(xes) != 0) &&
		 (xed3_operand_get_mode(xes) == 2) &&
		 xed_encode_ntluf_XMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_XMM_N3(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_GPR32_B(xes,xed3_operand_get_reg2(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][1]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_FIX_ROUND_LEN128_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_AVX512_ROUND_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[7], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_roundc(xes) != 0) &&
		 (xed3_operand_get_mode(xes) == 2) &&
		 xed_encode_ntluf_XMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_XMM_N3(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_GPR64_B(xes,xed3_operand_get_reg2(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][2]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_FIX_ROUND_LEN128_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_AVX512_ROUND_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[7], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_mode(xes) != 2) &&
		 xed_encode_ntluf_XMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_XMM_N3(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_GPR32_B(xes,xed3_operand_get_reg2(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][3]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_FIX_ROUND_LEN128_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[7], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_mode(xes) == 2) &&
		 xed_encode_ntluf_XMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_XMM_N3(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_GPR32_B(xes,xed3_operand_get_reg2(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][4]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_FIX_ROUND_LEN128_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[7], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_mode(xes) == 2) &&
		 xed_encode_ntluf_XMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_XMM_N3(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_GPR64_B(xes,xed3_operand_get_reg2(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][5]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_FIX_ROUND_LEN128_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[14], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_mode(xes) != 2) &&
		 xed_encode_ntluf_XMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_XMM_N3(xes,xed3_operand_get_reg1(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_D);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][6]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_32_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_GPR_READER_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_FIX_ROUND_LEN128_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[14], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_mode(xes) == 2) &&
		 xed_encode_ntluf_XMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_XMM_N3(xes,xed3_operand_get_reg1(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_D);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][7]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_32_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_GPR_READER_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_FIX_ROUND_LEN128_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[14], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_mode(xes) == 2) &&
		 xed_encode_ntluf_XMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_XMM_N3(xes,xed3_operand_get_reg1(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_Q);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][8]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_64_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_GPR_READER_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_FIX_ROUND_LEN128_BIND(xes);
       if (okay) return 1;
   }
     }
   return 0;
   (void) okay;
   (void) conditions_satisfied;
   (void) xes;
}
xed_bool_t xed_encode_group_351(xed_encoder_request_t* xes)
{
   xed_bool_t okay=1;
   xed_bool_t conditions_satisfied=0;
   xed_ptrn_func_ptr_t fb_ptrn_function;
   static const xed_uint16_t iform_ids[1][11] = {
   /*VCMPPS        */    {3649,3645,3647,3644,3646,3651,3653,3648,3652,3654,3650,},
   };
   xed_uint8_t iclass_index = xed_encoder_get_iclasses_index_in_group(xes);
   if (xes->_n_operand_order == 5 && memcmp(xed_encode_order[18], xes->_operand_order, sizeof(xed_uint8_t)*5)==0) {
   conditions_satisfied = (xed3_operand_get_sae(xes) != 0) &&
		 xed_encode_ntluf_MASK_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_ZMM_N3(xes,xed3_operand_get_reg2(xes)) &&
		 xed_encode_ntluf_ZMM_B3(xes,xed3_operand_get_reg3(xes)) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][0]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_FIX_ROUND_LEN512_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_SAE_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_UIMM8_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 4 && memcmp(xed_encode_order[21], xes->_operand_order, sizeof(xed_uint8_t)*4)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 (xed3_operand_get_must_use_evex(xes) == 0) &&
		 xed_encode_ntluf_XMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_XMM_N(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_XMM_B(xes,xed3_operand_get_reg2(xes)) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][1]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_UIMM8_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 4 && memcmp(xed_encode_order[21], xes->_operand_order, sizeof(xed_uint8_t)*4)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 1) &&
		 (xed3_operand_get_must_use_evex(xes) == 0) &&
		 xed_encode_ntluf_YMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_YMM_N(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_YMM_B(xes,xed3_operand_get_reg2(xes)) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][2]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_UIMM8_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 4 && memcmp(xed_encode_order[22], xes->_operand_order, sizeof(xed_uint8_t)*4)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 (xed3_operand_get_must_use_evex(xes) == 0) &&
		 xed_encode_ntluf_XMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_XMM_N(xes,xed3_operand_get_reg1(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_DQ) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][3]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_UIMM8_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 4 && memcmp(xed_encode_order[22], xes->_operand_order, sizeof(xed_uint8_t)*4)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 1) &&
		 (xed3_operand_get_must_use_evex(xes) == 0) &&
		 xed_encode_ntluf_YMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_YMM_N(xes,xed3_operand_get_reg1(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_QQ) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][4]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_UIMM8_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 5 && memcmp(xed_encode_order[18], xes->_operand_order, sizeof(xed_uint8_t)*5)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 xed_encode_ntluf_MASK_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_XMM_N3(xes,xed3_operand_get_reg2(xes)) &&
		 xed_encode_ntluf_XMM_B3(xes,xed3_operand_get_reg3(xes)) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][5]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_UIMM8_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 5 && memcmp(xed_encode_order[18], xes->_operand_order, sizeof(xed_uint8_t)*5)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 1) &&
		 xed_encode_ntluf_MASK_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_YMM_N3(xes,xed3_operand_get_reg2(xes)) &&
		 xed_encode_ntluf_YMM_B3(xes,xed3_operand_get_reg3(xes)) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][6]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_UIMM8_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 5 && memcmp(xed_encode_order[18], xes->_operand_order, sizeof(xed_uint8_t)*5)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 2) &&
		 xed_encode_ntluf_MASK_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_ZMM_N3(xes,xed3_operand_get_reg2(xes)) &&
		 xed_encode_ntluf_ZMM_B3(xes,xed3_operand_get_reg3(xes)) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][7]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_UIMM8_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 5 && memcmp(xed_encode_order[19], xes->_operand_order, sizeof(xed_uint8_t)*5)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 xed_encode_ntluf_MASK_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_XMM_N3(xes,xed3_operand_get_reg2(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_VV) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][8]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_UIMM8_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_32_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_FULL_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 5 && memcmp(xed_encode_order[19], xes->_operand_order, sizeof(xed_uint8_t)*5)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 1) &&
		 xed_encode_ntluf_MASK_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_YMM_N3(xes,xed3_operand_get_reg2(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_VV) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][9]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_UIMM8_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_32_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_FULL_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 5 && memcmp(xed_encode_order[19], xes->_operand_order, sizeof(xed_uint8_t)*5)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 2) &&
		 xed_encode_ntluf_MASK_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_ZMM_N3(xes,xed3_operand_get_reg2(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_VV) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][10]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_UIMM8_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_32_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_FULL_BIND(xes);
       if (okay) return 1;
   }
     }
   return 0;
   (void) okay;
   (void) conditions_satisfied;
   (void) xes;
}
xed_bool_t xed_encode_group_352(xed_encoder_request_t* xes)
{
   xed_bool_t okay=1;
   xed_bool_t conditions_satisfied=0;
   xed_ptrn_func_ptr_t fb_ptrn_function;
   static const xed_uint16_t iform_ids[2][8] = {
   /*VPSLLDQ       */    {6682,6683,6684,6686,6688,6685,6687,6689,},
   /*VPSRLDQ       */    {3655,3656,3657,3659,3661,3658,3660,3662,},
   };
   xed_uint8_t iclass_index = xed_encoder_get_iclasses_index_in_group(xes);
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[15], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 (xed3_operand_get_must_use_evex(xes) == 0) &&
		 xed_encode_ntluf_XMM_N(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_XMM_B(xes,xed3_operand_get_reg1(xes)) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][0]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_UIMM8_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[15], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 1) &&
		 (xed3_operand_get_must_use_evex(xes) == 0) &&
		 xed_encode_ntluf_YMM_N(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_YMM_B(xes,xed3_operand_get_reg1(xes)) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][1]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_UIMM8_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[15], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 xed_encode_ntluf_XMM_N3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_XMM_B3(xes,xed3_operand_get_reg1(xes)) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][2]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_UIMM8_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[15], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 1) &&
		 xed_encode_ntluf_YMM_N3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_YMM_B3(xes,xed3_operand_get_reg1(xes)) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][3]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_UIMM8_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[15], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 2) &&
		 xed_encode_ntluf_ZMM_N3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_ZMM_B3(xes,xed3_operand_get_reg1(xes)) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][4]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_UIMM8_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[20], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 xed_encode_ntluf_XMM_N3(xes,xed3_operand_get_reg0(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_DQ) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][5]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_UIMM8_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_8_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_FULLMEM_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[20], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 1) &&
		 xed_encode_ntluf_YMM_N3(xes,xed3_operand_get_reg0(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_QQ) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][6]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_UIMM8_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_8_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_FULLMEM_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[20], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 2) &&
		 xed_encode_ntluf_ZMM_N3(xes,xed3_operand_get_reg0(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_ZD) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][7]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_UIMM8_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_8_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_FULLMEM_BIND(xes);
       if (okay) return 1;
   }
     }
   return 0;
   (void) okay;
   (void) conditions_satisfied;
   (void) xes;
}
xed_bool_t xed_encode_group_353(xed_encoder_request_t* xes)
{
   xed_bool_t okay=1;
   xed_bool_t conditions_satisfied=0;
   xed_ptrn_func_ptr_t fb_ptrn_function;
   static const xed_uint16_t iform_ids[1][4] = {
   /*VMWRITE       */    {3667,3665,3666,3664,},
   };
   xed_uint8_t iclass_index = xed_encoder_get_iclasses_index_in_group(xes);
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_REG1) {
   conditions_satisfied = (xed3_operand_get_mode(xes) != 2) &&
		 xed_encode_ntluf_GPR32_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_GPR32_B(xes,xed3_operand_get_reg1(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][0]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_CR_WIDTH_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_REG1) {
   conditions_satisfied = (xed3_operand_get_mode(xes) == 2) &&
		 xed_encode_ntluf_GPR64_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_GPR64_B(xes,xed3_operand_get_reg1(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][1]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_CR_WIDTH_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_MEM0) {
   conditions_satisfied = (xed3_operand_get_mode(xes) != 2) &&
		 xed_encode_ntluf_GPR32_R(xes,xed3_operand_get_reg0(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_D);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][2]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_CR_WIDTH_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_MEM0) {
   conditions_satisfied = (xed3_operand_get_mode(xes) == 2) &&
		 xed_encode_ntluf_GPR64_R(xes,xed3_operand_get_reg0(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_Q);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][3]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_CR_WIDTH_BIND(xes);
       if (okay) return 1;
   }
     }
   return 0;
   (void) okay;
   (void) conditions_satisfied;
   (void) xes;
}
xed_bool_t xed_encode_group_354(xed_encoder_request_t* xes)
{
   xed_bool_t okay=1;
   xed_bool_t conditions_satisfied=0;
   xed_ptrn_func_ptr_t fb_ptrn_function;
   static const xed_uint16_t iform_ids[3][6] = {
   /*VPSHUFBITQMB  */    {3669,3671,3673,3670,3672,3674,},
   /*VPTESTMB      */    {3939,3941,3943,3940,3942,3944,},
   /*VPTESTNMB     */    {6525,6527,6529,6526,6528,6530,},
   };
   xed_uint8_t iclass_index = xed_encoder_get_iclasses_index_in_group(xes);
   if (xes->_n_operand_order == 4 && memcmp(xed_encode_order[12], xes->_operand_order, sizeof(xed_uint8_t)*4)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 xed_encode_ntluf_MASK_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_XMM_N3(xes,xed3_operand_get_reg2(xes)) &&
		 xed_encode_ntluf_XMM_B3(xes,xed3_operand_get_reg3(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][0]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 4 && memcmp(xed_encode_order[12], xes->_operand_order, sizeof(xed_uint8_t)*4)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 1) &&
		 xed_encode_ntluf_MASK_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_YMM_N3(xes,xed3_operand_get_reg2(xes)) &&
		 xed_encode_ntluf_YMM_B3(xes,xed3_operand_get_reg3(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][1]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 4 && memcmp(xed_encode_order[12], xes->_operand_order, sizeof(xed_uint8_t)*4)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 2) &&
		 xed_encode_ntluf_MASK_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_ZMM_N3(xes,xed3_operand_get_reg2(xes)) &&
		 xed_encode_ntluf_ZMM_B3(xes,xed3_operand_get_reg3(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][2]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 4 && memcmp(xed_encode_order[13], xes->_operand_order, sizeof(xed_uint8_t)*4)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 xed_encode_ntluf_MASK_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_XMM_N3(xes,xed3_operand_get_reg2(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_DQ);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][3]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_8_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_FULLMEM_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 4 && memcmp(xed_encode_order[13], xes->_operand_order, sizeof(xed_uint8_t)*4)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 1) &&
		 xed_encode_ntluf_MASK_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_YMM_N3(xes,xed3_operand_get_reg2(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_QQ);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][4]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_8_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_FULLMEM_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 4 && memcmp(xed_encode_order[13], xes->_operand_order, sizeof(xed_uint8_t)*4)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 2) &&
		 xed_encode_ntluf_MASK_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_ZMM_N3(xes,xed3_operand_get_reg2(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_ZD);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][5]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_8_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_FULLMEM_BIND(xes);
       if (okay) return 1;
   }
     }
   return 0;
   (void) okay;
   (void) conditions_satisfied;
   (void) xes;
}
xed_bool_t xed_encode_group_355(xed_encoder_request_t* xes)
{
   xed_bool_t okay=1;
   xed_bool_t conditions_satisfied=0;
   xed_ptrn_func_ptr_t fb_ptrn_function;
   static const xed_uint16_t iform_ids[1][6] = {
   /*BSF           */    {3676,3678,3680,3675,3677,3679,},
   };
   xed_uint8_t iclass_index = xed_encoder_get_iclasses_index_in_group(xes);
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_REG1) {
   conditions_satisfied = xed_encode_ntluf_GPRv_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_GPRv_B(xes,xed3_operand_get_reg1(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][0]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_REG1) {
   conditions_satisfied = xed_encode_ntluf_GPRv_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_GPRv_B(xes,xed3_operand_get_reg1(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][1]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_REG1) {
   conditions_satisfied = xed_encode_ntluf_GPRv_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_GPRv_B(xes,xed3_operand_get_reg1(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][2]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_MEM0) {
   conditions_satisfied = xed_encode_ntluf_GPRv_R(xes,xed3_operand_get_reg0(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_V);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][3]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_MEM0) {
   conditions_satisfied = xed_encode_ntluf_GPRv_R(xes,xed3_operand_get_reg0(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_V);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][4]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_MEM0) {
   conditions_satisfied = xed_encode_ntluf_GPRv_R(xes,xed3_operand_get_reg0(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_V);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][5]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay) return 1;
   }
     }
   return 0;
   (void) okay;
   (void) conditions_satisfied;
   (void) xes;
}
xed_bool_t xed_encode_group_356(xed_encoder_request_t* xes)
{
   xed_bool_t okay=1;
   xed_bool_t conditions_satisfied=0;
   xed_ptrn_func_ptr_t fb_ptrn_function;
   static const xed_uint16_t iform_ids[3][6] = {
   /*VPMOVQD       */    {6368,6370,6366,6369,6371,6367,},
   /*VPMOVSQD      */    {6779,6781,6777,6780,6782,6778,},
   /*VPMOVUSQD     */    {3683,3685,3681,3684,3686,3682,},
   };
   xed_uint8_t iclass_index = xed_encoder_get_iclasses_index_in_group(xes);
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[7], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 xed_encode_ntluf_XMM_B3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_XMM_R3(xes,xed3_operand_get_reg2(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][0]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[7], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 1) &&
		 xed_encode_ntluf_XMM_B3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_YMM_R3(xes,xed3_operand_get_reg2(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][1]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[7], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 2) &&
		 xed_encode_ntluf_YMM_B3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_ZMM_R3(xes,xed3_operand_get_reg2(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][2]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[6], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_Q) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_XMM_R3(xes,xed3_operand_get_reg1(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][3]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_32_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_HALFMEM_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[6], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 1) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_DQ) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_YMM_R3(xes,xed3_operand_get_reg1(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][4]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_32_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_HALFMEM_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[6], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 2) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_QQ) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_ZMM_R3(xes,xed3_operand_get_reg1(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][5]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_32_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_HALFMEM_BIND(xes);
       if (okay) return 1;
   }
     }
   return 0;
   (void) okay;
   (void) conditions_satisfied;
   (void) xes;
}
xed_bool_t xed_encode_group_357(xed_encoder_request_t* xes)
{
   xed_bool_t okay=1;
   xed_bool_t conditions_satisfied=0;
   xed_ptrn_func_ptr_t fb_ptrn_function;
   static const xed_uint16_t iform_ids[2][1] = {
   /*MOVHLPS       */    {6207,},
   /*MOVLHPS       */    {3706,},
   };
   xed_uint8_t iclass_index = xed_encoder_get_iclasses_index_in_group(xes);
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_REG1) {
   conditions_satisfied = xed_encode_ntluf_XMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_XMM_B(xes,xed3_operand_get_reg1(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][0]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   return 0;
   (void) okay;
   (void) conditions_satisfied;
   (void) xes;
}
xed_bool_t xed_encode_group_358(xed_encoder_request_t* xes)
{
   xed_bool_t okay=1;
   xed_bool_t conditions_satisfied=0;
   xed_ptrn_func_ptr_t fb_ptrn_function;
   static const xed_uint16_t iform_ids[1][10] = {
   /*VPSADBW       */    {3734,3736,3733,3735,3737,3739,3741,3738,3740,3742,},
   };
   xed_uint8_t iclass_index = xed_encoder_get_iclasses_index_in_group(xes);
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[7], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 (xed3_operand_get_must_use_evex(xes) == 0) &&
		 xed_encode_ntluf_XMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_XMM_N(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_XMM_B(xes,xed3_operand_get_reg2(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][0]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[7], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 1) &&
		 (xed3_operand_get_must_use_evex(xes) == 0) &&
		 xed_encode_ntluf_YMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_YMM_N(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_YMM_B(xes,xed3_operand_get_reg2(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][1]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[14], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 (xed3_operand_get_must_use_evex(xes) == 0) &&
		 xed_encode_ntluf_XMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_XMM_N(xes,xed3_operand_get_reg1(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_DQ);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][2]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[14], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 1) &&
		 (xed3_operand_get_must_use_evex(xes) == 0) &&
		 xed_encode_ntluf_YMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_YMM_N(xes,xed3_operand_get_reg1(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_QQ);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][3]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[7], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 xed_encode_ntluf_XMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_XMM_N3(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_XMM_B3(xes,xed3_operand_get_reg2(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][4]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[7], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 1) &&
		 xed_encode_ntluf_YMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_YMM_N3(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_YMM_B3(xes,xed3_operand_get_reg2(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][5]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[7], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 2) &&
		 xed_encode_ntluf_ZMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_ZMM_N3(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_ZMM_B3(xes,xed3_operand_get_reg2(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][6]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[14], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 xed_encode_ntluf_XMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_XMM_N3(xes,xed3_operand_get_reg1(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_DQ);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][7]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_8_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_FULLMEM_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[14], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 1) &&
		 xed_encode_ntluf_YMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_YMM_N3(xes,xed3_operand_get_reg1(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_QQ);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][8]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_8_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_FULLMEM_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[14], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 2) &&
		 xed_encode_ntluf_ZMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_ZMM_N3(xes,xed3_operand_get_reg1(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_ZD);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][9]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_8_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_FULLMEM_BIND(xes);
       if (okay) return 1;
   }
     }
   return 0;
   (void) okay;
   (void) conditions_satisfied;
   (void) xes;
}
xed_bool_t xed_encode_group_359(xed_encoder_request_t* xes)
{
   xed_bool_t okay=1;
   xed_bool_t conditions_satisfied=0;
   xed_ptrn_func_ptr_t fb_ptrn_function;
   static const xed_uint16_t iform_ids[1][9] = {
   /*VCVTSD2USI    */    {3752,3753,3757,3750,3751,3756,3754,3755,3758,},
   };
   xed_uint8_t iclass_index = xed_encoder_get_iclasses_index_in_group(xes);
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_REG1) {
   conditions_satisfied = (xed3_operand_get_roundc(xes) != 0) &&
		 (xed3_operand_get_mode(xes) != 2) &&
		 xed_encode_ntluf_GPR32_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_XMM_B3(xes,xed3_operand_get_reg1(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][0]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_FIX_ROUND_LEN128_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_AVX512_ROUND_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_REG1) {
   conditions_satisfied = (xed3_operand_get_roundc(xes) != 0) &&
		 (xed3_operand_get_mode(xes) == 2) &&
		 xed_encode_ntluf_GPR32_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_XMM_B3(xes,xed3_operand_get_reg1(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][1]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_FIX_ROUND_LEN128_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_AVX512_ROUND_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_REG1) {
   conditions_satisfied = (xed3_operand_get_roundc(xes) != 0) &&
		 (xed3_operand_get_mode(xes) == 2) &&
		 xed_encode_ntluf_GPR64_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_XMM_B3(xes,xed3_operand_get_reg1(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][2]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_FIX_ROUND_LEN128_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_AVX512_ROUND_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_REG1) {
   conditions_satisfied = (xed3_operand_get_mode(xes) != 2) &&
		 xed_encode_ntluf_GPR32_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_XMM_B3(xes,xed3_operand_get_reg1(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][3]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_FIX_ROUND_LEN128_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_REG1) {
   conditions_satisfied = (xed3_operand_get_mode(xes) == 2) &&
		 xed_encode_ntluf_GPR32_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_XMM_B3(xes,xed3_operand_get_reg1(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][4]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_FIX_ROUND_LEN128_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_REG1) {
   conditions_satisfied = (xed3_operand_get_mode(xes) == 2) &&
		 xed_encode_ntluf_GPR64_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_XMM_B3(xes,xed3_operand_get_reg1(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][5]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_FIX_ROUND_LEN128_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_MEM0) {
   conditions_satisfied = (xed3_operand_get_mode(xes) != 2) &&
		 xed_encode_ntluf_GPR32_R(xes,xed3_operand_get_reg0(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_Q);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][6]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_64_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_GPR_WRITER_LDOP_Q_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_FIX_ROUND_LEN128_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_MEM0) {
   conditions_satisfied = (xed3_operand_get_mode(xes) == 2) &&
		 xed_encode_ntluf_GPR32_R(xes,xed3_operand_get_reg0(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_Q);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][7]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_64_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_GPR_WRITER_LDOP_Q_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_FIX_ROUND_LEN128_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_MEM0) {
   conditions_satisfied = (xed3_operand_get_mode(xes) == 2) &&
		 xed_encode_ntluf_GPR64_R(xes,xed3_operand_get_reg0(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_Q);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][8]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_64_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_GPR_WRITER_LDOP_Q_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_FIX_ROUND_LEN128_BIND(xes);
       if (okay) return 1;
   }
     }
   return 0;
   (void) okay;
   (void) conditions_satisfied;
   (void) xes;
}
xed_bool_t xed_encode_group_360(xed_encoder_request_t* xes)
{
   xed_bool_t okay=1;
   xed_bool_t conditions_satisfied=0;
   xed_ptrn_func_ptr_t fb_ptrn_function;
   static const xed_uint16_t iform_ids[1][20] = {
   /*VPERMILPS     */    {3765,3767,3769,3764,3771,3766,3768,3770,3778,3782,3774,3776,3780,3772,3779,3783,3775,3777,3781,3773,},
   };
   xed_uint8_t iclass_index = xed_encoder_get_iclasses_index_in_group(xes);
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[7], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 (xed3_operand_get_must_use_evex(xes) == 0) &&
		 xed_encode_ntluf_XMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_XMM_N(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_XMM_B(xes,xed3_operand_get_reg2(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][0]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[7], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 1) &&
		 (xed3_operand_get_must_use_evex(xes) == 0) &&
		 xed_encode_ntluf_YMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_YMM_N(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_YMM_B(xes,xed3_operand_get_reg2(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][1]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[15], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 (xed3_operand_get_must_use_evex(xes) == 0) &&
		 xed_encode_ntluf_XMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_XMM_B(xes,xed3_operand_get_reg1(xes)) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][2]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_UIMM8_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[14], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 (xed3_operand_get_must_use_evex(xes) == 0) &&
		 xed_encode_ntluf_XMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_XMM_N(xes,xed3_operand_get_reg1(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_DQ);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][3]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[15], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 1) &&
		 (xed3_operand_get_must_use_evex(xes) == 0) &&
		 xed_encode_ntluf_YMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_YMM_B(xes,xed3_operand_get_reg1(xes)) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][4]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_UIMM8_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[14], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 1) &&
		 (xed3_operand_get_must_use_evex(xes) == 0) &&
		 xed_encode_ntluf_YMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_YMM_N(xes,xed3_operand_get_reg1(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_QQ);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][5]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[20], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 (xed3_operand_get_must_use_evex(xes) == 0) &&
		 xed_encode_ntluf_XMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_DQ) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][6]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_UIMM8_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[20], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 1) &&
		 (xed3_operand_get_must_use_evex(xes) == 0) &&
		 xed_encode_ntluf_YMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_QQ) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][7]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_UIMM8_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 4 && memcmp(xed_encode_order[12], xes->_operand_order, sizeof(xed_uint8_t)*4)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 xed_encode_ntluf_XMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_XMM_N3(xes,xed3_operand_get_reg2(xes)) &&
		 xed_encode_ntluf_XMM_B3(xes,xed3_operand_get_reg3(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][8]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 4 && memcmp(xed_encode_order[12], xes->_operand_order, sizeof(xed_uint8_t)*4)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 1) &&
		 xed_encode_ntluf_YMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_YMM_N3(xes,xed3_operand_get_reg2(xes)) &&
		 xed_encode_ntluf_YMM_B3(xes,xed3_operand_get_reg3(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][9]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 4 && memcmp(xed_encode_order[12], xes->_operand_order, sizeof(xed_uint8_t)*4)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 2) &&
		 xed_encode_ntluf_ZMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_ZMM_N3(xes,xed3_operand_get_reg2(xes)) &&
		 xed_encode_ntluf_ZMM_B3(xes,xed3_operand_get_reg3(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][10]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 4 && memcmp(xed_encode_order[21], xes->_operand_order, sizeof(xed_uint8_t)*4)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 xed_encode_ntluf_XMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_XMM_B3(xes,xed3_operand_get_reg2(xes)) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][11]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_UIMM8_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 4 && memcmp(xed_encode_order[21], xes->_operand_order, sizeof(xed_uint8_t)*4)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 1) &&
		 xed_encode_ntluf_YMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_YMM_B3(xes,xed3_operand_get_reg2(xes)) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][12]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_UIMM8_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 4 && memcmp(xed_encode_order[21], xes->_operand_order, sizeof(xed_uint8_t)*4)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 2) &&
		 xed_encode_ntluf_ZMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_ZMM_B3(xes,xed3_operand_get_reg2(xes)) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][13]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_UIMM8_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 4 && memcmp(xed_encode_order[13], xes->_operand_order, sizeof(xed_uint8_t)*4)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 xed_encode_ntluf_XMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_XMM_N3(xes,xed3_operand_get_reg2(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_VV);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][14]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_32_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_FULL_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 4 && memcmp(xed_encode_order[13], xes->_operand_order, sizeof(xed_uint8_t)*4)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 1) &&
		 xed_encode_ntluf_YMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_YMM_N3(xes,xed3_operand_get_reg2(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_VV);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][15]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_32_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_FULL_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 4 && memcmp(xed_encode_order[13], xes->_operand_order, sizeof(xed_uint8_t)*4)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 2) &&
		 xed_encode_ntluf_ZMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_ZMM_N3(xes,xed3_operand_get_reg2(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_VV);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][16]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_32_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_FULL_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 4 && memcmp(xed_encode_order[22], xes->_operand_order, sizeof(xed_uint8_t)*4)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 xed_encode_ntluf_XMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_VV) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][17]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_UIMM8_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_32_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_FULL_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 4 && memcmp(xed_encode_order[22], xes->_operand_order, sizeof(xed_uint8_t)*4)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 1) &&
		 xed_encode_ntluf_YMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_VV) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][18]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_UIMM8_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_32_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_FULL_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 4 && memcmp(xed_encode_order[22], xes->_operand_order, sizeof(xed_uint8_t)*4)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 2) &&
		 xed_encode_ntluf_ZMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_VV) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][19]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_UIMM8_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_32_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_FULL_BIND(xes);
       if (okay) return 1;
   }
     }
   return 0;
   (void) okay;
   (void) conditions_satisfied;
   (void) xes;
}
xed_bool_t xed_encode_group_361(xed_encoder_request_t* xes)
{
   xed_bool_t okay=1;
   xed_bool_t conditions_satisfied=0;
   xed_ptrn_func_ptr_t fb_ptrn_function;
   static const xed_uint16_t iform_ids[2][7] = {
   /*FNSAVE        */    {5927,5924,5928,5925,5929,5930,5926,},
   /*FRSTOR        */    {3793,3790,3794,3791,3795,3796,3792,},
   };
   xed_uint8_t iclass_index = xed_encoder_get_iclasses_index_in_group(xes);
   if (xes->_n_operand_order == 1 && xes->_operand_order[0] == XED_OPERAND_MEM0) {
   conditions_satisfied = (xed3_operand_get_mode(xes) == 0) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_MEM108);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][0]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 1 && xes->_operand_order[0] == XED_OPERAND_MEM0) {
   conditions_satisfied = (xed3_operand_get_mode(xes) == 0) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_MEM94);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][1]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 1 && xes->_operand_order[0] == XED_OPERAND_MEM0) {
   conditions_satisfied = (xed3_operand_get_mode(xes) == 1) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_MEM108);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][2]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 1 && xes->_operand_order[0] == XED_OPERAND_MEM0) {
   conditions_satisfied = (xed3_operand_get_mode(xes) == 1) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_MEM94);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][3]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 1 && xes->_operand_order[0] == XED_OPERAND_MEM0) {
   conditions_satisfied = (xed3_operand_get_mode(xes) == 2) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_MEM108);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][4]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 1 && xes->_operand_order[0] == XED_OPERAND_MEM0) {
   conditions_satisfied = (xed3_operand_get_mode(xes) == 2) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_MEM108);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][5]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 1 && xes->_operand_order[0] == XED_OPERAND_MEM0) {
   conditions_satisfied = (xed3_operand_get_mode(xes) == 2) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_MEM94);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][6]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay) return 1;
   }
     }
   return 0;
   (void) okay;
   (void) conditions_satisfied;
   (void) xes;
}
xed_bool_t xed_encode_group_362(xed_encoder_request_t* xes)
{
   xed_bool_t okay=1;
   xed_bool_t conditions_satisfied=0;
   xed_ptrn_func_ptr_t fb_ptrn_function;
   static const xed_uint16_t iform_ids[2][20] = {
   /*VMOVAPD       */    {3810,3808,3814,3812,3809,3807,3813,3811,3821,3819,3825,3823,3817,3815,3822,3820,3826,3824,3818,3816,},
   /*VMOVUPD       */    {6851,6849,6855,6853,6850,6848,6854,6852,6862,6860,6866,6864,6858,6856,6863,6861,6867,6865,6859,6857,},
   };
   xed_uint8_t iclass_index = xed_encoder_get_iclasses_index_in_group(xes);
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_REG1) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 (xed3_operand_get_must_use_evex(xes) == 0) &&
		 xed_encode_ntluf_XMM_B(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_XMM_R(xes,xed3_operand_get_reg1(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][0]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_REG1) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 (xed3_operand_get_must_use_evex(xes) == 0) &&
		 xed_encode_ntluf_XMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_XMM_B(xes,xed3_operand_get_reg1(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][1]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_REG1) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 1) &&
		 (xed3_operand_get_must_use_evex(xes) == 0) &&
		 xed_encode_ntluf_YMM_B(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_YMM_R(xes,xed3_operand_get_reg1(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][2]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_REG1) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 1) &&
		 (xed3_operand_get_must_use_evex(xes) == 0) &&
		 xed_encode_ntluf_YMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_YMM_B(xes,xed3_operand_get_reg1(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][3]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_MEM0 && xes->_operand_order[1] == XED_OPERAND_REG0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 (xed3_operand_get_must_use_evex(xes) == 0) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_DQ) &&
		 xed_encode_ntluf_XMM_R(xes,xed3_operand_get_reg0(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][4]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_MEM0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 (xed3_operand_get_must_use_evex(xes) == 0) &&
		 xed_encode_ntluf_XMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_DQ);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][5]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_MEM0 && xes->_operand_order[1] == XED_OPERAND_REG0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 1) &&
		 (xed3_operand_get_must_use_evex(xes) == 0) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_QQ) &&
		 xed_encode_ntluf_YMM_R(xes,xed3_operand_get_reg0(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][6]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_MEM0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 1) &&
		 (xed3_operand_get_must_use_evex(xes) == 0) &&
		 xed_encode_ntluf_YMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_QQ);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][7]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[7], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 xed_encode_ntluf_XMM_B3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_XMM_R3(xes,xed3_operand_get_reg2(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][8]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[7], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 xed_encode_ntluf_XMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_XMM_B3(xes,xed3_operand_get_reg2(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][9]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[7], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 1) &&
		 xed_encode_ntluf_YMM_B3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_YMM_R3(xes,xed3_operand_get_reg2(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][10]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[7], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 1) &&
		 xed_encode_ntluf_YMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_YMM_B3(xes,xed3_operand_get_reg2(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][11]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[7], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 2) &&
		 xed_encode_ntluf_ZMM_B3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_ZMM_R3(xes,xed3_operand_get_reg2(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][12]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[7], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 2) &&
		 xed_encode_ntluf_ZMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_ZMM_B3(xes,xed3_operand_get_reg2(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][13]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[6], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_DQ) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_XMM_R3(xes,xed3_operand_get_reg1(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][14]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_64_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_FULLMEM_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[14], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 xed_encode_ntluf_XMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_DQ);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][15]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_64_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_FULLMEM_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[6], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 1) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_QQ) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_YMM_R3(xes,xed3_operand_get_reg1(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][16]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_64_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_FULLMEM_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[14], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 1) &&
		 xed_encode_ntluf_YMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_QQ);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][17]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_64_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_FULLMEM_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[6], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 2) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_ZD) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_ZMM_R3(xes,xed3_operand_get_reg1(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][18]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_64_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_FULLMEM_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[14], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 2) &&
		 xed_encode_ntluf_ZMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_ZD);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][19]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_64_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_FULLMEM_BIND(xes);
       if (okay) return 1;
   }
     }
   return 0;
   (void) okay;
   (void) conditions_satisfied;
   (void) xes;
}
xed_bool_t xed_encode_group_363(xed_encoder_request_t* xes)
{
   xed_bool_t okay=1;
   xed_bool_t conditions_satisfied=0;
   xed_ptrn_func_ptr_t fb_ptrn_function;
   static const xed_uint16_t iform_ids[2][4] = {
   /*MOVSX         */    {5441,5439,5438,5440,},
   /*MOVZX         */    {3830,3828,3827,3829,},
   };
   xed_uint8_t iclass_index = xed_encoder_get_iclasses_index_in_group(xes);
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_REG1) {
   conditions_satisfied = xed_encode_ntluf_GPRv_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_GPR16_B(xes,xed3_operand_get_reg1(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][0]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_REG1) {
   conditions_satisfied = xed_encode_ntluf_GPRv_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_GPR8_B(xes,xed3_operand_get_reg1(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][1]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_MEM0) {
   conditions_satisfied = xed_encode_ntluf_GPRv_R(xes,xed3_operand_get_reg0(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_B);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][2]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_MEM0) {
   conditions_satisfied = xed_encode_ntluf_GPRv_R(xes,xed3_operand_get_reg0(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_W);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][3]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay) return 1;
   }
     }
   return 0;
   (void) okay;
   (void) conditions_satisfied;
   (void) xes;
}
xed_bool_t xed_encode_group_364(xed_encoder_request_t* xes)
{
   xed_bool_t okay=1;
   xed_bool_t conditions_satisfied=0;
   xed_ptrn_func_ptr_t fb_ptrn_function;
   static const xed_uint16_t iform_ids[1][4] = {
   /*OUTSD         */    {3843,3844,3845,3846,},
   };
   xed_uint8_t iclass_index = xed_encoder_get_iclasses_index_in_group(xes);
   if (xes->_n_operand_order == 0) {
   conditions_satisfied = (xed3_operand_get_mode(xes) == 0);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][0]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_OVERRIDE_SEG0_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 0) {
   conditions_satisfied = (xed3_operand_get_mode(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][1]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_OVERRIDE_SEG0_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 0) {
   conditions_satisfied = (xed3_operand_get_mode(xes) == 2);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][2]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_OVERRIDE_SEG0_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 0) {
   conditions_satisfied = (xed3_operand_get_mode(xes) == 2);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][3]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_OVERRIDE_SEG0_BIND(xes);
       if (okay) return 1;
   }
     }
   return 0;
   (void) okay;
   (void) conditions_satisfied;
   (void) xes;
}
xed_bool_t xed_encode_group_365(xed_encoder_request_t* xes)
{
   xed_bool_t okay=1;
   xed_bool_t conditions_satisfied=0;
   xed_ptrn_func_ptr_t fb_ptrn_function;
   static const xed_uint16_t iform_ids[2][4] = {
   /*VINSERTF64X2  */    {3857,3859,3858,3860,},
   /*VINSERTI64X2  */    {4392,4394,4393,4395,},
   };
   xed_uint8_t iclass_index = xed_encoder_get_iclasses_index_in_group(xes);
   if (xes->_n_operand_order == 5 && memcmp(xed_encode_order[18], xes->_operand_order, sizeof(xed_uint8_t)*5)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 1) &&
		 xed_encode_ntluf_YMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_YMM_N3(xes,xed3_operand_get_reg2(xes)) &&
		 xed_encode_ntluf_XMM_B3(xes,xed3_operand_get_reg3(xes)) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][0]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_UIMM8_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 5 && memcmp(xed_encode_order[18], xes->_operand_order, sizeof(xed_uint8_t)*5)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 2) &&
		 xed_encode_ntluf_ZMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_ZMM_N3(xes,xed3_operand_get_reg2(xes)) &&
		 xed_encode_ntluf_XMM_B3(xes,xed3_operand_get_reg3(xes)) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][1]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_UIMM8_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 5 && memcmp(xed_encode_order[19], xes->_operand_order, sizeof(xed_uint8_t)*5)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 1) &&
		 xed_encode_ntluf_YMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_YMM_N3(xes,xed3_operand_get_reg2(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_DQ) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][2]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_UIMM8_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_64_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_TUPLE2_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 5 && memcmp(xed_encode_order[19], xes->_operand_order, sizeof(xed_uint8_t)*5)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 2) &&
		 xed_encode_ntluf_ZMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_ZMM_N3(xes,xed3_operand_get_reg2(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_DQ) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][3]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_UIMM8_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_64_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_TUPLE2_BIND(xes);
       if (okay) return 1;
   }
     }
   return 0;
   (void) okay;
   (void) conditions_satisfied;
   (void) xes;
}
xed_bool_t xed_encode_group_366(xed_encoder_request_t* xes)
{
   xed_bool_t okay=1;
   xed_bool_t conditions_satisfied=0;
   xed_ptrn_func_ptr_t fb_ptrn_function;
   static const xed_uint16_t iform_ids[2][3] = {
   /*VPSCATTERDQ   */    {4723,4724,4722,},
   /*VSCATTERDPD   */    {3871,3872,3870,},
   };
   xed_uint8_t iclass_index = xed_encoder_get_iclasses_index_in_group(xes);
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[6], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 (xed3_operand_get_easz(xes) != 1) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_Q) &&
		 xed_encode_ntluf_MASKNOT0(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_XMM_R3(xes,xed3_operand_get_reg1(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][0]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_UISA_VMODRM_XMM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_64_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_GSCAT_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[6], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 1) &&
		 (xed3_operand_get_easz(xes) != 1) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_Q) &&
		 xed_encode_ntluf_MASKNOT0(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_YMM_R3(xes,xed3_operand_get_reg1(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][1]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_UISA_VMODRM_XMM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_64_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_GSCAT_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[6], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 2) &&
		 (xed3_operand_get_easz(xes) != 1) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_Q) &&
		 xed_encode_ntluf_MASKNOT0(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_ZMM_R3(xes,xed3_operand_get_reg1(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][2]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_UISA_VMODRM_YMM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_64_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_GSCAT_BIND(xes);
       if (okay) return 1;
   }
     }
   return 0;
   (void) okay;
   (void) conditions_satisfied;
   (void) xes;
}
xed_bool_t xed_encode_group_367(xed_encoder_request_t* xes)
{
   xed_bool_t okay=1;
   xed_bool_t conditions_satisfied=0;
   xed_ptrn_func_ptr_t fb_ptrn_function;
   static const xed_uint16_t iform_ids[2][2] = {
   /*CMPXCHG8B     */    {3884,3885,},
   /*CMPXCHG8B_LOCK*/    {6213,6214,},
   };
   xed_uint8_t iclass_index = xed_encoder_get_iclasses_index_in_group(xes);
   if (xes->_n_operand_order == 1 && xes->_operand_order[0] == XED_OPERAND_MEM0) {
   conditions_satisfied = (xed3_operand_get_mode(xes) != 2) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_Q);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][0]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_IMMUNE66_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 1 && xes->_operand_order[0] == XED_OPERAND_MEM0) {
   conditions_satisfied = (xed3_operand_get_mode(xes) == 2) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_Q);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][1]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_IMMUNE66_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay) return 1;
   }
     }
   return 0;
   (void) okay;
   (void) conditions_satisfied;
   (void) xes;
}
xed_bool_t xed_encode_group_368(xed_encoder_request_t* xes)
{
   xed_bool_t okay=1;
   xed_bool_t conditions_satisfied=0;
   xed_ptrn_func_ptr_t fb_ptrn_function;
   static const xed_uint16_t iform_ids[1][5] = {
   /*VMOVNTDQA     */    {3934,3935,3937,3938,3936,},
   };
   xed_uint8_t iclass_index = xed_encoder_get_iclasses_index_in_group(xes);
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_MEM0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 (xed3_operand_get_must_use_evex(xes) == 0) &&
		 xed_encode_ntluf_XMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_DQ);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][0]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_MEM0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 1) &&
		 (xed3_operand_get_must_use_evex(xes) == 0) &&
		 xed_encode_ntluf_YMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_QQ);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][1]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_MEM0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 xed_encode_ntluf_XMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_DQ);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][2]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_32_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_FULLMEM_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_MEM0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 1) &&
		 xed_encode_ntluf_YMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_QQ);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][3]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_32_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_FULLMEM_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_MEM0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 2) &&
		 xed_encode_ntluf_ZMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_ZD);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][4]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_32_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_FULLMEM_BIND(xes);
       if (okay) return 1;
   }
     }
   return 0;
   (void) okay;
   (void) conditions_satisfied;
   (void) xes;
}
xed_bool_t xed_encode_group_369(xed_encoder_request_t* xes)
{
   xed_bool_t okay=1;
   xed_bool_t conditions_satisfied=0;
   xed_ptrn_func_ptr_t fb_ptrn_function;
   static const xed_uint16_t iform_ids[2][10] = {
   /*VPMOVSXBQ     */    {3948,3950,3949,3951,3954,3956,3952,3955,3957,3953,},
   /*VPMOVZXBQ     */    {6225,6227,6226,6228,6231,6233,6229,6232,6234,6230,},
   };
   xed_uint8_t iclass_index = xed_encoder_get_iclasses_index_in_group(xes);
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_REG1) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 (xed3_operand_get_must_use_evex(xes) == 0) &&
		 xed_encode_ntluf_XMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_XMM_B(xes,xed3_operand_get_reg1(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][0]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_REG1) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 1) &&
		 (xed3_operand_get_must_use_evex(xes) == 0) &&
		 xed_encode_ntluf_YMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_XMM_B(xes,xed3_operand_get_reg1(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][1]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_MEM0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 (xed3_operand_get_must_use_evex(xes) == 0) &&
		 xed_encode_ntluf_XMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_W);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][2]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_MEM0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 1) &&
		 (xed3_operand_get_must_use_evex(xes) == 0) &&
		 xed_encode_ntluf_YMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_D);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][3]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[7], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 xed_encode_ntluf_XMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_XMM_B3(xes,xed3_operand_get_reg2(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][4]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[7], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 1) &&
		 xed_encode_ntluf_YMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_XMM_B3(xes,xed3_operand_get_reg2(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][5]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[7], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 2) &&
		 xed_encode_ntluf_ZMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_XMM_B3(xes,xed3_operand_get_reg2(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][6]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[14], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 xed_encode_ntluf_XMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_WRD);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][7]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_8_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_EIGHTHMEM_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[14], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 1) &&
		 xed_encode_ntluf_YMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_D);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][8]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_8_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_EIGHTHMEM_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[14], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 2) &&
		 xed_encode_ntluf_ZMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_Q);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][9]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_8_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_EIGHTHMEM_BIND(xes);
       if (okay) return 1;
   }
     }
   return 0;
   (void) okay;
   (void) conditions_satisfied;
   (void) xes;
}
xed_bool_t xed_encode_group_370(xed_encoder_request_t* xes)
{
   xed_bool_t okay=1;
   xed_bool_t conditions_satisfied=0;
   xed_ptrn_func_ptr_t fb_ptrn_function;
   static const xed_uint16_t iform_ids[2][20] = {
   /*VMOVAPS       */    {5557,5555,5561,5559,5556,5554,5560,5558,5568,5566,5572,5570,5564,5562,5569,5567,5573,5571,5565,5563,},
   /*VMOVUPS       */    {3993,3991,3997,3995,3992,3990,3996,3994,4004,4002,4008,4006,4000,3998,4005,4003,4009,4007,4001,3999,},
   };
   xed_uint8_t iclass_index = xed_encoder_get_iclasses_index_in_group(xes);
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_REG1) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 (xed3_operand_get_must_use_evex(xes) == 0) &&
		 xed_encode_ntluf_XMM_B(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_XMM_R(xes,xed3_operand_get_reg1(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][0]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_REG1) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 (xed3_operand_get_must_use_evex(xes) == 0) &&
		 xed_encode_ntluf_XMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_XMM_B(xes,xed3_operand_get_reg1(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][1]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_REG1) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 1) &&
		 (xed3_operand_get_must_use_evex(xes) == 0) &&
		 xed_encode_ntluf_YMM_B(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_YMM_R(xes,xed3_operand_get_reg1(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][2]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_REG1) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 1) &&
		 (xed3_operand_get_must_use_evex(xes) == 0) &&
		 xed_encode_ntluf_YMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_YMM_B(xes,xed3_operand_get_reg1(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][3]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_MEM0 && xes->_operand_order[1] == XED_OPERAND_REG0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 (xed3_operand_get_must_use_evex(xes) == 0) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_DQ) &&
		 xed_encode_ntluf_XMM_R(xes,xed3_operand_get_reg0(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][4]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_MEM0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 (xed3_operand_get_must_use_evex(xes) == 0) &&
		 xed_encode_ntluf_XMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_DQ);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][5]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_MEM0 && xes->_operand_order[1] == XED_OPERAND_REG0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 1) &&
		 (xed3_operand_get_must_use_evex(xes) == 0) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_QQ) &&
		 xed_encode_ntluf_YMM_R(xes,xed3_operand_get_reg0(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][6]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_MEM0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 1) &&
		 (xed3_operand_get_must_use_evex(xes) == 0) &&
		 xed_encode_ntluf_YMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_QQ);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][7]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[7], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 xed_encode_ntluf_XMM_B3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_XMM_R3(xes,xed3_operand_get_reg2(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][8]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[7], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 xed_encode_ntluf_XMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_XMM_B3(xes,xed3_operand_get_reg2(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][9]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[7], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 1) &&
		 xed_encode_ntluf_YMM_B3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_YMM_R3(xes,xed3_operand_get_reg2(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][10]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[7], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 1) &&
		 xed_encode_ntluf_YMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_YMM_B3(xes,xed3_operand_get_reg2(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][11]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[7], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 2) &&
		 xed_encode_ntluf_ZMM_B3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_ZMM_R3(xes,xed3_operand_get_reg2(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][12]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[7], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 2) &&
		 xed_encode_ntluf_ZMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_ZMM_B3(xes,xed3_operand_get_reg2(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][13]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[6], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_DQ) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_XMM_R3(xes,xed3_operand_get_reg1(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][14]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_32_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_FULLMEM_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[14], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 xed_encode_ntluf_XMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_DQ);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][15]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_32_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_FULLMEM_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[6], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 1) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_QQ) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_YMM_R3(xes,xed3_operand_get_reg1(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][16]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_32_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_FULLMEM_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[14], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 1) &&
		 xed_encode_ntluf_YMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_QQ);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][17]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_32_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_FULLMEM_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[6], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 2) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_ZD) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_ZMM_R3(xes,xed3_operand_get_reg1(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][18]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_32_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_FULLMEM_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[14], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 2) &&
		 xed_encode_ntluf_ZMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_ZD);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][19]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_32_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_FULLMEM_BIND(xes);
       if (okay) return 1;
   }
     }
   return 0;
   (void) okay;
   (void) conditions_satisfied;
   (void) xes;
}
xed_bool_t xed_encode_group_371(xed_encoder_request_t* xes)
{
   xed_bool_t okay=1;
   xed_bool_t conditions_satisfied=0;
   xed_ptrn_func_ptr_t fb_ptrn_function;
   static const xed_uint16_t iform_ids[1][4] = {
   /*VBROADCASTF32X2*/    {4020,4022,4021,4023,},
   };
   xed_uint8_t iclass_index = xed_encoder_get_iclasses_index_in_group(xes);
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[7], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 1) &&
		 xed_encode_ntluf_YMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_XMM_B3(xes,xed3_operand_get_reg2(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][0]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[7], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 2) &&
		 xed_encode_ntluf_ZMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_XMM_B3(xes,xed3_operand_get_reg2(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][1]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[14], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 1) &&
		 xed_encode_ntluf_YMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_Q);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][2]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_32_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_TUPLE2_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[14], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 2) &&
		 xed_encode_ntluf_ZMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_Q);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][3]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_32_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_TUPLE2_BIND(xes);
       if (okay) return 1;
   }
     }
   return 0;
   (void) okay;
   (void) conditions_satisfied;
   (void) xes;
}
xed_bool_t xed_encode_group_372(xed_encoder_request_t* xes)
{
   xed_bool_t okay=1;
   xed_bool_t conditions_satisfied=0;
   xed_ptrn_func_ptr_t fb_ptrn_function;
   static const xed_uint16_t iform_ids[1][6] = {
   /*VBROADCASTI32X2*/    {4026,4028,4030,4027,4029,4031,},
   };
   xed_uint8_t iclass_index = xed_encoder_get_iclasses_index_in_group(xes);
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[7], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 xed_encode_ntluf_XMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_XMM_B3(xes,xed3_operand_get_reg2(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][0]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[7], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 1) &&
		 xed_encode_ntluf_YMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_XMM_B3(xes,xed3_operand_get_reg2(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][1]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[7], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 2) &&
		 xed_encode_ntluf_ZMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_XMM_B3(xes,xed3_operand_get_reg2(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][2]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[14], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 xed_encode_ntluf_XMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_Q);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][3]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_32_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_TUPLE2_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[14], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 1) &&
		 xed_encode_ntluf_YMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_Q);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][4]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_32_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_TUPLE2_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[14], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 2) &&
		 xed_encode_ntluf_ZMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_Q);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][5]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_32_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_TUPLE2_BIND(xes);
       if (okay) return 1;
   }
     }
   return 0;
   (void) okay;
   (void) conditions_satisfied;
   (void) xes;
}
xed_bool_t xed_encode_group_373(xed_encoder_request_t* xes)
{
   xed_bool_t okay=1;
   xed_bool_t conditions_satisfied=0;
   xed_ptrn_func_ptr_t fb_ptrn_function;
   static const xed_uint16_t iform_ids[1][2] = {
   /*LSL           */    {4034,4033,},
   };
   xed_uint8_t iclass_index = xed_encoder_get_iclasses_index_in_group(xes);
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_REG1) {
   conditions_satisfied = xed_encode_ntluf_GPRv_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_GPRz_B(xes,xed3_operand_get_reg1(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][0]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_MEM0) {
   conditions_satisfied = xed_encode_ntluf_GPRv_R(xes,xed3_operand_get_reg0(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_W);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][1]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay) return 1;
   }
     }
   return 0;
   (void) okay;
   (void) conditions_satisfied;
   (void) xes;
}
xed_bool_t xed_encode_group_374(xed_encoder_request_t* xes)
{
   xed_bool_t okay=1;
   xed_bool_t conditions_satisfied=0;
   xed_ptrn_func_ptr_t fb_ptrn_function;
   static const xed_uint16_t iform_ids[2][10] = {
   /*VPMOVSXBD     */    {5969,5971,5970,5972,5975,5977,5973,5976,5978,5974,},
   /*VPMOVZXBD     */    {4035,4037,4036,4038,4041,4043,4039,4042,4044,4040,},
   };
   xed_uint8_t iclass_index = xed_encoder_get_iclasses_index_in_group(xes);
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_REG1) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 (xed3_operand_get_must_use_evex(xes) == 0) &&
		 xed_encode_ntluf_XMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_XMM_B(xes,xed3_operand_get_reg1(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][0]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_REG1) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 1) &&
		 (xed3_operand_get_must_use_evex(xes) == 0) &&
		 xed_encode_ntluf_YMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_XMM_B(xes,xed3_operand_get_reg1(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][1]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_MEM0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 (xed3_operand_get_must_use_evex(xes) == 0) &&
		 xed_encode_ntluf_XMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_D);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][2]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_MEM0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 1) &&
		 (xed3_operand_get_must_use_evex(xes) == 0) &&
		 xed_encode_ntluf_YMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_Q);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][3]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[7], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 xed_encode_ntluf_XMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_XMM_B3(xes,xed3_operand_get_reg2(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][4]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[7], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 1) &&
		 xed_encode_ntluf_YMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_XMM_B3(xes,xed3_operand_get_reg2(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][5]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[7], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 2) &&
		 xed_encode_ntluf_ZMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_XMM_B3(xes,xed3_operand_get_reg2(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][6]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[14], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 xed_encode_ntluf_XMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_D);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][7]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_8_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_QUARTERMEM_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[14], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 1) &&
		 xed_encode_ntluf_YMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_Q);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][8]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_8_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_QUARTERMEM_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[14], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 2) &&
		 xed_encode_ntluf_ZMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_DQ);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][9]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_8_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_QUARTERMEM_BIND(xes);
       if (okay) return 1;
   }
     }
   return 0;
   (void) okay;
   (void) conditions_satisfied;
   (void) xes;
}
xed_bool_t xed_encode_group_375(xed_encoder_request_t* xes)
{
   xed_bool_t okay=1;
   xed_bool_t conditions_satisfied=0;
   xed_ptrn_func_ptr_t fb_ptrn_function;
   static const xed_uint16_t iform_ids[4][2] = {
   /*LGDT          */    {5007,5006,},
   /*LIDT          */    {4120,4119,},
   /*SGDT          */    {5774,5773,},
   /*SIDT          */    {6044,6045,},
   };
   xed_uint8_t iclass_index = xed_encoder_get_iclasses_index_in_group(xes);
   if (xes->_n_operand_order == 1 && xes->_operand_order[0] == XED_OPERAND_MEM0) {
   conditions_satisfied = (xed3_operand_get_mode(xes) != 2) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_S);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][0]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 1 && xes->_operand_order[0] == XED_OPERAND_MEM0) {
   conditions_satisfied = (xed3_operand_get_mode(xes) == 2) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_S64);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][1]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_FORCE64_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay) return 1;
   }
     }
   return 0;
   (void) okay;
   (void) conditions_satisfied;
   (void) xes;
}
xed_bool_t xed_encode_group_376(xed_encoder_request_t* xes)
{
   xed_bool_t okay=1;
   xed_bool_t conditions_satisfied=0;
   xed_ptrn_func_ptr_t fb_ptrn_function;
   static const xed_uint16_t iform_ids[2][6] = {
   /*VPERMD        */    {6794,6793,6797,6795,6798,6796,},
   /*VPERMPS       */    {4136,4135,4139,4137,4140,4138,},
   };
   xed_uint8_t iclass_index = xed_encoder_get_iclasses_index_in_group(xes);
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[7], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 1) &&
		 (xed3_operand_get_must_use_evex(xes) == 0) &&
		 xed_encode_ntluf_YMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_YMM_N(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_YMM_B(xes,xed3_operand_get_reg2(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][0]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[14], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 1) &&
		 (xed3_operand_get_must_use_evex(xes) == 0) &&
		 xed_encode_ntluf_YMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_YMM_N(xes,xed3_operand_get_reg1(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_QQ);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][1]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 4 && memcmp(xed_encode_order[12], xes->_operand_order, sizeof(xed_uint8_t)*4)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 1) &&
		 xed_encode_ntluf_YMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_YMM_N3(xes,xed3_operand_get_reg2(xes)) &&
		 xed_encode_ntluf_YMM_B3(xes,xed3_operand_get_reg3(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][2]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 4 && memcmp(xed_encode_order[12], xes->_operand_order, sizeof(xed_uint8_t)*4)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 2) &&
		 xed_encode_ntluf_ZMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_ZMM_N3(xes,xed3_operand_get_reg2(xes)) &&
		 xed_encode_ntluf_ZMM_B3(xes,xed3_operand_get_reg3(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][3]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 4 && memcmp(xed_encode_order[13], xes->_operand_order, sizeof(xed_uint8_t)*4)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 1) &&
		 xed_encode_ntluf_YMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_YMM_N3(xes,xed3_operand_get_reg2(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_VV);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][4]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_32_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_FULL_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 4 && memcmp(xed_encode_order[13], xes->_operand_order, sizeof(xed_uint8_t)*4)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 2) &&
		 xed_encode_ntluf_ZMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_ZMM_N3(xes,xed3_operand_get_reg2(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_VV);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][5]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_32_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_FULL_BIND(xes);
       if (okay) return 1;
   }
     }
   return 0;
   (void) okay;
   (void) conditions_satisfied;
   (void) xes;
}
xed_bool_t xed_encode_group_377(xed_encoder_request_t* xes)
{
   xed_bool_t okay=1;
   xed_bool_t conditions_satisfied=0;
   xed_ptrn_func_ptr_t fb_ptrn_function;
   static const xed_uint16_t iform_ids[1][4] = {
   /*VPEXTRQ       */    {4189,4188,4190,4191,},
   };
   xed_uint8_t iclass_index = xed_encoder_get_iclasses_index_in_group(xes);
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[15], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 (xed3_operand_get_mode(xes) == 2) &&
		 (xed3_operand_get_must_use_evex(xes) == 0) &&
		 xed_encode_ntluf_GPR64_B(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_XMM_R(xes,xed3_operand_get_reg1(xes)) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][0]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_UIMM8_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[17], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 (xed3_operand_get_mode(xes) == 2) &&
		 (xed3_operand_get_must_use_evex(xes) == 0) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_Q) &&
		 xed_encode_ntluf_XMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][1]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_UIMM8_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[15], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 (xed3_operand_get_mode(xes) == 2) &&
		 xed_encode_ntluf_GPR64_B(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_XMM_R3(xes,xed3_operand_get_reg1(xes)) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][2]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_UIMM8_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[17], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 (xed3_operand_get_mode(xes) == 2) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_Q) &&
		 xed_encode_ntluf_XMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][3]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_UIMM8_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_64_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_GPR_WRITER_STORE_BIND(xes);
       if (okay) return 1;
   }
     }
   return 0;
   (void) okay;
   (void) conditions_satisfied;
   (void) xes;
}
xed_bool_t xed_encode_group_378(xed_encoder_request_t* xes)
{
   xed_bool_t okay=1;
   xed_bool_t conditions_satisfied=0;
   xed_ptrn_func_ptr_t fb_ptrn_function;
   static const xed_uint16_t iform_ids[3][18] = {
   /*VPSLLW        */    {6188,6191,6189,6187,6192,6190,6193,6197,6201,6195,6199,6203,6194,6198,6202,6196,6200,6204,},
   /*VPSRAW        */    {4633,4636,4634,4632,4637,4635,4638,4642,4646,4640,4644,4648,4639,4643,4647,4641,4645,4649,},
   /*VPSRLW        */    {4193,4196,4194,4192,4197,4195,4198,4202,4206,4200,4204,4208,4199,4203,4207,4201,4205,4209,},
   };
   xed_uint8_t iclass_index = xed_encoder_get_iclasses_index_in_group(xes);
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[7], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 (xed3_operand_get_must_use_evex(xes) == 0) &&
		 xed_encode_ntluf_XMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_XMM_N(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_XMM_B(xes,xed3_operand_get_reg2(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][0]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[7], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 1) &&
		 (xed3_operand_get_must_use_evex(xes) == 0) &&
		 xed_encode_ntluf_YMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_YMM_N(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_XMM_B(xes,xed3_operand_get_reg2(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][1]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[15], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 (xed3_operand_get_must_use_evex(xes) == 0) &&
		 xed_encode_ntluf_XMM_N(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_XMM_B(xes,xed3_operand_get_reg1(xes)) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][2]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_UIMM8_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[14], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 (xed3_operand_get_must_use_evex(xes) == 0) &&
		 xed_encode_ntluf_XMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_XMM_N(xes,xed3_operand_get_reg1(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_DQ);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][3]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[15], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 1) &&
		 (xed3_operand_get_must_use_evex(xes) == 0) &&
		 xed_encode_ntluf_YMM_N(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_YMM_B(xes,xed3_operand_get_reg1(xes)) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][4]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_UIMM8_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[14], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 1) &&
		 (xed3_operand_get_must_use_evex(xes) == 0) &&
		 xed_encode_ntluf_YMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_YMM_N(xes,xed3_operand_get_reg1(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_DQ);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][5]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 4 && memcmp(xed_encode_order[12], xes->_operand_order, sizeof(xed_uint8_t)*4)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 xed_encode_ntluf_XMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_XMM_N3(xes,xed3_operand_get_reg2(xes)) &&
		 xed_encode_ntluf_XMM_B3(xes,xed3_operand_get_reg3(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][6]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 4 && memcmp(xed_encode_order[12], xes->_operand_order, sizeof(xed_uint8_t)*4)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 1) &&
		 xed_encode_ntluf_YMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_YMM_N3(xes,xed3_operand_get_reg2(xes)) &&
		 xed_encode_ntluf_XMM_B3(xes,xed3_operand_get_reg3(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][7]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 4 && memcmp(xed_encode_order[12], xes->_operand_order, sizeof(xed_uint8_t)*4)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 2) &&
		 xed_encode_ntluf_ZMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_ZMM_N3(xes,xed3_operand_get_reg2(xes)) &&
		 xed_encode_ntluf_XMM_B3(xes,xed3_operand_get_reg3(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][8]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 4 && memcmp(xed_encode_order[21], xes->_operand_order, sizeof(xed_uint8_t)*4)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 xed_encode_ntluf_XMM_N3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_XMM_B3(xes,xed3_operand_get_reg2(xes)) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][9]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_UIMM8_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 4 && memcmp(xed_encode_order[21], xes->_operand_order, sizeof(xed_uint8_t)*4)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 1) &&
		 xed_encode_ntluf_YMM_N3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_YMM_B3(xes,xed3_operand_get_reg2(xes)) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][10]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_UIMM8_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 4 && memcmp(xed_encode_order[21], xes->_operand_order, sizeof(xed_uint8_t)*4)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 2) &&
		 xed_encode_ntluf_ZMM_N3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_ZMM_B3(xes,xed3_operand_get_reg2(xes)) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][11]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_UIMM8_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 4 && memcmp(xed_encode_order[13], xes->_operand_order, sizeof(xed_uint8_t)*4)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 xed_encode_ntluf_XMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_XMM_N3(xes,xed3_operand_get_reg2(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_DQ);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][12]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_16_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_MEM128_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 4 && memcmp(xed_encode_order[13], xes->_operand_order, sizeof(xed_uint8_t)*4)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 1) &&
		 xed_encode_ntluf_YMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_YMM_N3(xes,xed3_operand_get_reg2(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_DQ);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][13]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_16_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_MEM128_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 4 && memcmp(xed_encode_order[13], xes->_operand_order, sizeof(xed_uint8_t)*4)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 2) &&
		 xed_encode_ntluf_ZMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_ZMM_N3(xes,xed3_operand_get_reg2(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_DQ);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][14]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_16_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_MEM128_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 4 && memcmp(xed_encode_order[22], xes->_operand_order, sizeof(xed_uint8_t)*4)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 xed_encode_ntluf_XMM_N3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_DQ) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][15]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_UIMM8_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_16_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_FULLMEM_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 4 && memcmp(xed_encode_order[22], xes->_operand_order, sizeof(xed_uint8_t)*4)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 1) &&
		 xed_encode_ntluf_YMM_N3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_QQ) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][16]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_UIMM8_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_16_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_FULLMEM_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 4 && memcmp(xed_encode_order[22], xes->_operand_order, sizeof(xed_uint8_t)*4)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 2) &&
		 xed_encode_ntluf_ZMM_N3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_ZD) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][17]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_UIMM8_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_16_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_FULLMEM_BIND(xes);
       if (okay) return 1;
   }
     }
   return 0;
   (void) okay;
   (void) conditions_satisfied;
   (void) xes;
}
xed_bool_t xed_encode_group_379(xed_encoder_request_t* xes)
{
   xed_bool_t okay=1;
   xed_bool_t conditions_satisfied=0;
   xed_ptrn_func_ptr_t fb_ptrn_function;
   static const xed_uint16_t iform_ids[1][10] = {
   /*VPCLMULQDQ    */    {4211,4219,4212,4220,4213,4215,4217,4214,4216,4218,},
   };
   xed_uint8_t iclass_index = xed_encoder_get_iclasses_index_in_group(xes);
   if (xes->_n_operand_order == 4 && memcmp(xed_encode_order[21], xes->_operand_order, sizeof(xed_uint8_t)*4)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 (xed3_operand_get_must_use_evex(xes) == 0) &&
		 xed_encode_ntluf_XMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_XMM_N(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_XMM_B(xes,xed3_operand_get_reg2(xes)) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][0]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_UIMM8_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 4 && memcmp(xed_encode_order[21], xes->_operand_order, sizeof(xed_uint8_t)*4)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 1) &&
		 (xed3_operand_get_must_use_evex(xes) == 0) &&
		 xed_encode_ntluf_YMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_YMM_N(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_YMM_B(xes,xed3_operand_get_reg2(xes)) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][1]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_UIMM8_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 4 && memcmp(xed_encode_order[22], xes->_operand_order, sizeof(xed_uint8_t)*4)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 (xed3_operand_get_must_use_evex(xes) == 0) &&
		 xed_encode_ntluf_XMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_XMM_N(xes,xed3_operand_get_reg1(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_DQ) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][2]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_UIMM8_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 4 && memcmp(xed_encode_order[22], xes->_operand_order, sizeof(xed_uint8_t)*4)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 1) &&
		 (xed3_operand_get_must_use_evex(xes) == 0) &&
		 xed_encode_ntluf_YMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_YMM_N(xes,xed3_operand_get_reg1(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_QQ) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][3]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_UIMM8_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 4 && memcmp(xed_encode_order[21], xes->_operand_order, sizeof(xed_uint8_t)*4)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 xed_encode_ntluf_XMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_XMM_N3(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_XMM_B3(xes,xed3_operand_get_reg2(xes)) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][4]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_UIMM8_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 4 && memcmp(xed_encode_order[21], xes->_operand_order, sizeof(xed_uint8_t)*4)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 1) &&
		 xed_encode_ntluf_YMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_YMM_N3(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_YMM_B3(xes,xed3_operand_get_reg2(xes)) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][5]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_UIMM8_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 4 && memcmp(xed_encode_order[21], xes->_operand_order, sizeof(xed_uint8_t)*4)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 2) &&
		 xed_encode_ntluf_ZMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_ZMM_N3(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_ZMM_B3(xes,xed3_operand_get_reg2(xes)) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][6]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_UIMM8_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 4 && memcmp(xed_encode_order[22], xes->_operand_order, sizeof(xed_uint8_t)*4)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 xed_encode_ntluf_XMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_XMM_N3(xes,xed3_operand_get_reg1(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_DQ) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][7]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_UIMM8_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_64_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_FULLMEM_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 4 && memcmp(xed_encode_order[22], xes->_operand_order, sizeof(xed_uint8_t)*4)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 1) &&
		 xed_encode_ntluf_YMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_YMM_N3(xes,xed3_operand_get_reg1(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_QQ) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][8]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_UIMM8_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_64_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_FULLMEM_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 4 && memcmp(xed_encode_order[22], xes->_operand_order, sizeof(xed_uint8_t)*4)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 2) &&
		 xed_encode_ntluf_ZMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_ZMM_N3(xes,xed3_operand_get_reg1(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_ZD) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][9]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_UIMM8_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_64_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_FULLMEM_BIND(xes);
       if (okay) return 1;
   }
     }
   return 0;
   (void) okay;
   (void) conditions_satisfied;
   (void) xes;
}
xed_bool_t xed_encode_group_380(xed_encoder_request_t* xes)
{
   xed_bool_t okay=1;
   xed_bool_t conditions_satisfied=0;
   xed_ptrn_func_ptr_t fb_ptrn_function;
   static const xed_uint16_t iform_ids[2][2] = {
   /*VBROADCASTF64X2*/    {5100,5101,},
   /*VBROADCASTI64X2*/    {4243,4244,},
   };
   xed_uint8_t iclass_index = xed_encoder_get_iclasses_index_in_group(xes);
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[14], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 1) &&
		 xed_encode_ntluf_YMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_DQ);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][0]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_64_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_TUPLE2_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[14], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 2) &&
		 xed_encode_ntluf_ZMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_DQ);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][1]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_64_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_TUPLE2_BIND(xes);
       if (okay) return 1;
   }
     }
   return 0;
   (void) okay;
   (void) conditions_satisfied;
   (void) xes;
}
xed_bool_t xed_encode_group_381(xed_encoder_request_t* xes)
{
   xed_bool_t okay=1;
   xed_bool_t conditions_satisfied=0;
   xed_ptrn_func_ptr_t fb_ptrn_function;
   static const xed_uint16_t iform_ids[1][10] = {
   /*VCVTDQ2PD     */    {4250,4252,4249,4251,4255,4257,4253,4256,4258,4254,},
   };
   xed_uint8_t iclass_index = xed_encoder_get_iclasses_index_in_group(xes);
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_REG1) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 (xed3_operand_get_must_use_evex(xes) == 0) &&
		 xed_encode_ntluf_XMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_XMM_B(xes,xed3_operand_get_reg1(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][0]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_REG1) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 1) &&
		 (xed3_operand_get_must_use_evex(xes) == 0) &&
		 xed_encode_ntluf_YMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_XMM_B(xes,xed3_operand_get_reg1(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][1]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_MEM0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 (xed3_operand_get_must_use_evex(xes) == 0) &&
		 xed_encode_ntluf_XMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_Q);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][2]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_MEM0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 1) &&
		 (xed3_operand_get_must_use_evex(xes) == 0) &&
		 xed_encode_ntluf_YMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_DQ);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][3]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[7], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 xed_encode_ntluf_XMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_XMM_B3(xes,xed3_operand_get_reg2(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][4]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[7], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 1) &&
		 xed_encode_ntluf_YMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_XMM_B3(xes,xed3_operand_get_reg2(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][5]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[7], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 2) &&
		 xed_encode_ntluf_ZMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_YMM_B3(xes,xed3_operand_get_reg2(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][6]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[14], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 xed_encode_ntluf_XMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_VV);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][7]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_32_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_HALF_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[14], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 1) &&
		 xed_encode_ntluf_YMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_VV);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][8]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_32_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_HALF_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[14], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 2) &&
		 xed_encode_ntluf_ZMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_VV);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][9]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_32_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_HALF_BIND(xes);
       if (okay) return 1;
   }
     }
   return 0;
   (void) okay;
   (void) conditions_satisfied;
   (void) xes;
}
xed_bool_t xed_encode_group_382(xed_encoder_request_t* xes)
{
   xed_bool_t okay=1;
   xed_bool_t conditions_satisfied=0;
   xed_ptrn_func_ptr_t fb_ptrn_function;
   static const xed_uint16_t iform_ids[2][6] = {
   /*VPTESTMW      */    {4449,4451,4453,4450,4452,4454,},
   /*VPTESTNMW     */    {4282,4284,4286,4283,4285,4287,},
   };
   xed_uint8_t iclass_index = xed_encoder_get_iclasses_index_in_group(xes);
   if (xes->_n_operand_order == 4 && memcmp(xed_encode_order[12], xes->_operand_order, sizeof(xed_uint8_t)*4)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 xed_encode_ntluf_MASK_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_XMM_N3(xes,xed3_operand_get_reg2(xes)) &&
		 xed_encode_ntluf_XMM_B3(xes,xed3_operand_get_reg3(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][0]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 4 && memcmp(xed_encode_order[12], xes->_operand_order, sizeof(xed_uint8_t)*4)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 1) &&
		 xed_encode_ntluf_MASK_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_YMM_N3(xes,xed3_operand_get_reg2(xes)) &&
		 xed_encode_ntluf_YMM_B3(xes,xed3_operand_get_reg3(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][1]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 4 && memcmp(xed_encode_order[12], xes->_operand_order, sizeof(xed_uint8_t)*4)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 2) &&
		 xed_encode_ntluf_MASK_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_ZMM_N3(xes,xed3_operand_get_reg2(xes)) &&
		 xed_encode_ntluf_ZMM_B3(xes,xed3_operand_get_reg3(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][2]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 4 && memcmp(xed_encode_order[13], xes->_operand_order, sizeof(xed_uint8_t)*4)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 xed_encode_ntluf_MASK_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_XMM_N3(xes,xed3_operand_get_reg2(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_DQ);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][3]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_16_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_FULLMEM_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 4 && memcmp(xed_encode_order[13], xes->_operand_order, sizeof(xed_uint8_t)*4)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 1) &&
		 xed_encode_ntluf_MASK_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_YMM_N3(xes,xed3_operand_get_reg2(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_QQ);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][4]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_16_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_FULLMEM_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 4 && memcmp(xed_encode_order[13], xes->_operand_order, sizeof(xed_uint8_t)*4)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 2) &&
		 xed_encode_ntluf_MASK_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_ZMM_N3(xes,xed3_operand_get_reg2(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_ZD);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][5]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_16_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_FULLMEM_BIND(xes);
       if (okay) return 1;
   }
     }
   return 0;
   (void) okay;
   (void) conditions_satisfied;
   (void) xes;
}
xed_bool_t xed_encode_group_383(xed_encoder_request_t* xes)
{
   xed_bool_t okay=1;
   xed_bool_t conditions_satisfied=0;
   xed_ptrn_func_ptr_t fb_ptrn_function;
   static const xed_uint16_t iform_ids[1][9] = {
   /*VCVTSS2USI    */    {4292,4293,4297,4290,4291,4296,4294,4295,4298,},
   };
   xed_uint8_t iclass_index = xed_encoder_get_iclasses_index_in_group(xes);
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_REG1) {
   conditions_satisfied = (xed3_operand_get_roundc(xes) != 0) &&
		 (xed3_operand_get_mode(xes) != 2) &&
		 xed_encode_ntluf_GPR32_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_XMM_B3(xes,xed3_operand_get_reg1(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][0]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_FIX_ROUND_LEN128_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_AVX512_ROUND_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_REG1) {
   conditions_satisfied = (xed3_operand_get_roundc(xes) != 0) &&
		 (xed3_operand_get_mode(xes) == 2) &&
		 xed_encode_ntluf_GPR32_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_XMM_B3(xes,xed3_operand_get_reg1(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][1]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_FIX_ROUND_LEN128_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_AVX512_ROUND_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_REG1) {
   conditions_satisfied = (xed3_operand_get_roundc(xes) != 0) &&
		 (xed3_operand_get_mode(xes) == 2) &&
		 xed_encode_ntluf_GPR64_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_XMM_B3(xes,xed3_operand_get_reg1(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][2]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_FIX_ROUND_LEN128_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_AVX512_ROUND_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_REG1) {
   conditions_satisfied = (xed3_operand_get_mode(xes) != 2) &&
		 xed_encode_ntluf_GPR32_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_XMM_B3(xes,xed3_operand_get_reg1(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][3]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_FIX_ROUND_LEN128_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_REG1) {
   conditions_satisfied = (xed3_operand_get_mode(xes) == 2) &&
		 xed_encode_ntluf_GPR32_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_XMM_B3(xes,xed3_operand_get_reg1(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][4]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_FIX_ROUND_LEN128_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_REG1) {
   conditions_satisfied = (xed3_operand_get_mode(xes) == 2) &&
		 xed_encode_ntluf_GPR64_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_XMM_B3(xes,xed3_operand_get_reg1(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][5]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_FIX_ROUND_LEN128_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_MEM0) {
   conditions_satisfied = (xed3_operand_get_mode(xes) != 2) &&
		 xed_encode_ntluf_GPR32_R(xes,xed3_operand_get_reg0(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_D);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][6]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_32_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_GPR_WRITER_LDOP_D_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_FIX_ROUND_LEN128_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_MEM0) {
   conditions_satisfied = (xed3_operand_get_mode(xes) == 2) &&
		 xed_encode_ntluf_GPR32_R(xes,xed3_operand_get_reg0(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_D);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][7]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_32_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_GPR_WRITER_LDOP_D_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_FIX_ROUND_LEN128_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_MEM0) {
   conditions_satisfied = (xed3_operand_get_mode(xes) == 2) &&
		 xed_encode_ntluf_GPR64_R(xes,xed3_operand_get_reg0(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_D);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][8]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_32_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_GPR_WRITER_LDOP_D_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_FIX_ROUND_LEN128_BIND(xes);
       if (okay) return 1;
   }
     }
   return 0;
   (void) okay;
   (void) conditions_satisfied;
   (void) xes;
}
xed_bool_t xed_encode_group_384(xed_encoder_request_t* xes)
{
   xed_bool_t okay=1;
   xed_bool_t conditions_satisfied=0;
   xed_ptrn_func_ptr_t fb_ptrn_function;
   static const xed_uint16_t iform_ids[2][2] = {
   /*PSHUFHW       */    {4529,4528,},
   /*PSHUFLW       */    {4300,4299,},
   };
   xed_uint8_t iclass_index = xed_encoder_get_iclasses_index_in_group(xes);
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[15], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = xed_encode_ntluf_XMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_XMM_B(xes,xed3_operand_get_reg1(xes)) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][0]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_IGNORE66_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_UIMM8_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[20], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = xed_encode_ntluf_XMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_DQ) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][1]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_IGNORE66_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_UIMM8_BIND(xes);
       if (okay) return 1;
   }
     }
   return 0;
   (void) okay;
   (void) conditions_satisfied;
   (void) xes;
}
xed_bool_t xed_encode_group_385(xed_encoder_request_t* xes)
{
   xed_bool_t okay=1;
   xed_bool_t conditions_satisfied=0;
   xed_ptrn_func_ptr_t fb_ptrn_function;
   static const xed_uint16_t iform_ids[1][4] = {
   /*VPPERM        */    {4315,4317,4314,4316,},
   };
   xed_uint8_t iclass_index = xed_encoder_get_iclasses_index_in_group(xes);
   if (xes->_n_operand_order == 4 && memcmp(xed_encode_order[12], xes->_operand_order, sizeof(xed_uint8_t)*4)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 xed_encode_ntluf_XMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_XMM_N(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_XMM_B(xes,xed3_operand_get_reg2(xes)) &&
		 xed_encode_ntluf_XMM_SE(xes,xed3_operand_get_reg3(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][0]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_SE_IMM8_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 4 && memcmp(xed_encode_order[12], xes->_operand_order, sizeof(xed_uint8_t)*4)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 xed_encode_ntluf_XMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_XMM_N(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_XMM_SE(xes,xed3_operand_get_reg2(xes)) &&
		 xed_encode_ntluf_XMM_B(xes,xed3_operand_get_reg3(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][1]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_SE_IMM8_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 4 && memcmp(xed_encode_order[11], xes->_operand_order, sizeof(xed_uint8_t)*4)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 xed_encode_ntluf_XMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_XMM_N(xes,xed3_operand_get_reg1(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_DQ) &&
		 xed_encode_ntluf_XMM_SE(xes,xed3_operand_get_reg2(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][2]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_SE_IMM8_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 4 && memcmp(xed_encode_order[13], xes->_operand_order, sizeof(xed_uint8_t)*4)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 xed_encode_ntluf_XMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_XMM_N(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_XMM_SE(xes,xed3_operand_get_reg2(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_DQ);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][3]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_SE_IMM8_BIND(xes);
       if (okay) return 1;
   }
     }
   return 0;
   (void) okay;
   (void) conditions_satisfied;
   (void) xes;
}
xed_bool_t xed_encode_group_386(xed_encoder_request_t* xes)
{
   xed_bool_t okay=1;
   xed_bool_t conditions_satisfied=0;
   xed_ptrn_func_ptr_t fb_ptrn_function;
   static const xed_uint16_t iform_ids[2][1] = {
   /*CMPXCHG16B    */    {6096,},
   /*CMPXCHG16B_LOCK*/    {4318,},
   };
   xed_uint8_t iclass_index = xed_encoder_get_iclasses_index_in_group(xes);
   if (xes->_n_operand_order == 1 && xes->_operand_order[0] == XED_OPERAND_MEM0) {
   conditions_satisfied = (xed3_operand_get_mode(xes) == 2) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_DQ);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][0]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_IMMUNE66_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay) return 1;
   }
     }
   return 0;
   (void) okay;
   (void) conditions_satisfied;
   (void) xes;
}
xed_bool_t xed_encode_group_387(xed_encoder_request_t* xes)
{
   xed_bool_t okay=1;
   xed_bool_t conditions_satisfied=0;
   xed_ptrn_func_ptr_t fb_ptrn_function;
   static const xed_uint16_t iform_ids[1][2] = {
   /*JECXZ         */    {4325,4326,},
   };
   xed_uint8_t iclass_index = xed_encoder_get_iclasses_index_in_group(xes);
   if (xes->_n_operand_order == 1 && xes->_operand_order[0] == XED_OPERAND_RELBR) {
   conditions_satisfied = (xed3_operand_get_easz(xes) == 2) &&
		 (xed3_operand_get_mode(xes) != 2) &&
		 (xed3_operand_get_relbr(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][0]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_BRDISP8_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 1 && xes->_operand_order[0] == XED_OPERAND_RELBR) {
   conditions_satisfied = (xed3_operand_get_easz(xes) == 2) &&
		 (xed3_operand_get_mode(xes) == 2) &&
		 (xed3_operand_get_relbr(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][1]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_BRDISP8_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_FORCE64_BIND(xes);
       if (okay) return 1;
   }
     }
   return 0;
   (void) okay;
   (void) conditions_satisfied;
   (void) xes;
}
xed_bool_t xed_encode_group_388(xed_encoder_request_t* xes)
{
   xed_bool_t okay=1;
   xed_bool_t conditions_satisfied=0;
   xed_ptrn_func_ptr_t fb_ptrn_function;
   static const xed_uint16_t iform_ids[1][9] = {
   /*VCVTTSS2USI   */    {4330,4331,4335,4328,4329,4334,4332,4333,4336,},
   };
   xed_uint8_t iclass_index = xed_encoder_get_iclasses_index_in_group(xes);
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_REG1) {
   conditions_satisfied = (xed3_operand_get_sae(xes) != 0) &&
		 (xed3_operand_get_mode(xes) != 2) &&
		 xed_encode_ntluf_GPR32_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_XMM_B3(xes,xed3_operand_get_reg1(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][0]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_FIX_ROUND_LEN128_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_SAE_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_REG1) {
   conditions_satisfied = (xed3_operand_get_sae(xes) != 0) &&
		 (xed3_operand_get_mode(xes) == 2) &&
		 xed_encode_ntluf_GPR32_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_XMM_B3(xes,xed3_operand_get_reg1(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][1]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_FIX_ROUND_LEN128_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_SAE_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_REG1) {
   conditions_satisfied = (xed3_operand_get_sae(xes) != 0) &&
		 (xed3_operand_get_mode(xes) == 2) &&
		 xed_encode_ntluf_GPR64_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_XMM_B3(xes,xed3_operand_get_reg1(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][2]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_FIX_ROUND_LEN128_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_SAE_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_REG1) {
   conditions_satisfied = (xed3_operand_get_mode(xes) != 2) &&
		 xed_encode_ntluf_GPR32_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_XMM_B3(xes,xed3_operand_get_reg1(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][3]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_FIX_ROUND_LEN128_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_REG1) {
   conditions_satisfied = (xed3_operand_get_mode(xes) == 2) &&
		 xed_encode_ntluf_GPR32_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_XMM_B3(xes,xed3_operand_get_reg1(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][4]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_FIX_ROUND_LEN128_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_REG1) {
   conditions_satisfied = (xed3_operand_get_mode(xes) == 2) &&
		 xed_encode_ntluf_GPR64_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_XMM_B3(xes,xed3_operand_get_reg1(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][5]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_FIX_ROUND_LEN128_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_MEM0) {
   conditions_satisfied = (xed3_operand_get_mode(xes) != 2) &&
		 xed_encode_ntluf_GPR32_R(xes,xed3_operand_get_reg0(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_D);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][6]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_32_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_GPR_WRITER_LDOP_D_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_FIX_ROUND_LEN128_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_MEM0) {
   conditions_satisfied = (xed3_operand_get_mode(xes) == 2) &&
		 xed_encode_ntluf_GPR32_R(xes,xed3_operand_get_reg0(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_D);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][7]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_32_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_GPR_WRITER_LDOP_D_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_FIX_ROUND_LEN128_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_MEM0) {
   conditions_satisfied = (xed3_operand_get_mode(xes) == 2) &&
		 xed_encode_ntluf_GPR64_R(xes,xed3_operand_get_reg0(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_D);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][8]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_32_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_GPR_WRITER_LDOP_D_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_FIX_ROUND_LEN128_BIND(xes);
       if (okay) return 1;
   }
     }
   return 0;
   (void) okay;
   (void) conditions_satisfied;
   (void) xes;
}
xed_bool_t xed_encode_group_389(xed_encoder_request_t* xes)
{
   xed_bool_t okay=1;
   xed_bool_t conditions_satisfied=0;
   xed_ptrn_func_ptr_t fb_ptrn_function;
   static const xed_uint16_t iform_ids[1][4] = {
   /*VMREAD        */    {4340,4338,4339,4337,},
   };
   xed_uint8_t iclass_index = xed_encoder_get_iclasses_index_in_group(xes);
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_REG1) {
   conditions_satisfied = (xed3_operand_get_mode(xes) != 2) &&
		 xed_encode_ntluf_GPR32_B(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_GPR32_R(xes,xed3_operand_get_reg1(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][0]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_CR_WIDTH_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_REG1) {
   conditions_satisfied = (xed3_operand_get_mode(xes) == 2) &&
		 xed_encode_ntluf_GPR64_B(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_GPR64_R(xes,xed3_operand_get_reg1(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][1]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_CR_WIDTH_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_MEM0 && xes->_operand_order[1] == XED_OPERAND_REG0) {
   conditions_satisfied = (xed3_operand_get_mode(xes) != 2) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_D) &&
		 xed_encode_ntluf_GPR32_R(xes,xed3_operand_get_reg0(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][2]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_CR_WIDTH_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_MEM0 && xes->_operand_order[1] == XED_OPERAND_REG0) {
   conditions_satisfied = (xed3_operand_get_mode(xes) == 2) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_Q) &&
		 xed_encode_ntluf_GPR64_R(xes,xed3_operand_get_reg0(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][3]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_CR_WIDTH_BIND(xes);
       if (okay) return 1;
   }
     }
   return 0;
   (void) okay;
   (void) conditions_satisfied;
   (void) xes;
}
xed_bool_t xed_encode_group_390(xed_encoder_request_t* xes)
{
   xed_bool_t okay=1;
   xed_bool_t conditions_satisfied=0;
   xed_ptrn_func_ptr_t fb_ptrn_function;
   static const xed_uint16_t iform_ids[1][4] = {
   /*OUT           */    {4343,4341,4344,4342,},
   };
   xed_uint8_t iclass_index = xed_encoder_get_iclasses_index_in_group(xes);
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_REG1) {
   conditions_satisfied = (xed3_operand_get_reg0(xes) == XED_REG_DX) &&
		 (xed3_operand_get_reg1(xes) == XED_REG_AL);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][0]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_IMM0 && xes->_operand_order[1] == XED_OPERAND_REG0) {
   conditions_satisfied = (xed3_operand_get_imm0(xes) == 1) &&
		 (xed3_operand_get_reg0(xes) == XED_REG_AL);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][1]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_UIMM8_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_REG1) {
   conditions_satisfied = (xed3_operand_get_reg0(xes) == XED_REG_DX) &&
		 xed_encode_ntluf_OeAX(xes,xed3_operand_get_reg1(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][2]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_IMMUNE_REXW_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_IMM0 && xes->_operand_order[1] == XED_OPERAND_REG0) {
   conditions_satisfied = (xed3_operand_get_imm0(xes) == 1) &&
		 xed_encode_ntluf_OeAX(xes,xed3_operand_get_reg0(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][3]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_UIMM8_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_IMMUNE_REXW_BIND(xes);
       if (okay) return 1;
   }
     }
   return 0;
   (void) okay;
   (void) conditions_satisfied;
   (void) xes;
}
xed_bool_t xed_encode_group_391(xed_encoder_request_t* xes)
{
   xed_bool_t okay=1;
   xed_bool_t conditions_satisfied=0;
   xed_ptrn_func_ptr_t fb_ptrn_function;
   static const xed_uint16_t iform_ids[1][8] = {
   /*XCHG          */    {4368,4369,4364,4367,4362,4363,4365,4366,},
   };
   xed_uint8_t iclass_index = xed_encoder_get_iclasses_index_in_group(xes);
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_REG1) {
   conditions_satisfied = xed_encode_ntluf_GPRv_SB(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_OrAX(xes,xed3_operand_get_reg1(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][0]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_REG1) {
   conditions_satisfied = xed_encode_ntluf_GPRv_SB(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_OrAX(xes,xed3_operand_get_reg1(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][1]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_REG1) {
   conditions_satisfied = xed_encode_ntluf_GPR8_B(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_GPR8_R(xes,xed3_operand_get_reg1(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][2]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_REG1) {
   conditions_satisfied = xed_encode_ntluf_GPRv_B(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_GPRv_R(xes,xed3_operand_get_reg1(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][3]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_MEM0 && xes->_operand_order[1] == XED_OPERAND_REG0) {
   conditions_satisfied = (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_B) &&
		 xed_encode_ntluf_GPR8_R(xes,xed3_operand_get_reg0(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][4]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_MEM0 && xes->_operand_order[1] == XED_OPERAND_REG0) {
   conditions_satisfied = (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_B) &&
		 xed_encode_ntluf_GPR8_R(xes,xed3_operand_get_reg0(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][5]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_MEM0 && xes->_operand_order[1] == XED_OPERAND_REG0) {
   conditions_satisfied = (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_V) &&
		 xed_encode_ntluf_GPRv_R(xes,xed3_operand_get_reg0(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][6]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_MEM0 && xes->_operand_order[1] == XED_OPERAND_REG0) {
   conditions_satisfied = (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_V) &&
		 xed_encode_ntluf_GPRv_R(xes,xed3_operand_get_reg0(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][7]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay) return 1;
   }
     }
   return 0;
   (void) okay;
   (void) conditions_satisfied;
   (void) xes;
}
xed_bool_t xed_encode_group_392(xed_encoder_request_t* xes)
{
   xed_bool_t okay=1;
   xed_bool_t conditions_satisfied=0;
   xed_ptrn_func_ptr_t fb_ptrn_function;
   static const xed_uint16_t iform_ids[1][16] = {
   /*VMOVQ         */    {4373,4371,4377,4375,4372,4370,4376,4374,4380,4378,4384,4382,4385,4381,4379,4383,},
   };
   xed_uint8_t iclass_index = xed_encoder_get_iclasses_index_in_group(xes);
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_REG1) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 (xed3_operand_get_mode(xes) == 2) &&
		 (xed3_operand_get_must_use_evex(xes) == 0) &&
		 xed_encode_ntluf_GPR64_B(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_XMM_R(xes,xed3_operand_get_reg1(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][0]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_REG1) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 (xed3_operand_get_mode(xes) == 2) &&
		 (xed3_operand_get_must_use_evex(xes) == 0) &&
		 xed_encode_ntluf_XMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_GPR64_B(xes,xed3_operand_get_reg1(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][1]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_REG1) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 (xed3_operand_get_must_use_evex(xes) == 0) &&
		 xed_encode_ntluf_XMM_B(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_XMM_R(xes,xed3_operand_get_reg1(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][2]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_REG1) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 (xed3_operand_get_must_use_evex(xes) == 0) &&
		 xed_encode_ntluf_XMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_XMM_B(xes,xed3_operand_get_reg1(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][3]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_MEM0 && xes->_operand_order[1] == XED_OPERAND_REG0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 (xed3_operand_get_mode(xes) == 2) &&
		 (xed3_operand_get_must_use_evex(xes) == 0) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_Q) &&
		 xed_encode_ntluf_XMM_R(xes,xed3_operand_get_reg0(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][4]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_MEM0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 (xed3_operand_get_mode(xes) == 2) &&
		 (xed3_operand_get_must_use_evex(xes) == 0) &&
		 xed_encode_ntluf_XMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_Q);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][5]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_MEM0 && xes->_operand_order[1] == XED_OPERAND_REG0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 (xed3_operand_get_must_use_evex(xes) == 0) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_Q) &&
		 xed_encode_ntluf_XMM_R(xes,xed3_operand_get_reg0(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][6]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_MEM0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 (xed3_operand_get_must_use_evex(xes) == 0) &&
		 xed_encode_ntluf_XMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_Q);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][7]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_REG1) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 (xed3_operand_get_mode(xes) == 2) &&
		 xed_encode_ntluf_GPR64_B(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_XMM_R3(xes,xed3_operand_get_reg1(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][8]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_REG1) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 (xed3_operand_get_mode(xes) == 2) &&
		 xed_encode_ntluf_XMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_GPR64_B(xes,xed3_operand_get_reg1(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][9]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_REG1) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 xed_encode_ntluf_XMM_B3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_XMM_R3(xes,xed3_operand_get_reg1(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][10]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_REG1) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 xed_encode_ntluf_XMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_XMM_B3(xes,xed3_operand_get_reg1(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][11]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_MEM0 && xes->_operand_order[1] == XED_OPERAND_REG0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_Q) &&
		 xed_encode_ntluf_XMM_R3(xes,xed3_operand_get_reg0(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][12]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_64_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_SCALAR_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_MEM0 && xes->_operand_order[1] == XED_OPERAND_REG0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 (xed3_operand_get_mode(xes) == 2) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_Q) &&
		 xed_encode_ntluf_XMM_R3(xes,xed3_operand_get_reg0(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][13]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_64_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_GPR_WRITER_STORE_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_MEM0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 (xed3_operand_get_mode(xes) == 2) &&
		 xed_encode_ntluf_XMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_Q);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][14]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_64_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_GPR_READER_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_MEM0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 xed_encode_ntluf_XMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_Q);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][15]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_64_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_SCALAR_BIND(xes);
       if (okay) return 1;
   }
     }
   return 0;
   (void) okay;
   (void) conditions_satisfied;
   (void) xes;
}
xed_bool_t xed_encode_group_393(xed_encoder_request_t* xes)
{
   xed_bool_t okay=1;
   xed_bool_t conditions_satisfied=0;
   xed_ptrn_func_ptr_t fb_ptrn_function;
   static const xed_uint16_t iform_ids[1][8] = {
   /*VMOVSD        */    {4404,4402,4403,4401,4408,4407,4406,4405,},
   };
   xed_uint8_t iclass_index = xed_encoder_get_iclasses_index_in_group(xes);
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[7], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_must_use_evex(xes) == 0) &&
		 xed_encode_ntluf_XMM_B(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_XMM_N(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_XMM_R(xes,xed3_operand_get_reg2(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][0]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[7], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_must_use_evex(xes) == 0) &&
		 xed_encode_ntluf_XMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_XMM_N(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_XMM_B(xes,xed3_operand_get_reg2(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][1]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_MEM0 && xes->_operand_order[1] == XED_OPERAND_REG0) {
   conditions_satisfied = (xed3_operand_get_must_use_evex(xes) == 0) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_Q) &&
		 xed_encode_ntluf_XMM_R(xes,xed3_operand_get_reg0(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][2]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_MEM0) {
   conditions_satisfied = (xed3_operand_get_must_use_evex(xes) == 0) &&
		 xed_encode_ntluf_XMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_Q);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][3]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 4 && memcmp(xed_encode_order[12], xes->_operand_order, sizeof(xed_uint8_t)*4)==0) {
   conditions_satisfied = xed_encode_ntluf_XMM_B3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_XMM_N3(xes,xed3_operand_get_reg2(xes)) &&
		 xed_encode_ntluf_XMM_R3(xes,xed3_operand_get_reg3(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][4]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 4 && memcmp(xed_encode_order[12], xes->_operand_order, sizeof(xed_uint8_t)*4)==0) {
   conditions_satisfied = xed_encode_ntluf_XMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_XMM_N3(xes,xed3_operand_get_reg2(xes)) &&
		 xed_encode_ntluf_XMM_B3(xes,xed3_operand_get_reg3(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][5]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[6], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_Q) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_XMM_R3(xes,xed3_operand_get_reg1(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][6]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_64_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_SCALAR_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[14], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = xed_encode_ntluf_XMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_Q);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][7]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_64_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_SCALAR_BIND(xes);
       if (okay) return 1;
   }
     }
   return 0;
   (void) okay;
   (void) conditions_satisfied;
   (void) xes;
}
xed_bool_t xed_encode_group_394(xed_encoder_request_t* xes)
{
   xed_bool_t okay=1;
   xed_bool_t conditions_satisfied=0;
   xed_ptrn_func_ptr_t fb_ptrn_function;
   static const xed_uint16_t iform_ids[1][13] = {
   /*VPBROADCASTW  */    {4420,4422,4419,4421,4425,4423,4428,4426,4431,4429,4424,4427,4430,},
   };
   xed_uint8_t iclass_index = xed_encoder_get_iclasses_index_in_group(xes);
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_REG1) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 (xed3_operand_get_must_use_evex(xes) == 0) &&
		 xed_encode_ntluf_XMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_XMM_B(xes,xed3_operand_get_reg1(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][0]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_REG1) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 1) &&
		 (xed3_operand_get_must_use_evex(xes) == 0) &&
		 xed_encode_ntluf_YMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_XMM_B(xes,xed3_operand_get_reg1(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][1]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_MEM0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 (xed3_operand_get_must_use_evex(xes) == 0) &&
		 xed_encode_ntluf_XMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_W);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][2]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_MEM0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 1) &&
		 (xed3_operand_get_must_use_evex(xes) == 0) &&
		 xed_encode_ntluf_YMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_W);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][3]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[7], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 xed_encode_ntluf_XMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_GPR32_B(xes,xed3_operand_get_reg2(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][4]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[7], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 xed_encode_ntluf_XMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_XMM_B3(xes,xed3_operand_get_reg2(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][5]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[7], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 1) &&
		 xed_encode_ntluf_YMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_GPR32_B(xes,xed3_operand_get_reg2(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][6]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[7], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 1) &&
		 xed_encode_ntluf_YMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_XMM_B3(xes,xed3_operand_get_reg2(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][7]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[7], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 2) &&
		 xed_encode_ntluf_ZMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_GPR32_B(xes,xed3_operand_get_reg2(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][8]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[7], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 2) &&
		 xed_encode_ntluf_ZMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_XMM_B3(xes,xed3_operand_get_reg2(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][9]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[14], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 xed_encode_ntluf_XMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_WRD);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][10]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_16_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_TUPLE1_WORD_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[14], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 1) &&
		 xed_encode_ntluf_YMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_WRD);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][11]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_16_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_TUPLE1_WORD_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[14], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 2) &&
		 xed_encode_ntluf_ZMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_WRD);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][12]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_16_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_TUPLE1_WORD_BIND(xes);
       if (okay) return 1;
   }
     }
   return 0;
   (void) okay;
   (void) conditions_satisfied;
   (void) xes;
}
xed_bool_t xed_encode_group_395(xed_encoder_request_t* xes)
{
   xed_bool_t okay=1;
   xed_bool_t conditions_satisfied=0;
   xed_ptrn_func_ptr_t fb_ptrn_function;
   static const xed_uint16_t iform_ids[1][1] = {
   /*FBSTP         */    {4432,},
   };
   xed_uint8_t iclass_index = xed_encoder_get_iclasses_index_in_group(xes);
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_MEM0 && xes->_operand_order[1] == XED_OPERAND_REG0) {
   conditions_satisfied = (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_MEM80DEC) &&
		 (xed3_operand_get_reg0(xes) == XED_REG_ST0);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][0]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay) return 1;
   }
     }
   return 0;
   (void) okay;
   (void) conditions_satisfied;
   (void) xes;
}
xed_bool_t xed_encode_group_396(xed_encoder_request_t* xes)
{
   xed_bool_t okay=1;
   xed_bool_t conditions_satisfied=0;
   xed_ptrn_func_ptr_t fb_ptrn_function;
   static const xed_uint16_t iform_ids[1][2] = {
   /*VFPCLASSSS    */    {4441,4442,},
   };
   xed_uint8_t iclass_index = xed_encoder_get_iclasses_index_in_group(xes);
   if (xes->_n_operand_order == 4 && memcmp(xed_encode_order[21], xes->_operand_order, sizeof(xed_uint8_t)*4)==0) {
   conditions_satisfied = xed_encode_ntluf_MASK_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_XMM_B3(xes,xed3_operand_get_reg2(xes)) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][0]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_UIMM8_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 4 && memcmp(xed_encode_order[22], xes->_operand_order, sizeof(xed_uint8_t)*4)==0) {
   conditions_satisfied = xed_encode_ntluf_MASK_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_D) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][1]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_UIMM8_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_32_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_SCALAR_BIND(xes);
       if (okay) return 1;
   }
     }
   return 0;
   (void) okay;
   (void) conditions_satisfied;
   (void) xes;
}
xed_bool_t xed_encode_group_397(xed_encoder_request_t* xes)
{
   xed_bool_t okay=1;
   xed_bool_t conditions_satisfied=0;
   xed_ptrn_func_ptr_t fb_ptrn_function;
   static const xed_uint16_t iform_ids[1][2] = {
   /*PCMPISTRM     */    {4444,4443,},
   };
   xed_uint8_t iclass_index = xed_encoder_get_iclasses_index_in_group(xes);
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[15], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = xed_encode_ntluf_XMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_XMM_B(xes,xed3_operand_get_reg1(xes)) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][0]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_IMMUNE66_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_UIMM8_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[20], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = xed_encode_ntluf_XMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_DQ) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][1]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_IMMUNE66_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_UIMM8_BIND(xes);
       if (okay) return 1;
   }
     }
   return 0;
   (void) okay;
   (void) conditions_satisfied;
   (void) xes;
}
xed_bool_t xed_encode_group_398(xed_encoder_request_t* xes)
{
   xed_bool_t okay=1;
   xed_bool_t conditions_satisfied=0;
   xed_ptrn_func_ptr_t fb_ptrn_function;
   static const xed_uint16_t iform_ids[2][2] = {
   /*CVTDQ2PD      */    {6396,6395,},
   /*MOVDDUP       */    {4469,4468,},
   };
   xed_uint8_t iclass_index = xed_encoder_get_iclasses_index_in_group(xes);
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_REG1) {
   conditions_satisfied = xed_encode_ntluf_XMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_XMM_B(xes,xed3_operand_get_reg1(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][0]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_IGNORE66_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_MEM0) {
   conditions_satisfied = xed_encode_ntluf_XMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_Q);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][1]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_IGNORE66_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay) return 1;
   }
     }
   return 0;
   (void) okay;
   (void) conditions_satisfied;
   (void) xes;
}
xed_bool_t xed_encode_group_399(xed_encoder_request_t* xes)
{
   xed_bool_t okay=1;
   xed_bool_t conditions_satisfied=0;
   xed_ptrn_func_ptr_t fb_ptrn_function;
   static const xed_uint16_t iform_ids[3][2] = {
   /*INVEPT        */    {4477,4476,},
   /*INVPCID       */    {6969,6968,},
   /*INVVPID       */    {4862,4861,},
   };
   xed_uint8_t iclass_index = xed_encoder_get_iclasses_index_in_group(xes);
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_MEM0) {
   conditions_satisfied = (xed3_operand_get_mode(xes) != 2) &&
		 xed_encode_ntluf_GPR32_R(xes,xed3_operand_get_reg0(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_DQ);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][0]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_REFINING66_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_CR_WIDTH_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_MEM0) {
   conditions_satisfied = (xed3_operand_get_mode(xes) == 2) &&
		 xed_encode_ntluf_GPR64_R(xes,xed3_operand_get_reg0(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_DQ);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][1]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_REFINING66_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_CR_WIDTH_BIND(xes);
       if (okay) return 1;
   }
     }
   return 0;
   (void) okay;
   (void) conditions_satisfied;
   (void) xes;
}
xed_bool_t xed_encode_group_400(xed_encoder_request_t* xes)
{
   xed_bool_t okay=1;
   xed_bool_t conditions_satisfied=0;
   xed_ptrn_func_ptr_t fb_ptrn_function;
   static const xed_uint16_t iform_ids[4][1] = {
   /*VGATHERPF0DPD */    {4478,},
   /*VGATHERPF1DPD */    {6847,},
   /*VSCATTERPF0DPD*/    {5029,},
   /*VSCATTERPF1DPD*/    {6680,},
   };
   xed_uint8_t iclass_index = xed_encoder_get_iclasses_index_in_group(xes);
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_MEM0 && xes->_operand_order[1] == XED_OPERAND_REG0) {
   conditions_satisfied = (xed3_operand_get_easz(xes) != 1) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_Q) &&
		 xed_encode_ntluf_MASKNOT0(xes,xed3_operand_get_reg0(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][0]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_UISA_VMODRM_YMM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_64_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_GSCAT_BIND(xes);
       if (okay) return 1;
   }
     }
   return 0;
   (void) okay;
   (void) conditions_satisfied;
   (void) xes;
}
xed_bool_t xed_encode_group_401(xed_encoder_request_t* xes)
{
   xed_bool_t okay=1;
   xed_bool_t conditions_satisfied=0;
   xed_ptrn_func_ptr_t fb_ptrn_function;
   static const xed_uint16_t iform_ids[1][1] = {
   /*PVALIDATE     */    {4515,},
   };
   xed_uint8_t iclass_index = xed_encoder_get_iclasses_index_in_group(xes);
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[7], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_mode(xes) == 2) &&
		 (xed3_operand_get_reg0(xes) == XED_REG_RAX) &&
		 (xed3_operand_get_reg1(xes) == XED_REG_ECX) &&
		 (xed3_operand_get_reg2(xes) == XED_REG_EDX);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][0]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   return 0;
   (void) okay;
   (void) conditions_satisfied;
   (void) xes;
}
xed_bool_t xed_encode_group_402(xed_encoder_request_t* xes)
{
   xed_bool_t okay=1;
   xed_bool_t conditions_satisfied=0;
   xed_ptrn_func_ptr_t fb_ptrn_function;
   static const xed_uint16_t iform_ids[2][5] = {
   /*VCOMISD       */    {4571,4569,4568,4570,4572,},
   /*VUCOMISD      */    {6693,6691,6690,6692,6694,},
   };
   xed_uint8_t iclass_index = xed_encoder_get_iclasses_index_in_group(xes);
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_REG1) {
   conditions_satisfied = (xed3_operand_get_sae(xes) != 0) &&
		 xed_encode_ntluf_XMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_XMM_B3(xes,xed3_operand_get_reg1(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][0]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_FIX_ROUND_LEN128_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_SAE_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_REG1) {
   conditions_satisfied = (xed3_operand_get_must_use_evex(xes) == 0) &&
		 xed_encode_ntluf_XMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_XMM_B(xes,xed3_operand_get_reg1(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][1]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_MEM0) {
   conditions_satisfied = (xed3_operand_get_must_use_evex(xes) == 0) &&
		 xed_encode_ntluf_XMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_Q);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][2]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_REG1) {
   conditions_satisfied = xed_encode_ntluf_XMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_XMM_B3(xes,xed3_operand_get_reg1(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][3]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_FIX_ROUND_LEN128_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_MEM0) {
   conditions_satisfied = xed_encode_ntluf_XMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_Q);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][4]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_64_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_SCALAR_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_FIX_ROUND_LEN128_BIND(xes);
       if (okay) return 1;
   }
     }
   return 0;
   (void) okay;
   (void) conditions_satisfied;
   (void) xes;
}
xed_bool_t xed_encode_group_403(xed_encoder_request_t* xes)
{
   xed_bool_t okay=1;
   xed_bool_t conditions_satisfied=0;
   xed_ptrn_func_ptr_t fb_ptrn_function;
   static const xed_uint16_t iform_ids[1][13] = {
   /*VPBROADCASTQ  */    {4585,4587,4584,4586,4593,4592,4596,4595,4590,4589,4591,4594,4588,},
   };
   xed_uint8_t iclass_index = xed_encoder_get_iclasses_index_in_group(xes);
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_REG1) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 (xed3_operand_get_must_use_evex(xes) == 0) &&
		 xed_encode_ntluf_XMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_XMM_B(xes,xed3_operand_get_reg1(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][0]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_REG1) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 1) &&
		 (xed3_operand_get_must_use_evex(xes) == 0) &&
		 xed_encode_ntluf_YMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_XMM_B(xes,xed3_operand_get_reg1(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][1]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_MEM0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 (xed3_operand_get_must_use_evex(xes) == 0) &&
		 xed_encode_ntluf_XMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_Q);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][2]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_MEM0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 1) &&
		 (xed3_operand_get_must_use_evex(xes) == 0) &&
		 xed_encode_ntluf_YMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_Q);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][3]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[7], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 (xed3_operand_get_mode(xes) == 2) &&
		 xed_encode_ntluf_XMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_GPR64_B(xes,xed3_operand_get_reg2(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][4]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[7], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 xed_encode_ntluf_XMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_XMM_B3(xes,xed3_operand_get_reg2(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][5]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[7], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 1) &&
		 (xed3_operand_get_mode(xes) == 2) &&
		 xed_encode_ntluf_YMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_GPR64_B(xes,xed3_operand_get_reg2(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][6]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[7], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 1) &&
		 xed_encode_ntluf_YMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_XMM_B3(xes,xed3_operand_get_reg2(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][7]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[7], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 2) &&
		 (xed3_operand_get_mode(xes) == 2) &&
		 xed_encode_ntluf_ZMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_GPR64_B(xes,xed3_operand_get_reg2(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][8]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[7], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 2) &&
		 xed_encode_ntluf_ZMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_XMM_B3(xes,xed3_operand_get_reg2(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][9]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[14], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 xed_encode_ntluf_XMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_Q);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][10]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_64_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_TUPLE1_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[14], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 1) &&
		 xed_encode_ntluf_YMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_Q);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][11]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_64_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_TUPLE1_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[14], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 2) &&
		 xed_encode_ntluf_ZMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_Q);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][12]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_64_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_TUPLE1_BIND(xes);
       if (okay) return 1;
   }
     }
   return 0;
   (void) okay;
   (void) conditions_satisfied;
   (void) xes;
}
xed_bool_t xed_encode_group_404(xed_encoder_request_t* xes)
{
   xed_bool_t okay=1;
   xed_bool_t conditions_satisfied=0;
   xed_ptrn_func_ptr_t fb_ptrn_function;
   static const xed_uint16_t iform_ids[1][10] = {
   /*VPABSD        */    {4669,4671,4668,4670,4674,4676,4672,4675,4677,4673,},
   };
   xed_uint8_t iclass_index = xed_encoder_get_iclasses_index_in_group(xes);
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_REG1) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 (xed3_operand_get_must_use_evex(xes) == 0) &&
		 xed_encode_ntluf_XMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_XMM_B(xes,xed3_operand_get_reg1(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][0]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_REG1) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 1) &&
		 (xed3_operand_get_must_use_evex(xes) == 0) &&
		 xed_encode_ntluf_YMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_YMM_B(xes,xed3_operand_get_reg1(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][1]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_MEM0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 (xed3_operand_get_must_use_evex(xes) == 0) &&
		 xed_encode_ntluf_XMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_DQ);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][2]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_MEM0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 1) &&
		 (xed3_operand_get_must_use_evex(xes) == 0) &&
		 xed_encode_ntluf_YMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_QQ);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][3]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[7], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 xed_encode_ntluf_XMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_XMM_B3(xes,xed3_operand_get_reg2(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][4]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[7], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 1) &&
		 xed_encode_ntluf_YMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_YMM_B3(xes,xed3_operand_get_reg2(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][5]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[7], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 2) &&
		 xed_encode_ntluf_ZMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_ZMM_B3(xes,xed3_operand_get_reg2(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][6]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[14], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 xed_encode_ntluf_XMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_VV);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][7]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_32_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_FULL_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[14], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 1) &&
		 xed_encode_ntluf_YMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_VV);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][8]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_32_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_FULL_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[14], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 2) &&
		 xed_encode_ntluf_ZMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_VV);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][9]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_32_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_FULL_BIND(xes);
       if (okay) return 1;
   }
     }
   return 0;
   (void) okay;
   (void) conditions_satisfied;
   (void) xes;
}
xed_bool_t xed_encode_group_405(xed_encoder_request_t* xes)
{
   xed_bool_t okay=1;
   xed_bool_t conditions_satisfied=0;
   xed_ptrn_func_ptr_t fb_ptrn_function;
   static const xed_uint16_t iform_ids[1][1] = {
   /*SYSCALL_AMD   */    {4685,},
   };
   xed_uint8_t iclass_index = xed_encoder_get_iclasses_index_in_group(xes);
   if (xes->_n_operand_order == 0) {
   conditions_satisfied = (xed3_operand_get_mode(xes) != 2);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][0]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_IGNORE66_BIND(xes);
       if (okay) return 1;
   }
     }
   return 0;
   (void) okay;
   (void) conditions_satisfied;
   (void) xes;
}
xed_bool_t xed_encode_group_406(xed_encoder_request_t* xes)
{
   xed_bool_t okay=1;
   xed_bool_t conditions_satisfied=0;
   xed_ptrn_func_ptr_t fb_ptrn_function;
   static const xed_uint16_t iform_ids[2][5] = {
   /*VGATHERDPD    */    {4687,4686,4689,4690,4688,},
   /*VPGATHERDQ    */    {6617,6616,6619,6620,6618,},
   };
   xed_uint8_t iclass_index = xed_encoder_get_iclasses_index_in_group(xes);
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[24], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 (xed3_operand_get_easz(xes) != 1) &&
		 (xed3_operand_get_must_use_evex(xes) == 0) &&
		 xed_encode_ntluf_XMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_Q) &&
		 xed_encode_ntluf_XMM_N(xes,xed3_operand_get_reg1(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][0]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_VMODRM_XMM_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[24], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 1) &&
		 (xed3_operand_get_easz(xes) != 1) &&
		 (xed3_operand_get_must_use_evex(xes) == 0) &&
		 xed_encode_ntluf_YMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_Q) &&
		 xed_encode_ntluf_YMM_N(xes,xed3_operand_get_reg1(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][1]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_VMODRM_XMM_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[14], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 (xed3_operand_get_easz(xes) != 1) &&
		 xed_encode_ntluf_XMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASKNOT0(xes,xed3_operand_get_reg1(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_Q);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][2]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_UISA_VMODRM_XMM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_64_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_GSCAT_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[14], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 1) &&
		 (xed3_operand_get_easz(xes) != 1) &&
		 xed_encode_ntluf_YMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASKNOT0(xes,xed3_operand_get_reg1(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_Q);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][3]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_UISA_VMODRM_XMM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_64_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_GSCAT_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[14], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 2) &&
		 (xed3_operand_get_easz(xes) != 1) &&
		 xed_encode_ntluf_ZMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASKNOT0(xes,xed3_operand_get_reg1(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_Q);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][4]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_UISA_VMODRM_YMM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_64_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_GSCAT_BIND(xes);
       if (okay) return 1;
   }
     }
   return 0;
   (void) okay;
   (void) conditions_satisfied;
   (void) xes;
}
xed_bool_t xed_encode_group_407(xed_encoder_request_t* xes)
{
   xed_bool_t okay=1;
   xed_bool_t conditions_satisfied=0;
   xed_ptrn_func_ptr_t fb_ptrn_function;
   static const xed_uint16_t iform_ids[1][2] = {
   /*FNSTSW        */    {4692,4691,},
   };
   xed_uint8_t iclass_index = xed_encoder_get_iclasses_index_in_group(xes);
   if (xes->_n_operand_order == 1 && xes->_operand_order[0] == XED_OPERAND_REG0) {
   conditions_satisfied = (xed3_operand_get_reg0(xes) == XED_REG_AX);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][0]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 1 && xes->_operand_order[0] == XED_OPERAND_MEM0) {
   conditions_satisfied = (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_MEM16);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][1]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay) return 1;
   }
     }
   return 0;
   (void) okay;
   (void) conditions_satisfied;
   (void) xes;
}
xed_bool_t xed_encode_group_408(xed_encoder_request_t* xes)
{
   xed_bool_t okay=1;
   xed_bool_t conditions_satisfied=0;
   xed_ptrn_func_ptr_t fb_ptrn_function;
   static const xed_uint16_t iform_ids[2][2] = {
   /*VRCPSS        */    {4716,4715,},
   /*VRSQRTSS      */    {6285,6284,},
   };
   xed_uint8_t iclass_index = xed_encoder_get_iclasses_index_in_group(xes);
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[7], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_must_use_evex(xes) == 0) &&
		 xed_encode_ntluf_XMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_XMM_N(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_XMM_B(xes,xed3_operand_get_reg2(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][0]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[14], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_must_use_evex(xes) == 0) &&
		 xed_encode_ntluf_XMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_XMM_N(xes,xed3_operand_get_reg1(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_D);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][1]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay) return 1;
   }
     }
   return 0;
   (void) okay;
   (void) conditions_satisfied;
   (void) xes;
}
xed_bool_t xed_encode_group_409(xed_encoder_request_t* xes)
{
   xed_bool_t okay=1;
   xed_bool_t conditions_satisfied=0;
   xed_ptrn_func_ptr_t fb_ptrn_function;
   static const xed_uint16_t iform_ids[1][5] = {
   /*VCMPSD        */    {4720,4718,4717,4719,4721,},
   };
   xed_uint8_t iclass_index = xed_encoder_get_iclasses_index_in_group(xes);
   if (xes->_n_operand_order == 5 && memcmp(xed_encode_order[18], xes->_operand_order, sizeof(xed_uint8_t)*5)==0) {
   conditions_satisfied = (xed3_operand_get_sae(xes) != 0) &&
		 xed_encode_ntluf_MASK_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_XMM_N3(xes,xed3_operand_get_reg2(xes)) &&
		 xed_encode_ntluf_XMM_B3(xes,xed3_operand_get_reg3(xes)) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][0]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_FIX_ROUND_LEN128_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_SAE_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_UIMM8_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 4 && memcmp(xed_encode_order[21], xes->_operand_order, sizeof(xed_uint8_t)*4)==0) {
   conditions_satisfied = (xed3_operand_get_must_use_evex(xes) == 0) &&
		 xed_encode_ntluf_XMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_XMM_N(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_XMM_B(xes,xed3_operand_get_reg2(xes)) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][1]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_UIMM8_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 4 && memcmp(xed_encode_order[22], xes->_operand_order, sizeof(xed_uint8_t)*4)==0) {
   conditions_satisfied = (xed3_operand_get_must_use_evex(xes) == 0) &&
		 xed_encode_ntluf_XMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_XMM_N(xes,xed3_operand_get_reg1(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_Q) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][2]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_UIMM8_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 5 && memcmp(xed_encode_order[18], xes->_operand_order, sizeof(xed_uint8_t)*5)==0) {
   conditions_satisfied = xed_encode_ntluf_MASK_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_XMM_N3(xes,xed3_operand_get_reg2(xes)) &&
		 xed_encode_ntluf_XMM_B3(xes,xed3_operand_get_reg3(xes)) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][3]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_UIMM8_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 5 && memcmp(xed_encode_order[19], xes->_operand_order, sizeof(xed_uint8_t)*5)==0) {
   conditions_satisfied = xed_encode_ntluf_MASK_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_XMM_N3(xes,xed3_operand_get_reg2(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_Q) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][4]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_UIMM8_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_64_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_SCALAR_BIND(xes);
       if (okay) return 1;
   }
     }
   return 0;
   (void) okay;
   (void) conditions_satisfied;
   (void) xes;
}
xed_bool_t xed_encode_group_410(xed_encoder_request_t* xes)
{
   xed_bool_t okay=1;
   xed_bool_t conditions_satisfied=0;
   xed_ptrn_func_ptr_t fb_ptrn_function;
   static const xed_uint16_t iform_ids[2][10] = {
   /*VPSHUFHW      */    {4726,4728,4725,4727,4729,4731,4733,4730,4732,4734,},
   /*VPSHUFLW      */    {6294,6296,6293,6295,6297,6299,6301,6298,6300,6302,},
   };
   xed_uint8_t iclass_index = xed_encoder_get_iclasses_index_in_group(xes);
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[15], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 (xed3_operand_get_must_use_evex(xes) == 0) &&
		 xed_encode_ntluf_XMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_XMM_B(xes,xed3_operand_get_reg1(xes)) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][0]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_UIMM8_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[15], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 1) &&
		 (xed3_operand_get_must_use_evex(xes) == 0) &&
		 xed_encode_ntluf_YMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_YMM_B(xes,xed3_operand_get_reg1(xes)) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][1]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_UIMM8_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[20], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 (xed3_operand_get_must_use_evex(xes) == 0) &&
		 xed_encode_ntluf_XMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_DQ) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][2]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_UIMM8_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[20], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 1) &&
		 (xed3_operand_get_must_use_evex(xes) == 0) &&
		 xed_encode_ntluf_YMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_QQ) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][3]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_UIMM8_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 4 && memcmp(xed_encode_order[21], xes->_operand_order, sizeof(xed_uint8_t)*4)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 xed_encode_ntluf_XMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_XMM_B3(xes,xed3_operand_get_reg2(xes)) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][4]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_UIMM8_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 4 && memcmp(xed_encode_order[21], xes->_operand_order, sizeof(xed_uint8_t)*4)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 1) &&
		 xed_encode_ntluf_YMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_YMM_B3(xes,xed3_operand_get_reg2(xes)) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][5]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_UIMM8_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 4 && memcmp(xed_encode_order[21], xes->_operand_order, sizeof(xed_uint8_t)*4)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 2) &&
		 xed_encode_ntluf_ZMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_ZMM_B3(xes,xed3_operand_get_reg2(xes)) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][6]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_UIMM8_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 4 && memcmp(xed_encode_order[22], xes->_operand_order, sizeof(xed_uint8_t)*4)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 xed_encode_ntluf_XMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_DQ) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][7]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_UIMM8_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_16_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_FULLMEM_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 4 && memcmp(xed_encode_order[22], xes->_operand_order, sizeof(xed_uint8_t)*4)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 1) &&
		 xed_encode_ntluf_YMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_QQ) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][8]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_UIMM8_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_16_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_FULLMEM_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 4 && memcmp(xed_encode_order[22], xes->_operand_order, sizeof(xed_uint8_t)*4)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 2) &&
		 xed_encode_ntluf_ZMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_ZD) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][9]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_UIMM8_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_16_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_FULLMEM_BIND(xes);
       if (okay) return 1;
   }
     }
   return 0;
   (void) okay;
   (void) conditions_satisfied;
   (void) xes;
}
xed_bool_t xed_encode_group_411(xed_encoder_request_t* xes)
{
   xed_bool_t okay=1;
   xed_bool_t conditions_satisfied=0;
   xed_ptrn_func_ptr_t fb_ptrn_function;
   static const xed_uint16_t iform_ids[1][4] = {
   /*BEXTR_XOP     */    {4745,4746,4743,4744,},
   };
   xed_uint8_t iclass_index = xed_encoder_get_iclasses_index_in_group(xes);
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[15], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_mode(xes) != 2) &&
		 (xed3_operand_get_vl(xes) == 0) &&
		 xed_encode_ntluf_GPR32_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_GPR32_B(xes,xed3_operand_get_reg1(xes)) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][0]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_UIMM32_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[15], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_mode(xes) == 2) &&
		 (xed3_operand_get_vl(xes) == 0) &&
		 xed_encode_ntluf_GPRy_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_GPRy_B(xes,xed3_operand_get_reg1(xes)) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][1]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_UIMM32_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[20], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_mode(xes) != 2) &&
		 (xed3_operand_get_vl(xes) == 0) &&
		 xed_encode_ntluf_GPR32_R(xes,xed3_operand_get_reg0(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_D) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][2]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_UIMM32_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[20], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_mode(xes) == 2) &&
		 (xed3_operand_get_vl(xes) == 0) &&
		 xed_encode_ntluf_GPRy_R(xes,xed3_operand_get_reg0(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_Y) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][3]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_UIMM32_BIND(xes);
       if (okay) return 1;
   }
     }
   return 0;
   (void) okay;
   (void) conditions_satisfied;
   (void) xes;
}
xed_bool_t xed_encode_group_412(xed_encoder_request_t* xes)
{
   xed_bool_t okay=1;
   xed_bool_t conditions_satisfied=0;
   xed_ptrn_func_ptr_t fb_ptrn_function;
   static const xed_uint16_t iform_ids[1][11] = {
   /*VCVTPS2PD     */    {4766,4762,4764,4761,4763,4768,4770,4765,4769,4771,4767,},
   };
   xed_uint8_t iclass_index = xed_encoder_get_iclasses_index_in_group(xes);
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[7], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_sae(xes) != 0) &&
		 xed_encode_ntluf_ZMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_YMM_B3(xes,xed3_operand_get_reg2(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][0]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_FIX_ROUND_LEN512_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_SAE_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_REG1) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 (xed3_operand_get_must_use_evex(xes) == 0) &&
		 xed_encode_ntluf_XMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_XMM_B(xes,xed3_operand_get_reg1(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][1]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_REG1) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 1) &&
		 (xed3_operand_get_must_use_evex(xes) == 0) &&
		 xed_encode_ntluf_YMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_XMM_B(xes,xed3_operand_get_reg1(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][2]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_MEM0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 (xed3_operand_get_must_use_evex(xes) == 0) &&
		 xed_encode_ntluf_XMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_Q);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][3]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_MEM0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 1) &&
		 (xed3_operand_get_must_use_evex(xes) == 0) &&
		 xed_encode_ntluf_YMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_DQ);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][4]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[7], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 xed_encode_ntluf_XMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_XMM_B3(xes,xed3_operand_get_reg2(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][5]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[7], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 1) &&
		 xed_encode_ntluf_YMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_XMM_B3(xes,xed3_operand_get_reg2(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][6]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[7], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 2) &&
		 xed_encode_ntluf_ZMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_YMM_B3(xes,xed3_operand_get_reg2(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][7]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[14], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 xed_encode_ntluf_XMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_VV);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][8]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_32_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_HALF_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[14], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 1) &&
		 xed_encode_ntluf_YMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_VV);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][9]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_32_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_HALF_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[14], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 2) &&
		 xed_encode_ntluf_ZMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_VV);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][10]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_32_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_HALF_BIND(xes);
       if (okay) return 1;
   }
     }
   return 0;
   (void) okay;
   (void) conditions_satisfied;
   (void) xes;
}
xed_bool_t xed_encode_group_413(xed_encoder_request_t* xes)
{
   xed_bool_t okay=1;
   xed_bool_t conditions_satisfied=0;
   xed_ptrn_func_ptr_t fb_ptrn_function;
   static const xed_uint16_t iform_ids[4][4] = {
   /*VFMADDSD      */    {6573,6575,6572,6574,},
   /*VFMSUBSD      */    {4945,4947,4944,4946,},
   /*VFNMADDSD     */    {4790,4792,4789,4791,},
   /*VFNMSUBSD     */    {5602,5604,5601,5603,},
   };
   xed_uint8_t iclass_index = xed_encoder_get_iclasses_index_in_group(xes);
   if (xes->_n_operand_order == 4 && memcmp(xed_encode_order[12], xes->_operand_order, sizeof(xed_uint8_t)*4)==0) {
   conditions_satisfied = (xed3_operand_get_must_use_evex(xes) == 0) &&
		 xed_encode_ntluf_XMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_XMM_N(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_XMM_B(xes,xed3_operand_get_reg2(xes)) &&
		 xed_encode_ntluf_XMM_SE(xes,xed3_operand_get_reg3(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][0]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_SE_IMM8_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 4 && memcmp(xed_encode_order[12], xes->_operand_order, sizeof(xed_uint8_t)*4)==0) {
   conditions_satisfied = (xed3_operand_get_must_use_evex(xes) == 0) &&
		 xed_encode_ntluf_XMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_XMM_N(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_XMM_SE(xes,xed3_operand_get_reg2(xes)) &&
		 xed_encode_ntluf_XMM_B(xes,xed3_operand_get_reg3(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][1]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_SE_IMM8_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 4 && memcmp(xed_encode_order[11], xes->_operand_order, sizeof(xed_uint8_t)*4)==0) {
   conditions_satisfied = (xed3_operand_get_must_use_evex(xes) == 0) &&
		 xed_encode_ntluf_XMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_XMM_N(xes,xed3_operand_get_reg1(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_Q) &&
		 xed_encode_ntluf_XMM_SE(xes,xed3_operand_get_reg2(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][2]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_SE_IMM8_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 4 && memcmp(xed_encode_order[13], xes->_operand_order, sizeof(xed_uint8_t)*4)==0) {
   conditions_satisfied = (xed3_operand_get_must_use_evex(xes) == 0) &&
		 xed_encode_ntluf_XMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_XMM_N(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_XMM_SE(xes,xed3_operand_get_reg2(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_Q);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][3]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_SE_IMM8_BIND(xes);
       if (okay) return 1;
   }
     }
   return 0;
   (void) okay;
   (void) conditions_satisfied;
   (void) xes;
}
xed_bool_t xed_encode_group_414(xed_encoder_request_t* xes)
{
   xed_bool_t okay=1;
   xed_bool_t conditions_satisfied=0;
   xed_ptrn_func_ptr_t fb_ptrn_function;
   static const xed_uint16_t iform_ids[3][7] = {
   /*VCVTPD2UDQ    */    {4816,4818,4820,4815,4819,4821,4817,},
   /*VCVTQQ2PS     */    {5634,5629,5631,5633,5630,5632,5635,},
   /*VCVTUQQ2PS    */    {6253,6248,6250,6252,6249,6251,6254,},
   };
   xed_uint8_t iclass_index = xed_encoder_get_iclasses_index_in_group(xes);
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[7], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_roundc(xes) != 0) &&
		 xed_encode_ntluf_YMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_ZMM_B3(xes,xed3_operand_get_reg2(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][0]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_FIX_ROUND_LEN512_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_AVX512_ROUND_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[7], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 xed_encode_ntluf_XMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_XMM_B3(xes,xed3_operand_get_reg2(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][1]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[7], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 1) &&
		 xed_encode_ntluf_XMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_YMM_B3(xes,xed3_operand_get_reg2(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][2]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[7], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 2) &&
		 xed_encode_ntluf_YMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_ZMM_B3(xes,xed3_operand_get_reg2(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][3]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[14], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 xed_encode_ntluf_XMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_VV);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][4]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_64_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_FULL_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[14], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 1) &&
		 xed_encode_ntluf_XMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_VV);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][5]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_64_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_FULL_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[14], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 2) &&
		 xed_encode_ntluf_YMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_VV);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][6]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_64_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_FULL_BIND(xes);
       if (okay) return 1;
   }
     }
   return 0;
   (void) okay;
   (void) conditions_satisfied;
   (void) xes;
}
xed_bool_t xed_encode_group_415(xed_encoder_request_t* xes)
{
   xed_bool_t okay=1;
   xed_bool_t conditions_satisfied=0;
   xed_ptrn_func_ptr_t fb_ptrn_function;
   static const xed_uint16_t iform_ids[1][12] = {
   /*VPSRAQ        */    {4874,4878,4870,4876,4880,4872,4875,4879,4871,4877,4881,4873,},
   };
   xed_uint8_t iclass_index = xed_encoder_get_iclasses_index_in_group(xes);
   if (xes->_n_operand_order == 4 && memcmp(xed_encode_order[12], xes->_operand_order, sizeof(xed_uint8_t)*4)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 xed_encode_ntluf_XMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_XMM_N3(xes,xed3_operand_get_reg2(xes)) &&
		 xed_encode_ntluf_XMM_B3(xes,xed3_operand_get_reg3(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][0]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 4 && memcmp(xed_encode_order[12], xes->_operand_order, sizeof(xed_uint8_t)*4)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 1) &&
		 xed_encode_ntluf_YMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_YMM_N3(xes,xed3_operand_get_reg2(xes)) &&
		 xed_encode_ntluf_XMM_B3(xes,xed3_operand_get_reg3(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][1]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 4 && memcmp(xed_encode_order[12], xes->_operand_order, sizeof(xed_uint8_t)*4)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 2) &&
		 xed_encode_ntluf_ZMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_ZMM_N3(xes,xed3_operand_get_reg2(xes)) &&
		 xed_encode_ntluf_XMM_B3(xes,xed3_operand_get_reg3(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][2]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 4 && memcmp(xed_encode_order[21], xes->_operand_order, sizeof(xed_uint8_t)*4)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 xed_encode_ntluf_XMM_N3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_XMM_B3(xes,xed3_operand_get_reg2(xes)) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][3]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_UIMM8_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 4 && memcmp(xed_encode_order[21], xes->_operand_order, sizeof(xed_uint8_t)*4)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 1) &&
		 xed_encode_ntluf_YMM_N3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_YMM_B3(xes,xed3_operand_get_reg2(xes)) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][4]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_UIMM8_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 4 && memcmp(xed_encode_order[21], xes->_operand_order, sizeof(xed_uint8_t)*4)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 2) &&
		 xed_encode_ntluf_ZMM_N3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_ZMM_B3(xes,xed3_operand_get_reg2(xes)) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][5]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_UIMM8_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 4 && memcmp(xed_encode_order[13], xes->_operand_order, sizeof(xed_uint8_t)*4)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 xed_encode_ntluf_XMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_XMM_N3(xes,xed3_operand_get_reg2(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_DQ);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][6]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_64_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_MEM128_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 4 && memcmp(xed_encode_order[13], xes->_operand_order, sizeof(xed_uint8_t)*4)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 1) &&
		 xed_encode_ntluf_YMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_YMM_N3(xes,xed3_operand_get_reg2(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_DQ);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][7]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_64_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_MEM128_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 4 && memcmp(xed_encode_order[13], xes->_operand_order, sizeof(xed_uint8_t)*4)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 2) &&
		 xed_encode_ntluf_ZMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_ZMM_N3(xes,xed3_operand_get_reg2(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_DQ);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][8]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_64_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_MEM128_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 4 && memcmp(xed_encode_order[22], xes->_operand_order, sizeof(xed_uint8_t)*4)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 xed_encode_ntluf_XMM_N3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_VV) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][9]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_UIMM8_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_64_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_FULL_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 4 && memcmp(xed_encode_order[22], xes->_operand_order, sizeof(xed_uint8_t)*4)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 1) &&
		 xed_encode_ntluf_YMM_N3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_VV) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][10]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_UIMM8_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_64_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_FULL_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 4 && memcmp(xed_encode_order[22], xes->_operand_order, sizeof(xed_uint8_t)*4)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 2) &&
		 xed_encode_ntluf_ZMM_N3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_VV) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][11]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_UIMM8_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_64_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_FULL_BIND(xes);
       if (okay) return 1;
   }
     }
   return 0;
   (void) okay;
   (void) conditions_satisfied;
   (void) xes;
}
xed_bool_t xed_encode_group_416(xed_encoder_request_t* xes)
{
   xed_bool_t okay=1;
   xed_bool_t conditions_satisfied=0;
   xed_ptrn_func_ptr_t fb_ptrn_function;
   static const xed_uint16_t iform_ids[1][6] = {
   /*VFPCLASSPD    */    {4882,4884,4886,4883,4885,4887,},
   };
   xed_uint8_t iclass_index = xed_encoder_get_iclasses_index_in_group(xes);
   if (xes->_n_operand_order == 4 && memcmp(xed_encode_order[21], xes->_operand_order, sizeof(xed_uint8_t)*4)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 xed_encode_ntluf_MASK_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_XMM_B3(xes,xed3_operand_get_reg2(xes)) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][0]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_UIMM8_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 4 && memcmp(xed_encode_order[21], xes->_operand_order, sizeof(xed_uint8_t)*4)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 1) &&
		 xed_encode_ntluf_MASK_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_YMM_B3(xes,xed3_operand_get_reg2(xes)) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][1]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_UIMM8_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 4 && memcmp(xed_encode_order[21], xes->_operand_order, sizeof(xed_uint8_t)*4)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 2) &&
		 xed_encode_ntluf_MASK_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_ZMM_B3(xes,xed3_operand_get_reg2(xes)) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][2]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_UIMM8_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 4 && memcmp(xed_encode_order[22], xes->_operand_order, sizeof(xed_uint8_t)*4)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 xed_encode_ntluf_MASK_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_VV) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][3]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_UIMM8_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_64_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_FULL_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 4 && memcmp(xed_encode_order[22], xes->_operand_order, sizeof(xed_uint8_t)*4)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 1) &&
		 xed_encode_ntluf_MASK_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_VV) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][4]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_UIMM8_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_64_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_FULL_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 4 && memcmp(xed_encode_order[22], xes->_operand_order, sizeof(xed_uint8_t)*4)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 2) &&
		 xed_encode_ntluf_MASK_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_VV) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][5]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_UIMM8_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_64_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_FULL_BIND(xes);
       if (okay) return 1;
   }
     }
   return 0;
   (void) okay;
   (void) conditions_satisfied;
   (void) xes;
}
xed_bool_t xed_encode_group_417(xed_encoder_request_t* xes)
{
   xed_bool_t okay=1;
   xed_bool_t conditions_satisfied=0;
   xed_ptrn_func_ptr_t fb_ptrn_function;
   static const xed_uint16_t iform_ids[2][1] = {
   /*VBROADCASTF64X4*/    {4888,},
   /*VBROADCASTI64X4*/    {4962,},
   };
   xed_uint8_t iclass_index = xed_encoder_get_iclasses_index_in_group(xes);
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[14], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 2) &&
		 xed_encode_ntluf_ZMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_QQ);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][0]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_64_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_TUPLE4_BIND(xes);
       if (okay) return 1;
   }
     }
   return 0;
   (void) okay;
   (void) conditions_satisfied;
   (void) xes;
}
xed_bool_t xed_encode_group_418(xed_encoder_request_t* xes)
{
   xed_bool_t okay=1;
   xed_bool_t conditions_satisfied=0;
   xed_ptrn_func_ptr_t fb_ptrn_function;
   static const xed_uint16_t iform_ids[1][3] = {
   /*MOVNTI        */    {4921,4922,4923,},
   };
   xed_uint8_t iclass_index = xed_encoder_get_iclasses_index_in_group(xes);
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_MEM0 && xes->_operand_order[1] == XED_OPERAND_REG0) {
   conditions_satisfied = (xed3_operand_get_mode(xes) != 2) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_D) &&
		 xed_encode_ntluf_GPR32_R(xes,xed3_operand_get_reg0(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][0]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_MEM0 && xes->_operand_order[1] == XED_OPERAND_REG0) {
   conditions_satisfied = (xed3_operand_get_mode(xes) == 2) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_D) &&
		 xed_encode_ntluf_GPR32_R(xes,xed3_operand_get_reg0(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][1]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_MEM0 && xes->_operand_order[1] == XED_OPERAND_REG0) {
   conditions_satisfied = (xed3_operand_get_mode(xes) == 2) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_Q) &&
		 xed_encode_ntluf_GPR64_R(xes,xed3_operand_get_reg0(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][2]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay) return 1;
   }
     }
   return 0;
   (void) okay;
   (void) conditions_satisfied;
   (void) xes;
}
xed_bool_t xed_encode_group_419(xed_encoder_request_t* xes)
{
   xed_bool_t okay=1;
   xed_bool_t conditions_satisfied=0;
   xed_ptrn_func_ptr_t fb_ptrn_function;
   static const xed_uint16_t iform_ids[1][2] = {
   /*RET_FAR       */    {4929,4928,},
   };
   xed_uint8_t iclass_index = xed_encoder_get_iclasses_index_in_group(xes);
   if (xes->_n_operand_order == 0) {
   conditions_satisfied = 1;
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][0]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 1 && xes->_operand_order[0] == XED_OPERAND_IMM0) {
   conditions_satisfied = (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][1]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_UIMM16_BIND(xes);
       if (okay) return 1;
   }
     }
   return 0;
   (void) okay;
   (void) conditions_satisfied;
   (void) xes;
}
xed_bool_t xed_encode_group_420(xed_encoder_request_t* xes)
{
   xed_bool_t okay=1;
   xed_bool_t conditions_satisfied=0;
   xed_ptrn_func_ptr_t fb_ptrn_function;
   static const xed_uint16_t iform_ids[1][12] = {
   /*VMOVDQU16     */    {4950,4948,4954,4952,4958,4956,4951,4949,4955,4953,4959,4957,},
   };
   xed_uint8_t iclass_index = xed_encoder_get_iclasses_index_in_group(xes);
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[7], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 xed_encode_ntluf_XMM_B3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_XMM_R3(xes,xed3_operand_get_reg2(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][0]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[7], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 xed_encode_ntluf_XMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_XMM_B3(xes,xed3_operand_get_reg2(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][1]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[7], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 1) &&
		 xed_encode_ntluf_YMM_B3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_YMM_R3(xes,xed3_operand_get_reg2(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][2]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[7], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 1) &&
		 xed_encode_ntluf_YMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_YMM_B3(xes,xed3_operand_get_reg2(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][3]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[7], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 2) &&
		 xed_encode_ntluf_ZMM_B3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_ZMM_R3(xes,xed3_operand_get_reg2(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][4]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[7], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 2) &&
		 xed_encode_ntluf_ZMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_ZMM_B3(xes,xed3_operand_get_reg2(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][5]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[6], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_DQ) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_XMM_R3(xes,xed3_operand_get_reg1(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][6]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_16_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_FULLMEM_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[14], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 xed_encode_ntluf_XMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_DQ);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][7]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_16_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_FULLMEM_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[6], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 1) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_QQ) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_YMM_R3(xes,xed3_operand_get_reg1(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][8]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_16_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_FULLMEM_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[14], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 1) &&
		 xed_encode_ntluf_YMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_QQ);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][9]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_16_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_FULLMEM_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[6], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 2) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_ZD) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_ZMM_R3(xes,xed3_operand_get_reg1(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][10]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_16_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_FULLMEM_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[14], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 2) &&
		 xed_encode_ntluf_ZMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_ZD);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][11]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_16_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_FULLMEM_BIND(xes);
       if (okay) return 1;
   }
     }
   return 0;
   (void) okay;
   (void) conditions_satisfied;
   (void) xes;
}
xed_bool_t xed_encode_group_421(xed_encoder_request_t* xes)
{
   xed_bool_t okay=1;
   xed_bool_t conditions_satisfied=0;
   xed_ptrn_func_ptr_t fb_ptrn_function;
   static const xed_uint16_t iform_ids[1][10] = {
   /*VPALIGNR      */    {5014,5016,5013,5015,5017,5019,5021,5018,5020,5022,},
   };
   xed_uint8_t iclass_index = xed_encoder_get_iclasses_index_in_group(xes);
   if (xes->_n_operand_order == 4 && memcmp(xed_encode_order[21], xes->_operand_order, sizeof(xed_uint8_t)*4)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 (xed3_operand_get_must_use_evex(xes) == 0) &&
		 xed_encode_ntluf_XMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_XMM_N(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_XMM_B(xes,xed3_operand_get_reg2(xes)) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][0]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_UIMM8_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 4 && memcmp(xed_encode_order[21], xes->_operand_order, sizeof(xed_uint8_t)*4)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 1) &&
		 (xed3_operand_get_must_use_evex(xes) == 0) &&
		 xed_encode_ntluf_YMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_YMM_N(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_YMM_B(xes,xed3_operand_get_reg2(xes)) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][1]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_UIMM8_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 4 && memcmp(xed_encode_order[22], xes->_operand_order, sizeof(xed_uint8_t)*4)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 (xed3_operand_get_must_use_evex(xes) == 0) &&
		 xed_encode_ntluf_XMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_XMM_N(xes,xed3_operand_get_reg1(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_DQ) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][2]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_UIMM8_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 4 && memcmp(xed_encode_order[22], xes->_operand_order, sizeof(xed_uint8_t)*4)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 1) &&
		 (xed3_operand_get_must_use_evex(xes) == 0) &&
		 xed_encode_ntluf_YMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_YMM_N(xes,xed3_operand_get_reg1(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_QQ) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][3]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_UIMM8_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 5 && memcmp(xed_encode_order[18], xes->_operand_order, sizeof(xed_uint8_t)*5)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 xed_encode_ntluf_XMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_XMM_N3(xes,xed3_operand_get_reg2(xes)) &&
		 xed_encode_ntluf_XMM_B3(xes,xed3_operand_get_reg3(xes)) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][4]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_UIMM8_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 5 && memcmp(xed_encode_order[18], xes->_operand_order, sizeof(xed_uint8_t)*5)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 1) &&
		 xed_encode_ntluf_YMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_YMM_N3(xes,xed3_operand_get_reg2(xes)) &&
		 xed_encode_ntluf_YMM_B3(xes,xed3_operand_get_reg3(xes)) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][5]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_UIMM8_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 5 && memcmp(xed_encode_order[18], xes->_operand_order, sizeof(xed_uint8_t)*5)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 2) &&
		 xed_encode_ntluf_ZMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_ZMM_N3(xes,xed3_operand_get_reg2(xes)) &&
		 xed_encode_ntluf_ZMM_B3(xes,xed3_operand_get_reg3(xes)) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][6]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_UIMM8_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 5 && memcmp(xed_encode_order[19], xes->_operand_order, sizeof(xed_uint8_t)*5)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 xed_encode_ntluf_XMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_XMM_N3(xes,xed3_operand_get_reg2(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_DQ) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][7]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_UIMM8_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_64_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_FULLMEM_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 5 && memcmp(xed_encode_order[19], xes->_operand_order, sizeof(xed_uint8_t)*5)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 1) &&
		 xed_encode_ntluf_YMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_YMM_N3(xes,xed3_operand_get_reg2(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_QQ) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][8]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_UIMM8_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_64_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_FULLMEM_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 5 && memcmp(xed_encode_order[19], xes->_operand_order, sizeof(xed_uint8_t)*5)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 2) &&
		 xed_encode_ntluf_ZMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_ZMM_N3(xes,xed3_operand_get_reg2(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_ZD) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][9]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_UIMM8_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_64_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_FULLMEM_BIND(xes);
       if (okay) return 1;
   }
     }
   return 0;
   (void) okay;
   (void) conditions_satisfied;
   (void) xes;
}
xed_bool_t xed_encode_group_422(xed_encoder_request_t* xes)
{
   xed_bool_t okay=1;
   xed_bool_t conditions_satisfied=0;
   xed_ptrn_func_ptr_t fb_ptrn_function;
   static const xed_uint16_t iform_ids[1][4] = {
   /*MOVDQU        */    {5033,5031,5032,5030,},
   };
   xed_uint8_t iclass_index = xed_encoder_get_iclasses_index_in_group(xes);
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_REG1) {
   conditions_satisfied = xed_encode_ntluf_XMM_B(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_XMM_R(xes,xed3_operand_get_reg1(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][0]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_IGNORE66_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_REG1) {
   conditions_satisfied = xed_encode_ntluf_XMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_XMM_B(xes,xed3_operand_get_reg1(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][1]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_IGNORE66_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_MEM0 && xes->_operand_order[1] == XED_OPERAND_REG0) {
   conditions_satisfied = (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_DQ) &&
		 xed_encode_ntluf_XMM_R(xes,xed3_operand_get_reg0(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][2]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_IGNORE66_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_MEM0) {
   conditions_satisfied = xed_encode_ntluf_XMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_DQ);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][3]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_IGNORE66_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay) return 1;
   }
     }
   return 0;
   (void) okay;
   (void) conditions_satisfied;
   (void) xes;
}
xed_bool_t xed_encode_group_423(xed_encoder_request_t* xes)
{
   xed_bool_t okay=1;
   xed_bool_t conditions_satisfied=0;
   xed_ptrn_func_ptr_t fb_ptrn_function;
   static const xed_uint16_t iform_ids[1][5] = {
   /*PREFETCH_RESERVED*/    {5039,5040,5041,5042,5043,},
   };
   xed_uint8_t iclass_index = xed_encoder_get_iclasses_index_in_group(xes);
   if (xes->_n_operand_order == 1 && xes->_operand_order[0] == XED_OPERAND_MEM0) {
   conditions_satisfied = (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_MPREFETCH);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][0]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 1 && xes->_operand_order[0] == XED_OPERAND_MEM0) {
   conditions_satisfied = (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_MPREFETCH);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][1]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 1 && xes->_operand_order[0] == XED_OPERAND_MEM0) {
   conditions_satisfied = (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_MPREFETCH);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][2]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 1 && xes->_operand_order[0] == XED_OPERAND_MEM0) {
   conditions_satisfied = (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_MPREFETCH);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][3]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 1 && xes->_operand_order[0] == XED_OPERAND_MEM0) {
   conditions_satisfied = (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_MPREFETCH);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][4]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay) return 1;
   }
     }
   return 0;
   (void) okay;
   (void) conditions_satisfied;
   (void) xes;
}
xed_bool_t xed_encode_group_424(xed_encoder_request_t* xes)
{
   xed_bool_t okay=1;
   xed_bool_t conditions_satisfied=0;
   xed_ptrn_func_ptr_t fb_ptrn_function;
   static const xed_uint16_t iform_ids[1][8] = {
   /*POP           */    {5048,5046,5047,5049,5050,5051,5045,5044,},
   };
   xed_uint8_t iclass_index = xed_encoder_get_iclasses_index_in_group(xes);
   if (xes->_n_operand_order == 1 && xes->_operand_order[0] == XED_OPERAND_REG0) {
   conditions_satisfied = (xed3_operand_get_mode(xes) != 2) &&
		 (xed3_operand_get_reg0(xes) == XED_REG_DS);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][0]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 1 && xes->_operand_order[0] == XED_OPERAND_REG0) {
   conditions_satisfied = (xed3_operand_get_mode(xes) != 2) &&
		 (xed3_operand_get_reg0(xes) == XED_REG_ES);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][1]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 1 && xes->_operand_order[0] == XED_OPERAND_REG0) {
   conditions_satisfied = (xed3_operand_get_mode(xes) != 2) &&
		 (xed3_operand_get_reg0(xes) == XED_REG_SS);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][2]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 1 && xes->_operand_order[0] == XED_OPERAND_REG0) {
   conditions_satisfied = xed_encode_ntluf_GPRv_SB(xes,xed3_operand_get_reg0(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][3]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_DF64_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 1 && xes->_operand_order[0] == XED_OPERAND_REG0) {
   conditions_satisfied = (xed3_operand_get_reg0(xes) == XED_REG_FS);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][4]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_DF64_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 1 && xes->_operand_order[0] == XED_OPERAND_REG0) {
   conditions_satisfied = (xed3_operand_get_reg0(xes) == XED_REG_GS);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][5]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_DF64_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 1 && xes->_operand_order[0] == XED_OPERAND_REG0) {
   conditions_satisfied = xed_encode_ntluf_GPRv_B(xes,xed3_operand_get_reg0(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][6]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_DF64_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 1 && xes->_operand_order[0] == XED_OPERAND_MEM0) {
   conditions_satisfied = (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_V);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][7]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_DF64_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay) return 1;
   }
     }
   return 0;
   (void) okay;
   (void) conditions_satisfied;
   (void) xes;
}
xed_bool_t xed_encode_group_425(xed_encoder_request_t* xes)
{
   xed_bool_t okay=1;
   xed_bool_t conditions_satisfied=0;
   xed_ptrn_func_ptr_t fb_ptrn_function;
   static const xed_uint16_t iform_ids[1][4] = {
   /*BNDLDX        */    {5072,5073,5074,5075,},
   };
   xed_uint8_t iclass_index = xed_encoder_get_iclasses_index_in_group(xes);
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_MEM0) {
   conditions_satisfied = (xed3_operand_get_mpxmode(xes) == 1) &&
		 (xed3_operand_get_mode(xes) != 2) &&
		 (xed3_operand_get_easz(xes) == 2) &&
		 xed_encode_ntluf_BND_R(xes,xed3_operand_get_reg0(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_BND32);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][0]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_MEM0) {
   conditions_satisfied = (xed3_operand_get_mpxmode(xes) == 1) &&
		 (xed3_operand_get_mode(xes) == 2) &&
		 xed_encode_ntluf_BND_R(xes,xed3_operand_get_reg0(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_BND64);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][1]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_MEM0) {
   conditions_satisfied = (xed3_operand_get_mpxmode(xes) == 1) &&
		 (xed3_operand_get_mode(xes) == 2) &&
		 xed_encode_ntluf_BND_R(xes,xed3_operand_get_reg0(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_BND64);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][2]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_MEM0) {
   conditions_satisfied = (xed3_operand_get_mpxmode(xes) == 1) &&
		 (xed3_operand_get_mode(xes) == 2) &&
		 xed_encode_ntluf_BND_R(xes,xed3_operand_get_reg0(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_BND64);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][3]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay) return 1;
   }
     }
   return 0;
   (void) okay;
   (void) conditions_satisfied;
   (void) xes;
}
xed_bool_t xed_encode_group_426(xed_encoder_request_t* xes)
{
   xed_bool_t okay=1;
   xed_bool_t conditions_satisfied=0;
   xed_ptrn_func_ptr_t fb_ptrn_function;
   static const xed_uint16_t iform_ids[2][1] = {
   /*INT           */    {5087,},
   /*XABORT        */    {5786,},
   };
   xed_uint8_t iclass_index = xed_encoder_get_iclasses_index_in_group(xes);
   if (xes->_n_operand_order == 1 && xes->_operand_order[0] == XED_OPERAND_IMM0) {
   conditions_satisfied = (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][0]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_UIMM8_BIND(xes);
       if (okay) return 1;
   }
     }
   return 0;
   (void) okay;
   (void) conditions_satisfied;
   (void) xes;
}
xed_bool_t xed_encode_group_427(xed_encoder_request_t* xes)
{
   xed_bool_t okay=1;
   xed_bool_t conditions_satisfied=0;
   xed_ptrn_func_ptr_t fb_ptrn_function;
   static const xed_uint16_t iform_ids[2][4] = {
   /*VMOVHPD       */    {6704,6703,6706,6705,},
   /*VMOVLPD       */    {5089,5088,5091,5090,},
   };
   xed_uint8_t iclass_index = xed_encoder_get_iclasses_index_in_group(xes);
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_MEM0 && xes->_operand_order[1] == XED_OPERAND_REG0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 (xed3_operand_get_must_use_evex(xes) == 0) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_Q) &&
		 xed_encode_ntluf_XMM_R(xes,xed3_operand_get_reg0(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][0]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[14], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 (xed3_operand_get_must_use_evex(xes) == 0) &&
		 xed_encode_ntluf_XMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_XMM_N(xes,xed3_operand_get_reg1(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_Q);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][1]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_MEM0 && xes->_operand_order[1] == XED_OPERAND_REG0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_Q) &&
		 xed_encode_ntluf_XMM_R3(xes,xed3_operand_get_reg0(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][2]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_64_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_SCALAR_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[14], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 xed_encode_ntluf_XMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_XMM_N3(xes,xed3_operand_get_reg1(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_Q);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][3]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_64_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_SCALAR_BIND(xes);
       if (okay) return 1;
   }
     }
   return 0;
   (void) okay;
   (void) conditions_satisfied;
   (void) xes;
}
xed_bool_t xed_encode_group_428(xed_encoder_request_t* xes)
{
   xed_bool_t okay=1;
   xed_bool_t conditions_satisfied=0;
   xed_ptrn_func_ptr_t fb_ptrn_function;
   static const xed_uint16_t iform_ids[1][2] = {
   /*MOVDIR64B     */    {5092,5093,},
   };
   xed_uint8_t iclass_index = xed_encoder_get_iclasses_index_in_group(xes);
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_MEM0) {
   conditions_satisfied = (xed3_operand_get_mode(xes) != 2) &&
		 xed_encode_ntluf_A_GPR_R(xes,xed3_operand_get_reg0(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_ZD);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][0]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_MEM0) {
   conditions_satisfied = (xed3_operand_get_mode(xes) == 2) &&
		 xed_encode_ntluf_A_GPR_R(xes,xed3_operand_get_reg0(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_ZD);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][1]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay) return 1;
   }
     }
   return 0;
   (void) okay;
   (void) conditions_satisfied;
   (void) xes;
}
xed_bool_t xed_encode_group_429(xed_encoder_request_t* xes)
{
   xed_bool_t okay=1;
   xed_bool_t conditions_satisfied=0;
   xed_ptrn_func_ptr_t fb_ptrn_function;
   static const xed_uint16_t iform_ids[1][2] = {
   /*CMPSD_XMM     */    {5095,5094,},
   };
   xed_uint8_t iclass_index = xed_encoder_get_iclasses_index_in_group(xes);
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[15], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = xed_encode_ntluf_XMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_XMM_B(xes,xed3_operand_get_reg1(xes)) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][0]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_IGNORE66_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_UIMM8_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[20], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = xed_encode_ntluf_XMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_SD) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][1]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_IGNORE66_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_UIMM8_BIND(xes);
       if (okay) return 1;
   }
     }
   return 0;
   (void) okay;
   (void) conditions_satisfied;
   (void) xes;
}
xed_bool_t xed_encode_group_430(xed_encoder_request_t* xes)
{
   xed_bool_t okay=1;
   xed_bool_t conditions_satisfied=0;
   xed_ptrn_func_ptr_t fb_ptrn_function;
   static const xed_uint16_t iform_ids[1][1] = {
   /*MOVMSKPD      */    {5096,},
   };
   xed_uint8_t iclass_index = xed_encoder_get_iclasses_index_in_group(xes);
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_REG1) {
   conditions_satisfied = xed_encode_ntluf_GPR32_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_XMM_B(xes,xed3_operand_get_reg1(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][0]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_REFINING66_BIND(xes);
       if (okay) return 1;
   }
     }
   return 0;
   (void) okay;
   (void) conditions_satisfied;
   (void) xes;
}
xed_bool_t xed_encode_group_431(xed_encoder_request_t* xes)
{
   xed_bool_t okay=1;
   xed_bool_t conditions_satisfied=0;
   xed_ptrn_func_ptr_t fb_ptrn_function;
   static const xed_uint16_t iform_ids[1][2] = {
   /*LAR           */    {5105,5104,},
   };
   xed_uint8_t iclass_index = xed_encoder_get_iclasses_index_in_group(xes);
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_REG1) {
   conditions_satisfied = xed_encode_ntluf_GPRv_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_GPRv_B(xes,xed3_operand_get_reg1(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][0]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_MEM0) {
   conditions_satisfied = xed_encode_ntluf_GPRv_R(xes,xed3_operand_get_reg0(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_W);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][1]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay) return 1;
   }
     }
   return 0;
   (void) okay;
   (void) conditions_satisfied;
   (void) xes;
}
xed_bool_t xed_encode_group_432(xed_encoder_request_t* xes)
{
   xed_bool_t okay=1;
   xed_bool_t conditions_satisfied=0;
   xed_ptrn_func_ptr_t fb_ptrn_function;
   static const xed_uint16_t iform_ids[1][2] = {
   /*PINSRD        */    {5118,5117,},
   };
   xed_uint8_t iclass_index = xed_encoder_get_iclasses_index_in_group(xes);
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[15], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = xed_encode_ntluf_XMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_GPR32_B(xes,xed3_operand_get_reg1(xes)) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][0]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_REFINING66_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_UIMM8_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[20], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = xed_encode_ntluf_XMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_D) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][1]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_REFINING66_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_UIMM8_BIND(xes);
       if (okay) return 1;
   }
     }
   return 0;
   (void) okay;
   (void) conditions_satisfied;
   (void) xes;
}
xed_bool_t xed_encode_group_433(xed_encoder_request_t* xes)
{
   xed_bool_t okay=1;
   xed_bool_t conditions_satisfied=0;
   xed_ptrn_func_ptr_t fb_ptrn_function;
   static const xed_uint16_t iform_ids[1][2] = {
   /*PREFETCHW     */    {5186,5187,},
   };
   xed_uint8_t iclass_index = xed_encoder_get_iclasses_index_in_group(xes);
   if (xes->_n_operand_order == 1 && xes->_operand_order[0] == XED_OPERAND_MEM0) {
   conditions_satisfied = (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_MPREFETCH);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][0]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 1 && xes->_operand_order[0] == XED_OPERAND_MEM0) {
   conditions_satisfied = (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_MPREFETCH);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][1]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay) return 1;
   }
     }
   return 0;
   (void) okay;
   (void) conditions_satisfied;
   (void) xes;
}
xed_bool_t xed_encode_group_434(xed_encoder_request_t* xes)
{
   xed_bool_t okay=1;
   xed_bool_t conditions_satisfied=0;
   xed_ptrn_func_ptr_t fb_ptrn_function;
   static const xed_uint16_t iform_ids[1][10] = {
   /*VSHUFPS       */    {5208,5210,5207,5209,5213,5215,5211,5214,5216,5212,},
   };
   xed_uint8_t iclass_index = xed_encoder_get_iclasses_index_in_group(xes);
   if (xes->_n_operand_order == 4 && memcmp(xed_encode_order[21], xes->_operand_order, sizeof(xed_uint8_t)*4)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 (xed3_operand_get_must_use_evex(xes) == 0) &&
		 xed_encode_ntluf_XMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_XMM_N(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_XMM_B(xes,xed3_operand_get_reg2(xes)) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][0]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_UIMM8_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 4 && memcmp(xed_encode_order[21], xes->_operand_order, sizeof(xed_uint8_t)*4)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 1) &&
		 (xed3_operand_get_must_use_evex(xes) == 0) &&
		 xed_encode_ntluf_YMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_YMM_N(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_YMM_B(xes,xed3_operand_get_reg2(xes)) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][1]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_UIMM8_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 4 && memcmp(xed_encode_order[22], xes->_operand_order, sizeof(xed_uint8_t)*4)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 (xed3_operand_get_must_use_evex(xes) == 0) &&
		 xed_encode_ntluf_XMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_XMM_N(xes,xed3_operand_get_reg1(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_DQ) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][2]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_UIMM8_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 4 && memcmp(xed_encode_order[22], xes->_operand_order, sizeof(xed_uint8_t)*4)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 1) &&
		 (xed3_operand_get_must_use_evex(xes) == 0) &&
		 xed_encode_ntluf_YMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_YMM_N(xes,xed3_operand_get_reg1(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_QQ) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][3]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_UIMM8_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 5 && memcmp(xed_encode_order[18], xes->_operand_order, sizeof(xed_uint8_t)*5)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 xed_encode_ntluf_XMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_XMM_N3(xes,xed3_operand_get_reg2(xes)) &&
		 xed_encode_ntluf_XMM_B3(xes,xed3_operand_get_reg3(xes)) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][4]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_UIMM8_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 5 && memcmp(xed_encode_order[18], xes->_operand_order, sizeof(xed_uint8_t)*5)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 1) &&
		 xed_encode_ntluf_YMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_YMM_N3(xes,xed3_operand_get_reg2(xes)) &&
		 xed_encode_ntluf_YMM_B3(xes,xed3_operand_get_reg3(xes)) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][5]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_UIMM8_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 5 && memcmp(xed_encode_order[18], xes->_operand_order, sizeof(xed_uint8_t)*5)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 2) &&
		 xed_encode_ntluf_ZMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_ZMM_N3(xes,xed3_operand_get_reg2(xes)) &&
		 xed_encode_ntluf_ZMM_B3(xes,xed3_operand_get_reg3(xes)) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][6]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_UIMM8_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 5 && memcmp(xed_encode_order[19], xes->_operand_order, sizeof(xed_uint8_t)*5)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 xed_encode_ntluf_XMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_XMM_N3(xes,xed3_operand_get_reg2(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_VV) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][7]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_UIMM8_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_32_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_FULL_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 5 && memcmp(xed_encode_order[19], xes->_operand_order, sizeof(xed_uint8_t)*5)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 1) &&
		 xed_encode_ntluf_YMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_YMM_N3(xes,xed3_operand_get_reg2(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_VV) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][8]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_UIMM8_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_32_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_FULL_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 5 && memcmp(xed_encode_order[19], xes->_operand_order, sizeof(xed_uint8_t)*5)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 2) &&
		 xed_encode_ntluf_ZMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_ZMM_N3(xes,xed3_operand_get_reg2(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_VV) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][9]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_UIMM8_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_32_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_FULL_BIND(xes);
       if (okay) return 1;
   }
     }
   return 0;
   (void) okay;
   (void) conditions_satisfied;
   (void) xes;
}
xed_bool_t xed_encode_group_435(xed_encoder_request_t* xes)
{
   xed_bool_t okay=1;
   xed_bool_t conditions_satisfied=0;
   xed_ptrn_func_ptr_t fb_ptrn_function;
   static const xed_uint16_t iform_ids[1][11] = {
   /*VCVTTPS2DQ    */    {5227,5223,5225,5222,5224,5229,5231,5226,5230,5232,5228,},
   };
   xed_uint8_t iclass_index = xed_encoder_get_iclasses_index_in_group(xes);
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[7], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_sae(xes) != 0) &&
		 xed_encode_ntluf_ZMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_ZMM_B3(xes,xed3_operand_get_reg2(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][0]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_FIX_ROUND_LEN512_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_SAE_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_REG1) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 (xed3_operand_get_must_use_evex(xes) == 0) &&
		 xed_encode_ntluf_XMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_XMM_B(xes,xed3_operand_get_reg1(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][1]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_REG1) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 1) &&
		 (xed3_operand_get_must_use_evex(xes) == 0) &&
		 xed_encode_ntluf_YMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_YMM_B(xes,xed3_operand_get_reg1(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][2]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_MEM0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 (xed3_operand_get_must_use_evex(xes) == 0) &&
		 xed_encode_ntluf_XMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_DQ);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][3]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_MEM0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 1) &&
		 (xed3_operand_get_must_use_evex(xes) == 0) &&
		 xed_encode_ntluf_YMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_QQ);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][4]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[7], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 xed_encode_ntluf_XMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_XMM_B3(xes,xed3_operand_get_reg2(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][5]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[7], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 1) &&
		 xed_encode_ntluf_YMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_YMM_B3(xes,xed3_operand_get_reg2(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][6]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[7], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 2) &&
		 xed_encode_ntluf_ZMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_ZMM_B3(xes,xed3_operand_get_reg2(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][7]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[14], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 xed_encode_ntluf_XMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_VV);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][8]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_32_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_FULL_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[14], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 1) &&
		 xed_encode_ntluf_YMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_VV);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][9]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_32_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_FULL_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[14], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 2) &&
		 xed_encode_ntluf_ZMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_VV);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][10]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_32_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_FULL_BIND(xes);
       if (okay) return 1;
   }
     }
   return 0;
   (void) okay;
   (void) conditions_satisfied;
   (void) xes;
}
xed_bool_t xed_encode_group_436(xed_encoder_request_t* xes)
{
   xed_bool_t okay=1;
   xed_bool_t conditions_satisfied=0;
   xed_ptrn_func_ptr_t fb_ptrn_function;
   static const xed_uint16_t iform_ids[1][24] = {
   /*SHL           */    {5285,5287,5289,5291,5284,5286,5288,5290,5277,5279,5269,5271,5281,5283,5273,5275,5276,5278,5268,5270,5280,5282,5272,5274,},
   };
   xed_uint8_t iclass_index = xed_encoder_get_iclasses_index_in_group(xes);
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_REG1) {
   conditions_satisfied = xed_encode_ntluf_GPR8_B(xes,xed3_operand_get_reg0(xes)) &&
		 (xed3_operand_get_reg1(xes) == XED_REG_CL);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][0]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_REG1) {
   conditions_satisfied = xed_encode_ntluf_GPR8_B(xes,xed3_operand_get_reg0(xes)) &&
		 (xed3_operand_get_reg1(xes) == XED_REG_CL);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][1]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_REG1) {
   conditions_satisfied = xed_encode_ntluf_GPRv_B(xes,xed3_operand_get_reg0(xes)) &&
		 (xed3_operand_get_reg1(xes) == XED_REG_CL);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][2]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_REG1) {
   conditions_satisfied = xed_encode_ntluf_GPRv_B(xes,xed3_operand_get_reg0(xes)) &&
		 (xed3_operand_get_reg1(xes) == XED_REG_CL);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][3]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_MEM0 && xes->_operand_order[1] == XED_OPERAND_REG0) {
   conditions_satisfied = (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_B) &&
		 (xed3_operand_get_reg0(xes) == XED_REG_CL);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][4]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_MEM0 && xes->_operand_order[1] == XED_OPERAND_REG0) {
   conditions_satisfied = (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_B) &&
		 (xed3_operand_get_reg0(xes) == XED_REG_CL);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][5]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_MEM0 && xes->_operand_order[1] == XED_OPERAND_REG0) {
   conditions_satisfied = (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_V) &&
		 (xed3_operand_get_reg0(xes) == XED_REG_CL);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][6]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_MEM0 && xes->_operand_order[1] == XED_OPERAND_REG0) {
   conditions_satisfied = (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_V) &&
		 (xed3_operand_get_reg0(xes) == XED_REG_CL);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][7]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_IMM0) {
   conditions_satisfied = xed_encode_ntluf_GPR8_B(xes,xed3_operand_get_reg0(xes)) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][8]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_ONE_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_IMM0) {
   conditions_satisfied = xed_encode_ntluf_GPR8_B(xes,xed3_operand_get_reg0(xes)) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][9]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_ONE_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_IMM0) {
   conditions_satisfied = xed_encode_ntluf_GPR8_B(xes,xed3_operand_get_reg0(xes)) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][10]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_UIMM8_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_IMM0) {
   conditions_satisfied = xed_encode_ntluf_GPR8_B(xes,xed3_operand_get_reg0(xes)) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][11]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_UIMM8_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_IMM0) {
   conditions_satisfied = xed_encode_ntluf_GPRv_B(xes,xed3_operand_get_reg0(xes)) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][12]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_ONE_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_IMM0) {
   conditions_satisfied = xed_encode_ntluf_GPRv_B(xes,xed3_operand_get_reg0(xes)) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][13]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_ONE_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_IMM0) {
   conditions_satisfied = xed_encode_ntluf_GPRv_B(xes,xed3_operand_get_reg0(xes)) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][14]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_UIMM8_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_IMM0) {
   conditions_satisfied = xed_encode_ntluf_GPRv_B(xes,xed3_operand_get_reg0(xes)) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][15]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_UIMM8_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_MEM0 && xes->_operand_order[1] == XED_OPERAND_IMM0) {
   conditions_satisfied = (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_B) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][16]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ONE_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_MEM0 && xes->_operand_order[1] == XED_OPERAND_IMM0) {
   conditions_satisfied = (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_B) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][17]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ONE_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_MEM0 && xes->_operand_order[1] == XED_OPERAND_IMM0) {
   conditions_satisfied = (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_B) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][18]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_UIMM8_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_MEM0 && xes->_operand_order[1] == XED_OPERAND_IMM0) {
   conditions_satisfied = (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_B) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][19]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_UIMM8_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_MEM0 && xes->_operand_order[1] == XED_OPERAND_IMM0) {
   conditions_satisfied = (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_V) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][20]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ONE_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_MEM0 && xes->_operand_order[1] == XED_OPERAND_IMM0) {
   conditions_satisfied = (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_V) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][21]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ONE_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_MEM0 && xes->_operand_order[1] == XED_OPERAND_IMM0) {
   conditions_satisfied = (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_V) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][22]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_UIMM8_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_MEM0 && xes->_operand_order[1] == XED_OPERAND_IMM0) {
   conditions_satisfied = (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_V) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][23]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_UIMM8_BIND(xes);
       if (okay) return 1;
   }
     }
   return 0;
   (void) okay;
   (void) conditions_satisfied;
   (void) xes;
}
xed_bool_t xed_encode_group_437(xed_encoder_request_t* xes)
{
   xed_bool_t okay=1;
   xed_bool_t conditions_satisfied=0;
   xed_ptrn_func_ptr_t fb_ptrn_function;
   static const xed_uint16_t iform_ids[1][1] = {
   /*SKINIT        */    {5306,},
   };
   xed_uint8_t iclass_index = xed_encoder_get_iclasses_index_in_group(xes);
   if (xes->_n_operand_order == 1 && xes->_operand_order[0] == XED_OPERAND_REG0) {
   conditions_satisfied = (xed3_operand_get_reg0(xes) == XED_REG_EAX);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][0]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   return 0;
   (void) okay;
   (void) conditions_satisfied;
   (void) xes;
}
xed_bool_t xed_encode_group_438(xed_encoder_request_t* xes)
{
   xed_bool_t okay=1;
   xed_bool_t conditions_satisfied=0;
   xed_ptrn_func_ptr_t fb_ptrn_function;
   static const xed_uint16_t iform_ids[2][6] = {
   /*VPROLQ        */    {6737,6739,6735,6738,6740,6736,},
   /*VPRORQ        */    {5309,5311,5307,5310,5312,5308,},
   };
   xed_uint8_t iclass_index = xed_encoder_get_iclasses_index_in_group(xes);
   if (xes->_n_operand_order == 4 && memcmp(xed_encode_order[21], xes->_operand_order, sizeof(xed_uint8_t)*4)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 xed_encode_ntluf_XMM_N3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_XMM_B3(xes,xed3_operand_get_reg2(xes)) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][0]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_UIMM8_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 4 && memcmp(xed_encode_order[21], xes->_operand_order, sizeof(xed_uint8_t)*4)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 1) &&
		 xed_encode_ntluf_YMM_N3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_YMM_B3(xes,xed3_operand_get_reg2(xes)) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][1]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_UIMM8_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 4 && memcmp(xed_encode_order[21], xes->_operand_order, sizeof(xed_uint8_t)*4)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 2) &&
		 xed_encode_ntluf_ZMM_N3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_ZMM_B3(xes,xed3_operand_get_reg2(xes)) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][2]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_UIMM8_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 4 && memcmp(xed_encode_order[22], xes->_operand_order, sizeof(xed_uint8_t)*4)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 xed_encode_ntluf_XMM_N3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_VV) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][3]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_UIMM8_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_64_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_FULL_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 4 && memcmp(xed_encode_order[22], xes->_operand_order, sizeof(xed_uint8_t)*4)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 1) &&
		 xed_encode_ntluf_YMM_N3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_VV) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][4]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_UIMM8_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_64_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_FULL_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 4 && memcmp(xed_encode_order[22], xes->_operand_order, sizeof(xed_uint8_t)*4)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 2) &&
		 xed_encode_ntluf_ZMM_N3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_VV) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][5]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_UIMM8_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_64_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_FULL_BIND(xes);
       if (okay) return 1;
   }
     }
   return 0;
   (void) okay;
   (void) conditions_satisfied;
   (void) xes;
}
xed_bool_t xed_encode_group_439(xed_encoder_request_t* xes)
{
   xed_bool_t okay=1;
   xed_bool_t conditions_satisfied=0;
   xed_ptrn_func_ptr_t fb_ptrn_function;
   static const xed_uint16_t iform_ids[2][10] = {
   /*VPERMPD       */    {6002,6001,6009,6005,6007,6003,6010,6006,6008,6004,},
   /*VPERMQ        */    {5337,5336,5344,5340,5342,5338,5345,5341,5343,5339,},
   };
   xed_uint8_t iclass_index = xed_encoder_get_iclasses_index_in_group(xes);
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[15], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 1) &&
		 (xed3_operand_get_must_use_evex(xes) == 0) &&
		 xed_encode_ntluf_YMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_YMM_B(xes,xed3_operand_get_reg1(xes)) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][0]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_UIMM8_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[20], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 1) &&
		 (xed3_operand_get_must_use_evex(xes) == 0) &&
		 xed_encode_ntluf_YMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_QQ) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][1]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_UIMM8_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 4 && memcmp(xed_encode_order[12], xes->_operand_order, sizeof(xed_uint8_t)*4)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 1) &&
		 xed_encode_ntluf_YMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_YMM_N3(xes,xed3_operand_get_reg2(xes)) &&
		 xed_encode_ntluf_YMM_B3(xes,xed3_operand_get_reg3(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][2]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 4 && memcmp(xed_encode_order[12], xes->_operand_order, sizeof(xed_uint8_t)*4)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 2) &&
		 xed_encode_ntluf_ZMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_ZMM_N3(xes,xed3_operand_get_reg2(xes)) &&
		 xed_encode_ntluf_ZMM_B3(xes,xed3_operand_get_reg3(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][3]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 4 && memcmp(xed_encode_order[21], xes->_operand_order, sizeof(xed_uint8_t)*4)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 1) &&
		 xed_encode_ntluf_YMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_YMM_B3(xes,xed3_operand_get_reg2(xes)) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][4]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_UIMM8_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 4 && memcmp(xed_encode_order[21], xes->_operand_order, sizeof(xed_uint8_t)*4)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 2) &&
		 xed_encode_ntluf_ZMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_ZMM_B3(xes,xed3_operand_get_reg2(xes)) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][5]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_UIMM8_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 4 && memcmp(xed_encode_order[13], xes->_operand_order, sizeof(xed_uint8_t)*4)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 1) &&
		 xed_encode_ntluf_YMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_YMM_N3(xes,xed3_operand_get_reg2(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_VV);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][6]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_64_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_FULL_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 4 && memcmp(xed_encode_order[13], xes->_operand_order, sizeof(xed_uint8_t)*4)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 2) &&
		 xed_encode_ntluf_ZMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_ZMM_N3(xes,xed3_operand_get_reg2(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_VV);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][7]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_64_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_FULL_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 4 && memcmp(xed_encode_order[22], xes->_operand_order, sizeof(xed_uint8_t)*4)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 1) &&
		 xed_encode_ntluf_YMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_VV) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][8]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_UIMM8_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_64_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_FULL_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 4 && memcmp(xed_encode_order[22], xes->_operand_order, sizeof(xed_uint8_t)*4)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 2) &&
		 xed_encode_ntluf_ZMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_VV) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][9]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_UIMM8_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_64_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_FULL_BIND(xes);
       if (okay) return 1;
   }
     }
   return 0;
   (void) okay;
   (void) conditions_satisfied;
   (void) xes;
}
xed_bool_t xed_encode_group_440(xed_encoder_request_t* xes)
{
   xed_bool_t okay=1;
   xed_bool_t conditions_satisfied=0;
   xed_ptrn_func_ptr_t fb_ptrn_function;
   static const xed_uint16_t iform_ids[2][6] = {
   /*VEXPANDPS     */    {5390,5392,5388,5389,5391,5387,},
   /*VPEXPANDD     */    {6084,6086,6082,6083,6085,6081,},
   };
   xed_uint8_t iclass_index = xed_encoder_get_iclasses_index_in_group(xes);
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[7], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 xed_encode_ntluf_XMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_XMM_B3(xes,xed3_operand_get_reg2(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][0]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[7], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 1) &&
		 xed_encode_ntluf_YMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_YMM_B3(xes,xed3_operand_get_reg2(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][1]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[7], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 2) &&
		 xed_encode_ntluf_ZMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_ZMM_B3(xes,xed3_operand_get_reg2(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][2]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[14], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 xed_encode_ntluf_XMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_DQ);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][3]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_32_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_GSCAT_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[14], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 1) &&
		 xed_encode_ntluf_YMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_QQ);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][4]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_32_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_GSCAT_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[14], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 2) &&
		 xed_encode_ntluf_ZMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_ZD);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][5]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_32_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_GSCAT_BIND(xes);
       if (okay) return 1;
   }
     }
   return 0;
   (void) okay;
   (void) conditions_satisfied;
   (void) xes;
}
xed_bool_t xed_encode_group_441(xed_encoder_request_t* xes)
{
   xed_bool_t okay=1;
   xed_bool_t conditions_satisfied=0;
   xed_ptrn_func_ptr_t fb_ptrn_function;
   static const xed_uint16_t iform_ids[2][2] = {
   /*VAESKEYGENASSIST*/    {5411,5412,},
   /*VPCMPISTRM    */    {6107,6106,},
   };
   xed_uint8_t iclass_index = xed_encoder_get_iclasses_index_in_group(xes);
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[15], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 (xed3_operand_get_must_use_evex(xes) == 0) &&
		 xed_encode_ntluf_XMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_XMM_B(xes,xed3_operand_get_reg1(xes)) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][0]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_UIMM8_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[20], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 (xed3_operand_get_must_use_evex(xes) == 0) &&
		 xed_encode_ntluf_XMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_DQ) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][1]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_UIMM8_BIND(xes);
       if (okay) return 1;
   }
     }
   return 0;
   (void) okay;
   (void) conditions_satisfied;
   (void) xes;
}
xed_bool_t xed_encode_group_442(xed_encoder_request_t* xes)
{
   xed_bool_t okay=1;
   xed_bool_t conditions_satisfied=0;
   xed_ptrn_func_ptr_t fb_ptrn_function;
   static const xed_uint16_t iform_ids[2][18] = {
   /*VPSLLQ        */    {6335,6338,6336,6334,6339,6337,6344,6348,6340,6346,6350,6342,6345,6349,6341,6347,6351,6343,},
   /*VPSRLQ        */    {5453,5456,5454,5452,5457,5455,5462,5466,5458,5464,5468,5460,5463,5467,5459,5465,5469,5461,},
   };
   xed_uint8_t iclass_index = xed_encoder_get_iclasses_index_in_group(xes);
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[7], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 (xed3_operand_get_must_use_evex(xes) == 0) &&
		 xed_encode_ntluf_XMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_XMM_N(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_XMM_B(xes,xed3_operand_get_reg2(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][0]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[7], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 1) &&
		 (xed3_operand_get_must_use_evex(xes) == 0) &&
		 xed_encode_ntluf_YMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_YMM_N(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_XMM_B(xes,xed3_operand_get_reg2(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][1]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[15], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 (xed3_operand_get_must_use_evex(xes) == 0) &&
		 xed_encode_ntluf_XMM_N(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_XMM_B(xes,xed3_operand_get_reg1(xes)) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][2]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_UIMM8_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[14], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 (xed3_operand_get_must_use_evex(xes) == 0) &&
		 xed_encode_ntluf_XMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_XMM_N(xes,xed3_operand_get_reg1(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_DQ);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][3]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[15], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 1) &&
		 (xed3_operand_get_must_use_evex(xes) == 0) &&
		 xed_encode_ntluf_YMM_N(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_YMM_B(xes,xed3_operand_get_reg1(xes)) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][4]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_UIMM8_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[14], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 1) &&
		 (xed3_operand_get_must_use_evex(xes) == 0) &&
		 xed_encode_ntluf_YMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_YMM_N(xes,xed3_operand_get_reg1(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_DQ);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][5]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 4 && memcmp(xed_encode_order[12], xes->_operand_order, sizeof(xed_uint8_t)*4)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 xed_encode_ntluf_XMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_XMM_N3(xes,xed3_operand_get_reg2(xes)) &&
		 xed_encode_ntluf_XMM_B3(xes,xed3_operand_get_reg3(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][6]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 4 && memcmp(xed_encode_order[12], xes->_operand_order, sizeof(xed_uint8_t)*4)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 1) &&
		 xed_encode_ntluf_YMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_YMM_N3(xes,xed3_operand_get_reg2(xes)) &&
		 xed_encode_ntluf_XMM_B3(xes,xed3_operand_get_reg3(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][7]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 4 && memcmp(xed_encode_order[12], xes->_operand_order, sizeof(xed_uint8_t)*4)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 2) &&
		 xed_encode_ntluf_ZMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_ZMM_N3(xes,xed3_operand_get_reg2(xes)) &&
		 xed_encode_ntluf_XMM_B3(xes,xed3_operand_get_reg3(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][8]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 4 && memcmp(xed_encode_order[21], xes->_operand_order, sizeof(xed_uint8_t)*4)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 xed_encode_ntluf_XMM_N3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_XMM_B3(xes,xed3_operand_get_reg2(xes)) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][9]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_UIMM8_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 4 && memcmp(xed_encode_order[21], xes->_operand_order, sizeof(xed_uint8_t)*4)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 1) &&
		 xed_encode_ntluf_YMM_N3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_YMM_B3(xes,xed3_operand_get_reg2(xes)) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][10]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_UIMM8_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 4 && memcmp(xed_encode_order[21], xes->_operand_order, sizeof(xed_uint8_t)*4)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 2) &&
		 xed_encode_ntluf_ZMM_N3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_ZMM_B3(xes,xed3_operand_get_reg2(xes)) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][11]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_UIMM8_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 4 && memcmp(xed_encode_order[13], xes->_operand_order, sizeof(xed_uint8_t)*4)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 xed_encode_ntluf_XMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_XMM_N3(xes,xed3_operand_get_reg2(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_DQ);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][12]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_64_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_MEM128_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 4 && memcmp(xed_encode_order[13], xes->_operand_order, sizeof(xed_uint8_t)*4)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 1) &&
		 xed_encode_ntluf_YMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_YMM_N3(xes,xed3_operand_get_reg2(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_DQ);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][13]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_64_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_MEM128_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 4 && memcmp(xed_encode_order[13], xes->_operand_order, sizeof(xed_uint8_t)*4)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 2) &&
		 xed_encode_ntluf_ZMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_ZMM_N3(xes,xed3_operand_get_reg2(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_DQ);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][14]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_64_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_MEM128_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 4 && memcmp(xed_encode_order[22], xes->_operand_order, sizeof(xed_uint8_t)*4)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 xed_encode_ntluf_XMM_N3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_VV) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][15]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_UIMM8_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_64_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_FULL_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 4 && memcmp(xed_encode_order[22], xes->_operand_order, sizeof(xed_uint8_t)*4)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 1) &&
		 xed_encode_ntluf_YMM_N3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_VV) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][16]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_UIMM8_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_64_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_FULL_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 4 && memcmp(xed_encode_order[22], xes->_operand_order, sizeof(xed_uint8_t)*4)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 2) &&
		 xed_encode_ntluf_ZMM_N3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_VV) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][17]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_UIMM8_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_64_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_FULL_BIND(xes);
       if (okay) return 1;
   }
     }
   return 0;
   (void) okay;
   (void) conditions_satisfied;
   (void) xes;
}
xed_bool_t xed_encode_group_443(xed_encoder_request_t* xes)
{
   xed_bool_t okay=1;
   xed_bool_t conditions_satisfied=0;
   xed_ptrn_func_ptr_t fb_ptrn_function;
   static const xed_uint16_t iform_ids[1][15] = {
   /*VCVTTSD2SI    */    {5523,5524,5528,5516,5518,5520,5515,5517,5519,5521,5522,5527,5525,5526,5529,},
   };
   xed_uint8_t iclass_index = xed_encoder_get_iclasses_index_in_group(xes);
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_REG1) {
   conditions_satisfied = (xed3_operand_get_sae(xes) != 0) &&
		 (xed3_operand_get_mode(xes) != 2) &&
		 xed_encode_ntluf_GPR32_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_XMM_B3(xes,xed3_operand_get_reg1(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][0]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_FIX_ROUND_LEN128_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_SAE_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_REG1) {
   conditions_satisfied = (xed3_operand_get_sae(xes) != 0) &&
		 (xed3_operand_get_mode(xes) == 2) &&
		 xed_encode_ntluf_GPR32_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_XMM_B3(xes,xed3_operand_get_reg1(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][1]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_FIX_ROUND_LEN128_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_SAE_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_REG1) {
   conditions_satisfied = (xed3_operand_get_sae(xes) != 0) &&
		 (xed3_operand_get_mode(xes) == 2) &&
		 xed_encode_ntluf_GPR64_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_XMM_B3(xes,xed3_operand_get_reg1(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][2]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_FIX_ROUND_LEN128_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_SAE_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_REG1) {
   conditions_satisfied = (xed3_operand_get_mode(xes) != 2) &&
		 (xed3_operand_get_must_use_evex(xes) == 0) &&
		 xed_encode_ntluf_GPR32_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_XMM_B(xes,xed3_operand_get_reg1(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][3]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_REG1) {
   conditions_satisfied = (xed3_operand_get_mode(xes) == 2) &&
		 (xed3_operand_get_must_use_evex(xes) == 0) &&
		 xed_encode_ntluf_GPR32_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_XMM_B(xes,xed3_operand_get_reg1(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][4]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_REG1) {
   conditions_satisfied = (xed3_operand_get_mode(xes) == 2) &&
		 (xed3_operand_get_must_use_evex(xes) == 0) &&
		 xed_encode_ntluf_GPR64_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_XMM_B(xes,xed3_operand_get_reg1(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][5]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_MEM0) {
   conditions_satisfied = (xed3_operand_get_mode(xes) != 2) &&
		 (xed3_operand_get_must_use_evex(xes) == 0) &&
		 xed_encode_ntluf_GPR32_R(xes,xed3_operand_get_reg0(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_Q);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][6]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_MEM0) {
   conditions_satisfied = (xed3_operand_get_mode(xes) == 2) &&
		 (xed3_operand_get_must_use_evex(xes) == 0) &&
		 xed_encode_ntluf_GPR32_R(xes,xed3_operand_get_reg0(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_Q);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][7]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_MEM0) {
   conditions_satisfied = (xed3_operand_get_mode(xes) == 2) &&
		 (xed3_operand_get_must_use_evex(xes) == 0) &&
		 xed_encode_ntluf_GPR64_R(xes,xed3_operand_get_reg0(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_Q);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][8]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_REG1) {
   conditions_satisfied = (xed3_operand_get_mode(xes) != 2) &&
		 xed_encode_ntluf_GPR32_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_XMM_B3(xes,xed3_operand_get_reg1(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][9]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_FIX_ROUND_LEN128_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_REG1) {
   conditions_satisfied = (xed3_operand_get_mode(xes) == 2) &&
		 xed_encode_ntluf_GPR32_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_XMM_B3(xes,xed3_operand_get_reg1(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][10]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_FIX_ROUND_LEN128_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_REG1) {
   conditions_satisfied = (xed3_operand_get_mode(xes) == 2) &&
		 xed_encode_ntluf_GPR64_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_XMM_B3(xes,xed3_operand_get_reg1(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][11]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_FIX_ROUND_LEN128_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_MEM0) {
   conditions_satisfied = (xed3_operand_get_mode(xes) != 2) &&
		 xed_encode_ntluf_GPR32_R(xes,xed3_operand_get_reg0(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_Q);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][12]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_64_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_GPR_WRITER_LDOP_Q_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_FIX_ROUND_LEN128_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_MEM0) {
   conditions_satisfied = (xed3_operand_get_mode(xes) == 2) &&
		 xed_encode_ntluf_GPR32_R(xes,xed3_operand_get_reg0(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_Q);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][13]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_64_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_GPR_WRITER_LDOP_Q_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_FIX_ROUND_LEN128_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_MEM0) {
   conditions_satisfied = (xed3_operand_get_mode(xes) == 2) &&
		 xed_encode_ntluf_GPR64_R(xes,xed3_operand_get_reg0(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_Q);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][14]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_64_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_GPR_WRITER_LDOP_Q_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_FIX_ROUND_LEN128_BIND(xes);
       if (okay) return 1;
   }
     }
   return 0;
   (void) okay;
   (void) conditions_satisfied;
   (void) xes;
}
xed_bool_t xed_encode_group_444(xed_encoder_request_t* xes)
{
   xed_bool_t okay=1;
   xed_bool_t conditions_satisfied=0;
   xed_ptrn_func_ptr_t fb_ptrn_function;
   static const xed_uint16_t iform_ids[1][4] = {
   /*LZCNT         */    {5533,5535,5532,5534,},
   };
   xed_uint8_t iclass_index = xed_encoder_get_iclasses_index_in_group(xes);
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_REG1) {
   conditions_satisfied = xed_encode_ntluf_GPRv_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_GPRv_B(xes,xed3_operand_get_reg1(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][0]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_REG1) {
   conditions_satisfied = xed_encode_ntluf_GPRv_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_GPRv_B(xes,xed3_operand_get_reg1(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][1]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_MEM0) {
   conditions_satisfied = xed_encode_ntluf_GPRv_R(xes,xed3_operand_get_reg0(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_V);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][2]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_MEM0) {
   conditions_satisfied = xed_encode_ntluf_GPRv_R(xes,xed3_operand_get_reg0(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_V);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][3]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay) return 1;
   }
     }
   return 0;
   (void) okay;
   (void) conditions_satisfied;
   (void) xes;
}
xed_bool_t xed_encode_group_445(xed_encoder_request_t* xes)
{
   xed_bool_t okay=1;
   xed_bool_t conditions_satisfied=0;
   xed_ptrn_func_ptr_t fb_ptrn_function;
   static const xed_uint16_t iform_ids[1][8] = {
   /*BNDMOV        */    {5550,5546,5551,5547,5552,5548,5553,5549,},
   };
   xed_uint8_t iclass_index = xed_encoder_get_iclasses_index_in_group(xes);
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_REG1) {
   conditions_satisfied = (xed3_operand_get_mpxmode(xes) == 1) &&
		 xed_encode_ntluf_BND_B(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_BND_R(xes,xed3_operand_get_reg1(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][0]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_REFINING66_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_REG1) {
   conditions_satisfied = (xed3_operand_get_mpxmode(xes) == 1) &&
		 xed_encode_ntluf_BND_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_BND_B(xes,xed3_operand_get_reg1(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][1]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_REFINING66_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_MEM0 && xes->_operand_order[1] == XED_OPERAND_REG0) {
   conditions_satisfied = (xed3_operand_get_mpxmode(xes) == 1) &&
		 (xed3_operand_get_mode(xes) == 0) &&
		 (xed3_operand_get_easz(xes) == 2) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_Q) &&
		 xed_encode_ntluf_BND_R(xes,xed3_operand_get_reg0(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][2]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_REFINING66_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_MEM0) {
   conditions_satisfied = (xed3_operand_get_mpxmode(xes) == 1) &&
		 (xed3_operand_get_mode(xes) == 0) &&
		 (xed3_operand_get_easz(xes) == 2) &&
		 xed_encode_ntluf_BND_R(xes,xed3_operand_get_reg0(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_Q);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][3]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_REFINING66_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_MEM0 && xes->_operand_order[1] == XED_OPERAND_REG0) {
   conditions_satisfied = (xed3_operand_get_mpxmode(xes) == 1) &&
		 (xed3_operand_get_mode(xes) == 1) &&
		 (xed3_operand_get_easz(xes) == 2) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_Q) &&
		 xed_encode_ntluf_BND_R(xes,xed3_operand_get_reg0(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][4]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_REFINING66_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_MEM0) {
   conditions_satisfied = (xed3_operand_get_mpxmode(xes) == 1) &&
		 (xed3_operand_get_mode(xes) == 1) &&
		 (xed3_operand_get_easz(xes) == 2) &&
		 xed_encode_ntluf_BND_R(xes,xed3_operand_get_reg0(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_Q);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][5]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_REFINING66_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_MEM0 && xes->_operand_order[1] == XED_OPERAND_REG0) {
   conditions_satisfied = (xed3_operand_get_mpxmode(xes) == 1) &&
		 (xed3_operand_get_mode(xes) == 2) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_DQ) &&
		 xed_encode_ntluf_BND_R(xes,xed3_operand_get_reg0(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][6]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_REFINING66_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_MEM0) {
   conditions_satisfied = (xed3_operand_get_mpxmode(xes) == 1) &&
		 (xed3_operand_get_mode(xes) == 2) &&
		 xed_encode_ntluf_BND_R(xes,xed3_operand_get_reg0(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_DQ);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][7]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_REFINING66_BIND(xes);
       if (okay) return 1;
   }
     }
   return 0;
   (void) okay;
   (void) conditions_satisfied;
   (void) xes;
}
xed_bool_t xed_encode_group_446(xed_encoder_request_t* xes)
{
   xed_bool_t okay=1;
   xed_bool_t conditions_satisfied=0;
   xed_ptrn_func_ptr_t fb_ptrn_function;
   static const xed_uint16_t iform_ids[1][1] = {
   /*JRCXZ         */    {5588,},
   };
   xed_uint8_t iclass_index = xed_encoder_get_iclasses_index_in_group(xes);
   if (xes->_n_operand_order == 1 && xes->_operand_order[0] == XED_OPERAND_RELBR) {
   conditions_satisfied = (xed3_operand_get_easz(xes) == 3) &&
		 (xed3_operand_get_relbr(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][0]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_BRDISP8_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_FORCE64_BIND(xes);
       if (okay) return 1;
   }
     }
   return 0;
   (void) okay;
   (void) conditions_satisfied;
   (void) xes;
}
xed_bool_t xed_encode_group_447(xed_encoder_request_t* xes)
{
   xed_bool_t okay=1;
   xed_bool_t conditions_satisfied=0;
   xed_ptrn_func_ptr_t fb_ptrn_function;
   static const xed_uint16_t iform_ids[1][1] = {
   /*MASKMOVQ      */    {5611,},
   };
   xed_uint8_t iclass_index = xed_encoder_get_iclasses_index_in_group(xes);
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_REG1) {
   conditions_satisfied = xed_encode_ntluf_MMX_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MMX_B(xes,xed3_operand_get_reg1(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][0]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_OVERRIDE_SEG0_BIND(xes);
       if (okay) return 1;
   }
     }
   return 0;
   (void) okay;
   (void) conditions_satisfied;
   (void) xes;
}
xed_bool_t xed_encode_group_448(xed_encoder_request_t* xes)
{
   xed_bool_t okay=1;
   xed_bool_t conditions_satisfied=0;
   xed_ptrn_func_ptr_t fb_ptrn_function;
   static const xed_uint16_t iform_ids[1][2] = {
   /*REP_MONTMUL   */    {5636,5637,},
   };
   xed_uint8_t iclass_index = xed_encoder_get_iclasses_index_in_group(xes);
   if (xes->_n_operand_order == 0) {
   conditions_satisfied = (xed3_operand_get_easz(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][0]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 0) {
   conditions_satisfied = (xed3_operand_get_easz(xes) == 2);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][1]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   return 0;
   (void) okay;
   (void) conditions_satisfied;
   (void) xes;
}
xed_bool_t xed_encode_group_449(xed_encoder_request_t* xes)
{
   xed_bool_t okay=1;
   xed_bool_t conditions_satisfied=0;
   xed_ptrn_func_ptr_t fb_ptrn_function;
   static const xed_uint16_t iform_ids[2][1] = {
   /*LLWPCB        */    {6058,},
   /*SLWPCB        */    {5638,},
   };
   xed_uint8_t iclass_index = xed_encoder_get_iclasses_index_in_group(xes);
   if (xes->_n_operand_order == 1 && xes->_operand_order[0] == XED_OPERAND_REG0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 xed_encode_ntluf_GPRy_B(xes,xed3_operand_get_reg0(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][0]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   return 0;
   (void) okay;
   (void) conditions_satisfied;
   (void) xes;
}
xed_bool_t xed_encode_group_450(xed_encoder_request_t* xes)
{
   xed_bool_t okay=1;
   xed_bool_t conditions_satisfied=0;
   xed_ptrn_func_ptr_t fb_ptrn_function;
   static const xed_uint16_t iform_ids[1][16] = {
   /*VMOVD         */    {5649,5647,5653,5651,5648,5646,5652,5650,5658,5654,5659,5655,5660,5656,5661,5657,},
   };
   xed_uint8_t iclass_index = xed_encoder_get_iclasses_index_in_group(xes);
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_REG1) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 (xed3_operand_get_mode(xes) != 2) &&
		 (xed3_operand_get_must_use_evex(xes) == 0) &&
		 xed_encode_ntluf_GPR32_B(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_XMM_R(xes,xed3_operand_get_reg1(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][0]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_REG1) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 (xed3_operand_get_mode(xes) != 2) &&
		 (xed3_operand_get_must_use_evex(xes) == 0) &&
		 xed_encode_ntluf_XMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_GPR32_B(xes,xed3_operand_get_reg1(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][1]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_REG1) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 (xed3_operand_get_mode(xes) == 2) &&
		 (xed3_operand_get_must_use_evex(xes) == 0) &&
		 xed_encode_ntluf_GPR32_B(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_XMM_R(xes,xed3_operand_get_reg1(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][2]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_REG1) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 (xed3_operand_get_mode(xes) == 2) &&
		 (xed3_operand_get_must_use_evex(xes) == 0) &&
		 xed_encode_ntluf_XMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_GPR32_B(xes,xed3_operand_get_reg1(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][3]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_MEM0 && xes->_operand_order[1] == XED_OPERAND_REG0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 (xed3_operand_get_mode(xes) != 2) &&
		 (xed3_operand_get_must_use_evex(xes) == 0) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_D) &&
		 xed_encode_ntluf_XMM_R(xes,xed3_operand_get_reg0(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][4]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_MEM0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 (xed3_operand_get_mode(xes) != 2) &&
		 (xed3_operand_get_must_use_evex(xes) == 0) &&
		 xed_encode_ntluf_XMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_D);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][5]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_MEM0 && xes->_operand_order[1] == XED_OPERAND_REG0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 (xed3_operand_get_mode(xes) == 2) &&
		 (xed3_operand_get_must_use_evex(xes) == 0) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_D) &&
		 xed_encode_ntluf_XMM_R(xes,xed3_operand_get_reg0(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][6]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_MEM0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 (xed3_operand_get_mode(xes) == 2) &&
		 (xed3_operand_get_must_use_evex(xes) == 0) &&
		 xed_encode_ntluf_XMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_D);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][7]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_REG1) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 (xed3_operand_get_mode(xes) != 2) &&
		 xed_encode_ntluf_GPR32_B(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_XMM_R3(xes,xed3_operand_get_reg1(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][8]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_REG1) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 (xed3_operand_get_mode(xes) != 2) &&
		 xed_encode_ntluf_XMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_GPR32_B(xes,xed3_operand_get_reg1(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][9]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_REG1) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 (xed3_operand_get_mode(xes) == 2) &&
		 xed_encode_ntluf_GPR32_B(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_XMM_R3(xes,xed3_operand_get_reg1(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][10]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_REG1) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 (xed3_operand_get_mode(xes) == 2) &&
		 xed_encode_ntluf_XMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_GPR32_B(xes,xed3_operand_get_reg1(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][11]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_MEM0 && xes->_operand_order[1] == XED_OPERAND_REG0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 (xed3_operand_get_mode(xes) != 2) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_D) &&
		 xed_encode_ntluf_XMM_R3(xes,xed3_operand_get_reg0(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][12]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_32_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_GPR_WRITER_STORE_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_MEM0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 (xed3_operand_get_mode(xes) != 2) &&
		 xed_encode_ntluf_XMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_D);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][13]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_32_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_GPR_READER_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_MEM0 && xes->_operand_order[1] == XED_OPERAND_REG0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 (xed3_operand_get_mode(xes) == 2) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_D) &&
		 xed_encode_ntluf_XMM_R3(xes,xed3_operand_get_reg0(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][14]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_32_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_GPR_WRITER_STORE_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_MEM0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 (xed3_operand_get_mode(xes) == 2) &&
		 xed_encode_ntluf_XMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_D);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][15]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_32_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_GPR_READER_BIND(xes);
       if (okay) return 1;
   }
     }
   return 0;
   (void) okay;
   (void) conditions_satisfied;
   (void) xes;
}
xed_bool_t xed_encode_group_451(xed_encoder_request_t* xes)
{
   xed_bool_t okay=1;
   xed_bool_t conditions_satisfied=0;
   xed_ptrn_func_ptr_t fb_ptrn_function;
   static const xed_uint16_t iform_ids[2][10] = {
   /*VPCMPEQQ      */    {6178,6180,6177,6179,6183,6185,6181,6184,6186,6182,},
   /*VPCMPGTQ      */    {5668,5670,5667,5669,5673,5675,5671,5674,5676,5672,},
   };
   xed_uint8_t iclass_index = xed_encoder_get_iclasses_index_in_group(xes);
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[7], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 (xed3_operand_get_must_use_evex(xes) == 0) &&
		 xed_encode_ntluf_XMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_XMM_N(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_XMM_B(xes,xed3_operand_get_reg2(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][0]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[7], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 1) &&
		 (xed3_operand_get_must_use_evex(xes) == 0) &&
		 xed_encode_ntluf_YMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_YMM_N(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_YMM_B(xes,xed3_operand_get_reg2(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][1]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[14], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 (xed3_operand_get_must_use_evex(xes) == 0) &&
		 xed_encode_ntluf_XMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_XMM_N(xes,xed3_operand_get_reg1(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_DQ);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][2]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[14], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 1) &&
		 (xed3_operand_get_must_use_evex(xes) == 0) &&
		 xed_encode_ntluf_YMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_YMM_N(xes,xed3_operand_get_reg1(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_QQ);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][3]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 4 && memcmp(xed_encode_order[12], xes->_operand_order, sizeof(xed_uint8_t)*4)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 xed_encode_ntluf_MASK_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_XMM_N3(xes,xed3_operand_get_reg2(xes)) &&
		 xed_encode_ntluf_XMM_B3(xes,xed3_operand_get_reg3(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][4]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 4 && memcmp(xed_encode_order[12], xes->_operand_order, sizeof(xed_uint8_t)*4)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 1) &&
		 xed_encode_ntluf_MASK_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_YMM_N3(xes,xed3_operand_get_reg2(xes)) &&
		 xed_encode_ntluf_YMM_B3(xes,xed3_operand_get_reg3(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][5]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 4 && memcmp(xed_encode_order[12], xes->_operand_order, sizeof(xed_uint8_t)*4)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 2) &&
		 xed_encode_ntluf_MASK_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_ZMM_N3(xes,xed3_operand_get_reg2(xes)) &&
		 xed_encode_ntluf_ZMM_B3(xes,xed3_operand_get_reg3(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][6]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 4 && memcmp(xed_encode_order[13], xes->_operand_order, sizeof(xed_uint8_t)*4)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 xed_encode_ntluf_MASK_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_XMM_N3(xes,xed3_operand_get_reg2(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_VV);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][7]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_64_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_FULL_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 4 && memcmp(xed_encode_order[13], xes->_operand_order, sizeof(xed_uint8_t)*4)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 1) &&
		 xed_encode_ntluf_MASK_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_YMM_N3(xes,xed3_operand_get_reg2(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_VV);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][8]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_64_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_FULL_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 4 && memcmp(xed_encode_order[13], xes->_operand_order, sizeof(xed_uint8_t)*4)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 2) &&
		 xed_encode_ntluf_MASK_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_ZMM_N3(xes,xed3_operand_get_reg2(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_VV);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][9]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_64_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_FULL_BIND(xes);
       if (okay) return 1;
   }
     }
   return 0;
   (void) okay;
   (void) conditions_satisfied;
   (void) xes;
}
xed_bool_t xed_encode_group_452(xed_encoder_request_t* xes)
{
   xed_bool_t okay=1;
   xed_bool_t conditions_satisfied=0;
   xed_ptrn_func_ptr_t fb_ptrn_function;
   static const xed_uint16_t iform_ids[1][12] = {
   /*VMOVDQU8      */    {5679,5677,5683,5681,5687,5685,5680,5678,5684,5682,5688,5686,},
   };
   xed_uint8_t iclass_index = xed_encoder_get_iclasses_index_in_group(xes);
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[7], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 xed_encode_ntluf_XMM_B3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_XMM_R3(xes,xed3_operand_get_reg2(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][0]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[7], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 xed_encode_ntluf_XMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_XMM_B3(xes,xed3_operand_get_reg2(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][1]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[7], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 1) &&
		 xed_encode_ntluf_YMM_B3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_YMM_R3(xes,xed3_operand_get_reg2(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][2]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[7], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 1) &&
		 xed_encode_ntluf_YMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_YMM_B3(xes,xed3_operand_get_reg2(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][3]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[7], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 2) &&
		 xed_encode_ntluf_ZMM_B3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_ZMM_R3(xes,xed3_operand_get_reg2(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][4]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[7], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 2) &&
		 xed_encode_ntluf_ZMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_ZMM_B3(xes,xed3_operand_get_reg2(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][5]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[6], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_DQ) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_XMM_R3(xes,xed3_operand_get_reg1(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][6]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_8_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_FULLMEM_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[14], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 xed_encode_ntluf_XMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_DQ);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][7]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_8_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_FULLMEM_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[6], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 1) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_QQ) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_YMM_R3(xes,xed3_operand_get_reg1(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][8]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_8_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_FULLMEM_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[14], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 1) &&
		 xed_encode_ntluf_YMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_QQ);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][9]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_8_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_FULLMEM_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[6], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 2) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_ZD) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_ZMM_R3(xes,xed3_operand_get_reg1(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][10]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_8_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_FULLMEM_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[14], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 2) &&
		 xed_encode_ntluf_ZMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_ZD);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][11]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_8_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_FULLMEM_BIND(xes);
       if (okay) return 1;
   }
     }
   return 0;
   (void) okay;
   (void) conditions_satisfied;
   (void) xes;
}
xed_bool_t xed_encode_group_453(xed_encoder_request_t* xes)
{
   xed_bool_t okay=1;
   xed_bool_t conditions_satisfied=0;
   xed_ptrn_func_ptr_t fb_ptrn_function;
   static const xed_uint16_t iform_ids[1][7] = {
   /*VSCALEFPS     */    {5699,5701,5703,5698,5702,5704,5700,},
   };
   xed_uint8_t iclass_index = xed_encoder_get_iclasses_index_in_group(xes);
   if (xes->_n_operand_order == 4 && memcmp(xed_encode_order[12], xes->_operand_order, sizeof(xed_uint8_t)*4)==0) {
   conditions_satisfied = (xed3_operand_get_roundc(xes) != 0) &&
		 xed_encode_ntluf_ZMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_ZMM_N3(xes,xed3_operand_get_reg2(xes)) &&
		 xed_encode_ntluf_ZMM_B3(xes,xed3_operand_get_reg3(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][0]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_FIX_ROUND_LEN512_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_AVX512_ROUND_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 4 && memcmp(xed_encode_order[12], xes->_operand_order, sizeof(xed_uint8_t)*4)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 xed_encode_ntluf_XMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_XMM_N3(xes,xed3_operand_get_reg2(xes)) &&
		 xed_encode_ntluf_XMM_B3(xes,xed3_operand_get_reg3(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][1]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 4 && memcmp(xed_encode_order[12], xes->_operand_order, sizeof(xed_uint8_t)*4)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 1) &&
		 xed_encode_ntluf_YMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_YMM_N3(xes,xed3_operand_get_reg2(xes)) &&
		 xed_encode_ntluf_YMM_B3(xes,xed3_operand_get_reg3(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][2]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 4 && memcmp(xed_encode_order[12], xes->_operand_order, sizeof(xed_uint8_t)*4)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 2) &&
		 xed_encode_ntluf_ZMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_ZMM_N3(xes,xed3_operand_get_reg2(xes)) &&
		 xed_encode_ntluf_ZMM_B3(xes,xed3_operand_get_reg3(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][3]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 4 && memcmp(xed_encode_order[13], xes->_operand_order, sizeof(xed_uint8_t)*4)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 xed_encode_ntluf_XMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_XMM_N3(xes,xed3_operand_get_reg2(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_VV);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][4]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_32_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_FULL_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 4 && memcmp(xed_encode_order[13], xes->_operand_order, sizeof(xed_uint8_t)*4)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 1) &&
		 xed_encode_ntluf_YMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_YMM_N3(xes,xed3_operand_get_reg2(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_VV);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][5]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_32_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_FULL_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 4 && memcmp(xed_encode_order[13], xes->_operand_order, sizeof(xed_uint8_t)*4)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 2) &&
		 xed_encode_ntluf_ZMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_ZMM_N3(xes,xed3_operand_get_reg2(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_VV);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][6]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_32_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_FULL_BIND(xes);
       if (okay) return 1;
   }
     }
   return 0;
   (void) okay;
   (void) conditions_satisfied;
   (void) xes;
}
xed_bool_t xed_encode_group_454(xed_encoder_request_t* xes)
{
   xed_bool_t okay=1;
   xed_bool_t conditions_satisfied=0;
   xed_ptrn_func_ptr_t fb_ptrn_function;
   static const xed_uint16_t iform_ids[1][11] = {
   /*VCVTPS2PH     */    {5743,5739,5741,5738,5740,5745,5747,5742,5746,5748,5744,},
   };
   xed_uint8_t iclass_index = xed_encoder_get_iclasses_index_in_group(xes);
   if (xes->_n_operand_order == 4 && memcmp(xed_encode_order[21], xes->_operand_order, sizeof(xed_uint8_t)*4)==0) {
   conditions_satisfied = (xed3_operand_get_sae(xes) != 0) &&
		 xed_encode_ntluf_YMM_B3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_ZMM_R3(xes,xed3_operand_get_reg2(xes)) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][0]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_FIX_ROUND_LEN512_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_SAE_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_UIMM8_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[15], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 (xed3_operand_get_must_use_evex(xes) == 0) &&
		 xed_encode_ntluf_XMM_B(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_XMM_R(xes,xed3_operand_get_reg1(xes)) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][1]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_UIMM8_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[15], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 1) &&
		 (xed3_operand_get_must_use_evex(xes) == 0) &&
		 xed_encode_ntluf_XMM_B(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_YMM_R(xes,xed3_operand_get_reg1(xes)) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][2]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_UIMM8_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[17], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 (xed3_operand_get_must_use_evex(xes) == 0) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_Q) &&
		 xed_encode_ntluf_XMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][3]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_UIMM8_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[17], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 1) &&
		 (xed3_operand_get_must_use_evex(xes) == 0) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_DQ) &&
		 xed_encode_ntluf_YMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][4]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_UIMM8_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 4 && memcmp(xed_encode_order[21], xes->_operand_order, sizeof(xed_uint8_t)*4)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 xed_encode_ntluf_XMM_B3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_XMM_R3(xes,xed3_operand_get_reg2(xes)) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][5]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_UIMM8_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 4 && memcmp(xed_encode_order[21], xes->_operand_order, sizeof(xed_uint8_t)*4)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 1) &&
		 xed_encode_ntluf_XMM_B3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_YMM_R3(xes,xed3_operand_get_reg2(xes)) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][6]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_UIMM8_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 4 && memcmp(xed_encode_order[21], xes->_operand_order, sizeof(xed_uint8_t)*4)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 2) &&
		 xed_encode_ntluf_YMM_B3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_ZMM_R3(xes,xed3_operand_get_reg2(xes)) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][7]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_UIMM8_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 4 && memcmp(xed_encode_order[26], xes->_operand_order, sizeof(xed_uint8_t)*4)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_Q) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_XMM_R3(xes,xed3_operand_get_reg1(xes)) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][8]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_UIMM8_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_16_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_HALFMEM_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 4 && memcmp(xed_encode_order[26], xes->_operand_order, sizeof(xed_uint8_t)*4)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 1) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_DQ) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_YMM_R3(xes,xed3_operand_get_reg1(xes)) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][9]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_UIMM8_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_16_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_HALFMEM_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 4 && memcmp(xed_encode_order[26], xes->_operand_order, sizeof(xed_uint8_t)*4)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 2) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_QQ) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_ZMM_R3(xes,xed3_operand_get_reg1(xes)) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][10]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_UIMM8_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_16_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_HALFMEM_BIND(xes);
       if (okay) return 1;
   }
     }
   return 0;
   (void) okay;
   (void) conditions_satisfied;
   (void) xes;
}
xed_bool_t xed_encode_group_455(xed_encoder_request_t* xes)
{
   xed_bool_t okay=1;
   xed_bool_t conditions_satisfied=0;
   xed_ptrn_func_ptr_t fb_ptrn_function;
   static const xed_uint16_t iform_ids[1][8] = {
   /*VPEXTRD       */    {5752,5750,5751,5749,5753,5754,5755,5756,},
   };
   xed_uint8_t iclass_index = xed_encoder_get_iclasses_index_in_group(xes);
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[15], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 (xed3_operand_get_mode(xes) != 2) &&
		 (xed3_operand_get_must_use_evex(xes) == 0) &&
		 xed_encode_ntluf_GPR32_B(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_XMM_R(xes,xed3_operand_get_reg1(xes)) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][0]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_UIMM8_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[15], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 (xed3_operand_get_mode(xes) == 2) &&
		 (xed3_operand_get_must_use_evex(xes) == 0) &&
		 xed_encode_ntluf_GPR32_B(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_XMM_R(xes,xed3_operand_get_reg1(xes)) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][1]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_UIMM8_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[17], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 (xed3_operand_get_mode(xes) != 2) &&
		 (xed3_operand_get_must_use_evex(xes) == 0) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_D) &&
		 xed_encode_ntluf_XMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][2]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_UIMM8_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[17], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 (xed3_operand_get_mode(xes) == 2) &&
		 (xed3_operand_get_must_use_evex(xes) == 0) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_D) &&
		 xed_encode_ntluf_XMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][3]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_UIMM8_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[15], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 (xed3_operand_get_mode(xes) != 2) &&
		 xed_encode_ntluf_GPR32_B(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_XMM_R3(xes,xed3_operand_get_reg1(xes)) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][4]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_UIMM8_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[15], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 (xed3_operand_get_mode(xes) == 2) &&
		 xed_encode_ntluf_GPR32_B(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_XMM_R3(xes,xed3_operand_get_reg1(xes)) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][5]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_UIMM8_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[17], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 (xed3_operand_get_mode(xes) != 2) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_D) &&
		 xed_encode_ntluf_XMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][6]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_UIMM8_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_32_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_GPR_WRITER_STORE_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[17], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 (xed3_operand_get_mode(xes) == 2) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_D) &&
		 xed_encode_ntluf_XMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][7]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_UIMM8_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_32_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_GPR_WRITER_STORE_BIND(xes);
       if (okay) return 1;
   }
     }
   return 0;
   (void) okay;
   (void) conditions_satisfied;
   (void) xes;
}
xed_bool_t xed_encode_group_456(xed_encoder_request_t* xes)
{
   xed_bool_t okay=1;
   xed_bool_t conditions_satisfied=0;
   xed_ptrn_func_ptr_t fb_ptrn_function;
   static const xed_uint16_t iform_ids[1][1] = {
   /*LOOP          */    {5757,},
   };
   xed_uint8_t iclass_index = xed_encoder_get_iclasses_index_in_group(xes);
   if (xes->_n_operand_order == 1 && xes->_operand_order[0] == XED_OPERAND_RELBR) {
   conditions_satisfied = (xed3_operand_get_relbr(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][0]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_DF64_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_BRDISP8_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_IMMUNE66_LOOP64_BIND(xes);
       if (okay) return 1;
   }
     }
   return 0;
   (void) okay;
   (void) conditions_satisfied;
   (void) xes;
}
xed_bool_t xed_encode_group_457(xed_encoder_request_t* xes)
{
   xed_bool_t okay=1;
   xed_bool_t conditions_satisfied=0;
   xed_ptrn_func_ptr_t fb_ptrn_function;
   static const xed_uint16_t iform_ids[1][2] = {
   /*PTWRITE       */    {5789,5790,},
   };
   xed_uint8_t iclass_index = xed_encoder_get_iclasses_index_in_group(xes);
   if (xes->_n_operand_order == 1 && xes->_operand_order[0] == XED_OPERAND_REG0) {
   conditions_satisfied = xed_encode_ntluf_GPRy_B(xes,xed3_operand_get_reg0(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][0]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 1 && xes->_operand_order[0] == XED_OPERAND_MEM0) {
   conditions_satisfied = (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_Y);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][1]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay) return 1;
   }
     }
   return 0;
   (void) okay;
   (void) conditions_satisfied;
   (void) xes;
}
xed_bool_t xed_encode_group_458(xed_encoder_request_t* xes)
{
   xed_bool_t okay=1;
   xed_bool_t conditions_satisfied=0;
   xed_ptrn_func_ptr_t fb_ptrn_function;
   static const xed_uint16_t iform_ids[1][8] = {
   /*BSR           */    {5806,5808,5810,5812,5805,5807,5809,5811,},
   };
   xed_uint8_t iclass_index = xed_encoder_get_iclasses_index_in_group(xes);
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_REG1) {
   conditions_satisfied = xed_encode_ntluf_GPRv_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_GPRv_B(xes,xed3_operand_get_reg1(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][0]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_REG1) {
   conditions_satisfied = xed_encode_ntluf_GPRv_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_GPRv_B(xes,xed3_operand_get_reg1(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][1]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_REG1) {
   conditions_satisfied = xed_encode_ntluf_GPRv_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_GPRv_B(xes,xed3_operand_get_reg1(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][2]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_REG1) {
   conditions_satisfied = xed_encode_ntluf_GPRv_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_GPRv_B(xes,xed3_operand_get_reg1(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][3]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_MEM0) {
   conditions_satisfied = xed_encode_ntluf_GPRv_R(xes,xed3_operand_get_reg0(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_V);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][4]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_MEM0) {
   conditions_satisfied = xed_encode_ntluf_GPRv_R(xes,xed3_operand_get_reg0(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_V);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][5]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_MEM0) {
   conditions_satisfied = xed_encode_ntluf_GPRv_R(xes,xed3_operand_get_reg0(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_V);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][6]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_MEM0) {
   conditions_satisfied = xed_encode_ntluf_GPRv_R(xes,xed3_operand_get_reg0(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_V);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][7]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay) return 1;
   }
     }
   return 0;
   (void) okay;
   (void) conditions_satisfied;
   (void) xes;
}
xed_bool_t xed_encode_group_459(xed_encoder_request_t* xes)
{
   xed_bool_t okay=1;
   xed_bool_t conditions_satisfied=0;
   xed_ptrn_func_ptr_t fb_ptrn_function;
   static const xed_uint16_t iform_ids[1][8] = {
   /*REP_OUTSD     */    {5826,5830,5827,5831,5828,5829,5832,5833,},
   };
   xed_uint8_t iclass_index = xed_encoder_get_iclasses_index_in_group(xes);
   if (xes->_n_operand_order == 0) {
   conditions_satisfied = (xed3_operand_get_mode(xes) == 0);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][0]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_OVERRIDE_SEG0_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 0) {
   conditions_satisfied = (xed3_operand_get_mode(xes) == 0);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][1]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_OVERRIDE_SEG0_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 0) {
   conditions_satisfied = (xed3_operand_get_mode(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][2]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_OVERRIDE_SEG0_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 0) {
   conditions_satisfied = (xed3_operand_get_mode(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][3]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_OVERRIDE_SEG0_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 0) {
   conditions_satisfied = (xed3_operand_get_mode(xes) == 2);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][4]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_OVERRIDE_SEG0_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 0) {
   conditions_satisfied = (xed3_operand_get_mode(xes) == 2);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][5]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_OVERRIDE_SEG0_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 0) {
   conditions_satisfied = (xed3_operand_get_mode(xes) == 2);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][6]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_OVERRIDE_SEG0_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 0) {
   conditions_satisfied = (xed3_operand_get_mode(xes) == 2);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][7]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_OVERRIDE_SEG0_BIND(xes);
       if (okay) return 1;
   }
     }
   return 0;
   (void) okay;
   (void) conditions_satisfied;
   (void) xes;
}
xed_bool_t xed_encode_group_460(xed_encoder_request_t* xes)
{
   xed_bool_t okay=1;
   xed_bool_t conditions_satisfied=0;
   xed_ptrn_func_ptr_t fb_ptrn_function;
   static const xed_uint16_t iform_ids[1][2] = {
   /*VFPCLASSSD    */    {5840,5841,},
   };
   xed_uint8_t iclass_index = xed_encoder_get_iclasses_index_in_group(xes);
   if (xes->_n_operand_order == 4 && memcmp(xed_encode_order[21], xes->_operand_order, sizeof(xed_uint8_t)*4)==0) {
   conditions_satisfied = xed_encode_ntluf_MASK_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_XMM_B3(xes,xed3_operand_get_reg2(xes)) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][0]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_UIMM8_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 4 && memcmp(xed_encode_order[22], xes->_operand_order, sizeof(xed_uint8_t)*4)==0) {
   conditions_satisfied = xed_encode_ntluf_MASK_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_Q) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][1]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_UIMM8_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_64_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_SCALAR_BIND(xes);
       if (okay) return 1;
   }
     }
   return 0;
   (void) okay;
   (void) conditions_satisfied;
   (void) xes;
}
xed_bool_t xed_encode_group_461(xed_encoder_request_t* xes)
{
   xed_bool_t okay=1;
   xed_bool_t conditions_satisfied=0;
   xed_ptrn_func_ptr_t fb_ptrn_function;
   static const xed_uint16_t iform_ids[1][16] = {
   /*MOVD          */    {5876,5872,5874,5870,5875,5868,5871,5864,5873,5866,5869,5862,5867,5863,5865,5861,},
   };
   xed_uint8_t iclass_index = xed_encoder_get_iclasses_index_in_group(xes);
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_REG1) {
   conditions_satisfied = (xed3_operand_get_mode(xes) != 2) &&
		 xed_encode_ntluf_GPR32_B(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MMX_R(xes,xed3_operand_get_reg1(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][0]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_REG1) {
   conditions_satisfied = (xed3_operand_get_mode(xes) != 2) &&
		 xed_encode_ntluf_MMX_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_GPR32_B(xes,xed3_operand_get_reg1(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][1]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_REG1) {
   conditions_satisfied = (xed3_operand_get_mode(xes) == 2) &&
		 xed_encode_ntluf_GPR32_B(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MMX_R(xes,xed3_operand_get_reg1(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][2]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_REG1) {
   conditions_satisfied = (xed3_operand_get_mode(xes) == 2) &&
		 xed_encode_ntluf_MMX_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_GPR32_B(xes,xed3_operand_get_reg1(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][3]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_MEM0 && xes->_operand_order[1] == XED_OPERAND_REG0) {
   conditions_satisfied = (xed3_operand_get_mode(xes) != 2) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_D) &&
		 xed_encode_ntluf_MMX_R(xes,xed3_operand_get_reg0(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][4]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_REG1) {
   conditions_satisfied = (xed3_operand_get_mode(xes) != 2) &&
		 xed_encode_ntluf_GPR32_B(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_XMM_R(xes,xed3_operand_get_reg1(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][5]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_REFINING66_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_MEM0) {
   conditions_satisfied = (xed3_operand_get_mode(xes) != 2) &&
		 xed_encode_ntluf_MMX_R(xes,xed3_operand_get_reg0(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_D);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][6]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_REG1) {
   conditions_satisfied = (xed3_operand_get_mode(xes) != 2) &&
		 xed_encode_ntluf_XMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_GPR32_B(xes,xed3_operand_get_reg1(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][7]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_REFINING66_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_MEM0 && xes->_operand_order[1] == XED_OPERAND_REG0) {
   conditions_satisfied = (xed3_operand_get_mode(xes) == 2) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_D) &&
		 xed_encode_ntluf_MMX_R(xes,xed3_operand_get_reg0(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][8]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_REG1) {
   conditions_satisfied = (xed3_operand_get_mode(xes) == 2) &&
		 xed_encode_ntluf_GPR32_B(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_XMM_R(xes,xed3_operand_get_reg1(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][9]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_REFINING66_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_MEM0) {
   conditions_satisfied = (xed3_operand_get_mode(xes) == 2) &&
		 xed_encode_ntluf_MMX_R(xes,xed3_operand_get_reg0(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_D);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][10]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_REG1) {
   conditions_satisfied = (xed3_operand_get_mode(xes) == 2) &&
		 xed_encode_ntluf_XMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_GPR32_B(xes,xed3_operand_get_reg1(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][11]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_REFINING66_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_MEM0 && xes->_operand_order[1] == XED_OPERAND_REG0) {
   conditions_satisfied = (xed3_operand_get_mode(xes) != 2) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_D) &&
		 xed_encode_ntluf_XMM_R(xes,xed3_operand_get_reg0(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][12]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_REFINING66_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_MEM0) {
   conditions_satisfied = (xed3_operand_get_mode(xes) != 2) &&
		 xed_encode_ntluf_XMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_D);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][13]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_REFINING66_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_MEM0 && xes->_operand_order[1] == XED_OPERAND_REG0) {
   conditions_satisfied = (xed3_operand_get_mode(xes) == 2) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_D) &&
		 xed_encode_ntluf_XMM_R(xes,xed3_operand_get_reg0(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][14]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_REFINING66_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_MEM0) {
   conditions_satisfied = (xed3_operand_get_mode(xes) == 2) &&
		 xed_encode_ntluf_XMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_D);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][15]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_REFINING66_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay) return 1;
   }
     }
   return 0;
   (void) okay;
   (void) conditions_satisfied;
   (void) xes;
}
xed_bool_t xed_encode_group_462(xed_encoder_request_t* xes)
{
   xed_bool_t okay=1;
   xed_bool_t conditions_satisfied=0;
   xed_ptrn_func_ptr_t fb_ptrn_function;
   static const xed_uint16_t iform_ids[1][6] = {
   /*VBROADCASTSD  */    {5880,5879,5884,5882,5883,5881,},
   };
   xed_uint8_t iclass_index = xed_encoder_get_iclasses_index_in_group(xes);
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_REG1) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 1) &&
		 (xed3_operand_get_must_use_evex(xes) == 0) &&
		 xed_encode_ntluf_YMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_XMM_B(xes,xed3_operand_get_reg1(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][0]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_MEM0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 1) &&
		 (xed3_operand_get_must_use_evex(xes) == 0) &&
		 xed_encode_ntluf_YMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_Q);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][1]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[7], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 1) &&
		 xed_encode_ntluf_YMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_XMM_B3(xes,xed3_operand_get_reg2(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][2]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[7], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 2) &&
		 xed_encode_ntluf_ZMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_XMM_B3(xes,xed3_operand_get_reg2(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][3]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[14], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 1) &&
		 xed_encode_ntluf_YMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_Q);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][4]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_64_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_TUPLE1_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[14], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 2) &&
		 xed_encode_ntluf_ZMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_Q);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][5]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_64_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_TUPLE1_BIND(xes);
       if (okay) return 1;
   }
     }
   return 0;
   (void) okay;
   (void) conditions_satisfied;
   (void) xes;
}
xed_bool_t xed_encode_group_463(xed_encoder_request_t* xes)
{
   xed_bool_t okay=1;
   xed_bool_t conditions_satisfied=0;
   xed_ptrn_func_ptr_t fb_ptrn_function;
   static const xed_uint16_t iform_ids[1][10] = {
   /*VMOVDDUP      */    {5890,5892,5889,5891,5895,5897,5893,5896,5898,5894,},
   };
   xed_uint8_t iclass_index = xed_encoder_get_iclasses_index_in_group(xes);
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_REG1) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 (xed3_operand_get_must_use_evex(xes) == 0) &&
		 xed_encode_ntluf_XMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_XMM_B(xes,xed3_operand_get_reg1(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][0]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_REG1) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 1) &&
		 (xed3_operand_get_must_use_evex(xes) == 0) &&
		 xed_encode_ntluf_YMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_YMM_B(xes,xed3_operand_get_reg1(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][1]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_MEM0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 (xed3_operand_get_must_use_evex(xes) == 0) &&
		 xed_encode_ntluf_XMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_Q);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][2]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_MEM0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 1) &&
		 (xed3_operand_get_must_use_evex(xes) == 0) &&
		 xed_encode_ntluf_YMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_QQ);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][3]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[7], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 xed_encode_ntluf_XMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_XMM_B3(xes,xed3_operand_get_reg2(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][4]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[7], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 1) &&
		 xed_encode_ntluf_YMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_YMM_B3(xes,xed3_operand_get_reg2(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][5]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[7], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 2) &&
		 xed_encode_ntluf_ZMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_ZMM_B3(xes,xed3_operand_get_reg2(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][6]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[14], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 xed_encode_ntluf_XMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_Q);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][7]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_64_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_MOVDDUP_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[14], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 1) &&
		 xed_encode_ntluf_YMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_QQ);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][8]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_64_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_MOVDDUP_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[14], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 2) &&
		 xed_encode_ntluf_ZMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_ZD);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][9]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_64_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_MOVDDUP_BIND(xes);
       if (okay) return 1;
   }
     }
   return 0;
   (void) okay;
   (void) conditions_satisfied;
   (void) xes;
}
xed_bool_t xed_encode_group_464(xed_encoder_request_t* xes)
{
   xed_bool_t okay=1;
   xed_bool_t conditions_satisfied=0;
   xed_ptrn_func_ptr_t fb_ptrn_function;
   static const xed_uint16_t iform_ids[1][7] = {
   /*VCVTUSI2SD    */    {5908,5903,5904,5907,5905,5906,5909,},
   };
   xed_uint8_t iclass_index = xed_encoder_get_iclasses_index_in_group(xes);
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[7], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_mode(xes) == 2) &&
		 (xed3_operand_get_roundc(xes) != 0) &&
		 xed_encode_ntluf_XMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_XMM_N3(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_GPR64_B(xes,xed3_operand_get_reg2(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][0]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_FIX_ROUND_LEN128_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_AVX512_ROUND_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[7], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_mode(xes) != 2) &&
		 xed_encode_ntluf_XMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_XMM_N3(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_GPR32_B(xes,xed3_operand_get_reg2(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][1]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_FIX_ROUND_LEN128_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[7], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_mode(xes) == 2) &&
		 xed_encode_ntluf_XMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_XMM_N3(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_GPR32_B(xes,xed3_operand_get_reg2(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][2]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_FIX_ROUND_LEN128_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[7], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_mode(xes) == 2) &&
		 xed_encode_ntluf_XMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_XMM_N3(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_GPR64_B(xes,xed3_operand_get_reg2(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][3]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_FIX_ROUND_LEN128_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[14], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_mode(xes) != 2) &&
		 xed_encode_ntluf_XMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_XMM_N3(xes,xed3_operand_get_reg1(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_D);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][4]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_32_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_GPR_READER_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_FIX_ROUND_LEN128_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[14], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_mode(xes) == 2) &&
		 xed_encode_ntluf_XMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_XMM_N3(xes,xed3_operand_get_reg1(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_D);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][5]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_32_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_GPR_READER_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_FIX_ROUND_LEN128_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[14], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_mode(xes) == 2) &&
		 xed_encode_ntluf_XMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_XMM_N3(xes,xed3_operand_get_reg1(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_Q);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][6]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_64_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_GPR_READER_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_FIX_ROUND_LEN128_BIND(xes);
       if (okay) return 1;
   }
     }
   return 0;
   (void) okay;
   (void) conditions_satisfied;
   (void) xes;
}
xed_bool_t xed_encode_group_465(xed_encoder_request_t* xes)
{
   xed_bool_t okay=1;
   xed_bool_t conditions_satisfied=0;
   xed_ptrn_func_ptr_t fb_ptrn_function;
   static const xed_uint16_t iform_ids[1][2] = {
   /*FIST          */    {5921,5920,},
   };
   xed_uint8_t iclass_index = xed_encoder_get_iclasses_index_in_group(xes);
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_MEM0 && xes->_operand_order[1] == XED_OPERAND_REG0) {
   conditions_satisfied = (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_MEM16INT) &&
		 (xed3_operand_get_reg0(xes) == XED_REG_ST0);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][0]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_MEM0 && xes->_operand_order[1] == XED_OPERAND_REG0) {
   conditions_satisfied = (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_MEM32INT) &&
		 (xed3_operand_get_reg0(xes) == XED_REG_ST0);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][1]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay) return 1;
   }
     }
   return 0;
   (void) okay;
   (void) conditions_satisfied;
   (void) xes;
}
xed_bool_t xed_encode_group_466(xed_encoder_request_t* xes)
{
   xed_bool_t okay=1;
   xed_bool_t conditions_satisfied=0;
   xed_ptrn_func_ptr_t fb_ptrn_function;
   static const xed_uint16_t iform_ids[1][2] = {
   /*MOVBE         */    {5936,5935,},
   };
   xed_uint8_t iclass_index = xed_encoder_get_iclasses_index_in_group(xes);
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_MEM0 && xes->_operand_order[1] == XED_OPERAND_REG0) {
   conditions_satisfied = (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_V) &&
		 xed_encode_ntluf_GPRv_R(xes,xed3_operand_get_reg0(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][0]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_MEM0) {
   conditions_satisfied = xed_encode_ntluf_GPRv_R(xes,xed3_operand_get_reg0(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_V);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][1]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay) return 1;
   }
     }
   return 0;
   (void) okay;
   (void) conditions_satisfied;
   (void) xes;
}
xed_bool_t xed_encode_group_467(xed_encoder_request_t* xes)
{
   xed_bool_t okay=1;
   xed_bool_t conditions_satisfied=0;
   xed_ptrn_func_ptr_t fb_ptrn_function;
   static const xed_uint16_t iform_ids[1][4] = {
   /*MOVDQA        */    {5938,5940,5937,5939,},
   };
   xed_uint8_t iclass_index = xed_encoder_get_iclasses_index_in_group(xes);
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_REG1) {
   conditions_satisfied = xed_encode_ntluf_XMM_B(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_XMM_R(xes,xed3_operand_get_reg1(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][0]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_REFINING66_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_REG1) {
   conditions_satisfied = xed_encode_ntluf_XMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_XMM_B(xes,xed3_operand_get_reg1(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][1]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_REFINING66_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_MEM0 && xes->_operand_order[1] == XED_OPERAND_REG0) {
   conditions_satisfied = (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_DQ) &&
		 xed_encode_ntluf_XMM_R(xes,xed3_operand_get_reg0(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][2]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_REFINING66_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_MEM0) {
   conditions_satisfied = xed_encode_ntluf_XMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_DQ);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][3]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_REFINING66_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay) return 1;
   }
     }
   return 0;
   (void) okay;
   (void) conditions_satisfied;
   (void) xes;
}
xed_bool_t xed_encode_group_468(xed_encoder_request_t* xes)
{
   xed_bool_t okay=1;
   xed_bool_t conditions_satisfied=0;
   xed_ptrn_func_ptr_t fb_ptrn_function;
   static const xed_uint16_t iform_ids[1][1] = {
   /*BNDMK         */    {5992,},
   };
   xed_uint8_t iclass_index = xed_encoder_get_iclasses_index_in_group(xes);
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_AGEN) {
   conditions_satisfied = (xed3_operand_get_mpxmode(xes) == 1) &&
		 xed_encode_ntluf_BND_R(xes,xed3_operand_get_reg0(xes)) &&
		 (xed3_operand_get_agen(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][0]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay) return 1;
   }
     }
   return 0;
   (void) okay;
   (void) conditions_satisfied;
   (void) xes;
}
xed_bool_t xed_encode_group_469(xed_encoder_request_t* xes)
{
   xed_bool_t okay=1;
   xed_bool_t conditions_satisfied=0;
   xed_ptrn_func_ptr_t fb_ptrn_function;
   static const xed_uint16_t iform_ids[1][4] = {
   /*INSD          */    {6011,6012,6013,6014,},
   };
   xed_uint8_t iclass_index = xed_encoder_get_iclasses_index_in_group(xes);
   if (xes->_n_operand_order == 0) {
   conditions_satisfied = (xed3_operand_get_mode(xes) == 0);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][0]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 0) {
   conditions_satisfied = (xed3_operand_get_mode(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][1]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 0) {
   conditions_satisfied = (xed3_operand_get_mode(xes) == 2);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][2]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 0) {
   conditions_satisfied = (xed3_operand_get_mode(xes) == 2);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][3]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   return 0;
   (void) okay;
   (void) conditions_satisfied;
   (void) xes;
}
xed_bool_t xed_encode_group_470(xed_encoder_request_t* xes)
{
   xed_bool_t okay=1;
   xed_bool_t conditions_satisfied=0;
   xed_ptrn_func_ptr_t fb_ptrn_function;
   static const xed_uint16_t iform_ids[1][2] = {
   /*VROUNDSD      */    {6018,6017,},
   };
   xed_uint8_t iclass_index = xed_encoder_get_iclasses_index_in_group(xes);
   if (xes->_n_operand_order == 4 && memcmp(xed_encode_order[21], xes->_operand_order, sizeof(xed_uint8_t)*4)==0) {
   conditions_satisfied = (xed3_operand_get_must_use_evex(xes) == 0) &&
		 xed_encode_ntluf_XMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_XMM_N(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_XMM_B(xes,xed3_operand_get_reg2(xes)) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][0]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_UIMM8_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 4 && memcmp(xed_encode_order[22], xes->_operand_order, sizeof(xed_uint8_t)*4)==0) {
   conditions_satisfied = (xed3_operand_get_must_use_evex(xes) == 0) &&
		 xed_encode_ntluf_XMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_XMM_N(xes,xed3_operand_get_reg1(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_Q) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][1]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_UIMM8_BIND(xes);
       if (okay) return 1;
   }
     }
   return 0;
   (void) okay;
   (void) conditions_satisfied;
   (void) xes;
}
xed_bool_t xed_encode_group_471(xed_encoder_request_t* xes)
{
   xed_bool_t okay=1;
   xed_bool_t conditions_satisfied=0;
   xed_ptrn_func_ptr_t fb_ptrn_function;
   static const xed_uint16_t iform_ids[1][5] = {
   /*VPEXTRW       */    {6092,6093,6091,6094,6095,},
   };
   xed_uint8_t iclass_index = xed_encoder_get_iclasses_index_in_group(xes);
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[15], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 (xed3_operand_get_must_use_evex(xes) == 0) &&
		 xed_encode_ntluf_GPR32_B(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_XMM_R(xes,xed3_operand_get_reg1(xes)) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][0]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_UIMM8_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[15], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 (xed3_operand_get_must_use_evex(xes) == 0) &&
		 xed_encode_ntluf_GPR32_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_XMM_B(xes,xed3_operand_get_reg1(xes)) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][1]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_UIMM8_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[17], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 (xed3_operand_get_must_use_evex(xes) == 0) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_W) &&
		 xed_encode_ntluf_XMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][2]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_UIMM8_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[15], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 xed_encode_ntluf_GPR32_B(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_XMM_R3(xes,xed3_operand_get_reg1(xes)) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][3]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_UIMM8_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[17], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_WRD) &&
		 xed_encode_ntluf_XMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][4]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_UIMM8_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_16_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_GPR_WRITER_STORE_WORD_BIND(xes);
       if (okay) return 1;
   }
     }
   return 0;
   (void) okay;
   (void) conditions_satisfied;
   (void) xes;
}
xed_bool_t xed_encode_group_472(xed_encoder_request_t* xes)
{
   xed_bool_t okay=1;
   xed_bool_t conditions_satisfied=0;
   xed_ptrn_func_ptr_t fb_ptrn_function;
   static const xed_uint16_t iform_ids[1][2] = {
   /*PSHUFW        */    {6119,6118,},
   };
   xed_uint8_t iclass_index = xed_encoder_get_iclasses_index_in_group(xes);
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[15], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = xed_encode_ntluf_MMX_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MMX_B(xes,xed3_operand_get_reg1(xes)) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][0]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_UIMM8_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[20], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = xed_encode_ntluf_MMX_R(xes,xed3_operand_get_reg0(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_Q) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][1]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_UIMM8_BIND(xes);
       if (okay) return 1;
   }
     }
   return 0;
   (void) okay;
   (void) conditions_satisfied;
   (void) xes;
}
xed_bool_t xed_encode_group_473(xed_encoder_request_t* xes)
{
   xed_bool_t okay=1;
   xed_bool_t conditions_satisfied=0;
   xed_ptrn_func_ptr_t fb_ptrn_function;
   static const xed_uint16_t iform_ids[2][2] = {
   /*TPAUSE        */    {6124,6123,},
   /*UMWAIT        */    {6577,6576,},
   };
   xed_uint8_t iclass_index = xed_encoder_get_iclasses_index_in_group(xes);
   if (xes->_n_operand_order == 1 && xes->_operand_order[0] == XED_OPERAND_REG0) {
   conditions_satisfied = (xed3_operand_get_mode(xes) == 2) &&
		 xed_encode_ntluf_GPR64_B(xes,xed3_operand_get_reg0(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][0]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 1 && xes->_operand_order[0] == XED_OPERAND_REG0) {
   conditions_satisfied = xed_encode_ntluf_GPR32_B(xes,xed3_operand_get_reg0(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][1]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   return 0;
   (void) okay;
   (void) conditions_satisfied;
   (void) xes;
}
xed_bool_t xed_encode_group_474(xed_encoder_request_t* xes)
{
   xed_bool_t okay=1;
   xed_bool_t conditions_satisfied=0;
   xed_ptrn_func_ptr_t fb_ptrn_function;
   static const xed_uint16_t iform_ids[1][3] = {
   /*VSCALEFSD     */    {6161,6160,6162,},
   };
   xed_uint8_t iclass_index = xed_encoder_get_iclasses_index_in_group(xes);
   if (xes->_n_operand_order == 4 && memcmp(xed_encode_order[12], xes->_operand_order, sizeof(xed_uint8_t)*4)==0) {
   conditions_satisfied = (xed3_operand_get_roundc(xes) != 0) &&
		 xed_encode_ntluf_XMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_XMM_N3(xes,xed3_operand_get_reg2(xes)) &&
		 xed_encode_ntluf_XMM_B3(xes,xed3_operand_get_reg3(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][0]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_FIX_ROUND_LEN128_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_AVX512_ROUND_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 4 && memcmp(xed_encode_order[12], xes->_operand_order, sizeof(xed_uint8_t)*4)==0) {
   conditions_satisfied = xed_encode_ntluf_XMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_XMM_N3(xes,xed3_operand_get_reg2(xes)) &&
		 xed_encode_ntluf_XMM_B3(xes,xed3_operand_get_reg3(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][1]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 4 && memcmp(xed_encode_order[13], xes->_operand_order, sizeof(xed_uint8_t)*4)==0) {
   conditions_satisfied = xed_encode_ntluf_XMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_XMM_N3(xes,xed3_operand_get_reg2(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_Q);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][2]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_64_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_SCALAR_BIND(xes);
       if (okay) return 1;
   }
     }
   return 0;
   (void) okay;
   (void) conditions_satisfied;
   (void) xes;
}
xed_bool_t xed_encode_group_475(xed_encoder_request_t* xes)
{
   xed_bool_t okay=1;
   xed_bool_t conditions_satisfied=0;
   xed_ptrn_func_ptr_t fb_ptrn_function;
   static const xed_uint16_t iform_ids[1][2] = {
   /*CVTPI2PD      */    {6176,6175,},
   };
   xed_uint8_t iclass_index = xed_encoder_get_iclasses_index_in_group(xes);
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_REG1) {
   conditions_satisfied = xed_encode_ntluf_XMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MMX_B(xes,xed3_operand_get_reg1(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][0]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_REFINING66_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_MEM0) {
   conditions_satisfied = xed_encode_ntluf_XMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_Q);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][1]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_REFINING66_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay) return 1;
   }
     }
   return 0;
   (void) okay;
   (void) conditions_satisfied;
   (void) xes;
}
xed_bool_t xed_encode_group_476(xed_encoder_request_t* xes)
{
   xed_bool_t okay=1;
   xed_bool_t conditions_satisfied=0;
   xed_ptrn_func_ptr_t fb_ptrn_function;
   static const xed_uint16_t iform_ids[1][1] = {
   /*MOVSB         */    {6212,},
   };
   xed_uint8_t iclass_index = xed_encoder_get_iclasses_index_in_group(xes);
   if (xes->_n_operand_order == 0) {
   conditions_satisfied = 1;
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][0]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_OVERRIDE_SEG1_BIND(xes);
       if (okay) return 1;
   }
     }
   return 0;
   (void) okay;
   (void) conditions_satisfied;
   (void) xes;
}
xed_bool_t xed_encode_group_477(xed_encoder_request_t* xes)
{
   xed_bool_t okay=1;
   xed_bool_t conditions_satisfied=0;
   xed_ptrn_func_ptr_t fb_ptrn_function;
   static const xed_uint16_t iform_ids[2][8] = {
   /*VPERMIL2PD    */    {6836,6840,6838,6842,6835,6839,6837,6841,},
   /*VPERMIL2PS    */    {6236,6240,6238,6242,6235,6239,6237,6241,},
   };
   xed_uint8_t iclass_index = xed_encoder_get_iclasses_index_in_group(xes);
   if (xes->_n_operand_order == 5 && memcmp(xed_encode_order[18], xes->_operand_order, sizeof(xed_uint8_t)*5)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 (xed3_operand_get_must_use_evex(xes) == 0) &&
		 xed_encode_ntluf_XMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_XMM_N(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_XMM_B(xes,xed3_operand_get_reg2(xes)) &&
		 xed_encode_ntluf_XMM_SE(xes,xed3_operand_get_reg3(xes)) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][0]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_SE_IMM8_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 5 && memcmp(xed_encode_order[18], xes->_operand_order, sizeof(xed_uint8_t)*5)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 (xed3_operand_get_must_use_evex(xes) == 0) &&
		 xed_encode_ntluf_XMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_XMM_N(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_XMM_SE(xes,xed3_operand_get_reg2(xes)) &&
		 xed_encode_ntluf_XMM_B(xes,xed3_operand_get_reg3(xes)) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][1]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_SE_IMM8_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 5 && memcmp(xed_encode_order[18], xes->_operand_order, sizeof(xed_uint8_t)*5)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 1) &&
		 (xed3_operand_get_must_use_evex(xes) == 0) &&
		 xed_encode_ntluf_YMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_YMM_N(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_YMM_B(xes,xed3_operand_get_reg2(xes)) &&
		 xed_encode_ntluf_YMM_SE(xes,xed3_operand_get_reg3(xes)) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][2]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_SE_IMM8_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 5 && memcmp(xed_encode_order[18], xes->_operand_order, sizeof(xed_uint8_t)*5)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 1) &&
		 (xed3_operand_get_must_use_evex(xes) == 0) &&
		 xed_encode_ntluf_YMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_YMM_N(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_YMM_SE(xes,xed3_operand_get_reg2(xes)) &&
		 xed_encode_ntluf_YMM_B(xes,xed3_operand_get_reg3(xes)) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][3]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_SE_IMM8_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 5 && memcmp(xed_encode_order[30], xes->_operand_order, sizeof(xed_uint8_t)*5)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 (xed3_operand_get_must_use_evex(xes) == 0) &&
		 xed_encode_ntluf_XMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_XMM_N(xes,xed3_operand_get_reg1(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_DQ) &&
		 xed_encode_ntluf_XMM_SE(xes,xed3_operand_get_reg2(xes)) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][4]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_SE_IMM8_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 5 && memcmp(xed_encode_order[19], xes->_operand_order, sizeof(xed_uint8_t)*5)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 (xed3_operand_get_must_use_evex(xes) == 0) &&
		 xed_encode_ntluf_XMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_XMM_N(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_XMM_SE(xes,xed3_operand_get_reg2(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_DQ) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][5]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_SE_IMM8_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 5 && memcmp(xed_encode_order[30], xes->_operand_order, sizeof(xed_uint8_t)*5)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 1) &&
		 (xed3_operand_get_must_use_evex(xes) == 0) &&
		 xed_encode_ntluf_YMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_YMM_N(xes,xed3_operand_get_reg1(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_QQ) &&
		 xed_encode_ntluf_YMM_SE(xes,xed3_operand_get_reg2(xes)) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][6]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_SE_IMM8_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 5 && memcmp(xed_encode_order[19], xes->_operand_order, sizeof(xed_uint8_t)*5)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 1) &&
		 (xed3_operand_get_must_use_evex(xes) == 0) &&
		 xed_encode_ntluf_YMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_YMM_N(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_YMM_SE(xes,xed3_operand_get_reg2(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_QQ) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][7]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_SE_IMM8_BIND(xes);
       if (okay) return 1;
   }
     }
   return 0;
   (void) okay;
   (void) conditions_satisfied;
   (void) xes;
}
xed_bool_t xed_encode_group_478(xed_encoder_request_t* xes)
{
   xed_bool_t okay=1;
   xed_bool_t conditions_satisfied=0;
   xed_ptrn_func_ptr_t fb_ptrn_function;
   static const xed_uint16_t iform_ids[1][1] = {
   /*MOVNTPS       */    {6243,},
   };
   xed_uint8_t iclass_index = xed_encoder_get_iclasses_index_in_group(xes);
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_MEM0 && xes->_operand_order[1] == XED_OPERAND_REG0) {
   conditions_satisfied = (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_DQ) &&
		 xed_encode_ntluf_XMM_R(xes,xed3_operand_get_reg0(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][0]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay) return 1;
   }
     }
   return 0;
   (void) okay;
   (void) conditions_satisfied;
   (void) xes;
}
xed_bool_t xed_encode_group_479(xed_encoder_request_t* xes)
{
   xed_bool_t okay=1;
   xed_bool_t conditions_satisfied=0;
   xed_ptrn_func_ptr_t fb_ptrn_function;
   static const xed_uint16_t iform_ids[1][18] = {
   /*OR            */    {6321,6320,6313,6317,6315,6319,6312,6314,6309,6305,6316,6311,6307,6318,6304,6310,6306,6308,},
   };
   xed_uint8_t iclass_index = xed_encoder_get_iclasses_index_in_group(xes);
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_IMM0) {
   conditions_satisfied = xed_encode_ntluf_OrAX(xes,xed3_operand_get_reg0(xes)) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][0]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_SIMMz_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_IMM0) {
   conditions_satisfied = (xed3_operand_get_reg0(xes) == XED_REG_AL) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][1]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_UIMM8_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_REG1) {
   conditions_satisfied = xed_encode_ntluf_GPR8_B(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_GPR8_R(xes,xed3_operand_get_reg1(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][2]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_REG1) {
   conditions_satisfied = xed_encode_ntluf_GPR8_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_GPR8_B(xes,xed3_operand_get_reg1(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][3]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_REG1) {
   conditions_satisfied = xed_encode_ntluf_GPRv_B(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_GPRv_R(xes,xed3_operand_get_reg1(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][4]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_REG1) {
   conditions_satisfied = xed_encode_ntluf_GPRv_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_GPRv_B(xes,xed3_operand_get_reg1(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][5]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_MEM0 && xes->_operand_order[1] == XED_OPERAND_REG0) {
   conditions_satisfied = (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_B) &&
		 xed_encode_ntluf_GPR8_R(xes,xed3_operand_get_reg0(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][6]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_MEM0 && xes->_operand_order[1] == XED_OPERAND_REG0) {
   conditions_satisfied = (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_V) &&
		 xed_encode_ntluf_GPRv_R(xes,xed3_operand_get_reg0(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][7]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_IMM0) {
   conditions_satisfied = (xed3_operand_get_mode(xes) != 2) &&
		 xed_encode_ntluf_GPR8_B(xes,xed3_operand_get_reg0(xes)) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][8]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_SIMM8_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_IMM0) {
   conditions_satisfied = xed_encode_ntluf_GPR8_B(xes,xed3_operand_get_reg0(xes)) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][9]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_SIMM8_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_MEM0) {
   conditions_satisfied = xed_encode_ntluf_GPR8_R(xes,xed3_operand_get_reg0(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_B);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][10]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_IMM0) {
   conditions_satisfied = xed_encode_ntluf_GPRv_B(xes,xed3_operand_get_reg0(xes)) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][11]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_SIMM8_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_IMM0) {
   conditions_satisfied = xed_encode_ntluf_GPRv_B(xes,xed3_operand_get_reg0(xes)) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][12]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_SIMMz_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_MEM0) {
   conditions_satisfied = xed_encode_ntluf_GPRv_R(xes,xed3_operand_get_reg0(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_V);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][13]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_MEM0 && xes->_operand_order[1] == XED_OPERAND_IMM0) {
   conditions_satisfied = (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_B) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][14]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_SIMM8_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_MEM0 && xes->_operand_order[1] == XED_OPERAND_IMM0) {
   conditions_satisfied = (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_V) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][15]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_SIMM8_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_MEM0 && xes->_operand_order[1] == XED_OPERAND_IMM0) {
   conditions_satisfied = (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_V) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][16]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_SIMMz_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_MEM0 && xes->_operand_order[1] == XED_OPERAND_IMM0) {
   conditions_satisfied = (xed3_operand_get_mode(xes) != 2) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_B) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][17]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_SIMM8_BIND(xes);
       if (okay) return 1;
   }
     }
   return 0;
   (void) okay;
   (void) conditions_satisfied;
   (void) xes;
}
xed_bool_t xed_encode_group_480(xed_encoder_request_t* xes)
{
   xed_bool_t okay=1;
   xed_bool_t conditions_satisfied=0;
   xed_ptrn_func_ptr_t fb_ptrn_function;
   static const xed_uint16_t iform_ids[1][2] = {
   /*CVTPS2DQ      */    {6380,6379,},
   };
   xed_uint8_t iclass_index = xed_encoder_get_iclasses_index_in_group(xes);
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_REG1) {
   conditions_satisfied = xed_encode_ntluf_XMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_XMM_B(xes,xed3_operand_get_reg1(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][0]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_REFINING66_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_MEM0) {
   conditions_satisfied = xed_encode_ntluf_XMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_PS);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][1]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_REFINING66_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay) return 1;
   }
     }
   return 0;
   (void) okay;
   (void) conditions_satisfied;
   (void) xes;
}
xed_bool_t xed_encode_group_481(xed_encoder_request_t* xes)
{
   xed_bool_t okay=1;
   xed_bool_t conditions_satisfied=0;
   xed_ptrn_func_ptr_t fb_ptrn_function;
   static const xed_uint16_t iform_ids[1][4] = {
   /*CALL_NEAR     */    {6439,6440,6438,6437,},
   };
   xed_uint8_t iclass_index = xed_encoder_get_iclasses_index_in_group(xes);
   if (xes->_n_operand_order == 1 && xes->_operand_order[0] == XED_OPERAND_RELBR) {
   conditions_satisfied = (xed3_operand_get_mode(xes) != 2) &&
		 (xed3_operand_get_relbr(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][0]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_BRDISPz_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 1 && xes->_operand_order[0] == XED_OPERAND_RELBR) {
   conditions_satisfied = (xed3_operand_get_mode(xes) == 2) &&
		 (xed3_operand_get_relbr(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][1]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_BRDISP32_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_DF64_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_FORCE64_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 1 && xes->_operand_order[0] == XED_OPERAND_REG0) {
   conditions_satisfied = xed_encode_ntluf_GPRv_B(xes,xed3_operand_get_reg0(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][2]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_DF64_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_IMMUNE66_LOOP64_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 1 && xes->_operand_order[0] == XED_OPERAND_MEM0) {
   conditions_satisfied = (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_V);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][3]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_DF64_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_IMMUNE66_LOOP64_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay) return 1;
   }
     }
   return 0;
   (void) okay;
   (void) conditions_satisfied;
   (void) xes;
}
xed_bool_t xed_encode_group_482(xed_encoder_request_t* xes)
{
   xed_bool_t okay=1;
   xed_bool_t conditions_satisfied=0;
   xed_ptrn_func_ptr_t fb_ptrn_function;
   static const xed_uint16_t iform_ids[1][5] = {
   /*VCMPSS        */    {6450,6448,6447,6449,6451,},
   };
   xed_uint8_t iclass_index = xed_encoder_get_iclasses_index_in_group(xes);
   if (xes->_n_operand_order == 5 && memcmp(xed_encode_order[18], xes->_operand_order, sizeof(xed_uint8_t)*5)==0) {
   conditions_satisfied = (xed3_operand_get_sae(xes) != 0) &&
		 xed_encode_ntluf_MASK_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_XMM_N3(xes,xed3_operand_get_reg2(xes)) &&
		 xed_encode_ntluf_XMM_B3(xes,xed3_operand_get_reg3(xes)) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][0]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_FIX_ROUND_LEN128_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_SAE_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_UIMM8_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 4 && memcmp(xed_encode_order[21], xes->_operand_order, sizeof(xed_uint8_t)*4)==0) {
   conditions_satisfied = (xed3_operand_get_must_use_evex(xes) == 0) &&
		 xed_encode_ntluf_XMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_XMM_N(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_XMM_B(xes,xed3_operand_get_reg2(xes)) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][1]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_UIMM8_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 4 && memcmp(xed_encode_order[22], xes->_operand_order, sizeof(xed_uint8_t)*4)==0) {
   conditions_satisfied = (xed3_operand_get_must_use_evex(xes) == 0) &&
		 xed_encode_ntluf_XMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_XMM_N(xes,xed3_operand_get_reg1(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_D) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][2]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_UIMM8_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 5 && memcmp(xed_encode_order[18], xes->_operand_order, sizeof(xed_uint8_t)*5)==0) {
   conditions_satisfied = xed_encode_ntluf_MASK_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_XMM_N3(xes,xed3_operand_get_reg2(xes)) &&
		 xed_encode_ntluf_XMM_B3(xes,xed3_operand_get_reg3(xes)) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][3]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_UIMM8_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 5 && memcmp(xed_encode_order[19], xes->_operand_order, sizeof(xed_uint8_t)*5)==0) {
   conditions_satisfied = xed_encode_ntluf_MASK_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_XMM_N3(xes,xed3_operand_get_reg2(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_D) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][4]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_UIMM8_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_32_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_SCALAR_BIND(xes);
       if (okay) return 1;
   }
     }
   return 0;
   (void) okay;
   (void) conditions_satisfied;
   (void) xes;
}
xed_bool_t xed_encode_group_483(xed_encoder_request_t* xes)
{
   xed_bool_t okay=1;
   xed_bool_t conditions_satisfied=0;
   xed_ptrn_func_ptr_t fb_ptrn_function;
   static const xed_uint16_t iform_ids[1][6] = {
   /*VCVTUDQ2PD    */    {6474,6476,6472,6475,6477,6473,},
   };
   xed_uint8_t iclass_index = xed_encoder_get_iclasses_index_in_group(xes);
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[7], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 xed_encode_ntluf_XMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_XMM_B3(xes,xed3_operand_get_reg2(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][0]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[7], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 1) &&
		 xed_encode_ntluf_YMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_XMM_B3(xes,xed3_operand_get_reg2(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][1]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[7], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 2) &&
		 xed_encode_ntluf_ZMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_YMM_B3(xes,xed3_operand_get_reg2(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][2]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[14], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 xed_encode_ntluf_XMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_VV);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][3]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_32_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_HALF_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[14], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 1) &&
		 xed_encode_ntluf_YMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_VV);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][4]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_32_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_HALF_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[14], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 2) &&
		 xed_encode_ntluf_ZMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK1(xes,xed3_operand_get_reg1(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_VV);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][5]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_32_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_HALF_BIND(xes);
       if (okay) return 1;
   }
     }
   return 0;
   (void) okay;
   (void) conditions_satisfied;
   (void) xes;
}
xed_bool_t xed_encode_group_484(xed_encoder_request_t* xes)
{
   xed_bool_t okay=1;
   xed_bool_t conditions_satisfied=0;
   xed_ptrn_func_ptr_t fb_ptrn_function;
   static const xed_uint16_t iform_ids[1][1] = {
   /*SYSCALL       */    {6484,},
   };
   xed_uint8_t iclass_index = xed_encoder_get_iclasses_index_in_group(xes);
   if (xes->_n_operand_order == 0) {
   conditions_satisfied = (xed3_operand_get_mode(xes) == 2);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][0]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_FORCE64_BIND(xes);
       if (okay) return 1;
   }
     }
   return 0;
   (void) okay;
   (void) conditions_satisfied;
   (void) xes;
}
xed_bool_t xed_encode_group_485(xed_encoder_request_t* xes)
{
   xed_bool_t okay=1;
   xed_bool_t conditions_satisfied=0;
   xed_ptrn_func_ptr_t fb_ptrn_function;
   static const xed_uint16_t iform_ids[1][2] = {
   /*PINSRQ        */    {6532,6531,},
   };
   xed_uint8_t iclass_index = xed_encoder_get_iclasses_index_in_group(xes);
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[15], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_mode(xes) == 2) &&
		 xed_encode_ntluf_XMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_GPR64_B(xes,xed3_operand_get_reg1(xes)) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][0]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_REFINING66_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_UIMM8_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 3 && memcmp(xed_encode_order[20], xes->_operand_order, sizeof(xed_uint8_t)*3)==0) {
   conditions_satisfied = (xed3_operand_get_mode(xes) == 2) &&
		 xed_encode_ntluf_XMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_Q) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][1]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_REFINING66_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_UIMM8_BIND(xes);
       if (okay) return 1;
   }
     }
   return 0;
   (void) okay;
   (void) conditions_satisfied;
   (void) xes;
}
xed_bool_t xed_encode_group_486(xed_encoder_request_t* xes)
{
   xed_bool_t okay=1;
   xed_bool_t conditions_satisfied=0;
   xed_ptrn_func_ptr_t fb_ptrn_function;
   static const xed_uint16_t iform_ids[1][1] = {
   /*MOVNTSS       */    {6678,},
   };
   xed_uint8_t iclass_index = xed_encoder_get_iclasses_index_in_group(xes);
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_MEM0 && xes->_operand_order[1] == XED_OPERAND_REG0) {
   conditions_satisfied = (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_D) &&
		 xed_encode_ntluf_XMM_R(xes,xed3_operand_get_reg0(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][0]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay) return 1;
   }
     }
   return 0;
   (void) okay;
   (void) conditions_satisfied;
   (void) xes;
}
xed_bool_t xed_encode_group_487(xed_encoder_request_t* xes)
{
   xed_bool_t okay=1;
   xed_bool_t conditions_satisfied=0;
   xed_ptrn_func_ptr_t fb_ptrn_function;
   static const xed_uint16_t iform_ids[1][1] = {
   /*ENTER         */    {6681,},
   };
   xed_uint8_t iclass_index = xed_encoder_get_iclasses_index_in_group(xes);
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_IMM0 && xes->_operand_order[1] == XED_OPERAND_IMM1) {
   conditions_satisfied = (xed3_operand_get_imm0(xes) == 1) &&
		 (xed3_operand_get_imm1(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][0]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_DF64_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_UIMM16_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_UIMM8_1_BIND(xes);
       if (okay) return 1;
   }
     }
   return 0;
   (void) okay;
   (void) conditions_satisfied;
   (void) xes;
}
xed_bool_t xed_encode_group_488(xed_encoder_request_t* xes)
{
   xed_bool_t okay=1;
   xed_bool_t conditions_satisfied=0;
   xed_ptrn_func_ptr_t fb_ptrn_function;
   static const xed_uint16_t iform_ids[1][1] = {
   /*MOVNTDQA      */    {6698,},
   };
   xed_uint8_t iclass_index = xed_encoder_get_iclasses_index_in_group(xes);
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_MEM0) {
   conditions_satisfied = xed_encode_ntluf_XMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_DQ);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][0]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_REFINING66_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay) return 1;
   }
     }
   return 0;
   (void) okay;
   (void) conditions_satisfied;
   (void) xes;
}
xed_bool_t xed_encode_group_489(xed_encoder_request_t* xes)
{
   xed_bool_t okay=1;
   xed_bool_t conditions_satisfied=0;
   xed_ptrn_func_ptr_t fb_ptrn_function;
   static const xed_uint16_t iform_ids[1][8] = {
   /*VPCMOV        */    {6760,6762,6764,6766,6759,6761,6763,6765,},
   };
   xed_uint8_t iclass_index = xed_encoder_get_iclasses_index_in_group(xes);
   if (xes->_n_operand_order == 4 && memcmp(xed_encode_order[12], xes->_operand_order, sizeof(xed_uint8_t)*4)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 xed_encode_ntluf_XMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_XMM_N(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_XMM_B(xes,xed3_operand_get_reg2(xes)) &&
		 xed_encode_ntluf_XMM_SE(xes,xed3_operand_get_reg3(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][0]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_SE_IMM8_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 4 && memcmp(xed_encode_order[12], xes->_operand_order, sizeof(xed_uint8_t)*4)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 xed_encode_ntluf_XMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_XMM_N(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_XMM_SE(xes,xed3_operand_get_reg2(xes)) &&
		 xed_encode_ntluf_XMM_B(xes,xed3_operand_get_reg3(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][1]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_SE_IMM8_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 4 && memcmp(xed_encode_order[12], xes->_operand_order, sizeof(xed_uint8_t)*4)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 1) &&
		 xed_encode_ntluf_YMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_YMM_N(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_YMM_B(xes,xed3_operand_get_reg2(xes)) &&
		 xed_encode_ntluf_YMM_SE(xes,xed3_operand_get_reg3(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][2]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_SE_IMM8_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 4 && memcmp(xed_encode_order[12], xes->_operand_order, sizeof(xed_uint8_t)*4)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 1) &&
		 xed_encode_ntluf_YMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_YMM_N(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_YMM_SE(xes,xed3_operand_get_reg2(xes)) &&
		 xed_encode_ntluf_YMM_B(xes,xed3_operand_get_reg3(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][3]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_SE_IMM8_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 4 && memcmp(xed_encode_order[11], xes->_operand_order, sizeof(xed_uint8_t)*4)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 xed_encode_ntluf_XMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_XMM_N(xes,xed3_operand_get_reg1(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_DQ) &&
		 xed_encode_ntluf_XMM_SE(xes,xed3_operand_get_reg2(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][4]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_SE_IMM8_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 4 && memcmp(xed_encode_order[13], xes->_operand_order, sizeof(xed_uint8_t)*4)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 xed_encode_ntluf_XMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_XMM_N(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_XMM_SE(xes,xed3_operand_get_reg2(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_DQ);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][5]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_SE_IMM8_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 4 && memcmp(xed_encode_order[11], xes->_operand_order, sizeof(xed_uint8_t)*4)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 1) &&
		 xed_encode_ntluf_YMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_YMM_N(xes,xed3_operand_get_reg1(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_QQ) &&
		 xed_encode_ntluf_YMM_SE(xes,xed3_operand_get_reg2(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][6]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_SE_IMM8_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 4 && memcmp(xed_encode_order[13], xes->_operand_order, sizeof(xed_uint8_t)*4)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 1) &&
		 xed_encode_ntluf_YMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_YMM_N(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_YMM_SE(xes,xed3_operand_get_reg2(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_QQ);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][7]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_SE_IMM8_BIND(xes);
       if (okay) return 1;
   }
     }
   return 0;
   (void) okay;
   (void) conditions_satisfied;
   (void) xes;
}
xed_bool_t xed_encode_group_490(xed_encoder_request_t* xes)
{
   xed_bool_t okay=1;
   xed_bool_t conditions_satisfied=0;
   xed_ptrn_func_ptr_t fb_ptrn_function;
   static const xed_uint16_t iform_ids[1][4] = {
   /*VINSERTPS     */    {6844,6843,6845,6846,},
   };
   xed_uint8_t iclass_index = xed_encoder_get_iclasses_index_in_group(xes);
   if (xes->_n_operand_order == 4 && memcmp(xed_encode_order[21], xes->_operand_order, sizeof(xed_uint8_t)*4)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 (xed3_operand_get_must_use_evex(xes) == 0) &&
		 xed_encode_ntluf_XMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_XMM_N(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_XMM_B(xes,xed3_operand_get_reg2(xes)) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][0]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_UIMM8_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 4 && memcmp(xed_encode_order[22], xes->_operand_order, sizeof(xed_uint8_t)*4)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 (xed3_operand_get_must_use_evex(xes) == 0) &&
		 xed_encode_ntluf_XMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_XMM_N(xes,xed3_operand_get_reg1(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_D) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][1]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_UIMM8_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 4 && memcmp(xed_encode_order[21], xes->_operand_order, sizeof(xed_uint8_t)*4)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 xed_encode_ntluf_XMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_XMM_N3(xes,xed3_operand_get_reg1(xes)) &&
		 xed_encode_ntluf_XMM_B3(xes,xed3_operand_get_reg2(xes)) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][2]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_UIMM8_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 4 && memcmp(xed_encode_order[22], xes->_operand_order, sizeof(xed_uint8_t)*4)==0) {
   conditions_satisfied = (xed3_operand_get_vl(xes) == 0) &&
		 xed_encode_ntluf_XMM_R3(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_XMM_N3(xes,xed3_operand_get_reg1(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_D) &&
		 (xed3_operand_get_imm0(xes) == 1);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][3]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_UIMM8_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_ESIZE_32_BITS_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_NELEM_TUPLE1_BIND(xes);
       if (okay) return 1;
   }
     }
   return 0;
   (void) okay;
   (void) conditions_satisfied;
   (void) xes;
}
xed_bool_t xed_encode_group_491(xed_encoder_request_t* xes)
{
   xed_bool_t okay=1;
   xed_bool_t conditions_satisfied=0;
   xed_ptrn_func_ptr_t fb_ptrn_function;
   static const xed_uint16_t iform_ids[1][7] = {
   /*KMOVD         */    {6874,6872,6873,6871,6868,6870,6869,},
   };
   xed_uint8_t iclass_index = xed_encoder_get_iclasses_index_in_group(xes);
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_REG1) {
   conditions_satisfied = (xed3_operand_get_mode(xes) != 2) &&
		 (xed3_operand_get_must_use_evex(xes) == 0) &&
		 xed_encode_ntluf_GPR32_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK_B(xes,xed3_operand_get_reg1(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][0]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_REG1) {
   conditions_satisfied = (xed3_operand_get_mode(xes) != 2) &&
		 (xed3_operand_get_must_use_evex(xes) == 0) &&
		 xed_encode_ntluf_MASK_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_GPR32_B(xes,xed3_operand_get_reg1(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][1]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_REG1) {
   conditions_satisfied = (xed3_operand_get_mode(xes) == 2) &&
		 (xed3_operand_get_must_use_evex(xes) == 0) &&
		 xed_encode_ntluf_GPR32_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK_B(xes,xed3_operand_get_reg1(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][2]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_REG1) {
   conditions_satisfied = (xed3_operand_get_mode(xes) == 2) &&
		 (xed3_operand_get_must_use_evex(xes) == 0) &&
		 xed_encode_ntluf_MASK_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_GPR32_B(xes,xed3_operand_get_reg1(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][3]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_REG1) {
   conditions_satisfied = (xed3_operand_get_must_use_evex(xes) == 0) &&
		 xed_encode_ntluf_MASK_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MASK_B(xes,xed3_operand_get_reg1(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][4]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_MEM0 && xes->_operand_order[1] == XED_OPERAND_REG0) {
   conditions_satisfied = (xed3_operand_get_must_use_evex(xes) == 0) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_D) &&
		 xed_encode_ntluf_MASK_R(xes,xed3_operand_get_reg0(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][5]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_MEM0) {
   conditions_satisfied = (xed3_operand_get_must_use_evex(xes) == 0) &&
		 xed_encode_ntluf_MASK_R(xes,xed3_operand_get_reg0(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_D);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][6]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay) return 1;
   }
     }
   return 0;
   (void) okay;
   (void) conditions_satisfied;
   (void) xes;
}
xed_bool_t xed_encode_group_492(xed_encoder_request_t* xes)
{
   xed_bool_t okay=1;
   xed_bool_t conditions_satisfied=0;
   xed_ptrn_func_ptr_t fb_ptrn_function;
   static const xed_uint16_t iform_ids[1][16] = {
   /*MOVQ          */    {6918,6916,6922,6920,6921,6917,6910,6915,6908,6919,6912,6914,6911,6909,6907,6913,},
   };
   xed_uint8_t iclass_index = xed_encoder_get_iclasses_index_in_group(xes);
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_REG1) {
   conditions_satisfied = (xed3_operand_get_mode(xes) == 2) &&
		 xed_encode_ntluf_GPR64_B(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MMX_R(xes,xed3_operand_get_reg1(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][0]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_REG1) {
   conditions_satisfied = (xed3_operand_get_mode(xes) == 2) &&
		 xed_encode_ntluf_MMX_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_GPR64_B(xes,xed3_operand_get_reg1(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][1]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_REG1) {
   conditions_satisfied = xed_encode_ntluf_MMX_B(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MMX_R(xes,xed3_operand_get_reg1(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][2]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_REG1) {
   conditions_satisfied = xed_encode_ntluf_MMX_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_MMX_B(xes,xed3_operand_get_reg1(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][3]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_MEM0 && xes->_operand_order[1] == XED_OPERAND_REG0) {
   conditions_satisfied = (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_Q) &&
		 xed_encode_ntluf_MMX_R(xes,xed3_operand_get_reg0(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][4]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_MEM0 && xes->_operand_order[1] == XED_OPERAND_REG0) {
   conditions_satisfied = (xed3_operand_get_mode(xes) == 2) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_Q) &&
		 xed_encode_ntluf_MMX_R(xes,xed3_operand_get_reg0(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][5]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_REG1) {
   conditions_satisfied = (xed3_operand_get_mode(xes) == 2) &&
		 xed_encode_ntluf_GPR64_B(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_XMM_R(xes,xed3_operand_get_reg1(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][6]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_REFINING66_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_MEM0) {
   conditions_satisfied = (xed3_operand_get_mode(xes) == 2) &&
		 xed_encode_ntluf_MMX_R(xes,xed3_operand_get_reg0(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_Q);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][7]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_REG1) {
   conditions_satisfied = (xed3_operand_get_mode(xes) == 2) &&
		 xed_encode_ntluf_XMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_GPR64_B(xes,xed3_operand_get_reg1(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][8]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_REFINING66_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_MEM0) {
   conditions_satisfied = xed_encode_ntluf_MMX_R(xes,xed3_operand_get_reg0(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_Q);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][9]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_REG1) {
   conditions_satisfied = xed_encode_ntluf_XMM_B(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_XMM_R(xes,xed3_operand_get_reg1(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][10]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_REFINING66_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_REG1) {
   conditions_satisfied = xed_encode_ntluf_XMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_XMM_B(xes,xed3_operand_get_reg1(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][11]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_IGNORE66_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_MEM0 && xes->_operand_order[1] == XED_OPERAND_REG0) {
   conditions_satisfied = (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_Q) &&
		 xed_encode_ntluf_XMM_R(xes,xed3_operand_get_reg0(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][12]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_REFINING66_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_MEM0 && xes->_operand_order[1] == XED_OPERAND_REG0) {
   conditions_satisfied = (xed3_operand_get_mode(xes) == 2) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_Q) &&
		 xed_encode_ntluf_XMM_R(xes,xed3_operand_get_reg0(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][13]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_REFINING66_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_MEM0) {
   conditions_satisfied = (xed3_operand_get_mode(xes) == 2) &&
		 xed_encode_ntluf_XMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_Q);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][14]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_REFINING66_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay) return 1;
   }
     }
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_MEM0) {
   conditions_satisfied = xed_encode_ntluf_XMM_R(xes,xed3_operand_get_reg0(xes)) &&
		 (xed3_operand_get_mem0(xes) == 1) &&
		 xed_encoder_request__memop_compatible(xes,XED_OPERAND_WIDTH_Q);
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][15]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_IGNORE66_BIND(xes);
       if (okay)
           okay = xed_encode_nonterminal_MODRM_BIND(xes);
       if (okay) return 1;
   }
     }
   return 0;
   (void) okay;
   (void) conditions_satisfied;
   (void) xes;
}
xed_bool_t xed_encode_group_493(xed_encoder_request_t* xes)
{
   xed_bool_t okay=1;
   xed_bool_t conditions_satisfied=0;
   xed_ptrn_func_ptr_t fb_ptrn_function;
   static const xed_uint16_t iform_ids[1][1] = {
   /*MOVDQ2Q       */    {6932,},
   };
   xed_uint8_t iclass_index = xed_encoder_get_iclasses_index_in_group(xes);
   if (xes->_n_operand_order == 2 && xes->_operand_order[0] == XED_OPERAND_REG0 && xes->_operand_order[1] == XED_OPERAND_REG1) {
   conditions_satisfied = xed_encode_ntluf_MMX_R(xes,xed3_operand_get_reg0(xes)) &&
		 xed_encode_ntluf_XMM_B(xes,xed3_operand_get_reg1(xes));
   if (conditions_satisfied) {
       okay=1;
       xed_encoder_request_set_iform_index(xes,iform_ids[iclass_index][0]);
       fb_ptrn_function = xed_encoder_get_fb_ptrn(xes);
       (*fb_ptrn_function)(xes);
       if (okay)
           okay = xed_encode_nonterminal_IGNORE66_BIND(xes);
       if (okay) return 1;
   }
     }
   return 0;
   (void) okay;
   (void) conditions_satisfied;
   (void) xes;
}
